 class language_circuit_english {
    constructor($NLP, $LC) {
        this.LC = $LC;
        this.NLP = $NLP;

        this._suffix_actions = [];
        this._suffix_nonaction = [];
        this._suffix_plurals = [];

        this.LC._aSymbols = [];             //all symbols, associated array via text index.
        
        this.LC._setCharFlagsByStr([",", ";", ":", "-"], ["breaker"]); //[" ", 
        this.LC._setCharFlagsByStr([";"], ["clump-breaker"]);
        this.LC._setCharFlagsByStr([":"], ["context-setter"]);
        
        this.LC._setCharFlagsByStr([".", "?", "!"], ["ender"]);
        this.LC._setCharFlagsByStr(["?"], ["question"]);
        this.LC._setCharFlagsByStr([" "], ["spacer"]);
        this.LC._setCharFlagsByStr([",",";"], ["connector"])

        this._monthMap = [];
        this._monthLookup=[];

        //this idea needs work.. on now to handle periods
        //not using it yet.. should neuron-ify it.
        this._cas = ["mr.", "mrs.", "dr.", 
                        "etc.", "vol.", "jr.", 
                        "sr.", "ph.d.", 
                        "m.d.", "b.a.", 
                        "m.a.", "d.d.s."];

        this.LC._pats = [
                        {roles:[{role:'role_actor', nObj:MEM.role_actor}]},
                        {roles:[{role:'role_action', nObj:MEM.role_action}]},
                        {roles:[{role:'role_where_mod', nObj:MEM.role_where_mod},
                                {role:'role_where', nObj:MEM.role_actor}]},
                        {roles:[{role:'role_when_mod', nObj:MEM.role_where_mod},
                                {role:'role_when', nObj:MEM.role_actor}]},        
                    ];


        //fixes.
        //var rObj = MEM.makeTempRelon(MEM.location, TYPE_BRAIN, MEM.expe, TO_TYPE_ANNE, toNOBJ.nid, true);

    }


    /**
     */
    init = async($NLP)=> {

        for (var m=1; m <= 12; m++) {
            var monthNOBJ = MEMG.getNeuronByClassAndValue(MEM.month, m);
            var str = monthNOBJ.text.toLowerCase();
            this._monthMap[ str ] = monthNOBJ;
            this._monthLookup.push(str);
            var str = str.substring(0,3);
            this._monthMap[ str ] = monthNOBJ;
            this._monthLookup.push(str);
            this._monthMap[ m ] = monthNOBJ;
        }

        //loadDefaultRelon(Consts.TYPE_HAS, ECS.gregorian_date, ECS.ec_pattern, dp1a);
        
        this._langDefaultExpRoles=[MEM.role_actor.temp_nid, MEM.role_action.temp_nid];

        this.LC.initPrefixMap(MEM.lang_english);  
        this.LC.initSuffixMap(MEM.lang_english);
        await this.LC.initPhraseSignalsMap();
    }



    /**
     * Lang specific rule flags
     */
    alterSuffixMap = function($sObjs) {
        var action=0;
        var thing=0;
        var state=0;
        var manner=0;
        var plural = 0;

        for (var s=0; s < $sObjs.length; s++) {
            var suffixObj = $sObjs[s];
            var sNObj = suffixObj.nObj;
            sNObj.text = sNObj.text.toLowerCase();
            if (sNObj.text.indexOf("ec:")!=-1 || sNObj.text.indexOf("ec.")!=-1) continue;

            //custom functs to validate ending rules
            //this can be embedded in ACQL neurons.
            //for now, we will put it here.
            if (sNObj.text.toLowerCase()=="d") {
                suffixObj.cdx_rule = this.__dCDX;
                suffixObj.tense = MEM.tense_past;
            }
            else if (sNObj.text.toLowerCase()=="ed") {
                suffixObj.cdx_rule = this.__edCDX;
                suffixObj.tense = MEM.tense_past;
            }
            else if (sNObj.text.toLowerCase()=="ing") {
                suffixObj.cdx_rule = this.__ingCDX;
            }
            else if (sNObj.text.toLowerCase()=="king") suffixObj.cdx_rule = this.__kingCDX;
            else if (sNObj.text.toLowerCase()=="ked") {
                suffixObj.cdx_rule = this.__kedCDX;
                suffixObj.tense = MEM.tense_past;
            }
            else if (sNObj.text.toLowerCase()=="ly") {
                suffixObj.cdx_rule = this.__lyCDX; 
                suffixObj.cdx_rule_out = this.__lyAdd;
            }

            
            //flags apply to suffixes and the LAST ONE PRESENT from the base morph or from the most PREV ending
            if (this.__hasGrammarRule(sNObj, MEM.eng_state_to_action.temp_nid)==true) { 
                action+=1; 
                suffixObj.action=true;
                suffixObj.dpool_adders=[MEM.role_action, MEM.ec_action];
                suffixObj.expects_roles=[MEM.role_action.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_action.temp_nid;
                suffixObj.rule = MEM.eng_state_to_action;
                this._suffix_actions.push(sNObj);
            }
            else if (this.__hasGrammarRule(sNObj, MEM.eng_action_to_thing.temp_nid)==true) {
                thing+=1; 
                suffixObj.thing=true;
                suffixObj.dpool_adders=[MEM.role_thing, MEM.ec_thing];
                suffixObj.expects_roles=[MEM.role_thing.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_thing.temp_nid;
                suffixObj.rule = MEM.eng_action_to_thing;
                this._suffix_nonaction.push(sNObj);

                //in eng we have 3 suffix that are action->thing and also action->action
                //ed, ked, king
                if (this.__hasGrammarRule(sNObj, MEM.eng_action_to_action.temp_nid)==true) {
                    action+=1;
                    suffixObj.action=true;
                    suffixObj.dpool_adders=[MEM.role_action, MEM.ec_action];
                    suffixObj.expects_roles=[MEM.role_action.temp_nid];
                    suffixObj.ec_type_tnid = MEM.ec_action.temp_nid;   
                    suffixObj.rule = MEM.eng_action_to_action;
                    this._suffix_actions.push(sNObj);
                }
            }
            else if (this.__hasGrammarRule(sNObj, MEM.eng_action_to_state.temp_nid)==true) {
                state+=1; 
                suffixObj.state=true;
                suffixObj.dpool_adders=[MEM.role_state, MEM.ec_state];
                suffixObj.expects_roles=[MEM.role_state.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_state.temp_nid;   
                suffixObj.rule = MEM.eng_action_to_state;
                this._suffix_nonaction.push(sNObj);
            }
            else if (this.__hasGrammarRule(sNObj, MEM.eng_thing_to_state.temp_nid)==true)  {
                state+=1; 
                suffixObj.state=true;
                suffixObj.dpool_adders=[MEM.role_state_thing, MEM.ec_state];
                suffixObj.expects_roles=[MEM.role_state.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_state.temp_nid; 
                this._suffix_nonaction.push(sNObj);
            }   
            else if (this.__hasGrammarRule(sNObj, MEM.eng_thing_to_thing.temp_nid)==true) {
                thing+=1; 
                suffixObj.thing=true;
                suffixObj.dpool_adders=[MEM.role_thing, MEM.ec_thing];
                suffixObj.expects_roles=[MEM.role_thing.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_thing.temp_nid; 
                suffixObj.rule = MEM.eng_thing_to_thing;
                this._suffix_nonaction.push(sNObj);
            }
            else if (this.__hasGrammarRule(sNObj, MEM.eng_state_to_thing.temp_nid)==true) {
                thing+=1; 
                suffixObj.thing=true;
                suffixObj.dpool_adders=[MEM.role_thing, MEM.ec_thing];
                suffixObj.expects_roles=[MEM.role_thing.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_thing.temp_nid; 
                suffixObj.rule = MEM.eng_state_to_thing;
                this._suffix_nonaction.push(sNObj);
            }
            else if (this.__hasGrammarRule(sNObj, MEM.eng_state_to_manner.temp_nid)==true) {
                manner+=1;
                suffixObj.manner=true;
                suffixObj.dpool_adders=[MEM.role_manner, MEM.ec_manner];
                suffixObj.expects_roles=[MEM.role_manner.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_manner.temp_nid; 
                suffixObj.rule = MEM.eng_state_to_manner;
                this._suffix_nonaction.push(sNObj);
            }
            else if (this.__hasGrammarRule(sNObj, MEM.eng_action_to_action.temp_nid)==true) {
                action+=1;
                suffixObj.action=true;
                suffixObj.dpool_adders=[MEM.role_action, MEM.ec_action];
                suffixObj.expects_roles=[MEM.role_action.temp_nid];
                suffixObj.ec_type_tnid = MEM.ec_action.temp_nid; 
                suffixObj.rule = MEM.eng_action_to_action;
                this._suffix_actions.push(sNObj);
            }

            //NOTE:  very informal slang english can turn any plural noun into a verb.
            //ANNE should be able to decipher these when no other valid action vb is found.
            //He walls the painting.
            //He towels his body.
            //he computers the records.
            if (this.__hasStrongAssoc(sNObj, MEM.ec_plural.temp_nid)==true) {
                plural+=1;
                suffixObj.plural=true;
                suffixObj.dpool_adders=[MEM.ec_plural];
                this._suffix_plurals.push(sNObj);
                suffixObj.ec_type_tnid = MEM.ec_thing.temp_nid;

                if (sNObj.text=="s") {
                    suffixObj.cdx_rule = this.__sCDX;
                }
                else if (sNObj.text=="es") suffixObj.cdx_rule = this.__esCDX;
                else if (sNObj.text=="ies") suffixObj.cdx_rule = this.__iesCDX;
                else if (sNObj.text=="i") suffixObj.cdx_rule = this.__iCDX;
            }

        }
        console.log("%c(alterSuffixMap) action:"+action+" state:"+state+" thing:"+thing+" manner:"+manner+" plural:"+plural, 'background: yellow; color: black');
    }

    /**
     * quick strong assoc relon lookup.
     */
    __hasStrongAssoc=function($nObj, $to_assoc_temp_nid) {
        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].to_type!=TO_TYPE_ANNE) continue;
            if ($nObj.outs[r].type!=TYPE_BRAIN) continue;
            if ($nObj.outs[r].r!=MEM.brain_assoc_strong.temp_nid) continue;
            if ($nObj.outs[r].t!=$to_assoc_temp_nid) continue;
            return true;
        }
        return false;
    }

    /**
     * Grammar rules
     */
     __hasGrammarRule=function($nObj, $rule_temp_nid) {
        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].to_type!=TO_TYPE_ANNE) continue;
            if ($nObj.outs[r].type!=TYPE_HAS) continue;
            if ($nObj.outs[r].r!=MEM.eng_grammar_rule.temp_nid) continue;
            if ($nObj.outs[r].t!=$rule_temp_nid) continue;
            return true;
        }
        return false;
    }


    /**
     * We saw an apostrophe.. in ENGLISH this carries extra meaning.
     * Let's prep the wdObj to get ready for its handling.
     */
    handleApostrophe=function($wd) {
        console.warn("TO DO, handle apostrophe for english");
        var n1char = $wd.str[$wd.str.length-1];
        var n2char = $wd.str[$wd.str.length-2];
        
        if (n2char=="'") {
            
            //standard possessive
            if (n1char=="s") {
                $wd.possessive = true;
                $wd.original_str = $wd.str;
                $wd.str = $wd.str.substring(0, $wd.str.length-2);
            }

            //contraction
            //would be nice to set the nObj in here.
            else if (n1char=="t") {
                $wd.contraction = true;
                $wd.negation = true;
                $wd.original_str = $wd.str;
                $wd.str = $wd.str.substring(0, $wd.str.length-2)+" not";
            }
        }

        //possessive ending in s
        else if (n1char=="'" && n2char=="s") {
            $wd.possessive = true;
            $wd.original_str = $wd.str;
            $wd.str = $wd.str.substring(0, $wd.str.length);
        }


        //unclear what this apostrophe is for.
        //could be a quoted phrase..
        //could be a foreign language wd.
        else {
        }

    }
       

    /**
     */
    extractPrefixes = function($wd, $str, $pMORPH=null) {
        var multiMorph = [];
        var minP = this.LC._minPrefixLen;
        var maxP = Math.min(this.LC._maxPrefixLen, $str.length-2);

        var largest_prefixes = [];
        var largestqpre = "";
        var smallestMorph = "";

        for (var p=minP; p<=maxP; p++) {
            var qprefixchk = $str.substring(0,p);
            //console.log("%c qprefixchk %c "+qprefixchk, TALK.black, TALK.bggreen);
            
            var prefixes_test = this.LC._getPrefix(qprefixchk);//morph shouldn't be w/o vowel or too short
            if (prefixes_test==null) continue;

            var psbl_morph = $str.substring(p);
            if (psbl_morph.length<3) continue;
            if (language_circuit_english._vowelCnt(psbl_morph)==0) continue;

            //if the leftover is a Suffix.. this is not likely a prefix.
            //skip it so we don't have troubles.
            if (this.LC._getSuffix(psbl_morph)!=null) continue;
            
            largest_prefixes = prefixes_test.concat();
            largestqpre = qprefixchk;
            smallestMorph = psbl_morph;

        }

        //gets way to nutty on searches with multiple prefixes
        //a word like "animal" (unknown) would get a+n+im with root of al.  It's ridonkulous.
        if (largest_prefixes.length>0 && largestqpre.length>1 && smallestMorph.length>2) {
            //+dis +assemble +d
            //if ($pMORPH==null) 
            var mObj = nlp_morph.make_prefix(smallestMorph, largestqpre, 1, largest_prefixes);
            //else var mObj = nlp_morph.make_prefix(psbl_morph, $pMORPH.p+qprefixchk, $pMORPH.p_cnt+1, $pMORPH.prefixes.concat(prefixes));

            $wd.addPsblMorph(mObj);
            multiMorph.push(mObj);
        }
        
        return multiMorph;
    }

    /**
     * Written to be iteratatable for multi-suffixes.
     * Call it, get the morphs, if morphs exist, call with the morphs
     */
    extractSuffixes = function($wd, $str, $sMORPH=null) {
        var multiMorph = [];
        var chars = Math.min(this.LC._maxSuffixLen, $str.length-1);
        for (var q=chars; q>0; q--) {
            var qsuffixchk = $str.substring($str.length-q);
            var suffixes = this.LC._getSuffix(qsuffixchk);
            if (suffixes!=null) {
                for (var s=0; s < suffixes.length; s++) {
                    var suffix = suffixes[s];
                    var cdxrule = suffix.cdx_rule; //rule
                    if (cdxrule==undefined || typeof cdxrule!=='function') {

                        //morph shouldn't be w/o vowel or too short
                        var psbl_morph = $str.substring(0, ($str.length-q));
                        if (psbl_morph.length<3) continue;
                        if (language_circuit_english._vowelCnt(psbl_morph)==0) continue;
                        
                        if ( $sMORPH==null) {
                            var mObj = nlp_morph.make_suffix(psbl_morph, qsuffixchk, 1, [suffix]);
                        }
                        else {
                            var mObj = nlp_morph.make_suffix(psbl_morph, qsuffixchk+$sMORPH.s, $sMORPH.s_cnt+1,$sMORPH.suffixes.push(suffix));
                        }
                        $wd.addPsblMorph(mObj);
                        multiMorph.push(mObj);
                        if (suffix.plural==true) mObj.plural=true;
                    }
                    else {
                        var morph = cdxrule(suffix, $wd, $str, $sMORPH);
                        if (morph!=null) multiMorph.push(morph);
                    }
                }
            }
        }
        return multiMorph;
    }


    /**
     * -s, -es, -ies, -i, -a
     * This is run at the first pass so we don't actually know if this
     * concept is plural or if it just happens to match one of the known plural patterns.
     * 
     * This is put on the initial wd object (not the phrase)
     * We can move it over to the phrase when we make it.
     */
     _nakedEndingsDetector=function($wd) {
        if ($wd.str.length < 4) return; //smallest plural handled here:  dogs
        var str = $wd.str.toLowerCase();

        var suffixMorphs = this.extractSuffixes($wd, str);
        var sm2 = [];
        if (suffixMorphs.length) {
            while(suffixMorphs.length>0) {
                var sMorph = suffixMorphs.shift();
                if (sMorph==undefined || sMorph==null) break;
                //once comes through here it is removed from multisuffixes and put in strs
                sm2.push(sMorph);  
                var innerMS = this.extractSuffixes($wd, sMorph.morph);
                if (innerMS.length>0) suffixMorphs=suffixMorphs.concat(innerMS);    //extends outter loop.
            }
        }


        //for prefixes, our str will be all our possible morphs.
        var prefixMorphs = this.extractPrefixes($wd, str);
        var pm2 = [];
        if (prefixMorphs.length) {
            while(prefixMorphs.length) {
                var pMorph = prefixMorphs.shift();
                if (pMorph==undefined || pMorph==null) break;
                //once comes through here it is removed from multisuffixes and put in strs
                pm2.push(pMorph);  
            }
        }

        //both must be non-zero for a combo play
        if (sm2.length==0 || pm2.length==0) return;

        //multiply them out for all options (lolz, a bit silly but this is what we do in eng)
        //note: we could not do this until we think we are lost and need to get creative to try
        //and find something.
        for (var sm=0; sm < sm2.length; sm++) {
            var sm2_obj = sm2[sm];      //disassemble +d
            for (var pm=0; pm < pm2.length; pm++) {
                var pm2_obj = pm2[pm];  //+dis, assembled 
                var comboMorph = sm2_obj.morph.substring( pm2_obj.p.length );
                if (comboMorph==pm2_obj.morph || comboMorph==sm2_obj.morph) continue;
                if (comboMorph.length<3) continue;
                if (language_circuit_english._vowelCnt(comboMorph)==0) continue;
                var mObj = nlp_morph.make_prefix_and_suffix(comboMorph, pm2_obj.p, pm2_obj.p_cnt, pm2_obj.prefixes, sm2_obj.s, sm2_obj.s_cnt, sm2_obj.suffixes);
                $wd.addPsblMorph(mObj);
            }
        }   

        return;
    }


    /**
     * @return {nlp_morph}
     */
    __sCDX = function($suffix, $wd, $str, $sMORPH=null) {
        var end1 = $str[$str.length-1];
        var test3 = $str.substring($str.length-3);
        if (test3=="ies" || test3=="ses" || test3=="zes" || test3=="zes") return null; //not relevant to +s
        var test4 = $str.substring($str.length-4);
        if (test4=="sses" || test4=="ches" || test4=="shes") return null; //this +es ending

        if ($str.length>3 && end1=="s") {
            var morph = ($str.substring(0, $str.length-1));
            if ($sMORPH==null) {
                var mObj = nlp_morph.make_suffix(morph, "s", 1, [$suffix]);
                if ($suffix.plural==true) {
                    mObj.plural=true;
                    mObj.ec_type_tnid = MEM.ec_thing.temp_nid;
                }
            }
            else var mObj = nlp_morph.make_suffix(morph,"s"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix));
            $wd.psbl_plural_morph = mObj;
            $wd.addPsblMorph(mObj);
            return mObj;
        }
        return null
    }

    /**
     * @return {nlp_morph}
     */
    __esCDX = function($suffix, $wd, $str, $sMORPH=null) {
        var end2 = $str.substring($str.length-2, $str.length);
        //boxes.., churches, pushes,  fizzes

        //NOT companies!
        if ($str.length>3 && end2=="es") {
            //var lastChar = $str[ $str.length-1];
            //var last2char = $str.substring($str.length-2);
            var char3 = $str[$str.length-3];
            var char4 = $str[$str.length-4];
            var cc = char4+char3;

            // one of these cases is valid "+es" 
            // ending in -s, -z or -x or -ss, -ch, -sh
            if (("szx".indexOf(char3)!=-1) || ("sschsh".indexOf(cc)!=-1)) {
                var morph = ($str.substring(0, $str.length-2));
                if (morph.length<3) return null;
                if (language_circuit_english._vowelCnt(morph)==0) return null;
                if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "es", 1, [$suffix]);
                else var mObj = nlp_morph.make_suffix(morph,"es"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
                $wd.psbl_plural_morph = mObj;
                $wd.addPsblMorph(mObj);
                return mObj;
            }
        }
        return null;
    }

    /**
     * @return {nlp_morph}
     */
    __iesCDX = function($suffix, $wd, $str, $sMORPH=null) {
        var end3 = $str.substring($str.length-3, $str.length);
        //ies  (baby, fairy, berry...)    NOTE:  NOT donkey or monkey here.  Those are donkeys and monkeys!
        //([C]-y, drop y +ies..  if this is the -y rule then 4char back must be a consonant.
        if ($str.length>4 && end3=="ies") {
            var c4 = $str[ $str.length-4 ];
            if (language_circuit_english._isConsonant(c4)==true) {
                var morph = ($str.substring(0, $str.length-3)+"y");
                if (morph.length<3) return null;
                if (language_circuit_english._vowelCnt(morph)==0) return null;
                if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "ies", 1, [$suffix]);
                else var mObj = nlp_morph.make_suffix(morph,"ies"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
                $wd.psbl_plural_morph = mObj;
                $wd.addPsblMorph(mObj);
                return mObj;
            }
        }
        return null
    }

    /**
     * alumni, bacilli, octopi, nuclei, espressi
     * @return {nlp_morph}
     */
    __iCDX = function($suffix, $wd, $str, $sMORPH=null) {
        var end1 = $str[$str.length-1];
        if ($str.length>3 && end1=="i") {
            var morph = ($str.substring(0, $str.length-1));
            if (morph.length<3) return null;
            if (language_circuit_english._vowelCnt(morph)==0) return null;
            if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "i", 1, [$suffix]);
            else var mObj = nlp_morph.make_suffix(morph,"i"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
            $wd.psbl_plural_morph = mObj;
            $wd.addPsblMorph(mObj);
            return mObj;
        }
        return null;
    }
    

    __lyCDX = function($suffix, $wd, $str, $sMORPH=null){
        var ly = $str.indexOf("ly");
        if (ly!=-1 && ly==($str.length-2)) {
            var b3 = $str[$str.length-3];   //if == i, alter root to y
            var b4 = $str[$str.length-4];

            var morph1 = "";
            var morph2 = "";

            //we need multiple options here, as we don't know if root is natively ending in what the rule produces.
            //silly english.
            if (b3=="i") {
                morph1 = $str.substring(0, $str.length-3)+"y";   //-ily, replace i with y.  angrily->angry
                morph2 = $str.substring(0, $str.length-3)+"i";   //-ily, put back on i. quasily-> quasi
            }

            //-ally
            else if (b4=="a" && b3=="l") {
                morph1 = $str.substring(0, $str.length-4);  //magic
                morph2 = $str.substring(0, $str.length-2);  //magical
            }

            //remove y and add e
            //just remove ly
            else {
                morph1 = $str.substring(0, $str.length-2);      //-ly
                morph2 = $str.substring(0, $str.length-1)+"e";  //-y +e    cuddly->cuddle   gentle->gently     
            }

            //ambiguous potentials with willy wonka english rules and breakages.
            if (morph2.length>2) {
                if (language_circuit_english._vowelCnt(morph2)==0) return null;
                if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph2, "ly", 1, [$suffix]);
                else var mObj = nlp_morph.make_suffix(morph2,"ly"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
                $wd.addPsblMorph(mObj);
                mObj.bCANBESTATE=true;
            }

            if (morph1.length>2) {
                if (language_circuit_english._vowelCnt(morph1)==0) return null;
                if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph1, "ly", 1, [$suffix]);
                else var mObj = nlp_morph.make_suffix(morph1,"ly"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
                $wd.addPsblMorph(mObj);
                mObj.bCANBESTATE=true;
                return mObj;
            }

            //this will return morph2 if we didn't qualify for morph1
            return mObj;
        }
        return null;
    }


    __lyAdd = function($str) {
        var end1 = $str[$str.length-1];
        if (end1=="y") return $str.substring(0, $str.length-2)+"i"+"ly";
        var end2 = $str[$str.length-2];
        if (end2=="le") return $str.substring(0, $str.length-2)+"y";
        return $str+"ly";
    }


    /**
     * @return {nlp_morph}
     */
    __ingCDX = function($suffix, $wd, $str, $sMORPH=null){
        var ing = $str.indexOf("ing");
        if(ing==($str.length-3)) {
            var b4 = $str[$str.length-4];
            var b5 = $str[$str.length-5];
            var morph = "";
            var dc = false;
            //ti[pp]ing, cra[mm]ing, regre[tt]ing...  tip, cram, regret  
            if (b4==b5) {
                dc=true;
                morph = $str.substring(0, $str.length-4);
            }
            else morph = $str.substring(0, $str.length-3);
            if (morph.length<3) return null;
            if (language_circuit_english._vowelCnt(morph)==0) return null;
            if ($sMORPH==null) {

                if (dc==false && language_circuit_english._isConsonant(b4)==true 
                    && language_circuit_english._isVowel(b5)==true) {
                    var mObj = nlp_morph.make_suffix(morph+"e", "ing", 1, [$suffix]);
                    $wd.addPsblMorph(mObj);
                    mObj.bCANBESTATE=true;
                }
                else {
                    var mObj = nlp_morph.make_suffix(morph, "ing", 1, [$suffix]);
                    $wd.addPsblMorph(mObj);
                    mObj.bCANBESTATE=true;
                }
                $wd.psbl_ing = true;
            }
            else {
                if (dc==false && language_circuit_english._isConsonant(b4)==true 
                    && language_circuit_english._isVowel(b5)==true) {
                    var mObj = nlp_morph.make_suffix(morph+"e", "ing"+$sMORPH.s, "ing"+$sMORPH.s, $sMORPH.suffixes.push($suffix));
                    $wd.addPsblMorph(mObj);
                    mObj.bCANBESTATE=true;
                }
                else {
                    var mObj = nlp_morph.make_suffix(morph,"ing"+$sMORPH.s, "ing"+$sMORPH.s, $sMORPH.suffixes.push($suffix))
                    $wd.addPsblMorph(mObj);
                    mObj.bCANBESTATE=true;
                }

                $wd.psbl_ing = true;
            }
            return mObj;
        }
        return null;
    }


    /**
     * @return {nlp_morph}
     */
    __kingCDX = function($suffix, $wd, $str, $sMORPH=null){
        var king = $str.indexOf("king");
        if (king==-1) {
            var matchingEnding = language_circuit_english.__strMatchWithPrevVowel($str, "king", 5, "c", 6);
            if (matchingEnding.length>0) {
                var morph = $str.substring(0, $str.length-4);
                if (morph.length<3) return null;
                //to avoid false positives, we need atleast 2 vowels in the morph
                if (language_circuit_english._vowelCnt(morph)>1) {
                    if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "king", 1, [$suffix]);
                    else var mObj = nlp_morph.make_suffix(morph,"king"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
                    $wd.addPsblMorph(mObj); 
                    mObj.bCANBESTATE=true;
                    return mObj;
                }
            }
        }
        return null;
    }

    /**
     * @return {nlp_morph}
     */
    __dCDX = function($suffix, $wd, $str, $sMORPH=null){
        var lastChar = $str[$str.length-1];
        var lastChar2 = $str[$str.length-2];
        if (lastChar=="d" && lastChar2=="e") {
            var morph = $str.substring(0, $str.length-1);
            if (morph.length<3) return null;
            if (language_circuit_english._vowelCnt(morph)==0) return null;
            if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "d", 1, [$suffix]);
            else var mObj = nlp_morph.make_suffix(morph,"d"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
            $wd.addPsblMorph(mObj);
            mObj.bCANBESTATE=true;
            return mObj;
        }
        return null;
    }

    /**
     * @return {nlp_morph}
     */
    __edCDX = function($suffix, $wd, $str, $sMORPH=null){
        var ed = $str.indexOf("ed");
        if (ed!=-1 && ed==($str.length-2)) {
            var b3 = $str[$str.length-3];
            var b4 = $str[$str.length-4];
            var morph = "";
            //ti[pp]ed,  cra[mm]ed, regre[tt]ed...  tip, cram, regret  
            if (b3==b4) morph = $str.substring(0, $str.length-3);
            else morph = $str.substring(0, $str.length-2);
            if (morph.length<3) return null;
            if (language_circuit_english._vowelCnt(morph)==0) return null;
            if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "ed", 1, [$suffix]);
            else var mObj = nlp_morph.make_suffix(morph,"ed"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
            $wd.addPsblMorph(mObj);
            mObj.bCANBESTATE=true;
            return mObj;
        }
        return null;
    }

    /**
     * @return {nlp_morph}
     */
    __kedCDX = function($suffix, $wd, $str, $sMORPH=null){
        var ked = $str.indexOf("ked");
        if (ked!=-1) {
            //picnicked - good..   
            //false positive : f*cked
            //discount matches that do not have atleast 2 vowels.
            var matchingEnding = language_circuit_english.__strMatchWithPrevVowel($str, "ked", 4, "c", 5);
            if (matchingEnding.length>0) {
                var morph = $str.substring(0, $str.length-4);
                if (morph.length<3) return null;
                if (language_circuit_english._vowelCnt(morph)>1) {
                    if ($sMORPH==null) var mObj = nlp_morph.make_suffix(morph, "ked", 1, [$suffix]);
                    else var mObj = nlp_morph.make_suffix(morph,"ked"+$sMORPH.s, $sMORPH.s_cnt+1, $sMORPH.suffixes.push($suffix))
                    $wd.addPsblMorph(mObj);
                    mObj.bCANBESTATE=true;
                    return mObj;
                }
            }
        }
        return null;
    }


    /**
     * Since referenced in callbacks -- we lose the "this" unless we rube JS.
     * Better to just use a static.
     * @return {string}
     */
    static __strMatchWithPrevVowel = function($str, $end, $cback, $4char, $vowelCharTest) {
        var end = $str.indexOf($end);
        if ($str[ $str.length-$cback]==$4char) {
            var char5 = $str[$str.length-5];
            if ("aeiou".indexOf(char5)!=-1) return $end;
        }
        return "";
    }

        
    /**
     */
    static _vowelCnt = function($str) {
        if ($str==undefined || $str==null) {
            alert("FIX THIS vowelCnt");
            return 0;
        }
        var matches = $str.match(/[aeiou]/gi);
        if (matches==null || matches==undefined) return 0;
        return matches.length; 
    }
    


    /**
     * Test for unknown word having known ed ending rules for potential match to known word.
     * These rules change the length of the base morpheme.
     * tests:
     * [-y]+ied, [V][C] +[C]ed.
     */
    static _isConsonant = function($char) {
        if ('bcdfghjklmnpqrstvwxyz'.indexOf($char) ==-1) return false;
        return true;   
    }

    static _isVowel = function($char) { 
        if ('aeiou'.indexOf($char) ==-1) return false;
        return true;
    }



    /**
     *  //Nikt was jumped by a dog.
     *  //A dog jumped Nikt.
     *  giving.. an action+thingending.    [gave a [congratulat]-ions] 
     *  receiving.. an action..
     *  
     *  These must be simplified!
     * 
     * //Nikt received a congratulations from Mr.Scatman.
     * //Congratulations were received by Nikt from Mr.Scatman.
     * //Nikt was congratulated by Mr.Scatman.
     * //Mr.Scatman gave a congratulations to Nikt.
     * //Mr.Scatman congratulated Nikt.
     * //Mr.Scatman gave congratulations to Nikt.
     *  
     *  
     *  //basic similarity via action definitions and parent classes:
     *  //i travelled through the wilderness.
     *  //i traversed through the wilderness.
     *  //i motated through the wildnerness.
     *  
     * 
     * @param {anne_nlp_parse} $nlpP 
     */
    setVoice = function($nlpP) {
        console.log("%c (setVoice)", TALK.bgpink);
        if ($nlpP.conveyor_part!=null && $nlpP.clump.tense!="present" && $nlpP.has_aux==true) {
            $nlpP.clump.flipVoice();
        }
    }


    /**
     * 
     * consider encoding in neurons/relons  
     * LANG patterns (ie, ENG LANG) like  DET [class]  conveyor DEFN/POSN (no ric needed)
     * LANG rules are truly formed/learned via experience (seeing them, observing, formulating conclusions)
     * 
     * @param {anne_nlp_parse} $nlpP 
     * @param {nlp_ph} $ph 
     */
    conceptualizePh = function($nlpP, $ph) {
        console.log("(conceptualizePh) %c"+$ph.l1str_nosignal, TALK.bggreen);

        //role candidates if no signals.
        var expect_roles = $ph.expects_roles;
        var priority_roles = $nlpP.clump.default_exp_roles;
        var other_roles = $nlpP.clump.getDefaultRoleTnids();

        var rolePool=null;
        
        //need to get a WHERE to concpetualize to where (with a where signal present)
        //expect roles is only set by signals in the phrase.
        if (expect_roles.length) {
            priority_roles = priority_roles.concat(other_roles);
            
            //MAKE ROLE POOL.
            rolePool = $nlpP.clump.makeRolePool(expect_roles, priority_roles, $ph);
            
            //decrease ambiguous role resolution of thing when we have a where/when expectation present
            //from the signal.
            //boost their signal.
            if (expect_roles.indexOf(MEM.role_where.temp_nid)!=-1 || expect_roles.indexOf(MEM.role_when.temp_nid)!=-1) {
                if (expect_roles.indexOf(MEM.role_where.temp_nid)!=-1) rolePool.weightSpecific(MEM.role_where, 2);
                if (expect_roles.indexOf(MEM.role_when.temp_nid)!=-1) rolePool.weightSpecific(MEM.role_when, 2);
                
                //decrease role_thing
                if ($nlpP.clump.thing_cnt>0) {
                    rolePool.weightSpecific(MEM.role_thing, .1);
                    rolePool.weightSpecific(MEM.ec_thing, .1);
                    rolePool.weightSpecific(MEM.role_affected_thing, .1);
                }
                else {
                    rolePool.weightSpecific(MEM.role_thing, .2);
                    rolePool.weightSpecific(MEM.ec_thing, .2);
                    rolePool.weightSpecific(MEM.role_affected_thing, .2);
                }
            }
        }
            
        //MAKE ROLE POOL.
        else {
            rolePool = $nlpP.clump.makeRolePool(priority_roles, other_roles, $ph);
        }

        //a resolved_nObj is just the neuron of the WORDS used.
        //in some cases were were able to store the known phrase already in the resolved_nObj of the phrase.
        //rolePool.printPool();
        //fire the phrase parts/wds/neurons to match against the weighted roles.
        if ($ph.resolved_nObj==null) {
            for (var w=0; w < $ph.l1wds.length; w++) {
                var wdOBJ = $ph.l1wds[w];
                
                if (wdOBJ.charObj_ender!=null) continue;    //why???

                if (wdOBJ.tnids==undefined || wdOBJ.tnids.length==0) {
                    if (wdOBJ.charObj!=null && wdOBJ.charObj.charNOBJ!=null) {
                        rolePool.addFireWdUp(wdOBJ.charObj.charNOBJ);
                    }
                }
                else {
                    for (var t=0; t < wdOBJ.tnids.length; t++) {
                        var nObj = MEMG.getNeuronByTempNid(wdOBJ.tnids[t]);
                        rolePool.addFireWdUp(nObj);
                    }
                }
            }
        }

        //phrase is already resolved, just use the resolved neuron
        else rolePool.addFireWdUp($ph.resolved_nObj);
        

        //we should load the coneyor clump def roles in the clump to add in here every time as default contextualizers.
        //something like "give" will be tied to location.

        //TODO.. switch this just to pull the role value.
        if ($nlpP.conveyor_part && $nlpP.conveyor_part.resolved_nObj!=null) {
            rolePool.contextualizeWithConveyor($nlpP.conveyor_part.resolved_nObj);
        }

        rolePool.printPool();
        
        var highNC =  rolePool.getHighestTop();
        var winningRoleNOBJ = null;
        if (highNC!=null) winningRoleNOBJ = highNC.nObj;
        else {
            winningRoleNOBJ = rolePool.getHighestWeight();
        }

        var isTHING=false;

        if ($ph.l1str_nosignal=="gorge" || $ph.l1str_nosignal=="landform") {
            console.log("debug here");
        }
        
        //if this is a thing role, we need to specify which type of thing role
        //this needs work to NOT conceptualize things incorrectly after the conveyor.
        if (winningRoleNOBJ.nid==MEM.role_thing.nid || winningRoleNOBJ.nid==MEM.role_actor.nid) {
            //console.log("to do, narrow down thing role.");
            winningRoleNOBJ = this._thingPlacementAssignment($nlpP, $nlpP.clump, $ph, winningRoleNOBJ);
            isTHING=true;
        }

        var valueText  = "";
        if ($ph.resolved_nObj!=null) valueText = $ph.resolved_nObj.text;
        else valueText = $ph.l1str;


        //we don't need a pool.. we already isolated the sig via the role selection.
        //we should have retained that.. (todo: check if we can just snag the sig)
        var getBestSig = function ($role, $signal_arr) {
            if ($signal_arr.length==1) return $signal_arr[0].nObj;
            for (var s=0; s < $signal_arr.length; s++) {
                var sig = $signal_arr[s];
                if ($role.temp_nid==MEM.role_when.temp_nid && sig.x_when==true) return sig.nObj;
                else if ($role.temp_nid==MEM.role_where.temp_nid && sig.x_where==true) return sig.nObj;
            }

            //just return the first one.
            return $signal_arr[0].nObj;    
        }
        
        
        if ($ph.l1str_nosignal.length>0 && $ph.l1str_nosignal!=valueText) {
            valueText = $ph.l1str_nosignal;
        }

        //***** ADD ROLE HERE **/
        //if ph is resolved, store that value.
        var role = $nlpP.clump.addRole(valueText, winningRoleNOBJ, $ph.resolved_nObj, $ph, 1, false);
        
        if ($ph.likelyConcept!=null) {
            role.best_class_tnid = $ph.likelyConcept.temp_nid;
        }

        //if sig part exists and flat_ph is a .mod, (ie, a prep) we want to store this mod.
        //we don't typically need to keep dets
        //we want to store mods in the clump (not the neuron referenced) so we can
        //operate in a "flat" env and not a nested one.  The nesthexint allows for that.
        if (role.ph.sig_parts.length) {
            for (var s=0; s < role.ph.sig_parts.length; s++) {
                var sig = role.ph.sig_parts[s];
                if (sig.flat_ph!=null) {
                    if (sig.flat_ph.mod==true) {
                        console.log(sig.flat_ph);
                        var sig_nObj = getBestSig(role, sig.flat_ph.signal_arr);
                        var modRoleNOBJ = MEM[role.roleNOBJ.text+"_mod"];
                        $nlpP.clump.nlpRolesObj.addModRole(role, sig_nObj.text, modRoleNOBJ, sig_nObj, sig, 1, false);
                    }
                }
            }
        }

        return role;
    }

     

    /**
     * 
     * DEPRECATED 
     * 
     * This helps us resolve things better to know where we are at 
     * in the sentence.  $clump.vb_ph_i will default to 999999 until we update it
     * so we will be left of the verb in an "active" voice as default.
     * @param {nlp_clump}
     * @param {nlp_phrase}
     */
    getLangPart=function($clump, $ph){
        //if we are left of the verb..
        if ($ph.temp_p_index < $clump.vb_ph_i) {
            //passive voice, the left of the verb is the object
            if ($clump.voice=="passive") {
                console.log("%c (getLangPart) passive OBJ %c ph index:"+$ph.temp_p_index, TALK.bgpurple, TALK.black);
                return MEM.eng_obj;
            }
            //active voice, the left of the verb is the subject
            else {
                console.log("%c (getLangPart) active SUBJ %c ph index:"+$ph.temp_p_index, TALK.bgpurple, TALK.black);
                return MEM.eng_subj;
            }
        }

        //right of the verb..
        else {
            //passive voice, the right of the verb is the subject
            if ($clump.voice=="passive"){
                console.log("%c (getLangPart) passive SUBJ %c ph index:"+$ph.temp_p_index, TALK.bgpurple, TALK.black);
                return MEM.eng_subj;
            }
            //active voice, the left of the verb is the object
            else {
                console.log("%c (getLangPart) active OBJ %c ph index:"+$ph.temp_p_index, TALK.bgpurple, TALK.black);
                return MEM.eng_obj;
            }
        }
    }



    /**
     * out put side.. this will be for verbalizing english
     */
     englishTensify = function($vb, $tense) {
        if ($tense==MEM.tense_past.nid) {
            var rev = $text.split("").reverse().join("");
            var c0 = rev[0];
            var c1 = "";
            if (rev.length>1) c1 = rev[1];
            if (c0=="e") return $vb+"d";
            if (c0=="y" && $text.length>1) return $vb.substring(0, $vb.length-1)+"ied";
            if (this.vowel.indexof(c1)!=-1 && this.vowel.indexOf(c0)==-1) return $vb+c0+"ed";
            if (c0=="c") return $vb+"ked"; 
            return $vb+"ed";
        }
        else return $vb;
    }


    /**
     * NOTE: must still think of infinitive form resolving correctly.
     * "to be jumping" is what I what.
     * [What I want] [is] [to be jumping].
     * 
     * DEPRECATED
     */
    _thingPlacementAssignment=function($nlpP, $clump, $ph, $role_NOBJ) {
        console.log("%c (_thingPlacementAssignment) %c"+$role_NOBJ.text, TALK.bgpink, TALK.green);
        
        //NEEDS TO RETURN THE RIGHT ROLE NEURON.

        //if passive voice
        if ($clump.voice=="passive") {

            //passive + left of the action vb.
            if ($ph.index < $nlpP.conveyor_part.index) {
                if ($clump.clump_sub_type==CLUMP_SUBTYPE_POSN) {
                   return MEM.role_posn_thing;  
                }
                else if ($clump.clump_sub_type==CLUMP_SUBTYPE_DEFN) {
                    return MEM.role_be_thing;
                }
                else if ($clump.clump_type==CLUMP_TYPE_Q) {
                    console.log("%c TO DO: QUESTION THING??? ", TALK.bgpink);
                }
                else if  ($clump.clump_sub_type==CLUMP_SUBTYPE_ACTION) {
                    if ($role_NOBJ.nid!=MEM.role_thing.nid) return $role_NOBJ;
                    var thing_role_nObjs = $clump.getPosblThingRoles();
                    
                    //ez rez, only one possiblity.
                    if (thing_role_nObjs.length==1) {
                        return thing_role_nObjs[0];
                    }
                    else {
                        console.log("%c TO DO: ACTION THING ROLE AMBIGUITY. %c NEED A DPOOL FACEOFF!", TALK.bgred, TALK.bgblack);
                        return null;
                    }
                }
            }

            //passive + right of the verb.  s.b. the actor..
            else {
                return MEM.role_actor.temp_nid;
            }
        }

        //active voice
        else {

            //active voice, left of the verb
            if ($ph.index < $nlpP.conveyor_part.index) {
                return MEM.role_actor;
            }

            //active voice, right of the verb
            else {
                if ($clump.clump_sub_type==CLUMP_SUBTYPE_POSN) return MEM.role_posn_thing;
                else if ($clump.clump_sub_type==CLUMP_SUBTYPE_DEFN) return MEM.role_be_thing;
                else if ($clump.clump_type==CLUMP_TYPE_Q) {
                    console.log("%c TO DO: QUESTION THING??? ", TALK.bgpink);
                }
                else if  ($clump.clump_sub_type==CLUMP_SUBTYPE_ACTION) {
                    if ($role_NOBJ.nid!=MEM.role_thing.nid) return $role_NOBJ;
                    var thing_role_nObjs = $clump.getPosblThingRoles();
                    
                    //ez rez, only one possiblity.
                    if (thing_role_nObjs.length==1) {
                        return thing_role_nObjs[0];
                    }
                    else {
                        console.log("%c TO DO: ACTION THING ROLE AMBIGUITY. %c NEED A DPOOL FACEOFF!", TALK.bgred, TALK.bgblack);
                    }
                }
            }
        }
        return $role_NOBJ;
    }

    /**
     * work in progress.. still needs work.
     */
    handlePeriodFlags = function($wdObj=null) {
        if ($wdObj!=null) {
            if($wdObj.str.length<=2) {
                $wdObj.psbl_abbreviation=true;
            }
            $wdObj.psbl_sentence_ender=true;
        }
        return;
    }
}