
    //*** ANNE modes ***  these set the PRIME DIRECTIVE.
    //ANNE is not a robot -- there is on body to serve or aid in the physical world.
    //There are no 3 laws here.. just the PRIME DIRECTIVE set by the mode. 

    //PRIME DIRECTIVE POOL loads neural templates that flavor / alter the functioning
    //of ANNE.  The PDP will contain state of where at in the PD FLOW ANNE is.
    //ie, in a friendly dialogue there may be norms such as "salutations" or "goodbyes" etc.

    //listen/learn only  (no way to clarify ambiguous pts)
    //dialogue  (user can interact)
        //discuss  (+additional objectives)
            //ask questions to clarify
            //ask questions to confirm
            //inform -> attempt to gain "ec_agreement"  (+additional objectives)
            //NOTE: more than one in convo.. must KNOW WHEN TO TALK (when addressed)
            //what is your name? directed at someone else.. ANNE should not blather out her name.
        //debate
        //clarifyQuest (try to learn)
    //snipe/correct
    
    //Q&A
        //resolve/lookup (questions asking for info)
        //solve  (math etc)
        //infer / deduce
        //conject
        //riddles / lateral thinking puzzles (fun stuff!)

    //    
    //need understanding of when we (ANNE) are being addressed.
    //this is the variable "theAudience" in the CTP


//these can later be just firing neurons in the context pool
//to help us know what mode we are in.. 
//that's for an AGI usecase tho.. 

const MODE_LISTEN_AND_LEARN = 0;    //INPUT!!!
const MODE_DIALOGUE = 1;
const   MODE_DISCUSS = 11;
const   MODE_DEBATE = 21;
const   MODE_QUEST = 31;
const       MODE_CONJECT = 131;
const MODE_SNIPE = 2;
const MODE_QANDA = 3;
const MODE_JOKESTER = 4;            //"your momma was a snow blower"
const MODE_INSULT = 5;
const MODE_PUN_MAKER = 6;

const MODE_ANNE_EXT_DATA_MAKER = 7;

class anblon{
    constructor($a, $b) {
        this.edge = [];        
    }
}


class anbl {
    constructor($arr, $text){
        this.text = $text;      
        this.full_tnids = [];        //any conceptual neuron this anbl is apart of.
        this.partial_tnids = [];
        this.i=$arr.length;
        $arr.push(this);
    }
    addTnid=function($tnid) {
        if (this.tnid_matches.indexOf($tnid)==-1) this.tnid_matches.push($tnid);
    }
    setFullTnid = function($tnid){
        if (this.full_tnids.indexOf($tnid)==-1) {
            this.full_tnids.push($tnid);
        }
    }
    setpartialTnid = function($tnid){
        if (Array.isArray($tnid)==true) {
            console.log("fix this jacky chan");
            if ($tnid.lenght) this.setpartialTnids($tnid);
            return;
        }
        if (this.partial_tnids.indexOf($tnid)==-1 && this.full_tnids.indexOf($tnid)==-1) {
            this.partial_tnids.push($tnid);
        }
    }
    setpartialTnids = function($tnids){
        if (Array.isArray($tnids)==false) {
            console.log("bad array");
            return;
        }
        
        for (var t=0; t < $tnids.length; t++) {
            var tnid = $tnids[t];
            if (this.partial_tnids.indexOf(tnid)==-1 && this.full_tnids.indexOf(tnid)==-1) {
                this.partial_tnids.push(tnid);
            }
        }
    }
    
    print = function(){
        var full = MEMG.getTextListFromTnids(this.full_tnids);
        var partial = MEMG.getTextListFromTnids(this.partial_tnids);
        console.log("%c"+this.text+" %c full:"+full+" %c partial:"+partial, TALK.bggreen, TALK.bgblue, TALK.bgorange);
    }
}


class brain {
    constructor() {
        this.idg = null;        //internal dialogue
        this.ctp = null;        //context pool
        this.ctp_light = null;  //for the app release (light mode)
        this.anz = null;        //analyzer
        this.vsm = null;        //VERy short term memory
        this.MEM = null;        //pointer (lolz, js psuedo ref..) to MEM space
        this.NLP = null;        //Natural language processing
        this._text_com = null;  //text com (out)
        this._voice_com = null; //voice com (out)

        this.pd_pool_core = null;   //primary directive guiding pool. (ie, frame)
        
        this._PRIMARY_DIRECTIVE = MODE_ANNE_EXT_DATA_MAKER;

        this._anbls=[];
        this._anbls_map=new Object();
        
    }


    
    /**
     * NLP is used to communicate in/out
     * We need it to process external language into our internal language.
     * We need it to process internal language to get it to an external language.
     */
    init = async($LANG="EN")=> {
        this.idg = new internal_dialogue();
        this.ctp = new context_pool();
        this.anz = new analyzer();
        this.issues = new active_issues();
        this.vsm = new very_short_term_memory();
        this.NLP = new anne_nlp(this, this.SOA);
        this.NLP.init($LANG);
        //genenalized for the PRIMARY DIRECTIVE we are in.
        this.startContextViaPD();
    }
    initLight = function() {
        this.ctp_light = new simple_context_pool();
    }
    printCtpLightPool400 = function() {
        if (this.ctp_light==null) return;
        this.ctp_light.printPool(POOL_SORT_FIRE, 400);
    }
    printCtpLightPool = function($sort=POOL_SORT_FIRE, $max=100) {
        if (this.ctp_light==null) return;
        this.ctp_light.printPool($sort, $max);
    }

    getInstNObjs = function($classNOBJ=null, $max=20, $ignoreClassTnids=[]) {
        if (this.ctp_light==null) return [];
        return this.ctp_light.getInstNObjs($classNOBJ, $max, $ignoreClassTnids);
    }

    getByClass = function($classNOBJ, $max=100){
        if (this.ctp_light==null) return;
        return this.ctp_light.getByClass($classNOBJ, $max);
    }
    fireNid = function($nid, $fireWeight=1) {
        if (this.ctp_light==null) return;
        this.ctp_light.addNid($nid, $fireWeight);
    }
    fireNeuron = function($nObj, $fireWeight=1) {
        if (this.ctp_light==null) return;
        this.ctp_light.addNObj($nObj, $fireWeight);
    }
    fireStrings = function($strs) {
        for (var s=0; s < $strs.length; s++) {
            this.fireString($strs[s]);
        }
    }
    fireString = function($str, $fireWeight=1) {
        if (this.ctp_light==null) return;
        this.ctp_light.addString($str, $fireWeight);
    }
    getByString = function($str) {
        if (this.ctp_light==null) return;
        return this.ctp_light.getByText($str);
    }
    getLongerByShorterString = function($str) {
        if (this.ctp_light==null) return;
        return this.ctp_light.getLongerByShorterString($str);
    }

    applyPoolWeights = function($aMatches, $context=[], $bWINNERONLY=false) {
        if (this.ctp_light==null) return $aMatches;
        return this.ctp_light.applyPoolWeights($aMatches, $context, $bWINNERONLY);
    }
    getHottestByContextStr = function($contexts, $aNOBJS) {
        var max_score = 0;
        var maxNOBJ = null;
        for (var n=0; n < $aNOBJS.length; n++) {
            $aNOBJS[n].setDisambigArrStr();
            var score = $aNOBJS[n].contextAdditive($contexts);
            if (score > max_score) {
                max_score = score;
                maxNOBJ = $aNOBJS[n];
            }
        }
        
        if (maxNOBJ==null) maxNOBJ = $aNOBJS[0];
        
        return maxNOBJ;
    }
    


    printAnblReport = function() {
        console.log("%canbls report", TALK.bgheading);
        for (var a=0; a < this._anbls.length; a++) {
            var anb = this._anbls[a];
            anb.print();
        }
    }


    printAnbl = function($text) {
        var anb = this.getOrMakeAnbl($text);
        anb.print();
        return anb;
    }

    
    testAnbls = function() {
        this.anblHouse("house");
        this.anblHouse("hose");
        this.anblHouse("blouse");
        this.anblHouse("clothes");
        this.anblHouse("the");
        this.anblHouse("then");
        this.anblHouse("their");
        this.anblHouse("car");
        this.anblHouse("care");
        this.anblHouse("cart");
        this.anblHouse("caretaker");
        this.anblHouse("car loan");
        this.anblHouse("horse");
        this.anblHouse("his");
        this.anblHouse("hers");
        this.anblHouse("hit");
        this.anblHouse("health");
        this.anblHouse("henry");
        this.anblHouse("pen");
        this.anblHouse("pester");
        this.anblHouse("lester");
        this.anblHouse("fester");
        this.anblHouse("jester");
        console.log( this._anbls);
        console.log( this._anbls_map);
    }

        

    getOrMakeAnbl=function($text, $tnid=-1) {
        if (typeof $text !="string") {
            alert("bad anbl data");
            return null;
        }
        //$text = $text.replace(" ","");
        $text = $text.toLowerCase();
        $tnid=parseInt($tnid);
        var anb = this.__getAnbl($text);
        if (anb!=null) {
            if ($tnid!=-1) anb.setFullTnid($tnid);
            this._setAnblPartials(anb, $text);
            return anb;
        } 

        //make full anbl tnid ref is tnid is there.
        anb = this.__getOrMakeAnbl($text, $tnid);
        
        return anb;
    } 

    //this.text = $text;      
    //this.full_tnids = [];        //any conceptual neuron this anbl is apart of.
    //this.partial_tnids = [];
    //this.i=$arr.length;
    anblHouse=function($text) {
        //    FOR NN HOUSE METHOD.
        var text = $text.split(" ");
        for (var t=0; t < text.length; t++) {
            this.__anblHouse(text[t]);
        }
    }


    __anblHouse=function($text){
        //pieces:
        //     h   o   u   s   e

        var fullanbl = this.__getOrMakeAnbl($text);

        var anbslastlvl=[];
        for (var t=0; t < $text.length-1; t++) {
            var char = $text[t];
            var charnext = $text[t+1];
            var anb = this.__getOrMakeAnbl(char);
            var anbNext = this.__getOrMakeAnbl(charnext);
            if (anb.next==undefined) anb.next = [];
            if (anb.next[charnext]==undefined) {
                anb.next[charnext]={anb:anbNext, m:1};
            }
            else {
                anb.next[charnext].m+=1;
            }
            anbslastlvl.push(anb);
            if (t==$text.length-2) anbslastlvl.push(anbNext);
        }

        for (var chars=2; chars < $text.length; chars++) {
            var pieces = $text.length-(chars-1);
            var anbnewlastlvl = [];
            var lastthis = null;
            for (var p=0; p<pieces; p++) {
                var anblastlvl=anbslastlvl[p];
                var anbthisstr = $text.substr(p,chars);         //anb extended
                var anbthis = this.__getOrMakeAnbl(anbthisstr);
                anbnewlastlvl.push(anbthis);
                
                //tie prev level to this
                //h->ho   o->ou   u->us  e->se
                if (anblastlvl.next==undefined) anblastlvl.next=[];
                if (anblastlvl.next[anbthisstr]==undefined) {
                    anblastlvl.next[anbthisstr]={anb:anbthis, m:1};
                }
                else {
                    anblastlvl.next[anbthisstr].m+=1;
                }

                //last to this on same lvl.
                if (lastthis!=null) {
                    if (lastthis.next==undefined) lastthis.next=[]
                    if (lastthis.next[anbthisstr]==undefined) {
                        lastthis.next[anbthisstr]={anb:anbthis, m:1};
                    }
                    else {
                        lastthis.next[anbthisstr].m+=1;
                    }
                }
                lastthis = anbthis;

                //final level tie to full anbl.  (only tie p=0)
                if (chars==$text.length-1 && p==0) {
                    if (anblastlvl.next[$text]==undefined) {
                        anblastlvl.next[$text]={anb:fullanbl, m:1};
                    }
                    else {
                        anblastlvl.next[$text].m+=1;
                    }
                }
            }    
            anbslastlvl = anbnewlastlvl;
        }


        //     h   o   u   s   e
        //       ho  ou  us  se  
        //        hou  ous  use 
        //          hous  ouse
        //             house
        //    h->o, o->u, u->s, s->e
        //  h->ho, o->ou, u->us, s->se  e(none)
        //  ho->hou ou->ous us->use   se (none)
        //  hou->hous  (ouse) none

        //      ALL point to the neuron HOUSE.
    }

        
    __getOrMakeAnbl=function($text, $tnid=-1){
        $text = $text.toLowerCase();
        var anb = null;
        
        if (this._anbls_map[$text]==undefined) {
            anb = new anbl(this._anbls, $text);
            this._anbls_map[$text] = anb.i;
            this._setAnblPartials(anb, $text);
            if ($tnid!=-1) anb.setFullTnid($tnid);
        }

        else {
            anb = this._anbls[ this._anbls_map[$text] ];
            this._setAnblPartials(anb, $text);
            if ($tnid!=-1) anb.setFullTnid($tnid);
        }

        //we should have anbl of "statue" even if we have no concept of "statue" if we saw
        //"statue" in the concept "statue of liberty".  partial should point statue anbl statue of liberty
        if ($tnid!=-1) {
          var parts = $text.split(" ");
            if (parts.length>1) {
                for (var p=0; p < parts.length; p++) {
                    if (parts[p].length<3) continue;
                    var anbl_part = this.__getOrMakeAnbl(parts[p]);
                    if (anbl_part!=null) {
                        anbl_part.setpartialTnid($tnid);
                    }
                }
            }  
        }

        return anb;
    }

    
    //set this anbl to have partials of any other "longer" anbls.
    //find shorter anbls of this anbl and set their partial to this anbl.
    _setAnblPartials = function($anb, $text) {
        for (var a=0; a < this._anbls.length; a++) {
            
            //look for longer anbls where the $anb is a partial match
            if (this._anbls[a].text.length > $text.length) {

                //all the full tnids of this anbl are parital tnids of the $anb.
                if (this._anbls[a].text.indexOf($text)==0) {
                    $anb.setpartialTnids(this._anbls[a].full_tnids);
                }
                continue;
            }

            //look for short anbls where this $anb is a longer etended match.
            if (this._anbls[a].text.length < $text.length) {
                if ($text.indexOf(this._anbls[a].text)==0) {
                    this._anbls[a].setpartialTnids($anb.full_tnids);
                }
            }
        } 
    }


    //maybe we always want to make an anbl by the mere act of looking it up??
    getTnidsByAnbl = function($text) {
        return ANNE.MEM.getTnidsByText($text);
        //var anb = this.__getAnbl($text);
        //if (anb!=null) return anb.full_tnids;
        //return [];
    }

    getTnidsByAnblORmake = function($text, $tnid=-1) {
        var anb = this.__getOrMakeAnbl($text, $tnid);
        return anb.full_tnids;
    }

    __getAnbl = function($text) {
        //$text = $text.replace(" ","");
        $text = $text.toLowerCase();
        if (this._anbls_map[$text]==undefined) return null;
        return this._anbls[ this._anbls_map[$text] ];  
    }


    /**
     * Get the context we want present when parsing from passed in fire_context array
     * and the primary directive neurons we want in play.
     * @returns 
     */
    startContextViaPD = function($newPrimeDirective=null){
        if ($newPrimeDirective!=null) this._PRIMARY_DIRECTIVE = $newPrimeDirective;
        var context = [];

        if (this._PRIMARY_DIRECTIVE==MODE_ANNE_EXT_DATA_MAKER) {
            context.push(MEM.ec_thing.temp_nid); 
            context.push(MEM.company.temp_nid);
            context.push(MEM.date_gregorian.temp_nid);
            context.push(MEM.person.temp_nid);
            context.push(MEM.company_type.temp_nid);
            context.push(MEM.location.temp_nid);
            context.push(MEM.site.temp_nid);
            context.push(MEM.geo_site.temp_nid);
            context.push(MEM.name.temp_nid);
        }

        //core pool for things we are typically interested in (for a given mode)
        this.pd_pool_core = new pool_core();
        this.pd_pool_core.init(context, false);
    }


    setMem = function($MEM) {
        this.MEM = $MEM;
    }

    //set when we have a user using the app.
    setPrimarySpeaker=function($userNid) {
        if (this.ctp!=null) this.ctp.setPrimarySpeaker($userNid);
    }


    /**
     * A callback function used to send text com to  (from ANNE)
     * This is app specific.
     */
    setTextCom = function($text_com) {
        this._text_com = $text_com;
    }


    /**
     * A callback function used to send voice com to (from ANNE)
     * This is app specific. 
     */
    setVoiceCom = function($voice_com) {
        this._voice_com = $voice_com;
    }



    /************************************************************************
     * QUICK HIT NLP TO GET CONCEPTUZLIZED AND CONTEXTUALLY RESOLVED PARSE **
     ***********************************************************************/

    /**
     * Manually pass information in a non-AGI non-"aware" setting... 
     * ie, simply a function that will process stuff.
     * @param {*} $text 
     * @param {*} $fire_roles 
     * @param {*} $fire_context 
     */
    manuallyStartASOA = async($text, $fire_roles=[], $exitAt=-1)=>{
        var ASOA = new anne_soa(this, $exitAt);
        return await ASOA.startSpiral(SOA_MODE_SYMBOLS, $text, $fire_roles);
    }

    ASOA_withKnownConveyor = async($text, $conveyor=null, $exitAt=-1)=>{
        var ASOA = new anne_soa(this, $exitAt);
        return await ASOA.startSpiral(SOA_MODE_SYMBOLS, $text, $fire_roles);
    }

    maketodo = function($obj) {}


    /**
     * This is essentially ANNE's sense of text here.
     * Any text stream that needs to be parsed should come through here.
     *
     * Set an even to listen for text input and pass the event and text here.
     * @param {*} $e 
     * @param {*} $text 
     * @returns 
     */
    textstreamIn=async($e, $text)=> {
        return await this.NLP.nakedParseSentence($text);    
    }
    

    nlpClumpIn=async($clump)=>{
        return await this.ctp.nlpClumpIn($clump);
    }


    /**
     * This is the last mile from formulating a thought
     * using a language circuit to get the thought into a language,
     * and now getting that communication out
     */
    expressText_byClump=function($clump) {
    }
    expressVoice_byClump=function($clump) {
    }
}



//SPIRAL OF AWARENESS
//ITERATIVE (multi-pass) non-grammar lang independent SIGNAL-BASED NLP
//spirals within spirals occur, so this is not a linear progression in coms
const SOA_MODE_SENSORY_DATA = 0;         //base-lvl detection of shapes/color/luminosity/contrast/volume.
const SOA_MODE_SYMBOLS = 1;              //what is this symbol
const SOA_MODE_WORDS = 2;                //what word is this?
const SOA_MODE_LANG_SIGNALS = 3;         //what does this signal in this specific language of communication?
const SOA_MODE_PARTS = 4;                //what parts of phrases are here?
const SOA_MODE_PHRASE = 5;               //what phrases are here?
const SOA_MODE_CONCEPTUALIZE = 6;        //what are the semantic structures/PAS of this communication?
const SOA_MODE_RESOLVE_CONTEXT = 7;      //what does this refer to?
const SOA_MODE_OPTIMIZE_CLUMP = 7.1;     //sub process for storing clumps in ANNE 
const SOA_MODE_MEANING = 8;              //what does this mean?
const SOA_MODE_INTENT = 9;               //what is the intent?

class anne_soa {
    
    constructor($BRAIN, $exitAt=-1) {
        this.BRAIN = $BRAIN;
        this.NLP = $BRAIN.NLP;

        //NLP.LC must be init.. (one-time)
        if ($BRAIN.NLP==null || $BRAIN.NLP.LC==undefined || $BRAIN.NLP.LC==null) {
            $BRAIN.init();
            this.NLP = $BRAIN.NLP;
        }
        this.LC = this.NLP.LC;    
        this._nlpP = null;
        this.exit_at = $exitAt;
    }


    /**
     * 
     * @param {*} $mode 
     * @param {*} $text 
     * @param {*} $fire_roles 
     */
    startSpiral = async($mode, $text, $fire_roles=[])=> {
        this.SOA_MODE = $mode;
        this._nlpP = new anne_nlp_parse(this.LC, $text);
        this._fire_roles = $fire_roles;
  
        await this._nlpP.start();
        await this.spiral();
        return this;
    }


    /**
     * SOA uses the spiral of awareness method.
     * See documentation, because ANNE invented this.
     * @returns 
     */
    spiral = async()=>{
        if (this.SOA_MODE==SOA_MODE_SENSORY_DATA) {
            //process sensory data into a usable stream of data we can process.
            //apps that have chat should pipe through here with the text input sense.
            //default soas should spawn based on triggers of these sensory inputs.
            //they are set to the SOA_MODE of sensory data so they can process that data according
            //to what channel it is coming in on.
        }

        if (this.SOA_MODE==SOA_MODE_SYMBOLS) {
            this._nlpP.str = this._nlpP.str.replace(/\s\s+/g, ' '); //remove double spaces;
            this._nlpP.str = this._nlpP.str.trim();
            this._nlpP.wdsObj = await this.LC.firstPassPrepPunct(this._nlpP, this._nlpP.str);
            this.SOA_MODE=SOA_MODE_WORDS;
        }

        if (this.exit_at!=-1 && this.exit_at==SOA_MODE_WORDS) return;
        
        if (this.SOA_MODE==SOA_MODE_WORDS) {
            if (ANNE.UTILS.isset(this._nlpP.wdsObj)==false) return;
            await this.LC.secondPassPrepPunct(this._nlpP.wdsObj);
            this.SOA_MODE=SOA_MODE_LANG_SIGNALS;
        }

        if (this.exit_at!=-1 && this.exit_at==SOA_MODE_LANG_SIGNALS) return;
        
        if (this.SOA_MODE==SOA_MODE_LANG_SIGNALS) {
            if (ANNE.UTILS.isset(this._nlpP.wdsObj)==false) return;
            await this.LC.signalPass(this._nlpP.wdsObj);
            this.SOA_MODE=SOA_MODE_PARTS;
        }

        if (this.exit_at!=-1 && this.exit_at==SOA_MODE_PARTS) return;
        
        if (this.SOA_MODE==SOA_MODE_PARTS) {
            if (ANNE.UTILS.isset(this._nlpP)==false) return;
            await this.LC.flatParse(this._nlpP);
            this.SOA_MODE=SOA_MODE_PHRASE;
        }

        if (this.exit_at!=-1 && this.exit_at==SOA_MODE_PHRASE) return;
        
        if (this.SOA_MODE==SOA_MODE_PHRASE) {
            if (ANNE.UTILS.isset(this._nlpP)==false) return;
            await this.LC.phPartsParse(this._nlpP);
            this.SOA_MODE=SOA_MODE_CONCEPTUALIZE;
        }

        if (this.exit_at!=-1 && this.exit_at==SOA_MODE_CONCEPTUALIZE) return;
        

        //NOT GOING BEYOND HERE FOR NOW ----> AS MANY THINGS HAVE BEEN ALTERED.
        //USING THE PHRASE PARSER, FOR NOW, FOR HELPING METHODS PARSING AND CONCEPTUALIZING
        //EXTERNAL DATA.

        if (this.SOA_MODE==SOA_MODE_CONCEPTUALIZE) {
            if (ANNE.UTILS.isset(this._nlpP)==false) return;
            await this.LC.phToRoles(this._nlpP);
            this.SOA_MODE=SOA_MODE_RESOLVE_CONTEXT;
        }
        
        if (this.exit_at!=-1 && this.exit_at==SOA_MODE_RESOLVE_CONTEXT) return;
        
        //resolves prounouns and references to things in context.
        //also resolves expressions  (the capital of texas, the planet with a red eye)
        //"that fuzzy creature"
        if (this.SOA_MODE==SOA_MODE_RESOLVE_CONTEXT) {
            if (ANNE.UTILS.isset(this._nlpP)==false) return;
            await this.LC.resolveContext(this._nlpP);
            this.SOA_MODE=SOA_MODE_OPTIMIZE_CLUMP;

            //NOTE-> we need a true "analyzer" ability to properly resolve context for 
            //phrases that require analyzing/thinking/solving/understanding of logic/reason/location.
            //ie, The state above california has lots of trees.
            //the actor role of this statement requires we answer an internl question ->  "what is the state above california"
            //Without relying upon linguistic pattern matches to haveing encountered the knowledge that Oregon is "above"
            //washington, we will need to be able to resolve this.
            //To do this without hardcode cheating is an epic task.
        }


        //easy cases, simple posn and defn
        //these store a single relon  (TYPE_HAS or TYPE_BE).
        //if more complicated with additional roles, a full clump is required.
        //harder cases ---> boiling down statements into the most basic form...
        //so that various ways of stating the same thing will conceptualize the same.
        if (this.SOA_MODE==SOA_MODE_OPTIMIZE_CLUMP) {
            if (ANNE.UTILS.isset(this._nlpP)==false) return;
            await this.LC.optimizeClump(this._nlpP);
            this.SOA_MODE=SOA_MODE_MEANING;
        }

        //there will include other areas of the ANNE BRAIN in order to properly pull-off.
        if (this.SOA_MODE==SOA_MODE_MEANING) {
            //console.log("TO DO");
            this.SOA_MODE=SOA_MODE_INTENT;
            //work with MODE the brain is set in to formulate what to do with this information.
        }

        if (this.SOA_MODE==SOA_MODE_INTENT) {
            //console.log("TO DO");
            //work with MODE the brain is set in to formulate what to do with this information.
        }

        /**
         if (this.SOA_MODE==SOA_MODE_RESPOND) {
            if ($nlpP.clump.clump_type==CLUMP_TYPE_Q) {
                this._nlpP.handleQuestion();
            }
            else {
                this._nlpP.handleStatement();
            }
        }*/
    }
}



class very_short_term_memory {
    constructor() {
    }
}

class internal_dialogue {
    constructor() {
    }
}


/**
 * pending issues here..
 * issues have recourse..
 * recourse is attempted, then either resolved or unresolved.
 */
class active_issues {
    constructor() {       
        this._issues = [];
    }
    lowConfidenceClumpParse=function(){
    }
    unknownConcept=function(){
    }
    unkownConceptClass=function(){
    }
    expectationUnmet=function(){
    }
    contradictingTense=function(){
    }
    contradictingPlurality=function(){
    }
}


/**
 * Internal methods of analyzing that we can 
 * define in neurons/relons with ACQL or hardcode with functions
 * by tying to language.
 * ie, "add" is a "+" and can be processed into a function (poor man's circuit)
 * that does the adding.  This is NOT idea -- much more ideal is calling neuron/relon
 * circuitry as that can be "learned" and thus the code IS the neurons/relons.
 */
class analyzer {
    constructor() {
    }
    

    pickPhStrategy=function(){
    }

    //patterns in language -- structure/form and meta-conceptual-meaning patterns..
    //can clue us in to intent of modality of communication.

    //clump_type is -> feelz, opinionz

    //ascertain ph

    //poetic/creative
    //riddle
    //math problem
    //alt-reference / alias / abbreviation / short-hand

    //ascertain communication type.
    //discuss, debate, q&a

    //formulate strategy to fulfill session objectives
}


var BRAIN = new brain();