

class nlp_ph_pool {
    constructor ($for_ph) {
        this.ph = $for_ph;
        this._pool = [];
        this._pool_map = {};
    }

    //this may not be the real/final match but we don't know that yet.
    //we decide which way to go when we decide to close the ph.
    addPslbMatch=function($mObj) {
        if (this._pool_map[$mObj.nObj.temp_nid]==undefined) {
            this._pool_map[$mObj.nObj.temp_nid] = $mObj;
            this._pool.push($mObj);
        }
    }
}


/**
 * We've conceptualized the role but it needs to be resolved.
 * 
 * note:  smart search settings (estimate of children) should inform us 
 * 
 * if we want to do a target=mods ('third' / 'with the big red spot') with cadidates=children of class(planets)
 * (this is for smaller sized candidate lists.. ie, knowns)
 * 
 * OR
 * if we need to build candidates by chasing attributes(blond haired tall 'believe me' guy) INS from things of class (people). 
 *
 * why this? 
 * We don't want to search through 1 million candidates.  we should "discover" the winner by chasing
 * the attributes..
 * 
 */
 class nlp_role_concept_resolver {
    constructor($role, $name="concept_resolver") {
        this.role=$role;
        this._pool_map = [];
        this._pool = [];
        this._baseCandidatesNOBJS=[];
        this._baseCandidatesTNIDS=[];
    }

    /**
     */
    fireLooseCandidates=function($tnids, $weight=.55) {
        for (var t=0; t < $tnids.length; t++) {
            var nObj = MEMG.getNeuronByTempNid($tnids[t]);
            this.addUniqueCandidate(nObj, 1, nObj.temp_nid, $weight);
        }
    }

    getCandidateTnids = function() {
        return MEMG.getTnidsFromNObjs(this._baseCandidatesNOBJS);
    }

     
    /**
     *  capital of texas.
     *  capital bulds a pool.
     *  next word, texas, tries to connect to this pool and point to another neuron.
     * 
     * red..   big....   vehicle....   fire ....   
     * 
     * this does the FIRST TWO.  (red and big..   capital and texas...) etc
     */
    union_tnids=async($arr_of_arr)=> {
        if ($arr_of_arr.length<=1) return;

        var tnids1 = $arr_of_arr[0];
        var tnids2 = $arr_of_arr[1];

        //run it the other way too.
        for (var t=0; t < tnids1.length; t++) {
            var t1_nObj = MEMG.getNeuronByTempNid(tnids1[t]);
            var t1_relons = await MEMG.getRuntimeRelonsForContext(t1_nObj.nid); 
            for (var r=0; r < t1_relons.length; r++) {
                var rel = t1_relons[r];
                if (rel.to_type!=TO_TYPE_ANNE) continue;
                if (tnids2.indexOf(rel.r)!=-1) {
                    var pObj = this.__getPoolObjByTNID(rel.t);
                    if (pObj==null) {
                        var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                        pObj = {nObj:toNOBJ, target:false, candidate:true, from_text:t1_nObj.text, base_target:t1_nObj, weight:1, hits:0, founds:[true, true], founds_hits:[1,1]};
                        this.__addNewPoolObj(pObj); 
                    }
                    else pObj.founds_hits[1]+=1;
                }
                continue;
            }
            for (var r=0; r < t1_nObj.ins.length; r++) {
                var rel = t1_nObj.ins[r];
                if (rel.to_type!=TO_TYPE_ANNE) continue;
                if (tnids2.indexOf(rel.r)!=-1) {
                    var pObj = this.__getPoolObjByTNID(rel.f);
                    if (pObj==null) {
                        var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
                        pObj = {nObj:fromNOBJ, target:false, candidate:true, from_text:fromNOBJ.text, base_target:t1_nObj, weight:1, hits:0, founds:[true, true], founds_hits:[1,1]};
                        this.__addNewPoolObj(pObj); 
                    }
                    else pObj.founds_hits[1]+=1;
                }
                continue;
            }
        }

        //run it the other way too.
        for (var t=0; t < tnids2.length; t++) {
            var t2_nObj = MEMG.getNeuronByTempNid(tnids2[t]);
            var t2_relons = await MEMG.getRuntimeRelonsForContext(t2_nObj.nid); 
            for (var r=0; r < t2_relons.length; r++) {
                var rel = t2_relons[r];
                if (rel.to_type!=TO_TYPE_ANNE) continue;
                if (tnids1.indexOf(rel.r)!=-1) {
                    var pObj = this.__getPoolObjByTNID(rel.t);
                    if (pObj==null) {
                        var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                        pObj = {nObj:toNOBJ, target:false, candidate:true, from_text:t2_nObj.text, base_target:t2_nObj, weight:1, hits:0, founds:[true, true], founds_hits:[1,1]};
                        this.__addNewPoolObj(pObj); 
                    }
                    else pObj.founds_hits[0]+=1;
                }
                continue;
            }
            for (var r=0; r < t2_nObj.ins.length; r++) {
                var rel = t2_nObj.ins[r];
                if (rel.to_type!=TO_TYPE_ANNE) continue;
                if (tnids2.indexOf(rel.r)!=-1) {
                    var pObj = this.__getPoolObjByTNID(rel.f);
                    if (pObj==null) {
                        var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
                        pObj = {nObj:fromNOBJ, target:false, candidate:true, from_text:fromNOBJ.text, base_target:t2_nObj, weight:1, hits:0, founds:[true, true], founds_hits:[1,1]};
                        this.__addNewPoolObj(pObj);
                    }
                    else pObj.founds_hits[0]+=1;
                }
                continue;
            }
        }

        if ($arr_of_arr.length>2) {
            for (var a=2; a < $arr_of_arr.length; a++) {
                await this.union_tnids_extend($arr_of_arr[a], a);
            }
        }
    }


    /**
     * Candidate pool has matches up to thus far.  
     * We need to now look for a union of a candidate with our new tnid
     * @param {*} $arr1 
     */
    union_tnids_extend=async($tnids, $index=2)=> {
        var candiateTnids = this.getCandidateTnids();
        for (var t=0; t < $tnids.length; t++) {
            var t1_nObj = MEMG.getNeuronByTempNid($tnids[t]);
            var t1_relons = await MEMG.getRuntimeRelonsForContext(t1_nObj.nid); 
            for (var r=0; r < t1_relons.length; r++) {
                var rel = t1_relons[r];
                if (rel.to_type!=TO_TYPE_ANNE) continue;
                if (candiateTnids.indexOf(rel.t)!=-1) {
                    var pObj = this.__getPoolObjByTNID(rel.t);
                    pObj.founds[$index]=true;
                    pObj.founds_hits[$index]+=1;
                }
                continue;
            }

            for (var r=0; r < t1_nObj.ins.length; r++) {
                var rel = t1_nObj.ins[r];
                if (rel.to_type!=TO_TYPE_ANNE) continue;
                if (candiateTnids.indexOf(rel.r)!=-1) {
                    var pObj = this.__getPoolObjByTNID(rel.r);
                    pObj.founds[$index]=true;
                    pObj.founds_hits[$index]+=1;
                }
                continue;
            }
        }
    }


    /**
     * We may have to manage this pool better with things that get really big 
     * for partial matches.
     * @param {*} $title 
     * @returns 
     */
    getCandidatesWithFounds=function($title="") {
        var candidates_with_founds=[];
        for (var p=0; p < this._pool.length; p++) {
            var pObj = this._pool[p];
            if (pObj.candidate==false) continue;
            for (var f=0; f < pObj.founds.length; f++) {
                if (pObj.founds[f]==true) {
                    pObj.hits+=1;
                    pObj.weight += pObj.founds_hits[f];
                }
            }
            candidates_with_founds.push(pObj);
        }
        if (candidates_with_founds.length) candidates_with_founds.sort(anne_nlp._sortMatchObjByHits);
        console.log(candidates_with_founds);
        this.printPool($title);
        return candidates_with_founds;
    }

    __addNewPoolObj = function($pObj) {
        if ($pObj.fire==undefined) $pObj.fire=0;
        this._pool.push($pObj);
        this._pool_map[$pObj.nObj.temp_nid] = this._pool.length-1;
    }  


    /**
     * 
     * @param {*} $thresh 
     * @param {*} $title 
     * @returns 
     */
    getHighestWeightOverThreshold=function($thresh=1, $title=""){
        this.printPool($title);
        var highestThresh = $thresh;
        var candidates = [];
        for (var p=0; p < this._pool.length; p++) {
            var pObj = this._pool[p];
            if (pObj.candidate==false) continue;
            candidates.push(pObj);
            if (pObj.weight>highestThresh) {
                highestThresh = pObj.weight;
                candidate = pObj;
            }
        }
        if (candidates.length>1) candidates.sort(anne_nlp._sortMatchObjByWeight);
        return candidates;
    }

     
    /**
     * 
     * @param {*} $title 
     * @param {*} $sortBy 
     */
    printPool = function($title="print", $sortBy=DP_SORT_BY_FIRE) {
        var candlist = ANNE.MEMG.getTextListStrFromNObjs(this._baseCandidatesNOBJS);
        console.log("%c "+$title+"%cRESOLVE POOL %c candidates ["+candlist+"] %c"+this.role.ph.l1str, TALK.bgblack, TALK.bgyellow, TALK.bggreen, TALK.green)
        var sortable = [];
        for (var p=0; p < this._pool.length; p++) {
            var pObj = this._pool[p];
            sortable.push(pObj);
        }
        if ($sortBy==DP_SORT_BY_FIRE) sortable.sort(anne_nlp._sortMatchObjByFire);
        else if ($sortBy==DP_SORT_BY_HITS) sortable.sort(anne_nlp._sortMatchObjByHits);
        for (var s=0; s < sortable.length; s++) {
            var sObj = sortable[s];
            if (sObj.target==true) { 
                if (sObj.hits>0) console.log("%c target %c '"+sObj.nObj.text+"' weight:"+sObj.weight+" %cfrom:["+sObj.from_text+"] %c hits:"+sObj.hits, TALK.bgblue, TALK.bgblack, TALK.bgblue, TALK.bggreen)
                else console.log("%c target %c '"+sObj.nObj.text+"' weight:"+sObj.weight, TALK.bglightblue, TALK.bggray)
            }
            else if (sObj.candidate==true) {
                var froms = this._genTextListFromTNIDS(sObj.base_candidateTNIDS);
                if (sObj.fire>0) console.log("%c candidate %c '"+sObj.nObj.text+"' %c fire:"+sObj.fire+" weight:"+sObj.weight+" hits:"+sObj.hits+" %c from:"+froms, TALK.bggreen, TALK.bgblack, TALK.bgfire, TALK.bgblack);
                else console.log("%c candidate %c '"+sObj.nObj.text+"' fire:"+sObj.fire+" weight:"+sObj.weight+" hits:"+sObj.hits+" %c from:"+froms, TALK.bglightgreen, TALK.bggray, TALK.bgblack);
            }
        }
    }












        
    //change this to be for the new nlp_ph we use parts, mod_ph_parts, and sig_parts.
    resolve=async()=>{
        this.fireModsTargets(this.role.mods);           //"third"  ||  "with the big red spot"
        this.fireClassCandidates(this.role.nObj);       //planet
    }



    /**
     * This is for PN resolution
     * We could use gender as a clue..
     * The only other clues is how they are referenced in the next sentence..
     * 
     * non-prev-actor resolution is NOT EASY without clues.
     * 
     * "She thought she was so invincible" ---  (who is she?)
     * if prev sentence was "Suzy punched Sally and bloodied her lip."....
     * "she" is resolving to the affected_thing (Sally), not the actor (Suzy)!
     * 
     * if prev setence was "Suzy let a scorpion bite her on the lip."
     * "she" would be the actor (Suzy).
     * 
     * 
     * Simple use:
     * "She keeps up with current technology trends."
     * 
     * @param {anne_neuron} - the pn neuron we are trying to resolve
     * @param {array} - array of ctp_obj objects for things in recent context.
     */
    resolvePNRoleAndSetWinner=async($role, $candidateCOBJS, $types=[TYPE_BE, TYPE_HAS, TYPE_ROLE, TYPE_CLUMP, TYPE_BRAIN])=> {
        
        //hmmm.
        
        var cands = this.getHighestWeightOverThreshold($candidatesCOBJS);
        return this.setWinner(cands);

        await this.addTargetRobust($role.ph.resolve_nObj);
        var weight=1;
        for (var c=0;  c < $candidateCOBJS.length; c++) {
            var candCOBJ = $candidateCOBJS[c];
            console.log(candCOBJ);
            this.addUniqueCandidate(candCOBJ.nObj, 1, candCOBJ.nObj.temp_nid, weight/(ANNE.BRAIN.ctp._clump_index-candCOBJ.last_ci));
            var relons = await MEMG.getRuntimeRelonsForContext(candCOBJ.nObj.nid, $types);
            for (var r=0; r < relons.length; r++) {
                var w2 = weight;
                var relon = relons[r];
                if (relon.to_type!=TO_TYPE_ANNE) continue;
                if ($types.indexOf(relon.type)==-1) continue;
                if (relon.type==TYPE_BRAIN) {
                    var rN = MEMG.getNeuronByTempNid(relon.r);
                    if (rN.value!=undefined) w2 = rN.value;
                }
                var toNOBJ = MEMG.getNeuronByTempNid(relon.t);
                this.addUniqueCandidate(toNOBJ, 2, candCOBJ.nObj.temp_nid, w2);
            }
        }

        var cands = this.getCandidatesWithWeight();
        console.log(cands);
        return this.setWinner(cands);
    }
    

    /**
     * boom!
     */
    resolveAndSetWinner=async($debug="")=>{
        //"third"  ||  "with the big red spot"
        this.fireModsTargets(this.role.mods);           
        this.fireClassCandidates(this.role.nObj);       //planet
        var cands = this.getCandidatesWithFire($debug);
        return this.setWinner(cands);
    }


    /**
     * set the winner
     **/
    setWinner=function($cands) {
        if ($cands.length>0) {
            this.role.updateResolved($cands[0].nObj);
            return true;
        }
        else console.log("%c NO WINNER :( for role ["+this.role.role_text+"] %c"+this.role.ph.phrase, TALK.bgred, TALK.bggreen);
        //we will need a new neuron for this.  
        //we don't know of it.
        return false;
    }

    
    /**
     * blow out the children of this class.. as our targets for resolution.
     */
     fireModsTargets=function($modRoles){
        for (var n=0; n < $modRoles.length; n++) {
            var role = $modRoles[n];
            console.log(role);
            this.addTarget(role.nObj);
        }
    }
    

    /**
     * add the target neuron and pull in its level 1 (non-inherited) relons.
     * example:  "third"  "with the big red spot"
     * investigate signal words like "with" and what ecs they may touch to alter
     * the logical meaning (ie, without)
     */
    addTarget=function($nObj, $types=[TYPE_BE, TYPE_HAS, TYPE_ROLE, TYPE_CLUMP, TYPE_BRAIN]){
        var weight = 1;
        var pObj = {nObj:$nObj, target:true, candidate:false, from_text:$nObj.text, base_target:$nObj, weight:3, hits:0};
        this.__addNewPoolObj(pObj);
        for (var r=0; r < $nObj.outs.length; r++) {
            var relon = $nObj.outs[r];
            if (relon.to_type!=TO_TYPE_ANNE) continue;
            if ($types.indexOf(relon.type)==-1) continue;
            if (relon.type==TYPE_BRAIN) {
                var rN = MEMG.getNeuronByTempNid(relon.r);
                if (rN.val!=undefined) weight = rN.val;
            }
            if (this._pool_map[relon.t]==undefined) {
                var toNOBJ = MEMG.getNeuronByTempNid(relon.t);
                var pObj = {nObj:toNOBJ, target:true, candidate:false, from_text:$nObj.text, base_target:$nObj, weight:weight, hits:0};
                this.__addNewPoolObj(pObj);
            }
            else {
                var pObj = this.__getPoolObjByTNID($nObj.temp_nid);
                if (pObj==null) {
                    alert("fix this.. this is in our map!");
                    return;
                }
                pObj.weight+=weight;
            }
        }
    }
    addTargetRobust=async($nObj, $types=[TYPE_BE, TYPE_HAS, TYPE_ROLE, TYPE_CLUMP, TYPE_BRAIN])=>{
        var weight = 1;
        var pObj = {nObj:$nObj, target:true, candidate:false, from_text:$nObj.text, base_target:$nObj, weight:3, hits:0};
        this.__addNewPoolObj(pObj);
        var relons = await MEMG.getRuntimeRelonsForContext($nObj.nid, $types);  
        for (var r=0; r < relons.length; r++) {
            var relon = relons[r];
            if (relon.to_type!=TO_TYPE_ANNE) continue;
            if ($types.indexOf(relon.type)==-1) continue;
            if (relon.type==TYPE_BRAIN) {
                var rN = MEMG.getNeuronByTempNid(relon.r);
                if (rN.val!=undefined) weight = rN.val;
            }
            if (this._pool_map[relon.t]==undefined) {
                var toNOBJ = MEMG.getNeuronByTempNid(relon.t);
                var pObj = {nObj:toNOBJ, target:true, candidate:false, from_text:$nObj.text, base_target:$nObj, weight:weight, hits:0};
                this.__addNewPoolObj(pObj);
            }
            else {
                var pObj = this.__getPoolObjByTNID($nObj.temp_nid);
                if (pObj==null) {
                    alert("fix this.. this is in our map!");
                    return;
                }
                pObj.weight+=weight;
            }
        }
    }
  
    __getPoolObjByTNID = function($temp_nid) {
        var poolIndex = this._pool_map[$temp_nid];
        if (poolIndex==undefined) return null;
        return this._pool[poolIndex];
    }

     
    /**
     * Candidates (typically insts but always) that match up to the 
     * target params we are looking for
     */
    fireClassCandidates=function($nObj, $weight=1, $types=[TYPE_BE, TYPE_HAS, TYPE_ROLE, TYPE_CLUMP, TYPE_BRAIN], $maxChildren=100){
        var children = [];
        $nObj.getAllDownlineChildren(children, 0, true, false, true, false);
        for (var c=0; c < Math.min(children.length, $maxChildren); c++) {
            this.addUniqueCandidate(children[c], 1, children[c].temp_nid, $weight);
            for (var r=0; r < children[c].outs.length; r++) {
                var weight = $weight;
                var relon = children[c].outs[r];
                if (relon.to_type!=TO_TYPE_ANNE) continue;
                if ($types.indexOf(relon.type)==-1) continue;
                if (relon.type==TYPE_BRAIN) {
                    var rN = MEMG.getNeuronByTempNid(relon.r);
                    if (rN.value!=undefined) weight = rN.value;
                }
                var toNOBJ = MEMG.getNeuronByTempNid(relon.t);
                this.addUniqueCandidate(toNOBJ, 2, children[c].temp_nid, weight);
            }
        }
    }
     

    /**
     */
    addUniqueCandidate = function($nObj, $gen=1, $candidateTNID, $weight=1) {
        if (this._pool_map[$nObj.temp_nid]==undefined) {
            var pObj = {nObj:$nObj, text:$nObj.text.toLowerCase(), weight:$weight, gen:$gen, candidate:true, target:false, base_candidateTNIDS:[$candidateTNID], hits:0};
            this.__addNewPoolObj(pObj);
            this._baseCandidatesNOBJS.push($nObj);
        }

        //existing neuron in the pool
        else {
            var pObj = this._pool[ this._pool_map[$nObj.temp_nid] ];
            if (pObj.target==true) {
                pObj.candidate=true;
                var candidatePObj = this.__getPoolObjByTNID($candidateTNID) 
                candidatePObj.fire+= ($weight * pObj.weight);
                candidatePObj.hits+=1;
                pObj.hits+=1;
            }
            else {
                if (pObj.base_candidateTNIDS.indexOf($candidateTNID)==-1) pObj.base_candidateTNIDS.push($candidateTNID);
                pObj.weight+=$weight;   //no guarantee of order of this before it propogates.. but want it to test for print
            }
        }
    }




    /**
     * 
     * @param {*} $tnids 
     * @returns 
     */
    _genTextListFromTNIDS = function($tnids) {
        if ($tnids==undefined || $tnids==null || $tnids.length==0) return "";
        var str = [];
        for (var t=0; t <$tnids.length;t++) {
            var nObj = MEMG.getNeuronByTempNid($tnids[t]);
            if(nObj==null) continue;
            str.push(nObj.text);
        }
        if (str.length==0) return "";
        else if (str.length==1) return str[0];
        return str.join(", ");
    }


    /**
     * 
     * @param {*} $title 
     * @param {*} $bHITSMULTIPLIER 
     * @returns 
     */
    getCandidatesWithFire=function($title="", $bHITSMULTIPLIER=true){
        this.printPool($title);
        var candidates_with_fire=[];
        for (var p=0; p < this._pool.length; p++) {
            var pObj = this._pool[p];
            if (pObj.candidate==false) continue;
            if (pObj.fire>0) {
                if ($bHITSMULTIPLIER) pObj.fire = pObj.fire+(pObj.hits*2);
                candidates_with_fire.push(pObj);
            }
        }
        if (candidates_with_fire.length>1) candidates_with_fire.sort(anne_nlp._sortMatchObjByFire);
        console.log(candidates_with_fire);
        return candidates_with_fire;
    }
}