
/**
 * dossier_asdf
 */
 class dossier_asdf extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_asdf", TALK.bgredbig);
        this._mode = "";
        this.rel_oracle = null;
        this.rel_reln = null;
        this.rel_reward = null;
        this.btn_to = null;
        this.rel_to = null;
        this.rel_to_cdx = null;
        this.rel_to_nonanne_val = null;
        this.rel_desc = null;
        this.rel_freeze = null;
        this.rel_nomoretakers = null;
        this.rel_cuttof_to = null;
        this.rel_risk_funded = null;
        this.el_dynamic_to_div = null;
        this.el_to_question = null;
        this.btn_to = null;
        this.btn_to_noneanne_val = null;
        this.el_btns = null;
        this._freeze_annies = 0;
        this.status = "";
        this.resultNOBJ = null;
    }


    initASYNC = async()=>{
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);
        await this.getBalance(true); 
        
        ANNE.A.removeSelf("garden_"+this.nObj.temp_nid);
        ANNE.A.removeSelf(this.el_bebox_name);

        //make the page max.
        if (this.nObj.ghost==true || this.nObj.freeze==0) {
            //ANNE.A.addRemoveClass(this.el_doss_body, "anne-page-dossier-solo-body-nofeedback", "anne-page-dossier-solo-body")
        }
        
        var required = 0;
        
        if (this.nObj.owned_by==USER._userNObj.nid) {
            if (this.nObj.ghost==true) {
                var msg = "<span class='callout-title-ghost'>&#9888;&nbsp;<span style='font-size:1.3rem'>NOTE</span></span><BR>";
                msg = msg + "<span style='text-align:center'>Once all the minimum requirements are SET you will be able to update this Ghost to a real neuron. <img class='dib' src='../imgs/ghost_upgrade_other_ico.png' width='40px'>";
                msg = msg + " After your neuron is a real neuron you must <img class='dib' src='../imgs/ico_freeze.png' width='20px'>FREEZE it with payment to fund the total risk you are offering.</span>"
                ANNE.A.ezEl(this.el_bes_content, "div", "callout-ghost-text-reading", msg); 
            }
            else if (this.nObj.freeze==0) {
                var msg = "<span class='callout-title-freeze'>&#9888;&nbsp;<span style='font-size:1.3rem'>NOTE</span></span><BR>";
                msg = msg + "<span style='text-align:center'>For your ASDF to be live to the public you must <b><img class='dib' src='../imgs/ico_freeze.png' width='20px'>FREEZE</b> and fund the risk you want to offer.  You decide how much risk you are offering to the public on this ASDF.";
                msg = msg +"  At any time during the ASDF being active you can send more annecoin to offer more risk.  This must be done via the <b>ASDF-ADD-RISK</b> button that will be availble to ASDF owners while the ASDF is active.</span>";
                ANNE.A.ezEl(this.el_bes_content, "div", "callout-freeze-text-reading", msg); 
            }
            this._mode = "maker";
        }
        else this._mode="user";        
        
        if (this.nObj.freeze==1) {
            this.rel_freeze = MEMG.getSysMsgRelon(this.nObj.outs, MEM.CMD_FREEZE.temp_nid);
        }
        this.el_stuff=ANNE.A.ezEl(this.el_content, "div", "simple-row");
        
        //desc will go at top.
        this.el_desc=ANNE.A.ezEl(this.el_content, "div", "simple-row");

        if (this._mode=="maker") this.el_btns=ANNE.A.ezEl(this.el_content, "div", ""); //only makers will use this.

        //ORACLE
        this.rel_oracle = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_ORACLE.temp_nid);
        if (this.rel_oracle==null) {    
            if (this._mode=="maker") {
                var rel_param_oracle = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_ORACLE.temp_nid);
                var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_CHILD_RELON, rel_param_oracle, "SET the oracle of this ASDF", true);    
            }
            required+=1;
        }
        else this.doSingleTHISHas(this.el_stuff, "", this.rel_oracle);
        
        //RELN
        this.rel_reln = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_ORACLE_RELN.temp_nid);
        if (this.rel_reln==null) {    
            if (this._mode=="maker") {
                var rel_param_reln = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_ORACLE_RELN.temp_nid);
                var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_CHILD_RELON, rel_param_reln, "SET the oracle RELN of this ASDF", true);    
            }
            required+=1;
        }
        else {
            this.doSingleTHISHas(this.el_stuff, "", this.rel_reln);
        }

        //REWARD
        this.rel_reward = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_REWARD.temp_nid);
        if (this.rel_reward==null) {    
            if (this._mode=="maker") {
                var rel_param_reward = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_REWARD.temp_nid);
                var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_CHILD_RELON, rel_param_reward, "SET the reward (ratio)", true);
                btn.setAttribute("minimum", "0.0001");
                btn.setAttribute("maximum", "1000"); 
                btn.setAttribute("default", 1);
                btn.setAttribute("prompt", "<b>More likely</b> events should be less than 1.<BR><b>Less likely</b> events should be greater than 1.<BR>This is the future payout factor if the TO value or TO CDX (condition) is observed.");
            }
            required+=1;
        }
        else this.doSingleTHISHas(this.el_stuff, "", this.rel_reward);

        
        //DESCRIPTION
        this.rel_desc = MEMG.getHasRelon(this.nObj.outs, MEM.description.temp_nid);
        if (this.rel_desc==null) {    
            if (this._mode=="maker") {
                var rel_param_desc = MEMG.getParamRelon(MEM.ASDF.outs, MEM.description.temp_nid);
                var btn = this.makeCollabBtn(this.el_btns, TXB.TXTYPE_CHILD_RELON, rel_param_desc, "set the description", true);
                btn.setAttribute("prompt", "Set the description to be as clear as possible as to what this ASDF is for.");
            }
            required+=1;
        }

        //get these relons...
        this.rel_to = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO.temp_nid);
        this.rel_to_cdx = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_CDX.temp_nid);
        this.rel_to_nonanne_val = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_CDX_NONANNE_VAL.temp_nid);
        this.rel_to_anne_date = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_ANNE_CDX_ANNE_DATE.temp_nid);
        this.rel_future_to_attr = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_NID_ATTR.temp_nid);

        /*************** QUESTION DIV **************************/
        //present the user with the question of which type of to.
        if (this._mode=="maker") {
             
            if (this.rel_to==null && this.rel_to_cdx==null && this.rel_to_noneanne_val==null && this.rel_to_anne_date==null) {
                var q = "<b>Is future TO value an ANNE neuron value, future non-anne numeric or a future anne date?</b>";
                this.el_to_question=ANNE.A.ezEl(this.el_btns, "div", "simple-row asdf-question", q);
                var note = "<b>note</b>: The future value can be INSIDE of a future neuron.  If so, make sure to set the future ATTR value!<BR>";
                ANNE.A.ezAddNote(this.el_to_question, note, "small-note");

                this.el_dynamic_to_div=ANNE.A.ezEl(this.el_btns, "div", "");
                required+=1;
                var ezbtn = ANNE.A.ezButton(this.el_to_question, "", "ANNE neuron", "noround anne-btn2 btn-red-sq btn-stpd-sm", async(e)=>{
                    this.doToANNENeuron();
                });
                ezbtn.style['margin-right']="10px";
                var ezbtn2 = ANNE.A.ezButton(this.el_to_question, "", "CDX numeric val", "noround anne-btn2 btn-red-sq btn-stpd-sm", async(e)=>{
                    this.doToCDXNumber();
                });
                ezbtn2.style['margin-right']="10px";
                ANNE.A.ezButton(this.el_to_question, "", "CDX DATE", "noround anne-btn2 btn-red-sq btn-stpd-sm", async(e)=>{
                    this.doToCDXDate();
                });
            }
        }
        
        //just display what we have (non-maker mode)
        if (this.rel_to!=null) this.doSingleTHISHas(this.el_stuff, "", this.rel_to);
        else if (this.rel_to_nonanne_val!=null) this.doSingleTHISHas(this.el_stuff, "", this.rel_to_nonanne_val);
        else if (this.rel_to_anne_date!=null) this.doSingleTHISHas(this.el_stuff, "", this.rel_to_anne_date);
        if (this.rel_to_cdx!=null)  this.doSingleTHISHas(this.el_stuff, "", this.rel_to_cdx);
        if (this.rel_future_to_attr!=null)  this.doSingleTHISHas(this.el_stuff, "", this.rel_future_to_attr);
        

        //******************** OPTIONALS */
        //**********************************************************/
        //**********************************************************/
        if (this.nObj.freeze==0) {
            ANNE.A.ezEl(this.el_bes_content, "div", "section-title", "Optional Settings");
        }

        //expire..
        this.rel_expire = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_EXPIRE_AT_BLOCK.temp_nid);
        if (this.rel_expire==null) {    
            if (this._mode=="maker" && this.nObj.freeze==0) {
                var rel_param_expire = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_EXPIRE_AT_BLOCK.temp_nid);
                var elbtn = ANNE.A.ezEl(this.el_bes_content, "div");
                elbtn.style.display="flex";
                var btn = this.makeCollabBtn(elbtn, TXB.TXTYPE_CHILD_RELON, rel_param_expire, "set the expire block");   
                btn.setAttribute("validate", "future_block");
            }
        }
        else this.doSingleTHISHas(this.el_stuff, "", this.rel_expire);
        //**********************************************************/
        //**********************************************************/
        

        if (this.rel_risk_funded!=null) this.doSingleTHISHas(this.el_stuff, " ", this.rel_nomoretakers);
        this.status = "";

        //************************** STATUS **************************/
        //only show status and annode created relons when non-ghost mode.
        //also, status won't show until FREEZE as that is when the ASDF is first taken action upon by the annode.
        if (this.nObj.ghost==false) {
            this.rel_on_chain_status = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_STATUS.temp_nid);
            
            //we want to colorize the gui bg with this to super callout status.
            if (this.rel_on_chain_status!=null) {

                this.status = this.rel_on_chain_status.t;
                this.doSingleTHISHas(this.el_bes_content, "", this.rel_on_chain_status);

                //status explanation goes here.
                var el_status_explain = ANNE.A.__getEl("status_explain_"+this.ID);
                ANNE.A.show(el_status_explain);
                if (this.status == MEM.ASDF_STATUS_EXPIRED.temp_nid) {
                    el_status_explain.classList.add("status-expired");
                    el_status_explain.setHTML("** This ASDF has expired at block "+this.rel_expire.to_s+" and all funds were returned. **");
                }
                else if (this.status == MEM.ASDF_STATUS_SETTLED.temp_nid) {
                    el_status_explain.classList.add("status-complete");
                    
                    //MEM.ASDF_RESULT
                    var rel_result =MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_RESULT.temp_nid);
                    if (rel_result!=null) {
                        this.resultNOBJ = MEMG.getNeuronByTempNid(rel_result.t);
                        if (this.resultNOBJ.nid==MEM.ASDF_RESULT_FUTURE_OBSERVED.nid) {
                            var el_final = ANNE.A.ezEl(el_status_explain, "div", "", "This ASDF is settled. <span class='asdf-future-observed'>"+this.resultNOBJ.text+"&nbsp;</span>");
                            var el_trigger = await MEMG.lookupByTXID_chase(rel_result.sys_ref_txid);
                            if (el_trigger!=null) EXT_BTNS.makeRelonViewLink_SMART(el_final, el_trigger, false, 8, true);

                        }
                        else {
                            var el_final = ANNE.A.ezEl(el_status_explain, "div", "", "This ASDF is settled. <span class='asdf-future-not-observed'>"+this.resultNOBJ.text+"&nbsp;</span>");
                            var el_trigger = await MEMG.lookupByTXID_chase(rel_result.sys_ref_txid);
                            if (el_trigger!=null) EXT_BTNS.makeRelonViewLink_SMART(el_final, el_trigger, false, 8, true);
                        }
                    }
                    else {
                        el_status_explain.setHTML("** This ASDF is settled. **");
                    }
                }
                else if (this.status == MEM.ASDF_STATUS_OPEN.temp_nid) {
                    el_status_explain.classList.add("status-open");
                    el_status_explain.innerHTML="** This ASDF is open for risk taking. **";
                }
                else if (this.status == MEM.ASDF_STATUS_FULL.temp_nid) {
                    el_status_explain.classList.add("status-full");
                    el_status_explain.innerHTML="** This ASDF is full (no more risk available). **";
                }
            }

            //auto calc by annode ASDF.java.
            this.rel_risk_funded = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_RISK_FUNDED.temp_nid);
            if (this.rel_risk_funded!=null) this.doSingleTHISHas(this.el_stuff, "", this.rel_risk_funded);

            if(this.status==MEM.ASDF_STATUS_OPEN.temp_nid) {

                this.rel_event_risk_remaining = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_RISK_REMAINING.temp_nid);
                
                if (this.rel_event_risk_remaining!=null) {
                    this.doSingleTHISHas(this.el_bes_content, "", this.rel_event_risk_remaining);
                }

                var el_bes_btns = ANNE.A.ezEl(this.el_bes_content, "div", "simple-row");
                el_bes_btns.style['margin-top']="10px";
                
                //add risk
                if (this._mode=="maker" && this.nObj.freeze==1) {
                    const el_holder = ANNE.A.ezAnnecoin_entry(el_bes_btns, async($annecoin)=>{
                        console.log("accept risk!");
                        ANNE.A.hide(el_holder);
                        var annies = parseInt($annecoin)*100;   //we store annies in the backend.
                        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.ASDF_ADD_RISK.nid, TO_TYPE_ANNE, this.nObj.nid, annies);
                        //reference the freeze, we can't mine this until the neuron is froze!
                        ghost_rel.sys_ref_txid = this.rel_freeze.txid;
                        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ASDF_ADD_RISK);   
                        ANNE.playSound("success");
                        return await SENDQ.___sendQueue();
                    }, "add available risk", "add risk", null, "aar", "noround btn-someanniesaction");

                    var btnm = ANNE.A.setAttribute("btn_main_aar", "i_placeholder", "min annecoin 100");
                    btnm.setAttribute("i_min_val", 100);
                    

                    var cutoffBtn = ANNE.A.ezButton(el_bes_btns, "", "NO MORE takers", "noround btn-someanniesaction", async(e)=>{
                        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.ASDF_ORACLE_NO_MORE_TAKERS.nid, TO_TYPE_ANNE, this.nObj.nid);
                        //reference the freeze, we can't mine this until the neuron is froze!
                        ghost_rel.sys_ref_txid = this.rel_freeze.txid;
                        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ASDF_NOMORE_RISK);   
                        ANNE.playSound("success");
                        return await SENDQ.___sendQueue();
                    });
                    cutoffBtn.setAttribute("title", "set the ASDF to allow no more risk takers.")  
                }

                //accept risk
                else if (this._mode=="user" && this.nObj.freeze==1){

                    //bug in refresh, but the data is good.
                    if (this.rel_event_risk_remaining && this.rel_event_risk_remaining.to_s>0) {
                        const el_holder = ANNE.A.ezAnnecoin_entry(el_bes_btns, 
                            async($annecoin)=>{
                                console.log("accept risk!");
                                ANNE.A.hide(el_holder);
                                var annies = parseInt($annecoin)*100;
                                var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, USER._userNObj, MEM.ASDF_ACCEPT_RISK.nid, TO_TYPE_ANNE, this.nObj.nid, annies);
                                //reference the freeze, we can't mine this until the neuron is froze!
                                ghost_rel.sys_ref_txid = this.rel_freeze.txid;
                                await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_ASDF_ACCEPT_RISK);   
                                ANNE.playSound("success");
                                return await SENDQ.___sendQueue();
                            }, 
                            "accept available risk", 
                            "accept risk", 
                            async($annecoin, $disp)=>{
                                    ANNE.A.removeSelf("acceptriskid");
                                    if ($annecoin!=0) {
                                        var msg = " risk <b>"+UTILS.formatNumber($annecoin)+" annecoin </b> to get <b>"+UTILS.formatNumber(parseInt($annecoin)+(parseInt($annecoin)*this.rel_reward.to_s))+" annecoin back</b>";
                                        ANNE.A.ezEl($disp.parentNode.parentNode, "span", "msgline", msg, "acceptriskid");
                                    }
                                }, "aar");
                        
                        var btnm = ANNE.A.setAttribute("btn_main_aar", "i_placeholder", "min annecoin 100");
                        btnm.setAttribute("i_min_val", 100);
                        var maxval = this.rel_event_risk_remaining.to_s;
                        if (maxval > USER._userNObj.balanceObj.annies) maxval = USER._userNObj.balanceObj.annies/100;
                        btnm.setAttribute("i_max_val", maxval);
                        console.log(USER._userNObj.balanceObj);
                    }
                }
            }
        }


        //upgrade/freeze logics
        if (this._mode=="maker") {
            if (this.nObj.ghost==true) {
                if (required>0) ANNE.A.hide(this.el_upgrade_ghost_relons);
                else {
                    this.explainRisk();
                    ANNE.A.show(this.el_upgrade_ghost_relons);
                }
            }
            else {
                if (this.nObj.ghost==false && required==0 && this.nObj.freeze==0)  {
                    if (this.nObj.hasGhostRelons()==false) {
                        var btn_freeze = ANNE.A.showParent("freeze_selfOwned_btn_"+this.ID, true);
                        btn_freeze.addEventListener("click", async(e)=>{
                            ANNE.A.show("freeze_annies_"+this.ID);
                            ANNE.A.removeParent(btn_freeze);  //don't want any downstream gui stuff to turn this back on in this view.
                            var freeze_anne_input = ANNE.A.show("freeze_anne_input_"+this.ID);
                            freeze_anne_input.addEventListener("input", e=>this.freeze_annecoin_entered(e));
                            freeze_anne_input.setAttribute("uid_pre", this.ID);
                            var btn_final_freeze = ANNE.A.hide("final_freeze_"+this.ID);
                            btn_final_freeze.addEventListener("click", e=>this.freezeASDF(e));
                        });
                    }
                }
            }
        }

        else {
            if (this.nObj.freeze==1) {
                if (this.status==MEM.ASDF_STATUS_OPEN.temp_nid) {
                    this.explainRisk();
                }
            }
        }
        
    
        var takers = MEMG.getRelonsByType(this.nObj.outs, TYPE_BRAIN120);
        if (takers.length) this.doSection_risk_takers(takers);
       

        //explain clearly.
        if (this.status == MEM.ASDF_STATUS_SETTLED.temp_nid) this.explainSettled();

        //show feedback if not a ghost and not frozen.
        if (this.nObj.false==true || this.nObj.freeze==1) {
            this.addAwarvu();
        }
            
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }


    /**
     * 
     */
    explainSettled = function() {
        var explain = "";
        var rezNOT = "";
        if (this.resultNOBJ.nid==MEM.ASDF_RESULT_FUTURE_NOT_OBSERVED.nid) rezNOT = " <b style='color:red'>NOT</b>";
        var oracleNOBJ = MEMG.getNeuronByTempNid(this.rel_oracle.t);
        var oracleRelnNOBJ = MEMG.getNeuronByTempNid(this.rel_reln.t);
        explain = "This ASDF paid out&nbsp;<b>"+this.rel_reward.to_s+"</b> times the risk plus returned the risked amount.";
        explain = explain + "  The ORACLE <b>"+oracleNOBJ.text+"</b> broadcast a transaction with the RELN <b>"+oracleRelnNOBJ.text+"</b>";
        explain = explain + " and the value was"+rezNOT;
        if (this.rel_to!=null) {
            var oracle_toNOBJ = MEMG.getNeuronByTempNid(this.rel_to.t);
            explain = explain + " equal to the FUTURE-TO of <b>"+oracle_toNOBJ.text+"</b>.";
        }
        else {

            var oracle_to_cdxNOBJ = MEMG.getNeuronByTempNid(this.rel_to_cdx.t);
            if (this.rel_to_nonenanne_val!=null) var toNonAnneVal  = this.rel_to_nonanne_val.to_s; 
            else if (this.rel_to_anne_date!=null) var toNonAnneVal  = this.rel_to_anne_date.to_s;    
            explain = explain + "<b>"+oracle_to_cdxNOBJ.text+"</b> the FUTURE-TO-VAL <b>"+toNonAnneVal+"</b>.";
        }
        var xrw = ANNE.A.ezElPrepend(this.el_content, "div", "simple-row");
        var xcol = ANNE.A.ezEl(xrw, "div", "asdf-reading");
        xcol.innerHTML = explain;
    }



    /**
     * 
     */
    explainRisk = function() {
        var explain = "";
        //if (this.nObj.ghost==false) return;
        var oracleNOBJ = MEMG.getNeuronByTempNid(this.rel_oracle.t);
        var oracleRelnNOBJ = MEMG.getNeuronByTempNid(this.rel_reln.t);
        var oracleOwnerNOBJ = MEMG.getNeuronByNid(oracleNOBJ.owned_by);
        explain = "This ASDF will pay out a total of &nbsp;<b class='text-success-lbl'>"+this.rel_reward.to_s+"</b> times the risk plus return the risked amount.  ";
        explain = explain + "  Settlement triggers when the owner <em>"+oracleOwnerNOBJ.bestNameHTML("", true)+"</em> of ORACLE neuron <b class='text-yellow'>"+oracleNOBJ.text+"</b>";
        explain = explain+" broadcasts or approves a collaboration with a RELN of <b class='text-yellow'>"+oracleRelnNOBJ.text+"</b> (nid:"+oracleRelnNOBJ.nid+").";
     
        if (this.rel_to!=null) {
            var oracle_toNOBJ = MEMG.getNeuronByTempNid(this.rel_to.t);

            if (this.rel_future_to_attr!=null) {
                var attrNOBJ = MEMG.getNeuronByTempNid(this.rel_future_to_attr.t);
                explain = explain + "<BR><BR>The observed future to value will come in a future neuron which has an atribute <b class='text-yellow'>"+attrNOBJ.text+"</b> that must ";
                explain = explain +  "be a value <b style='color:red; font-weight:800;'>"+oracle_toNOBJ.text+"</b> for the risk takers to get paid out for their risk.  ";
                explain = explain + "If this condition is not met, all funds go back to the ASDF creator.";
            } 
            else {
                explain = explain + "<BR><BR>The observed future to neuron must be <b>nid: "+oracle_toNOBJ.nid+"</b> named <b class='text-success-lbl'>"+oracle_toNOBJ.text+"</b>.";
                explain = explain + "If a different neuron (different nid) but same text 'name' is observed it will not match and ASDF risk takers will lose.";
            }
        }
        else {
            var oracle_to_cdxNOBJ = MEMG.getNeuronByTempNid(this.rel_to_cdx.t);
            
            //nonanne mode
            if (this.rel_to_nonanne_val!=null) {
                var toNonAnneVal  = this.rel_to_nonanne_val.to_s; 
                if (this.rel_future_to_attr!=null) {
                    var attrNOBJ = MEMG.getNeuronByTempNid(this.rel_future_to_attr.t);
                    explain = explain + "<BR><BR>The observed future to value will come in a future neuron that itself has a relon with reln (attribute) <b>"+attrNOBJ.text+"</b> that must ";
                    explain = explain +  "be <b style='color:red; font-weight:800;'>"+oracle_to_cdxNOBJ.text+"</b> <b>"+toNonAnneVal+"</b> for the risk takers to get paid out for their risk.  ";
                    explain = explain + "If this condition is not met, all funds go back to the ASDF creator.";
                }   
                else {
                    var cdx = "<b style='color:red; font-weight:800;'>"+oracle_to_cdxNOBJ.text+" "+toNonAnneVal+"</b>";
                    explain = explain + "<BR><BR>The observed future to value must be "+cdx+" for the risk takers to get paid out for their risk.  If this condition is <b>not</b> met, all funds go back to the ASDF creator (risk offerer).";
                }
            }

            else if (this.rel_to_anne_date!=null) {
                var toAnneDateNOBJ  = MEMG.getNeuronByNid(this.rel_to_anne_date.to_s); 
                var cdx = "<b style='text-success-lbl'>"+oracle_to_cdxNOBJ.asdf_date_disp+"</b> <b>"+toAnneDateNOBJ.text+"</b>";
                explain = explain + "<BR><BR>The observed future date value must be "+cdx+" for the risk takers to get paid out for their risk.  If this condition is <b>not</b> met, all funds go to the ASDF creator (risk offerer).";
            }
        }

        if (this.nObj.bGHOST==true) {
            explain = explain+"<BR>Once you upgrade your ASDF Ghost to a real neuron you can fund and freeze it..";
        }
        else if (this.nObj.bGHOST==true) {
            explain = explain+"<BR>Once you fund and freeze your ASDF it will be active.";
        }
        
        explain = explain+"<BR><BR><em style='font-size:.8rem; text-align:center; font-weight:800'>ANNE takes no fees for ASDFs.  This is a deal between ANNE identities.  ANNE L1 faciciliates and settles the ASDF according to protocol rules.</em>";

        var xrw = ANNE.A.__getEl("explain_detailed_"+this.ID);
        if (xrw==null) xrw = ANNE.A.ezElPrepend(this.el_content, "div", "simple-row", "", "explain_detailed_"+this.ID);
        var xcol = ANNE.A.ezEl(xrw, "div", "asdf-reading");
        xcol.innerHTML = explain;
    }


    /**
     * 
     */
    doToANNENeuron = function() {
        ANNE.A.empty(this.el_dynamic_to_div);
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
        this.el_to_question.style['opacity']=.5;

        var rel_param_future_to = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO.temp_nid);
        this.btn_to = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_future_to, "SET a direct TO value this pays out for", true);                
        //if the ASDF is using a death date (for example)
        //we want to populate the TO values with a date.
        if (this.rel_reln!=null) {
            var oracle_relon_toNOBJ = MEMG.getNeuronByTempNid(this.rel_reln.t);
            console.log(oracle_relon_toNOBJ);
            if (oracle_relon_toNOBJ.is(MEM.ec_state)==false && oracle_relon_toNOBJ.bes.indexOf(MEM.feelz.temp_nid)==-1) {
                this.btn_to.setAttribute("restrictToNid", oracle_relon_toNOBJ.nid);
            }
        }


        //we will need to make this more clear.. 
        //as the FUTURE_TO here is the -------> FUTURE ATTRIBUTE TO value if we provide a TO ATTR value (the reln we look for from the future neuron)
        if (this.rel_future_to_attr==null) {
            var rel_param_to_attr = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO_NID_ATTR.temp_nid);
            var btn = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_to_attr, "SET dynamic TO by attribute of TO neuron", false);
            
            //this is going to be any NEURON possible...
            //but most likely should be default to being those observed in the param of the ORACLE FROM
            //and/or those observed in any sibbling instances  (same parent class as oracle from)
            //var tnids_str = MEM.pdnOpTnids.join(",");
            //btn.setAttribute("manual-tnids", tnids_str);
            btn.setAttribute("title", "Used if the oracle will NOT broadcast a single value with the trigger reln but instead a complex neuron with many attributes.")
        }

        this.setToBtnMsg();
    }


    /**
     * 
     */
    doToCDXNumber=function(){
        ANNE.A.empty(this.el_dynamic_to_div);
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
        this.el_to_question.style['opacity']=.5;

        //conditional
        if (this.rel_to_cdx==null) {    
            var rel_param_to_cdx = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO_CDX.temp_nid);
            var btn = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_to_cdx, "SET a CDX (conditional)", true);
            var tnids_str = MEM.pdnOpTnids.join(",");
            btn.setAttribute("manual-tnids", tnids_str);
        }
        var rel_param_to_nonanne = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO_CDX_NONANNE_VAL.temp_nid);
        this.btn_to_noneanne_val = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_to_nonanne, "SET the numeric value", true);
        this.btn_to_noneanne_val.style["margin-left"]="6px";
        this.btn_to_noneanne_val.setAttribute("restrictToNid", MEM.number.nid);


        if (this.rel_future_to_attr==null) {
            var rel_param_to_attr = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO_NID_ATTR.temp_nid);
            var btn = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_to_attr, "SET dynamic TO by attribute of TO neuron", false);
            
            //this is going to be any NEURON possible...
            //but most likely should be default to being those observed in the param of the ORACLE FROM
            //and/or those observed in any sibbling instances  (same parent class as oracle from)
            //var tnids_str = MEM.pdnOpTnids.join(",");
            //btn.setAttribute("manual-tnids", tnids_str);
            btn.setAttribute("title", "Used if the oracle will NOT broadcast a single value with the trigger reln but instead a complex neuron with many attributes.")
        }
        
    }


    /**
     * 
     */
    doToCDXDate=function(){
        ANNE.A.empty(this.el_dynamic_to_div);
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
        this.el_to_question.style['opacity']=.5;

        //conditional
        if (this.rel_to_cdx==null) {    
            var rel_param_to_cdx = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO_CDX.temp_nid);
            var btn = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_to_cdx, "SET a CDX (conditional)", true);
            var tnids_str = MEM.pdnOpTnids.join(",");
            btn.setAttribute("manual-tnids", tnids_str);
        }
        
        var rel_param_to_anne_date = MEMG.getParamRelon(MEM.ASDF.outs, MEM.ASDF_FUTURE_TO_ANNE_CDX_ANNE_DATE.temp_nid);
        this.btn_to_anne_date = this.makeCollabBtn(this.el_dynamic_to_div, TXB.TXTYPE_CHILD_RELON, rel_param_to_anne_date, "SET the DATE value", true);
        this.btn_to_anne_date.style["margin-left"]="6px";
        this.btn_to_anne_date.setAttribute("restrictToNid", MEM.date_gregorian.nid);
    }



    /**
     * 
     * @param {*} $outs 
     */
    doSection_risk_takers=function($outs){
        var braindiv = ANNE.A.ezEl(this.el_content, "div", "section-title", "Risk Takers");
        var bDIDAPPEND = false;
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
             if (bDIDAPPEND==false) {
                this.el_content.append(braindiv);
                bDIDAPPEND=true;
             }
            var div = ANNE.A.ezEl(this.el_content, "div", "simple-row whiteonblack")
            EXT_BTNS.makeRelonViewLink_SMART(div, rel, false, 8, true);
            EXT_BTNS.makeNeuronLink_colorSquares(div, rel.reln);

            var el_risk = ANNE.A.ezSpan(div);
            ANNE.A.ezAnniesToAnneDisplay(el_risk, rel.to_s, true)

            var rez_relon = MEMG.getSysMsgRelonTo(this.nObj.outs, MEM.ASDF_RESULT_FUTURE_OBSERVED.temp_nid, rel.reln);
            if (rez_relon!=null) {
                ANNE.A.ezSpan(div, "", "", "&nbsp;paid out");
                EXT_BTNS.makeRelonViewLink_SMART(div, rez_relon, false, 8, true);
                var el_reward = ANNE.A.ezSpan(div);
                ANNE.A.ezAnniesToAnneDisplay(el_reward, rez_relon.annies)
            }
        }
    }

    
    /**
     * 
     * @param {*} $e 
     */
    freeze_annecoin_entered = async($e)=>{
        var el_freeze_annies_input = $e.target;
        if (el_freeze_annies_input==null) return;
        var el_display = el_freeze_annies_input.getAttribute("el-display");
        if (el_display!=null) el_display = document.getElementById(el_display);

        var amt = 0;
        var newval = 0;
        var lastChar = el_freeze_annies_input.value[el_freeze_annies_input.value.length-1];
        if (lastChar=="k" || lastChar=="K") {
            newval = Number.parseFloat(ANNE.A.getValue(el_freeze_annies_input)) * 1000;
            el_freeze_annies_input.value = newval;
        }
        else if (lastChar=="m" || lastChar=="M") {
            newval = Number.parseFloat(ANNE.A.getValue(el_freeze_annies_input)) * 1000000;
            el_freeze_annies_input.value = newval;
        }
        else if (lastChar=="b" || lastChar=="B") {
            newval = Number.parseFloat(ANNE.A.getValue(el_freeze_annies_input)) * 1000000000;
            el_freeze_annies_input.value = newval;
        }
        else if ("0123456789.,".indexOf(lastChar)==-1) {
            newval = "";
            for (var a=0; a < amt.length; a++) {
                if ((a!=(amt.length-1)) && "kKmMbB".indexOf(amt[a])!=-1) continue;
                else if ("0123456789.,".indexOf(amt[a])!=-1) continue;
                newval = newval+amt[a];
            }
            el_freeze_annies_input.value = newval;
        }

        this._freeze_annies = parseInt(el_freeze_annies_input.value)*100;
        var el_freeze_annies_final= document.getElementById("final_freeze_"+this.ID);
        if (this._freeze_annies>0) {
            ANNE.A.show(el_freeze_annies_final);
            ANNE.A.ezAnniesToAnneDisplay("freeze_annies_display_"+this.ID, this._freeze_annies, true); 
        }
        else {
            ANNE.A.hide(el_freeze_annies_final);
            ANNE.A.ezAnniesToAnneDisplay("freeze_annies_display_"+this.ID, 0); 
        }
    }
    

    /**
     * When user goes back from sender the page can be refreshed.
     * @param {*} $e 
     * @returns 
     */
    freezeASDF=async($e)=>{
        console.log("freeze ASDF!");
        ANNE.A.hideParent("freeze_selfOwned_btn_"+this.ID, true);
        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, this.nObj, MEM.CMD_FREEZE, TO_TYPE_ANNE, this.nObj.nid, parseInt(this._freeze_annies));
        ghost_rel.freeze = 1;
        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_CHILD_RELON);   
        ANNE.playSound("success");
        return await SENDQ.___sendQueue();
    }


    /**
     * Quick prompt builder.
     * Will re-run if oracle or oracle reln are set (and btn_to exists)
     * @returns 
     */
    setToBtnMsg = function() {
        if (this.btn_to==null) return;
        var asdf_oracle_text = "[oracle neuron not set]";
        var asdf_reln_text = "[oracle reln not set]";
 
        if (this.rel_oracle!=null) {
            var asdf_oracleNOBJ = MEMG.getNeuronByTempNid(this.rel_oracle.t);
            asdf_oracle_text = asdf_oracleNOBJ.text;
        }
        if (this.rel_reln!=null) {
            var asdf_relnNOBJ = MEMG.getNeuronByTempNid(this.rel_reln.t);
            asdf_reln_text = asdf_relnNOBJ.text;
        }
        this.btn_to.setAttribute("prompt", "Set the future TO data value that the future relon from ORACLE NEURON&nbsp;<span class='text-success-lbl'>"+asdf_oracle_text+"</span>&nbsp;with RELN&nbsp;<span class='text-success-lbl'>"+asdf_reln_text+"</span>&nbsp; is for.");
    }


    /**
     * Validate the status of the ASDF.
     */
    validateStatus = function() {
        console.log("validate status)");
        var req_missing = 0;

        //must have oracle
        this.rel_oracle = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_ORACLE.temp_nid);
        if (this.rel_oracle==null) req_missing+=1;

        //must have oracle reln
        this.rel_reln = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_ORACLE_RELN.temp_nid);
        if (this.rel_reln==null) req_missing+=1;

        //must have reward set
        this.rel_reward = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_REWARD.temp_nid);
        if (this.rel_reward==null) req_missing+=1;

        //must have either to or cdx+nonanneval
        this.rel_to = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO.temp_nid);
        this.rel_to_cdx = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_CDX.temp_nid);
        this.rel_to_nonanne_val = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_CDX_NONANNE_VAL.temp_nid);
        this.rel_to_anne_date = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_ANNE_CDX_ANNE_DATE.temp_nid);
        this.rel_future_to_attr = MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_NID_ATTR.temp_nid);

        if (this.rel_to==null) {
            if(this.rel_to_cdx==null) req_missing+=1;
            if (this.rel_to_nonanne_val==null && this.rel_to_anne_date==null) req_missing+=1;
        }

        //must have reward set
        this.rel_desc = MEMG.getHasRelon(this.nObj.outs, MEM.description.temp_nid);
        if (this.rel_desc==null) req_missing+=1;


        //if any of these are missing, it isn't a valid ASDF.
        if (req_missing>0) {
            if (this._mode=="maker") {
                if (this.nObj.ghost==true) ANNE.A.hide(this.el_upgrade_ghost_relons);
                
                //hide freeze.
                else if (this.nObj.freeze==0) ANNE.A.hide("freeze_selfOwned_btn_"+this.ID);
            }
        }

        //none-missing, we're good to go.
        else {
            if (this._mode=="maker") {
                if (this.nObj.ghost==true) {
                    ANNE.A.show(this.el_upgrade_ghost_relons);
                    this.explainRisk();
                }
                else if (this.nObj.freeze==0) {
                    ANNE.A.show("freeze_selfOwned_btn_"+this.ID);

                    //do pending freeze here.
                    //lookup freezeCmd
                    var relFreeze = ANNE.MEMG.getFreezeRel(this.nObj.outs)
                    if (relFreeze!=null) {
                        console.log("PENDING FREEZE REL ", relFreeze);
                        
                    }

                    this.explainRisk();
                }
            }
            else {
                //show TAKE RISK BTN.
            }
        }
    }


    /**
     * help the maker of the ghost upgade when reqs are met
     */
     dataAdded = function($new_relon) {
        if ($new_relon.r==MEM.ASDF_ORACLE.temp_nid) this.setToBtnMsg();
        else if ($new_relon.r==MEM.ASDF_ORACLE_RELN.temp_nid) this.setToBtnMsg();
        else if ($new_relon.r==MEM.ASDF_FUTURE_TO.temp_nid
                || $new_relon.r==MEM.ASDF_FUTURE_TO_CDX.temp_nid
                || $new_relon.r==MEM.ASDF_FUTURE_TO_CDX_NONANNE_VAL.temp_nid) {
            ANNE.A.removeSelf(this.el_to_question);
        }
        else if ($new_relon.r==MEM.ASDF_FUTURE_TO_ANNE_CDX_ANNE_DATE.temp_nid) {
            MEMG.getHasRelon(this.nObj.outs, MEM.ASDF_FUTURE_TO_ANNE_CDX_ANNE_DATE.temp_nid);
        }
        this.validateStatus();
    }
}
