

/**
 * class neurons
 */
 class dossier_class extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        console.log("%c dossier_class", TALK.bgredbig);
        super($pgui, $secondary, $third, $misc);
    }
    initASYNC = async($pguicopy)=>{

        //anne-page-dossier
        //anne-page-dossier-body

        await this.getData(false, this.nObj, [], true);
        await this.doHeading(false, []);

        this.doSimpleRoles(this.el_content);

        //show the active BRAIN20 patterns.
        if (this.nObj.nid==MEM.ASDF.nid) {
           var b120s = MEMG.getRelonsByType(this.nObj.outs, TYPE_BRAIN120);
           if (b120s.length) this.doSysRefHackNidSection(this.el_content, b120s, "Active ASDF patterns", "section-title");
        }
        else if (this.nObj.nid==MEM.ANNE_BLOCK_TRIGGER.nid) {
            var b120s = MEMG.getFutureTriggers(this.nObj.outs);
            if (b120s.length) this.doSysRefHackBlockSection(this.el_content, b120s, "Active triggers by block", "section-title");
        }

        //ANNE.A.hide(this.el_idsbox);
        //ANNE.A.addRemoveClass(this.el_content, "doss-body-box-full", "doss-body-box");

        this.doAltBES(this.el_bes_content);
        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);

        //if this is a name --- we should link to names.
        if (this.nObj.nid==ANNE.MEM.name.nid) {
            alert("to do, pull instances of people with a first name/middle or last name relon to this neuron");
            //await ANNE.API.getInstsWithName(this.nObj.nid);
        }
        
        await this.doHas(this.el_content, "HAS attributes", true);    //generic.

        await this.doAllParams(this.el_content);

        //do this for functional be children...
        //and real children...
        await this.doAllChildren(this.el_content);

        await this.doAllInsSection2(this.el_content, "inbound references", true);

        await this.doAllSysRelons(this.el_content);


        //used as RELN?
        //ie, occupation.. position..  could do a dynamic dd loaded on dd.

        //do ins here for names.  (all dossiers now)
        //if (this.nObj.ghost==false) await ANNE.API.getIns(this.nObj.nid);
        //await this.doAllInsSection2(this.el_content, "inbound references", true, "section-title", "first");

        
        //no highlighting of notoriety --- the remain nameless.. 
        //just ip and nid.  Meh.
        if (this.nObj.nid==MEM.REDLIST.nid) {
            var response = await ANNE.API.getREDLIST();
            if (response!=null) {
                console.log(response);
                //redlisted_ips
                //redlisted_nids
                for (var n=0; n < response.redlisted_nids.length; n++) {
                    var obj = response.redlisted_nids[n];
                    var sectionRow = ANNE.A.ezEl(this.el_content, "row", "");
                    sectionRow.innerHTML = "nid: "+obj.nid;
                }
                for (var i=0; i < response.redlisted_ips.length; i++) {
                    var obj = response.redlisted_ips[n];
                    var sectionRow = ANNE.A.ezEl(this.el_content, "row", "matches-row");
                    sectionRow.innerHTML = "ip: "+obj.ip;
                }
                
            }
        }


        this.doAdminRelons(this.el_content);
        
        //this.doKwds();
        //this.doAssociate();
        this.doBRAINSection(this.el_content); 

        this.addAwarvu();

        await this.doImgs(this.el_thumbs); //images after the body

        if (this.nObj.ghost==false && this.ghost_cnt==0 && this.collab_ghost==0 && this.external_btns_showing==0) {
            ANNE.A.hide(this.el_actions);
        }

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }


    /**
     * @param {*} $el 
     * @param {*} $outs 
     * @param {*} $title 
     * @param {*} $headingClass 
     */
    doSysRefHackBlockSection=function($el, $outs, $title="some section", $headingClass="section-title"){
        var braindiv = ANNE.A.ezEl($el, "div", $headingClass, $title);
        var bDIDAPPEND = false;
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            if (bDIDAPPEND==false) {
                $el.append(braindiv);
                bDIDAPPEND=true;
            }
            var div = ANNE.A.ezEl($el, "div", "simple-row")
            EXT_BTNS.makeRelonViewLink_SMART(div, rel, false, 8, true);
            EXT_BTNS.makeNeuronLink(div, rel.reln);
            
            if (rel.sys_ref_txid!=undefined) {
                console.log("hack nid for block:"+rel.sys_ref_txid);
                ANNE.A.ezSpan(div, "", "", "block "+rel.sys_ref_txid)
                //EXT_BTNS.makeNeuronLink(div, rel.sys_ref_txid); 
            }

            if (rel.to_type==TO_TYPE_ANNE) EXT_BTNS.makeNeuronLink(div, rel.to_s);
            else ANNE.A.ezSpan(div, "", "text-success-lbl", MEMG.__MASTER_DISPLAY_RELON_TO(rel));
        }
    }


    //hacky use of .sys_ref_txid for a ref nid (not txid)
    //only can use this function if you know the relons doing this and u pass them in.
    doSysRefHackNidSection=function($el, $outs, $title="some section", $headingClass="section-title"){
        var braindiv = ANNE.A.ezEl($el, "div", $headingClass, $title);
        var bDIDAPPEND = false;
        for (var r=0; r < $outs.length; r++) {
            var rel = $outs[r];
            if (bDIDAPPEND==false) {
                $el.append(braindiv);
                bDIDAPPEND=true;
            }
            var div = ANNE.A.ezEl($el, "div", "simple-row")
            EXT_BTNS.makeRelonViewLink_SMART(div, rel, false, 8, true);
            EXT_BTNS.makeNeuronLink(div, rel.reln);
            
            if (rel.sys_ref_txid!=undefined) {
                console.log("hack nid:"+rel.sys_ref_txid);
                EXT_BTNS.makeNeuronLink(div, rel.sys_ref_txid); //this is the TRIGGER ORACLE (from)
            }

            if (rel.to_type==TO_TYPE_ANNE) EXT_BTNS.makeNeuronLink(div, rel.to_s);
            else ANNE.A.ezSpan(div, "", "text-success-lbl", MEMG.__MASTER_DISPLAY_RELON_TO(rel));
        }
    }

}
