
class anne_pdn {
    constructor($nObj){
        this.el_stuff = null;
        this.dossier_inst = null;

        this.txtype = ANNE.TXB.TXTYPE_CHILD_RELON;
        this.nObj = $nObj;
        this.parentNOBJ = MEMG.getNeuronByTempNid(this.nObj.bes[0]);
        this.bVALID = false;
        this.e_type_nObj = null;

        this.rel_uri = MEMG.getHasRelon(this.nObj.outs, MEM.ANNODE_URI.temp_nid);
        this.rel_encrypted_data_type = MEMG.getHasRelon(this.nObj.outs, MEM.ENCRYPED_DATA_TYPE.temp_nid);
        if (this.rel_encrypted_data_type!=null) {
            this.e_type_nObj = MEMG.getNeuronByNid(this.rel_encrypted_data_type.to_s);
        }

        this.rel_desc = MEMG.getHasRelon(this.nObj.outs, MEM.description.temp_nid);
        this.rel_secret = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_SECRET.temp_nid);
        this.rel_op_question = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_OP_QUESTION.temp_nid);
        this.rel_op_reveal_all = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_OP_REVEAL_ALL.temp_nid);
        this.rel_equality_question = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_EQUALITY_QUESTION.temp_nid);
    
        this.rel_viplets = null;

        this.annies_reveal_all = null;
        this.annies_equality_test = null;
        this.annies_op_question = null;

        if (this.nObj.owned_by==USER._userNObj.nid) this._mode = "maker";
        else this._mode="user";

        if (this._mode=="maker") {
            this.rel_param_secret = MEMG.getParamRelon(this.nObj.outs, MEM.PDN_SECRET.temp_nid);
            this.makeTempParam();
        }
    }


    /**
     */
    makeTempParam = function() {
        if (this.rel_secret==null && this.rel_encrypted_data_type!=null) {
            if (this.rel_param_secret==null) {
                this.rel_param_secret = MEM.makeTempRelon(this.nObj, TYPE_PARAM, MEM.PDN_SECRET.nid, TO_TYPE_ANNE, this.rel_encrypted_data_type.to_s, true);
            }
        }
    }


    /**
     */
    classifyPDN = async($el, $dossierINST)=> {
        this.dossier_inst = $dossierINST;
        this.el_stuff=ANNE.A.ezEl($el, "div", "dossier-stuff"); 
        this.makerMode();
        this.isValid();
        await this.useMode();
        return;
    }


    /**
     */
    makerMode = function() {
        if (this.nObj.owned_by!=USER._userNObj.nid) return;
        
        if (this.rel_secret==null && this.rel_param_secret!=null) { 
            var bREQUIRED=true;
            var lock = '<span title="encrypted" style="filter: grayscale(100%); font-size:.8rem">🔒</span>';
            var msg = lock+"the&nbsp;<b>private data</b>&nbsp;you want to <b>encrypt</b>";
            this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, this.rel_param_secret, msg, bREQUIRED);
        }

        //if rel encrypted data type is number,
        //we can open up the op question reveal type (end user can pose an op question)
        if (this.rel_encrypted_data_type!=null) {
            if(this.rel_encrypted_data_type.to_s==MEM.e_number.nid) {
                if (this.rel_op_question==null)  {
                    var rel_param_op_q = MEMG.getParamRelon(MEM.PDN.outs, MEM.PDN_OP_QUESTION.temp_nid);
                    var btn = this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_param_op_q, "<b>set annies price</b>&nbsp;MATH OPERATOR question");
                    btn.setAttribute("prompt", "<b>How many</b> annies to ask a MATH OPERATOR question of the numeric PDN by logical operator?");
                }
            }
        }
        else {
            var rel_etype = MEMG.getParamRelon(MEM.PDN.outs, MEM.ENCRYPED_DATA_TYPE.temp_nid);
            this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_etype, "set&nbsp;<b>encrypted data type</b>");
        }

        if (this.rel_op_reveal_all==null) {
            var rel_param_op_reveal_all = MEMG.getParamRelon(MEM.PDN.outs, MEM.PDN_OP_REVEAL_ALL.temp_nid);
            var btn = this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_param_op_reveal_all, "<b>set annies price</b>&nbsp;REVEAL");
            btn.setAttribute("prompt", "<b>How many</b> annies to reveal the private data?");
        }

        if (this.e_type_nObj.nid!=MEM.e_boolean.nid) {
            if (this.rel_equality_question==null) {
                var rel_param_quality_question = MEMG.getParamRelon(MEM.PDN.outs, MEM.PDN_EQUALITY_QUESTION.temp_nid);
                var btn = this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_param_quality_question, "<b>set annies price</b>&nbsp;for IS EQUAL question");
                btn.setAttribute("prompt", "<b>How many</b> annies to ask a 'does the value equal' question of the PDN?");
            }
        }

        //check for type --
        //PUBLIC (do nothing)
        //VIP LIST 
        //(build an identity)
        if (this.parentNOBJ.temp_nid==MEM.PDN_VIP.temp_nid) {
            var rel_param_viplets = MEMG.getParamRelon(MEM.PDN_VIP.outs, MEM.viplet.temp_nid);
            var bREQUIRED=true;
            var btn = this.dossier_inst.makeCollabBtn(this.el_stuff, this.txtype, rel_param_viplets, "add vip identity", bREQUIRED);    
            btn.setAttribute("insts_only", 1);
        }

        //BEARER TOKEN
        //(build an issue bearer token)
        //todo.  TXTYPE for node to issue a bearer token (relon)
        //from:PDN reln->bearer_token to->encrypted token
        //annode gens rand token.  Stores it in relon in PDN, encrypted for owned.
        //owner gets that relon, decrypts it.  That's the token.
        //That token can be manually delivered to someone or
        //sent via a send_bearer_token TX.
        //That TX will encrypt the bearer token (yet again) for the desired user.
        //That user can decrypt it via standard L1 sendEncrypt handling.
        //That bearer token can thus be used (the from is the neuron)
        //Users will need an area to view their PDNS + any VIP and/or bearer tokens.
        //Note: create a notification when a user is added to a VIP and/or receives a bearer token.
        else if (this.parentNOBJ.temp_nid==MEM.PDN_BEARER_TOKEN.temp_nid) {
            console.log("to do");
        }
    }


    /**
     */
    useMode = async()=> {
        //if not valid, cannot use
        if (this.bVALID==false) return;
        
        //can't use if self
        if (this._mode=="maker") return;

        //if VIP list, this user must be in the list or they can't get in.
        if (this.parentNOBJ.nid==MEM.PDN_VIP.nid) {
            console.log(this.nObj._vip_let);
            if (this.nObj._vip_let.indexOf(USER._userNObj.temp_nid)==-1) {
                ANNE.A.ezEl(this.el_stuff, "div", "red-notice", "<BR>You are not in the VIP list and cannot use this PDN.");
                return;
            }
        }
        
        
        var el_reveals = ANNE.A.ezEl(this.el_stuff, "div", "dblock100", "", "reveals_info");

        //show any reveals we have done.
        var reveals = await MEMG.getUserRevealsFor(this.nObj);
        for (var r=0; r < reveals.length; r++) {
            var revel=ANNE.A.ezEl(el_reveals, "span", "dblock");
            EXT_BTNS.makeRelonViewLink(revel, reveals[r].txid, false, 12, false, "", reveals[r].decrypted);
        }
                  
        //make reveals
        if (this.rel_op_question!=null) {
            var el_op_q_section = ANNE.A.ezEl(this.el_stuff, "div", "", "", "pdn_op_q_section");
            this.annies_op_question = parseInt(this.rel_op_question.to_s);
            var el_btn_opq = ANNE.A.ezButton(el_op_q_section, "", "op query", "btn-yellow-sq anne-tiny-btn", 
                function(e){ 
                    var elop = ANNE.A.show("pdn_op_dd");
                    elop.focus();
                    ANNE.A.hide(el_btn_opq);
                });
            var el_dd = ANNE.A.ezDD(el_op_q_section,MEM.pdnOpTnids,function(e){
                if (el_dd.value!=null) {
                    var elopval = ANNE.A.show("pdn_op_val");
                    elopval.focus();
                }
                else ANNE.A.hide("pdn_op_val");
            },"select op");
            el_dd.setAttribute("id", "pdn_op_dd");
            ANNE.A.hide(el_dd);
            var el_op_val = ANNE.A.ezInputText(el_op_q_section, "pdn_op_val", "", "value", function(e) {
                if (el_op_val.value) {
                    var val = el_op_val.value;
                    var newval = "";
                    for (var v=0; v < val.length; v++) {
                        if("0123456789.,".indexOf(val[v])==-1) continue;
                        newval += val[v];
                    }
                    el_op_val.value=newval+"";
                    if (newval.length) {
                        ANNE.A.show("pdn_op_query_submit");
                    }
                    else ANNE.A.hide("pdn_op_query_submit");
                }
                else ANNE.A.hide("pdn_op_query_submit");
            });
            ANNE.A.hide(el_op_val);

            //final submit button.
            var text = "op query&nbsp;";
            var el_op_q_submit = ANNE.A.ezButton(el_op_q_section, "pdn_op_query_submit", text, "btn-green-sq anne-tiny-btn");
            
            ANNE.A.ezAnniesToAnneDisplay(el_op_q_submit, this.annies_op_question);
            el_op_q_submit.addEventListener("click", e=>this.pdnOpQuery(e));
            ANNE.A.hide(el_op_q_submit);
        }

    
        if (this.rel_op_reveal_all!=null) {
            this.annies_reveal_all = parseInt(this.rel_op_reveal_all.to_s);
            var text = "reveal all&nbsp;";
            var btn = ANNE.A.ezButton(this.el_stuff, "", text, "btn-green-sq anne-tiny-btn");
            ANNE.A.ezAnniesToAnneDisplay(btn, this.annies_reveal_all);
            btn.addEventListener("click", e=>this.pdnRevealAll(e));
        }
        

        //TEST FOR EQUALITY
        if(this.rel_equality_question!=null) {
            var el_op_eqality_section = ANNE.A.ezEl(this.el_stuff, "div", "", "", "pdn_op_eq_section");
            this.annies_equality_test = parseInt(this.rel_equality_question.to_s);
            var el_btn_eq = ANNE.A.ezButton(el_op_eqality_section, "", "equality test", "btn-yellow-sq anne-tiny-btn", 
                function(e){ 
                    var eleq = ANNE.A.show("pdn_eq_val");
                    eleq.focus();
                    ANNE.A.hide(el_btn_eq);
                });
            var el_eq_val = ANNE.A.ezInputText(el_op_eqality_section, "pdn_eq_val", "", "value", 
            function(e) {
                if (el_eq_val.value) ANNE.A.show("pdn_eq_query_submit");
                else ANNE.A.hide("pdn_eq_query_submit");
            });
            ANNE.A.hide(el_eq_val);

            //final equality test submit
            var text = "equality test&nbsp;";
            var el_eq_submit = ANNE.A.ezButton(el_op_eqality_section, "pdn_eq_query_submit", text, "btn-green-sq anne-tiny-btn");
            ANNE.A.ezAnniesToAnneDisplay(el_eq_submit, this.annies_equality_test);
            el_eq_submit.addEventListener("click", e=>this.pdnEqualsQuery(e));
            ANNE.A.hide(el_eq_submit);
        }
    }
    

    /**
     */
    isValid = function() {
        if (this.parentNOBJ.temp_nid==MEM.PDN_VIP.temp_nid) {
            this.rel_viplets = MEMG.getSysRelons(this.nObj.outs, MEM.viplet.temp_nid);
            if (this.rel_viplets!=null) {
                //todo: if we have one,
                //remove actions-link-required class from the vip btn.
                //still should keep the btn with .mulitples true set.
                var btn = document.getElementById(this.dossier_inst.ID+"_"+this.nObj.nid);
                if (btn!=null) ANNE.A.removeClass("actions-link-required");
            }
            else {
                this.bVALID=false;
                return;
            }
        }

        this.rel_uri = MEMG.getHasRelon(this.nObj.outs, MEM.ANNODE_URI.temp_nid);
        if (this.rel_uri==null) {
            this.bVALID=false;
            return;
        }
        this.rel_encrypted_data_type = MEMG.getHasRelon(this.nObj.outs, MEM.ENCRYPED_DATA_TYPE.temp_nid);
        if (this.rel_encrypted_data_type==null) {
            this.bVALID=false;
            return;
        }
        else {
            this.e_type_nObj = MEMG.getNeuronByNid(this.rel_encrypted_data_type.to_s);
        }

        this.rel_desc = MEMG.getHasRelon(this.nObj.outs, MEM.description.temp_nid);
        this.rel_secret = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_SECRET.temp_nid);
        if (this.rel_secret==null){
            this.bVALID=false;
            return;
        }
        this.rel_op_question = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_OP_QUESTION.temp_nid);
        this.rel_op_reveal_all = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_OP_REVEAL_ALL.temp_nid);
        this.rel_equality_question = MEMG.getHasRelon(this.nObj.outs, MEM.PDN_EQUALITY_QUESTION.temp_nid);    
        if (this.rel_op_question==null && this.rel_op_reveal_all==null && this.rel_equality_question==null){
            this.bVALID=false;
            return;
        }

            
        if (this.rel_encrypted_data_type!=null || this.rel_op_reveal_all!=null 
            || this.rel_equality_question!=null) this.bVALID=true;
        else {
            this.bVALID=false;
            return;
        }
    }


    /**
     * Reveal All payment from user to see what is in the PDN
     * There is no outbound encryption on this request as there is no leaking 
     * info to protect for the PDN.
     * We encrypt the response back from the annode (on-chain) so the requestor 
     * can regain answer to this question at a later date or from another device.
     */
    pdnRevealAll = async($e)=>{
        var gui_extras = new Object();
        gui_extras.payment = this.annies_reveal_all;
        gui_extras.ss_seed_relon = this.rel_secret;
        //gui_extras.encryption_method=TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
        var sysmsg_rel = await ANNE.MEMZ.ez_new_sys_msg(this.nObj, MEM.PDN_OP_REVEAL_ALL.nid, TO_TYPE_ANNE, USER._userNObj.nid, gui_extras, null);
        ANNE.SENDQ.___sendQueue();
    }

    
    /**
     * Query a numeric PDN with a logical operand. 
     * Is the secret >= <= < > than X? 
     * Response is an encrypted yes or no.
     * 
     * We encrypt the outbound to request to protect the integrity of the PDN.
     * If a question is asked and not further requests are made viewers 
     * could surmise the response was positive.  (the test passed)
     * We encrypt the to so it is not possible for the public to see what was queried.
     * We encrypt the response back from the annode (on-chain) so the requestor 
     * can regain answer to this question at a later date or from another device.
     */
    pdnOpQuery = async($e)=>{
        var op_nid = ANNE.A.getValue("pdn_op_dd");
        var query_string = ANNE.A.getValue("pdn_op_val");
        console.log("pdnOpQuery query string:"+query_string);
        var gui_extras = new Object();
        gui_extras.payment = this.annies_op_question;
        gui_extras.ss_seed_relon = this.rel_secret;
        gui_extras.encryption_method=TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
        var sysmsg_rel = await ANNE.MEMZ.ez_new_sys_msg(this.nObj, op_nid, TO_TYPE_ENCR_ANNE, query_string, gui_extras, null);
        ANNE.SENDQ.___sendQueue();
    }


    /**
     * Query a PDN for equivalence.  This is like asking, "is the secret EQUAL to x"?
     * Response is an encrypted yes or no.
     * 
     * We encrypt the outbound to request to protect the integrity of the PDN.
     * If a question is asked and not further requests are made viewers 
     * could surmise the response was positive.  (the test passed)
     * We encrypt the to so it is not possible for the public to see what was queried.
     * We encrypt the response back from the annode (on-chain) so the requestor 
     * can regain answer to this question at a later date or from another device.
     */
    pdnEqualsQuery = async($e)=>{
        var query_string = ANNE.A.getValue("pdn_eq_val");
        if (query_string=="") return;   //should never get here.
        var gui_extras = new Object();
        gui_extras.payment = this.annies_equality_test;
        gui_extras.ss_seed_relon = this.rel_secret;
        gui_extras.encryption_method=TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
        var sysmsg_rel = await ANNE.MEMZ.ez_new_sys_msg(this.nObj, MEM.PDN_EQUALITY_QUESTION.nid, TO_TYPE_ENCR_ANNE, query_string, gui_extras, null);
        ANNE.SENDQ.___sendQueue();
    }
}


/**
 * pdn edit (for owners) and user (for viweers)
 */
 class dossier_pdn extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        this.el_params = null;
        console.log("%c dossier_pdn", TALK.bgredbig);
    }

    initASYNC = async($pguicopy)=>{
        ANNE.A.removeSelf(this.el_bebox_img);
        
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);

        ANNE.A.removeSelf("garden_"+this.nObj.temp_nid);
        
        await this.doAllHas(this.el_content, "section-title-center", [], [], "simple-col tal", "tal");
        
       
        this.pdn = new anne_pdn(this.nObj);

        //display all param buttons in main area of page for owner.
        if (this.pdn._mode=="maker") {
            this.el_params = ANNE.A.ezEl(this.el_content, "div", "simple-row", "");
            await this.pdn.classifyPDN(this.el_params, this);
        }

        //display use buttons in right hand side of page for user.
        else {
            this.el_use = ANNE.A.ezEl(this.el_bes_content, "div", "", "");
            await this.pdn.classifyPDN(this.el_use, this);
        }

         var map = [];
         map[MEM.viplet.nid] = this.pdn.rel_viplets;
         this.displayOutsMultiplesObj(this.el_content, map, "simple-col tal", "tal");

        if (this.pdn.bVALID==false) {
            if (this.pdn._mode=="maker") {
                ANNE.A.hide(this.el_upgrade_ghost_relons);
            }
        }


        this.doAltBES(this.el_bes_content);

        this.addAwarvu();

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }

    dataAdded = function($new_relon) {
        this.pdn.isValid();
        if (this.pdn.bVALID==false) {
            if (this.pdn._mode=="maker") {
                ANNE.A.hide(this.el_upgrade_ghost_relons);
            }
        }
        else {
            if (this.nObj.ghost==true) {
                ANNE.A.show(this.el_upgrade_ghost_relons);
            }
        }
    }
}



