/**
 * Globals service is used for the globals that use the
 * selfRelon pattern.  These are primary classes ANNE is initially interesting in managing
 * in the ANNE worldview.
 * 
 * ALL GLOBAL NEURONS are first created as GHOST NEURONS.  They can be upgraded to REAL 
 * neurons at anytime.
 * 
 * Upon upgrading from ghost (draft) to real, 
 * based on class they will either be sponsored straight-away (like dates) and owned by ANNE worldview
 * or they will first be created and owned by the user and must be hanai'd to the ANNE worldview.
 * 
 * @author {Mr.Scatman}
 */
 class globals_service extends anne_service {
    constructor ($pgui) {
        super($pgui);
        this.miscObjFromSelector = null;
        this.relon_to_make = null;
        this.existing_nid = null;
        this.enter = "none";   
        this.el_input = document.getElementById("dynamic_input_"+this.ID);
        this.el_checkbtn = document.getElementById("check_new_btn_"+this.ID);
        this.el_msg = document.getElementById("valid_msg_"+this.ID);
        this.el_saveghostbtn = document.getElementById("make_new_ghost_btn_"+this.ID); 
        this.bSELECTMODE=true;

    }

    validation_fail = function() {
        this.el_msg.innerHTML="<span class='text-danger-lbl'>This is not a valid "+this.makeclass_nObj.text+"</span>";
        //ANNE.A.hide(this.el_savebtn);
        ANNE.A.hide(this.el_saveghostbtn);
        this.enter = "none";
    }

    lookupNewGlobalService = async($val)=> {
        var result = await CHASE.getGlobal(this.makeclass_nObj, $val);
        if (result.status=="good" && result.message=="available") {
            this.el_msg.innerHTML="<span class='text-success-lbl'>"+this.makeclass_nObj.text+" available</span>";
            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
        }
        else {
            ANNE.A.empty(this.el_msg);
            var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
            EXT_BTNS.makeNeuronLink(el, result.result.nid);
            el.append("is already sponsored");
            //ANNE.A.hide(this.el_savebtn);
            ANNE.A.hide(this.el_saveghostbtn);
            this.enter = "lookup";
        }
        return result;
    }

    success = function($obj) {
        console.log($obj);
        this.el_msg.innerHTML="<span class='text-success-lbl'>"+this.makeclass_nObj.text+" created!</span>"; 
    }
    
    /** 
     * default lookupNew (by class and value)
     */
     lookupNewSelector = async($val)=> {
        var result = await CHASE.getGlobal(this.makeclass_nObj, $val);
        if (result.status=="good" && result.message=="available") {
            //let us select our own date if we have a ghost or our neuron.
            if (this.bSELECTMODE==true) {
                for (var c=0; c < this.makeclass_nObj.children.length; c++) {
                    var childNOBJ = MEMG.getNeuronByTempNid(this.makeclass_nObj.children[c]);
                    if (childNOBJ.mine==false) continue;
                    if (childNOBJ.text==$val) {
                        this.enter = "select";
                        this.existing_nid = result.result.nid;
                        ANNE.A.show(this.el_select_btn);
                       // ANNE.A.hide(this.el_savebtn);
                        ANNE.A.hide(this.el_saveghostbtn);
                        this.existing_nid = childNOBJ.nid;
                        this.el_msg.innerHTML="<span class='text-success-lbl'>You have a ghost neuron for this already.</span>";
                        return;
                    }
                }
            }

            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
            this.el_msg.innerHTML="<span class='text-success-lbl'>"+this.makeclass_nObj.text+" available</span>";
        }
        
        else {
            ANNE.A.empty(this.el_msg);
            if (this.bSELECTMODE==true) {
                this.enter = "select";
                this.existing_nid = result.result.nid;
                ANNE.A.show(this.el_select_btn);
                ANNE.A.hide(this.el_saveghostbtn);
            }
            else {
                var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
                EXT_BTNS.makeNeuronLink(el, result.result.nid);
                el.append("is already sponsored");
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter = "lookup";
            }
        }
    }

}


//global location service
//works with the maker_location_gui
//this is the most complicated non-wiki "maker" service
class service_location_maker extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.altBeNID = "";
        this.altBeNOBJ = null;
        this.el_loc_type = document.getElementById("loc_type_"+this.ID);
        this.el_loc_type.addEventListener("change", this.typeSelected);

        //will get those we have in local memory..
        //we will then do a smart search to get what constituent_of the user actually wants
        //if it isn't in local mem already.
        this.validClassTempNids = [];
        
        // no double rabbit holes for location..
        // constituent_of the *NEW* location must already exist.
        var bTESTFORNEWOK = false; 
        
        //we need our own make new.
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewGhostLocation(e));  

        //rename ssdivs since we will be injecting els  with the this.ID..
        //we can't have conflicts.
        var ss_div = document.getElementById("ss_div_"+this.ID);
        ss_div.setAttribute("id", "ss_div_"+this.ID+"AA");
        
        //rename ssdivs since we will be injecting els  with the this.ID..
        //we can't have conflicts.
        this.el_input = document.getElementById("dynamic_input_"+this.ID);
        this.el_input.addEventListener("input",  e=>this.inputEventHandler(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));

        var bSMARTSEARCH = true;
        this._SS = new smart_search("ss_div_"+this.ID+"AA", this.ID+"AA", this.makeclass_nObj.temp_nid, bSMARTSEARCH, "", bTESTFORNEWOK);
        this._SS.onValid = this.validSelection;
        this._SS.onInValid = this.invalidSelection;
        
        this.ss_div = ANNE.A.hide("ss_div_"+this.ID+"AA");

        //this.el_input.addEventListener("input",  e=> this.inputEventHandler(e));
        this.el_audit_msg = document.getElementById("audit_msg_"+this.ID);
        this.el_disambig =  document.getElementById('disambig_'+this.ID);
        
        this.el_checkbtn.addEventListener("click", e=>this.testNewLocation(e));         //???

        //we did a more robust check with the double smart search.
        ANNE.A.hide(this.el_disambig);
        ANNE.A.hide(this.el_input);     //no input until valid constituent of selected.
    }
    

    setHistoricSite=function($obj) {
        console.log("This is a historic site"); //non-geo
        console.log($obj);
        ANNE.A.setValue(this.el_loc_type, MEM.site.nid);
        ANNE.A.setValue(this.el_input, $obj.search_text);
        this.typeSelected(null);        //trigger event
        this.inputEventHandler(null);   //for name typing handling
    }


    /**
     */
    customTnidsGetter = async()=> {
        var tnids = [];
        for (var i=0; i < MEM.location.ins.length; i++) {
            var rel = MEM.location.ins[i];
            var fromLocNOBJ = MEMG.getNeuronByTempNid(rel.f);
            //console.log("(customTnidsGetter) location: "+fromLocNOBJ.text);
            //is this location the same type of location we are creating?
            if (MEMG.isAltBeOf(fromLocNOBJ.outs, this.altBeNOBJ.temp_nid)==true) {
                
                //if yes, get what it is a constiutent of.
                //this is a valid item in our DD
                var co = fromLocNOBJ["be_"+MEM.constituent_of.temp_nid];
                if (co!=undefined && tnids.indexOf(co)==-1) tnids.push(co);
            }
        }
        console.log(tnids);
        return tnids;
    }


    //we need all locations with TYPE_BE relationship pointing to  the 
    reloadParentLocations=async()=>{
        this.validClassTempNids = await this.customTnidsGetter();
        var bSORTALPHA = true;
        this._SS.redoDD(this.validClassTempNids, bSORTALPHA);
    }

    typeSelected=async($e)=>{
        this.altBeNID = ANNE.A.getValue(this.el_loc_type);
        if (this.altBeNID!="") {
            this.altBeNOBJ = MEMG.getNeuronByNid(this.altBeNID);
            if ( this.altBeNOBJ!=null) {
                this.el_input.setAttribute("placeholder",  this.altBeNOBJ.text + " name");

                //populate the smart search for parent based on knowns.
                //we never need to have them all.. If the user needs to search for something
                //that option will be available when whatever they type is a no-show.
                await this.reloadParentLocations(); 
            }
        }
        else {
            this.el_input.setAttribute("placeholder", "location name");
        }
        await this.validateNewLocation();
    }

    //for name typing
    inputEventHandler=async($e)=> {
        await this.validateNewLocation();
    }  

    invalidSelection = async()=> {
        this.constituent_of_nObj = null;
        await this.validateNewLocation();
    }

    //smart search valid selection
    validSelection = async($nObj)=> {
        console.log("validSelection");
        this.constituent_of_nObj = $nObj;
        this.constituent_of_nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID, true);
        ANNE.A.show(this.el_disambig);
        this.validateNewLocation();
    }

    validateNewLocation = async()=> {
        //set type first.
        ANNE.A.empty(this.el_disambig);

        if (this.altBeNID=="") {
            ANNE.A.hide(this.el_disambig);
            ANNE.A.hide(this.el_checkbtn);
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.hide(this.el_input);
            ANNE.A.hide(this.ss_div);
            ANNE.A.setHTML(this.el_msg, "select type of location");
            return;
        }

        //next do typing the new name.
        var txt = ANNE.A.getValue(this.el_input);
        if (txt.length>0) {
            ANNE.A.applyRQD(this.el_input, true);

            //consituent of (parent location) is valid
            if (this.constituent_of_nObj!=undefined && this.constituent_of_nObj!=null) {
                this.constituent_of_nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID, true);
                ANNE.A.show(this.el_disambig);
                var loc = txt+", "+this.constituent_of_nObj.text;
                ANNE.A.setHTML(this.el_msg, "<span class='text-success-lbl'>"+loc+"</span>");     
                ANNE.A.setHTML(this.el_checkbtn, "search ANNE for <span class='color:#fefe17'>"+loc+"</span>", true);
                this.enter = "lookup"; 
                ANNE.A.show(this.ss_div);
            }
            else {
                ANNE.A.applyRQD(this.el_input, false);
                console.log("no parent selected");
                this.constituent_of_nObj = null;
                ANNE.A.setHTML(this.el_msg, "<span class='text-danger-lbl'>Select a parent location.</span>", true); 
                ANNE.A.hide(this.el_disambig);
                ANNE.A.hide(this.el_saveghostbtn);
                ANNE.A.hide(this.el_checkbtn);
                this.enter = "none"; 
                ANNE.A.show(this.ss_div);
            }
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            ANNE.A.hide(this.el_disambig);
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.hide(this.ss_div);
            ANNE.A.show(this.el_input);
            this.enter= "none";
            ANNE.A.setHTML(this.el_msg, "<span class='text-danger-lbl'>Enter name</span>"); 
        }
    }

    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") $this.testNewLocation($e);
            else if ($this.enter=="submit") $this.makeNew($e);
        }
    }

    setMiscObjFromSelectorPassthru=async($miscObj)=> {
        this.miscObjFromSelector = $miscObj;
        this.relon_to_make = new Object();
        this.relon_to_make.from_nid = this.miscObjFromSelector.from_nid;
        this.relon_to_make.reln_nid = MEM.ec_is.nid;
        this.relon_to_make.type = TYPE_BE;
        this.relon_to_make.to_type = TO_TYPE_ANNE;
        this.relon_to_make.to_s = null;

        var altBeNid = $miscObj.altBeNid;
        var altBeNOBJ = $miscObj.altBeNOBJ; 

        //set text the user tried in the prev screen
        ANNE.A.setValue(this.el_input, $miscObj.intiating_text);
        ANNE.A.show(this.ss_div);
        
        //set type and freeze it
        var el = ANNE.A.setValue(this.el_loc_type, altBeNid);
        el.setAttribute("disabled", true);
        
        //handle setting
        await this.typeSelected(null);

        //intiating_fromNid
        this.constituent_of_nObj = MEMG.getNeuronByNid($miscObj.intiating_fromNid);
        this.constituent_of_nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID, true);
        ANNE.A.show(this.el_disambig);

        this.validateNewLocation();
    }


    /**
     * Just make a ghost.
     * if we have a relon_to_make, make the relon to!
     * if we have a miscObjFromSelector.original_s_callback, call it!  ($ge, $to_s, $new_relon)
     * //relon_to_make
     */
     makeNewGhostLocation = async($e)=> {
        ANNE.A.hide(this.el_saveghostbtn);
        var val = this.el_input.value;
        if (val==undefined) return;
        if (val==null) return;
        if (val=="") return;
        ANNE.A.empty(this.el_msg, true);
        var relons_to_ghost = [];
        var newGhostNOBJ = await MEM.makeGhostNObj(USER._userNObj.nid, NTYPE_INST, val, MEM.location, true, true);
        newGhostNOBJ.bNEW=true;
        relons_to_ghost = newGhostNOBJ.outs.concat();

        //passthru relon we want to make from something we were previously on
        //connecting to this new thing.
        if (this.relon_to_make!=null) {
            var fromNOBJ = MEMG.getNeuronByNid(this.relon_to_make.from_nid);
            var rel_passthru = MEM.makeTempRelon(fromNOBJ, this.relon_to_make.type, this.relon_to_make.reln_nid, 
                                            this.relon_to_make.to_type, newGhostNOBJ.nid, true);
            relons_to_ghost.push(rel_passthru);
        }

        var crel = MEM.makeTempRelon(newGhostNOBJ, TYPE_BE, MEM.constituent_of.nid, TO_TYPE_ANNE, this.constituent_of_nObj.nid, true);
        relons_to_ghost.push(crel);

        //we need the proper reln for this alt_be..
        //that will be stored in the BE_CHILDREN_RELN
        //should be polity, ec_is.. etc.. Whatever this type of location requires
        //for its alt-be heirarchy to work.
        //country, city etc have a TYPE_BE polity reln pointing to the polity (which is the altBe here)
        //something like geo site uses a TYPE_BE IS reln to point to the altBe of geo site.
        var be_children_tnid = this.altBeNOBJ['be_'+MEM.BE_CHILDREN.temp_nid];
        var alt_be_nid = "";
        if (be_children_tnid==undefined) alt_be_nid = MEM.ec_is.nid;
        else {
            var altBeChildNOBJ = MEMG.getNeuronByTempNid(be_children_tnid);
            alt_be_nid = altBeChildNOBJ.nid;
            var alt_be_rel = MEM.makeTempRelon(newGhostNOBJ, TYPE_BE, alt_be_nid, TO_TYPE_ANNE, this.altBeNOBJ.nid, true);
            relons_to_ghost.push(alt_be_rel);
        }

        if (relons_to_ghost.length) {
            await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        }

        //DEPRECATE THIS bit.. and just launch the new ghost neuron.
        //we no longer should hijack this service when doing selector of location (and donig new)
        //that is now done in -> ss_location_selector
        //if (this.misc && this.misc.restorePage!=undefined) {
            //await PAGES.goToManualTargetPage(this.misc.restorePage);
            //return;
        //}
        //else {
        PAGES.launchNeuron(newGhostNOBJ.nid);
        return;
        //}
    }


    /**
     * 
     * @param {*} $e 
     * @returns 
     */
    testNewLocation = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var name = ANNE.A.getValue(this.el_input);
        if (this.constituent_of_nObj==null) return;
        if (this.altBeNID=="") return;
        var lsp = await CHASE.getGlobalLocation(name, this.constituent_of_nObj, this.altBeNID);
        console.log(lsp);
        if (lsp==null) await this.validNewLocation(relative_matches);
        
        var matches = lsp.getMatches();
        var relative_matches = [];
        if (matches.length>0) {
            for (var m=0; m < matches.length; m++) {
                var match = matches[n];
                var nObj = match.nObj;
                if (nObj.owned_by==USER._userNObj.nid || ANNE.isANNE(nObj.owned_by)==true) {
                    if (match.co==LSM_DIRECT) return await this.existingLocation(nObj);
                    relative_matches.push(nObj);
                }
            }
        }
        return await this.validNewLocation(relative_matches);
    }


    /**
     * 
     * @param {*} $relative_matches 
     */
    validNewLocation = async($relative_matches)=> {
        //what to do with these???
        console.log($relative_matches);

        ANNE.A.applyRQD(this.el_input, true);
        var loc = this.el_input.value+", "+this.constituent_of_nObj.text;
        ANNE.A.setHTML(this.el_saveghostbtn, "make new <em>"+this.altBeNOBJ.text+"</em> "+loc, true);
        this.enter="submit";
    }


    /**
     * 
     * @param {*} $locNOBJ 
     * @returns 
     */
    existingLocation = async($locNOBJ)=> {
        if (this.relon_to_make!=null) {
            ANNE.A.setHTML(this.el_msg, "<span class='text-danger-lbl'>You should select this value from the previous screen.  Plz go back. :)</span>");
            return;
        }
        ANNE.A.applyRQD(this.el_input, false);
        ANNE.A.setHTML(this.el_msg, "<span class='text-danger-lbl'></span>");
        ANNE.EXT_BTNS.makeNeuronLink_colorSquares(this.el_msg, $locNOBJ.nid, "", "This already exists!");
        ANNE.A.hide(this.el_saveghostbtn);
    }
}


/**
 * Global services sort of lost their original meaning..
 * This isn't a global neuron class, per say, as that was used before.
 * This is a keyless neuron owned by the user that can never be hanai'd or annexed.
 * @author {Mr.Scatman}
 */ 
class service_streampay extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.el_input.addEventListener("input",  e=>this.inputEventHandler(e, this));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        ANNE.A.hide(this.el_checkbtn);
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewStreampay(e));
        this.el_input.focus();
    }


    /**
     * 
     * @param {*} $e 
     * @param {*} $this 
     */
    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="submit") {
                this.makeNewStreampay(null);
            }
        }
    }


    /**
     * After one letter is typed, it is valid.
     * @param {*} $e 
     */
    inputEventHandler=async($e, $this)=> {
        ANNE.A.hide(this.el_savebtn);
        var txt = ANNE.A.getValue(this.el_input);
        if (txt.length>0) {
            $this.enter = "submit";
            this.el_msg.innerHTML="<span class='text-success-lbl'>Create new local ghost, define, then broadcast.</span>";
            ANNE.A.show("selected_action_div_"+this.ID);
            ANNE.A.show(this.el_saveghostbtn);
        }
        else {
            $this.enter = "";
            this.el_msg.innerHTML="<span class='text-danger-lbl'>Enter a helpful name.  The name will be publicly visible.</span>";
            ANNE.A.hide("selected_action_div_"+this.ID);
            ANNE.A.hide(this.el_saveghostbtn);
        }
    }


    /**
     * Make simple new ghost neuron with name and launch it.
     * It will be further defined there.
     * @param {*} $e 
     */
    makeNewStreampay = async($e)=> {
        ANNE.A.hide(this.el_saveghostbtn);
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.streampay, this.el_input.value);
        PAGES.launchNeuron(ghostNOBJ.nid);
    }
}



/**
 * @author {Mr.Scatman}
 */ 
class service_keyword extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.el_input.addEventListener("input",  e=>this.inputEventHandler(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
    }
    /**
     */
     returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") $this.testNew($e);
            else if ($this.enter=="submit") $this.makeNew($e);
        }
    }
    inputEventHandler=async($e)=> {
        ANNE.A.hide(this.el_savebtn);
        var txt = ANNE.A.getValue(this.el_input);
        if (txt.length>0) {
            ANNE.A.show(this.el_checkbtn);
            this.enter = "lookup";
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            this.enter= "none";
        }
    }
    testNew = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var kw = ANNE.A.getValue(this.el_input);
        if (kw.length==0) this.validation_fail();
        else this.lookupNewGlobalService(kw);
    }

}


/**
 * PDN
 */
 class service_pdn extends globals_service {
    constructor($pgui) {
        super($pgui);
        this.enter = "none";
        
        this._pdn_type = "";
        this._pdn_uri = "";
        this._pdn_nid = "";
        this._pdn_desc = "";
        this._pdn_data_type = "";
        this._pdn_secret_type = "";
        this._pdn_secret = "";
    }

    initASYNC=async($pgui)=> {

        //to use the PDN we must have handshook with atleast one ANNODE and received
        //an encrypted_sk.
        if (USER._userLS.encrypted_sk==undefined || USER._userLS.encrypted_sk==null) {
            var seedObj = USER.seedObj;
            if (seedObj.status=="success") {
                var ok = await USER.refreshAAUTH(seedObj.seed, USER._userLS);
            }
        }

        console.log(USER._userLS);

        this.el_input.addEventListener("input",  e=> this.inputEventHandler(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        this.el_input.focus();

        //do the annode select stuff here.
        this.el_pdn_default_annode_div = document.getElementById("pdn_default_annode_div_"+this.ID);
        //ANNE.A.hide(this.el_pdn_default_annode_div); //opens when we have a valid name/type/gov

        //TO DO:
        //gen annode dd from annodes user has trusted/set as defaults.

        //set value ot the default annode.
        this.el_pdn_annode_dd = document.getElementById("pdn_annode_"+this.ID);
        ANNE.A.setValue(this.el_pdn_annode_dd, USER._userLS.annode_uri);

        this.el_pdn_uri = document.getElementById("pdn_annode_uri_"+this.ID);
        ANNE.A.setHTML(this.el_pdn_uri, USER._userLS.annode_uri);

        this.el_pdn_types_div = document.getElementById("pdn_types_div_"+this.ID);
        ANNE.A.hide(this.el_pdn_types_div);
        this.el_type_dd = document.getElementById("pdn_type_"+this.ID);
        this.el_type_dd.addEventListener("change", e=>this.handleTypesChg(e));

        this.el_pdn_data_type_dd = document.getElementById("pdn_data_type_"+this.ID);
        this.el_pdn_data_type_dd.addEventListener("change", e=>this.handleTypesChg(e));

        this.el_pdn_desc_div = document.getElementById("pdn_desc_div_"+this.ID);
        ANNE.A.hide(this.el_pdn_desc_div); //opens when we have a valid name/type/gov
        this.el_desc_ta = document.getElementById("pdn_desc_"+this.ID);
        this.el_desc_ta.addEventListener("keypress", e=>this.handleDescChg(e));
        this.el_desc_ta.value="";

        this.el_pdn_the_desc_div = document.getElementById("pdn_the_desc_div_"+this.ID);
        ANNE.A.hide(this.el_pdn_the_desc_div);
    
        this.el_audit_msg = document.getElementById("audit_msg_"+this.ID)

        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewPDN(e));
        return;
    }


    /**
     */
    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="submit") $this.makeNewPDN($e);
        }
    }


    /**
     */
    inputEventHandler=function($e) {
        ANNE.A.hide(this.el_saveghostbtn);
        this.el_msg.innerHTML="";
        ANNE.A.setHTML(this.el_audit_msg, "");
        var val = ANNE.A.getValue(this.el_input);
        if (val.length>0) {
            ANNE.A.empty(this.el_msg, true);
            //ANNE.A.show(this.el_pdn_default_annode_div);
            ANNE.A.show(this.el_pdn_types_div);
        }
        else {
            ANNE.A.empty(this.el_msg);
            //ANNE.A.hide(this.el_pdn_default_annode_div);
            ANNE.A.hide(this.el_pdn_types_div);
            ANNE.A.setHTML(this.el_audit_msg, "Please enter an PDN name.", true);
        }
    }


    /**
     */
    handleTypesChg=async($e=null)=>{
        ANNE.A.setHTML(this.el_audit_msg, "");
        this._pdn_type = this.el_type_dd.value;
        this._pdn_data_type = this.el_pdn_data_type_dd.value;
        if (this._pdn_type=="") {
            ANNE.A.hide(this.el_pdn_the_desc_div);
            this.el_type_dd.focus();
        }
        else if (this._pdn_data_type=="") {
            ANNE.A.hide(this.el_pdn_the_desc_div);
            this.el_pdn_data_type_dd.focus();
        }
        else {
            ANNE.A.show(this.el_pdn_desc_div);
            ANNE.A.show(this.el_pdn_the_desc_div);
        }
    }

    handleDescChg=async($e=null)=>{
        this._annorg_desc = this.el_desc_ta.value.trim();
        if (this._annorg_desc=="") {
            if (this.pdn_type==MEM.PDN_PUBLIC_ACCESS.nid) {
                ANNE.A.hide(this.el_saveghostbtn);
                ANNE.A.setHTML(this.el_audit_msg, "Description is required for PUBLIC ACCESS PDNs.", true);
                this.enter="none";
            }
            else {
                ANNE.A.show(this.el_saveghostbtn);
                this.enter="submit";
                //ANNE.A.setHTML(this.el_audit_msg, "Description is optional for this PDN type.", true);
            }
            
        }
        else if (this._annorg_desc.length < 20) {
            if (this.pdn_type==MEM.PDN_PUBLIC_ACCESS.nid) {
                ANNE.A.setHTML(this.el_audit_msg, "Please set description to atleast 20 characters.", true);
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter="none";
            }
        }
        else {
            ANNE.A.show(this.el_saveghostbtn);
            this.enter="submit";
            ANNE.A.hide(this.el_audit_msg);
        }
    }


    /**
     * Make annorg and go to the new neuron.
     */
    makeNewPDN = async($e)=>{
        console.log("make it!");
        var val = ANNE.A.getValue(this.el_input).trim();
        this._pdn_uri = this.el_pdn_annode_dd.value;
        this._pdn_nid = "";
        this._pdn_type = this.el_type_dd.value;
        this._pdn_data_type = this.el_pdn_data_type_dd.value;
        //this._pdn_secret
        this._pdn_desc = this.el_desc_ta.value.trim();
        
        var classNOBJ = MEMG.getNeuronByNid(this._pdn_type);
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(classNOBJ, val);
        
        var relons_to_ghost = [];
     
        var annode_uri = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.ANNODE_URI.nid, TO_TYPE_URL, this._pdn_uri, true);
        relons_to_ghost.push(annode_uri);

        var datatyperel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.ENCRYPED_DATA_TYPE.nid, TO_TYPE_ANNE, this._pdn_data_type, true);
        relons_to_ghost.push(datatyperel);
  
        //var secretrel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.PDN_SECRET.nid, TO_TYPE_ANNE, this._pdn_data_type, true);
        //relons_to_ghost.push(secretrel);

        var descrel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.description.nid, TO_TYPE_BLOB, this._pdn_desc, true);
        relons_to_ghost.push(descrel);

        ANNE.TALK.printRelons(relons_to_ghost); //should see be, name and constituent relon!

        await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        
        PAGES.launchNeuron(ghostNOBJ.nid);
    }
}


/**
 * ANORG
 */
class service_anorg extends globals_service {
    constructor($pgui) {
        super($pgui);
        this._anorg_type="";
        this._anorg_gov="";
        this._anorg_desc="";
        this.enter = "lookup";
        
        this.el_anorg_typegov_div = document.getElementById("annorg_typegov_div_"+this.ID);
        ANNE.A.hide(this.el_anorg_typegov_div);  //opens when we have a valid name

        this.el_anorg_desc_div = document.getElementById("annorg_desc_div_"+this.ID);
        ANNE.A.hide(this.el_anorg_desc_div); //opens when we have a valid name/type/gov

        this.el_type_dd = document.getElementById("anorg_type_"+this.ID);
        this.el_type_dd.addEventListener("change", e=>this.handleTypeGovChg(e));

        this.el_gov_dd = document.getElementById("anorg_gov_"+this.ID);
        this.el_gov_dd.addEventListener("change", e=>this.handleTypeGovChg(e));

        this.el_input.addEventListener("input",  e=> this.inputEventHandler(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        this.el_input.focus();

        this.el_checkbtn.addEventListener("click", e=>this.testAnorgName(e));

        this.el_desc_ta = document.getElementById("anorg_desc_"+this.ID);
        this.el_desc_ta.addEventListener("keypress", e=>this.handleDescChg(e));
        this.el_desc_ta.value="";
        this.el_audit_msg = document.getElementById("audit_msg_"+this.ID);
        
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewAnorg(e));
    }

    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") $this.testAnorgName($e);
            else if ($this.enter=="submit") $this.makeNewAnorg($e);
        }
    }
    
    inputEventHandler=function($e) {
        ANNE.A.hide(this.el_saveghostbtn);
        this.el_msg.innerHTML="";
        ANNE.A.setHTML(this.el_audit_msg, "");
        var val = ANNE.A.getValue(this.el_input);
        
        var val2 = ANNE.UTILS.cleanAnorgName(val);
        if (val!=val2) ANNE.A.setvalue(this.el_input, val2);

        if (val.length>0) ANNE.A.show(this.el_checkbtn);
        else {
            ANNE.A.setHTML(this.el_audit_msg, "Please enter an Anorg name.", true);
            ANNE.A.hide(this.el_checkbtn);
        }
    }

    handleTypeGovChg=async($e=null)=>{
        ANNE.A.setHTML(this.el_audit_msg, "");
        this._anorg_type = this.el_type_dd.value;
        this._anorg_gov = this.el_gov_dd.value;
        if (this._anorg_type=="") {
            ANNE.A.hide(this.el_anorg_desc_div);
            this.el_type_dd.focus();
        }
        else if (this._anorg_gov=="") {
            ANNE.A.hide(this.el_anorg_desc_div);
            this.el_gov_dd.focus();
        }
        else {
            var selected = this.el_gov_dd.options[this.el_gov_dd.selectedIndex];
            if (selected!=null && selected!="") {
                var desc = selected.getAttribute("desc");
                ANNE.A.setHTML(this.el_audit_msg, desc, true);
                ANNE.A.show(this.el_anorg_desc_div);
                this.el_desc_ta.focus();
            }
        }
    }

    handleDescChg=async($e=null)=>{
        this.handleTypeGovChg($e);
        this._annorg_desc = this.el_desc_ta.value.trim();
        if (this._annorg_desc=="") {
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.setHTML(this.el_audit_msg, "Please provide a brief description.");
        }
        else if (this._annorg_desc.length < 20) {
            ANNE.A.setHTML(this.el_audit_msg, "Please set description to atleast 20 characters.");
        }
        else ANNE.A.show(this.el_saveghostbtn);
    }

    
    /** 
     * default lookupNew (by class and value)
     */
     testAnorgName = async($e)=> {
        var val = ANNE.A.getValue(this.el_input).trim();
        ANNE.A.hide(this.el_checkbtn);
        var result = await CHASE.getGlobal(MEM.anorg, val);
        console.log(result);
        if (result.status=="good" && result.message=="available") {
            this.enter = "submit";
            ANNE.A.empty(this.el_msg, true);
            //this.el_msg.innerHTML="<span class='text-success-lbl'>Anorg '"+val+"' is available to register!</span>";
            ANNE.A.show(this.el_anorg_typegov_div);
        }
        else {
            ANNE.A.empty(this.el_msg);
            var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
            el.innerHTML=result.reason;
            ANNE.A.hide(this.el_saveghostbtn);
            this.enter = "lookup";
            ANNE.A.hide(this.el_anorg_typegov_div);
        }
    }

    /**
     * Make annorg and go to the new neuron.
     */
    makeNewAnorg = async($e)=>{
        console.log("make it!");
        var val = ANNE.A.getValue(this.el_input);
        this._anorg_type = this.el_type_dd.value;
        this._anorg_gov = this.el_gov_dd.value;
        this._annorg_desc = this.el_desc_ta.value.trim()
        
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.anorg, val);
        
        var relons_to_ghost = [];

        var typerel = MEM.makeTempRelon(ghostNOBJ, TYPE_BE, MEM.anorg_type.nid, TO_TYPE_ANNE, this._anorg_type, true);
        relons_to_ghost.push(typerel);
                
        var govrel = MEM.makeTempRelon(ghostNOBJ, TYPE_BE, MEM.governance.nid, TO_TYPE_ANNE, this._anorg_gov, true);
        relons_to_ghost.push(govrel);

        var descrel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.description.nid, TO_TYPE_BLOB, this._annorg_desc, true);
        relons_to_ghost.push(descrel);

        ANNE.TALK.printRelons(relons_to_ghost); //should see be, name and constituent relon!

        await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        
        PAGES.launchNeuron(ghostNOBJ.nid);
    }
}


//global integer service
class service_integer extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.el_input.addEventListener("input",  e=>this.inputEventHandler(e));
    }

    inputEventHandler=function($e) {
        ANNE.A.hide(this.el_saveghostbtn);
        var num = parseInt(ANNE.A.getValue(this.el_input));
        if (num==undefined || num==null || isNaN(num)) {
            ANNE.A.setValue(this.el_input, "");
            this.el_msg.innerHTML="<span class='text-danger-lbl'>Only whole integer numbers are valid.</span>";
            return;
        }
        this.el_msg.innerHTML="";

        ANNE.A.setValue(this.el_input, num);
        console.log("num "+num);

        if (num) ANNE.A.show(this.el_checkbtn);
        else ANNE.A.hide(this.el_checkbtn);
    }

    testNew = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var int = ANNE.A.getValue(this.el_input);
        if (int.length==0) this.validation_fail();
        else this.lookupNewGlobalService(int);
    }
}




class service_asdf extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.asdf_name = "";
        this.asdf_oracle_NOBJ = null;
        this.asdf_reln_NOBJ = null;
        this.asdf_desc = "";
        this.el_input.addEventListener("input",  e=>this.inputASDFNameHandler(e));
        
        //we can snag recents from mempool tracking.. or favs/rememberedz..etc.
        //for now, pre-populate with instances of persons.
        this.someTestOracleDefaults = [];

        if (ANNE.BRAIN!=null) this.someTestOracleDefaults = ANNE.BRAIN.getInstNObjs(null, 20, [ANNE.MEM.preference, ANNE.MEM.THEME_default, 
                                                                                                ANNE.MEM.ANNE_THEME, ANNE.MEM.identity, 
                                                                                                ANNE.MEM.fileX, ANNE.MEM.anndle]);
        else this.someTestOracleDefaults = MEMG.getAllInstNOBJS([MEM.person.nid]);
       
        this.el_oracle = document.getElementById("asdf_oracle_"+this.ID);
        ANNE.GUI_STUFF.addClassDesc(MEM.ASDF_ORACLE, "asdf_oracle", this.ID);

        this.el_oracle_btn = ANNE.A.makeANNE_SIF(this.el_oracle, this.searchLocalOnlyCallback, this.searchAnnodeCallback, this.selectedOracleCallback, this.someTestOracleDefaults, 2, true, "asdf-sif-findmore");
        
        this.el_reln = document.getElementById("asdf_reln_"+this.ID);
        ANNE.GUI_STUFF.addClassDesc(MEM.ASDF_ORACLE_RELN, "asdf_reln", this.ID);

        this.el_reln_btn = ANNE.A.makeANNE_SIF(this.el_reln, this.searchLocalRelonsOnlyCallback, this.searchAnnodeRelonsCallback, this.selectedRelnCallback, [], 2, true, "asdf-sif-findmore");
    
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewGhostASDF(e));

        ANNE.A.hide("helper_msg_"+this.ID);
    }


    /**
     * 
     * @param {*} $e 
     */
    inputASDFNameHandler=async($e)=> {
        ANNE.A.hide(this.el_saveghostbtn);
        this.asdf_name = ANNE.A.getValue(this.el_input);
        if (this.asdf_name.length>0) {
            ANNE.A.addRemoveClass(this.el_input, "valid-inline-text", "invalid-inline-text");
        }
        else {
            ANNE.A.addRemoveClass(this.el_input, "invalid-inline-text", "valid-inline-text");
        }
        this.validateForm();
    }


    /**
     * 
     * @param {*} $temp_nid 
     */
    selectedOracleCallback = async($temp_nid)=>{
        ANNE.A.empty(this.el_reln);

        //-1 indicates delete was entered.
        if ($temp_nid==-1) {
            this.asdf_reln_NOBJ=null;
            this.asdf_oracle_NOBJ=null;
            ANNE.A.addSIF_opts_externalupdate(el_datalist, []);
            ANNE.A.setHTML('asdf_oracle_disambig_'+this.ID, "&nbsp");
            ANNE.A.setHTML('asdf_reln_disambig_'+this.ID, "&nbsp");
            this.validateForm();
            return;
        }
        this.asdf_oracle_NOBJ = MEMG.getNeuronByTempNid($temp_nid);
        var el_disambig =  document.getElementById('asdf_oracle_disambig_'+this.ID);
        this.asdf_oracle_NOBJ.disambigHTMLStr(el_disambig, true, false);

        var el_datalist = document.getElementById(this.el_reln_btn.getAttribute("list_id"));
        var observedRelnNOBJS = [];
        var tnids = [];
        
        //we want to get observed HAS relns on other sibblings of neuron..
        //the user, at anytime, can type whatever they want and search ANNE for it.. so this is just a helper.
        var parentNOBJ = this.asdf_oracle_NOBJ.getParent();
        for (var p=0; p < parentNOBJ.children.length; p++) {
            var childNOBJ = MEMG.getNeuronByTempNid(parentNOBJ.children[p]);
            for (var c=0; c<childNOBJ.outs.length; c++) {
                var rel = childNOBJ.outs[c];
                if (rel.type!=TYPE_HAS) continue;
                if (tnids.indexOf(rel.r)!==-1) continue; 
                if (rel.to_type!=TO_TYPE_ANNE && rel.to_type!=TO_TYPE_NUMBER) continue;
                var nObj = MEMG.getNeuronByTempNid(rel.r);
                tnids.push(nObj.temp_nid);
                observedRelnNOBJS.push(nObj);
            }
        }

        //preset the relns with the relns we have observed on this ORACLE neuron.
        //user can still pick one never observed but these are the default.
        ANNE.A.addSIF_opts_externalupdate(el_datalist, observedRelnNOBJS);
        
        this.validateForm();
    }


    /**
     * 
     * @param {*} $temp_nid 
     */
    selectedRelnCallback = async($temp_nid)=>{
        if ($temp_nid==-1) {
            this.asdf_reln_NOBJ=null;
            ANNE.A.setHTML('asdf_reln_disambig_'+this.ID, "&nbsp");
            this.validateForm();
            return;
        }
        this.asdf_reln_NOBJ= MEMG.getNeuronByTempNid($temp_nid);
        var el_disambig =  document.getElementById('asdf_reln_disambig_'+this.ID);
        this.asdf_reln_NOBJ.disambigHTMLStr(el_disambig, true, false);
        this.validateForm();
    }


    /**
     * Seach local app for an ajax-like type typing.
     * This is only necessary when the options are not yet populated in the widget.
     * @param {*} $e 
     */
     searchLocalOnlyCallback = async($val)=>{
        if ($val.length>0) {
            return await CHASE.anne_naked_neuron_search($val, true, [NTYPE_INST])
        }
        return [];
    }

    
    /**
     * Seach local app for an ajax-like type typing.
     * This is only necessary when the options are not yet populated in the widget.
     * We are looking here for matching neurons that have been observed in a relon before.
     * @param {*} $e 
     */
     searchLocalRelonsOnlyCallback = async($val)=>{
        var finalNOBJS = [];
        if ($val.length>0) {
            var aNOBJS = await CHASE.anne_naked_neuron_search($val, true, [NTYPE_CLASS]);
            for (var a=0; a < aNOBJS.length; a++) {
                if (aNOBJS[a].is(MEM.__ANNE_SYS_CLASS)==true || aNOBJS[a].is(MEM._GENERAL_PROP_CLASS)==true) {
                    finalNOBJS.push(aNOBJS[a]);
                    continue;
                }
                if (MEM.__isAnyReln(aNOBJS[a].r)==true) {
                    finalNOBJS.push(aNOBJS[a]);
                }
            }
        }
        return finalNOBJS;
    }


    /**
     * Seach ANNE for a string.
     * It doesn't make sense to offer ASDFs on class neurons.
     * While in theory possible, it makes little sense to create a futre on the value of a class neuron's relon.
     * It amkes most sense for INSTANCES to be the ORACLE.  This EXT will focus on INSTANCE neuron oracles.
     * @param {*} $e 
     */
    searchAnnodeCallback = async($e)=>{
        var val = this.el_oracle.value;
        if (val.length>1) {
            return await CHASE.anne_naked_neuron_search(val, false, [NTYPE_INST]);
        }
        ANNE.A.setHTML('asdf_oracle_disambig_'+this.ID, "no results found for '"+val+"'");
        return [];
    }


    /**
     * We may also want to filter these for observed relns so the result set isn't too big.
     * For now, let it slide.
     * @param {*} $e 
     * @returns 
     */
    searchAnnodeRelonsCallback = async($e)=>{
        var val = this.el_reln.value;
        if (val.length>1) {
            return await CHASE.anne_naked_neuron_search(val);
        }
        ANNE.A.setHTML('asdf_reln_disambig_'+this.ID, "no results found for '"+val+"'");
        return [];
    }


    /**
     * Validate the form.
     * @returns
     */
    validateForm = function() {
        if (this.asdf_name.length==0) {
            ANNE.A.hide(this.el_saveghostbtn);
            this.el_input.focus();
            return;
        }
        if (this.asdf_oracle_NOBJ==null) {
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.hide("selected_action_div_"+this.ID);
            return;
        }
        if (this.asdf_reln_NOBJ==null) {
            this.el_reln.focus();
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.hide("selected_action_div_"+this.ID);
            return;
        }
        ANNE.A.show("selected_action_div_"+this.ID);
        ANNE.A.show(this.el_saveghostbtn);
    }
    
    

    /**
     * Make the ghost ASDF and launch it in the GUI.
     * note: the user will have a few more options there to continue to define this ASDF neuron.
     * @param {*} $e 
     * @returns 
     */
    makeNewGhostASDF = async($e)=> {
        var relons_to_ghost = [];
        var newGhostNOBJ = await MEM.makeGhostNObj(USER._userNObj.nid, NTYPE_INST, this.asdf_name, MEM.ASDF, true, true);
        newGhostNOBJ.bNEW=true;
        relons_to_ghost = newGhostNOBJ.outs.concat();
        var oracle_rel = MEM.makeTempRelon(newGhostNOBJ, TYPE_HAS, MEM.ASDF_ORACLE.nid, TO_TYPE_ANNE, this.asdf_oracle_NOBJ.nid, true);
        relons_to_ghost.push(oracle_rel);
        var oracle_reln_rel = MEM.makeTempRelon(newGhostNOBJ, TYPE_HAS, MEM.ASDF_ORACLE_RELN.nid, TO_TYPE_ANNE, this.asdf_reln_NOBJ.nid, true);
        relons_to_ghost.push(oracle_reln_rel);
        if (relons_to_ghost.length) {
            await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        }
        PAGES.launchNeuron(newGhostNOBJ.nid);
        return;
    }
}



//***********************************************************//

/**
 * @author {Mr.Scatman}
 */ 
 class service_generic_unique_by_text extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.el_input.addEventListener("input",  e=>this.inputEventHandler(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        this.el_checkbtn.addEventListener("click", e=>this.testNew(e));
    }

     returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") $this.testNew($e);
            else if ($this.enter=="submit") $this.makeNew($e);
        }
    }
    inputEventHandler=async($e)=> {
        ANNE.A.hide(this.el_savebtn);
        var txt = ANNE.A.getValue(this.el_input);
        if (txt.length>0) {
            ANNE.A.show(this.el_checkbtn);
            this.enter = "lookup";
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            this.enter= "none";
        }
    }
    testNew = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var vb = ANNE.A.getValue(this.el_input);
        if (vb.length==0) this.validation_fail();
        else this.lookupNewGlobalService(vb);
    }
}



//anne_service->global_service->service_xx

//anndle service
class service_anndle extends service_generic_unique_by_text {
    constructor ($pgui) {
        super($pgui);
        this.el_saveghostbtn = document.getElementById("make_new_ghost_btn_"+this.ID); 
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewAnndle(e));
        this.parent_nid = null;
        this.parentNOBJ = null;
        this.anndle_lvl = 0;
        this.bDOINGSUBANNDLE = false;
        this.bREDIRECT_BACK_TO_PARENT = false;
        this.el_select = document.getElementById("anndle_parent");
        this.el_select.addEventListener("select", e=>this.selectedParent(e));
        //build a tree dropdown of anndles this user has sponsored.
        //they can select from that DD to build out their structure.
        //build this out once we have some to work with in the app.

        this.el_price = document.getElementById("price_"+this.ID);
        this.el_lunar_cycles_remaining = document.getElementById("lunar_cycles_remaining_"+this.ID);
    }
    

    initASYNC=async($miscObj)=>{
        if ($miscObj!=null) {
            if ($miscObj.default_anndle!=undefined) {
                console.log("prepop search for anndle");
                ANNE.A.setValue(this.el_input, $miscObj.default_anndle);
                await this.inputEventHandler(null);
                this.testNew(null);
            }

            if ($miscObj.parent_nid!=undefined) {
                this.bDOINGSUBANNDLE = true;
                this.bREDIRECT_BACK_TO_PARENT =true;
                this.parent_nid = $miscObj.parent_nid;
                this.parentNOBJ = MEMG.getNeuronByNid(this.parent_nid);
                var rel_anndle_lvl = MEMG.getBeRelon(this.parentNOBJ.outs, MEM.anndle_lvl.temp_nid);
                if (rel_anndle_lvl!=null) this.anndle_lvl = parseInt(rel_anndle_lvl.to_s);

                ANNE.A.hide(this.el_price);
                ANNE.A.hide(this.el_lunar_cycles_remaining);
            }
        }

        this.buildDD();
    }


    //TODO: check for neuron auto var .alvl after refresh of annode bootup
    selectedParent = async($e)=>{
        this.parent_nid = this.el_select.value;
        if (this.parent_nid==-1) this.parent_nid=null;
        else {
            this.bDOINGSUBANNDLE = true;
            this.parentNOBJ = MEMG.getNeuronByNid(this.parent_nid);
            var rel_anndle_lvl = MEMG.getBeRelon(parentNOBJ.outs, MEM.anndle_lvl.temp_nid);
            if (rel_anndle_lvl!=null) this.anndle_lvl = parseInt(rel_anndle_lvl.to_s);
        }
    }


    /**
     * 
     */
    buildDD = function() {
        console.log("buildDD")
        if (this.el_select==null) return;
        ANNE.A.empty(this.el_select);
        var headerO = document.createElement("option");
        headerO.setAttribute("data-divider", true);
        headerO.setAttribute("value", -1);
        headerO.innerHTML = "top level anndle";
        this.el_select.append(headerO);
        
        //get all anndle tops of the user.
        var topAnndles = [];
        console.log(USER._userNObj.my_sponsored);

        for (var s=0; s < USER._userNObj.my_sponsored.length; s++) {
            var nObj = MEMG.getNeuronByTempNid(USER._userNObj.my_sponsored[s]);
            topAnndles.push(nObj);
        }

        var doDownline = function($nObj, $lvl=1) {
            for (var r=0; r < $nObj.outs; r++) {
                var rel = $nObj.outs[r];
                if (rel.r!=MEM.subanndle_of.temp_nid) continue;
                var childNOBJ = MEMG.getNeuronByTempNid(rel.t);
                var indent = "&#9494;";
                var space = '&#160;';

                for (var i = 0; i < $lvl; i++) { space += '&#160;'; }
                space = space + indent;
                
                var opt2 = document.createElement("option");
                opt2.setAttribute("value", childNOBJ.nid);
                opt2.innerHTML = space + childNOBJ.bestNameHTML();
                this.el_select.append(opt2);
                if (this.parent_nid!=null && childNOBJ.nid==this.parent_nid) {
                    this.el_select.setAttribute('selectedIndex', 0);
                }
                if (childNOBJ.outs.length) doDownline(childNOBJ, $lvl+1);
            }
        }

        //aNOBJS are the are the tops.  
        //We want to dig down and get their children.
        for (var n = 0; n < topAnndles.length; n++) {
            var nObj = topAnndles[n];
            var opt = document.createElement("option");
            opt.setAttribute("value", nObj.nid);
            opt.innerHTML = nObj.bestNameHTML();
            opt.classList = "option-top";
            this.el_select.append(opt);
            if (this.parent_nid!=null && nObj.nid==this.parent_nid) {
                this.el_select.selectedIndex  = opt.index;
                //ANNE.A.setSelectedIndexByValue(this.el_select, this.parent_nid);
            }
            doDownline(nObj, 1);
        }
    }



    /**
     */
     returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") $this.testNew($e);
            else if ($this.enter=="submit") $this.makeNew($e);
        }
    }


    /**
     * 
     * TODO: catch non-conformant anndles here.
     */
    inputEventHandler=async($e)=> {
        ANNE.A.hide(this.el_savebtn);
        var txt = ANNE.A.getValue(this.el_input);
        
        if (txt.length>0) {
            
            //srip leading non alphanum
            var clean = ANNE.UTILS.stripAllNonAlphaChar(txt, 0);

            //looks at all those chars after the first
            var after = clean.substring(1);
            if (after=="") {
                this.el_input.value = clean;
                ANNE.A.show(this.el_checkbtn);
                this.enter = "lookup";
                return;
            }

            //strips all non alphaNum chars
            var after = ANNE.UTILS.stripNonAlphaNum(after);

            this.el_input.value = clean[0]+after;
            ANNE.A.show(this.el_checkbtn);
            this.enter = "lookup";
        }
        
        else {
            ANNE.A.hide(this.el_checkbtn);
            this.enter= "none";
        }
    }



    /**
     */
    testNew = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var mustBeUniqueAnndle = ANNE.A.getValue(this.el_input);
        if (mustBeUniqueAnndle.length==0) this.validation_fail();
        else {
            if (this.bDOINGSUBANNDLE==true) {
                this.lookupSubAnndle(mustBeUniqueAnndle);
            }
            else {
                var rez = this.lookupAnndle(mustBeUniqueAnndle);
                console.log(rez);
            }
        }
    }

    lookupAnndle = async($val)=> {
        var result = await CHASE.getGlobal(this.makeclass_nObj, $val);
        console.log("lookupAnndle", result);
        if (result.status=="good" && result.message=="available") {
            var result = result.result;
            this.el_msg.innerHTML="<span class='text-success-lbl'>"+this.makeclass_nObj.text+" available</span>";
            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
            ANNE.A.ezAnniesToAnneDisplay(this.el_price, result.anndle_annies_price, true);
            this.annies_price = parseInt(result.anndle_annies_price);
            this.el_lunar_cycles_remaining.innerHTML = result.lunar_cycles_remaining + "( +current ) of 13 cycles remaining";
        }
        else {
            ANNE.A.empty(this.el_msg);
            ANNE.A.empty(this.el_price);
            ANNE.A.empty(this.el_lunar_cycles_remaining);
            var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
            EXT_BTNS.makeNeuronLink(el, result.result.nid);
            el.append("is already sponsored");
            ANNE.A.hide(this.el_saveghostbtn);
            this.enter = "lookup";
        }
        return result;
    }




    /**
     * Lookup up a subanndle with respect to the anndle.
     * @param {*} $txt 
     */
    lookupSubAnndle = async($txt)=> {
        var result = await CHASE.getGlobal(this.makeclass_nObj, $txt);
        if (result.status=="good" && result.message=="available") {
            this.el_msg.innerHTML="<span class='text-success-lbl'>"+$txt+"."+this.parentNOBJ.text+" is avaiable</span>";
            ANNE.A.setHTML("make_new_ghost_btn_"+this.ID, "make ghost subanndle");
            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
        }
        else {
            ANNE.A.empty(this.el_msg);
            var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
            EXT_BTNS.makeNeuronLink(el, result.result.nid);
            el.append("is already sponsored");
            ANNE.A.hide(this.el_saveghostbtn);
            this.enter = "lookup";
        }
    }


    /**
     * This will create a ghost anndle.
     * User can submit it when they like, but if they are too slow they will miss out! :)
     */
     makeNewAnndle=async($e)=>{
        var anndle_text = ANNE.A.getValue(this.el_input);
        if (this.bDOINGSUBANNDLE==true) {
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.subanndle, anndle_text, NTYPE_INST);

            //this relon will be nuked (and not sent) when we upgrade this subanndle from a ghost.
            //this relon is a stand in..  
            //the annode will make this relon and this cannot be broadacast.
            await GHOSTDATA.makeGhostRelon(TYPE_BE, ghostNOBJ, MEM.subanndle_of.nid, TO_TYPE_ANNE, this.parent_nid);
            PAGES.launchNeuron(ghostNOBJ.nid);
        }
        else {
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.anndle, anndle_text, NTYPE_INST);
            PAGES.launchNeuron(ghostNOBJ.nid);
        }
    }
}





/**
 * 
 * TODO:
 * 
 * @author {Mr.Scatman}
 */ 
 class service_actionverb extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.el_input.addEventListener("input",  e=>this.inputEventHandler_actionverb_typed(e));
        this.el_input.addEventListener("keyup", e=>this.returnKeyPress_actionverb(e, this));
        this.el_checkbtn.addEventListener("click", e=>this.testNew_actionverb(e));

        this.el_actiondiv = document.getElementById("action_div_"+this.ID);
        ANNE.A.hide(this.el_actiondiv);

        this.actionParentNOBJ = false;

        //this.el_dd = document.getElementById("dd_actions_"+this.ID);
        this.el_ss = document.getElementById("ss_div_"+this.ID);

        var bSMARTSEARCH = true;
        var bTESTFORNEW = false;
        var bLVLSMODE = true;
        this._SS = new smart_search(this.el_ss, this.ID, MEM.ec_action.temp_nid, bSMARTSEARCH, "select action parent", bTESTFORNEW, bLVLSMODE);
        
        var tnids = [];
        MEM.ec_action.getAllDownlineChildren(tnids, 0, false, true, false, false);
        var finaltnids = [];
        for (var t=0; t < tnids.length; t++) {
            var nOBJ = MEMG.getNeuronByTempNid(tnids[t]);
            if (nOBJ.bes.indexOf(MEM.vb_v1.temp_nid)==-1) continue;
            finaltnids.push(nOBJ.temp_nid);
        }

        this._SS.init_dd_vals(finaltnids, true, true);
        
        this._SS.onValid = this.validParentActionSelected;     //a valid neuron selection the SS has been made
        this._SS.onInValid = this.invalidParentActionSelection; //no valid selection in the SS made
        this._SS.newCallback = null;
        //this._SS.setMakeText = "make new "+this.classNOBJ.text;
        this._SS.searchCallback=this.searchForECAction;

        //keyup event for ss too!
        this._SS.el_ss.addEventListener("keyup", e=>this.returnKeyPress_actionverb(e, this));
        this.enter="lookup";

        this.el_disambig =  document.getElementById('disambig_'+this.ID);
        this.el_selected_action = document.getElementById("selected_action_div_"+this.ID);
        ANNE.A.hide(this.el_selected_action);

        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewAction(e));
    }

    

    /**
     * Search for an action vb parent class.
     * 
     * This is just to help find an action vb that the user may not have in local mem yet.
     * @param {*} $e 
     */
     searchForECAction = async($e)=>{
        var searchVal  = this._SS.getVal();
        var aMatches = await CHASE.anne_bem_search(searchVal, MEM.ec_action.temp_nid, [MEM.ANNE_ACCTID, USER._userNObj.nid]);
        console.log(aMatches);
        var tnids=[];
        if (aMatches.length) {
            for (var a=0; a < aMatches.length; a++) {
                if (tnids.indexOf(aMatches[a].temp_nid)==-1) tnids.push(aMatches[a].temp_nid) 
            }
            this._SS.redoDD(tnids);
            var el_avcol1 = ANNE.A.empty("avcol1_"+this.ID);
            ANNE.A.ezEl(el_avcol1, "div", "simple-row", "<span class='text-success-lbl'>"+tnids.length+"</span> possible matches found");
            ANNE.A.show(this.el_selected_action);
            this._SS.el_ss.focus();
        }
    }


    /**
     * 
     * @param {*} $nObj 
     */
    validParentActionSelected = async($nObj)=> {
        console.log("validActionSelected");
        this.actionParentNOBJ = $nObj;
        this.classNid = $nObj.nid;
        var el_avcol1 = ANNE.A.empty("avcol1_"+this.ID);
        
        //we should linkify the sentence if this is a class def..
        var talkOBJ = await this.actionParentNOBJ.processActionNeuron();
        console.log(talkOBJ);
        if (talkOBJ.poa!=null) ANNE.A.ezEl(el_avcol1, "div", "simple-row part-of-anne", talkOBJ.poa.text+", "+talkOBJ.tense_lbl);
        ANNE.A.ezEl(el_avcol1, "div", "simple-row verbish-def-heading", "<span class='text-success-lbl'>"+talkOBJ.output+"</span>");
        var disambigEl = ANNE.A.ezEl(el_avcol1, "div", "");
        this.actionParentNOBJ.disambigHTMLStr(disambigEl, true, true);
        var el_bes =  ANNE.A.ezEl(el_avcol1, "div", "simple-row");
        ANNE.MEMZ.ezNeuronBes(el_bes, this.actionParentNOBJ, LINKS_NEURON_DOSSIER);
        ANNE.A.show(this.el_selected_action);
        ANNE.PAGES.updateLastHistMiscProp("action_vb_selected_nid", this.actionParentNOBJ.nid);  //we can deep link load this on a back
        if (ANNE.UTILS.isset(this.classNid)==true) ANNE.A.show(this.el_actiondiv);
        else ANNE.A.hide(this.el_actiondiv);
    }


    /**
     * 
     * @param {*} $val 
     * @param {*} $bool 
     * @param {*} $newResults 
     */    
    invalidParentActionSelection = async($val, $bool, $newResults=-1)=> {
        this.classNid = null;
        this.actionParentNOBJ = null;
        ANNE.A.hide(this.el_disambig);
        var msg = "";
        if ($newResults==0) {
            msg = $val+ " "+" not found";
        }
    }

    /**
     * 
     * @param {*} $e 
     */
    inputEventHandler_actionverb_typed=async($e)=> {
        ANNE.A.hide(this.el_savebtn);
        ANNE.A.hide(this.el_saveghostbtn);
        var txt = ANNE.A.getValue(this.el_input);
        console.log(txt);
        if (txt.length>2) {
            ANNE.A.setHTML(this.el_checkbtn, " check availability", true);
            this.enter = "lookup";
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            this.enter= "none";
        }
    }



    /**
     * A key has been pressed.  Check for the return key and handle it based on the .enter value.
     * 
     * @param {Event} $e 
     * @param {service_actionverb} $this - sometimes js loses the this so passing it fixes that.
     * @returns 
     */
     returnKeyPress_actionverb = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") {
                if (this.actionParentNOBJ==null) $this.searchForECAction(null); 
                else $this.testNew_actionverb($e);
            }
            else if ($this.enter=="submit") $this.makeNewAction($e);
        }
    }


    /**
     * Make the ghost action and launch the 
     * @param {*} $e 
     */
    makeNewAction = async($e)=> {
        var txt = ANNE.A.getValue(this.el_input);
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(this.actionParentNOBJ, txt, NTYPE_CLASS);
        PAGES.launchNeuron(ghostNOBJ.nid);
    }


    /**
     * Test a new action vb for uniqueness in that parent class
     * 
     * User has specified a parent.  We can have action vbs with the same name but not with the same parent.
     * We can allow the user to make whatever they like --- (ie, an alt definition they prefer for some action)
     * but we will not HANAI a dupe into ANNE's worldview.
     * @param {*} $e 
     */
     testNew_actionverb = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var newActionVal = this.el_input.value;

        var be_nids = [this.classNid];
        var searchObj = ANNE.SEARCH.SS.getDefaultSearchObj(newActionVal, be_nids);
        var aMatches = await CHASE.anne_global_search(searchObj);
        
        console.log(aMatches);
        if (aMatches.length==0) {
            var txt = ANNE.A.getValue(this.el_input);
            this.el_msg.innerHTML="<span class='text-success-lbl'>new '"+txt+"' action available</span>";
            ANNE.A.show(this.el_saveghostbtn);
            this.enter = "submit";
        }
        else {
            ANNE.A.empty(this.el_msg);
            var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
            EXT_BTNS.makeNeuronLink(el, result.result.nid);
            el.append("is already sponsored");
            ANNE.A.hide(this.el_saveghostbtn);
            this.enter = "lookup";
        }
    }
}


/**
 * @author {Mr.Scatman}
 */ 
 class service_imgneuron extends globals_service {
    constructor ($pgui) {
        super($pgui);
        this.bNEWWITHRELON=false;
        this.el_img_display = document.getElementById("img_disp_"+this.ID);
        this.el_input.addEventListener("input",  e=>this.inputImgUrlHandler(e));
        this.el_input.addEventListener("keyup", e=>this.returnImgUrlKeyPress(e, this));
        this.el_input.setAttribute("max", 191);
        this.el_loadimg_btn = document.getElementById("loadImg_btn_"+this.ID);
        this.el_loadimg_btn.addEventListener("click", e=>this.loadImg(e));
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewImg(e));
        ANNE.A.hide(this.el_loadimg_btn);
        ANNE.A.hide(this.el_checkbtn);
        this.el_checkbtn.addEventListener("click", e=>this.testNewImgUrl(e));
        ANNE.A.hide(this.el_saveghostbtn);
        this.anneimg = null;
    }

    /**
     * make a new ghost image.
    */
    makeNewImg = async($e)=> {
        if (this.anneimg==null) return;
        ANNE.A.hide(this.el_saveghostbtn);
        var val = this.el_input.value;
        if (val==undefined) return;
        if (val==null) return;
        if (val=="") return;
        ANNE.A.empty(this.el_msg, true);
        var relons_to_ghost = [];
        var newGhostNOBJ = null;
        if (this.bNEWWITHRELON==true) {
            var fromNOBJ = MEMG.getNeuronByNid(this.pObj.misc.from_nid);
            newGhostNOBJ = await this.anneimg.makeGhost(MEM.neuronImg, fromNOBJ, this.pObj.misc.type, this.pObj.misc.reln_nid);
        }
        else newGhostNOBJ = await this.anneimg.makeGhost();
        return PAGES.launchNeuron(newGhostNOBJ.nid);
    }


    /**
     */
     returnImgUrlKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="load") $this.loadImg($e);
            else if ($this.enter=="lookup") $this.testNewImgUrl($e);
            else if ($this.enter=="submit") $this.makeNewImg($e);
        }
    }

    //should have valid url before submitting test
    //we will create both the img url and the fingerprint.
    //we can get the fingerprint for free with the "make" cmd (annode created relon)
    //we will broadcast a second relon for the url.
    //multiple urls and backup locations are posisble if the img produces the same hash.
    inputImgUrlHandler=async($e)=> {
        ANNE.A.hide(this.el_saveghostbtn);
        ANNE.A.empty(this.el_img_display, true);
        var txt = ANNE.A.getValue(this.el_input);
        console.log(txt);
        txt = txt.trim();
        if (txt.length>0) {
            ANNE.A.show(this.el_loadimg_btn);
            ANNE.A.hide(this.el_checkbtn);
            this.enter = "get";
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            ANNE.A.hide(this.el_loadimg_btn);
            this.enter= "none";
        }
    }

    
    /**
     * load the img from the url
     */
    loadImg = async($e)=> {
        ANNE.A.show("loading");
        var url =  ANNE.A.getValue(this.el_input);
        this.anneimg = await IMAGES.getImgMetaFromUrl(url);
        console.log(this.anneimg);
        if (this.anneimg==null) {
            ANNE.A.hide("loading");
            this.enter= "lookup";
            return;
        }
        this.finger = this.anneimg.finger;
        if (this.finger!=null && this.finger!="") {
            ANNE.A.show(this.el_img_display);
            this.enter= "lookup";
            ANNE.A.show(this.el_checkbtn);
            ANNE.A.hide(this.el_loadimg_btn);
            ANNE.A.setHTML("img_finger"+this.ID, this.finger, true);
            ANNE.A.doImageDynoB64(this.el_img_display, "", this, "h200");
        }
        ANNE.A.hide("loading");
        this.enter= "lookup";
    }


    //we need to test if we have this img fingerprint already.
    testNewImgUrl = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        if (this.finger.length==0) this.validation_fail();
        else {
            var result = await CHASE.getGlobal(MEM.neuronImg, this.finger);
            console.log(result);
            if (result.status=="good" && result.message=="available") {
                this.el_msg.innerHTML="<span class='text-success-lbl'>"+MEM.neuronImg.text+" available</span>";
                ANNE.A.show(this.el_saveghostbtn);
                this.enter = "submit";
            }
            else {
                ANNE.A.empty(this.el_msg);
                var el = ANNE.A.ezEl(this.el_msg, "span", 'text-danger-lbl');
                EXT_BTNS.makeNeuronLink(el, result.result.nid);
                el.append("is already sponsored");
                ANNE.A.hide(this.el_saveghostbtn);
                this.enter = "lookup";
            }
        }
    }
}