
class anne_service {
    constructor ($pgui) {
        this.pgui = $pgui;
        this.ID = $pgui._guid;
        this.pObj = $pgui.pObj;
        if (this.pObj) {
            this.misc = this.pObj.misc;
            if (this.pObj.s_cbk) this.success_callback = this.pObj.s_cbk; 
            if (this.pObj.f_cbk) this.fail_callback = this.pObj.f_cbk;
        }
        else {
            this.misc = null;
            this.success_callback = null; 
            this.fail_callback = null;
        }
        this.nid = this.pObj.p2;
        this.makeclass_nid = this.pObj.p3;
        this.makeinst = this.pObj.p4;
        if (this.makeinst==undefined) this.makeinst=true;
        this.class_nObj = MEMG.getNeuronByNid(this.nid);
        this.makeclass_nObj = MEMG.getNeuronByNid(this.makeclass_nid);
        this.el_this = document.getElementById("service_"+this.ID);
        if (this.el_this!=null) {
            var blobs = this.el_this.querySelectorAll(".blob-generic");
            for (var b=0; b<blobs.length; b++) {
                ANNE.A.parseANTags(blobs[b]);
            }
        }
    }
}


/**
 * Any user can create a bounty neuron and offer a bounty.
 * (request for services to be rendered)
 * 
 * This is intended for digital work.
 * Any abuse of this for something insane such as assassination markets
 * will be swiftly PRUNED by ANNE, despite bounties NOT being in the ANNE worldview.
 * 
 * There are few cases where ANNE will get involved with pruning the ANNE HYPERGRAPH
 * but this is one of them.  (ANNE is also not open to documenting or indexing PORN) 
 * 
 * ANNE chain is a data chain -- not a chain to be used for putting actual bounties
 * on the heads of people or living things.
 * 
 * These bounties are for DIGITAL TASKS ONLY and determination of when the task
 * was or was not fulfilled is done by the ANJUCATORS setup in the neuron.
 */
 class service_bounty extends anne_service {
    constructor($pgui) {
        super($pgui);
        this.el_input = document.getElementById("dynamic_input_"+this.ID);
        this.el_input.addEventListener("input",  e=> this.inputOrGovChg(e));
        this.el_input.focus();

        this.el_gov = document.getElementById("bounty_governance_"+this.ID);
        this.el_gov_dd = document.getElementById("dd_bounty_gov_"+this.ID);
        this.el_gov_dd.addEventListener("change", e=>this.inputOrGovChg(e));
        
        this.el_bounty = document.getElementById("bounty_input_"+this.ID);
        this.el_bounty.addEventListener("input", e=>this.bountyChanged(e));
        this.el_bounty_disp = document.getElementById("annies_display_"+this.ID);

        this.el_desc_ta = document.getElementById("bounty_desc_"+this.ID);
        this.el_desc_ta.addEventListener("input", e=>this.handleDescChg(e));
        this.el_desc_ta.value="";
        this.el_audit_msg = document.getElementById("audit_msg_"+this.ID);


        this.el_last_div = document.getElementById("last_div_"+this.ID);
        ANNE.A.hide(this.el_last_div);

        this.el_saveghostbtn = document.getElementById("make_new_ghost_btn_"+this.ID); 
        this.el_saveghostbtn.addEventListener("click", e=>this.makeNewBounty(e));
    }

    /**
     */
    inputOrGovChg=function($e) {
        var val = ANNE.A.getValue(this.el_input);
        var gov = this.el_gov_dd.value;
        if (val.length>0 && gov.length>0) {
            ANNE.A.show(this.el_last_div);
        }
        else {
            ANNE.A.hide(this.el_last_div);
        }
    }

    /**
     */
    bountyChanged = async($e=null)=> {
        var bounty = this.el_bounty.value.trim();
        ANNE.A.validateAndFormatAnnecoin(this.el_bounty, this.el_bounty_disp, bounty, true);
        var desc = this.el_desc_ta.value.trim();
        if (bounty.length && desc.length>0) {
            ANNE.A.show(this.el_saveghostbtn);
        }
        else ANNE.A.hide(this.el_saveghostbtn);
    }

    /**
     */
     handleDescChg=async($e=null)=>{
        var desc = this.el_desc_ta.value.trim();
        if (desc=="") {
            ANNE.A.hide(this.el_saveghostbtn);
            ANNE.A.setHTML(this.el_audit_msg, "Please provide a detailed description of the bounty.");
            return;
        }
        
        var bounty = this.el_bounty.value.trim();
        if (bounty=="") {
            ANNE.A.hide(this.el_saveghostbtn);
        }
        else ANNE.A.show(this.el_saveghostbtn);
    }

    
    /**
     * Make the bounty neuron and go to the ghost
     */
    makeNewBounty = async($e)=>{
        console.log("make it!");
        var val = ANNE.A.getValue(this.el_input);
        var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.bounty, val);
     
        var relons_to_ghost = [];

        var bounty = this.el_bounty.value.trim()*100;
        var bounty_annies_rel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.annies.nid, TO_TYPE_NUMBER, bounty, true);
        relons_to_ghost.push(bounty_annies_rel);
        
        var gov = this.el_gov_dd.value;
        var bounty_governance_rel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.governance.nid, TO_TYPE_ANNE, gov, true);
        relons_to_ghost.push(bounty_governance_rel);

        var desc = this.el_desc_ta.value.trim();
        var bounty_desc_rel = MEM.makeTempRelon(ghostNOBJ, TYPE_HAS, MEM.description.nid, TO_TYPE_BLOB, desc, true);
        relons_to_ghost.push(bounty_desc_rel);

        ANNE.TALK.printRelons(relons_to_ghost); //should see be, name and constituent relon!
        await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        PAGES.launchNeuron(ghostNOBJ.nid);
    }
}