class user_master  {
    constructor(){
        this.public_nid = "";
        this.pubKey = "";
        this.privKey = "";
        this.seedObj = null;                    //switching from passing seedObj around.. ot just using it here when needed
        this.unlock_pw = "";
        this.balanceObj = null;                 //onoly set with the logged in user's balance
        this.onLoginCallback = null;
        this.onLogoutCallbackStr = "";
        this.onUserDetailsCallbackStr = "";
        this.welcomeCallback = null;
        this._bNEWUSER = false;  
        this._userNObj = {nid:0};
        this._pollingResultID = null;
        this._analysisObj = null;
        this._userLS = null;                    //user localStorage obj
        this._bWORLDVIEWBIPASS = false;
        this._badPWAttempts = 0;
    }


    /**
     * 
     * @author Mr.scatman
     */
    __loginCheck = async ($loggedInCallback, $notLoggedInCallback=null)=> {
        return USER.checkLoginFromStorage($loggedInCallback, $notLoggedInCallback);
    }



    /**
     * Check localStorage for user info.
     * 
     * first check the localStorage of THIS app --  if we don't find any  
     * goodies, check the ANNE SCOPE IFRAME.  Nifty --  if we find the       
     * goodies there, store them in localStorage here too!                
     *                                                                       
     * example use case:                                                     
     * We want on onboarding app ANNEON to be able to save the hash/address  
     * and count -- so the user can get their key out on another ANNE app    
     * without having to do it all again.                                    
     * @author Mr.scatman
     */
     checkLoginFromStorage=async($onLoginCallback=null, $notLoggedInCallback=null)=> {
        USER.onLoginCallback = $onLoginCallback;

        //CHECK ANNE SCOPE FIRST
        //THE USER MANAGES ALL THEIR SETTINGS THERE!
        var bDONE = false;
        var user = null;
        var temp = localStorage.getItem('ANNE');
        var ANNE_LS = null;
        var user = null;
        
        //if we have a local object, but it is bad, set bDEAD to true.
        if (temp!=undefined && temp!=null) {
            var ANNE_LS = JSON.parse(temp);
            if (ANNE_LS==undefined || ANNE_LS==null) bDEAD=true
            else {
                if (ANNE_LS.encrypted!=undefined && ANNE_LS.public_nid!=undefined) {
                    user = ANNE_LS;
                }
                else user = ANNE_LS.user;
                if (user==undefined || user==null || user.public_nid=="") bDEAD=true;
                else {
                    bDONE=true;
                    if (ANNE.API._AAUTH!=null) user.aauth = ANNE.API._AAUTH;
                    else {
                        if (user.aauth!=undefined) {
                            ANNE.API.setAAUTHFromLS(user.aauth);
                            //var ok = await USER.refreshAAUTH(seedObj.seed, USER._userLS);
                            //if we are missing vars, let's refresh this.
                        }
                    }

                    await USER.__saveHashInEXTScope(user);
                    if (user.user_pw!=undefined) USER.unlock_pw=user.user_pw;
                }
            }
        }

        if (bDONE==false) {
            var users = await USER.__checkLoginFromEXTScope();
            
            //take the first good one we have.
            if (users.length) {
                for (var u=0; u < users.length; u++) {
                    var user = users[u];
                    USER.public_nid = user.public_nid;
                    USER.pubKey = user.pubKey;
                    if (user.encrypted.length && user.count!=-1) {
                        if (ANNE.API._AAUTH!=null) user.aauth = ANNE.API._AAUTH;

                        //update this local scope
                        localStorage.setItem('ANNE', JSON.stringify(user));      //it's frenly, i know!  :)  
                        bDONE=true;
                        
                        //creates a new annode_auth object.
                        if (user.aauth!=undefined) {
                            ANNE.API.setAAUTHFromLS(user.aauth);
                        }
                        break;
                    }   
                }   
            }  
        }


        //no local storage of any users exist.
        //(no ANNE or ANNE_history)
        if (bDONE==false) {
            if($notLoggedInCallback!=null) $notLoggedInCallback();
            return false;
        }
        
        USER.public_nid = user.public_nid;
        USER.pubKey = user.pubKey; 
        if (ANNE.MEM) {
            USER._userNObj = ANNE.MEM.addInUserNeuron(user.public_nid, true);
        }
        USER._userNObj.my_sponsored=[];
        USER._userNObj.mine=true;
        USER._userLS = user; 

        
        if (ANNE.MEMP) await ANNE.MEMP.__postLoginCleanup();

        USER.updateLSNickname(USER._userNObj);

        //call the local callback first, if not set call the USER class callback
        //else do nothing
        if ($onLoginCallback!=null) $onLoginCallback(user.public_nid);
    }



    /**
     * 
     * @author Mr.scatman
     */
     setUserPIN=function($seed_el, $pin_el, $bSAVEPW=false) {
        USER.setSeedWithPW_gui('user_'+$seed_el, 'user_'+$pin_el, $bSAVEPW);
    }


    /**
     * Make a new random seed for an ANNE address and corresponding keys.
     * Populate it into the $el
     * 
     * @param {*} $el 
     * @param {*} $qrdivid 
     * @returns 
     */
     makeSeed=async($el, $qrdivid="")=> {
        var neuron = await USER.getNewAnneUserAccount();
        var el = document.getElementById($el);
        el.setAttribute('type', 'text');
        el.value=neuron.seed;
        if ($qrdivid) ANNE.A.show($qrdivid);
        return neuron.accountId;
    }

    
    makeSeedSOLO=async($elSeed, $seed)=> {
        var neuron = await USER.getNewAnneAccount($seed);
        var el = document.getElementById($elSeed);
        el.setAttribute('type', 'text');
        el.value=neuron.seed;
        return neuron;
    }

    
    /** 
     * Generate a random new seed.
     * @author Mr.Scatman
     */
    getNewAnneUserAccount=async()=> {
        var seedseed = ANNE.UTILS.randomHex(32)+ANNE.UTILS.randomHex(16)+ANNE.UTILS.randomHex(32);
        var aSeeds = [USER.getNewAnneAccount(seedseed)];

        var seed = "";
        if (aSeeds.length) seed = aSeeds[0].seed;
        else {
            seed = ANNE.UTILS.randomHex(32)+ANNE.UTILS.randomHex(16)+ANNE.UTILS.randomHex(32);
        }
        var neuron = ANNE.SIGNA.crypto.generateMasterKeys(seed);
        var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(neuron.publicKey, "A");
        neuron.accountId = addressObj._numericId;
        neuron.seed = seed;
        neuron.address = addressObj._rs;
        neuron.nid = neuron.accountId;
        //console.log(neuron);
        return neuron;
    }

    getNidFromSeed=function($seedObj) {
        var neuron = ANNE.SIGNA.crypto.generateMasterKeys($seedObj.seed);
        if (neuron!=null) {
            var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(neuron.publicKey, "A");
            return addressObj._numericId;
        }
        return null;
    }


    /** 
    * ANNE identity login passphrase w/ password using divs to get the info.
    * In the extension we can safely have this openly ready to use in the user.js RAM.
    * It is stored by the user PW in extension memory.
    * 
    * @author Mr.Scatman 
    */
    setSeedWithPW_gui=async($keydivid, $pwdivid, $bSAVEPW=false)=> {
        var seedEl = ANNE.A.__getEl($keydivid);
        var seed_text = seedEl.value;
        seed_text=seed_text.trim();
        var pwEl = ANNE.A.__getEl($pwdivid);
        var pw_text = pwEl.value;
        USER.unlock_pw = pw_text;
        var pubKey = ANNE.SIGNA.crypto.generateMasterKeys(seed_text).publicKey;
        await USER.setUserSeed(seed_text, pw_text, pubKey, $bSAVEPW);
        USER.seedObj = {seed:seed_text, status:"success"};

        console.log("%c USER.setSeedWithPW_gui ", TALK.bgyellow);
        
        //check here for already registered to fire the welcome back.
        console.log("new user login:"+USER._bNEWUSER);
        //welcomeBack

        await ANNE.API.getNeuron(USER._userNObj.nid, [0,1]);
        
        if (typeof USER.onLoginCallback === "function") {
            return USER.onLoginCallback();
        }
        return;
    }



    /*** 
    * ANNE identity login passphrase w/ password 
    * @param {string}
    * @param {string}
    * @param {string}
    * @param {Boolean}
    * @author Mr.Scatman 
    */
    setSeedWithPW=async($key, $pw, $errDivid, $bLOGIN=true)=> {
        var key_text =$key.trim();
        var pw_text = $pw;
        var pubKey = ANNE.SIGNA.crypto.generateMasterKeys(key_text).publicKey;

        var user = await USER.setUserSeed(key_text, pw_text, pubKey);
        if (user==null) {
            ANNE.A.setHTML($errDivid, "This is not a valid ANNE seed.");
            return false;
        }

        if ($bLOGIN==true && USER.onLoginCallback!=null) USER.onLoginCallback();
        return;
    }


    /*** 
    * ANNE identity login passphrase w/ password 
    * @param {string}
    * @param {Boolean}
    * @author Mr.Scatman 
    */
    setSeedWithPW=async($seed, $pw, $bLOGIN=true)=> {
        var seed_text = $seed.trim();
        
        //this is safe to set here in the extension.
        //for this session we will have access to it without
        //requiring a pw check.
        this.seedObj = {seed:seed_text, status:"success"};

        var pw_text = $pw.trim();
        var pubKey = ANNE.SIGNA.crypto.generateMasterKeys(seed_text).publicKey;
        var user = await USER.setUserSeed(seed_text, pw_text, pubKey);
        if (user==null) {
            console.log("This is not a valid ANNE seed.");
            return false;
        }
        if ($bLOGIN==true && USER.onLoginCallback!=null) USER.onLoginCallback();
        return;
    }



    /**                      
    * Encrypt the passphrase in local storage with a password.
    *
    * @param {string} 
    * @param {string}
    * @param {string}
    * @author Mr.Scatman                                           
    */
    setUserSeed = async($passPhrase, $pw_text, $pubKey="", $bSAVEPW=false)=> {
        var count = Math.floor(Math.random()*(9-5+1)+5);
        var pw_hash = await USER.hashPw($pw_text);
        var encrypted = USER.encrypt_it($passPhrase, pw_hash);  //using the pw_hash to encrypt the passphrase(seed)
        var public_nid = USER.getAccountIdFromSeed($passPhrase);
        if (public_nid=="") {
            USER.public_nid = "";
            USER._userNObj = {nid:0, my_sponsored:[]};
            USER.pubKey = "";
            return null;
        }
        USER.public_nid = public_nid;
        
        var user = {
                    "encrypted":encrypted,
                    "count":count, 
                    "activated":false,
                    "public_nid":public_nid,
                    "pubKey":$pubKey, 
                    "annode_uri":ANNE._annodesLS.last_uri,
                    "backed_up":false,
                    "backed_up_on":"",
                    "last_known_annies":0,
                    "last_login":Date.now(),
                    "nickname":""
                } 

        //this is entirely insecure and anyone can unlock the acct with access to the browser.
        if ($bSAVEPW==true) user.user_pw = $pw_text;

        USER.pubKey = $pubKey;
        
        var ok = await USER.refreshAAUTH($passPhrase, user);
        if (ok==true) {
            if (ANNE.MEM) {
                USER._userNObj = ANNE.MEM.addInUserNeuron(user.public_nid, true);
            }
            USER._userNObj.my_sponsored=[];
            USER._userLS = user;
        
            //user has opted to save pw in localStorage.
            //If they do not have a default pw set, use this pw as their default.
            //This will be used for new accts to prevent them from having to enter in the same pw every time.
            //If they want to change it, they can.
            if ($bSAVEPW==true) {
                var ah = localStorage.getItem('ANNE_history');
                if (ah!=null) {
                    var hObj = JSON.parse(ah);
                
                    //if we have a default_unlock_pw, use it to default the unlock pw for the new acct.
                    if (hObj.default_unlock_pw==undefined) {
                       hObj.default_unlock_pw = $pw_text;
                       localStorage.setItem('ANNE_history', JSON.stringify(hObj));
                    }
                }
            }
            
            await this.__saveHashInEXTScope(user);

            if (ANNE.BRAIN!=null) ANNE.BRAIN.setPrimarySpeaker(user.public_nid);
            
            return user;
        }

        return null;
    }


    /**                      
    * @param {string} - seed
    * @param {Object} - user LS object
    * @author Mr.Scatman                                           
    */
    refreshAAUTH=async($passPhrase, $userLSOBJ)=> {
        var aO = USER.prepANNEAuthObjFromSeed($passPhrase);
        var randuniquerequestid = UTILS.randHex(4);

        var result = await ANNE.API.ANNODEHANDSHAKE(aO, randuniquerequestid);
        if (result && result.status=="good") {
            var result = result.result;
            if (result.logins!=undefined) $userLSOBJ.logins = result.logins;
            if (result.encrypted_proof==undefined || result.nonce2==undefined) {
                console.log("ANNODE must supply proof of annode");
                return false;
            }

            var nonce2 = result.nonce2;

            //this is from the ANNENODE -- we need to decyrpt it
            //then do our standard hash encrypt FOR US, to store it back into localStorage.
            var proof_decrypted = await ANNE.USER.decryptMsgEncryptedFromANNODE(nonce2, result.encrypted_proof, ANNE.API._AAUTH.pubKey, aO.priv_key);
            var parts = proof_decrypted.split(":::");
            if (parts.length==2) {
                var proof_nid = parts[0];
                if (proof_nid.trim()!=$userLSOBJ.public_nid) {
                    console.log("nid of this user must match decrypted nid coming back");
                    return false;
                }
                var uid = parts[1];
                if (uid!=randuniquerequestid) {
                    console.log("uid sent must match decrypted uid coming back");
                    return false;
                }
            }
            else return false;
            
            //we must have the encrypted_sk and the nonce.
            //this will help with various annode services.
            if (result.encrypted_sk!=undefined && result.nonce!=undefined) {
                var nonce = result.nonce;

                //this is from the ANNENODE -- we need to decyrpt it
                //then do our standard hash encrypt FOR US, to store it back into localStorage.
                var shared_secret = await ANNE.USER.decryptMsgEncryptedFromANNODE(nonce, result.encrypted_sk, ANNE.API._AAUTH.pubKey, aO.priv_key);
                var ss_text = shared_secret;
                if (ANNE.SETTINGS.debug()==true) console.log("audit: "+ss_text);
                
                //hijack this function and use the hashedkey w/ salt as the pw, and encrypt the shared secret
                var encrypted_sk2 = await USER.hashSeedWithRecoveryPW("x"+$passPhrase+"y", shared_secret);
                if (encrypted_sk2==null) return false;

                //$user.encyrpted_sk_fromannode = result.encrypted_sk;
                $userLSOBJ.encrypted_sk = encrypted_sk2;    //now it is encrypted by US.
                
                if (ANNE.API._AAUTH!=null) {
                    ANNE.API._AAUTH.encrypted_sk = result.encrypted_sk;
                    ANNE.API._AAUTH.nonce = result.nonce;
                    ANNE.API._AAUTH.encrypted_proof = result.encrypted_proof;
                    ANNE.API._AAUTH.nonce2 = result.nonce2;
                    ANNE.API._AAUTH.next_proof_id = result.next_proof_id;

                    //add in existing extra props from our annode info pull (if we did it)
                    if ($userLSOBJ.aauth!=undefined && $userLSOBJ.aauth!=null) {
                        ANNE.API._AAUTH.ANNDLE_active = $userLSOBJ.aauth.ANNDLE_active;
                        ANNE.API._AAUTH.ASDF_active = $userLSOBJ.aauth.ASDF_active;
                        ANNE.API._AAUTH.BOUNTY_active = $userLSOBJ.aauth.BOUNTY_active;
                        ANNE.API._AAUTH.GOLIVE_active = $userLSOBJ.aauth.GOLIVE_active;
                        ANNE.API._AAUTH.PDNS_active = $userLSOBJ.aauth.PDNS_active;
                    }
                    
                    $userLSOBJ.aauth = ANNE.API._AAUTH;
                }

                
                //store this in ANNE scope memory too, if this is on.
                //unless we're told explicity not to.  Then don't.  :)
                //never store no_pw mode in anne scope.
                await USER.__saveHashInEXTScope($userLSOBJ);

                //extract the extras (relons from this annode aimed at us
                //using the relon=user syntax).
                //we need to extend the mem handler to get SYS_REF_TXID
                //in the relon.  We don't need to store it in the attachment.. (or do we??)
                if (result.extras!=undefined) {
                    console.log("WE HAVE EXTRAS");
                    console.log(result.extras);
                    for (var e=0; result.extras.length; e++) {
                        var relon = results.extras[e];      //the relon sent by the annode.
                        var ref_txid = relon.sys_ref_txid; 
                        if (ref_txid==undefined || ref_txid==null) continue;
                        
                        //this will be the relon WE SENT to the annode to trigger a service.
                        var ref_relon = MEMG.lookupRelonByTXID(ref_txid);
                        if (ref_relon==null) continue;

                        //this relon could have been sent in the childRelon pattern
                        //which means we were not in the "from_nid".
                        //the from_nid is the neuron we took action on...
                        //the reln is the action..
                        ref_relon.annode_response = relon;  //back link for mem use
                        
                        var temp_relon = MEM.makeTempRelon(nOBJ, TYPE_HAS, ref_relon.reln, ref_relon.to_type, ref_relon.to_s, true);
                        if (temp_relon) await DB.___update(temp_relon);
                    }
                }

                return true;
            }
        }
        return false;
    }


    /**
     * 
     * @author Mr.scatman
     */
    isUs=function($nid) {
        if (USER._userNObj==null) return false;
        if ($nid==USER._userNObj.nid) return true;
        return false;
    }


    /**
     * Is this neuron us or owned by us? 
     * @param {string}
     * @author Mr.scatman
     */
    isUsOrOwnedByUs=function($nid) {
        if (typeof $nid ==='object') {
            console.log("FIX THIS CALLER");
            if ($nid.nid!=undefined) $nid=$nid.nid;
            else return false;
        }
        if (USER._userNObj==null) return false;
        if ($nid==USER._userNObj.nid) return true;
        var nObj = MEMG.getNeuronByNid($nid);
        if (nObj==null) return false;
        if (nObj.owned_by!=undefined && nObj.owned_by==USER._userNObj.nid) return true;
        return false;
    }



    /**
    * AES encrypt a string with a key.
    **/
    encrypt_it = function ($stringToEncrypt, $key) {
        if (ANNE.SIGNA.crypto==null==null) {
            console.error("must include SIGNA.crypto");
            return;
        }
        return ANNE.SIGNA.crypto.encryptAES($stringToEncrypt, $key);
    }


    decryptMsgFromANNEUser = function($encryptedMsg, $senderPubKeyHex) {
        //var privKey = USER.
        //decryptMessage(encryptedMessage, senderPublicKeyHex, recipientPrivateKeyHex)
    }

    /**
    * AES decrypt a string with a key.
    **/
    decrypt_it = function ($string, $key) {
        if (ANNE.SIGNA.crypto==null) {
            console.error("must include SIGNA.crypto");
            return;
        }
        return ANNE.SIGNA.crypto.decryptAES($string, $key);
    }


    /**
     * For udf seeds, do not let the same char used too many times.
     * Also, do not allow more than 5 consectuve hits of the same char.
    */
    isValidSeed = function($passPhrase) {
        var len = $passPhrase.length;
    
        if (len < 64) {
            console.log("turn this on for release...");
            return false;
        }

        var hits = [];
        var last = -1;
        var consecs = 0;
        for (var i=0; i < len; i++) {
            var c = $passPhrase.charCodeAt(i);
            if (c==last) consecs+=1;
            else consecs=0;
            last = c;
            if (consecs > 5) {
                console.log("too man consectutive chars");
                return false;
            }

            if (hits[c]==undefined) hits[c]=1;
            else {
                hits[c]+=1;
                if (hits[c] > (len/5)) {
                    console.log("over 1/5th ur chars are the same!  Need more variance.");
                    return false;
                }
            }
        }

        return true;
    }


    /**
     * 
     * @param {*} $passPhrase 
     * @returns 
     */
    isValidSeedSOLO = function($passPhrase) {
        var len = $passPhrase.length;
        if (len < 64) {
            return {status:"bad", reason:"Seed must be atleast 64 chars."};
        }
        var hits = [];
        var last = -1;
        var consecs = 0;
        for (var i=0; i < len; i++) {
            var c = $passPhrase.charCodeAt(i);
            if (c==last) consecs+=1;
            else consecs=0;
            last = c;
            if (consecs > 5) {
                return {status:"bad", reason:"insecure. Too man consectutive chars."};
            }

            if (hits[c]==undefined) hits[c]=1;
            else {
                hits[c]+=1;
                if (hits[c] > (len/4)) {
                    return {status:"bad", reason:"over 1/4th ur chars are the same!  Need more variance."};
                }
            }
        }

        return {status:"good"};
    }
    

    /**
    * update this for signa.
    */
    isValidPK = function($pk) {
        true;
    }


    /** 
    * from a passphrase, get the accountId
    */
    getAccountIdFromSeed=function($seed) {
        if(ANNE.SIGNA.crypto==null || ANNE.SIGNA.sig==null) return "";
        var neuron = ANNE.SIGNA.crypto.generateMasterKeys($seed);
        var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(neuron.publicKey);
        return addressObj._numericId;
    }


    /**
    */
    getPrivateKeyStringFromSeed=function($seed) {
        if(ANNE.SIGNA.crypto==null || ANNE.SIGNA.sig==null) return "";
        var masterNeuron = ANNE.SIGNA.crypto.generateMasterKeys($seed);
        var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(masterNeuron.publicKey);
        return addressObj.signPrivateKey;
    }


    /**
    */
    prepANNEAuthObjFromSeed=function($seed=null) {
        if ($seed==null || $seed==null) { 
            console.log("must pass seed here"); 
            return {sign_key:'', priv_key:'', pub_key:'', rs_addr:''};
        }
        var neuron = USER.getNewAnneAccount($seed);
        return {sign_key:neuron.signPrivateKey, priv_key:neuron.agreementPrivateKey, pub_key:neuron.publicKey, rs_addr:neuron.address};
    }


    testKeys = function() {
        var masterNeuron = ANNE.SIGNA.crypto.generateMasterKeys(USER.seedObj.seed);
        console.log(masterNeuron);
    }

    /**
    */
    getPubKeyStringFromSeed = function($seed) { //
        if(ANNE.SIGNA.crypto==null || ANNE.SIGNA.sig==null) return "";
        var masterNeuron = ANNE.SIGNA.crypto.generateMasterKeys($seed);
        var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(masterNeuron.publicKey);
        return addressObj.publicKey;
    }

    auditAcctIdFromPubKey = function($acctId, $pubKey) {
        var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey($pubKey);
        if (addressObj._numericId==$acctId) return true;
        return false;
    }


    /** 
     * Generate a random new seed via SIGNA passphrase gen or a poor man's random algo.
     * If optionsal seed string is passed it will use it, otherwise it is random.
     * @author Mr.Scatman
     */
    getNewAnneAccount=function($seed="") {
        var seed = $seed;
        if (seed=="" && ANNE.UTILS!=null) {  //we need a random seed!
            if (ANNE.UTILS!=null) {
                seed = ANNE.UTILS.randomHex(32)+ANNE.UTILS.randomHex(16)+ANNE.UTILS.randomHex(32);
                console.log(seed);
            }
            else ""+Math.ceil(Math.random()*1000000)+Math.ceil(Math.random()*7777)+Math.ceil(Math.random()*1000000)
        }
        var neuron = ANNE.SIGNA.crypto.generateMasterKeys(seed);
        var addressObj = ANNE.SIGNA.sig.Address.fromPublicKey(neuron.publicKey, "A");
        neuron.accountId = addressObj._numericId;
        neuron.seed = seed;
        neuron.address = addressObj._rs;
        neuron.nid = neuron.accountId;
        return neuron;
    }

    genKeyPopupMsg=function(){
        var parts = [];
        parts.push("anne.nodeAccountId = "+USER._userNObj.nid);
        parts.push("anne.nodePubKey = "+USER.pubKey);
        if (USER.privKey=="" || USER.privKey==undefined) {
            var aO = USER.prepANNEAuthObjFromSeed(USER.seedObj.seed);
            USER.privKey = aO.priv_key;

            if (USER.RS_ADDR=="") USER.setRSADDR();
        }
        
        parts.push("anne.nodePrivKey = "+USER.privKey);
        parts.push("anne.nodeSecret = "+USER.seedObj.seed);
        return parts.join("<BR>");
    }

    
    /**
     * 
     * @returns 
     */
    genStandardKeyPopupMsg=function(){
        var parts = [];
        parts.push("<span style='display:block'>nid <b>"+USER._userNObj.nid+"</b></span>");
        parts.push("<span style='display:block'>public key <b>"+USER.pubKey+"</b></span>");
        if (USER.privKey=="" || USER.privKey==undefined) {
            var aO = USER.prepANNEAuthObjFromSeed(USER.seedObj.seed);
            USER.privKey = aO.priv_key;
        }
        parts.push("<spanstyle='display:block'>private key <b>"+USER.privKey+"</b></span>");
        parts.push("<span style='display:block;padding-bottom:30px'>secret <b>"+USER.seedObj.seed+"</b></span>");
        return parts.join("<BR>");
    }
    

    /**
     * Get a real accountId for use in emulation.
     * We are emulating a neuron and want to use an address that conforms 
     * so we don't break any downstream checkers.     
     * @author Mr.Scatman                              
     */
    getRandomEmulatedANNEAccountId=function() {
        return USER.getNewAnneAccount().accountId;
    }

    haveLSJustPing = async()=> {
        var result = await ANNE.API.ANNODEPING(aO);
        return;
    }

    /**
     * critical for our next non-TX annode interaction that requires proof of user.
     */
    updateNextProofId=async($id)=>{
        console.log("%c (updateNextProofId) id:"+$id, TALK.bgbigred);
        if (USER._userLS.aauth.next_proof_id!==$id){
            USER._userLS.aauth.next_proof_id=$id;
            alert("FIX THIS NOW JACKY");
        };
        await USER.__saveHashInEXTScope(USER._userLS);
    }


    /**
     * 
     * @param {*} $pw 
     */
    updateSavedPw=async($pw)=>{
        if (USER._userLS.user_pw!==$pw){
            USER._userLS.user_pw=$pw;
        };
        await USER.__saveHashInEXTScope(USER._userLS);
    }


    /**
     * 
     * @returns 
     */
    updateLastSignin=async()=>{
        if (USER._userLS==null) return;
        USER._userLS.last_login=Date.now()/1000;
        await USER.__saveHashInEXTScope(USER._userLS);
    }


    /**
     */ 
    updateLastBalance=async()=> {
        if (USER._userNObj.balanceObj==null) {
            console.log("no balance obj to update from.")
            return;
        }

        if (USER._userLS.last_known_annies != undefined && USER._userLS.last_known_annies!=null
            && USER._userLS.last_known_annies==USER._userNObj.balanceObj.annies) return;


        USER._userLS.last_known_annies = USER._userNObj.balanceObj.annies;
        await USER.__saveHashInEXTScope(USER._userLS);
        var anncoin = UTILS.displayAnneValue(USER._userLS.last_known_annies);
        ANNE.A.quickBalanceUpdate(".bal-"+USER._userNObj.temp_nid, anncoin+"<span style='font-size:1.6rem;'>&#x1d110;</span>");
    }


    /**
     * LN Nick will only update if it isn't set.
     */ 
     updateLSNickname=async($nObj)=> {
        if ($nObj==null) return;
        if ((USER._userLS.nickname==undefined || USER._userLS.nickname=="") && $nObj.text!="") {
            USER._userLS.nickname = $nObj.text;
            await USER.__saveHashInEXTScope(USER._userLS);
        }
    }


    /**
     * TODO:  update all user objects
     */ 
     updateBackupFlag=async()=> {
        var history = await ANNE.USER._getHistory();
        var thisAnnodeHistory = history[ANNE._annodesLS.last_uri];
        var users = thisAnnodeHistory.users;
        if (users!=undefined) {
            var keys = Object.keys(users);
            for (var k=0; k < keys.length; k++) {
                var key = keys[k];
                var user = users[key];
                user.backed_up = 1;
                user.backed_up_on = new Date().getTime();

                if (key==USER._userLS.public_nid) {
                    USER._userLS.backed_up = 1;
                    USER._userLS.backed_up_on = user.backed_up_on;
                }
                await USER.__saveHashInEXTScope(user);
            }
        }
    }


    /**
     * 
     * @author Mr.scatman
     */
    updateLSSS=async($ess)=>{
        USER._userLS.encrypted_ss = $ess;
        await USER.__saveHashInEXTScope(USER._userLS);
    }


    /**
     * 
     * @author Mr.scatman
     */
    updateLSActivated=async()=>{
        USER._userLS.activated = true;
        await USER.__saveHashInEXTScope(USER._userLS);
    }



    /**
     * helps with gui stuff before we go in too far to the processes
     * @author Mr.Scatman   
     */
    auditPw=async($pw) =>{
        var result = await USER.getSeedWithPW($pw);
        if (result.status=="success") return true;
        return false;
    }


    /**
    * Note: Anyone with access to a user's browser AND/OR any rogue apps    
    * that use the ANNE login frame can take advantage of this method if    
    * fool a user who has selected this "auto password" option.  We must    
    * thus lock it down by domain and require that the user is redirected to
    * the ANNE.network wallet to control their wallet type (mode) w/ ANNE   
    * on a domain-by-domain basis.                
    * @author Mr.Scatman                                                               
    */
    getSeedWithDefaultPW=async()=> {
        alert("(getSeedWithDefaultPW) do we do this still?");
        var nid = USER._userNObj.nid;
        if (ANNE.other.sha256==null) {
            console.error("you must include sha256.js");
            return;
        }
        var pw_text = ANNE.other.sha256(nid).substring(16); 
        return await USER.getSeedWithPW(pw_text, "encrypted_oneclick", USER._userLS.oneclick_count);
    }


    /**                                     
    */
    getSeedWithPW=async($pw, $hash_prop="encrypted", $bGENNID=false)=> {
        var user = null;
        var temp = localStorage.getItem('ANNE');
        if (temp==undefined || temp==null) return {status:"failure", reason:"no stored ANNE localStorage object."};;
        var user = JSON.parse(temp);
        if (user==undefined || user==null || user=="") {
            return {status:"failure", reason:"no stored user object."};
        }
        var encrypted_hash = user[$hash_prop];
        if (encrypted_hash==undefined || encrypted_hash==null) {
            return {status:"failure", reason:"no stored '"+$hash_prop+"'"};
        }

        var pw_hash = await USER.hashPw($pw);
        var decrypted = USER.decrypt_it(encrypted_hash, pw_hash);
        if (decrypted==undefined || decrypted=="") {
            return {status:"failure", reason:"invalid pw"};
        }
        var isValid = USER.isValidSeed(decrypted);
        if (isValid==false) return {status:"failure", reason:"invalid pw"};
        
        var nid = "";
        if ($bGENNID==true && decrypted!=null && decrypted!="") {
             nid = this.getNidFromSeed({seed:decrypted});
        }
        return {status:"success", seed:decrypted, nid:nid};
    }


    /*** hashPw ********************************************** 0x/xx/2019 ***
    * user seed encrypted in browser                                        *
    * not too critical here to use strong encryption.                       *
    * their pw will encrypt the wif so it doesn't sit in browser memory in  *
    * plaintext. pw must be used for every on-chain TX action. (or bundle)  *
    ******************************************************** Mr.Scatman ****/
    hashPw=async($pw)=> {
        var salt_post = "aSk3aCnDDqFm1zVd2hyk1tpxxrp4b24!x*d";
        var hash = $pw + salt_post;
        return hash;
    }


    /** 
     * take a salted seed (user can regen via their key or pw) and 
     * encrypted something.
     */
    hashSeedWithRecoveryPW=async($saltedKeyString, $something_to_encrypt)=> {
        if (ANNE.other.sha256==null) {
            console.error("you must include sha256.js");
            return;
        }
        var hash_as_key = ANNE.other.sha256($saltedKeyString);
        return USER.encrypt_it($something_to_encrypt, hash_as_key)
    }


    /*** Recover the seed with the recovery hash and recovery password.
    * With a recovery hash and recovery pw, recover the key!              
    * This is presently used by onboarders who were onboarded via an email 
    * and they had a code.  The code + their email ties them to their
    * recovery hash (which they can retrieve by request).
    */
    recoverSeedWithRecoveryHashAndPW=async($saltedKeyString, $encryptedString)=> {
        if (ANNE.other.sha256==null) {
            console.error("you must include sha256.js");
            return;
        }
        var encryption_key = ANNE.other.sha256($saltedKeyString);
        return USER.decrypt_it($encryptedString, encryption_key)
    }



    /**
     * We will do this run-time to encrypt PRIVATE DATA NEURONS.            
     * Only ANNE can and the user submitting them can decrypt them.          
     * THIS IS NOT the only encryption method.  User's can encrypt-for-self  
     * and they and only they can see that data unencrypted.  Private data   
     * neurons are a service used for selective disclosure.                                                                    
    */
    getSharedSecret=async()=>{
        if (USER._userLS.encrypted_sk!=undefined) {
            var seedObj = USER.seedObj;
            if (seedObj.status=="success") {
                var es = USER._userLS.encrypted_sk;
                var ss = await USER.recoverSeedWithRecoveryHashAndPW("x"+seedObj.seed+"y", es);
                if (ss!=undefined && ss!=null && ss.length) {
                    seedObj = null;
                    return {status:"success", seed:ss}; //seed here is the shared secret
                }
                else return  {status:"fail", reason:"We could not access your shared secret."}
            }
            return {status:"fail", reason:"The seed Obj used to get the shared secret is not set."}
        }

        //consider asking for the _getKey here, then retrieving the shared secret from
        //ANNE mem (restore localStorage goodies w/ existing wif pasted in)
        return {status:"fail", reason:"You do not have a shared secret.  This should be automatically made when you AAUTH with an ANNODE.  Contact Mr.Scatman."}
    }


    //encrypt msg here, this is what the annode stores on in the non-chain tbl.
    //on-demand this will be decrypted then re-encrpted for the recipient.
    genACHATEncryptMsg=async($sso, $aMsgParts, $sesh_id)=> {
        return $aMsgParts.join("|||");
        //var ephemeral_key = ANNE.other.sha256(shared_secretObj.seed+$sesh_id);
        //var encrypted = await USER.encryptForANNODE(ephemeral_key, msgStr);
        //console.log("encrypted:"+encrypted);
        //return encrypted;
    }


    /**
     * 
     * @param {*} $msg 
     * @returns 
     */
    genGeneralProveIt = async($msg)=>{
        var shared_secretObj = await USER.getSharedSecret();
        var nextProofId = ANNE.API.getNextProofId();
        var msgStr = USER._userNObj.nid+":::"+nextProofId+":::"+$msg;
        var ephemeral_key = ANNE.other.sha256(shared_secretObj.seed+USER._userNObj.nid+nextProofId);
        var encrypted = await USER.encryptForANNODE(ephemeral_key, msgStr);
        console.log("encrypted:"+encrypted);
        return encrypted;
    }
    

    /**
     * Send a msg to the handshook ANNODE that is not a TX.
     * 0 - sender nid
     * 1 - next_msg_id
     * 2 - the msg (when decrypted parts are separated by |||)
     */
    genACHATProveIt =async($aMsgParts=null, $sesh_id=null)=> {
        var shared_secretObj = await USER.getSharedSecret();
        var nextProofId = ANNE.API.getNextProofId();
        var msgStr = USER._userNObj.nid+":::"+nextProofId+":::"+"";
        
        if ($aMsgParts!=null && $aMsgParts.length>0 && $sesh_id!=null) {
            msgStr += await this.genACHATEncryptMsg(shared_secretObj, $aMsgParts, $sesh_id)
        }

        console.log(msgStr);

        //requester_shared_secret+from_nid_unsigned+next_msg_id.toString();
        var ephemeral_key = ANNE.other.sha256(shared_secretObj.seed+USER._userNObj.nid+nextProofId);
        //console.log("audit requester_shared_secret: "+shared_secretObj.seed);
        //console.log("audit from_nid_unsigned: "+USER._userNObj.nid);
        //console.log("audit next_msg_id: "+nextProofId);
        //console.log("audit ephemeralhex key: "+ephemeral_key);
        var encrypted = await USER.encryptForANNODE(ephemeral_key, msgStr);
        console.log("encrypted:"+encrypted);
        return encrypted;
    }

    

    /**
     * 
     */
    encryptRevealRequestQ = async($shared_secret, $q)=> {
        if ($shared_secret.length<32) {
            return "";
        }
        if ($q.length==0) return "";
        console.log("ss:"+$shared_secret+" from_nid:"+$relon.from_nid+" reln:"+$relon.reln);
        var ephemeral_key = ANNE.other.sha256($shared_secret+$relon.from_nid+$relon.reln);
        console.log("ephemeral_key:"+ephemeral_key);
        var encrypted = await USER.encryptForANNODE(ephemeral_key, $q);
        console.log("encrypted:"+encrypted);
        return encrypted;
    }

    /**
     * 
     */
    encryptRelonToWithSS = async($shared_secret, $relon, $bUPDATERELON=true)=> {
        if ($relon.to_type < TO_TYPE_ENCR_ANNE) {
            $relon.to_s = "wrong totype. wiping the to_s for safety.";
            console.log("(USER.encryptToWithSS)");
            return false;
        }
        if ($shared_secret.length<32) {
            return false;
        }
        console.log("ss:"+$shared_secret+" from_nid:"+$relon.from_nid+" reln:"+$relon.reln);
        var ephemeral_key = ANNE.other.sha256($shared_secret+$relon.from_nid+$relon.reln);
        console.log("ephemeral_key:"+ephemeral_key);
        var string_to_encrypt = $relon.to_s;
        var encrypted_to_s = await USER.encryptForANNODE(ephemeral_key, string_to_encrypt);
        if ($bUPDATERELON==true) $relon.to_s = encrypted_to_s;
        console.log("encrypted:"+encrypted_to_s);
        return true;
    }

    //requester_shared_secret+from_nid_unsigned+next_msg_id_unsigned;
    encryptSKChatComs = async($msg, $participant_nids)=> {
        var shared_secretObj = await USER.getSharedSecret();
        console.log(shared_secretObj);
        var ephemeral_key = ANNE.other.sha256($shared_secret+USER._userNObj.nid+ANNE.API._AAUTH.next_proof_id);
        console.log("ephemeral_key:"+ephemeral_key);
        return await USER.encryptForANNODE(ephemeral_key, $msg);
    }

    decryptSKChatComs = async($msg)=>{
    }


    /** 
     * We encrypted this FOR the annode, decrypt it out. */
     decryptSELFToSWithSS = async($shared_secret, $relon, $encryptedMsg)=> {
        if ($shared_secret.length<64) {
            console.log("secret too short");
            return false;
        }
        var ephemeral_key = ANNE.other.sha256($shared_secret+$relon.from_nid+$relon.reln)
        console.log("ephemeral_key:"+ephemeral_key);
        var decrypted_msg = await USER.decryptFromSelfForANNODE(ephemeral_key, $encryptedMsg);
        console.log("decrypted:"+decrypted_msg);
        return decrypted_msg;
    }

    /**
     * we have a relon that has an encrypted to type.
     * Try to decrypt it best we can.
     */
    ascertainSelfEncryptionAndDecrypt=async($rObj)=> {
        if ($rObj.decrypted!=undefined && $rObj.decrypted!=null) {
            return {status:"success", decrypted:$rObj.decrypted};
        }

        //encrypted by us for the annode
        if ($rObj.r==MEM.PDN_SECRET.temp_nid) {
            var ssObj = await USER.getSharedSecret();
            if (ssObj.status=="success") {
                var decrypted = await USER.decryptSELFToSWithSS(ssObj.seed, $rObj, $rObj.to_s);
                $rObj.decrypted=decrypted;   
                return {status:"success", decrypted:decrypted}
            }
            return {status:"fail", reason:""};
        }

        //encrypted by the annode, for us, using the request to reveal
        else if ($rObj.r==MEM.PDN_ANSWER.temp_nid) {
            var ssObj = await USER.getSharedSecret();
            if (ssObj.status=="success") {
                if ($rObj.sys_ref_txid==undefined) {
                    return {status:"fail", reason:"must have sys ref txid to decrypt here"};
                }
                var seed_relon = MEMG.lookupByTXID($rObj.sys_ref_txid);
                if (seed_relon==null) {
                    await CHASE.lookupTxid($rObj.sys_ref_txid);
                    seed_relon = MEMG.lookupByTXID($rObj.sys_ref_txid);
                    if (seed_relon==null) return {status:"fail", reason:"must have sys ref txid to decrypt here"};
                }
                if (seed_relon.decrypted!=undefined) return {status:"success", decrypted:seed_relon.decrypted};
                var decrypted = await USER.decryptToSWithSS(ssObj.seed, seed_relon, $rObj.to_s);
                $rObj.decrypted=decrypted;   
                return {status:"success", decrypted:decrypted}
            }
            return {status:"fail", reason:""};
        }

        else {
            console.log("unhandled local decryption");
        }
    }


    /**
     * Using the current seedObj, decrypt our rels for this PDN.
     * 
     * NOTE: we assume we've already chased the sys_ref_relon at this point.
     * For primary use of this function we have done it in MEMG.getUserRevealsFor.
     * 
     * TODO: if the PDN annode doesn't match our current ANNODE,
     * notify the user.  We need to get a different shared secret.
     * We can do this auto if we have that object stored.
     * 
     * THIS WILL BE MORE EASY TO TEST WHEN WE ARE IN TESTNET WITH MULTIPLE ANNODES
     * TO HANDSHAKE WITH.
     */
    decryptPDNAnswerRelons = async($rels)=> {
        console.log(this._userLS);
        console.log(ANNE._userAccts);
        var ssObj = await USER.getSharedSecret();
        if (ssObj.status=="fail") return $rels;
        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            var sys_ref_relon = rel.sys_ref_relon;
            if (sys_ref_relon==undefined && rel.sys_ref_txid!=undefined) sys_ref_relon = MEMG.lookupByTXID(rel.sys_ref_txid);
            if (sys_ref_relon==null) continue;
            var decrypted = await USER.decryptToSWithSS(ssObj.seed, sys_ref_relon, rel.to_s);
            rel.decrypted=decrypted;  
        }
        return $rels;
    }


    //inbound from annode use ephemeral pat of ss+reln+from_nid
    decryptToSWithSS = async($shared_secret, $relon, $encryptedMsg)=> {
        if ($shared_secret.length<64) {
            console.log("secret too short");
            return false;
        }
        console.log("ss:"+$shared_secret+" reln:"+$relon.reln+" from_nid:"+$relon.from_nid);
        var ephemeral_key = ANNE.other.sha256($shared_secret+$relon.reln+$relon.from_nid);
        console.log("ephemeral_key:"+ephemeral_key);
        console.log("encrypted msg:"+$encryptedMsg);
        var decrypted_msg = await USER.decryptFromANNODE(ephemeral_key, $encryptedMsg);
        console.log("decrypted:"+decrypted_msg);
        return decrypted_msg;
    }

    decryptACHATmsg = async($msg, $shared_secret, $next_proof_id)=>{
        if ($shared_secret.length<64) {
            console.log("secret too short");
            return false;
        }
        var ephemeral_key = ANNE.other.sha256($shared_secret+$next_proof_id);
        console.log("ephemeral_key:"+ephemeral_key);
        console.log("encrypted msg:"+$msg);
        var decrypted_msg = await USER.decryptFromANNODE(ephemeral_key, $msg);
        console.log("decrypted:"+decrypted_msg);
        return decrypted_msg;
    }


    PBKDF2 = async ($password, $salt, $iterations, $length, $hash, $algorithm ='AES-CBC') => {
        const keyMaterial = await window.crypto.subtle.importKey(
            'raw',
            encoder.encode($password),
            {name: 'PBKDF2'},
            false,
            ['deriveKey']
        );
        return await window.crypto.subtle.deriveKey(
            {name: 'PBKDF2', salt: encoder.encode($salt), $iterations, $hash},
            keyMaterial,
            {name: $algorithm, $length },
            false,
            ['encrypt', 'decrypt']
        );
    };


    /**
     * We are doing an ephemeral key that is ONE-TIME-USE only -- 
     * calculated via a hash of the shared
     * secret and relon pieces for a relon that will be encrypting the to_s.
     * 
     * The shared secret was randomly generated and is NOT tied to the user's
     * ANNE keys.
     */
    encryptForANNODE = async($ephemeralKey, $msg, $salt="xxxxxxxxxxxxxxxx")=> {
        const encoder = new TextEncoder();
        const toBase64 = buffer =>btoa(String.fromCharCode(...new Uint8Array(buffer)));
        var iv = new Uint8Array(16);
        const plain_text = encoder.encode($msg);//65536
        const key = await this.PBKDF2($ephemeralKey, $salt, 1024, 256, 'SHA-256');
        const encrypted = await window.crypto.subtle.encrypt(
            {name: "AES-CBC", iv },
            key,
            plain_text
        );
        var enc = toBase64(encrypted);
        console.log(enc);
        return enc;
    }

    //same as decryptFromANNODE but the ephemeral key is and msg are different.
    //we pass in here what we broadcast to the ANNODE.  this is just for us to get
    //our own stuff back out.
    decryptFromSelfForANNODE = async($ephemeralKey, $msg, $salt="xxxxxxxxxxxxxxxx")=> {
        return await this.decryptFromANNODE($ephemeralKey, $msg, $salt);
    }

    decryptFromANNODE = async($ephemeralKey, $encryptedMsg, $salt="xxxxxxxxxxxxxxxx")=> {
        const decoder = new TextDecoder();
        const fromBase64 = buffer =>Uint8Array.from(atob(buffer), c => c.charCodeAt(0));
        const encrypted = fromBase64($encryptedMsg);
        //console.log("encrypted converted:"+encrypted);
        const salt = $salt;                 //i know, looks unsecure.
        const iv = new Uint8Array(16);      //i know, looks unsecure. //65536

        try {
            const key = await this.PBKDF2($ephemeralKey, salt, 1024, 256, 'SHA-256');
            var decrypted = await window.crypto.subtle.decrypt({name: "AES-CBC", iv }, key, encrypted);
            var result = decoder.decode(decrypted);
            console.log(result);
            return result;
          }
          catch(err) {
            console.log(err);
          }
        return "[** decrypt ERROR **]";
    }


    /**
     * 
     */
    PBKDF2 = async (password, salt, iterations, length, hash, algorithm ='AES-CBC') => {
        const encoder = new TextEncoder();
        const keyMaterial = await window.crypto.subtle.importKey(
            'raw',
            encoder.encode(password),
            {name: 'PBKDF2'},
            false,
            ['deriveKey']
        );
        return await window.crypto.subtle.deriveKey(
            {
            name: 'PBKDF2',
            salt: encoder.encode(salt),
            iterations,
            hash
            },
            keyMaterial,
            { name: algorithm, length },
            false, // we don't need to export our key!!!
            ['encrypt', 'decrypt']
        );
    };


    /**
     * 
     */
    signOwnershipMsg=async($childPrivateKey, $parentNID)=> {
        console.log("pre sign msg: "+$parentNID+"::ownsme", $childPrivateKey);
        var sigmsg = await USER.signMessage($parentNID+"::ownsme", $childPrivateKey);
        console.log("sigmsg");
        return sigmsg;
    }


    /**
     * 
     */
    signMessage=async($msg, $privKeySigner)=> {
        var hexstring = ANNE.SIGNA.util.convertStringToHexString($msg);
        return ANNE.SIGNA.crypto.generateSignature(hexstring, $privKeySigner);
    }


    /**
     * 
     */
    verifyMsg=async($sig, $msgHex, $pubKeySigner)=> {
        return ANNE.SIGNA.crypto.verifySignature($sig, $msgHex, $pubKeySigner);
    }


    /**
     * Quickly encrypt a message for anothre user 
     * This will return nonce and data
     */
    encryptMsgForPUBKEY=async($msg, $pubKeyViewer, $privKeySigner)=>{
        var eObj = ANNE.SIGNA.crypto.encryptData($msg, $pubKeyViewer, $privKeySigner);
        eObj.data_string = ANNE.SIGNA.util.convertByteArrayToHexString(eObj.data);
        eObj.nonce_string = ANNE.SIGNA.util.convertByteArrayToHexString(eObj.nonce);
        //console.log(eObj);
        return eObj;
    }
    

    /**
     * Decrypt a message sent from the annode.
     */
    decryptMsgEncryptedFromANNODE=async($nonce, $encryptedString, $pubKeySignerHex, $privKeyViewerHex=null)=>{
        var encryptedData = {};

        //use our privkey.
        if ($privKeyViewerHex==null) {
            $privKeyViewerHex = this.prepANNEAuthObjFromSeed(USER.seedObj.seed).priv_key;
        }

        encryptedData.nonce = ANNE.SIGNA.util.convertHexStringToByteArray($nonce);
        encryptedData.data = ANNE.SIGNA.util.convertHexStringToByteArray($encryptedString);
        var data_buf = ANNE.SIGNA.crypto.decryptData(encryptedData, $pubKeySignerHex, $privKeyViewerHex);
        var decrypted_msg = ANNE.SIGNA.util.convertByteArrayToString(data_buf);
        if (ANNE.SETTINGS.debug()==true) console.log(decrypted_msg);
        return decrypted_msg;
    }



    /**
     * 
     * @param {*} $json 
     * @returns 
     */
    decryptRawTxJsonAttachmentMsg = async($json)=> {
        if ($json.recipient!=USER._userNObj.nid) {
            //msg was sent from us.
            if ($json.sender!=USE._userNObj.nid) return "";
        }
        if ($json.attachment==undefined) return "";
        if ($json.senderPublicKey==undefined) return "";
        if ($json.attachment.encryptedMessage==undefined) return "";
        var em = $json.attachment.encryptedMessage;
        var msg = await USER.decryptMsgEncryptedFromANNODE(em.nonce, em.data, $json.senderPublicKey);
        console.log(msg);
        return msg;
    }


    /**
     * altFundBoost
     */
    altFundBoost = function($index, $annies, $to_s) {
        return;
    }


    /**
     * return account in json
     * .annies,
     * .unconfirmedBalanceNQT,
     * .forgedBalanceNQT,
     * .guaranteedBalanceNQT
     * 
     * moving away from balanceNQT instead for annies.
     * should also rename other vars as ANNIES not NQT.
     * 
     * TO DO: UPDATE THIS WITH NEW SCAT BALANCE FEATURE I BUILT ON L1.
     * MEH.
     *
     * @param {string}
     * @param {boolean}
     * @author {Mr.Scatman}
     */
    checkBalance = async ($nid)=> {
        var json = await ANNE.API.getBalance($nid);
        var nObj = MEMG.getOrMakeIfNew($nid);
        var balanceObj = {balance:0, annies:0, annecoin:0};
        nObj.balanceObj = balanceObj;

        if (json) {
            if (json.annies!=undefined) {   //we should be using .annies now.
                json.annecoin = json.annies/100;
                nObj.balanceObj = json;
            }
            else return nObj.balanceObj;
        
            //this is activated
            if (json.activated=="y") {
                nObj.activated=true;
            }
            else nObj.activated=false;
            return nObj.balanceObj;
        }
        else return nObj.annies;
    }
    

    /**
     * Get balance from an annode.
     * 
     * @author {Mr.Scatman}
     */ 
    getOurBalance = async()=> {
        USER._userNObj.balanceObj = await this.checkBalance(USER._userNObj.nid);
        await USER.updateLastBalance(); //wallet handling
        if (USER._userNObj.balanceObj.annies!=undefined) {
            var newspan = ANNE.GUI_STUFF.formatANNIES_to_ANNECoin(USER._userNObj.balanceObj.annies);
            var els = document.querySelectorAll(".balance-updatable").forEach(el=> {
                el.innerHtml=newspan;
            });
        }
        return USER._userNObj.balanceObj;
    }


    
    /**
     * Manage an balanceObjOTHER for the user (or another neuron)
     * This will optimize our attempts to lookup balance changes on an alt-chain.
     * 
     * aoe_balance is the full AOE unit balance.  ie, 2.3 BTC, or 100.5 SIGNA or 10.3 BCH.
     * balance is the balance used on the chain for lowest unit of measure,  ie  230M sats, or 10.05B planck  etc 
     * @param {*} $nid 
     * @param {*} $ticker 
     * @returns 
     */
     makeAltBalanceObj = async($for_anne_user, $uniqueID, $ticker="SIGNA", $lastUsedURI="")=> {    
        if (ANNE.UTILS.isset($for_anne_user)==false || ANNE.UTILS.isset($uniqueID)==false) {
            return;
        }
        var alt_balances = await this.getOrMakeNewAltBalanceObj(null, $ticker, $for_anne_user, $uniqueID, $lastUsedURI);
        return this.getAltBalance(alt_balances, $ticker, $uniqueID)
    }


    /**
     * 
     * @param {*} $uri 
     * @param {*} $nid 
     * @returns 
     */
    getAcctByUri=async($uri, $nid)=> {
        var anne_history = await this._getHistory();
        var keys = Object.keys(anne_history);
        for (var k=0; k < keys.length; k++) {
            var uri = keys[k];
            if (uri!=$uri) continue;
            
            var uriUserObj = anne_history[uri];
            var keys2 = Object.keys(uriUserObj.users);
            for (var k2=0; k2 < keys2.length; k2++) {
                var k2nid = keys2[k2];
                if (k2nid!=$nid) continue;
                return uriUserObj;
            }
        }
        return null;
    }


    /**
     * Get all the user accounts stored in this EXT.
     * The user has chosen to manage verious accounts in ANNE.
     * They can be all ANNE coin accts or some AOE account (Assets of Exchange).. aka, other chains.
     * 
     * @returns {Array}
     */
    getAccounts=async()=>{
        var anne_history = await this._getHistory();
        //console.log(anne_history);
        //get the alt balances object out of mem.
        var alt_balances = await this.getAltBalances(this._userNObj.nid);

        //default the signa acct.. (unqiueID is equal to the ANNE ID)
        //if (alt_balances==null && $bDEFAULTSIGNAONNONE==true) {
            //alt_balances = await this.getOrMakeNewAltBalanceObj(null, "SIGNA", USER._userNObj.nid, USER._userNObj.nid, "");
        //}

        this._userNObj.alt_balances = alt_balances;

        var accts = [];

        //iterate the ANNE history.  Theese are by   key:nodeUri.. then .users  key: nid
        //we will create NEW objects for them to make this standard on the way out for the accts page.
        var keys = Object.keys(anne_history);
        var anne_user_nids = [];
        for (var k=0; k < keys.length; k++) {
            var uri = keys[k];
            if (uri=="default_unlock_pw") continue;
            
            var uriUserObj = anne_history[uri];
            if (uriUserObj.users==undefined) continue;
            var keys2 = Object.keys(uriUserObj.users);
            for (var k2=0; k2 < keys2.length; k2++) {
                var k2nid = keys2[k2];
                if (anne_user_nids.indexOf(k2nid)!=-1) continue;
                var k2uo = uriUserObj.users[k2nid];
                var acct_obj = {};
                acct_obj.annies=k2uo.last_known_annies; 
                acct_obj.aoe_balance=0;
                if (ANNE.UTILS.isset(k2uo.last_known_annies)==true) {
                    acct_obj.aoe_balance=parseInt(k2uo.last_known_annies)/ANNE.ANNE_TO_ANNIES;
                }
                else acct_obj.aoe_balance=0;
                acct_obj.for_anne_user=k2nid;
                acct_obj.uniqueID=k2nid; 
                acct_obj.ticker="ANNE"; 
                acct_obj.pref_uri="", 
                acct_obj.nickname=k2uo.nickname;
                acct_obj.last_block_checked=-1;
                acct_obj.encrypted_wif="";
                acct_obj.encrypted_pk="";
                acct_obj.encrypted_seed="";
                acct_obj.activated=k2uo.activated;
                accts.push(acct_obj);
                anne_user_nids.push(k2nid);
            }
        }


        //iterate each key in the alt_accts.  They will be by ticker.  There could be multiple accts per ticker.
        //put those all into a single accts obj array we will return out. 
        if (alt_balances==null) return accts;
        
        var keys = Object.keys(alt_balances);
        for (var k=0; k < keys.length; k++) {
            var ticker = keys[k];
            var tickerObj = alt_balances[ticker];
            var keys2 = Object.keys(tickerObj);
            for (var k2=0; k2 < keys2.length; k2++) {
                var uniqueID = keys2[k2];
                var acctObj = tickerObj[uniqueID];
                accts.push(acctObj);
            }
        }

        return accts;
    }




    /**
     * Get or make a new Alt balance object.  
     * If know alt_balances is passed in, check for and create it too.
     * @param {Object} $alt_balances 
     * @param {String} $ticker 
     * @param {String} $for_anne_user - nidlong string 
     * @param {String} $uniqueID 
     * @param {String} $pref_uri 
     * @returns {Object}
     */
    getOrMakeNewAltBalanceObj=async($alt_balances, $ticker, $for_anne_user, $uniqueID, $pref_uri="")=>{
        var nObj = MEMG.getNeuronByNid($for_anne_user);
        var alt_balances = $alt_balances;
        if ($alt_balances==null) alt_balances = {};

        if (ANNE.UTILS.isset(alt_balances)==false) {
            alt_balances =  await this.getAltBalances($for_anne_user);
            if (ANNE.UTILS.isset(alt_balances)==false) alt_balances = {};
        }

        if (ANNE.UTILS.isset(alt_balances[$ticker])==true) {
            var tickerObj = alt_balances[$ticker];
            nObj.alt_balances = alt_balances;
            if (tickerObj[$uniqueID]!=undefined) return tickerObj[$uniqueID];
        }

        var altBalObj = {
            balance:0, 
            aoe_balance:0, 
            for_anne_user:$for_anne_user,
            uniqueID:$uniqueID, 
            ticker:$ticker, 
            pref_uri:$pref_uri, 
            nickname:"",
            last_block_checked:0,
            encrypted_wif:"",
            encrypted_pk:"",
            encrypted_seed:"",
            activated:false
        };
        
        //within each nid then organized by ticker.
        var tickerObj = {};
        alt_balances[$ticker] = tickerObj;
        tickerObj[$uniqueID] = altBalObj;

        await this.setAltBalances(alt_balances);
        nObj.alt_balances = alt_balances;
        return alt_balances;
    }



    /**
     * get a specific alt balance by ticker and unique ID
     * @param {*} $alt_balances 
     * @param {*} $ticker 
     * @param {*} $uniqueID 
     */
    getAltBalance=function($alt_balances, $ticker, $uniqueID) {
        if (ANNE.UTILS.isset($alt_balances)==false) return null;
        if (ANNE.UTILS.isset($alt_balances[$ticker])==false) return null;
        var tickerObj = $alt_balances[$ticker];
        if (ANNE.UTILS.isset(tickerObj[$uniqueID])==false) return null;
        return tickerObj[$uniqueID];
    }


    /**
     * An alt balance updated.
     * Save it in localStorage.
     * @param {*} $nid 
     * @returns 
     */
    updateAltBalanceObj=async($nid)=>{
        var nObj = MEMG.getNeuronByNid($nid);
        if (ANNE.UTILS.isset(nObj.alt_balances)==false) return;
        return await this.setAltBalances(nObj.alt_balances);
    }
    setAltBalances=async($altBalances)=>{
        console.log($altBalances);
        var alt_balances = {};
        alt_balances.alt_balances = $altBalances;
        localStorage.setItem('alt_balances', JSON.stringify(alt_balances));
        return;
    }
    getAltBalances=async($nid)=>{
        var nObj = MEMG.getNeuronByNid($nid);
        if (ANNE.UTILS.isset(nObj.alt_balances)==true) return nObj.alt_balances;
        var alt_balances = localStorage.getItem('alt_balances');
        if (ANNE.UTILS.isset(alt_balances)==false) return null;
        return JSON.parse(alt_balances).alt_balances;
    }


    /**
     * @author {Mr.Scatman}
     */
    _getHistory=async()=> {
        var history = localStorage.getItem('ANNE_history');
        if (history!=undefined && history!=null) {
            var history_LS = JSON.parse(history);
            if (history_LS!=undefined & history_LS!=null) return history_LS;
        }
        return {};
    }

    /**
     * Check for login in extension scope.                                             
     * 
     * @author {Mr.Scatman}
     */
    __checkLoginFromEXTScope=async()=> {
        console.log("%c ANNE.NETWORK w/ annode: "+ANNE._annodesLS.last_uri, 'background: green; color: white');
        var history = localStorage.getItem('ANNE_history');
        if (history!=undefined && history!=null) {
            var hObj = JSON.parse(history);
            if (hObj!=undefined && hObj==null) hObj = {};
            var uObj = hObj[ANNE._annodesLS.last_uri];
            if (uObj!=undefined && uObj!=null && uObj.users!=undefined && uObj.users!=null) {
                var users = uObj.users;
                var loggedOut = uObj.loggedOut;
                if (loggedOut!=undefined && loggedOut==true) {
                    var retObj = {status:'ok', func:"check_login", fromclaim:"annelocalstorage", results:{loggedout:true, annode_uri:ANNE._annodesLS.last_uri, users:users}};
                    return users;
                }
                var keys = Object.keys(users);
                var winner = null;
                var max_lt = -1;
                for (var k=0; k < keys.length; k++) {
                    var key = keys[k];
                    var user = users[key];
                    delete user.user_pw;
                    var last_time = user.last_time;
                    if (last_time==undefined) last_time=0;
                    if (last_time > max_lt) {
                        max_lt = last_time;
                        winner = user;
                    }
                }
                if (winner) {
                    return [winner];
                }
            }
        }
        return [];
    }


    /**
     * 
     * We are converting to an EXT based wallet. 
     * These return objs are irrelevant now.  Will leave them in 
     * in case the wallet is edited to allow outside apps to interact.
     * For now I am not focused on that but it shouldn't be a big deal.
     * @author {Mr.Scatman}
     */
     __saveHashInEXTScope=async($user)=> {
        var keys = Object.keys($user);
        delete $user.user_pw;
        if (keys.indexOf("encrypted")==-1 || $user.public_nid==undefined || $user.public_nid=="") {
            return {status:"bad", func:"set_hash", fromclaim:"annelocalstorage", results:{msg: "missing data"}};
        }
        var ANNE_LS = {};
        ANNE_LS.user = $user;

        //we will sort by time in the default app.
        $user.last_time = new Date().getTime();

        //update the history of used logins on this annode.
        if (ANNE._annodesLS!=undefined) await this.updateHistory($user, ANNE._annodesLS.last_uri);

        localStorage.setItem('ANNE', JSON.stringify($user));
        
        return {status:'ok', func:"set_hash", fromclaim:"annelocalstorage", results:{msg:""}};
    }


    /**
     * 
     * @param {*} $user 
     * @param {*} $bDEFAULTNID 
     * @returns 
     */
    getBestUserAcctName=function($user, $bDEFAULTNID=false) {
        if ($user==null) return "";
        var nObj = MEMG.getOrMakeIfNew($user.public_nid);
        if ($user.nickname!=undefined && $user.nickname!="") return $user.nickname;
        if (nObj.text!="") return nObj.text;
        if ($bDEFAULTNID==true) return nObj.nid;
        return "";
    }


    /**
     */
    getDefaultName=function($default="") {
        if (USER._userLS.nickname!=undefined && USER._userLS.nickname!="") return USER._userLS.nickname;
        if (USER._userNObj.text!="") return USER._userNObj.text;
        if ($default!="") return $default;
        return USER._userNObj.nid;
    }


    /**
     * user is flipping between accounts.
     * we have their pw, but we need to reload the ANNE localStorage & their seedObj.
     * @author {Mr.Scatman}
     */
    loadAccount=async($nid)=>{
        
        ANNE.USER.seedObj = null;
        ANNE.USER.privKey = null;
        ANNE.USER.pubKey = null;

        var history = await ANNE.USER._getHistory();
        var thisAnnodeHistory = history[ANNE._annodesLS.last_uri];
        var users = thisAnnodeHistory.users;
        if (users!=undefined) {
            var keys = Object.keys(users);
            for (var k=0; k < keys.length; k++) {
                var key = keys[k];
                if (key!=$nid) continue;
                var user = users[key];

                USER.public_nid = user.public_nid;
                USER.pubKey = user.pubKey;
                if (user.encrypted.length && user.count!=-1) {
                    if (ANNE.API._AAUTH!=null) user.aauth = ANNE.API._AAUTH;
                    localStorage.setItem('ANNE', JSON.stringify(user));  
                    if (user.aauth!=undefined) ANNE.API.setAAUTHFromLS(user.aauth);
                }   

                if (ANNE.MEM) {
                    USER._userNObj = ANNE.MEM.addInUserNeuron(user.public_nid, true);
                }
                USER._userNObj.my_sponsored=[];
                USER._userNObj.mine=true;
                USER._userLS = user; 

                if (ANNE.BRAIN!=null) ANNE.BRAIN.setPrimarySpeaker(user.public_nid);

                await ANNE.MEMP.__postLoginCleanup();

                USER.updateLSNickname(USER._userNObj);

                USER.seedObj = null;
                USER.unlock_pw = "";
                USER.lockExt(null);
            }
        }
    }
    

    /**
     * 
     * @param {*} $nid 
     * @returns 
     */
    getNotYetActivatedAcctsFromThisAppPubKey = async($nid)=>{
        var history = await ANNE.USER._getHistory();
        var keys = Object.keys(history);
        for (var k=0; k < keys.length; k++) {
            var uri = keys[k];
            var users = history[uri].users;
            var keys2 = Object.keys(users);
            for (var k2=0; k2 < keys2.length; k2++) {
                var key2 = keys2[k2];
                if (key2==$nid) {
                    var user = users[key2];
                    if (user.pubKey!=undefined && user.pubKey!=null) {
                        if (user.activated==false) return user.pubKey;
                    }
                }
            }
        }
        return null;
    }


    /**
     * Get users array for annode endpoint,
     * not key/associated based array.
     * @author {Mr.Scatman}
     */
    getUserArrByAEP=async($aep)=> {
        var history = await ANNE.USER._getHistory();
        var thisAnnodeHistory = history[$aep];
        var users = thisAnnodeHistory.users;
        var arrUsers = [];
        if (users!=undefined) {
            var keys = Object.keys(users);
            for (var k=0; k < keys.length; k++) {
                var key = keys[k];
                var user = users[key];
                arrUsers.push(user);
            }
        }
        return arrUsers;
    }

    /**
     * Update history in local storage.
     * 
     * This will support the user's ability to swap between identities
     * and use the default ANNE wallet with ease.
     *
     * @author {Mr.Scatman}
     */
     updateHistory = async ($user, $annode_uri)=> {
        var history = localStorage.getItem('ANNE_history');
        var hObj = JSON.parse(history);
        delete $user.user_pw;
            
        //console.log(" $annode_uri "+ $annode_uri);

        //no history object make it
        if (hObj==undefined || hObj==null) {
            hObj = {};
            var users = {};
            users[$user.public_nid]=$user;
            hObj[$annode_uri]={'users':users,'loggedOut':false};
            localStorage.setItem('ANNE_history', JSON.stringify(hObj));
            return;
        }

        var thisAnnodeHistory = hObj[$annode_uri];
        
        //we have history, but not this annode_uri yet
        if (thisAnnodeHistory==undefined || thisAnnodeHistory==null) {
            var users = {};
            users[$user.public_nid]=$user;
            hObj[$annode_uri] = {'users':users, 'loggedOut':false};
            localStorage.setItem('ANNE_history', JSON.stringify(hObj));
            return;
        }

        var users = thisAnnodeHistory.users;

        //we have this annode_uri but no users..
        if (users==undefined || users==null) {
            var users = {};
            users[$user.public_nid]=$user;
            hObj[$annode_uri] = {'users':users, 'loggedOut':false};
            localStorage.setItem('ANNE_history', JSON.stringify(hObj));
            return;
        }

        var user = users[$user.public_nid];

        for (var u=0; u < users.length; u++) {
            delete users[u].user_pw;
        }

        //we have users but not THIS user.
        if (user==null || user==undefined) {
            users[$user.public_nid]=$user;
            hObj[$annode_uri]={users:users, 'loggedOut':false};
            localStorage.setItem('ANNE_history', JSON.stringify(hObj));
            return;
        }
         
        //we have this user, but update it to the most recent value.
        else {
            users[$user.public_nid]=$user;
            hObj[$annode_uri]={users:users, 'loggedOut':false};
            localStorage.setItem('ANNE_history', JSON.stringify(hObj));
            return;
        }
    }


    /**
     * Destruction of current account in data wallet.
     * @author Mr.scatman
     */
     destroyAccount=async($nid)=> {
        localStorage.removeItem("ANNE");        //log us out of this account.
        if ($nid!=USER._userNObj.nid) {
            console.log("u can only destroy an acct you are logged into to"); 
            return;
        }
        var history = localStorage.getItem('ANNE_history');
        var hObj = JSON.parse(history);
        if (hObj==undefined) return;
        var thisAnnodeHistory = hObj[ANNE._annodesLS.last_uri];
        if (thisAnnodeHistory==undefined) return;
        var users = thisAnnodeHistory.users;
        if (users==undefined) return;
        var user = users[USER._userNObj.nid];
        if (user==undefined) return;
        delete users[USER._userNObj.nid]; //delete the user out.
        USER.seedObj = null;
        USER._userLS = null;
        USER._userNObj = null;

        //update the hObj.
        localStorage.setItem('ANNE_history', JSON.stringify(hObj));
        return;
    }


    /**
     * Even if a rogue actor comes to a computer with the ext open,
     * and it is locked...
     * and they alter JS code in chrome to enact unlocking and use of the ext..
     * The seedObj is not set nor is the unlock_pw ---- so no seeds will be exposed
     * or able to be decrypted.  The user account is safe.
     * @author Mr.scatman
     */
    lockExt = async()=> {
        this.seedObj = null;
        this.unlock_pw = "";
        await PAGES.openPage("locked");
        PAGES.bLOCKED = true;//redundant.`
    }


    /**
     * Total destruction of data wallet.
     * @author Mr.scatman
     */
    nukeAllDataFromBrowserMem = async()=>{
        localStorage.removeItem("ANNE");
        localStorage.removeItem("ANNE_history");
        return;
    }



    //WHAT IS THIS>>>>>>>>>>>>>>?????

    
    /**
     * 
     * @author Mr.scatman
     * //nukeAllDataFromBrowserMem
     */
    logoutThisAccount = async()=> {
        localStorage.removeItem("ANNE");
        await this.logoutAccountByAnnode(ANNE._annodesLS.last_uri);
        location.reload();  // refresh page/app
    }
    logoutAccountByAnnode = async($annode_uri)=> {
        var history = localStorage.getItem('ANNE_history');
        var hObj = JSON.parse(history);
        if (hObj==undefined || hObj==null) return;
        var thisAnnodeHistory = hObj[$annode_uri];
        if (thisAnnodeHistory==undefined || thisAnnodeHistory==null) return;
        thisAnnodeHistory.loggedOut=true;
        localStorage.setItem('ANNE_history', JSON.stringify(hObj));
    }

}

const USER = new user_master ();