class anne_utils extends anne_singleton {
    constructor(){
        super(false);
	}

    quickAbbreviateName = function($text) {
        $text =  $text.trim();
        if ($text.length<10) return $text;
        const suffix = ["jr", "jr.", "sr", "sr.", "iii", "ii", "iv", "i", "v", "vi", "vii", "viii", "ix"];
        var parts = $text.split(" ");

        if (parts.length==2 && $text.length<17) return $text;

        var abbr = "";
        var first = "";
        var lastpart = parts[parts.length-1];
        var addsuffix = "";
        var pmax = parts.length;

        if (suffix.indexOf(lastpart.toLowerCase())!=-1) {
            addsuffix = lastpart;
            pmax = pmax-1;
        }

        for (var p=0; p < pmax; p++) {
            if (p==0) {
                abbr+=parts[p][0];
                first=parts[p];
            }
            else if (p < pmax-1){
                abbr+=parts[p][0]; //JD Rockfeller Jr
            }
            else if (p==(pmax-1)) abbr+=" "+parts[p];
            
        }
        return abbr;
    }

    stripAllNonAlphaChar=function($str, $charSlot) {
        var char = $str[$charSlot];
        if("abcdefghijklmnopqrstuvwzyz".indexOf(char)==-1) {
            $str = $str.substring(1);
            return this.stripAllNonAlphaChar($str, $charSlot);
        }
        return $str;
    }
    stripNonAlphaNum = function($str) {
        return this.stripNonIn($str, "abcdefghijklmnopqrstuvwzyz1234567890");
    }

    isMixedCase = function($str) {
        return /[a-z]/.test($str) && /[A-Z]/.test($str);
    }

    /**
     * note to self: comment this so i remember what it is.
     * @param {*} $str 
     * @param {*} $ifstr 
     * @returns 
     */
    extractNumberIf = async($str, $ifstr)=>{
        if ($str.indexOf($ifstr)!=-1) {
            if ($afterONLY==true) {
                var i = $str.indexOf($ifstr)+$ifstr.length;
                var newstr = $str.substr(i);
                return this.extractNumber($str);
            }
            else {
                return this.extractNumber($str);
            }
        }
        return null;
    }

    isSameYear = function ($nObj1, $nObj2) {
        var year1 = -1;
        var year2 = -1;
        
        if ($nObj1.bes.indexOf(ANNE.MEM.integer.temp_nid)!=-1) year1 = parseInt($nObj1.text);
        else {
            var year_relon = ANNE.MEM.getHasRelon($nOb1.outs, MEM.year.temp_nid);
            if (year_relon!=null) {
                var yearNOBJ = MEMG.getNeuronByNid(year_relon.to_s);
                if (yearNOBJ!=null) year1 = parseInt(yearNOBJ.text);
            }
        }

        if ($nObj2.bes.indexOf(ANNE.MEM.integer.temp_nid)!=-1) year2 = parseInt($nObj2.text);
        else {
            var year_relon = ANNE.MEMG.getHasRelon($nObj2.outs, MEM.year.temp_nid);
            if (year_relon!=null) {
                var yearNOBJ = MEMG.getNeuronByNid(year_relon.to_s);
                if (yearNOBJ!=null) year2 = parseInt(yearNOBJ.text);
            }
        }

        if(year1!=-1 && year2!=-1 && year1==year2) return true;
        return false;
        
    }


    extractNumber2 = async($str, $pmax=-1)=> {
        var parts = $str.split(/[\s-]+/);
        if (parts.length>0) {
            if ($pmax>-1 && parts.length>$pmax) return null;
            for (var p=0; p < parts.length; p++) {
                var part = parts[p];
                if (part=="") continue;
                if (ANNE.UTILS.isNum(part)==true) {
                    const ordinalRegex = /(st|nd|rd|th)$/;
                    let strippedNumber = part.replace(ordinalRegex, '');
                    let number = parseInt(strippedNumber, 10);
                    var numNOBJ = await MEMG.getOrMakeIfNewInteger(null, number);
                    if (numNOBJ!=null) {
                        parts.splice(p, 1);
                        return {nObj:numNOBJ, str:part, remaining:parts.join(" ")};
                    }
                    break;
                }
            }
        }
        return null;
    }


    extractNumber = async($str, $pmax=-1)=> {
        var parts = $str.split(/[\s-]+/);
        if (parts.length>0) {
            if ($pmax>-1 && parts.length>$pmax) return null;
            for (var p=0; p < parts.length; p++) {
                var part = parts[p];
                if (part=="") continue;
                if (ANNE.UTILS.isNum(part)==true) {
                    const ordinalRegex = /(st|nd|rd|th)$/;
                    let strippedNumber = part.replace(ordinalRegex, '');
                    let number = parseInt(strippedNumber, 10);
                    var numNOBJ = await MEMG.getOrMakeIfNewInteger(null, number);
                    if (numNOBJ!=null) {
                        return numNOBJ;
                    }
                    break;
                }
            }
        }
        return null;
    }

    extractNumberStr = async($str, $pmax=-1)=> {
        var parts = $str.split(/[\s-]+/);
        if (parts.length>0) {
            if ($pmax>-1 && parts.length>$pmax) return null;
            for (var p=0; p < parts.length; p++) {
                var part = parts[p];
                if (part=="") continue;
                if (ANNE.UTILS.isNum(part)==true) {
                    const ordinalRegex = /(st|nd|rd|th)$/;
                    let strippedNumber = part.replace(ordinalRegex, '');
                    let number = parseInt(strippedNumber, 10);
                    return number+"";
                }
            }
        }
        return "";
    }


    replaceWeirdLetters = function($str) {
        const regex = /[À-ÖØ-öø-ÿ]/g;
        const AtoZ = {
          À: "A",
          Á: "A",
          Â: "A",
          Ã: "A",
          Ä: "A",
          Å: "A",
          Æ: "AE",
          Ç: "C",
          È: "E",
          É: "E",
          Ê: "E",
          Ë: "E",
          Ì: "I",
          Í: "I",
          Î: "I",
          Ï: "I",
          Ð: "D",
          Ñ: "N",
          Ò: "O",
          Ó: "O",
          Ô: "O",
          Õ: "O",
          Ö: "O",
          Ø: "O",
          Ù: "U",
          Ú: "U",
          Û: "U",
          Ü: "U",
          Ý: "Y",
          Þ: "TH",
          ß: "ss",
          à: "a",
          á: "a",
          â: "a",
          ã: "a",
          ä: "a",
          å: "a",
          æ: "ae",
          ç: "c",
          è: "e",
          é: "e",
          ê: "e",
          ë: "e",
          ì: "i",
          í: "i",
          î: "i",
          ï: "i",
          ð: "d",
          ñ: "n",
          ò: "o",
          ó: "o",
          ô: "o",
          õ: "o",
          ö: "o",
          ø: "o",
          ù: "u",
          ú: "u",
          û: "u",
          ü: "u",
          ý: "y",
          þ: "th",
          ÿ: "y",
        };
        var result = $str.replace(regex, (match) => AtoZ[match]);
        console.log(result); // Output: "AAA EEE III OOO UUU"
        return result;
    }


    containsTXID=function($rels, $txid) {
        for (var r=0; r <$rels.length; r++) {
            if ($rels[r].txid==$txid) return true;
        }
        return false;
    }
    

    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    fixHack=function($str=null, $replace_underscores="") {
        if ($str==undefined || $str==null || typeof $str !="string") {
            console.log("don't call this, sir, and non-existant $str");
            return "";
        }

        //dont muck with date looking strings.
        var aParts = $str.split("-");
        if (aParts.length>=2) {
            var numbtest = parseInt($str.replaceAll("-", ""));
            if (numbtest > 0) {
                var parenObj = ANNE.UTILS.stripParens($str);
                console.log(parenObj);
                return parenObj;
            }
        }
        
        $str = $str.replaceAll("-2D","-");
        $str = $str.replaceAll("-28", "(");
        $str = $str.replaceAll("-29", ")");

        //too tired to chase it.  lazy kill
        //we already yank info from wikispooks in a hacky non rdf way..
        //so it comes with drama
        var apostrophe = $str.indexOf("-27");
        if (apostrophe!=-1 && apostrophe!=0 && apostrophe!=$str.length-1) {
            $str = $str.replaceAll("-27", "'");
        }
        
        var fix = $str.indexOf("-28unidentified-29");
        if (fix!=-1 && fix!=0) {
            $str = $str.replaceAll("-28unidentified-29", "");
        }

        $str = $str.replaceAll("-26", "&");
        $str = $str.replaceAll("27-", "");

        var parenObj = ANNE.UTILS.stripParensMulti($str);

        if ($replace_underscores!="") {
            parenObj.str = parenObj.str.replaceAll("_", $replace_underscores).trim();
        }
        else parenObj.str.trim();
        
        //console.log(parenObj);
        return parenObj;
    }

    
    blowOutAmpersands = function($arr) {
        var finalArray = [];
        for (var a=0; a < $arr.length; a++) {
            var val = $arr[a];
            if (val.indexOf("&")==-1) finalArray.push(val);
            else {
                var parts = val.split(" & ");
                for (var p=0; p < parts.length; p++) {
                    var val2 = parts[p].trim();
                    if (finalArray.indexOf(val2)==-1) finalArray.push( parts[p].trim() );
                }
            }
        }
        return finalArray;
    }


    //bob and suzy smith
    //s.b.  "bob smith", "suzy smith"
    extrapAmperStr = function($str) {
        var parts = $str.split(" & ");
        if (parts.length==1) part2 = $str.split(" and ");
        if (parts.length!=2) return null;
        
        var last_part = parts[ parts.length-1];
        var first_part = parts [0];
        if (last_part.split(" ").length > first_part.split(" ").length) {
            var last = last_part.split(" ");
            var last_name = last [ last.length-1];
            var first_person = first_part+" "+last_name;
            return [first_person, last_part];
        }
        return null;
    }

    /**
     * Strips a string of its paren and returns the new string with the stripped value in the context.
     * @param {*} $str 
     * @returns 
     */
    stripParens = function($str){
        const regex = /\s?\(([^)]+)\)/;
        var match = $str.match(regex);
        var newStr = $str.replace(/\s?\([^)]+\)/, '');
        var context = "";
        if (match && match.length>0) context = match[1];
        if (newStr==null || newStr=="" || newStr.length==0) newStr = $str;
        return {str:newStr.trim(), context:context};
    }


    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    prepNakeSearch = function($str) {
        var pOBJ = this.stripParens($str);
        pOBJ.inputStr = $str;
        const inputString = pOBJ.str;
        const regexPattern = /(['"])(.*?)\1/;

        let QUOTED = false;
        let extractedString = '';

        const match = inputString.match(regexPattern);
        if (match) {
            QUOTED = true;
            extractedString = match[2]; 
        }

        if (QUOTED==true) {
            pOBJ.bEXACT=true;
            pOBJ.str = extractedString;
        }
        else pOBJ.bEXACT=false;

        console.log("naked search:", pOBJ);
        return pOBJ;
    }


    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    stripParensMulti=function($str) {
        const regex = /\(([^)]+)\)/;
        const match = $str.match(regex);
        let newStr = $str.replace(/\([^)]+\)/, '');
        let context = [];
        if (match && match.length > 0) {
            context = match[1].split(',').map(item => item.trim());
        }
        if (newStr == null || newStr == "" || newStr.length == 0) {
            newStr = $str;
        }
        return {str: newStr.trim(), context: context};
    }


    /**
     * 
     * @param {*} $str 
     * @param {*} $stripifnotthis 
     * @returns 
     */
    stripNonIn=function($str, $stripifnotthis) {
        var newstr = $str.concat();
        for (var a=0; a < newstr.length; a++)  {
            var chara = newstr[a];
            if ($stripifnotthis.indexOf(chara)==-1) {
                newstr.slice(a, 1);
                a--;
            }
        }
        return newstr;
    }


    /**
     * For testing purposes, the firstseen datestamp marks
     * when the annode first saw a relon.
     * 
     * If the relon was in the mempool (time/block=-1) but the annode restarted..
     * and the relon never made it back to the mempool...
     * 
     * We have a faux relon in our localDB that the ANNE network doesn't actually know
     * about.  Our annode may know of it, but the the network does not.
     * 
     * We need to fix our indexDB.
     * 
     * We need to solve this problem in the annode as well.
     * Shutdown mid-mempool will leave neuron indexes created, neurons froze, etc..
     * which will reject the next attempt to create the same neuron indexes
     * (and will actually resolve the nid index conflict by creating a new one)
     * 
     * This will be a HUGE problem as that annode will be out of concensus.
     * @param {*} $sec 
     * @returns 
     */
    shouldBeMined = function($sec) {
        var se = this.timeElapsed($sec);
        if (se > 600) return true;
        return false;
    }

    timeElapsed = function($secs) {
        var currentTimestamp = Date.now();
        var timeElapsed = currentTimestamp - parseInt($secs);
        var secondsElapsed = Math.floor(timeElapsed / 1000);
        console.log("Time elapsed in seconds: " + secondsElapsed);
        return secondsElapsed;
    }


    secsElapsedToDHMS = function($secs) {
        const secmin = 60;
        const minshr = 60;
        const sechr = secmin*60;
        const secsday = sechr*24;
        var hrsday = 24;
        var minutes = Math.floor($secs/60);

        if (minutes > secmin) {
            var hours = Math.floor(minutes/60);
            if (hours > hrsday) {
                var days = Math.floor(hours / hrsday);
                var hrs_left = hours - (days*hrsday);
                var mins_left = minutes % 60;
                var secs_left = $secs % 60;
                var dayswd = ANNE.TALK.pluralizeNounIf(days, "day", "s");
                var hrswd = ANNE.TALK.pluralizeNounIf(hrs_left, "hr", "s");
                var minswd = ANNE.TALK.pluralizeNounIf(mins_left, "min", "s");
                var secsswd = ANNE.TALK.pluralizeNounIf(secs_left, "sec", "s")
                return days+dayswd+" "+hrs_left+hrswd+" "+mins_left+minswd+" "+secs_left+secsswd;
            }
            else {
                hours = Math.floor(hours);
                var mins_left = minutes % 60;
                var secs_left = $secs % 60;
                var hrswd = ANNE.TALK.pluralizeNounIf(hours, "hr", "s");
                var minswd = ANNE.TALK.pluralizeNounIf(mins_left, "min", "s");
                var secsswd = ANNE.TALK.pluralizeNounIf(secs_left, "sec", "s");
                return hours+hrswd+" "+mins_left+minswd+" "+secs_left+secsswd;
            }
        }
        else if (minutes > 0) {
            var minswd = ANNE.TALK.pluralizeNounIf(mins_left, "min", "s");
            var secsswd = ANNE.TALK.pluralizeNounIf($secs % 60, "sec", "s")
            return minutes +minswd+" "+($secs % 60)+secsswd;
        }
        else {
            var secsswd = ANNE.TALK.pluralizeNounIf($secs, "sec", "s")
            return $secs+secsswd;
        }
    }


    capFirstLetters = function($str) {
        var wds = $str.split(" ");
        for (var p=0; p < wds.length; p++) {
            wds[p] = wds[p][0].toUpperCase() + wds[p].substr(1);
        }
        return wds.join(" ");
    }

    concatUniqueNObjs=function($a1, $a2) {
        if ($a1.length==0) return $a2;
        if ($a2.length==0) return $a1;
        var a_temp_nid_list=[];
        for (var a=0; a < $a1.length; a++) {
            a_temp_nid_list.push($a1[a].temp_nid);
        }
        var a2_uniques = [];
        for (var a2=0; a2 < $a2.length; a2++) {
        var a2_temp_nid = $a2[a2].temp_nid;
            if (a_temp_nid_list.indexOf(a2_temp_nid)!=-1) continue;
            a2_uniques.push($a2[a2]);
        }
        return $a1.concat(a2_uniques);
    }


    copyToClipboard=function($str) {
        var el = document.createElement('textarea');
        el.value = $str;
        el.setAttribute('readonly', '');
        el.style = {position: 'absolute', left: '-9999px'};
        document.body.appendChild(el);
        el.select();
        document.execCommand('copy');
        document.body.removeChild(el);
    }

    concatUniqueRels = function ($arr1, $arr2) {
        var txids = [];
        var rels = [];
        for (var t=0; t < $arr1.length; t++) {
            var txid = $arr1[t].txid;
            if (txids.indexOf(txid)==-1) {
                txids.push(txid);
                rels.push($arr1[t]);
            }
        }
        for (var t=0; t < $arr2.length; t++) {
            var txid = $arr2[t].txid;
            if (txids.indexOf(txid)==-1) {
                txids.push(txid);
                rels.push($arr2[t]);
            }
        }
        return rels;
    }
    

    convertToCSV = function ($objArray, $bGENHEADER=false) {
        var array = typeof $objArray != 'object' ? JSON.parse($objArray) : $objArray;
        var str = '';

        if ($bGENHEADER==true) {
            var keys = Object.keys(array[0]);
            var header = new Object();
            for (var k=0; k < keys.length; k++) {
                header[keys[k]]=keys[k];
            }
            array.unshift(header);
        }

        for (var i = 0; i < array.length; i++) {
            var line = '';
            for (var index in array[i]) {
                if (line != '') line += ','

                line += array[i][index];
            }
            str += line + '\r\n';
        }
        return str;
    }

    l33t_checkForce = function($str) {
        var l33ts_num = [];
        var l33ts_alpha = [];
        
        //1234567890
        //1=l
        for (var s=0; s < $str.length; s++) {
            var char = $str[s]=$str[s];
            if (char=="0") {
                l33ts_num.push("0");
                l33ts_alpha.push("O");
            }
            else if (char=="1") {
                l33ts_num.push("1");
                l33ts_alpha.push("l");
            }
            else if (char=="2") {
                l33ts_num.push("1");
                l33ts_alpha.push("l");
            }
            else {
            } 
        }

    }


    /**
     * Alpha num.
     * single spaces ok.
     */
    cleanAnorgName = function($propName) {
        var str = $propName.replace(/ +(?= )/g,'');
        var cleanstr = str.replace(/[^a-z0-9 ]/gi,'');
        return cleanstr;
    }


    cleanPropName = function($propName) {
        var b = $propName.replace(/[^a-z0-9_]/gi,'');
        if (b.match(/^\d/)==true) {
            console.log("(utils.cleanPropname) result: "+"p_"+b);
            return "p_"+b;
        }
        return b;
    }


    commas($x) {
        if ($x==undefined || $x==null) {
            console.log("huh?");
            return;
        }
        return $x.toString().replace(/\B(?=(\d{3})+(?!\d))/g,",");
    }

    estimateTimeByBlocks = function($blocksMore) {
        var minsMore = $blocksMore*2;
        var secsMore = minsMore/60;
        const currentDate = new Date();
        const futureDate = new Date(currentDate.getTime() + secsMore * 1000);
        const options = { month: 'long', day: 'numeric', year: 'numeric' };
        const formattedDate = futureDate.toLocaleDateString('en-US', options);
        console.log(formattedDate);
        return formattedDate;
    }   

    
    firstCap = function($str, $bALL=true) {
        if ($bALL==true) {
            var newstr = [];
            var parts = $str.split(" ");
            if (parts.length==1) return parts[0][0].toUpperCase()+parts[0].substring(1);
            for (var p=0; p < parts.length; p++) {
                var str = parts[p][0].toUpperCase()+parts[p].substring(1);
                newstr.push(str);
            }
            return newstr.join(" ");
        }
        else {
            var parts = $str.split(" ");
            if (parts.length==1) return parts[0][0].toUpperCase()+parts[0].substring(1);
        } 
    }


    //won't get fully spelled numbers like "one"
    isNum = function($n) {
        if (!isNaN(parseFloat($n)) && isFinite($n)==true) return true;
        const regex = /^\d+(st|nd|rd|th)?$/;
        return regex.test($n);
    }
    

    /**
     * 
     * from https://gist.github.com/tralves/9e5de2bd9f582007a52708d7d4209865
     * @param {*} bytes 
     * @returns 
     */
    frenlySize = function (bytes) {
        var thresh = 1024;
        if (Math.abs(bytes) < thresh) return bytes + ' B';
        var units = ['KB','MB','GB','TB','PB','EB','ZB','YB'];
        var u = -1;
        do {
            bytes /= thresh;
            ++u;
        } 
        while(Math.abs(bytes) >= thresh && u < units.length - 1);
        return bytes.toFixed(1)+' '+units[u];
    }



    /**
     * Calculate annex price lvl factor via nth fib.
     * 
     * could be done with matrix math but we won't be getting high lvl numbers here
     * and that optimization is just showing off.
     * this suffices.
     * 
     * DO NOT CHANGE THIS FUNCTION UNLESS YOU ALSO CHANGE THE FUNCTION ON THE ANNODE.
     * 
     * @param {*} $nth 
     * @returns 
     */
    nthFib=function($nth){
        if ($nth==1 || $nth==2) return 1;
        var seq = [1, 1];
        var nextval = 0;
        for (var n=2; n < $nth; n++) {
            nextval = seq[n-1] + seq[n-2];
            seq.push(nextval);
        }
        return nextval;
    }


    /**
     * Only 2 decimal places
     * @param {*} $annies 
     * @param {*} $gap 
     * @returns 
     */
    displayAnneValue = function($annies, $gap=" ") {
        var parts = ((parseInt($annies)/ANNE.ANNE_TO_ANNIES)+"").split(".");
        if (parts.length==2) {
            var whole = UTILS.commas(parts[0]);
            var deci = parts[1];
        }
        else if (parts.length==1) {
            if ($annies<ANNE.ANNE_TO_ANNIES) {
                var whole = 0;
                var deci = parts[0];
            }
            else {
                var whole = UTILS.commas(parts[0]);
                var deci = "0";
            }
        }
        if (deci==undefined) return whole;
        deci = deci+"";
        
        if (deci.length==2) deci = "."+$gap+deci;
        else if (deci.length==1) deci = "."+$gap+deci+"0";
        else if (deci.length==0) return whole;
        
        return whole;//+deci;
    }


    /**
     * 
     * @param {*} $val 
     * @param {*} $minDigits 
     * @returns 
     */
    formatDigits = function($val, $minDigits=4) {
         if ($val==null) {
            console.log("%cERROR val can't be null here", TALK.bgred);
            return "";
        }
        var final = $val+"";
       
        if (final.length<$minDigits) {
            var dif = $minDigits-final.length;
            for (var d=1; d <= dif; d++) { final = "0"+final; }
        }
        return final;
    }

    
    //For calculating edit distance
    editDistance = function (s1, s2) {
        s1 = s1.toLowerCase();
        s2 = s2.toLowerCase();
        var costs = new Array();
        for (var i = 0; i <= s1.length; i++) {
            var lastValue = i;
            for (var j = 0; j <= s2.length; j++) {
                if (i == 0)
                    costs[j] = j;
                else {
                if (j > 0) {
                    var newValue = costs[j - 1];
                    if (s1.charAt(i - 1) != s2.charAt(j - 1)) newValue = Math.min(Math.min(newValue, lastValue), costs[j]) + 1;
                    costs[j - 1] = lastValue;
                    lastValue = newValue;
                }
            }
        }
        if (i > 0)
            costs[s2.length] = lastValue;
        }
        return costs[s2.length];
    }


    /**
     * 
     * @param {*} $dataEl 
     * @param {*} $fileTitle 
     * @param {*} $el 
     * @param {*} $bGENHEADER 
     */
    exportJSONFileViaID=function($dataEl, $fileTitle, $el="", $bGENHEADER=true) {
        console.log("'"+$dataEl+"'");
        var jsonStringData = document.getElementById($dataEl).innerHTML;
        if (jsonStringData) {
            this.exportJSONFile(jsonStringData, $fileTitle, $el, $bGENHEADER);
        }
    }

    /**
     * 
     * @param {*} $object 
     * @param {*} $fileTitle 
     */
    exportJSONFile=function($object, $fileTitle) {
        var exportedFilenmae = $fileTitle + '.json' || 'export.json';
        var jsonstring = JSON.stringify($object);
        const bytes = new TextEncoder().encode(jsonstring);
        const json = new Blob([bytes], {
            type: "application/json;charset=utf-8"
        });

        var link = document.createElement("a");
        if (link.download !== undefined) { // feature detection
            // Browsers that support HTML5 download attribute
            var url = URL.createObjectURL(json);
            link.setAttribute("href", url);
            link.setAttribute("download", exportedFilenmae);
            link.style.visibility = 'hidden';
            var el = null;
            el = document.body;
            el.appendChild(link);
            link.click();
            el.removeChild(link);
        }
    }

    /**
     * 
     * @param {*} $dataEl 
     * @param {*} $fileTitle 
     * @param {*} $el 
     * @param {*} $bGENHEADER 
     */
    exportCSVFileViaID=function($dataEl, $fileTitle, $bGENHEADER=true) {
        console.log("'"+$dataEl+"'");
        var jsonStringData = document.getElementById($dataEl).innerHTML;
        if (jsonStringData) {
            this.exportCSVFile(jsonStringData, $fileTitle, $bGENHEADER);
        }
    }

    /**
     * 
     * @param {*} $jsonStringOrObjectArray 
     * @param {*} $fileTitle 
     * @param {*} $el 
     * @param {*} $bGENHEADER 
     */
    exportCSVFile=function($jsonStringOrObjectArray, $fileTitle,  $bGENHEADER=true) {
        var csv = this.convertToCSV($jsonStringOrObjectArray, $bGENHEADER);
        this.exportCSVFile_inner(csv, $fileTitle);
    }

    /**
     * 
     * @param {*} $csv 
     * @param {*} $fileTitle 
     */
    exportCSVFile_inner=function($csv, $fileTitle) {
        var exportedFilenmae = $fileTitle + '.csv' || 'export.csv';
        var blob = new Blob([$csv], { type: 'text/csv;charset=utf-8;' });
        if (navigator.msSaveBlob) { // IE 10+
            navigator.msSaveBlob(blob, exportedFilenmae);
        } 
        else {
            var link = document.createElement("a");
            if (link.download !== undefined) { // feature detection
                // Browsers that support HTML5 download attribute
                var url = URL.createObjectURL(blob);
                link.setAttribute("href", url);
                link.setAttribute("download", exportedFilenmae);
                link.style.visibility = 'hidden';
                var el = null;
                el = document.body;
                el.appendChild(link);
                link.click();
                el.removeChild(link);
            }
        }
    }

    posNegRand = function($fact) {
        return (Math.random()-.5)*$fact;
    }

    /**
     * 
     * @param {*} $arr 
     * @param {*} $prop 
     * @param {*} $val 
     * @returns 
     */
    findValAndRemoveInObjnArr = function ($arr, $prop, $val) {
        for (var a=0; a<$arr.length; a++) {
            if ($arr[a][$prop]==$val){
                $arr.splice(a, 1);
                return true;
            }
        }
        return false;
    }

    /**
     * 
     * @param {*} $rels 
     * @param {*} $skip_tnids 
     * @returns 
     */
    getLatest = function($rels, $skip_tnids=[]) {
        var lastValid = null;
        for (var sr=0; sr < $rels.length; sr++) {
            var rel = $rels[sr];
            if ($skip_tnids.length && $skip_tnids.indexOf(rel.r)!=-1) continue;
            if (lastValid==null) lastValid = rel;

            //if we have a bigger block height OR a 0 (indicating mempool not updated yet)
            else if ((lastValid.time) > 0 && (rel.time > 0 || rel.time==0)) {
                if (rel.time > lastValid.time) lastValid = rel;
            }

            //this has been firstseen later, meaning it is newer
            else if (lastValid.firstseen < rel.firstseen) {
                lastValid = rel;
            }
        }
        return lastValid;
    }


    /**
     * 
     * @param {*} $rels 
     * @returns 
     */
    getLastSeen = function($rels) {
        if ($rels==null) return null;
        if ($rels.length==0) return null;
        if ($rels.length==1) return $rels[0];
        var last_seen = 0;
        var lastseenRel = null;
        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            if (rel.firstseen!=undefined && rel.firstseen > last_seen) {
                lastseenRel = rel;
                last_seen = rel.firstseen;
            }
        }
        if (lastseenRel!=null) return lastseenRel;
        if ($rels.length) return $rels [ $rels.length-1 ];
    }

        
    /**
     * 
     * @param {*} $rels 
     * @param {*} $annie 
     * @returns 
     */
    getFirst = function($rels, $annie=0) {
        if ($annies>0) return this.getFirstWithGTEAnnies($rel, $annies);
        var first = null;
        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            if (first==null) first=rel;
            else if ((rel.time < first.time) || (rel.time==0 && first.time!=0)) first=rel;
            else if (rel.time==first.time) {
                if (rel.firstseen < first.firstseen) first=rel;
            }
        }
        return first;
    }


    /**
     * attemps to handle multi payments if there was underpayment.
     * will use time/first seen from the last payment in the bunch to qualify
     * the payment as being the first seen (winner) of the FCFS 
     * 
     * @param {*} $rels 
     * @param {*} $annies 
     * @returns 
     */
    getFirstWithGTEAnnies = function($rels, $annies) {
        var first = null;
        var from_multi = new Object();

        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            var annies = rel.annies; 
            var rel_fs = rel.firstseen;
            var rel_time = rel.time;

            if (annies==undefined || annies==0) continue;
            if (annies < $annies) {
                var fm_this = from_multi[ rel.f ];
                if (fm_this==undefined) {
                    from_multi[ rel.f ] = {annies:annies, time:rel.time, firstseen:rel.firstseen, rel:rel};
                }
                else {
                    fm_this.annies += annies; 
                    if (rel.time > fm_this.time) {
                        fm_this.time = rel_time;
                        fm_this.firstseen = rel_fs;
                        fm_this.rel = rel;
                    }

                    if (fm_this.annies < $annies) continue; //no enough, still!
                }
            }

            if (first==null) first=rel;
            else if ((rel_time < first.time) || (rel_time==0 && first.time!=0)) first=rel;
            else if (rel_time==first.time) {
                if (rel_fs < first.firstseen) first=rel;
            }
        }
        return first;
    }


    /**
     * 
     * @param {*} $txt 
     * @param {*} $bDECIMALOK 
     * @returns 
     */
    inputNumberOnly = function ($txt, $bDECIMALOK=false) {
        var newString = "";
        for (var c=0; c < $txt.length; c++) {
            var charCode = $txt.charCodeAt(c);
            //console.log(charCode);
            if ($bDECIMALOK==false) {
                if (charCode < 48 || charCode> 57) continue;
                newString = newString + $txt[c];
            }
            else if ($bDECIMALOK==true) {
                if (charCode < 48 || (charCode> 57 && charCode!=190)) continue;
                newString = newString + $txt[c]; 
            }  
        }
        return newString;
    }


    /**
     */
    addUniqueRel=function($arr, $rel) {
        UTILS.addUnique($arr, "txid", $rel);
    }


    /**
     * 
     * @param {Array} $objArr 
     * @param {Array} $destination_arr 
     * @param {String} $uniqueObjProp 
     */
    addUniqueObjArray=function($objArr, $destination_arr, $uniqueObjProp="txid") {
        for (var r=0; r < $objArr.length; r++) {
            var newObj = $objArr[r];
            UTILS.addUnique($destination_arr, $uniqueObjProp, newObj);
        }
    }

    /**
     * 
     * @param {*} $arr 
     * @param {*} $tnids 
     */
    addUniqueTnids=function($arr, $tnids) {
        for (var t=0; t < $tnids.length; t++) {
            var tnid=$tnids[t];
            if ($arr.indexOf(tnid)==-1) $arr.push(tnid);
        }
    }



    /**
     * 
     * @param {Array} $arr 
     * @param {String} $uniqueProp 
     * @param {Object} $newRelon 
     * @returns 
     */
    addUnique=function($arr, $uniqueProp="txid", $newRelon) {
        if ($arr==null) return false;
        if ($newRelon==null) return false;

        if (this.findValInObjnArr($arr, $uniqueProp, $newRelon[$uniqueProp])==null) {
            $arr.push($newRelon);
            return true;
        }
        return false;
    }


    /**
     * 
     */
    deepCopy=function($obj) {
        if ($obj === null || typeof $obj !== 'object') {
            return $obj;
        }
    
        let copy = new $obj.constructor();
    
        for (let key in $obj) {
            if ($obj.hasOwnProperty(key)) {
                copy[key] = this.deepCopy($obj[key]);
            }
        }
        return copy;
    }
    
    
    /**
     * 
     * @param {*} $arr 
     * @param {*} $prop 
     * @param {*} $val 
     * @returns 
     */
    findValInObjnArr = function ($arr, $prop, $val) {
        if ($prop!="") {
            for (var a=0; a < $arr.length; a++) if ($arr[a][$prop]==$val) return $arr[a];
            return null;
        }
        for (var a=0; a < $arr.length; a++) if ($arr[a]==$val) return $arr[a];
        return null;
    }


    /**
     * Does an item exist in the array with the existing prop value set?
     * @param {*} $arr 
     * @param {*} $prop 
     * @returns 
     */
    findValInObjnArr2 = function ($arr, $prop, $val) {
        for (var a=0; a < $arr.length; a++) if ($arr[a][$prop]==$val) return true;
        return false;
    }


    sortByProp = function($arr, $prop) {
        $arr.sort( 
            function($a, $b) {
                var val_a = $a[$prop];
                if (val_a==undefined) return 0;

                var val_b = $b[$prop];
                if (val_b==undefined) return 0;

                if (val_a < val_b) return -1;
                else if (val_a > val_b) return 1;
                return 0;
            }
        );
        return $arr;
    }


    /**
     * 
     * @param {*} $arr 
     * @param {*} $prop 
     * @param {*} $val 
     * @returns 
     */
    removeObjInObjArr = function($arr, $prop, $val) {
        for (var a=0; a<$arr.length; a++) {
            if ($arr[a][$prop]==$val){
                $arr.splice(a, 1);
                return;
            }
        }
    }


    //weak attempt to add .png to end of bad imgur url
    fixImgURL=function($imgUrl) {
        if ($imgUrl.indexOf("imgur")==-1) return $imgUrl;   //do nothing
        var aParts = $imgUrl.split(".");
        aParts.reverse();
        var ext = aParts[0];
        aParts.reverse();
        if (ext.length<3 || ext.length>4) $imgUrl = $imgUrl+".png";
        else if (ext!="png" && ext!="jpg") $imgUrl = $imgUrl+".png";
        return $imgUrl;
    }


    /**
     * try to format the bigger number.
     * if it has a deci and we can't short-hand it with a B or M or K,
     * then just format the number with commas.
     */
    formatNumber=function($num, $bROUND=false) {
        var num_parts = ($num+"").toString().split(".");
        var num = parseInt(num_parts[0]);
        if (num >0 && num_parts.length>1 && $bROUND==false) return this.formatNumberCommas($num);

        var b = num / 1000000000;
        if (b>=1) {
            if ($bROUND==true) {
                var b100=Math.floor(b*100)/100;
                num_parts[0]=((b100+"").split(".").join("."))+" B";
            }
            else num_parts[0]=b+"B";
        }
        else {
            var m = num / 1000000;
            if (m>=1) {
                if ($bROUND==true) {
                    var m100=Math.floor(m*100)/100;
                    num_parts[0]=((m100+"").split(".").join("."))+" M";
                }
                else num_parts[0]=m+"M";
            }
            else {
                var k = num / 1000;
                if (k>=1) {
                    if ($bROUND==true) {
                        var k100=Math.floor(k*100)/100;
                        num_parts[0]=((k100+"").split(".").join("."))+" K";
                    }
                    else num_parts[0]=k+" K";
                }
                else num_parts[0]=num_parts[0];
            }
        }
        if ($bROUND==true) return num_parts[0];
        else if (num_parts.length==1) return num_parts[0];
        return num_parts[0]+"."+num_parts[1];
    }


    formatNumberCommas=function($num) {
        var num_parts = ($num+"").toString().split(".");
        num_parts[0] = num_parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        return num_parts.join(".");
    }

    convArr=function($arr) {
        var final_arr = [];
        var keys = Object.keys($arr);
        for (var k=0; k < keys.length; k++) {
            final_arr.push ( $arr [ keys[k]]);
        }
        return final_arr;
    }
    

    getSelectedOptionFromDD=function($dd_el) {
        var sel = document.getElementById($dd_el);
        return this.getSelectedOption(sel);
    }

    getSelectedOption = function($sel) {
        var opt;
        for ( var i = 0, len = $sel.options.length; i < len; i++ ) {
            opt = $sel.options[i];
            if ( opt.selected === true ) {
                break;
            }
        }
        return opt;
    }

    getUrlVars = function () {
        var vars = {};
        var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function (m, key, value) {
            vars[key] = value;
        });
        return vars;
    }

    hex_to_ascii=function($str1) {
        var hex  = $str1.toString();
        var str = '';
        for (var n = 0; n < hex.length; n += 2) {
            str += String.fromCharCode(parseInt(hex.substr(n, 2), 16));
        }
        return str;
    }

    htmlEntities=function(str) {
        return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&apos;');
    }

    
    isPrime($x){     
        var d = $x-1;
        while (d > 1){
          if (($x % d) == 0) return false;
          d--;
        }
        return true;
      }


    /**
     * 
     * @param {*} $map 
     * @param {*} $prop 
     * @returns 
     */
    __sortNumObjMapByProp = function($map, $prop="other") {
        var keys = Object.keys($map);
        keys.sort( function($a, $b) {
            var val_a = $map[$a][$prop];
            if (val_a==undefined) return 0;

            var val_b = $map[$b][$prop];
            if (val_b==undefined) return 0;

            if (val_a < val_b) return -1;
            else if (val_a > val_b) return 1;
            return 0;
        });
        
        var sortedMapObj = new Object();
        keys.forEach(key => {
            sortedMapObj[key] = $map[key];
          });
        return sortedMapObj;
    }


    __sortRelnKeyMap = function($relnMAP) {
        var keys = Object.keys($relnMAP);
        keys.sort( function($a, $b) {
            var rels_a = $relnMAP[$a];
            var text_a = MEMG.getNeuronByTempNid(rels_a[0].r).text.toLowerCase();
            var rels_b = $relnMAP[$b];
            var text_b = MEMG.getNeuronByTempNid(rels_b[0].r).text.toLowerCase();
            if (text_a < text_b) return -1;
            else if (text_a > text_b) return 1;
            return 0;
        });
        return keys;
    }

    endsWithStrip = function($str, $char=",") {
        if ($str[$str.length-1]==$char) {
            return $str.substring(0, $str.length-1);
        }
        return $str;
    }
    
    /**
     * 
     * @param {*} $val 
     * @returns 
     */
    isset = function($val) {
        if ($val==undefined || $val==null) return false;
        var _type = typeof $val;
        if (_type =="boolean") return $val;
        
        if (_type =="string") { 
            if($val.length==0) return false;
            return true;
        }
        if (_type=="number") {
            if($val==0) return false;
        }
        if (Array.isArray($val)==true && $val.length==0) return false;
        return true;
    }


    /**
     * move over unique props from one object to another
     * This is helpful when merging objects that are not in a custom class..
     * (basic objs or json being used)
     */
    moveUniquePropsToObj=function($obj_from, $obj_to) {
        if ($obj_from == null) return;
        if ($obj_to == null) return;
        var keys = Object.keys($obj_from);
        for (var k=0; k < keys.length; k++) {
            var prop = keys[k];
            if ($obj_to[prop]!=undefined) continue;
            var val = $obj_from[ prop ];
            $obj_to[prop]=val;
        }
    }


    printunixds=function($unixds) { 
        var d = new Date($unixds); //, timeZone:'UTC', timeZoneName:'short'
        const options = { year: 'numeric', month: '2-digit', day: '2-digit'};
        return d.toLocaleDateString('fr-CA', options)+" "+d.toLocaleTimeString();
    }

    //too tired to right now to implement the listsplitter.
    //this is for lazy sloppy jackass .csv files that include multiple
    //values in the column with a list.
    //we can split them into their own column and then give the user
    //the option to map it to an AKA.
    //for now, it gets nuked.
    processCSV_withHeader=async($csv, $delim, $listsplitter=";")=> {
        var allTextLines = $csv.split(/\r\n|\n/);
        var headers = [];
        var headerRow = allTextLines[0].split($delim);
        for (var h=0; h<headerRow.length; h++) {
            var clean = headerRow[h].replace(/['"]+/g, '');
            headers.push(clean.trim());
        }
        console.log(headers);
        var csvRowObjs = [];
        for (var n=1; n < allTextLines.length-1; n++) {
            var row = allTextLines[n].split($delim);
            var rowObj = [];
            for (var j=0; j<row.length; j++) {
                var clean2 = row[j].replace(/['"]+/g, '');
                var colName = headers[j];
                if (clean2.indexOf($listsplitter)!=-1) {
                    var aParts = clean2.split(";");
                    clean2 = aParts[0].trim();
                }
                if (headers!=null) rowObj[ colName ] = clean2;
                else rowObj.push(clean2.trim());
            }
            rowObj.__ROW_ACTIVE=true;
            csvRowObjs.push(rowObj);
        }
        return {'headers':headers, 'data': csvRowObjs};
    }

    processJsonKeyPairs=async($json, $delim)=> {
        var headers = [];
        var finaldata = [];
        for (var n=0; n < $json.length; n++) {
            var row = $json[n];
            //first loop snag all props from first row and make headers.
            if (n==0) {
                for (var prop in row) {
                    var header = prop;//.replace(/['"]+/g, '');
                    headers.push(header);
                }
            }
            var rowObj = [];
            //loop the headers, snag the objects
            for (var h=0; h<headers.length; h++) {
                var prop = headers[h];
                var value = row[prop];
                if (value=="null") value=="";
                else if (typeof value ==='string') value = value.replace(/['"]+/g, '');
                rowObj[ prop ] = value;
            }
            rowObj.__ROW_ACTIVE=true;
            finaldata.push(rowObj);
        }
        return {'headers':headers, 'data': finaldata};
    }
    
    pushUniqueProp=function($obj, $prop, $val) {
        if (Array.isArray($obj[$prop]) == true) { if ($obj[$prop].indexOf($val)==-1) $obj[$prop].push($val); }
        else {
            $obj[$prop]=[];
            $obj[$prop].push($val);
        }
    }

    fisherYatesShuffle=function($array) {
        for (let i = $array.length - 1; i > 0; i--) {
            const j = Math.floor(Math.random() * (i + 1));
            [$array[i], $array[j]] = [$array[j], $array[i]];
        }
        return $array;
    }

    range = function ($min,$max) {
        return Math.floor(Math.random()*($max-$min+1)+$min);
    }

    randTXID = function($len=20) {
        var txid = "";
        for (var s=1; s <= $len; s++) {
            txid = txid+Math.floor(Math.random()*10);
        }
        return "z"+txid;
    }


    /**
     * ghosts start with z.
     * @param {*} $len 
     * @returns 
     */
    randNID = function($len=20) {
        var txid = "";
        for (var s=1; s <= $len; s++) {
            txid = txid+Math.floor(Math.random()*10);
        }
        return "z"+tx 
    }

    convertDMSLatToDec($degrees, $minutes, $seconds) {
        return $degrees + ($minutes / 60) + ($seconds / 3600);
    }
    convertDMSLongToDec($degrees, $minutes, $seconds, $direction) {
        var dd = $degrees + ($minutes / 60) + ($seconds / 3600);
        if ($direction === 'W') {
            return dd * -1;
        } 
        else if ($direction === 'E') {
            return dd;
        }
    }
    testGeo=function() {
        //giza great pyramid
        var lat = this.convertDMSLatToDD(40, 42, 31.0, "N"); // 40.70861°N
        var long = this.convertDMSLongToDD(74, 0, 32.0, "W"); // -74.00889°W
        console.log(lat+", "+long)
    }
    


    
    getRandHex = function($len) { return UTILS.randomHex($len);}
    randHex = function($len) { return UTILS.randomHex($len); }
    randomHex = function($len) {
        var maxlen = 8;
        var min = Math.pow(16,Math.min($len,maxlen)-1) 
        var max = Math.pow(16,Math.min($len,maxlen)) - 1;
        var n   = Math.floor( Math.random() * (max-min+1) ) + min;
        var r   = n.toString(16);
        while ( r.length < $len ) {
            r = r + this.randomHex( $len - maxlen );
        }
        return r;
    };

    randomSpherePoint=function($x0,$y0,$z0,$radius){
        var u = Math.random()+.01;
        var v = Math.random()+.01;
        var theta = 2 * Math.PI * u;
        var phi = Math.acos(2 * v - 1);
        var pt = new Object();
        pt.x = $x0 + ($radius * Math.sin(phi) * Math.cos(theta));
        pt.y = $y0 + ($radius * Math.sin(phi) * Math.sin(theta));
        pt.z = $z0 + ($radius * Math.cos(phi));
        return pt;
    }

    //nid or tnid array works here
    removeFromNidArray=function($arr, $nid) {
        var index = $arr.indexOf($nid)
        if (index!==-1)  $arr.splice(index,1);
    }

    removeFromTnidsArray=function($tnids_arr, $temp_nid) {
        var index = $tnids_arr.indexOf($temp_nid)
        if (index!==-1)  $tnids_arr.splice(index,1);
    }

    removeFromRelonsArray=function($relons_arr, $r) {
        for (var r=0; r < $relons_arr.length; r++) {
            var rel = $relons_arr[r];
            if (rel.r==$r) {
                $relons_arr.splice(r,1);
                return $relons_arr;
            }
        }
        return $relons_arr;
    }

    removeRelonByTxid=function($relons_arr, $txid) {
        for (var r=0; r < $relons_arr.length; r++) {
            var rel = $relons_arr[r];
            if (rel.txid==$txid) {
                $relons_arr.splice(r,1);
                return $relons_arr;
            }
        }
        return $relons_arr;
    }

    
    getHighestSimilarity = function($NOBJs, $lookupval) {
        var highestSim = 0;
        var highestNOBJ = null;
        for (var c=0; c <$NOBJs.length; c++) {
            var nObj = $NOBJs[c];
            var sim = ANNE.UTILS.similarity(nObj.text, $lookupval);
            if (sim>highestSim) {
                highestSim = sim;
                highestNOBJ = nObj;
            }
        }
        return {nObj:highestNOBJ, sim:highestSim};
    }


    //levenshtein distance, altered
    similarity = function(s1, s2, $factor=1) {
        var longer = s1;
        var shorter = s2;
        if (s1==undefined || s1==null) {
            alert("woh");
            return 0;
        }
        if (s2==undefined || s2==null) {
            alert("woh");
            return 0;
        }
        if (s1.length < s2.length) {
            longer = s2;
            shorter = s1;
        }
        var longerLength = longer.length;
        
        if (longerLength == 0) return 1.0; //s1 and s2 have no length? lolz.

        var lenFact = shorter.length/longer.length;
        if ($factor>1) {
            var final = Math.floor($factor * (longerLength - this.editDistance(longer, shorter)) / parseFloat(longerLength));
            return (final/$factor)*lenFact;
        }
        else return ((longerLength - this.editDistance(longer, shorter)) / parseFloat(longerLength))*$factor;
    }

    
    setDDToIndex=function($dd_el, $index=0) {
        document.getElementById($dd_el).selectedIndex = $index;
    }


    sortByNid=function($a, $b) {
        if ($a==undefined || $a==null || $b.nid==undefined || $b.nid==null) return 0;
        if ($a.nid < $b.nid) return -1;
        else if ($a.nid > $b.nid) return 1;
        return 0;
    }


    //targetting the earliest here..
    sortByBeTime=function($a, $b) {
        if ($a==undefined || $a.be_time==null || $b.be_time==undefined || $b.be_time==null) return 0;
        if ($a.be_time < $b.be_time) return 1;
        else if ($a.be_time > $b.be_time) return -1;
        return 0;
    }


    //sort clump neurons by their WHEN role.
    sortClumpsByWhen=function($events) {
        if ($events==undefined || $events==null || $events.length<=1) return;
        $events.sort( UTILS.sortByWhenRole );
        return;
    }
    


    //these are role_when arrays.  We will only use the first
    //in 99.99% of cases there will only be one of a given role per sentence.
    sortByWhenRole=function($a, $b, $bFWD=true) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.role_when==undefined || $a.role_when==null) {
            if ($b.role_when!=undefined && $b.role_when!=null) return 1; 
            else return 0;
        }
        else if ($b.role_when==undefined && $b.role_when==null) return -1; 

        var a_when = MEMG.getNeuronByTempNid($a.role_when[0].t);
        var b_when = MEMG.getNeuronByTempNid($b.role_when[0].t);
        
        if ($bFWD) return UTILS.compareDates(b_when, a_when);
        else return UTILS.compareDates(a_when, b_when);
    }

    tnidsUnion = function($a, $b) {
        var union = [];
        for (var a=0; a <$a.length; a++) {
            var atnid = $a[a];
            for (var b=0; b <$b.length; b++) {
                if ($b[b]==atnid) {
                    if (union.indexOf(atnid)==-1) {
                        union.push(atnid);
                        break;
                    }
                }
            }   
        }
        return union;
    }


    //we should have an ANNE epoch day number for all dates.
    //that would be a better (more efficient) date compare.

    compareDates = function($a, $b) {
        $a.processAsDateNeuron();
        $b.processAsDateNeuron();
        if ($a.year < $b.year) return -1;
        else if ($a.year > $b.year) return 1;
        else {
            if ($a.month < $b.month) return -1;
            else if ($a.month > $b.month) return 1;
            else {
                if ($a.day < $b.day) return -1;
                else if ($a.day > $b.day) return 1;
                else return 0;
            }
        }
        return 0;
    }

    isUSSuffix=function($test) {
        var suffix = ["JR", "SR", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X"];
        if ($test[0]==".") $test = $test.substring(1);
        $test = $test.toUpperCase();
        if (suffix.indexOf($test)!=-1) return true;
        return false;
    }

    removeOption = function($el, $val) {
        var el = document.getElementById($el);
        if (el==undefined || el==null) return;
        var options = document.querySelector("#"+$el).options;
        if (options==undefined || options==null) return;
        for (var o=0; o < options.length; o++) {
            if (options[o].value==$val) {
                options.remove(o);
                break;
            }
        }
    }


    roughSizeOfObject($object) {
        var objectList = [];
        var stack = [$object];
        var bytes = 0;
        while (stack.length) {
            var value = stack.pop();
            if (typeof value === 'boolean') bytes += 4;
            else if (typeof value === 'string') bytes += value.length * 2;
            else if (typeof value === 'number') bytes += 8;
            else if (typeof value === 'object' && objectList.indexOf( value ) === -1) {
                objectList.push( value );
                for( var i in value ) stack.push( value[ i ] );
            }
        }
        return bytes;
    }

    sleep=function($ms) {
        return new Promise(resolve => setTimeout(resolve, $ms));
    }

    //test this with DOM converstion...
    sortDD = function ($el) {
        var sel = docuement.getElementById($el);
        var selected = sel.value; // cache selected value, before reordering
        var opts_list = sel.querySelector('option');
        opts_list.sort(function (a, b) { return document.getElementById(a).text > document.getElementById(b).text ? 1 : -1; });
        sel.innerHTML="";
        sel.append(opts_list);  //append children back
        sel.value=selected; 
    }

    sortByFire=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null || $a.fire==undefined || $b.fire==undefined) return 0;
        if ($a.fire < $b.fire) return -1;
        if ($a.fire > $b.fire) return 1;
        return 0;
    }

    sortByFireThenIns=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null || $a.fire==undefined || $b.fire==undefined) return 0;
        if ($a.fire > $b.fire) return -1;
        if ($a.fire < $b.fire) return 1;
        if ($a.ins.length > $b.ins.length) return -1;
        if ($a.ins.length < $b.ins.length) return 1;
        return 0;
    }

    sortByDimension=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.type < $b.type) return -1;
        if ($a.type > $b.type) return 1;
        return 0;
    }

    sortByText=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.text < $b.text) return -1;
        if ($a.text > $b.text) return 1;
        return 0;
    }

    sortTnidsByAlpha=function($tnids) {
        var nObjs = MEMG.getNeuronsFromTnids($tnids);
        nObjs.sort(this.sortByTextNoCase);
        return MEMG.getTnidList(nObjs);
    }

    sortByTextNoCase=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.text==undefined || $b.text==undefined || $a.text==null || $b.text==null) {
            console.log("alsdfkjalsdfjlafjadkfj;alsdfj");
            return 0;
        }
        if ($a.text.toUpperCase() < $b.text.toUpperCase()) return -1;
        if ($a.text.toUpperCase() > $b.text.toUpperCase()) return 1;
        return 0;
    }


    sortRelonsByFromNObjText=function($a, $b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.to_type!=TO_TYPE_ANNE) return -1;
        if ($b.to_type!=TO_TYPE_ANNE) return -1;
        var aNOBJ = MEMG.getNeuronByTempNid($a.f);
        if (aNOBJ==null || aNOBJ.text==undefined) return 0;
        var bNOBJ = MEMG.getNeuronByTempNid($b.f);
        if (bNOBJ==null || bNOBJ.text==undefined) return;
        if (aNOBJ.text.toUpperCase() < bNOBJ.text.toUpperCase()) return -1;
        if (aNOBJ.text.toUpperCase() > bNOBJ.text.toUpperCase()) return 1;
        return 0;
    }

    sortRelonsByToNObjText=function($a, $b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.to_type!=TO_TYPE_ANNE) return -1;
        if ($b.to_type!=TO_TYPE_ANNE) return -1;
        var aNOBJ = MEMG.getNeuronByTempNid($a.t);
        if (aNOBJ==null) return 0;
        var bNOBJ = MEMG.getNeuronByTempNid($b.t);
        if (bNOBJ==null) return;
        if (aNOBJ.text.toUpperCase() < bNOBJ.text.toUpperCase()) return -1;
        if (aNOBJ.text.toUpperCase() > bNOBJ.text.toUpperCase()) return 1;
        return 0;
    }


    sortGhostsLast=function($a, $b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.ghost==true) {
            if ($b.ghost==false) return 1;
            else return 0;
        }
        return 0;
    }

    sortByRelnTextNoCase=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        var aNOBJ = MEMG.getNeuronByTempNid($a.r);
        if (aNOBJ==null) return 0;
        var bNOBJ = MEMG.getNeuronByTempNid($b.r);
        if (bNOBJ==null) return;

        if (aNOBJ.text.toUpperCase() < bNOBJ.text.toUpperCase()) return -1;
        if (aNOBJ.text.toUpperCase() > bNOBJ.text.toUpperCase()) return 1;
        return 0;
    }

    sortByTime=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.time <=0 && $a.emulated==false && $b.time <=0 && $b.emulated==false) return 0;
        if ($a.time <=0 && $a.emulated==false) return -1;
        if ($b.time && $a.emulated==false <=0) return 1;
        if ($a.time < $b.time) return 1;
        if ($a.time > $b.time) return -1;
        return 0;
    }
    sortByTimeAsc=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.time <=0 && $a.emulated==false && $b.time <=0 && $b.emulated==false) return 0;
        if ($a.time <=0 && $a.emulated==false) return 1;
        if ($b.time && $a.emulated==false <=0) return -1;
        if ($a.time < $b.time) return -1;
        if ($a.time > $b.time) return 1;
        return 0;
    }
    sortByTimeASC=function($b,$a) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.time <=0 && $a.emulated==false && $b.time <=0 && $b.emulated==false) return 0;
        if ($a.time <=0 && $a.emulated==false) return -1;
        if ($b.time && $a.emulated==false <=0) return 1;
        if ($a.time < $b.time) return 1;
        if ($a.time > $b.time) return -1;
        return 0;
    }
    sortByFirstSeen=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
        if ($a.firstseen > $b.firstseen) return 1;
        if ($a.firstseen < $b.firstseen) return -1;
        return 0;
    }




    syntaxHighlight=function($json) {
        json = $json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
        return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
            var cls = 'number';
            if (/^"/.test(match)) {
                if (/:$/.test(match)) {
                    cls = 'key';
                } else {
                    cls = 'string';
                }
            } else if (/true|false/.test(match)) {
                cls = 'boolean';
            } else if (/null/.test(match)) {
                cls = 'null';
            }
            return '<span class="' + cls + '">' + match + '</span>';
        });
    }

        

    /**
     * validate an ipv4 addressed
     * @param {*} $nObj 
     * @returns {Boolean} 
     */
     __ipv4Validation=function($nObj) {
        console.log("(__ipv4Validation) to do!");
        return true;
    }


    /**
     * validate an ipv6 address
     * @param {*} $nObj 
     * @returns {Boolean}
     */
    __ipv6Validation=function($nObj) {
        console.log("(__ipv6Validation) to do!");
        return true;
    }


    /**
     * Validate an email string conforms to known email strings.
     * 
     * @param {anne_neuron} - The neuron with .value OR string we want to test
     * @author {Mr.Scatman} 
     *
     */
    __emailValidation = function($nObj) {
        var mailformat = /(?!.*\.{2})^([a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+(\.[a-z\d!#$%&'*+\-\/=?^_`{|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+)*|"((([ \t]*\r\n)?[ \t]+)?([\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*(([ \t]*\r\n)?[ \t]+)?")@(([a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\d\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.)+([a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF][a-z\d\-._~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]*[a-z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])\.?$/i
        
        //just a string (not an nObj);
        if (typeof $nObj === "string") {
            var test = mailformat.test($nObj.toLowerCase());
            //console.log(test);
            if(test==undefined || test==null) return "invalid format";
            else if (test==true) return true;
            else return false;
        }

        if ($nObj.value==undefined || $nObj.value==null || $nObj.value=="") {
            $nObj.value = $nObj.text.trim();    //default nObj .value is the .text if none was provided by a .set_value function.
        }
        if(mailformat.test($nObj.value.toLowerCase())==true) {
            $nObj.valid = true;
            return true;
        }
        else {
            $nObj.value = "";
            $nObj.valid = false;
            return false;
        }
    }

    //from devshed
    __urlValidation=function($str) {
        var pattern = new RegExp('^(https?:\\/\\/)?'+ // protocol
        '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|'+ // domain name
        '((\\d{1,3}\\.){3}\\d{1,3}))'+ // OR ip (v4) address
        '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*'+ // port and path
        '(\\?[;&a-z\\d%_.~+=-]*)?'+ // query string
        '(\\#[-a-z\\d_]*)?$','i'); // fragment locator
      return !!pattern.test($str);
    }

    
    /**
     * 
     * @param {*} $aMatches 
     * @param {*} $aMatches1 
     * @param {*} $prop 
     * @returns 
     */
    concatUnique=function($aMatches, $aMatches1, $prop="nid") {
        if($aMatches.length==0) return $aMatches1;
        if($aMatches1.length==0) return $aMatches;
        var arr = new arraymap();
        arr.setMapKey($prop);
        arr.addArray($aMatches);
        arr.addArray($aMatches1);
        return arr.arr;
    }


    uniqueConcat=function($a, $b, $prop="nid") {
        if ($a.length==0) return $b.concat();
        var a2 = $a.concat();
        for (var b=0; b < $b.length; b++) { 
            if ($a.indexOf($b[b])==-1) a2.push($b[b]);
        }
        return a2;
    }

    uniqueConcatRels = function($a, $b) {
        var a_rels_txids = [];
        var rels = [];
        for (var a=0; a < $a.length; a++) {
            a_rels_txids.push($a[a].txid);
            rels.push($a[a]);
        }
        for (var b=0; b < $b.length; b++) {
            if (a_rels_txids.indexOf($b[b].txid)!=-1) continue;
            a_rels_txids.push($b[b].txid);
            rels.push($b[b]);
        }
        return rels;
    }

    /**
     * 
     * @param {*} $str 
     * @returns 
     */
    poorMansAbbreviate=function($str) {
        $str = $str.trim();
        const words = $str.split(' ');
        
        if (words.length === 1) {
            return $str; 
        } 
        else {
            var abbr = '';    
            words.forEach((word, index) => {
                if (index === 0 || index === words.length - 1) {
                    abbr += word.charAt(0).toUpperCase() + '.';
                } 
                else {
                    abbr += word.charAt(0).toUpperCase();
                }
            });
            return abbr;
        }
    }

    
    /**
     * Check for a relon in a relon array.
     * If it is unique, add it to the array and return true.
     * if it is not unique, return false.
     * @param {array} $rels 
     * @param {Object} $rel 
     * @returns 
     */
    pushIfUniqueRel = function($rels, $rel) {
        for (var r=0; r < $rels.length; r++) {
            var rel = $rels[r];
            if(rel.txid==$rel.txid) {
                return false;
            }
        }
        $rels.push($rel);
        return true;
    }

    seededRandom=function() {
        var x = Math.sin(Math.random()*1000) * 10000;
        return x - Math.floor(x);
    }

    getScatModSeedArrItem=function($seed, $arr) {
        var per = UTILS.getScatModSeedPer($seed);
        var max_usable = Math.round($arr.length * per);
        return $arr [ Math.floor(Math.random()*max_usable)];
    }
    

    getScatModSeedPer=function($seed) {
        $seed = Math.round($seed);
        var per = .5;
        if ($seed % 3 !=0) per +.1;
        if ($seed % 2 !=0) per +.15;
        if ($seed % 7 ==0) per +.25;
        return per;
    }
    
    isWholeNumber=function($number) {
        return $number % 1 === 0;
    }

    HEXtoRGB = function($HEX) {
        var isNumb = Number.isInteger($HEX);
        if (isNumb) var bigint = $HEX;
        else var bigint = parseInt($HEX.slice(1), 16);
        const r = (bigint >> 16) & 255;
        const g = (bigint >> 8) & 255;
        const b = bigint & 255;
        return { r, g, b };
    }

    RGBtoHEX = function($rgb) {
        const { r, g, b } = $rgb;
        const hex = `0x${((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1)}`;
        return hex;
    };

    shiftRGB = function($RGB, $incr) {
        const shiftedColor = {
          r: $RGB.r + $incr,
          g: $RGB.g + $incr,
          b: $RGB.b + $incr,
        };
        shiftedColor.r = Math.max(0, Math.min(255, shiftedColor.r));
        shiftedColor.g = Math.max(0, Math.min(255, shiftedColor.g));
        shiftedColor.b = Math.max(0, Math.min(255, shiftedColor.b));
        return shiftedColor;
    };
}


const UTILS = new anne_utils ();
UTILS.set_init(UTILS);