
class circuit_piece {
    constructor($i, $mesh) {
        this.i = $i;
        this.mesh = $mesh;
        this.nObj = null;
        this.type = null;
        this.homePt = new THREE.Vector3($mesh.position.x,$mesh.position.y,$mesh.position.z); 
        
        //guis stuff for the piece.
    }
}

class circuit{
    constructor($nObj) {
        this.nObj = $nObj;
        this.nid = $nObj.nid;
    }
}
class circuit_board{
    constructor($CIRCUIT) {
        this.C = $CIRCUIT; //to get variables.
        this.pieces = [];
    
        this.circuits = new arraymap();
        this.circuits.setMapKey("nid");
    }

    buildCirc=function($nid) {
        var circ = this.circuits.get($nid);
        if (circ!=null) {
            console.log("already built this");
            return circ;
        }
        var nObj = MEMG.getNeuronByNid($nid);
        circ = new circuit (nObj);
        this.circuits.addU(circ);

        circ.blowOut()
    }


    makeBoxGrid=function($x, $z, $y = 0, $boxWidth = 1, $gap = 1) {
        const group = new THREE.Group();
        for (let i = 0; i < $z; i++) {
            for (let j = 0; j < $x; j++) {
                const posX = j * ($boxWidth + $gap);
                const posZ = i * ($boxWidth + $gap);
                const geometry = new THREE.BoxGeometry($boxWidth, $boxWidth, $boxWidth);
                const box = new THREE.Mesh(geometry, this.C.YELLOW.mat_solid_alpha);
                box.position.set(posX, $y, posZ);
                group.add(box);
                var cpe = new circuit_piece(this.pieces.length, box);
                this.pieces.push(cpe);
            }
        }
        return group;
    }

}

class circuit_pathway {
    constructor ($tnid) {
        this.tnid = $tnid;
        this.a_pathways = [];
        this.b_pathways = [];
        this.a_talk = "";
        this.b_talk = "";
        this.ab_talk = "";

        var NOBJ = MEMG.getNeuronByTempNid($tnid);
        this.debug_name = NOBJ.text;
    }
}


/**
* a utility mode to help build and manage a compare circuit.
* requires use of the ACE and CIRCUIT.
*/
class compare_circuit extends neuron_circuit{
    constructor($CIRCUIT, $ACE, $nObj) {

        //all the neuron_circuit goodies...
        super($nObj);

        //plus the compare unique goodies..
        this.CIRCUIT = $CIRCUIT;
        this.C = this.CIRCUIT;
        this.ACE = $ACE;
        this.current_compare_depth = 0;
        this.match_tnids = [];

        this._series=[]; //for comp line placement
    
        this._meta_pathways = [];

        this._el_rez_talk = null;
    }


    /**
     * Default on load of ACE using saved preference (to do)
     * @param {*} $defaultCompareDepth 
     */
    setCompareDepth=function($defaultCompareDepth) {
        console.log("setting default compare depth to "+$defaultCompareDepth);
        this.current_compare_depth = $defaultCompareDepth;
    }


    /**
     * Depth has changed via dat gui on ACE.
     * We will either throttle back, or go deeper in each circuit starting at the present gen max to the new gen max.
     */
    compareDepthChanged=function($new_compare_depth) {
        $new_compare_depth = parseInt($new_compare_depth);
        if ($new_compare_depth > this.current_compare_depth) {
            console.log("This is more deep!");
            for (var c = 0;  c < Math.min(2, this.C._aCircuits.length); c++) {
                var circ = this.C._aCircuits[c];
                circ.extend_depth_from_gen_to_gen(CMD.current_compare_depth, $new_compare_depth);
            }
        }
        else if ($new_compare_depth < this.current_compare_depth) {
            console.log("this is less deep, we will filter compares");
        }
        else {
            console.log("no change");
        }

        this.current_compare_depth = $new_compare_depth;
    }


    /**
     * topTgenToTraverse should be from the OTHER circ than circ1.
     * We want to look for topTgenToTraverse IN circ1's tnids.
     * @param {neuron_gen} $topTgenToTraverse 
     * @param {neuron_circuit} $circ1 
     */
    findComps = async ($topTgenToTraverse, $circ1, $bTOP=false)=> {
        var circ_match_tnids = [];
        var C = this.C;

        //need to vet this bigly. (lol)
        //interal function.

        /**
         * internal function
         */
        var checkTgen = async($tgens, $circ1)=> {
            var tgens_returned = [];
            
            for (var t=0; t < $tgens.length; t++) {
                
                //root circ will match and block all others..
                //so -- we want here to not count matches if the parent is a gen1 or greater and is already a CIRC_MATCH.
                var tgen1 = $tgens[t];
                
                if (tgen1.gen>1 
                    && tgen1.parent_tgen!=null 
                    && tgen1.parent_tgen.CIRC_MATCH==true) {
                    continue;
                }
        
                //root circ ref in other circ
                if (tgen1.CIRC_DEAD_END==true) continue;
                
                //top match passed in.
                if ($circ1.all_tnids.indexOf(tgen1.tnid)!=-1) {
        
                    //test why tipper gore is in trump's network
                    var circ2 = tgen1.circ;
                    var top_tnid_circ2 = circ2.nObj.temp_nid;

                    //no top circuit matches here..  (they are what we are comparing)
                    if (tgen1.tnid==top_tnid_circ2) continue;
                    
                    //all tgens matching this tnid in the all_nids circ1 network.
                    if (tgen1.tnid==8507) {
                        console.log("wef2017??");
                    }
                    var test_tgens = C.getAllCircTgensByTnid($circ1.circ_id, tgen1.tnid);
                            
                    //if this tnid is in the circ1 network downstream from a circ2.nObj.temp_nid (circ2 top nid)
                    //it is no good.  If circ2 top nid is in circ1 then ALL of the downstream TNIDS will match.
                    //Example - if Tipper Gore is in Trump's network because of Al Gore being at the 2020 WEF conference,
                    //this is NOT WANTED.  We will match the 2020 WEF conference (including Al Gore there)
                    //and thus we do not need to match TIPPER.  She is only in trump's network because of AL and AL is the 
                    
                    var bGOOD = false;
                    var bDEADEND=false;
                    for (var t=0; t < test_tgens.length; t++) {
                        if (test_tgens[t].parent_tgen!=null) {
                            if(test_tgens[t].parent_tgen.tnid==top_tnid_circ2) {
                                bDEADEND = true;
                                continue;
                            }    
                            else if (test_tgens[t].parent_tgen.CIRC_MATCH==true || $topTgenToTraverse.CIRC_DEAD_END==true) {
                                bDEADEND = true;
                                continue;
                            }
                            bGOOD=true;
                            test_tgens[t].CIRC_MATCH=true;
                            test_tgens[t].CIRC_MATCH_LINEAGE=true;
                            break;
                        }
                    }
        
                    //exit this.
                    if (bGOOD==false) {

                        //don't look further on a known dead-end.
                        if (bDEADEND==true) continue;
                        
                        //look even deeper on this line.
                        if (tgen1.gen+1 < ANNE.ACE._compareDepth) {
                            tgens_returned.push(tgen1);
                        }
                        continue;
                    }
                    
                    var mNOBJ = MEMG.getNeuronByTempNid(tgen1.tnid);
                    console.log("pushing match %c"+mNOBJ.text, ANNE.TALK.bggreen);
                    
                    //this is a legit circ match.
                    tgen1.CIRC_MATCH = true;
                    tgen1.CIRC_MATCH_LINEAGE = true;

                    circ_match_tnids.push(tgen1.tnid);
                    
                    //turn on the lineage that got us here.
                    while(tgen1!=null && tgen1.parent_tgen!=null) {
                        tgen1 = tgen1.parent_tgen;
                        tgen1.CIRC_MATCH_LINEAGE = true;
                    }
                }
            }

            return tgens_returned;
            
        } //end internal function

        var tgens_returned = await checkTgen([$topTgenToTraverse], $circ1);

        //if ($bTOP==true) tgens_returned.push($topTgenToTraverse)
        
        //we need to go no further to traverse this..
        //we found a hit and all downlstream will match.
        //ONLY CONTINUE HERE IF YOU DIDN'T FIND A hit
        //OR, if this is the TOP TGEN GEN=0.
        //Matching a top TGEN shouldn't kill the compare.
        if (circ_match_tnids.length==0 && $bTOP==false) {}
        
        //recurse through existing circuit from the top
        else if (circ_match_tnids.length>0 && $bTOP==true) {
            //trying to reduce recursive stack overload (and js blowup)
            while (tgens_returned.length>0) {
                var new_tgens = [];
                for (var t=0; t < tgens_returned.length; t++) {
                    if ((tgens_returned[t].gen+1) < ANNE.ACE._compareDepth) {
                        continue;
                    }
                    var new_tgens_returned = await checkTgen(tgens_returned[t]);
                    new_tgens = new_tgens.concat(new_tgens_returned);
                }
                tgens_returned = new_tgens;
            }
        }



        //these are found matches we have isolated from this traversal.
        for (var c=0; c < circ_match_tnids.length; c++) {

            //check if we already have this tnid in our comp set.
            var match_tnid = circ_match_tnids[c];
        
            //no dupe circ matches.
            if (this.all_tnids.indexOf(match_tnid)!=-1) {
                var comp_tgen = this.getTgenRaw(match_tnid)
                if (comp_tgen!=null) {
                    //this.createCompCircBacklinks(comp_tgen);
                }
                continue;
            }

            this.all_tnids.push(match_tnid);

            //make the green orb ONE-TIME
            //make a fake relon we can display via the standard halo code.
            //we will connect these boxes to the boxes in the other circuits when the compare is clicked.
            var thisNOBJ = MEMG.getNeuronByTempNid(match_tnid);
            var comp_reln = MEM.makeTempRelon(this.nObj, TYPE_HAS, MEM.comp_union.nid, TO_TYPE_ANNE, thisNOBJ.nid, true);
            if (comp_reln==null) continue;

            //add it in.. we will display it later when the setCompLine is called.
            await this.addCompareSubGen(match_tnid, comp_reln); 
        }
    }




    /**
     * Add in a green sub box for the compare match
     * It will be gen 1 of the compare (no deeper gens in the compare, tho the compare will be weighted by hits)
     * It will be placed in the compare match line.
     * @param {number} $tnid
     * @param {*} $initiating_rel 
     * @returns 
     */
    addCompareSubGen = async($tnid, $initiating_rel=null)=> {

        this.match_tnids.push($tnid);
        
        var size = this.C.targetSize;
        var thumb_size = 48;
        var geometry = new this.C.ta.THREE.SphereGeometry(this.C.targetSize/2, 32, 16);
        
        var comp_tgen = this.addUniqueTgen(this.root_tgen, $initiating_rel.t, 1, $initiating_rel);
        if (comp_tgen==null) return null;

        var nObj = MEMG.getNeuronByTempNid($initiating_rel.t);

        comp_tgen.external_chaseable=false; //green circ
        comp_tgen.anne_chaseable=false;     //green circ
        
        var material = new this.C.ta.THREE.MeshStandardMaterial( {  
            wireframe:true,
            color:this.C.YELLOW
        } );
        
        var mesh = new this.C.ta.THREE.Mesh( geometry, material );
        var y = 0;

        
        //when this tgen is clicked we want it to tie out to the common tgens in the circuits
        this.C.clickableMeshes.push(mesh);
        
        //if (comp_tgen.gen>1) y = y+(200);
        mesh.position.y = y;//C.targetSize/2;

        comp_tgen.setMesh(mesh);

        var name = comp_tgen.getName($initiating_rel);
        const neuronLblDiv = document.createElement( 'div' );
        neuronLblDiv.className = 'anne-match-neuron';
        neuronLblDiv.textContent = name;
        neuronLblDiv.style.marginTop = '-1em';

        var afile = await IMAGES.getAnyValidImgAFILE(nObj, thumb_size);
        if (afile!=null) {

            //remap the neuronLblDiv to be a container
            neuronLblDiv.textContent = "";
            neuronLblDiv.className = ""
            neuronLblDiv.style.marginTop = '';

            //load the image into a new div
            var imgel = document.createElement("div");
            imgel.style.display="block";
            imgel.style['text-align']="center";
            imgel.classList.add("neuron-css-img");
            neuronLblDiv.append(imgel);
            imgel.setAttribute("tgen-id", comp_tgen.tgenid);
            imgel.setAttribute("circ-id", comp_tgen.circ.circ_id);
            imgel.addEventListener("click", function($e) {
                $e.stopPropagation();
                $e.preventDefault();
                var tgen_id = this.getAttribute("tgen-id");
                var circ_id = this.getAttribute("circ-id");
                var tgen = this.C.getTgenByCircAndTgenId(circ_id, tgen_id);
                if (tgen==null) return;
                this.ACE.finalClickByTgen(tgen);
            });

            var textEl = document.createElement("div");
            textEl.className = 'anne-match-neuron';
            textEl.textContent = name;
            textEl.style.marginTop = '-1em';
            textEl.classList.add("show");
            neuronLblDiv.append(textEl);
            comp_tgen.bHASBOXIMG=true;
            ANNE.A.doImageDyno2_B64(imgel, "", afile, thumb_size, "");
        }
        
        const primaryNeuronLbl = new this.C.CSS3DObject( neuronLblDiv );
        
        primaryNeuronLbl.lbl_type=this.C.CSS3_NEURON_LBL;

        //stagger labels north/south
        var pairing = Math.floor((this.match_tnids.length+2)/2);
        //0 = 0+2/2 = 1 = 1
        //1 = 1+2/2 = 1.5 = 1
        //2 = 2+2/2 = 2
        //3 = 3+2/2 = 2.5 = 2
        //this will stagger the placement of 2 in a row down. .then 2 in a row up.. then 2 in a row down.. etc
        //since each one we flip sides this should order the lbls optimally.
        if ((pairing+2) %2 == 0) {
            primaryNeuronLbl.position.set( 0, size+10, 0 );
        }
        else {
            primaryNeuronLbl.position.set( 0, -size-10, 0 ); 
        }
        
        primaryNeuronLbl.circ_id = comp_tgen.circ.circ_id;
        primaryNeuronLbl.tgen = comp_tgen;
        mesh.add( primaryNeuronLbl );
        comp_tgen.primaryNeuronLbl = primaryNeuronLbl;
        this.C.css3dLbls.push(primaryNeuronLbl);
        
        mesh.tgen_ptr = comp_tgen;
        comp_tgen.parent_tgen.mesh.add(mesh);

        //turn it on when the COMP CIRC IS TOGGLED
        ANNE.A.hide(neuronLblDiv);

        return mesh;
    }



    /**
     * 
     * NOTE, we will have to make more of these as more data potentially comes in and hits circuits and matches.
     * 
     * NOTE2:  we may not want all of these...
     * these aren't specifically relevant without analyzing the FROM/RELN.
     * Some rando in circuit B can be a poltician.
     * Should that be a comp match to circuit A primary being a politician?
     * 
     * ie, person A is a politician, vs person B knowns a guy who knows a guy who is a politician.
     * Not the same.
     */
    createCompCircBacklinks = function($tgen) {
        console.log("%c(this.createCompCircBacklinks) %c"+$tgen.audit, ANNE.TALK.bggreen, ANNE.TALK.bgyellow);
        if ($tgen.comp_backlinks!=undefined && $tgen.comp_backlinks.length) {
            return;
        }

        //we need to get all the tgens in the circuits that have this tnid.
        //we will link to them ALL.  Quantity matters here to strengthen (and resize the comp orb)
        
        var tgens0 = this.C.getAllCircTgensByTnid(0, $tgen.tnid);
        var tgens1 = this.C.getAllCircTgensByTnid(1, $tgen.tnid);

        var tgen_hits = tgens0.concat(tgens1);

        if(tgen_hits.length>10) {
            console.log("investigate");
        }

        if ($tgen.tgen_hits==undefined) $tgen.tgen_hits= [];

        for (var i=0; i < tgen_hits.length; i++){
            var tgen_match = tgen_hits[i];

            /**********************************************/
            //we can safely call this function multiple times
            //for the same circ match on new updates to data which this points to again.
            //already made this one.
            if ($tgen.backlink_uids==undefined) {
                $tgen.backlink_uids = new Object();
            }
            else if (tgen_match.parent_tgen!=null && $tgen.backlink_uids[tgen_match.tnid+"_"+tgen_match.parent_tgen.tnid]!=undefined) {
                continue;
            }
            else if (tgen_match.parent_tgen==null && $tgen.backlink_uids[tgen_match.tnid]!=undefined) {
                continue;
            }
            
            if (tgen_match.parent_tgen!=null) $tgen.backlink_uids[tgen_match.tnid+"_"+tgen_match.parent_tgen.tnid]=true;
            else $tgen.backlink_uids[tgen_match.tnid]=true;
            
            $tgen.tgen_hits.push(tgen_match);
        }
    }




    /**
     * Single tgen just added to a circ.
     * @param {*} $tgen 
     */
    findCompsSingleAdded = async($tgen)=> {
        var circ = null;
        if ($tgen.circ_id==0) circ = this.C._aCircuits[1];
        else circ = this.C._aCircuits[0];
        //console.log("(findCompsSingleAdded) audit %c"+$tgen.audit+" %cgen %c"+$tgen.gen, ANNE.TALK.bggreen, ANNE.TALK.bgblack, ANNE.TALK.bgyellow);
        await this.findComps($tgen, circ);
    }



    /**
     * Turn the circuit on/off when toggled (just like the other circuits)
     * gen = 0 compare circuit.
     * @param {*} $tgen 
     * @returns 
     */
    toggleCompareCircuit = async($tgen=null)=>{
        console.log("%c(this.toggleCompareCircuit)", ANNE.TALK.bggreen);
        
        if ($tgen==null) $tgen = this.C._aCircuits[2].root_tgen;

        if ($tgen.bANIMATING==true) {
            ANNE.playSound("error_soft");
            return;
        }

        var y = 0;
        var nObj = MEMG.getNeuronByTempNid($tgen.tnid);   

        //compare is open, let's close it.
        if ($tgen.bOPEN==true) {
            y = 0;
            $tgen.bOPEN=false;
            await this.ACE.hideNeuronDisplay();
        }

        else if ($tgen.bOPEN==false) {

            //turn all lbls in the CIRC 0 and CIRC 1 OFF.
            //we only need the lbls that are relevant to the matches.
            this.C._aCircuits[0].turnOffAllForCirc(this.C);
            this.C._aCircuits[1].turnOffAllForCirc(this.C);

            //CLOSE BOTH CIRCUITS.
            //this.C.closeOnlyIfOpen(this.C._aCircuits[0]);
            //this.C.closeOnlyIfOpen(this.C._aCircuits[1]);

            //when we open them again via the compline we will only open the CIRC_MATCH_LINEAGE.
            y = 100;
            $tgen.bOPEN=true;
            
            this.C.camToCircuit_outter($tgen.circ.circ_id);
        }

        //lift or lower the circuit if it is clicked (or when it is added for default, lift)
        const THIS = this;
        const C = this.C;


        C.ta.gsap.to($tgen.mesh.position, {
            ease:"power1-in",
            duration: .5,
            y: y,
            onUpdate: function() {
            },
            onComplete: async()=> {
                if ($tgen.bOPEN==true) {
                    //we should do a special COMP DISPLAY IN THE NEURON DISPLAY!
                    await THIS.ACE.showNeuronDisplay(nObj, $tgen);
                    THIS.setCompLine($tgen);
                    THIS.ACE.processingDone(true);
                }
                else {
                    THIS.removeCompLine($tgen);
                    THIS.ACE.processingDone(false);
                }
            }
        } );
    }


    /**
     * Set the green compare line of orbs.
     * Cascade through the circuits to highlight the matches.
     * 
     * Here we want to set the locations of the line of compare matches (green box line of tgen gen1s)
     * This is like setHalos.  It is setting the placement of the green boxes.
     * 
     * @param {*} $tgen 
     */
    setCompLine = function($tgen) {
        console.log("%c(this.setCompLine) %c"+$tgen.audit, ANNE.TALK.bggreen, ANNE.TALK.bgyellow);
        
        //this.C.setOrbitPtByCIndex($tgen.circ.c_index, true);
        var nids = $tgen.tgens.length;  //number of next gen neurons in this circuit.

        //this just makes a series of points to place the matches in the compare circuit.
        //we want a LINE in between the circuits (not a halo)
        function genSeries($vals, $total) {
            let value = 0;
            let increment = 77;
            var seriesNEW = [];
            
            if ((($total+2) % 2) != 0) seriesNEW.push(0); //use 0 slot if odd.

            for (let i = 1; i <= $vals; i++) {
                if (i % 2 === 0) {
                    value -= increment;
                } 
                else {
                    value += increment;
                }
                seriesNEW.push(value);
                increment += 122;
            }
            return seriesNEW;
        }

        if (this._series.length==0) {
            this._series = genSeries(30, $tgen.tgens.length);
        }
        else {
            if (this._series.length < $tgen.tgens.length) {
                this._series = genSeries(nids+30, $tgen.tgens.length);
            }
        }

        for (var i=0; i < $tgen.tgens.length; i++) {
            const tgen = $tgen.tgens[i];
            tgen.mesh.material.color.setHex(this.C.YELLOW);

            //bi-pass for downline matches within a higher circuit.  We don't need this.
            if (tgen.parent_tgen!=null && tgen.parent_tgen.CIRC_MATCH==true) continue;

            //only draw them ONE TIME (adding them to the lines arrays)
            //this is only drawing the a relon from our comp match top (green box)
            //to the actual comp matches (new green boxes)
            if (tgen.primaryRelon==undefined || tgen.primaryRelon==null) {
                this.C.drawRelons(tgen, false);
            }

            //a line of boxes.. first in 0,0,0 the staggering left/right on the Z axis to for a Z axis line
            //that should split the center of the 2 existing circs we are comparing.
            var y = 300;
            var x = 0;
            var z = this._series[i];

            tgen.mesh.visible=true;
            tgen.mesh.opacity=1;
            var delay = 0;

            const C = this.C;
            const THIS = this;

            (function($tgenEnclosed) {
                delay+=.2;
                $tgenEnclosed.bANIMATING=true;
                C.ta.gsap.to( $tgenEnclosed.mesh.position, {
                    ease:"sine-in",
                    duration: .5,
                    delay: delay,
                    x:x,
                    z:z,
                    y:y,
                    onUpdate: function() {
                        C.updateRelons($tgenEnclosed.in_bound_lines, $tgenEnclosed.mesh);
                    },

                    //we also want to draw the match relons ready for display.
                    onComplete: async()=> {
                        $tgenEnclosed.bANIMATING=false;
                        $tgen.bANIMATING=false;
                        //console.warn("TO DO:  REDO BACKLINK FOR COMP TGEN "+$tgenEnclosed.tnid);

                        //on first toggle create the default com circ backlinks
                        //we can add to these if the other circuits grow with more unique hits.
                        if ($tgenEnclosed.init_backlinks_made==false) {
                            THIS.createCompCircBacklinks($tgenEnclosed);
                            $tgenEnclosed.init_backlinks_made = true;
                        }
                        if ($tgenEnclosed.primaryNeuronLbl!=null) {
                            ANNE.A.show($tgenEnclosed.primaryNeuronLbl.element);
                        }

                        //turn on this comp as if it were clicked.
                        await THIS.toggleCompareSpheres($tgenEnclosed);
                    }

                } );

            })(tgen);
        }
    }

    

    /**
     * 
     * @param {*} $tgen 
     * @param {*} $time_factor 
     * @param {*} $relativeDepth 
     * @returns 
     */
    removeCompLine = function($tgen, $time_factor=.7) {
        if ($tgen.tgens.length==0) {
            $tgen.bANIMATING=false;
            return;
        }
        var bDORELONLBLS = true;
        for (var i=0; i < $tgen.tgens.length; i++) {
            const tgen = $tgen.tgens[i];
            if (tgen.mesh==null) continue;
            if (tgen.relonLbl) ANNE.A.hide(tgen.relonLbl.element);
            tgen.hideInboundLineLbls(); //this should hide the lines ????
            //use enclosed func here to prevent dramas.
            const THIS=this;
            const C = this.C;

            (function($tgenEnclosed) {
                $tgenEnclosed.bANIMATING=true;
                C.ta.gsap.to( $tgenEnclosed.mesh.position, {
                    ease:"power2.InOut",
                    duration: 1.5*$time_factor,
                    x:0,
                    z:0,
                    y:0,
                    onUpdate: function() {
                        if (bDORELONLBLS==true) C.updateRelons($tgenEnclosed.in_bound_lines, $tgenEnclosed.mesh);
                    },

                    onComplete: function() {
                        if ($tgenEnclosed.primaryNeuronLbl) ANNE.A.hide($tgenEnclosed.primaryNeuronLbl.element);
                        $tgenEnclosed.bOPEN=false;
                        $tgenEnclosed.mesh.visible=false;
                        $tgenEnclosed.bANIMATING = false;
                        $tgenEnclosed.mesh.material.color.setHex(C.YELLOW);
                    }
                } );
            })(tgen);
        }
    }



    /**
     * This will be fun --
     * Tie the clicked on compare to the matching TGEN in the target circuits.
     * (visual aid)
     * @param {*} $tgen 
     */
    toggleCompareSpheres=async($tgen)=> {
        if ($tgen.bOPEN==true) {
            $tgen.bOPEN=false;
            //ANNE.A.hide($tgen.primaryNeuronLbl.element);
            $tgen.mesh.material.color.setHex(this.C.YELLOW);
            for (var t=0; t < $tgen.tgen_hits.length; t++) {
                this.C.deEmphasizePath($tgen.tgen_hits[t]);
            }
        }
        else if ($tgen.bOPEN==false) {
            $tgen.bOPEN=true;
            //ANNE.A.show($tgen.primaryNeuronLbl.element);
            $tgen.mesh.material.color.setHex(this.C.GREEN);
            for (var t=0; t < $tgen.tgen_hits.length; t++) {
                await this.C.openAndGreenifyPath($tgen.tgen_hits[t]);
            }

            this.fomulatePathways();
        }
    }


    /**
     * 
     */
    fomulatePathways=function() {
        this._meta_pathways = [];
        
        var circB_tnid = this.C._aCircuits[1].nObj.temp_nid;

        //tgens here are UNIQUE MATCHING NEURONS.
        //multiple gens and multiple ways to match are inside the tgen_hits
        for (var t=1; t < this.tgens.length; t++) {
            var tgen = this.tgens[t];
            var pathObj = new circuit_pathway(tgen.tnid);
            if (tgen.tgen_hits==undefined || tgen.tgen_hits.length==0) continue;

            //the various ways the tnid match occured.  Each circuit (a/b) can have multiple ways
            //it put a concept in the circuit.
            //we want to tally each way in this single PATHWAY object for each respective circuit so we 
            //can compare apples to apples on how these concept matched.
            for (var h=0; h < tgen.tgen_hits.length; h++) {
                var tgenHit = tgen.tgen_hits[h];
                
                var maxsteps = this._compareDepth;
                
                //deeper than our present compare depth.
                if (tgenHit.gen > this._compareDepth) {
                    console.log("tgen "+tgenHit.tnid+" is too deep at gen "+tgenHit.gen);
                    continue;
                } 

                var tgenHitNOBJ = MEMG.getNeuronByTempNid(tgenHit.tnid);

                //if the match is a class (like "politician") we don't care 
                //if the friend of a friend who went to a meeting had a poltician there.
                //that's not a relevant match in this usage.
                if (tgenHitNOBJ.ntype==NTYPE_CLASS) {
                    maxsteps=2;
                }
    
                var path = [];
                var circLetter = "a_pathways";
                
                if (tgenHit.circ.nObj.temp_nid==circB_tnid) {
                    circLetter = "b_pathways";
                }

                var bDITCHIT=false;
                while(tgenHit!=null && tgenHit.initiating_rel!=null) {
                    path.push(tgenHit.initiating_rel);
                    tgenHit = tgenHit.parent_tgen;
                    if (path.length>maxsteps) {
                        bDITCHIT=true;
                        break;
                    }
                }
                
                if (bDITCHIT==false) {
                    path.reverse();
                    pathObj[circLetter].push(path);
                }
            }

            if (pathObj.a_pathways.length && pathObj.b_pathways.length) {
                this._meta_pathways.push(pathObj);
            }
        }

        //at this point we have pathway objects that each have .a and .b arrays of paths.
        //a path is itself an array of connected relons to get from the top to the terminating leaf/node of the match.

        this.fomulatePathwayLanguage();
    }


    /**
     * 
     */
    fomulatePathwayLanguage=function($bDOOUTPUT=true) {

        //all pathways to common matches.
        //each specific match gets a meta_pathway obj.
        console.log("META PATHWAYS:"+this._meta_pathways.length);
        for (var m=0; m  <this._meta_pathways.length; m++) {
            var pathwayObj = this._meta_pathways[m];
            var nOBJ = MEMG.getNeuronByTempNid(pathwayObj.tnid);
            console.log("%c ________"+nOBJ.text+"____", ANNE.TALK.bgyellow);
        }

        //loop each one and provide an explanation of the match.
        for (var m=0; m  <this._meta_pathways.length; m++) {
            var pathwayObj = this._meta_pathways[m];
            var nOBJ = MEMG.getNeuronByTempNid(pathwayObj.tnid);
            console.log("%c matches ____(start)____"+nOBJ.text+"____", ANNE.TALK.bgred);
            console.log("a_pathways:"+pathwayObj.a_pathways.length);
            console.log("b_pathways:"+pathwayObj.b_pathways.length);
            
            if (pathwayObj.a_pathways.length>0) {
                var bDOINGUNBALANCED = false;

                //each meta pathway can have multiple entries for a, and/or b on how this 
                //concept got into its circuit.
                //we should atleast have one a and one b rel for each item, othewise,
                //they shouldn't have been matched.
                for (var p=0; p < pathwayObj.a_pathways.length; p++) {
                    var a_pathways  = pathwayObj.a_pathways[p];
                    ANNE.TALK.printRelons(a_pathways, true, false, ANNE.TALK.bgred);
                    
                    var b_pathways  = null;
                    if (p < pathwayObj.b_pathways.length) b_pathways = pathwayObj.b_pathways[p];
                    var mvb = "";
                    var wds = [];

                    //figure this out later
                    if (b_pathways==null) continue;
                    ANNE.TALK.printRelons(b_pathways, true, false, ANNE.TALK.bgred);
                    
                    for (var aa=0; aa < a_pathways.length; aa++) {
                       
                        if (aa==0) {
                            var a_pathway_rel = a_pathways[aa];
                            var b_pathway_rel = b_pathways[aa];
                            
                            //dreamy.  direct hit.
                            if (a_pathway_rel!=undefined && b_pathway_rel!=undefined && a_pathway_rel.r==b_pathway_rel.r) {
                                wds.push("Both");
                                if (a_pathway_rel.type==TYPE_BE) wds.push("are"); 
                                else if (a_pathway_rel.type==TYPE_HAS) wds.push("have");
                                
                                var relnNOBJ = MEMG.getNeuronByTempNid(a_pathway_rel.r);
                                var relndetwd = TALK.getDet2(relnNOBJ);
                                wds.push(relndetwd);
                                var bNOTODET=false;
                                if (relnNOBJ.nid==MEM.occupation.nid) {
                                    wds.push("of");
                                    bNOTODET=true;
                                }
                                if (a_pathway_rel.to_type==TO_TYPE_ANNE) {
                                    var toNOBJ = MEMG.getNeuronByTempNid(a_pathway_rel.t);
                                    if (bNOTODET==false) {
                                        var todetwd = TALK.getDet2(toNOBJ);  //the, a, an (insts will be the or nothing)
                                        wds.push(todetwd);
                                    }
                                    else wds.push(toNOBJ.text);
                                    
                                    if (toNOBJ.ntype==NTYPE_INST) {
                                        var beNOBJ = MEMG.getNeuronByTempNid(toNOBJ.bes[0]);
                                        wds.push(beNOBJ.text);
                                    }
                                }
                                else wds.push(a_pathway_rel.to_s);  

                                pathwayObj.ab_talk = wds.join(" ").trim()+".";
                                console.log("%c"+pathwayObj.ab_talk, ANNE.TALK.bggreen);
                            }
    
                            //do individual verbalization, put them in their respective splots.
                            //then join them.
                            else {
                                bDOINGUNBALANCED=true;
                            }       
                        }
                    }   
                }
            }
            console.log("%c matches __________(end)____________________", ANNE.TALK.bgyellow);
        }

        if ($bDOOUTPUT==true) this.outputPathwayLang();
    }


    
    /**
     *
     */
    outputPathwayLang=function() {
        for (var m=0; m  <this._meta_pathways.length; m++) {
            var pathwayObj = this._meta_pathways[m];
            if (pathwayObj.ab_talk!="") {
                var el_match = document.createElement("div");
                el_match.classList = "neuron-match-final";
                var el_talk = document.createElement("span");
                el_talk.classList = "neuron-match-talk";
                el_talk.innerHTML = pathwayObj.ab_talk;
                el_match.appendChild(el_talk);
                if (this._el_rez_talk==null) this.ACE.addElToConsole(el_match); 
                else this._el_rez_talk.appendChild(el_match);
            }
        }
    }
    

    getTgenRaw = function($tnid) {
        for (var t=0; t < this.tgens.length; t++) {
            if (this.tgens[t].tnid==$tnid) return this.tgens[t];
        }
        return null;
    }
}




     /**********************************************/

        /** 
        const points = [];
        var start=new this.C.ta.THREE.Vector3(0,0,0);
        points.push(start);
        points.push(start);

        //don't show at first until animate.
        let geometry = new THREE.BufferGeometry().setFromPoints(points);
        var color = this.C.GREEN;
        var line = new THREE.Line(
            geometry,
            new THREE.LineBasicMaterial({ color: color, transparent:true, linewidth: 2 })
        );
    
        geometry.setDrawRange( 0, 2 );  //$tgen.circ.color
        line.relon = null;

        line.match_mesh = tgen_match.mesh;
        line.match_tgen = tgen_match;
        
        line.comp_tgen = $tgen;
        tgen_match.comp_tgen = $tgen;
        
        //match line will animate from green box outward towards the matching tgen in the circuits.
        //lines are STILL stored on the inbound receiver of the line.  They are anchored in the FROM.  
        $tgen.mesh.add(line);
    
        $tgen.circ.lines.push(line);
        $tgen.out_bound_lines.push(line);
        
        if (tgen_match.comp_backlinks==undefined) tgen_match.comp_backlinks=[line];
        else tgen_match.comp_backlinks.push(line);
        */

        /*
        for (var l=0; l < $tgen.out_bound_lines.length; l++) {
            const line = $tgen.out_bound_lines[l];
            line.geometry.attributes.position.needsUpdate = true;

            this.C.ta.gsap.to(line.geometry.attributes.position.array, {
                duration: 2, 
                ease:"sine-in",
                delay: 0, 
                endArray: [0, 0, 0, 0, 0, 0],
                onUpdate: () => {
                  // Update the line's geometry
                  line.geometry.attributes.position.needsUpdate = true;
                },
                onComplete: function() {
                    $tgen.bANIMATING=false;
                    $tgen.bOPEN=false;
                }
              });

        }
        */


        /** 
        console.log("backlinks "+$tgen.out_bound_lines);
        for (var l=0; l < $tgen.out_bound_lines.length; l++) {
            const line = $tgen.out_bound_lines[l];
            line.geometry.attributes.position.needsUpdate = true;
           
            this.C.openAndGreenifyTGENLINE(line, line.match_tgen);
           
            var vEnd = this.C.spaceAtoSpaceB(line.match_mesh, $tgen.mesh);
            this.C.ta.gsap.to(line.geometry.attributes.position.array, {
                duration: 2, 
                ease:"sine-in",
                delay: 0, 
                endArray: [ 0, 0, 0, vEnd.x, vEnd.y, vEnd.z],
                onUpdate: () => {
                  line.geometry.attributes.position.needsUpdate = true;
                },
                onComplete: function() {
                    $tgen.bANIMATING=false;
                    $tgen.bOPEN=true;
                }
              });
        }
        */