//used for collabs and ghosts.
class history_cg  {
    constructor(){
        this._aHistory = []; 
        this.pullid = 1; 
        this._lastMyTxHeight = 0;   
        this._lastTxIndex = 0;
        this.my_last_block_index = 0;
    }

    getNextPullID = function () {
        var pullid = this.pullid;
        this.pullid +=1;
        return pullid;
    }

    /**                                                  
     * 
     * @author {Mr.Scatman}
     */
    processPullHistory = function ($aFullPullHistory) {
        var maxpullid = 0;
        if ($aFullPullHistory!=undefined && $aFullPullHistory!=null) {
            this._aHistory = $aFullPullHistory;
            for (var h=0; h < this._aHistory.length; h++) {
                var hObj = this._aHistory[h];
                if (hObj.pullid > maxpullid) maxpullid = hObj.pullid;
                hObj.bDIDIDB = false;
            }
        }

        this.pullid = maxpullid + 1;
    }

    
    /**
     * For functions where we get the latest height in the API return
     * we can manually update this without looping/checking
     * Much cleaner.
     */
     manuallyUpdatePullHistory=async($phObj, $lastBlock=null)=>{
        if ($lastBlock==null) $lastBlock = ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK+1;
        $phObj.lastBlock = $lastBlock;

        if ($phObj.pullid==0) {
            $phObj.pullid = HISTORY.getNextPullID();    
            console.log("%c ((inserting new history record with pullid:"+$phObj.pullid+" "+$phObj.functionName+" target:"+$phObj.functionName+"))", 'background: white; color: green');
            var done = await ANNE.DB_local.___update($phObj, "fullPullHistory");   
        }

        //if we had new info, update it.
        else {
            var done = ANNE.DB_local.___update($phObj, "fullPullHistory");    //update the localDB record
        }
    }

    

    /**
     * Get the last block we found results using this exact query.
     * 
     * Try to save processing/pull attempts by looking for this pull obj.  
     * We will still try to pull from the blockchain but with a min block  
     * number from the last known spot we already pulled in data for this  
     * type of pull.                                                       
     * 
     * @author {Mr.Scatman}
     */
    getLastBlockFromPullHistory = function($prefix, $functionName, $target, $extra=null) {
        var extra="";
        if ($extra!=null) extra=$extra;

        if (this._aHistory.length==0) {
            console.log("%c NO HISTORY ---- U SHOULD SEE THIS ONCE for "+$functionName+" target:"+$target+" "+$extra, 'background: white; color: red');
            return this.__makeDefaultPullHistoryObj($prefix, $functionName, $target, $extra);
        }

        for (var h=0; h < this._aHistory.length; h++) {
            var phObj = this._aHistory[h];
            if (phObj.prefix!=$prefix || phObj.functionName!=$functionName || phObj.target!=$target) continue;
            if (extra!="") {
                if (phObj.extra!=$extra) {
                    continue;
                }
            }
            console.log("%c history - we found a pull history object for function: "+$functionName+" target:"+$target, 'background: green; color: white');
            console.log(phObj);
            return phObj;
        }

        //we had history in our  history object, but not for THIS entry.
        //console.warn("temp new HISTORY object (will save if we find results) for ", $prefix, $functionName, $target);
        return this.__makeDefaultPullHistoryObj($prefix, $functionName, $target, $extra);
    }


    /**
     * IS THIS BEING USED????
     * 
     * We just need to get the highest height so we know
     * how to optimize our transaction pulls on the ANNE ID page.
     * 
     * We will do pulls to get the TXs list anytime we need it.
     * We do not need it hanging around in memory as we already have
     * a high enough local-RAM mem burden with relons.
     */
    preProcessStoredConfirmedTXs = function($stored_txs){
        for (var c=0; c < $stored_txs.length; c++) {
            if ($stored_txs[c].height > this._lastMyTxHeight) this._lastMyTxHeight=$stored_txs[c].height;
        }
        this._lastTxIndex = $stored_txs.length;
    }




    /**
     * DEPRECATED
     * we should emulate our transaction format so we can
     * process mined blocks in the payouts display with the same code.
     */
    processBlocks = function($my_blocks) {
        console.log("%c processBlocks "+$my_blocks.length, TALK.bgredbig);
        console.log($my_blocks);
        
        //calc actual block reward based on % via block number algo.

        var blocks = [];  //timestamp, scoopnum ?
        for (var b=0; b < $my_blocks.length; b++) {
            var block = $my_blocks[b];
            var emulated = {};
            emulated.blockid = "blockid_"+block.block;
            emulated.txid = "";
            emulated.type = "block";
            emulated.annies = parseInt(block.blockRewardNQT);
            emulated.fee = 0;
            emulated.height = block.height;
            emulated.confirmations = 1;
            
            emulated.miningObj = ANNE.reward(emulated.annies, block.height, block.totalFeeNQT);
            //console.log(emulated.miningObj);

            emulated.net_chg = parseInt(emulated.miningObj.mining_reward)+parseInt(emulated.miningObj.fees);

            emulated.anne_app_user = ANNE.USER._userNObj.nid;
            emulated.recipient = ANNE.USER._userNObj.nid;
            emulated.sender=null;
            emulated.downs = 0;
            emulated.sent_tx=false;
            emulated.attach=false;

            blocks.push(emulated);
        }

        if ($my_blocks.length) {
            USER.bMINER=true;
            USER._blocksMined = blocks;
        }

        this.my_last_block_index = 0;
        return blocks;
    }

    /**
     * This will preset our optmizer value for height
     * so we can properly filter (start index) the TXs when pulling them from the ANNODE
     */
    getAndProcessOURTXS_bootup=async()=>{
        var ourTXs = await this.getAndProcessOURTXS();
        this.preProcessStoredConfirmedTXs(ourTXs);
    }


    /**
     */
     getAndProcessOURTXS = async()=> {
        var aTXS =  await DB_local.__getStoredTxs();
        if (aTXS==null || aTXS.length==0) return [];
        var ours = [];
        for (var t=0; t< aTXS.length; t++) {
            if (aTXS[t].anne_app_user!=USER._userNObj.nid) continue;
            ours.push(aTXS[t]);
        }
        return ours;
    }


    /**
     * @author {Mr.Scatman}
     */ 
    __makeDefaultPullHistoryObj=function($prefix, $functionName, $target, $extra=null) {
        var phObj = new Object();
        phObj.prefix = $prefix;
        phObj.functionName = $functionName;
        phObj.target = $target;
        phObj.extra = $extra;
        phObj.lastBlock = ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK;
        phObj.pullid = 0;               //we will set this to the next one in line if we are going to insert the record
        phObj.bDONETHISSESSION = false; //for ANNE API optimzation
        phObj.bDIDIDB = false;          //for RAM optimization.
        this._aHistory.push(phObj);
        return phObj;
    }
}

const HISTORY_LOCAL = new history_cg ();