
class page_gui {

    /**
     * @param {string} $page
     * @param {page_params} $pObj
     */
    constructor($page, $pObj=null) {
        if ($pObj!=null) {
            if (($pObj instanceof page_params) == false) {
                $pObj=null;
                throw("you passed in a non page_params pObj!");
            }
        }
        this._guid="";
        this.bISOPEN = false;
        this.INST = null;
        
        this.loadedAsModal = false;
        this.loadedAsSiteTab = false;
        this.loadedAsPart = false;

        this.tab_parent_gui = "";       //this pgui is being used as a tab and inside a tabber!
        this.tab_title_override = "";   
        this.spacevar = "";
        this.proper_divid = $page.divid;

        if ($page.spacevar!="") this.spacevar=$page.spacevar;
        if ($page.display!="") this.name = $page.display;

        this.page = $page;              //the nf_page template
        this.pObj = $pObj;              //default params obj.
        
        this._pgui_children = [];
        this._parent_pgui = null;

        //set the _guid... it is important to use the setter if the guid exists..
        //that will also set the proper divid
        if (this.pObj 
            && this.pObj.guid!=undefined 
            && this.pObj.guid!=null 
            && this.pObj.guid!="") this.guid=$pObj.guid;
        else this._guid = ""; 
        
        if ($pObj!=null) {
            if ($pObj.guid!=undefined && $pObj.guid!=null) this.guid = $pObj.guid;
        }
        else this.pObj = new page_params();

        
    }

    get render_type () { 
        console.warn("THIS IS A COURTESY TO REMIND YOU THAT THIS PROP DOESN'T EXIST ON THIS OBJECT.  IT IS ON THE PAGE TEMPLATE!");
        return this.page.render_type; 
    }
    
    /**
     * @param {string} $guid
     */
    set guid ($guid) {  //proper_divid must be set anytime we get a guid.
        this._guid = $guid; 
        if ($guid.length) this.proper_divid = this.page.divid+"_"+$guid;
    }
    get guid () { return this._guid; }


    /***
     * we don't call this until the page is loaded. 
     * we activate the local close button 
     * (if it is defined as {divid}_close_btn)
     */   
    autoWireClose = function() {
        if (this.page.active_close_div==false) return;
        if (this.loadedAsModal==true) return;
        if (this.loadedAsSiteTab==true) return;
        
        var closebtn = null;
        if (this.guid!="") closebtn = document.getElementById(this.page.divid+"_close_btn_"+this._guid);
        else closebtn = document.getElementById(this.page.divid+"_close_btn");
        
        if (closebtn && closebtn.length) {
            ANNE.A.show(closebtn);
            var pgui = this;
            closebtn.click(function() { pgui.close();});
        }
    }


    /**
     */
    loadPart = async($pageid, $pObj, $bMODALONETIME=false, $bINJECTEDASPART=false)=> {
        var child_pgui = await ANNE.PAGES.openPart($pageid, $pObj, $bMODALONETIME, $bINJECTEDASPART);
        if (child_pgui==undefined || child_pgui==null) return; //gotta exit now.. oops
        child_pgui._parent_pgui = this;
        this._pgui_children.push(child_pgui);
        return child_pgui;
    }

    getChildPguiByGuid = function($guid) {
        for (var c=0; c < this._pgui_children.length; c++) {
            var pguic = this._pgui_children[c];
            if (pguic._guid==$guid) return pguic;
        }
        return null;
    }

    getChildPguiByDivid = function($divid) {
        for (var c=0; c < this._pgui_children.length; c++) {
            var pguic = this._pgui_children[c];
            if (pguic.page.divid==$divid) return pguic;
        }
        return null;
    }

    removeFromChildPguiTrackers = function($pgui) {
        for (var c=0; c<this._pgui_children.length; c++) {
            if (this._pgui_children[c].guid==$pgui._guid) {
                this._pgui_children.splice(c,1);
                return;
            }
        }
        return;
    }
  
    close = function($onetimeCallback=null, $bNOCALLBACKS=false) {
        ANNE.PAGES.close(this.page.divid, this.guid, $onetimeCallback, $bNOCALLBACKS);
    }

    closeAllChildren = function() {
        for (var c=0; c < this._pgui_children.length; c++) {
            var bNOCALLBACKS = true;
            ANNE.PAGES.close(this._pgui_children[c].page.divid, this._pgui_children[c].guid, null, bNOCALLBACKS);
        }
        this._pgui_children = [];
    }
}