
class awarvu_ring {

    /**
     * 
     * @param {*} $scene 
     * @param {*} $ANX 
     * @param {*} $apxSumObj 
     * @param {*} $outter_r 
     * @param {*} $inner_r 
     * @param {*} $stepsFactor 
     * @param {*} $animMS 
     * @returns 
     */
    constructor ($scene, $ANX, $apxSumObj, $outter_r=420, $inner_r=72, $stepsFactor=2, $animMS=1000) {
        this.scene = $scene;
        this.rot_index = 0;
        this.ANX = $ANX;
        this.apxSumObj = $apxSumObj;
        this.bCATASTROPHIC = false;
        
        if (this.apxSumObj==null) {
            console.warn("apxSumObj is NULL.  This is key in making a awarvu_ring");
        }
        
        if (this.apxSumObj!=null && this.apxSumObj._aplex!=null) {
            this._aplex = this.apxSumObj._aplex;
        }
            
        else this._aplex = null;
        
        this.ID = UTILS.randHex(6); // not sure we need this. 
        this.bDOINGARINGTUNNEL= false;

        this._lookatLbls = []; //used when in the ring to optimize (not in ANX anymore)

        if (this.apxSumObj==null) {
            //we're going to need to chase OR emulate this.
            this.bCATASTROPHIC = true;
            alert("fix this, missing apxSumObj");
            return;
        }

        if ($apxSumObj!=null) {
            this.target_nid = $apxSumObj.nid;
        }
        else this.target_nid=null;

        this.nObj = MEMG.getNeuronByNid(this.target_nid);

        if (this.target_nid==MEM.___SELF___.nid) {
            this.primaryName = "ALL of ANNE";
        }
        else this.primaryName = this.nObj.bestNameHTML();

        console.log(this.apxSumObj);

        this.outter_r = $outter_r;
        this.inner_r = $inner_r;
        this.stepsFactor = $stepsFactor;
        this.animMS = $animMS;

        this.maxSteps = parseInt(this.stepsFactor) * 100;        
        this.radStep = (Math.PI * 2) / this.maxSteps; 
        this.tubeRadius = this.inner_r/12;

        this.lastActiveSection = null;
        this.lastActiveBucket = null;

        this._callbackBucketHover = null;
        this.ARing = null;
        this.ATunnel = null;

        this._hoverableSections = [];

        this.elHolder = null;
        this.elHolder2 = null;
        
        //when in annex view, turn these off to minimize distraction.
        this.bHOVERABLESACTIVE = true;

        this.bANNEXABLE = true; //until turned false;
    }

    
    /**
     * cleanup the ring..
     */
    cleanup = function() {

        //if ring had a tunnel, clean up the tunnel first
        if (this.ATunnel!=null) {
            this.ATunnel.cleanup();   //removes tubes
            this.ATunnel = null;
        }

        this.ARing.remove(this.centerLbl);

        this.ARing.remove(this.rotatedHolder);
        this.rotatedHolder = null; //sections are in here.

        this._hoverableSections = null;
        
        this.centerLbl.element.remove();
        this.centerLbl = null;

        //remove the ring..
        this.scene.remove(this.ARing);
    }


    /**
     * 
     * @param {*} $hovObj 
     * @returns 
     */
    makeTunnel = function($hovObj) {
        if (this.ARing==null) return;
        if (this.ATunnel!=null) this.ARing.remove(this.ATunnel);

        if ($hovObj.ATYPE==AWAREZ_BUCKET) {
            this.ATunnel = new awarez_tunnel(this.ANX, this, $hovObj, this.target_nid);
        }
    }


    /**
     * should go back to default view...
     * a way to unhighlight as hovering something will alter what is visible.
     */
    backToHomeView = function() {
        if (this.lastActiveBucket!=null) {
            this.turnOffLastBucket();
            this.lastActiveBucket=null; 
        }

        if (this.lastActiveSection!=null) {
            this.deactivateSection(this.lastActiveSection);
            ANNE.A.empty(this.elBucket);
            ANNE.A.empty(this.elData);
            ANNE.A.empty(this.elData2);
            this.lastActiveSection=null; 
        }
        
        var val = "<span style='display:block' class='color-"+this.posSection.pol+"-bb'>"+this.formatPercentAndText(this.posSection.per, this.posSection.audit_name)+"</span>";
        val=val+"<span style='display:block' class='color-"+this.negSection.pol+"-bb'>"+this.formatPercentAndText(this.negSection.per, this.negSection.audit_name)+"</span>";
        ANNE.A.setHTML(this.elBucket, val+"<span style='display:block' class='color-"+this.neuSection.pol+"-bb'>"+this.formatPercentAndText(this.neuSection.per, this.neuSection.audit_name)+"</span>");
        
        //this.toggleCenter();
        //ANNE.A.removeClass(this.elRingCenterDiv, "dataon");
    }
    

    /**
     * 
     */
    initARing = async($default="awarvu", $helperObj, $bEMULATEDATA=false)=> {
        this.ARing = new THREE.Object3D();

        this.ARing.position.set($helperObj.objSpawnPosition.x, $helperObj.objSpawnPosition.y, $helperObj.objSpawnPosition.z);
        this.scene.add(this.ARing);

        this.ARing.ATYPE=AWAREZ_RING;
        this.ARing.awarezRing = this;

        //we will add items then rotate this.
        this.rotatedHolder = new THREE.Object3D();
        this.rotatedHolder.rotation.z = Math.PI/2;

        this.posSection = this.makeSection("pos", 0, 3, 0, "positive", 0x00ff00);
        this.negSection = this.makeSection("neg", 1, 4, this.posSection.barInfo.lastbar, "negative", 0xff0000);
        this.neuSection = this.makeSection("neu", 2, 5, this.negSection.barInfo.lastbar, "neutral", 0xfefe17);

        
        //if (this.ANX.hoverablesSection==undefined) {
            //console.warn("'hoverablesSection' should be defined on the instantiating object");
        //}
        this._hoverableSections.push(this.posSection);
        this._hoverableSections.push(this.negSection);
        this._hoverableSections.push(this.neuSection);

        if (this.ANX.awarez_mats==undefined) {
            console.warn("'awarez_mats array' should be defined on the instantiating object");
        }

    
        const radialSegments = this.inner_r/10;
        const tubularSegments = radialSegments*2;
        const geometry = new THREE.TorusGeometry(this.inner_r, this.tubeRadius, radialSegments, tubularSegments);
    
        for (var r=0; r < this.maxSteps; r++) {
            if (((r+this.stepsFactor)%this.stepsFactor)==0) continue; //space the bars

            var mat_i = 0;

            if (r<=this.posSection.barInfo.lastbar) mat_i = 0;
            else if (r>this.negSection.barInfo.lastbar) mat_i = 2;
            else if (r>this.posSection.barInfo.lastbar) mat_i = 1;

            var ringbar = new THREE.Mesh(geometry, this.ANX.awarez_mats[mat_i]);
            ringbar.ATYPE = AWAREZ_RINGASBAR;
            ringbar.awarezRing = this;
            ringbar.position.x = Math.cos(this.radStep*(r)) * this.outter_r;
            ringbar.position.y = Math.sin(this.radStep*(r)) * this.outter_r;
            
            ringbar.home_position = new THREE.Vector3();
            ringbar.home_position.copy(ringbar.position);

            ringbar.rotation.x = Math.PI / 2;
            ringbar.rotation.y = this.radStep*(r);

            ringbar.home_rotation = new THREE.Vector3();
            ringbar.home_rotation.copy(ringbar.rotation);
            

            if (mat_i==0) {
                this.posSection.add(ringbar);
            }
            else if (mat_i==1) {
                this.negSection.add(ringbar);
            }
            else {
                this.neuSection.add(ringbar);
            } 
        }
         
        this.elRingCenterDiv = document.createElement( 'div' );
        this.elRingCenterDiv.classList = "aring-center-div dataon show";
        this.elRingCenterDiv.setAttribute("overlay", true);
       
        this.elHolder = document.createElement("div");
        this.elHolder.classList="flexcolumn";
        this.elRingCenterDiv.appendChild(this.elHolder);

        this.elName = document.createElement("div");
        this.elName.classList.add("aring-name");
        this.elName.innerHTML = "<span class='aring-namebg'>"+this.primaryName+"</span>";
        if (this.nObj!=null) this.elName.setAttribute("title", this.nObj.nid)
        this.elHolder.appendChild(this.elName);

        //for pete's sake, get ur act together pal.
        if (this.apxSumObj.summary_type==APLEX_SUMMARY_SPECIFIC_NEURON 
            || this.apxSumObj.summary_type==APLEX_SUMMARY_IDENTITY) {
            var parentNOBJ = this.nObj.getParent();
            if (parentNOBJ==null) {
                await ANNE.CHASE.queryMinBem(this.nObj);
            }

            var elParent = document.createElement("div");
            elParent.classList = "aring-parent";
            if  (this.nObj.ntype==NTYPE_INST) {
                elParent.innerHTML = "<span style='background-color:black'><b>instance of</b>&nbsp;<span class='color-blue'>"+parentNOBJ.bestNameHTML()+"</span></span>";
            
            }
            else if (this.nObj.ntype==NTYPE_CLASS) {
                elParent.innerHTML = "<span style='background-color:black'><b>subclass of parent</b>&nbsp;<span class='color-blue'>"+parentNOBJ.bestNameHTML()+"</span></span>";
            
            }
            else {
                elParent.innerHTML = "<span style='background-color:black'><b>parent</b>&nbsp;<span class='color-blue'>"+parentNOBJ.bestNameHTML()+"</span></span>";
            
            }
            this.elHolder.appendChild(elParent);
        }

        var elNid = document.createElement("div");
        elNid.classList.add("aring-nid");
        elNid.innerHTML = "<span style='background-color:black'; color:'#00ff00'>"+this.nObj.nid+"</span>";
        this.elHolder.appendChild(elNid);

        var cp = document.createElement("div");
        cp.id="nidcpyico";
        cp.classList="aring-copy";
        var spanpre=document.createElement("span");
        spanpre.innerHTML="&#x2398";
        spanpre.classList="btn-copy";
        spanpre.title = "copy to clipboard";
        spanpre.setAttribute("data-copy", this.nObj.nid);
        spanpre.addEventListener("click", e=>ANNE.UTILS.copyToClipboard(this.nObj.nid));
        cp.append(spanpre);
        elNid.append(cp);

        this.elBucket = document.createElement("div");
        this.elBucket.classList.add("aring-bucket");
        this.elHolder.appendChild(this.elBucket);
     
        var val = "<span style='display:block' class='color-"+this.posSection.pol+"-bb'>"+this.formatPercentAndText(this.posSection.per, this.posSection.audit_name)+"</span>";
        val=val+"<span style='display:block' class='color-"+this.negSection.pol+"-bb'>"+this.formatPercentAndText(this.negSection.per, this.negSection.audit_name)+"</span>";
        ANNE.A.setHTML(this.elBucket, val+"<span style='display:block' class='color-"+this.neuSection.pol+"-bb'>"+this.formatPercentAndText(this.neuSection.per, this.neuSection.audit_name)+"</span>");
        
        this.elData = document.createElement("div");
        this.elData.classList.add("aring-data");
        this.elHolder.appendChild(this.elData);

        this.elData2 = document.createElement("div");
        this.elData2.classList.add("aring-data2");
        this.elHolder.appendChild(this.elData2);

        this.elData3 = document.createElement("div");
        this.elData3.classList.add("aring-data3");
        this.elHolder.appendChild(this.elData3);

        var fzWidgetBtn = document.createElement("div");
        fzWidgetBtn.classList = "ai-awarez-for-ring";
        this.elData3.append(fzWidgetBtn);
        var sp4=document.createElement("span");
        sp4.innerHTML = "<b>"+UTILS.commas(this.apxSumObj.fire)+"</b>";
        this.elData3.append(sp4);
        var THIS = this;
        fzWidgetBtn.addEventListener("click", $e=>{
            THIS.ANX.showFZWidgetOverlay(THIS.nObj.nid);
        })

        var bCHASE=true;
        if ($bEMULATEDATA==true) bCHASE=false;

        ANNE.A.hide("btn_nf_annex");
        ANNE.A.hide("btn_nf_awarvu");

        await this.setAnnexability($default, bCHASE);

        //override default if this isn't annexable.
        if (this.bANNEXABLE==false) $default="awarvu";
        
        this.ARing.add(this.rotatedHolder);

        const aringCSSObj = new ANNE.CSS3DObject( this.elRingCenterDiv );
        aringCSSObj.position.set( 0,0,0);
        this.ARing.add(aringCSSObj);
        this.centerLbl = aringCSSObj;

        if ($default!="awarvu") {
            this.elHolder.classList.add("hide");
        }
        else this.elHolder.classList.add("show");
    
        this.elImg = ANNE.u3js.setImgAsBackground(this.elRingCenterDiv, this.nObj);

        ANNE.A.show("neuron_footer");  
    }


    /**
     * 
     */
    handleAwarvuFooterClick=function() {
        console.log("(handleAwarvuFooterClick) clicked");
        this.toggleCenter();
    }

    
    /**
     * 
     */
    handleAnnexFooterClick=function() {
        console.log("(handleAnnexFooterClick) clicked")
        this.toggleCenter();
    }


    /**
     * 
     */
    setAnnexability = async($default="awarez", $bCHASE=false)=> {

        //chase the class info if we haven't yet.
        this.bANNEXABLE = await ANNE.ANNEX.assessAnnexability(this.nObj, $bCHASE);
        if (this.bANNEXABLE==false) return this.bANNEXABLE;

        if ($default=="awarez") {
            ANNE.A.show("btn_nf_awarvu");
            ANNE.A.hide("btn_nf_annex");
        }
        else {
            ANNE.A.hide("btn_nf_awarvu");
            ANNE.A.show("btn_nf_annex");
        }

        const THIS = this;

        this.elHolder2 = document.createElement("div");
        this.elHolder2.style.display="flex";
        this.elHolder2.style.flexDirection="column";
        this.elRingCenterDiv.appendChild(this.elHolder2);

        this.elAnnex = document.createElement("div");
        this.elAnnex.classList.add("aring-annex");
        this.elAnnex.setAttribute("overlay", true);

        this.elAnnexTop = document.createElement("div");
        this.elAnnexTop.classList.add("aring-top-annex");
        this.elAnnexTop.innerHTML="<span class='aring-annex-ico'></span><span class='aring-annex-lvl'><b class='color-green'>A</b>"+this.apxSumObj._aplex.price_lvl+"</span>";
        this.elAnnexTop.setAttribute("overlay", true);
        this.elAnnex.append(this.elAnnexTop);
       
        this.elAnnexBottom = document.createElement("div");
        this.elAnnexBottom.classList.add("aring-bottom-annex");
        this.elAnnexBottom.setAttribute("overlay", true);
        this.elAnnex.append(this.elAnnexBottom);

        var elName2 = document.createElement("div");
        elName2.classList.add("aring-name");
        elName2.innerHTML = "<span class='aring-namebg'>"+this.primaryName+"</span>";
        this.elAnnexBottom.appendChild(elName2);

        
        var sponsorNOBJ = null;
        if (this.nObj.sponsored_by!="") {
            sponsorNOBJ = MEMG.getOrMakeIfNew(this.nObj.sponsored_by);
            var bUSERISPONSOR=false;
            if (sponsorNOBJ.nid==ANNE.USER._userNObj.nid) bUSERISPONSOR=true;
        }
        
        //sponsor -- let the user click without losing where they are.
        //save a souvenir for later use.
        var elsp = document.createElement("div");
        elsp.classList = "aring-annex-sp";
        elsp.innerHTML="<b>sponsored by</b>&nbsp;";

        var makeSouv = document.createElement("span");
        makeSouv.classList="aring-sp-link";
        elsp.append(makeSouv);

        if (sponsorNOBJ!=null) {
            makeSouv.innerHTML=sponsorNOBJ.bestNameHTML();
            makeSouv.setAttribute("nid", sponsorNOBJ.nid);
            makeSouv.addEventListener("click", async e=>{
                if (sponsorNOBJ.text=="") {
                    await ANNE.API.queryNid(sponsorNOBJ.nid, [TYPE_BE]);
                    if (sponsorNOBJ.text!="") {
                        makeSouv.innerHTML=sponsorNOBJ.bestNameHTML();
                    }
                }
                var custLbl = sponsorNOBJ.bestNameHTML()+"<span style='font-size:.7rem'> (sp of "+THIS.primaryName+")</span>";
                THIS.ANX.addNeuronIdentityBtn(sponsorNOBJ, custLbl, "right_holder"); //put it in the right side
            });   
        }
        else {
           makeSouv.innerHTML="(none yet)";
        }

        this.elAnnexBottom.appendChild(elsp);

        //cost to annex
        var span_cost = document.createElement("span");
        span_cost.classList = "aring-cost";

        
                                    //($el, $val = 0, $bdclass="balance-display", $ico="annecoin-small-ico", $valClass="annecoin-balance-value") {
        ANNE.A.ezAnniesToAnneDisplay(span_cost, this.apxSumObj._aplex.calculated_cost, "balance-display-big", "annecoin-big-ico", "annecoin-balance-value-big");
        span_cost.innerHTML="<b>cost to ANNEX</b>&nbsp;"+span_cost.innerHTML;
        this.elAnnexBottom.appendChild(span_cost);
        
        if (this.apxSumObj._aplex.boosties>0) {
            var span_boosties = document.createElement("span");
            span_boosties.classList = "aring-boosties";
            ANNE.A.ezAnniesToAnneDisplay(span_boosties, this.apxSumObj._aplex.boosties, "balance-display-big", "annecoin-big-ico", "annecoin-balance-value-big");
            span_boosties.innerHTML="<b>boosties</b>&nbsp;"+span_boosties.innerHTML;
            this.elAnnexBottom.appendChild(span_boosties);
        }
        
        //last annex price
        var div2 = document.createElement("div");
        div2.style.display="flex";
        div2.style.flexDirection="row";
        this.elAnnexBottom.append(div2);

        var span_prev_price = document.createElement("span");
        span_prev_price.classList = "aring-prev-price";

        if (this.apxSumObj._aplex.prev_annex_price==0) {
            span_prev_price.innerHTML="<b>previous price</b>&nbsp;<span class='text-danger-lbl'>0</span>";
        }
        else {
            ANNE.A.ezAnniesToAnneDisplay(span_prev_price, this.apxSumObj._aplex.prev_annex_price, "balance-display-big", "annecoin-big-ico", "annecoin-balance-value-big");
            span_prev_price.innerHTML="<b>previous price</b>&nbsp;"+span_prev_price.innerHTML;
        }

        div2.appendChild(span_prev_price);

        //annies generated
        var span_gend= document.createElement("span");
        span_gend.classList = "aring-annies-generated";
        ANNE.A.ezAnniesToAnneDisplay(span_gend, this.apxSumObj._aplex.annies_in, "balance-display-big", "annecoin-big-ico", "annecoin-balance-value-big");
        span_gend.innerHTML="<b>annies generated</b>&nbsp;"+span_gend.innerHTML;
        div2.appendChild(span_gend);

        var span_data= document.createElement("span");
        span_data.classList = "aring-rel-data";

        var sp = "sponsored rels <b class='color-green'>"+UTILS.formatNumberCommas(this.apxSumObj._aplex.annex_sponsored_relons)+"</b>";
        var dt = "data rels <b class='color-green'>"+UTILS.formatNumberCommas(this.apxSumObj._aplex.non_awareness_outs)+"</b>";
        var awz = "awarez <b class='color-green'>"+UTILS.commas(this.apxSumObj.fire)+"</b>";
        span_data.innerHTML=sp+"&nbsp;|&nbsp;"+dt+"&nbsp;|&nbsp;"+awz;
        this.elAnnexBottom.appendChild(span_data);       

        //this.elAnnex.innerHTML="[gender] [religion] [political party] [tribe]";
        this.elHolder2.appendChild(this.elAnnex);
    
        if (this._aplex!=null && this._aplex.has_pending==true) {
            var el_pending = document.createElement("div");
            el_pending.classList="pending-annex-chg";
            el_pending.innerHTML="MEMPOOL HAS PENDING CHANGE";
            this.elAnnexBottom.appendChild(el_pending);
        }

        else if (bUSERISPONSOR==true) {
            var ID = 777;
            const btn_boosties = document.createElement("button");
            btn_boosties.classList = "btn-boosties fix-ptrevents show";
            btn_boosties.setAttribute("type", "button");
            btn_boosties.setAttribute("id", "annex_boosties_btn_"+ID);
            var sp_gi = document.createElement("span");
            sp_gi.classList = "boosties-green-ico";
            btn_boosties.appendChild(sp_gi);
            btn_boosties.innerHTML = "<span style='font-size:24px'>Add Boosties</span>";
            this.elAnnexBottom.appendChild(btn_boosties);

            const el_annex_boosties_amt_div = document.createElement("div");
            el_annex_boosties_amt_div.classList="hide boosties-amt";
            this.elAnnexBottom.appendChild(el_annex_boosties_amt_div);
            var el_col = document.createElement("div");
            el_col.style.textAlign="center";
            el_col.style.maxWidth = "80%";
            el_annex_boosties_amt_div.appendChild(el_col);
            
            const el_input = document.createElement("input");
            el_input.classList="rqd aring-boosties-input";
            el_input.setAttribute("size", "20");
            el_input.setAttribute("type", "text");
            el_input.setAttribute("id", "annex_bootsies_input_"+ID)
            el_input.setAttribute("placeholder", "enter annecoin");
            el_col.append(el_input);
            
            var el_col2 = document.createElement("div");
            el_col2.classList = "col2-disp";
            el_annex_boosties_amt_div.appendChild(el_col2);
         
            const btn_final = document.createElement("button");
            btn_final.classList = "btn-boosties-final2 hide";
            btn_final.setAttribute("id", "annex_boosties_final_btn_"+ID);
            btn_final.innerHTML =  "<span class='boosties-green-ico'></span><span>Submit Boosties</span>";
            el_col2.appendChild(btn_final);

            const elAB = this.elAnnexBottom;
            const NOBJ = this.nObj;
            
            //let's try to piggy back this so we don't have to redo all the events/validation etc.
            var __annex = new anne_annex_gui(null, ID, this.nObj, function($boosties) {
                THIS.ANX.boostiesNow(this.nObj, $boosties, function() {
                    var el_pending = document.createElement("div");
                    el_pending.classList="pending-annex-chg";
                    el_pending.innerHTML="MEMPOOL HAS PENDING CHANGE";
                    elAB.appendChild(el_pending);
                    NOBJ._aplex.has_pending=true;
                });
                btn_boosties.remove();
                el_annex_boosties_amt_div.remove();
            })

            //init th eevents using the annex obj.
            __annex.soloUseEvents(btn_boosties, el_annex_boosties_amt_div, el_input, btn_final);
        }

        else {
            var btn_annex = document.createElement("button");
            btn_annex.classList = "btn-annex2 fix-ptrevents show";
            btn_annex.setAttribute("type", "button");
            var sp_gi = document.createElement("span");
            sp_gi.classList = "annex-green-ico2";
            btn_annex.appendChild(sp_gi);
            btn_annex.innerHTML = "<span style='font-size:24px'>ANNEX this sponsorship</span>";
            this.elAnnexBottom.appendChild(btn_annex);

            const elAB = this.elAnnexBottom;
            const NOBJ = this.nObj;
            
            btn_annex.addEventListener("click", e=>{
                
                //after the annex it would be ideal to update the annex..
                //unsure if we want to do that until it is legit on-chain and mined tho.. hmmm.
                THIS.ANX.annexNow(THIS.nObj, function(){
                    var el_pending = document.createElement("div");
                    el_pending.classList="pending-annex-chg";
                    el_pending.innerHTML="MEMPOOL HAS PENDING CHANGE";
                    elAB.appendChild(el_pending);
                    NOBJ._aplex.has_pending=true;
                });
                btn_annex.remove();
            });
        }

        if ($default!="annex") {
            this.elHolder2.classList.add("hide");
            ANNE.A.hide("btn_nf_awarvu");
            ANNE.A.show("btn_nf_annex");
            this.bHOVERABLESACTIVE=true;
        }
        else {
            ANNE.A.hide("btn_nf_annex");
            ANNE.A.show("btn_nf_awarvu");
            this.elHolder2.classList.add("show");
            this.bHOVERABLESACTIVE=false;
        }

        return true;
    }


    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    makeLaunchSpan = function($nObj) {
        var sp = document.createElement("span");
        sp.class="btn-launch";
        var sp2=document.createElement("span");
        sp2.classList = "sq2-identity-neuron dib";
        sp.appendChild(sp2);
        sp2.innerHTML="<span>■"+$nObj.bestNameHTML()+"</span>";
        sp.addEventListener("click", e=>this.ANX.makeNewNeuronView($nObj));
        return sp;
    }


    /**
     * 
     * @returns 
     */
    toggleCenter = function() {
        //console.log("toggleCenter");
        if (this.bTOGGLEREADY==false) return;

        if (this.elHolder2==null) return;

        if (this.elHolder2.classList.contains("hide")==true) {
            ANNE.A.show(this.elHolder2);
            ANNE.A.hide(this.elHolder);

            //turn off all other stuff
            this.backToHomeView();
            this.bHOVERABLESACTIVE=false;
        }

        else {
            ANNE.A.hide(this.elHolder2);
            ANNE.A.show(this.elHolder);
            this.bHOVERABLESACTIVE=true;
        }
    }


    /**
     * 
     * @param {*} $pol 
     * @param {*} $mat_i 
     * @param {*} $mat_i2 
     * @param {*} $cutOffAdd 
     * @param {*} $audit 
     * @returns 
     */
    makeSection = function($pol, $mat_i, $mat_i2, $cutOffAdd=0, $audit="", $base_color=0x00ff00) {
        var section = new THREE.Object3D();
        section.ATYPE=AWAREZ_SECTION;
        section.mat_i = $mat_i;
        section.mat_i2 = $mat_i2;
        section.audit_name = $audit;
        section.awarezRing = this;
        section.pol = $pol;
        this.rotatedHolder.add(section);

        section.base_color = $base_color;
    
        section.per = 0;
        var bArr = null;
        var subTotal = 0;

        if ($pol=="pos") {
            section.per = this.apxSumObj.posPer;
            bArr = this.apxSumObj.bucket_pos;
            subTotal = this.apxSumObj.pos;
        }
        else if ($pol=="neg") {
            section.per = this.apxSumObj.negPer;
            bArr = this.apxSumObj.bucket_neg;
            subTotal = this.apxSumObj.neg;
        }
        else {
            section.per = this.apxSumObj.neuPer;
            bArr = this.apxSumObj.bucket_neu;
            subTotal = this.apxSumObj.neu;
        }

        var bars = 0;
        if ((section.per*this.maxSteps)>0 && (section.per*this.maxSteps)<1) bars = 1; 
        else bars = Math.round(section.per*this.maxSteps);
        
        var lastbar = bars+$cutOffAdd;
        if ($pol=="pos") bars = lastbar;

        var mid = 0;
        if (lastbar>0) mid = Math.round(lastbar/2)+$cutOffAdd;

        var slices = [];

        section.barInfo = {bars:bars, lastbar:lastbar, mid:mid, slices:slices, subTotal:subTotal};
  
        var widerad = this.outter_r+this.inner_r+this.inner_r/2;
 
        var l2steps = this.maxSteps*2;
        var onegap = ((Math.PI*2)*(1/l2steps));
        var twogap = onegap*2;
        
        var order = [];
        for (var b=0; b < bArr.length; b++) {
            var ord = {};
            var bObj = bArr[b];
            var count = bObj.count;
            var perSub = count/subTotal;
            ord.per = section.per;
            ord.perSub = perSub;
            ord.bucketObj = bObj;
            ord.section = section;
            order.push(ord);
        }

        order.sort( function($a, $b) {
            if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
            if ($a.perSub < $b.perSub) return 1;
            if ($a.perSub > $b.perSub) return -1;
            return 0;
        });
        //console.log(order);

        var thetaStart = (this.radStep*(lastbar-bars)) + onegap;
        section.slice_order = order;
        
        //furthest out we go with stuff.
        section.widerad = widerad+18;

        for (var o=0; o < order.length; o++) {
            var thetaLength =  ((Math.PI*2)*section.per*order[o].perSub) - twogap;
            const ringGeo2 = new THREE.RingGeometry( widerad, widerad+18, l2steps, 1, thetaStart, thetaLength); 
            const slice = new THREE.Mesh( ringGeo2, this.ANX.awarez_mats[$mat_i+6]); 
            
            slice.theta_start = thetaStart;
            slice.theta_length = thetaLength;

            slice.ATYPE=AWAREZ_BUCKET;
            slices.push(slice);
            slice.ord = order[o];
            slice.ord.rankz = (o+1);
            slice.mat_i=$mat_i;
            
            this.rotatedHolder.add( slice );
            thetaStart+=(thetaLength+twogap);
            this._hoverableSections.push(slice);
        }

        return section;
    }


    /**
     * if there was one on, turn it off.
     * turn this one one.
     * callback to potentially do something.
     * @param {*} $sliceMesh 
     */
    handleBucketHover=function($sliceMesh) {
        this.turnOffLastBucket($sliceMesh);
        $sliceMesh.material = this.ANX.awarez_mats[ $sliceMesh.mat_i+9];
        this.lastActiveBucket = $sliceMesh;
        this.__bucketHovered($sliceMesh);
    }


    /**
     * Show the bucket selected and all the the other buckets.
     * @param {*} $section 
     */
    showAllBucketsInSection=function($section) {
        ANNE.A.setHTML(this.elBucket, "<span class='color-"+$section.pol+"-bb'>"+this.formatPercentAndText($section.per, $section.audit_name)+"</span>");
        var title = "";
        if ($section.pol=="pos") title = "positive";
        else if ($section.pol=="neg") title = "negative";
        else if ($section.pol=="neu") title = "neutral";

        ANNE.A.emptySelf(this.elData);
        this.listAllBuckets(this.elData, $section, null, false);
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $section 
     * @param {String} $highlight_nid - nid longstring 
     * @param {Boolean} $bSHOWRANK 
     */
    listAllBuckets = function($el, $section, $highlight_nid=null, $bSHOWRANK=false) {;
        for (var s=0; s < Math.min(5, $section.slice_order.length); s++) {
            var ord = $section.slice_order[s];
            var bucketObj = ord.bucketObj;

            var bucketNOBJ = MEMG.getNeuronByNid(bucketObj.nid);
            var span = document.createElement('span');
            span.style.display="block";
            span.class="color-"+$section.pol+"-bb";
            var rankz="";
            if ($bSHOWRANK==true) {
                rankz="<span class='color-"+$section.pol+"-bb'>#"+ord.rankz+"&nbsp;"+"</span>";
            }
            var bucketPer = this.formatPercentAndText(ord.perSub, "");
            if ($highlight_nid!=null && bucketObj.nid==$highlight_nid) {
                span.innerHTML = "<b class='aring-data-highlight'>"+rankz+bucketPer+"<span class='color-"+$section.pol+"-bb'>"+bucketNOBJ.text+"</span></b>";
            }
            else {
                span.innerHTML = rankz+bucketPer+"<span class='color-"+$section.pol+"-bb'>"+bucketNOBJ.text+"</span>";
            }
            $el.append(span)
        }
    }


    /**
     * 
     * @param {*} $slice 
     */
    __bucketHovered = function($slice) {
        //turn the data lbl on to show it (with bg)
        var bucketNOBJ = MEMG.getNeuronByNid($slice.ord.bucketObj.nid);
        ANNE.A.addClass(this.elRingCenterDiv, "dataon");
        
        //section.barInfo = {bars:bars, lastbar:lastbar, mid:mid, slices:slices, subTotal:subTotal};
        //var barInfo = $ord.section.barInfo;

        var title = "";
        if (bucketNOBJ.pol=="pos") title = "positive";
        else if (bucketNOBJ.pol=="neg") title = "negative";
        else if (bucketNOBJ.pol=="neu") title = "neutral";
        
        ANNE.A.setHTML(this.elBucket, "<span class='color-"+bucketNOBJ.pol+"-bb'>"+this.formatPercentAndText($slice.ord.per, title)+"</span>");
        
        ANNE.A.empty(this.elData);

        this.listAllBuckets(this.elData, $slice.ord.section, bucketNOBJ.nid, true);

        if (this._callbackBucketHover!=null) {
           
        }
    }

    /**
     * 
     */
    resetLastBucketHTML=function(){
        ANNE.A.setHTML(this.elBucket, "");
        ANNE.A.setHTML(this.elData, ""); 
        ANNE.A.setHTML(this.elData2, "");
    }

    turnOffLastBucket =function() {
        if (this.lastActiveBucket!=null) {
            this.lastActiveBucket.material = this.ANX.awarez_mats[this.lastActiveBucket.mat_i+6];
            this.lastActiveBucket = null;
            //ANNE.A.removeClass(this.elRingCenterDiv, "dataon");
            this.resetLastBucketHTML();

        }
    }
    
    //a child ring bar has been hovered
    handleRingAsBarHover = function($ringbarObj) {
        if (this.lastActiveSection==null) {
            this.lastActiveSection = $ringbarObj.parent;
            this.activateSection(this.lastActiveSection);
        }
        else {

            //same section, do nothing.
            if ($ringbarObj.parent.uuid==this.lastActiveSection.uuid) {
                this.lightUpSection(this.lastActiveSection);    //redundant safeguard
            }

            //different section, deactivate old hover, set new.
            else {
                this.turnOffLastBucket();
                this.deactivateSection(this.lastActiveSection);
                this.lastActiveSection = $ringbarObj.parent;
                this.activateSection(this.lastActiveSection);
            }
        }
    }


    formatPercentAndText = function($per, $text) {
        var perlbl = Math.round($per*10000)/100;
        return perlbl+"% "+$text;
    }


    /**
     * 
     * @param {*} $section 
     */
    activateSection = function($section) {
        this.resetLastBucketHTML();
        ANNE.A.addClass(this.elRingCenterDiv, "dataon");
        this.showAllBucketsInSection($section);
        ANNE.A.setHTML(this.elData2, " <span class='color-"+$section.pol+"-bb'>total "+$section.audit_name+"</span><b class='aring-data2-highlight'>"+UTILS.commas($section.barInfo.subTotal)+"</b>");
        this.lightUpSection($section);
    }

    /** 
     * we want a section to start at the top of torus.
     * This is actually the "END" value of the torus
     * 
     * @param {*} $section 
     * @param {*} $cb 
     */
    rotateSectionToTop = function($section, $cb=null) {
        var barInfo = $section.barInfo;

        //we have the step indexes to rotate.
        //we can use this to calc rads and adjust the rotation.z
        var steps_to_rotate = ANNE.u3js.circStepMinPath(this.maxSteps, this.rot_index, barInfo.lastbar);

        const sect = $section;
        var inc = (steps_to_rotate*sect.awarezRing.radStep);
        console.log("%cinc "+inc, TALK.bgblackbold);

        sect.rot_index = barInfo.lastbar;

        gsap.to(sect.parent.rotation, {
            z: sect.parent.rotation.z+=inc,
            ease:"power2.in",   
            duration:.5,
            onComplete:function() {
                console.log("let's see if this worked");        
                if ($cb!=null) $cb($section);
            }
        });
    }


    /**
     * 
     * @param {*} $section 
     */
    lightUpSection = function($section) {
        var mat = this.ANX.awarez_mats[ $section.mat_i2 ];
        for (var c=$section.children.length-1; c >=0; c--) {
            if ($section.children[c].ATYPE!=AWAREZ_RINGASBAR) continue;
            if (mat==undefined || mat==null) {
                continue;
            }
            $section.children[c].material = mat;
        }
    }


    /**
     * 
     * @param {*} $obj 
     * @param {int} $mat 
     * @param {int} $c_index 
     * @param {Boolean} $bLAST 
     * @param {Number} $d 
     */
    tweenFlipMap = function($obj, $mat, $c_index, $bLAST=false, $d=.01) {
        gsap.to($obj, {
            delay:$d*$c_index,
            ease:"power2.in",
            duration: .01,
            onComplete() {
                $obj.material = $mat;
            }
        });
    }



    /**
     * 
     * @param {*} $section 
     */
    deactivateSection = function($section) {
        var mat = this.ANX.awarez_mats[ $section.mat_i ];

        for (var c=0; c < $section.children.length; c++) {
            if ($section.children[c].ATYPE!=AWAREZ_RINGASBAR) continue;
            //console.log("deactivating bar for "+$section.audit_name+" mat_i:"+$section.mat_i+" mat_i2:"+$section.mat_i2);
            
            if (mat==undefined || mat==null) {
                //console.log("LSDFJLSDFJLDJSLJSLDFJLSDFLDFJ");
                continue;
            }
            $section.children[c].material = mat;
            $section.children[c].position.copy($section.children[c].home_position);

            var euler = new THREE.Euler().setFromVector3($section.children[c].home_rotation);
            $section.children[c].rotation.copy(euler);
        }

    }
}

/**
 * 
 */
class awarez_tunnel {
    constructor($ANX, $ARing, $hovObj, $target_nid=0) {
        this.ANX = $ANX;

        if (this.ANX.camera==undefined) {
            console.warn("'camera' should be defined on instantiating ANX object");
        }
        if (this.ANX.color_array_by_base==undefined) {
            console.warn("'color_array_by_base' should be defined on instantiating ANX object");
        }
        if (this.ANX.saveRotation==undefined) {
            console.warn("'saveRotation' should be defined on instantiating ANX object");
        }
        if (this.ANX.savePosition==undefined) {
            console.warn("'savePosition' should be defined on instantiating ANX object");
        }

        this.ARing = $ARing;
        this.hovObj = $hovObj;
        this.target_nid = $target_nid; 

        this.percentage = 0.00;
        this.perStopIndex = 0;
        this.bPAUSEDATWAYSIDE=false;

        this.path = this.makePathForBucket();

        var colors = this.ANX.color_array_by_base[this.hovObj.ord.section.base_color];//.ord.section.mat_i+9

        this.PER_INCR = 0.008 / this.path.points.length; //.001 fast -- //0.0003 --slower;
        this.TUBES = new THREE.Object3D();
      
        for(var i=0;i<colors.length;i++){
            var geometry = new THREE.TubeGeometry(this.path, this.path.points.length*20, (i*2)+8, 20, true );
            var material = new THREE.MeshBasicMaterial({
            color:colors[i],
            transparent:true,
            wireframe:true,
                opacity : ((1- i/5)*0.5 + 0.1)
            });

            var tube = new THREE.Mesh( geometry, material );
            this.TUBES.add(tube);
        }

        this.ANX.scene.add(this.TUBES);

        this.ANX.savedRotation.copy(this.ANX.camera.rotation);
        this.ANX.savedPosition.copy(this.ANX.camera.position);
        this.ANX.saveZoom = this.ANX.camera.zoom;
        this.ANX.savedExposure = this.ANX.renderer.toneMappingExposure;

        
        this.ANX.bMLOOKOK = false;

        const _ANX = this.ANX;
        const THIS = this;

        var p1 = this.path.getPointAt(this.percentage);
        //var p1a = new THREE.Vector3(p1.x+this.ARing.ARing.position.x, p1.y+this.ARing.ARing.position.y, p1.z+this.ARing.ARing.position.z);
        
        var p2 = this.path.getPointAt((this.percentage + 0.01));
        //var p2a = new THREE.Vector3(p2.x+this.ARing.ARing.position.x, p2.y+this.ARing.ARing.position.y, p2.z+this.ARing.ARing.position.z);

        //these are timed for 3s in the css so the duration must be equal to get the right effect.
        this.ANX._lastARING.elRingCenterDiv.classList.add("blurFadeOut");
        
        if (this.path.points.length>6) {
            ANNE.A.play("powerup");
            ANNE.A.play("shepardtone");
        }
        
        gsap.to(this.ANX.camera.position, {
            delay:.4,
            duration:2.4,
            z:p1.z,
            y:p1.y,
            x:p1.x,
            onComplete:function(){
                ANNE.A.play("swoosh");
                THIS.ARing.bDOINGARINGTUNNEL=true;
                _ANX.camera.lookAt(p2);
                THIS.ARing.elRingCenterDiv.classList.remove("unBlurFadeIn");
            }
        });
   
        gsap.to(this.ANX.camera, {
            delay:.4,
            zoom:2.94,
            ease:"none",   
            duration:2,
            onComplete:function() {
                console.log("audit "+_ANX.camera.zoom);
            }
        });
    }




    /**
     * Make pts for a journey that is along the outter edge of the bucket arc that was clicked.
     * We will build a tunnel and traverse through it, in time.
     * @returns {Array} THREE.CatmullRomCurve3
     */
    makePathForBucket = function() {

        const globalPosition = this.ARing.ARing.position.clone();
        const globalRotation = this.ARing.ARing.quaternion.clone();

        console.log(this.hovObj);
        console.log(this.hovObj.parent.awarezRing);
        console.log(this.hovObj.ord.bucketObj);

        var total_leafs = this.hovObj.ord.bucketObj.count;
        var pts = null;

        this.kMap = new Object();

        var leafs = this.hovObj.ord.bucketObj.leafs;
        var keys = Object.keys(leafs);
        var leafs_audit = 0;
        
        pts = [];
        
        pts.push(globalPosition);
        
        var lastX = 0;
        var lastY = 0;
        var lastZ = 0;

        this.hovObj.leafMeshes = []; 

        var xDELT = -280;
        var yDELT = 200;
        var zDELT = -200;

        var zDELTm=1;
        if (keys.length<3) zDELTm=3;
        else if (keys.length<=5) zDELTm=2;

        zDELT = zDELT*zDELTm;

        var presort = [];
        var max = 0;
        for (var k=1; k <= keys.length; k++) {
            var leaf = leafs [keys[k-1]];
            leafs_audit+=parseInt(leaf.count);
            if (leaf.count > max) max = parseInt(leaf.count);
            leaf.nid = keys[k-1];
            leaf.nObj = MEMG.getNeuronByNid(leaf.nid);
            leaf.name = leaf.nObj.text;
            presort.push(leaf);
        }

        presort.sort(function($a, $b) {
            if ($a.count<$b.count) return -1;
            if ($b.count>$a.count) return 1;
            return 0;
        });

        var mid = presort.length/2;
        var turnfpt = Math.ceil(mid-2.5);
        console.log("total leafs:"+presort.length+" mid:"+mid+" 5pt turn start:"+turnfpt);


        //TODO.. MANUALLY BUILD 1, 2, 3, 4, 5 and 6 point pathes...
        //(with minor variance).. those greater than 6 are better suited for this LOOP

        for (var k=1; k <= presort.length; k++) {
            var leaf = presort[k-1];

            //inject a 5 pt turn.. yikes (lolz)
            if (presort.length>6) {
                if (k==turnfpt) {
                    var ptsObj = ANNE.u3js.hardCode5ptTurn(lastX, lastY, lastZ, 200);
                   
                    for (var r=0; r < ptsObj.pts.length; r++) {
                        var leaf = presort[k-1+r];
                        var size = Math.ceil(7*Math.pow((leaf.count/max),2)+1);
                        console.log("orb "+k+r+" size: "+size+" count:"+leaf.count+" max:"+max);
                        var mat = this.ANX.awarez_mats[this.hovObj.ord.section.mat_i+3];
                        const leafgeo = new THREE.SphereGeometry(size, 128, 32);
                        var leafmesh = new THREE.Mesh(leafgeo, mat);
                        leafmesh.ATYPE = AWAREZ_LEAF;

                        leafmesh.position.set(this.hovObj.position.x, this.hovObj.position.y, this.hovObj.position.z);
                        //leafmesh.percent = (k-1)/(keys.length+2);
                        leafmesh.bPASSEDIT=false;
                        leafmesh.perStopIndex = k-1;
                        leaf.leafmesh = leafmesh;
                        leafmesh.debug = leaf.name;
                        leafmesh.leaf = leaf;
                        if (leafmesh.leaf==undefined) {
                            console.log("FIX THIS leafmesh.leaf==undefined");
                        }
                        //this.perStopList.push({leaf:leaf, perStop:leafmesh.percent});
                        this.hovObj.leafMeshes.push(leafmesh);  //we want to come to a slow at this pt, 
                        this.ANX.scene.add(leafmesh); 

                        this.makeLeafDisplay(leaf);

                        var pt_pre_adjust = new THREE.Vector3(ptsObj.pts[r].x, ptsObj.pts[r].y, ptsObj.pts[r].z);
                        const point = pt_pre_adjust.clone();
                        point.applyQuaternion(globalRotation);
                        point.add(globalPosition);
                        pts.push(point);

                        gsap.to(leafmesh.position, {
                            duration:2,
                            x:point.x,
                            y:point.y,
                            z:point.z,
                        });
                    }

                    k+=5;
                    lastX=ptsObj.lastX; 
                    lastY=ptsObj.lastY; 
                    lastZ=ptsObj.lastZ;
                    continue;
                }
            }

            //coming back
            if (k*2 > keys.length) {
                xDELT = 280;
                yDELT = -200;
                zDELT = 200*zDELTm;
            }
            

            //we want to face here at the highest value orientated back to our original view.
            if (k==presort.length) {
                lastZ= 100;
                lastX= lastX/2;
                lastY= 0;
            }

            //smooth the arrival back if we over/undershot with rands
            else if (k==presort.length-1 && k>6) {
                lastZ= -200;     //last pt is at 50 (non orb)
                lastX= lastX/2;
                lastY= 0;       //perfect align with pt 1
            }
            else if (k==presort.length-2 && k>6) {
                lastZ= -220+(Math.random()*.8)*100;
                lastX= lastX/2+((Math.random()*.8)*40);
                lastY= lastY-100*(Math.random()*.2); 
            }
            else if (k==1) {
                lastZ+=zDELT*2*((Math.random()*.2)+.8);
                lastX+= Math.random()*xDELT/20;
                lastY+= Math.random()*yDELT/20; 
            }
            else {
                //normal going out/back incr
                //$f*((Math.random()*.2)+.8)
                lastZ+=zDELT*((Math.random()*.2)+.8);
                lastX+= Math.random()*xDELT/2;
                lastY+= Math.random()*yDELT/2;    
            }

            var pt_pre_adjust = new THREE.Vector3(lastX,lastY,lastZ);
            const point = pt_pre_adjust.clone();
            point.applyQuaternion(globalRotation);
            point.add(globalPosition);
            pts.push(point);

            var size = Math.ceil(7 * leaf.count/max)+1;
            console.log("orb "+k+" size: "+size+" count:"+leaf.count+" max:"+max);
            var mat = this.ANX.awarez_mats[this.hovObj.ord.section.mat_i+3];
            const leafgeo = new THREE.SphereGeometry(size, 128, 32);
            var leafmesh = new THREE.Mesh(leafgeo, mat);
            leafmesh.ATYPE = AWAREZ_LEAF;

            //starting tween point for the orb meshes..
            const worldPosition = new THREE.Vector3();
            this.hovObj.localToWorld(worldPosition);
            leafmesh.position.set(worldPosition.x, worldPosition.y, worldPosition.z);
            
            leafmesh.bPASSEDIT=false;
            leaf.leafmesh = leafmesh;
            leafmesh.perStopIndex = k-1;
            leafmesh.debug = leaf.name;
            leafmesh.leaf = leaf;

            //this.perStopList.push({leaf:leaf, perStop:leafmesh.percent});
            this.hovObj.leafMeshes.push(leafmesh);  //we want to come to a slow at this pt, 
            this.ANX.scene.add(leafmesh); 
            this.makeLeafDisplay(leaf);

            gsap.to(leafmesh.position, {
                duration:2,
                x:point.x,
                y:point.y,
                z:point.z,
            });
        }

        //close the loop ?
        pts.push(globalPosition);

        //console.log(this.perStopList);
        console.log(pts);

        console.log("%c POINTS "+pts.length, TALK.bgbigred);
        console.log("%cbucket's count: %c"+total_leafs+"%cleafs_audit: %c"+leafs_audit, TALK.bgblack, TALK.bgfire, TALK.bgblack, TALK.bgfire);
        this.hovObj.ord.bucketObj.pts = pts;
        
        return new THREE.CatmullRomCurve3(pts);
    }


    /**
     * 
     * @param {*} $leaf 
     */
    makeLeafDisplay = function($leaf) {
        var elLeaf = document.createElement("div");
        elLeaf.classList.add("aring-leaf");

        var elLeafName = document.createElement("div");
        elLeafName.classList.add("aring-leaf-name");
        elLeafName.innerHTML = $leaf.name;
        elLeaf.appendChild(elLeafName);

        var elLeafData = document.createElement("div");
        elLeafData.classList.add("aring-leaf-data");
        elLeafData.innerHTML = UTILS.commas($leaf.count);
        elLeaf.appendChild(elLeafData);

        const leafCSSObj = new ANNE.CSS3DObject( elLeaf );
        leafCSSObj.position.set( 0, 0, 0 );
        var scale = new THREE.Vector3(0.25, 0.25, 0.25);
        leafCSSObj.scale.copy(scale);

        $leaf.leafmesh.add(leafCSSObj);
        $leaf.leafmesh.leafCSSObj = leafCSSObj;
        $leaf.leafCSSObj = leafCSSObj;

        this.ARing._lookatLbls.push(leafCSSObj);

        ANNE.A.hide(leafCSSObj.element);
    }


    /**
     */
    tunnelTravel=function() {
        if (this.bPAUSEDATWAYSIDE==true) return;

        this.percentage += this.PER_INCR;
        
        if (this.percentage>.99) {
            this.percentage=0.00; 
            this.leaveTheTunnel();
            return;
        }

        if (this.perStopIndex < this.hovObj.leafMeshes.length-1) {
            const leafdist = 50;
            var mesh = this.hovObj.leafMeshes[this.perStopIndex];
            const distance = mesh.position.distanceTo(this.ANX.camera.position);
            if (distance < leafdist) {
                console.log("%c "+mesh.debug, TALK.bgbigred);
                ANNE.A.play("impact");
                mesh.bPASSEDIT=true; 
                this.perStopIndex+=1;
                if (mesh.leaf==undefined || mesh.leaf==null || mesh.leaf.nid==undefined) {
                    console.log("debug this");
                }
                this.ANX.addAwarezBtn(this.target_nid, mesh.leaf.nid, mesh.leaf.name);
            }
        }

        var p1 = this.path.getPointAt(this.percentage%1);
        var p2 = this.path.getPointAt((this.percentage + 0.01)%1);

        //need to shift these by the value of the ARIng.  Yikes.
        this.ANX.camera.position.set(p1.x, p1.y, p1.z);
        //var p2a = new THREE.Vector3(p2.x+this.ARing.ARing.position.x, p2.y+this.ARing.ARing.position.y, p2.z+this.ARing.ARing.position.z);

        this.ANX.camera.lookAt(p2);
    }


    /**
     * 
     */
    cleanup = function() {
        ANNE.A.stopPlay("shepardtone");
        this.ANX.scene.remove(this.TUBES);
        this.TUBES = null;
    }


    /**
     * Go back to the hom position.
     * Fix all that we mucked about with.
     */
    leaveTheTunnel = function() {
        this.ARing.bDOINGARINGTUNNEL= false;
        this.bPAUSEDATWAYSIDE = false;
        this.perStopIndex = 0;

        //nuke the tube meshes
        this.cleanup();

        this.ANX._lastARING.elRingCenterDiv.classList.add("unBlurFadeIn");
        ANNE.A.stopPlay("shepardtone");
        ANNE.A.play("trondown");
        
        const _ANX = this.ANX;

        const worldPosition = new THREE.Vector3();
        this.hovObj.localToWorld(worldPosition);

        for (var m=0; m < this.hovObj.leafMeshes.length; m++) {
            const leafmesh = this.hovObj.leafMeshes[m];    
            gsap.to(leafmesh.position, {
                duration:2,
                x:worldPosition.x,
                y:worldPosition.y,
                z:worldPosition.z,
                onComplete:function() {
                    ANNE.UTILS.findValAndRemoveInObjnArr(_ANX._lookatLbls, "uuid", leafmesh.leafCSSObj);
                    ANNE.A.removeSelf(leafmesh.leafCSSObj.element);
                    _ANX.scene.remove(leafmesh.leafCSSObj);
                    _ANX.scene.remove(leafmesh);
                    _ANX._lastARING.elRingCenterDiv.classList.remove("blurFadeOut");
                }
            });
        }

        ANNE.A.show(this.ANX.elRingCenterDiv);

        gsap.to(this.ANX.camera.rotation, {
            z: this.ANX.savedRotation.z,
            x: this.ANX.savedRotation.x,
            y: this.ANX.savedRotation.y,
            ease:"none",   
            duration:2
        });

        gsap.to(this.ANX.camera.position, {
            z: this.ANX.savedPosition.z,
            x: this.ANX.savedPosition.x,
            y: this.ANX.savedPosition.y,
            ease:"none",   
            duration:2
        });


        gsap.to(this.ANX.scene.fog, {
            density:0,
            ease:"none",   
            duration:.5,
            onComplete:function(){
                _ANX.scene.fog = null;
            }
        });

        //gsap.to(_ANX.renderer, {
         //   duration:.5,
         //   ease:"power2.inOut",
          //  toneMappingExposure:this.ANX.savedExposure
        //});

        gsap.to(this.ANX.camera, {
            zoom:this.ANX.saveZoom,
            ease:"none",   
            duration:.5,
        });

        //nuke the tunnel.
        this.ARing.ATunnel=null;
    }
}


const AWAREZ_RING = "ARING";
const AWAREZ_SECTION = "ASECTION";
const AWAREZ_RINGASBAR = "RINGASBAR";
const AWAREZ_BUCKET = "BUCKET";
const AWAREZ_LEAF = "LEAF";  //some end feelz/bucket/or even pos/neg/neu... There are the direct Awarez values
const ENTRY_TILE = "ENTRY_TILE";
const DEBUG_SPHERE = "DEBUG_SPHERE";
const TOP_X = "TOP_X";
const TOP_NEURON = "TOP_NEURON";
const ANNEFOLIO_VIEWER = "ANNEFOLIO";
const REVELATIAN = "REVELATIAN";

const SOUV_AWARENESS = 0;
const SOUV_NEURON = 1;
const SOUV_THUMBNAIL = 2;
const SOUV_IDENTITY = 3;
const SOUV_SEARCH = 4;

//results from search that can be clicked on to add to the revelatian display
const SOUV_SEARCH_REVELATIAN = 5; 

class souvenirs {
    constructor($app, $cb=null) {
        this.app = $app;
        this._souvenirs = [];
        this.type_class = [];
        this.cb = $cb;
    }

    //add a sovenir
    addSouvenir = function($type=SOUV_AWARENESS, $obj) {
        var sObj = new souvenir($type, $obj);
        this._souvenirs.push(sObj);

        //call the type-specific callback if it was set.
        if (this.cb!=null) this.cb(sObj, $type);
    }
}

class souvenir {
    constructor($type, $obj) {
        this.type = $type;
        this.obj = $obj;
        this.id = ANNE.UTILS.randHex(5);
    }
}



class lookatSmooth {
    constructor($looker, $wayptv3, $lookAtV3) {
        this.QO = {sQ:null, eQ:null};
        this.looker = $looker;
        this.wayptv3 = $wayptv3;
        this.finalV3 = $lookAtV3;
        this.QO.sQ =  this.looker.quaternion.clone(); 
        this.looker.lookAt(this.finalV3);
        this.QO.eQ = this.looker.quaternion.clone(); 
        this.looker.quaternion.copy(this.QO.sQ);
    }


    /**
     * Tween lookat of obj to a final spot.
     * tPer is what percent we want to tween
     * @param {*} $time 
     * @param {*} $ease 
     * @param {*} $delay 
     * @param {*} $tPer 
     * @param {*} $cb 
     */
    startLookOnly = function($time, $ease="none", $delay, $tPer=4, $cb=null) {
        const THIS = this;
        var tween = gsap.to(this.looker, {
            delay:$delay,
            ease:$ease,
            duration: $time,
            onUpdate: function() {
                var t_slice = tween.time()/$tPer;
                THIS.looker.quaternion.slerp(THIS.QO.eQ, t_slice);
            },
            onComplete: async()=> {  
                if ($cb!=null) $cb();
            }
        });
    }

    startLookAtWithMotion = function($time, $ease="none", $delay, $tPer=4, $cb=null) {
        const THIS = this;
        var tween = gsap.to(this.looker.position, {
            x:this.wayptv3.x,
            y:this.wayptv3.y,
            z:this.wayptv3.z,
            delay:$delay,
            ease:$ease,
            duration: $time,

            //look at the target while going through a way pt.
            onUpdate: function() {
                var t_slice = tween.time()/$tPer;
                THIS.looker.quaternion.slerp(THIS.QO.eQ, t_slice);
            },
            onComplete: async()=> {  
                if ($cb!=null) $cb();
            }
        });
    }

    updateSlerp = function($t) {
        var resultQuaternion = new THREE.Quaternion();
        resultQuaternion.slerp(this.QO.sQ, this.QO.eQ, $t);
        THIS.looker.quaternion.copy(resultQuaternion);
    }
}


/**
 * 
 */
class travel_tube {
    constructor($scene, $camera, $renderer, $catRomPath) {
        this.scene = $scene;
        this.camera = $camera;
        this.renderer = $renderer;
        this.path = $catRomPath;

        this.bDOINGTRANSIT = false;

        this.savedRotation = new THREE.Vector3();
        this.savedPosition = new THREE.Vector3();
        this.savedZoom = null;
        this.savedExposure = null;

        var geometry = new THREE.TubeGeometry(this.path, 300, 8, 24, true );
        var material = new THREE.MeshBasicMaterial( { color: 0xff0000, side : THREE.BackSide, wireframe:true } );
        this.tube = new THREE.Mesh( geometry, material );
        this.scene.add(this.tube);

        this.percentage = 0;
        this.PER_INCR = 0.008 / this.path.points.length; //.001 fast -- //0.0003 --slower;
        
        this.stop_cb = null;    //called when the 
    }

    startTunnelTravel=function($bUSEFOG=true, $density=.3, $finalTargetObj=null, $bLOOKATATCAMONCOMPLETE=true) {
        this.bDOINGTRANSIT = true;
        this.finalTargetObj = $finalTargetObj;
        this.bLOOKONCOMPLETE=$bLOOKATATCAMONCOMPLETE;

        this.savedRotation.copy(this.camera.rotation);
        this.savedPosition.copy(this.camera.position);
        this.saveZoom = this.camera.zoom;
        this.savedExposure = this.renderer.toneMappingExposure;
        this.scene.fog = new THREE.Fog(0x222222,100,30000);
        this.scene.fog.density = 0.0; // Set the fog density to 0.5 for transparency
        
        if ($bUSEFOG==true) {
            gsap.to(this.scene.fog, {
                density:$density,
                ease:"power2.in",   
                duration:3,
            });
        }
    }

    /**
     */
    tunnelTravel=function() {
        this.percentage += this.PER_INCR;
        if (this.percentage>=1) {
            this.percentage=0.00; 
            //leave camera as..
            this.stopTunnelTravel();
            return;
        }
        var p1 = this.path.getPointAt(this.percentage%1);
        var p2 = this.path.getPointAt((this.percentage + 0.01)%1);
        this.camera.position.set(p1.x,p1.y,p1.z);
        this.camera.lookAt(p2);

        if (this.bLOOKONCOMPLETE==true && this.finalTargetObj!=null) {
            this.finalTargetObj.lookAt(this.camera.position);
        }
    }

    stopTunnelTravel = function() {
        this.bDOINGTRANSIT = false;
        this.scene.remove(this.tube);
        this.tube = null;
        if (this.stop_cb!=null) this.stop_cb();
    }

    cleanup = function() {
    }        
}


const PT_STATUS_NOTSET_BUT_READY = -2;
const PT_STATUS_NOTSET = -1;
const PT_STATUS_NOT_ACTIVE = 0;
const PT_STATUS_ACTIVE = 1;
const PT_STATUS_MULTI = 2;
const PT_STATUS_FOUNDATION = 3;

class ANNEfolio {
    constructor($ANX, $scene, $camera, $rendererCSS, $nObj, $helperObj, $bEMULATE_DATA=false) {
        this.ANX = $ANX;
        this.scene = $scene;
        this.camera = $camera;
        this.rendererCSS = $rendererCSS;
        this.nObj = $nObj;
        this.helperObj = $helperObj;
        this.pts = [];
        this.default_attractor = null;
        this.mapped_classes = [];
        this.bEMULATE_DATA = $bEMULATE_DATA;

        this.pt_classes = [MEM.person.nid, MEM.location.nid, MEM.company.nid, 
                            MEM.gregorian_date.nid, MEM.group.nid, 
                            MEM.group_event.nid, MEM.EC_CLASS.nid];

        this.parent_i = -1;

        this.gcolor = new THREE.Color(0x00ff00);
        this.g2color = new THREE.Color(0x97ff97);
        this.wcolor = new THREE.Color(0xD3D3D3);
        this.ycolor = new THREE.Color(0xfefe17);
        this.tcolor = new THREE.Color(0x00ffff);

        this.highlightFinalColor = new THREE.Color(0xfefe17);


        //manager of our 3d css elements.
        //when we reset stuff we have them here to clear them out.
        this.last_lbl_pts = [];

        this.ZOOM_UP = 3.3875;

        this.MAX_CSS_3JS_LBLS = 80; //experiment with this.

        this.init();
    }

    updatePtClasses = function($arr) {
        this.pt_classes = $arr;
    }

    /**
     * cleanup our mess
     */
    cleanup = function() {
        this.resetAllFilters();

        this.scene.remove(this.mesh);
        this.mesh = null;
        ANNE.A.hide("id_annefolio_subfilters");

        //clean up sponsored_by spots we manually set
        if (this.bEMULATE_DATA==true) {
            var afc=this.nObj.af_chased_classes;
            for (var a=0; a < afc.length; a++) {
                var afc_obj = this.nObj.af_chased_classes[a];
                for (var aa=0; aa < afc_obj.arr.length; aa++) {
                    delete afc_obj.arr[aa].pts_i;
                }
            }
        }

        else {
            var afc=this.nObj.af_chased_classes;
            for (var a=0; a < afc.length; a++) {
                var afc_obj = this.nObj.af_chased_classes[a];
                for (var aa=0; aa < afc_obj.arr.length; aa++) {
                    delete afc_obj.arr[aa].pts_i;
                }
            }
        }

        this.pts = [];
    }


    /**
     * 
     */
    init = function() {
        ANNE.A.hide("id_annefolio_subfilters");
        ANNE.A.emptySelf("id_annefolio_subfilters");
        ANNE.A.hide("injected_div");
        ANNE.A.hide("left_holder2");
        ANNE.A.hide("afnd");

        var icolbls = document.querySelectorAll(".annefolio-ico-badge");
        for (var i=0; i < icolbls.length; i++) {
            icolbls.innerHTML="";
        }
      
        this.clock = new THREE.Clock();

        var sz = .5;
        var rcs = 4;
        if (this.nObj._anneid.sponsored_neurons.length > 10000) {
            sz = .04;
            rcs = 36;
        }

        else if (this.nObj._anneid.sponsored_neurons.length > 4000) {
            sz = .05;
            rcs = 24;
        }
        else if (this.nObj._anneid.sponsored_neurons.length > 1000) {
            sz = .1;
            rcs = 18;
        }
        else if (this.nObj._anneid.sponsored_neurons.length > 200) {
            sz = .2;
            rcs = 12;
        }

       
        var ptsObj = ANNE.u3js.makeSheetsPts(this.nObj._anneid.sponsored_neurons, rcs, rcs);
        this.pts = ANNE.UTILS.fisherYatesShuffle(ptsObj.pts);

        this.default_attractor = new THREE.Vector3(0, 0, 0);

        const geometry = new THREE.IcosahedronGeometry(sz, 0 );
        const vmat = new THREE.MeshBasicMaterial( { vertexColors: THREE.VertexColors } );
        this.mesh = new THREE.InstancedMesh( geometry, vmat, this.pts.length );
        this.mesh.ATYPE = ANNEFOLIO_VIEWER;

        const matrix = new THREE.Matrix4();
        
        //a class is mapped in this mesh when the user clicks on the filter item in the footer.
        //this is done each time the obj is rendered so if they come back to a neuron in this same session
        //it will be done again.. it is specific to the mesh object
        
        for (var c=0; c < this.pt_classes.length; c++) {
            this.mapped_classes[c] = false;
        }

        //this is done once per session -- to pull external data from the annode.
        if (this.nObj.af_chased_classes==undefined) {
            this.nObj.af_chased_classes = [];
            for (var c=0; c < this.pt_classes.length; c++) {

                //bCHASE = we chased it on the ANNODE for type 0, 1, 3
                //cnt = total count of sponsors of this class
                //arr = array of sponsors of this class.
                this.nObj.af_chased_classes.push({bCHASED:false, cnt:0, arr:[]});
            }
        }

        for(var p=0; p < this.pts.length; p++) {
            matrix.setPosition(this.pts[p].pt.x, this.pts[p].pt.y, this.pts[p].pt.z);
            this.mesh.setMatrixAt( p, matrix );
            this.mesh.setColorAt( p, this.wcolor );
        }

        if (this.helperObj!=null) {
            this.mesh.position.copy(this.helperObj.objSpawnPosition);
        }

        this.scene.add(this.mesh);
        
        u3js.makeDebugSphere(this.mesh, new THREE.Vector3(0,0,0), 20, 0x00ffff); 
        
        this.mesh.lookAt(this.camera.position);

        const midwayPoint = new THREE.Vector3().lerpVectors(this.helperObj.objSpawnPosition, this.helperObj.camPosition,  0.9);

        /*gsap.to(this.camera.position, {
            x:midwayPoint.x,
            y:midwayPoint.y,
            z:midwayPoint.z,
            ease:"none",
            duration: 6,
            onComplete() {
            }
        });
        */
        var THIS = this;
        gsap.to(this.camera, {
            zoom:1,
            ease:"none",
            duration: 6,
            onUpdate() {
                THIS.camera.updateProjectionMatrix();
            }
        });
    }


    /**
     * ANNEFolio animate
     * called in the animate loop of the main app whenever a _ANNEFolio object is present.
     */
    animate = function() {
        var dummy = new THREE.Object3D();

        const attractionForce = 1.7;
        const repelForce = -0.27;
        const TOO_CLOSE = 2;
        const TOO_CLOSE_NONACTIVE = 209;
        const TOO_FAR_INACTIVE = 219;
        const OK_NOW = 150;

        for (var i = 0; i < this.pts.length; i++) {

            const direction = new THREE.Vector3().subVectors(this.default_attractor,  this.pts[i].pt);
            const distance = Math.abs(direction.length());

            //if not active.. just wiggle in place.
            if (this.pts[i].status==PT_STATUS_ACTIVE) {

                if (distance<TOO_CLOSE_NONACTIVE) {
                    this.pts[i].pt.add(direction.normalize().multiplyScalar(repelForce*2*(Math.random()-.2)));  //20% of the time it goes the other way
                }
                else if (distance>TOO_FAR_INACTIVE) {
                    this.pts[i].pt.add(direction.normalize().multiplyScalar(attractionForce*Math.random()*.1));
                }
                if (this.pts[i].cssobj!=undefined) {
                    this.pts[i].cssobj.position.copy(this.pts[i].pt);
                    this.pts[i].cssobj.position.y-=4;
                    this.pts[i].cssobj.lookAt(this.camera.position);
                }
            }

            else {
                //if too close, repel it.
                if (this.pts[i].pt.tc==1) {

                    //turn off tc.
                    if (distance > OK_NOW && Math.random()>.96) {   //gotta get it hooked again.
                        this.pts[i].pt.tc=0;
                    }

                    //keep repelling
                    else {
                        this.pts[i].pt.add(direction.normalize().multiplyScalar(repelForce*Math.random()));
                    }
                }
                
                else if (distance<TOO_CLOSE) {
                    this.pts[i].pt.add(direction.normalize().multiplyScalar(repelForce));
                    this.pts[i].pt.tc=1;
                }

                //otherwise draw it in.
                else this.pts[i].pt.add(direction.normalize().multiplyScalar(attractionForce/2));

            }

             
            dummy.position.copy(this.pts[i].pt);
            dummy.updateMatrix();
            this.mesh.setMatrixAt(i, dummy.matrix );

            if(this.pts[i].cssobj!=null) {
                this.pts[i].cssobj.position.copy(this.pts[i].pt);
                this.pts[i].cssobj.position.y-=4;
                this.pts[i].cssobj.lookAt(this.camera.position);
            }
            
        }

        this.mesh.instanceMatrix.needsUpdate = true;

        const delta = this.clock.getDelta();
        this.mesh.rotation.y += delta/50 * 0.5;
    }


    /**
     * reset colors.
     * reset lbls
     * show left holder
     * hide subfilters.
     * (all filter btns are off)
     */
    resetAllFilters=function(){
        this.resetLbls();

        for (var i = 0; i <this.pts.length; i++) {
            this.mesh.setColorAt( i, this.wcolor );
            this.pts[i].status=PT_STATUS_NOT_ACTIVE;
        }
        if (this.mesh!=null && this.mesh.instanceColor!=null) this.mesh.instanceColor.needsUpdate = true;

        var aicos = document.querySelectorAll(".annefolio-ico");
        for (var a=0; a < aicos.length; a++) {
            aicos[a].classList.remove("on");
        }
        
        var aisubcos = document.querySelectorAll(".annefolio-ico-sub");
        for (var a=0; a < aisubcos.length; a++) {
            aisubcos[a].classList.remove("on");
        }
        ANNE.A.hide("id_annefolio_subfilters");

        ANNE.A.emptySelfAfterChild("afnd", 0, true);
        ANNE.A.show("left_holder2");    //reshow the left bar
    }


    /**
     * remove css 3d objs from scene and elements from the dom
     */
    resetLbls = function() {
        for (var i=0; i  < this.last_lbl_pts.length; i++) {
            if ( this.last_lbl_pts[i].cssobj==null) {
                continue;
            }
            this.scene.remove(this.last_lbl_pts[i].cssobj);
            ANNE.A.hide(this.last_lbl_pts[i].cssobj.element);
            var parent =this.last_lbl_pts[i].cssobj.element.parentElement;
            if (parent==undefined || parent==null) continue;
            parent.removeChild(this.last_lbl_pts[i].cssobj.element);
            this.last_lbl_pts[i].cssobj = null;
        }

        //audit
        for (var p=0; p < this.pts.length; p++) {
            if (this.pts[p].cssobj!=null) {
                console.log("WHO IS THIS?????");
                console.log(this.pts[p]);
                this.scene.remove(this.pts[p].cssobj);
                ANNE.A.hide(this.pts[p].cssobj.element);
                var parent =this.pts[p].cssobj.element.parentElement;
                if (parent==undefined || parent==null) continue;
                parent.removeChild(this.pts[p].cssobj.element);
                this.pts[p].cssobj = null;
            }
        }

        this.last_lbl_pts = [];
    }


    /**
     * 
     * @param {*} $nid 
     * @param {element} $elBtn
     */
    ANNEfolioFilter=async($nid, $elBtn)=> {
        this.parent_i = this.pt_classes.indexOf($nid);
        
        ANNE.A.show("id_annefolio_subfilters");

        //reactivate this when the subfilters are clicked.
        var el_afnd = ANNE.A.emptySelfAfterChild("afnd", 0, false);
        ANNE.A.hide(el_afnd);

        this.resetLbls();

        var el_badge = $elBtn.querySelector(".annefolio-ico-badge");

        //use real data
        if (this.bEMULATE_DATA==false) {
        
            if (this.nObj.af_chased_classes[this.parent_i].bCHASED==false) {

                //get sponsored neurons type 1 relons of neurons that are sponsored_by this user.
                //await ANNE.API.queryForOuts($nid, false, $types=[0,1,3]);
                await ANNE.API.queryNAPLEX(this.nObj.nid, $nid);

                var classNOBJ = MEMG.getNeuronByNid(this.pt_classes[this.parent_i]);

                //get an array of the neurons of a given class line sponsored by this user nid.
                if (classNOBJ.nid==MEM.EC_CLASS.nid) {
                    var arr = ANNE.MEMG.getSponsoredByClasses(this.nObj.nid, classNOBJ);
                }
                else var arr = ANNE.MEMG.getSponsoredBy(this.nObj.nid, classNOBJ);

                el_badge.innerHTML = ANNE.UTILS.commas(arr.length);

                this.nObj.af_chased_classes[this.parent_i].arr = arr;
                this.nObj.af_chased_classes[this.parent_i].cnt = arr.length;
                this.nObj.af_chased_classes[this.parent_i].bCHASED = true;
                var pts_to_assign = arr.length;
                var pts_assigned_i = 0;

                if (arr.length) {
                    //loop the pts and assign these known nids/pts to the next available pt in the instance mesh.
                    for (var i=0; i < this.pts.length; i++) {
                        if (this.pts[i].tnid!=-1) continue;
                        var nobj2 = arr[pts_assigned_i++];
                        
                        if (nobj2==undefined || nobj2==null) {
                            console.log("DEBUG THIS.")
                            continue;
                        }
                        
                        this.pts[i].tnid = nobj2.temp_nid;
                        nobj2.pts_i = i;
                        this.pts[i].parent_i = this.parent_i;
                        if (pts_assigned_i>=pts_to_assign) break;
                    }     
                }
            }
        }

        //emulate the data
        else {

            if (this.nObj.af_chased_classes[this.parent_i].bCHASED==false) {
                
                //randomly grab data in memory and assign it to this sponsor (overriding the value)
                var maxCntLeft = this.nObj._anneid.sponsored_neurons;
                for (var a=0; a < this.nObj.af_chased_classes.length; a++) {
                    maxCntLeft -= this.nObj.af_chased_classes[a].cnt;
                }
                var newCnt = 0;
                if (maxCntLeft==this.nObj._anneid.sponsored_neurons) {
                    newCnt = ANNE.UTILS.range(1, maxCntLeft/3)
                }
                else if (maxCntLeft > this.nObj._anneid.sponsored_neurons/2) {
                    newCnt = ANNE.UTILS.range(1, maxCntLeft/2);
                }
                else newCnt = ANNE.UTILS.range(1, maxCntLeft);

                this.nObj.af_chased_classes[this.parent_i].cnt = newCnt;
                var parentNOBJ = MEMG.getNeuronByNid( this.pt_classes[this.parent_i]);
                
                //go steal some neurons and their sponsorships.
                var arr = await this.emulateSponsoredBy(this.nObj, parentNOBJ, newCnt);

                this.nObj.af_chased_classes[this.parent_i].arr = arr;
                this.nObj.af_chased_classes[this.parent_i].bCHASED = true;

                //reserve and set pts parent_i:-1, tnid:-1, 
                var pts_to_assign = arr.length;
                var pts_assigned_i = 0;

                //loop the pts and assign these known nids/pts to the next available pt in the instance mesh.
                for (var i=0; i < this.pts.length; i++) {
                    if (this.pts[i].tnid!=-1) continue;
                    this.pts[i].tnid = arr[pts_assigned_i].temp_nid;
                    arr[pts_assigned_i++].pts_i = i;
                    this.pts[i].parent_i = this.parent_i;
                    if (pts_assigned_i>=pts_to_assign) break;
                }
            }
        }
        
        /**
         * turn on all pts of this parent.  Set it active (for the attractor)
         * turn off all pts that are not this parent.  Set inactive (for the attractor)
         */

        var active_pts = [];
        for (var i = 0; i <this.pts.length; i++) {
            if (this.pts[i].parent_i==this.parent_i) {
                this.pts[i].status=PT_STATUS_ACTIVE;
                this.mesh.setColorAt( i, this.gcolor );

                active_pts.push(this.pts[i]);
            }
            else {
                this.mesh.setColorAt( i, this.wcolor );
                this.pts[i].status=PT_STATUS_NOT_ACTIVE;
            }
        }

        if (this.mesh!=null && this.mesh.instanceColor!=null) this.mesh.instanceColor.needsUpdate = true;

        //this class has been mapped.
        this.mapped_classes[this.parent_i] = true;

        this.doSubFilters(active_pts);
    }


    /**
     * 
     * @param {*} $pts 
     */
    doSubFilters = function($pts) {
        var el = ANNE.A.emptySelf("id_annefolio_subfilters");
        var topALVL = 0;
        for (var p=0; p < $pts.length; p++) {
            var nObj = MEMG.getNeuronByTempNid($pts[p].tnid);
            if (nObj._aplex==undefined || nObj._aplex==null) {
                console.log("DEBUG THIS, "+nObj.text+" it should have _aplex on it.");
                continue;
            }
            if (parseInt(nObj._aplex.price_lvl) > topALVL) {
                topALVL = parseInt(nObj._aplex.price_lvl);
            }
        }

        const THIS = this;

        var el_ALL = document.createElement("div");
        el_ALL.classList = "annefolio-ico-sub";
        el_ALL.innerHTML = "ALL";
        el_ALL.setAttribute("subfilter", "price_lvl");
        el_ALL.setAttribute("subfilter_val", "ALL");
        el_ALL.addEventListener("click", $e=>{
            var subfilter = $e.target.getAttribute("subfilter");
            var subfilter_val = $e.target.getAttribute("subfilter_val");
            if (subfilter_val!="ALL") subfilter_val = parseInt(subfilter_val);
            THIS.resetSubPrep();
            var el = ANNE.A.getNearestParentOf($e.target, "annefolio-ico-sub");
            if (el.classList.contains("on")==false)  {
                el.classList.add("on");
                THIS.processSubFilter(subfilter, subfilter_val);
            }
        });
        el.append(el_ALL);

        for (var t=topALVL; t >= 0; t--) {
            var el_top = document.createElement("div");
            el_top.classList = "annefolio-ico-sub";
            el_top.innerHTML = "A"+(t);
            el_top.setAttribute("subfilter", "price_lvl");
            el_top.setAttribute("subfilter_val", t);
            el_top.addEventListener("click", $e=>{
                var subfilter = $e.target.getAttribute("subfilter");
                var subfilter_val = $e.target.getAttribute("subfilter_val");
                subfilter_val = parseInt(subfilter_val);
                THIS.resetSubPrep();
                var el = ANNE.A.getNearestParentOf($e.target, "annefolio-ico-sub");
                if (el.classList.contains("on")==false)  {
                    el.classList.add("on");
                    THIS.processSubFilter(subfilter, subfilter_val);
                }
            });
            el.append(el_top);

            //turn the first (highest level) on
            if(t==topALVL) {
                el_top.classList.add("on");
                THIS.processSubFilter("price_lvl", t, false);
            }
        }
  
        var el_fire = document.createElement("div");
        el_fire.classList = "annefolio-ico-sub";
        el_fire.innerHTML = "awarez 🔥";
        el_fire.setAttribute("subfilter", "fire");
        el_fire.setAttribute("subfilter_val", "");
        el_fire.addEventListener("click", $e=>{
            var subfilter = $e.target.getAttribute("subfilter");
            var subfilter_val = $e.target.getAttribute("subfilter_val");
            if (subfilter==undefined) {
                subfilter = el_fire.getAttribute("subfilter");
                el_fire.getAttribute("subfilter_val");
            }
            subfilter_val = parseInt(subfilter_val);
            THIS.resetSubPrep();
            var el = ANNE.A.getNearestParentOf($e.target, "annefolio-ico-sub");
            if (el.classList.contains("on")==false)  {
                el.classList.add("on");
                THIS.processSubFilter(subfilter, subfilter_val);
            }
        });
        el.append(el_fire);
    }


    /**
     * 
     */
    resetSubPrep = function() {
        var aicos = document.querySelectorAll(".annefolio-ico-sub");
        for (var a=0; a < aicos.length; a++) {
            aicos[a].classList.remove("on");
        }
        var arr = this.nObj.af_chased_classes[this.parent_i].arr;
        for (var a=0; a < arr.length; a++) {
            var nObj = arr[a];
            var pt = this.pts [ nObj.pts_i ];
            pt.status=PT_STATUS_NOT_ACTIVE;
            this.mesh.setColorAt( nObj.pts_i, this.gcolor);    //not the active one anymore, ycolor is the new active.
        }
        this.mesh.instanceColor.needsUpdate = true;
    }

    
    /**
     * 
     * @param {*} $e 
     */
    processSubFilter = async($subfilter, $subfilter_val)=> {
        const THIS = this;
        this.resetLbls();

        var arr = this.nObj.af_chased_classes[this.parent_i].arr;
        if ($subfilter=="fire") {
            //sort the displaying list by fire.
        }
        else {
            var el_afnd = ANNE.A.emptySelfAfterChild("afnd", 0, false);
            ANNE.A.show(el_afnd);
            var filterval = "A"+$subfilter_val;
            if ($subfilter_val=="ALL") filterval = "ALL";

            var filterspan = "<span style='font-size:.7rem; font-weight:none; padding-left:4px'>:&nbsp;</span><span class='color-teal'>"+filterval+"</span>";
            var filterNOBJ = MEMG.getNeuronByNid(this.pt_classes[this.parent_i]);
            var total = "<span style='font-size:.7rem; font-weight:none; padding-left:14px'>cnt</span><span class='annefolio-ico-badge'>"+ANNE.UTILS.commas(arr.length)+"</span>";
            ANNE.A.setHTML("afnd_title", "<span class='filtered-heading'>"+filterNOBJ.text+"</span>"+filterspan+total);

            var farr = [];
            for (var a=0; a < arr.length; a++) {
                var nObj = arr[a];
                if (nObj._aplex==null) {
                    console.log("FIX THIS..WTHECK");
                    continue;
                }

                //do all
                if ($subfilter=="price_lvl" && $subfilter_val=="ALL") {
                    var pt = this.pts [ nObj.pts_i ];
                    if (pt==undefined || pt==null) {
                        console.log("debug this ");
                        console.warn("trouble:"+nObj.pts_i);
                        continue;
                    }
                    farr.push(nObj);
                    continue;
                }

                if (nObj._aplex[$subfilter]!=$subfilter_val) {
                    var pt = this.pts [ nObj.pts_i ];
                    pt.status=PT_STATUS_NOT_ACTIVE;
                    this.mesh.setColorAt( nObj.pts_i, this.g2color);    //not the active one anymore, ycolor is the new active.
                    continue;
                }
                var pt = this.pts [ nObj.pts_i ];
                if (pt==undefined || pt==null) {
                    console.log("debug this ");
                    console.warn("trouble:"+nObj.pts_i);
                    continue;
                }
                farr.push(nObj)
            }

            var bDO3JSLBL = true;
            if (farr.length>this.MAX_CSS_3JS_LBLS) {
                bDO3JSLBL=false;
            }

            if (bDO3JSLBL==false) {
                this.doAlphaSection(farr,$subfilter_val);
                this.mesh.instanceColor.needsUpdate = true;
                return;
            }
            
            //build ui elements on left and potentially the csslbls (if not too many)
            //if too many we pend the creation until the left item is clicked.
            for (var f=0; f < farr.length; f++) {
                var nObj = farr[f];
                var pt = this.pts [ nObj.pts_i ];
                
                pt.status=PT_STATUS_ACTIVE;
                this.mesh.setColorAt( nObj.pts_i, this.tcolor);
                
                if (pt.cssobj==null) {
                    const elLbl3js = document.createElement("div");
                    elLbl3js.innerHTML = nObj.bestNameHTML();
                    elLbl3js.classList = "neuron-name-floater";
                    elLbl3js.id="pt_"+nObj.pts_i;
                    elLbl3js.setAttribute("nid", nObj.nid);
                    pt.cssobj = new ANNE.CSS3DObject( elLbl3js );
                    pt.cssobj.position.set( pt.pt.x, pt.pt.y-4, pt.pt.z );
                    this.mesh.add(pt.cssobj);
                    pt.cssobj.lookAt(this.camera.position);
                    this.last_lbl_pts.push(pt);
                    
                    const eloverlay = document.createElement("div");
                    eloverlay.classList="annefolio-neuron-item";
                    eloverlay.innerHTML=nObj.bestNameHTML();
                    eloverlay.setAttribute("subfilter_val", $subfilter_val);
                    eloverlay.setAttribute("nid", nObj.nid);
                    var el_afnd = document.getElementById("afnd");
                    el_afnd.appendChild(eloverlay);

                    eloverlay.addEventListener("click", e=>{
                        if (eloverlay.classList.contains("highlight")==true) return;
                        var nid = eloverlay.getAttribute("nid");
                        var nObj2 = MEMG.getNeuronByNid(nid);
                        var subfilter_val = eloverlay.getAttribute("subfilter_val");
                        var pts_i = nObj2.pts_i;
                        THIS.ANX.addNeuronAnnexBtn(nObj2, nObj2.bestNameHTML()+" (<span class='color-green'>A"+subfilter_val+"</span>)", "right_holder", "", "scale80");
                        
                        THIS.mesh.setColorAt( pts_i, THIS.highlightFinalColor);
                        THIS.mesh.instanceColor.needsUpdate = true;
                        var elLbl3js = document.getElementById("pt_"+pts_i);
                        if (elLbl3js!=undefined && elLbl3js!=null) {
                            if (elLbl3js.classList.contains("highlight")==false) {
                                elLbl3js.classList.add("highlight");
                            }
                            if (elLbl3js.classList.contains("hide")==true) {
                                ANNE.A.show(elLbl3js);
                            }
                        }

                        //if we didn't make the cssobj (we had too many to render in 3js)
                        //make it when the user clicks on the left element.
                        else {
                            elLbl3js = document.createElement("div");
                            elLbl3js.innerHTML = nObj2.bestNameHTML();
                            elLbl3js.classList = "neuron-name-floater";
                            elLbl3js.classList.add("highlight");
                            elLbl3js.id="pt_"+nObj2.pts_i;
                            var pt = THIS.pts[pts_i];
                            pt.cssobj = new ANNE.CSS3DObject( elLbl3js );
                            pt.cssobj.position.set( pt.pt.x, pt.pt.y-4, pt.pt.z );
                            THIS.mesh.add(pt.cssobj);
                            pt.cssobj.lookAt(this.camera.position);
                            THIS.last_lbl_pts.push(pt);
                        }

                        eloverlay.classList.add("highlight");
                        ANNE.A.play("sharpbeep");
                        
                    });

                    elLbl3js.addEventListener("click", e=>{
                        if (elLbl3js.classList.contains("highlight")==true) return;
                        var nid = elLbl3js.getAttribute("nid");
                        var nObj3 = MEMG.getNeuronByNid(nid);
                        THIS.ANX.addNeuronAnnexBtn(nObj3, nObj3.bestNameHTML()+" (A"+$subfilter_val+")", "right_holder", "", "scale80");
                        this.mesh.setColorAt( nObj3.pts_i, THIS.highlightFinalColor);
                        this.mesh.instanceColor.needsUpdate = true;
                        elLbl3js.classList.add("highlight");
                        eloverlay.classList.add("highlight");
                        ANNE.A.play("sharpbeep");
                    });
                }
            }
            
            this.mesh.instanceColor.needsUpdate = true;
        }
    }


    /**
     * We hvae met the threshold to display oru elements in an alpha set.
     * @param {*} $neurons 
     * @param {*} $subfilter_val 
     */
    doAlphaSection=async($neurons, $subfilter_val)=> {
        var el_afnd = document.getElementById("afnd");
        var nids = []; 
        var obj_lbls = new Object();

        for (var n=0; n < $neurons.length; n++) {
            var nObj=$neurons[n];
            if (nObj==null) continue;
            if (nids.indexOf(nObj.nid)!=-1) continue;
            nids.push(nObj.nid);
            var parts = nObj.text.split(" ");
            var last_part = parts.pop();
            if (UTILS.isUSSuffix(last_part)==true) {
                last_part = parts.pop();
            }
            last_part.trim();
            
            var L = last_part.substring(0,1).toUpperCase();
            if (last_part=="" || last_part==" ") {
                L = "other";
            }
            else L = last_part.substring(0,1).toUpperCase();

            if ("ABCDEFGHIJKLMNOPQRSTUVWXYZ".indexOf(L)==-1) {
                L = "other";
            }
            if (obj_lbls[L]==undefined) {
                obj_lbls[L] =[nObj];
            }
            else {
                obj_lbls[L].push(nObj);
            }
        }

        const THIS = this;
        
        //alpha by last name
        for (var a=0; a < 27; a++) {
            var charcode = a+65;
            var char = String.fromCharCode(charcode);
            if (a==26) {//last index is for other (nums and no text)
                if(obj_lbls["other"]==undefined) continue;
                char = "other";
            }
            else if (obj_lbls[char]==undefined) continue;
            
            var blk = ANNE.A.ezSpan2(el_afnd, "", "annefolio-char-heading", char);
            blk.style.display="block";

            var nObjs = obj_lbls[char];
            var setel = ANNE.A.ezSpan2(el_afnd, "", "");
            setel.style['padding-right']='3px';
            
            for (var n=0; n < nObjs.length; n++) {
                var nObj = nObjs[n];
                var eloverlay = document.createElement("span");
                setel.appendChild(eloverlay);
                eloverlay.setAttribute("nid", nObj.nid);
                eloverlay.classList="annefolio-neuron-item";
                eloverlay.innerHTML=nObj.bestNameHTML();
                eloverlay.setAttribute("subfilter_val", $subfilter_val);
                eloverlay.setAttribute("nid", nObj.nid);
                eloverlay.addEventListener("click", $e=>{
                    $e.stopPropagation();
                    $e.preventDefault();
                    var eloverlay = ANNE.A.getNearestParentOf($e.target, "annefolio-neuron-item");
                    if (eloverlay.classList.contains("highlight")==true) return;
                    var nid = eloverlay.getAttribute("nid");
                    var nObj = MEMG.getNeuronByNid(nid);
                    var subfilter_val = eloverlay.getAttribute("subfilter_val");
                    var pts_i = nObj.pts_i;
                    THIS.ANX.addNeuronAnnexBtn(nObj, nObj.bestNameHTML()+" (<span class='color-green'>A"+subfilter_val+"</span>)", "right_holder", "", "scale80");
                    THIS.mesh.setColorAt( pts_i, THIS.highlightFinalColor);
                    THIS.mesh.instanceColor.needsUpdate = true;
                    var elLbl3js = document.getElementById("pt_"+pts_i);
                    if (elLbl3js!=undefined && elLbl3js!=null) {
                        elLbl3js.classList.add("highlight");
                    }

                    //if we didn't make the cssobj (we had too many to render in 3js)
                    //make it when the user clicks on the left element.
                    else {
                        elLbl3js = document.createElement("div");
                        elLbl3js.innerHTML = nObj.bestNameHTML();
                        elLbl3js.classList = "neuron-name-floater";
                        elLbl3js.classList.add("highlight");
                        elLbl3js.id="pt_"+nObj.pts_i;
                        var pt = THIS.pts[pts_i];
                        pt.cssobj = new ANNE.CSS3DObject( elLbl3js );
                        pt.cssobj.position.set( pt.pt.x, pt.pt.y-4, pt.pt.z );
                        THIS.mesh.add(pt.cssobj);
                        pt.cssobj.lookAt(this.camera.position);
                        THIS.last_lbl_pts.push(pt);
                    }

                    eloverlay.classList.add("highlight");
                    ANNE.A.play("sharpbeep");
                });
                
                if (n<$neurons.length-1) {
                    var pipe = document.createElement("span");
                    pipe.innerHTML="&nbsp;<span class='color-teal'>|</span>&nbsp;";
                    eloverlay.appendChild(pipe);
                }
            }
        }
    }

    /**
     * Emulate a new sponsored by neuron as well as an aplex record.
     * We need these here to be able to test this widget without enough data.
     * @param {*} nObj 
     * @param {*} newCnt 
     */
    emulateSponsoredBy=async($nObj, $parentNOBJ, $newCnt)=> {
        var sp = [];
        for (var m=0; m < $newCnt; m++) {
            var dNOBJ = await MEM.makeGhostNObj(ANNE.MEM.ANNE_ACCTID, NTYPE_INST, "emu ("+$parentNOBJ.bestNameHTML()+" #"+m+")", $parentNOBJ, true);
            dNOBJ.sponsored_by=$nObj.nid;
            dNOBJ.ntype = NTYPE_INST;
            dNOBJ.origin = ORIGIN_KEYLESS;
            dNOBJ.owned_by = MEM.ANNE_ACCTID;
            sp.push(dNOBJ);
            dNOBJ._aplex = new aplex(dNOBJ, dNOBJ.nid, null);
            dNOBJ._aplex.emulateAplex(10);
        }

        return sp;
    }
}

var u3js = {};

//quick class ptrs (not necessary but nice)
u3js.awarvu_ring = awarvu_ring;
u3js.awarez_tunnel = awarez_tunnel;


/**
 * 
 * @param {*} $camera 
 * @param {*} $mesh 
 * @param {*} $duration 
 */
u3js.flyby360=function($camera, $mesh, $duration) {
    //var radStep = (Math.PI * 2) / 12; 

    //ringbar.position.x = Math.cos(this.radStep*(r)) * this.outter_r;
    //ringbar.position.y = Math.sin(this.radStep*(r)) * this.outter_r;

}

    
u3js.makeCubePts = function($edgeLength, $edgeCnt) {
    var Ydelt = -$edgeLength/$edgeCnt;
    var Xdelt = $edgeLength/$edgeCnt;
    var Zdelt = -$edgeLength/$edgeCnt;
    var sheets = $edgeCnt;
    var startX = -$edgeLength/2;
    var startY = $edgeLength/2;
    var startZ = -(sheets/2)*Zdelt;
    var x, y, z;
    var points = [];
    var minX = 0; 
    var maxX = 0;
    for (var s=0; s < sheets; s++) {
        for (var r=0; r < $edgeCnt; r++) {
            for (var c=0; c < $edgeCnt; c++) {
                x = startX + (c*Xdelt);
                y = startY+(Ydelt*r);
                z = startZ+Zdelt*s;
                if (x<minX) minX = x;
                if (x>maxX) maxX = x;
                points.push( 
                    { 
                        pt:new THREE.Vector3(x, y, z), 
                        time:Math.random(),
                        factor:ANNE.UTILS.range(20, 120),
                        speed:ANNE.UTILS.range(0.01, 0.015)}
                    );
            }
        }
    }
    console.log("minX: "+minX+ " maxX:"+maxX);
    return points;
}


/**
 * 
 * @param {*} $pts 
 * @param {*} $width 
 * @param {*} $height 
 * @returns 
 */
u3js.makeSheetsPts = function($pts, $rows=24, $cols=24, $width=319, $height=150) {
    var yRowDelt = -$height/$rows;
    var xItemDelt = $width/$cols;
    var startX = -$width/2;
    var startY = $height/2;
    const zSheetDelt = -$width/100;
    var itemsPerSheet = $rows * $cols;
    var sheets = Math.ceil($pts/itemsPerSheet);

    var startZ = 0;
    if (sheets>1) startZ = -(sheets/2)*zSheetDelt;

    var x, y, z;
    var points = [];
    var minX = 0; 
    var maxX = 0;

    for (var s=0; s < sheets; s++) {
        for (var r=0; r < $rows; r++) {
            for (var c=0; c < $cols; c++) {
                x = startX + (c*xItemDelt);
                y = startY+(yRowDelt*r);
                z = startZ+zSheetDelt*s;

                if (x<minX) minX = x;
                if (x>maxX) maxX = x;

                var pt = new rev_point(points.length);
                pt.pt=new THREE.Vector3(x, y, z);
                
                points.push(pt);
            }
        }
    }
    //console.log("minX: "+minX+ " maxX:"+maxX);
    return {pts:points, mid_z:sheets*zSheetDelt/2};
}


u3js.makeNeuronElement2 = function($parentObj, $nObj, $matPos, $matNeg, $matNeu, $rank=1) {
    var el_outter = document.createElement("div");
    el_outter.classList = "neuron-3-wrapper";
    el_outter.setAttribute("overlay", true);


    var elData= document.createElement("div");
    elData.classList.add("n3-data");
    elData.innerHTML = "<span class='annex-yellow-sm-ico'></span><span>"+$nObj._aplex.price_lvl+"</span>";
    el_outter.appendChild(elData);

    var elName = document.createElement("div");
    elName.classList.add("n3-name");
    elName.innerHTML = "<span class='n3-namebg'>#"+$rank+" "+$nObj.text+"</span>";
    el_outter.appendChild(elName);

    //u3js.setImgAsBackground(el, $nObj);

    var posPer = .44;
    var negPer = .33;
    var neuPer = .23;

    const ringGeoPos = new THREE.RingGeometry( 60, 70, Math.round(posPer*100), 1, 0, posPer*Math.PI*2); 
    const posSlice = new THREE.Mesh( ringGeoPos, $matPos); 
    $parentObj.add(posSlice);
    const ringGeoNeg = new THREE.RingGeometry( 60, 70, Math.round(negPer*100), 1, posPer*Math.PI*2, negPer*Math.PI*2); 
    const negSlice = new THREE.Mesh( ringGeoNeg, $matNeg); 
    $parentObj.add(negSlice);
    const ringGeoNeu = new THREE.RingGeometry( 60, 70, Math.round(neuPer*100), 1, (posPer+negPer)*Math.PI*2, neuPer*Math.PI*2); 
    const neuSlice = new THREE.Mesh( ringGeoNeu, $matNeu); 
    $parentObj.add(neuSlice);

    const nCSSOBJ = new ANNE.CSS3DObject( el_outter );
    nCSSOBJ.position.set( 0, 0, 0 );
    $parentObj.add(nCSSOBJ);
    $parentObj.nCSSOBJ = nCSSOBJ;
    return nCSSOBJ;
}


/**
 * Load a default thumb and use it as a background div.
 * Ensure the min dimension is our min so the circle mask is full no matter what dimens the img.
 * @param {*} $el 
 * @param {*} $nObj 
 * @param {*} $min 
 */
u3js.setImgAsBackground=function($el, $nObj, $min=660) {

    var el = ANNE.A.__getEl($el);
    if (el==null) return;

    var url = ANNE.A.getThumbImgUrl($nObj);
    
    var newimgel = document.createElement( 'img' );
    newimgel.classList = "aring-img";
    newimgel.addEventListener('load', function () {
        var realW = this.width;
        var realH = this.height;
        var ratio = realW / realH;
        var smallestDimen = "w";
        if (realW > realH ) smallestDimen = "h";
        if (smallestDimen == "w") {
            newimgel.setAttribute("width", $min);
            var newH = $min / ratio;  //(>1 ratio)
            newimgel.setAttribute("height", newH);
        }
        else {
            newimgel.setAttribute("height", $min);
            var newW = $min * ratio; //<1 ratio
            newimgel.setAttribute("width", newW);
        }
        el.prepend(newimgel);
    });

    //load the img.
    newimgel.setAttribute('src', url); // Loads the image   
    return newimgel;
}


u3js.makeCirclePts = function($pts=12, $radius=1) {
    var pts = [];
    console.log("FSdFKLJSDFJLSDFJLDSF");
    var radStep = (Math.PI * 2) / $pts; 

    for (var i = 0; i <= $pts; i++) {
        var v3 = new THREE.Vector3();
        v3.x =  Math.cos(radStep*i)*$radius;
        v3.y =  Math.sin(radStep*i)*$radius;
        v3.z = 0;
        console.log("x:"+v3.x+" y:"+v3.y+" z:"+v3.z);
        pts.push(v3);
    }
    return pts;
}


u3js.makeRandSphericalPts = function($pts, $radius=1000) {
    var pts = [];
    for (var i = 0; i < $pts; i++) {
        var phi = Math.random() * Math.PI * 2; 
        var theta = Math.random() * Math.PI; 
        var x = $radius * Math.sin(theta) * Math.cos(phi);
        var y = $radius * Math.sin(theta) * Math.sin(phi);
        var z = $radius * Math.cos(theta);
        var point = new THREE.Vector3(x, y, z);
        pts.push(point);
    }
    return pts;
}



/**
 * 
 * @param {*} $pts 
 * @param {*} $r 
 * @returns 
 */
u3js.makeSphericalPts = function($pts, $r=1000) {
    const goldenRatio = (Math.sqrt(5.0) + 1.0) / 2.0;                
    const goldenAngle = (2.0 - goldenRatio) * (2.0 * Math.PI); 
    var points = [];
    var lat, lon;
    var x, y, z;
    for (let i=1; i <= $pts; ++i) {
        lat = Math.asin(-1.0 + 2.0 * (i / ($pts+1)));
        lon = goldenAngle * i;
        x = Math.cos(lon)*Math.cos(lat)*$r;
        y = Math.sin(lon)*Math.cos(lat)*$r;
        z = Math.sin(lat)*$r;
        points.push(new THREE.Vector3(x, y, z));
    }
    return points;
}


u3js.makeDebugSphere = function($parent, $position, $size=20, $color=0xfefe17, $opacity=.2) {
    var debuggeo = new THREE.SphereGeometry($size, 32, 16);
    var mat = new THREE.MeshBasicMaterial({ color: $color, wireframe:true, transparent:true, opacity:$opacity });
    var mesh = new THREE.Mesh(debuggeo, mat);
    mesh.ATYPE = DEBUG_SPHERE;
    if ($position!=null) mesh.position.copy($position);
    $parent.add(mesh);
    return mesh;
}


u3js.lerpSet=function($start, $end, $time, $slices) {
    const incs = $time / $slices;
    const delta = ($start - $end) / incs;
    let currentValue = $start;
    const vals = [];
    for (let i = 0; i <= incs; i++) {
        vals.push(currentValue);
        currentValue += delta;
    }
    return vals;
}


/**
 * 
 * @param {*} $mesh 
 * @param {*} $mag 
 */
u3js.poorMansLogoShake=function($gsap, $obj, $onComplete=null) {
    var x = $obj.position.x;
    var y = $obj.position.y;
    var z = $obj.position.z;
    var ani = $gsap.timeline();
    ani.to($obj.position, {
        x:x+20,
        y:y+20,
        z:z+20,
        ease:"rough",
        duration: .05
    })
    .to($obj.position, {
        x:x-20,
        y:y-20,
        z:z-20,
        ease:"rough",
        duration: .05
    })
    .to($obj.position, {
        x:x,
        y:y,
        z:z,
        ease:"rough",
        duration: .05,
        onComplete: async()=> {
            if ($onComplete!=null) $onComplete();
        }
    });
}



u3js.makeAndAddText=function($parent, $canvas="combinedCanvas", $text="Hello world") {
    const canvas = document.getElementById($canvas);
    const ctx = canvas.getContext('2d');
    ctx.clearRect(0, 0, combinedCanvas.width, combinedCanvas.height);
    ctx.font = "50px Arial";
    ctx.fillText($text, 50, 90);
    const imgsrc = canvas.toDataURL();
    return u3js.textgeo($parent, imgsrc);
}
u3js.textgeo = function($parent, $imgSrc) {
    const texture = new THREE.TextureLoader().load($imgSrc);
    const material = new THREE.MeshBasicMaterial({ map: texture, side:THREE.DoubleSide });
    const geometry = new THREE.PlaneGeometry(100, 100);
    const mesh = new THREE.Mesh(geometry, material);
    $parent.add(mesh);
    return mesh;
}


/**
 * At current rotational index,
 * with a low index of low and a high of high,
 * what is +/- number of rotational index slices do we need?
 * @param {*} $high - dial max
 * @param {*} $current 
 * @param {*} $next 
 */
u3js.circStepMinPath = function($max=200, $current, $next) {
    function getFwdDist($start, $end) {
        if ($end>$start) return $end-$start;
        else if ($end==$start) return 0;

        //loop to the max, then cover up to the start
        else return ($max-$start) + $end;
    }

    function getBwdDist($start, $end) {
        if ($end<$start) return $start-$end;
        else if ($end==$start) return 0;

        //loop to the max, then cover up to the start
        else return $start + ($max-$end);
    }

    var fwdDist = getFwdDist($current, $next);
    var backDist = getBwdDist($current, $next);
    console.log("%ccurrent "+$current+"%c next "+$next+"%c fwd "+fwdDist+"%c back "+backDist, TALK.bgblack, TALK.bgblue, TALK.bggreen, TALK.bgred);
    if (fwdDist < backDist) return fwdDist;
    return -backDist;
}



/**
 * @returns 
 * 
 * //ct=catmullrom
 * tension
 */
u3js.makeRandTunnelFromStartToDest = function($steps=6, $start, $destination, $bCLOSED=false, $ct="chordal") {
    var pts = [];
    pts.push($start);
    var lastX = $start.x;
    var lastY = $start.y;
    var lastZ = $start.z;
    var Xstepper = ($destination.x - $start.x)/($steps+1);
    var Zstepper = ($destination.z - $start.z)/($steps+1);
    for (var s = 0; s < $steps; s++) {
        lastX = lastX+Xstepper;//*Math.random();
        lastY = lastY;//UTILS.posNegRand(lastY);
        lastZ = lastZ+Zstepper;//*Math.random();
        lastpt = new THREE.Vector3(lastX, lastY, lastZ);
        pts.push(lastpt);
    }
    pts.push($destination);
    console.log(pts);

    return new THREE.CatmullRomCurve3(pts, $bCLOSED, $ct);

}


/**
 * 
 * @param {*} $num 
 * @param {*} $thetaStart 
 * @param {*} $thetaLength 
 * @param {*} $radius 
 * @returns 
 */
u3js.getPtsOnArc = function($num, $thetaStart, $thetaLength, $radius=2000) {
    var pts = [];
    var radStep = ($thetaLength / $num); 

    for (var p=0; p < $num; p++) {
        var y =   (Math.sin(radStep*(p))+ $thetaStart) * $radius;  
        var x = (Math.cos(radStep*(p))+ $thetaStart) * $radius; 
        pts.push(new THREE.Vector3(x, y, 0));
    }
    return new THREE.CatmullRomCurve3(pts);
}


u3js.lookAtGlobal=function($camera, $obj_space, $position_within_objspace) {
    var v3 = new THREE.Vector3($position_within_objspace);
    var v4 = $obj_space.localToWorld(v3);
    $camera.lookAt(v4);
}


/**
 * 
 * @param {*} $x 
 * @param {*} $y 
 * @param {*} $z 
 * @param {*} $f 
 * @returns 
 */
u3js.hardCode5ptTurn=function($x, $y, $z, $f=200) {
    var turn = [];
    var lastX = $x;
    var lastY = $y;
    var lastZ = $z;
    
    lastX += $f/3*((Math.random()*.2)+.8);
    lastY += $f/2*((Math.random()*.2)+.8);
    lastZ -= $f*((Math.random()*.2)+.8);
    var pt = new THREE.Vector3(lastX, lastY, lastZ);
    turn.push(pt);
    
    lastX += $f/3*((Math.random()*.2)+.8);
    lastY += $f*((Math.random()*.2)+.8);       //climb steeper
    lastZ -= $f/1.5*((Math.random()*.2)+.8);     
    var pt = new THREE.Vector3(lastX, lastY, lastZ);
    turn.push(pt);

    lastX += $f/1.5*((Math.random()*.2)+.8);
    lastY += $f*1.2*((Math.random()*.2)+.8);    //highest point like a jet float pause
    lastZ -= $f/2*((Math.random()*.2)+.8);      //no so far deeper  
    var pt = new THREE.Vector3(lastX, lastY, lastZ);
    turn.push(pt);

    lastX += $f/3*((Math.random()*.2)+.8);
    lastY -= $f*((Math.random()*.2)+.8);        //climb steeper
    lastZ += $f/1.5*((Math.random()*.2)+.8);     
    var pt = new THREE.Vector3(lastX, lastY, lastZ);
    turn.push(pt);

    lastX += $f/3*((Math.random()*.2)+.8);
    lastY -= $f/2*((Math.random()*.2)+.8);
    lastZ += $f*((Math.random()*.2)+.8);
    var pt = new THREE.Vector3(lastX, lastY, lastZ);
    turn.push(pt);
    return {pts:turn, lastX:lastX, lastY:lastY, lastZ:lastZ};
}


/**
 * 
 * @param {anne_file} $afile 
 * @returns 
 */
u3js.loadTexture=async($afile)=> {
    return new Promise((resolve, reject) => {
        var image = new Image();
        image.onload = function() {
            var texture = new THREE.DataTexture(image, image.width, image.height);
            texture.needsUpdate = true;
            resolve(texture);
        };
        image.onerror = function() {
            reject(null);
            return null;
        };

        try{
            if ($afile.b64data.indexOf("data")==0) image.src = $afile.b64data;
            else image.src = 'data:'+$afile.mimetype+';base64,' + $afile.b64data;
        }
        catch($e) {
            console.log($e);
            reject(null);
            return null;
        }

    });
}


/**
 * This is async but we do not await it.. let it update on its own as we continue on.
 * @param {*} $parent 
 * @param {anne_file} $afile 
 * @param {*} $biggest 
 * @param {*} $position 
 * @returns 
 */
u3js.imagePlane = async ($parent, $afile = null, $biggest = 200, $position)=> {
    if ($afile==null) return;
    const planeGeometry = new THREE.PlaneGeometry(1, 1);
    var texture = null;
    try {
        texture = await u3js.loadTexture($afile);
    }
    catch($e) {
        console.log($e);
        return;
    }
    if (texture==null) {
        return null;
    }
    var realW  = texture.image.width;
    var realH = texture.image.height;
    var ratio = realW / realH;
    var biggestD = realW;
    var smallestD = realH;
    var bgd = "w";
    if (realH > realW) {
        biggestD = realH;
        smallestD = realW;
        bgd = "h";
    }

    var newH = 0;
    var newW = 0;

    if (biggestD > $biggest) {
        if (bgd == "w") {
            newH = $biggest / ratio;  //(>1 ratio)
            newW = $biggest;
        }
        else {
            newW = $biggest * ratio; //<1 ratio
            newH = $biggest;
        }
    }

    texture.wrapS = THREE.RepeatWrapping;
    texture.wrapT = THREE.RepeatWrapping;
    texture.repeat.y = -1; 

    const material = new THREE.MeshBasicMaterial({ map: texture });
    const planeMesh = new THREE.Mesh(planeGeometry, material);
    planeMesh.position.copy($position);
    
    planeMesh.scale.set(newW, newH, 1);

    $parent.add(planeMesh);
}
