class relon_table {
    constructor($pgui) {
        this.pgui = $pgui;

        //back ref from the pgui to this.  We can use this when looking up this relon
        //table by guid (for GUI drama)
        this.pgui.INST = this; 

        this.pObj = $pgui.pObj;
        this.ID = $pgui._guid;
        this.tbl_divid = "anne_tbl_"+this.ID;

        var init_cols = this.pObj.init_cols;
        if (init_cols==undefined) {
            init_cols = ["txid", "type", "reln", "to", "actions"];
        }
        
        this.cols = [];
        this.nid = this.pObj.p1;
        this.nObj = MEMG.getNeuronByNid(this.nid);
        this.data = this.pObj.p2;
        this.bUS = this.pObj.p3;
        
        if (this.pgui.p3!=null) this.cols = this.pgui.p3;

        //class els.
        this.el_tbl = document.getElementById(this.tbl_divid);
        this.el_newRelon_str = this.pObj.p4;
        
        this.el_rowsearch = this.el_tbl.querySelector('.row-search');
        this.el_rowheader = this.el_tbl.querySelector('.row-header');
        this.el_tbl_title = ANNE.A.setHTML("tbl_title_"+this.ID, "");
        
        this.el_tblbody = this.el_tbl.querySelector('.anne-tbl-body-overflow');

        this.el_embedded_filters = ANNE.A.hide("anne_embedded_filters_"+this.ID);
        this.el_availableCols = document.getElementById("ds_available_cols_"+this.ID);

        this.el_gardeninfo = this.el_availableCols.querySelector(".ds-let-deny-list");
        ANNE.A.hide(this.el_gardeninfo);
        this.el_colchks = this.el_availableCols.querySelector(".ds-col-checks");

        this.el_edit_btn = ANNE.A.hide('tbl_edit_btn_'+this.ID, "glow");
        this.el_save_btn = ANNE.A.hide('tbl_save_btn_'+this.ID, "glow");
        

        //txid link
        this.cols.push({
            active:init_cols.indexOf("txid")!=-1 ? true : false, 
            text:"txid", 
            ttype:"txid", 
            dataprop:"txid", 
            sortprop:"**DISPLAY**",
            displayprop:"txid", 
            drill_txid:true,
            filter:false,
            c:this.cols.length,
            style_class:"txid-cell",
            f:"f1"
        });
        

        //type 
        this.cols.push({
            active:init_cols.indexOf("type")!=-1 ? true : false, 
            text:"type", 
            ttype:"string", 
            dataprop:"type", 
            displayprop:"type",
            sortprop:"**DISPLAY**",
            drill_neuron:true, 
            filter:true,
            c:this.cols.length,
            f:"f2"
        });

        
        //reln
        this.cols.push({
            active:init_cols.indexOf("reln")!=-1 ? true : false, 
            text:"reln", 
            ttype:"anne", 
            dataprop:"reln", 
            displayprop:"reln", 
            sortprop:"**DISPLAY**",
            drill_neuron:true, 
            filter:true,
            c:this.cols.length,
            f:"f3"
        });

        
        //to type
        this.cols.push({
            active:init_cols.indexOf("to_type")!=-1 ? true : false, 
            text:"to type", 
            ttype:"string", 
            dataprop:"to_type", 
            displayprop:"to type",
            drill_neuron:true, 
            sortprop:"**DISPLAY**",
            filter:true,
            c:this.cols.length,
            f:"f1"
        });
        

        //to
        this.cols.push({
            active:init_cols.indexOf("to")!=-1 ? true : false,  
            text:"to", 
            ttype:"misc", 
            dataprop:"to_s", 
            displayprop:"to", 
            drill_neuron:true, 
            drill_txid:true, 
            sortprop:"**DISPLAY**",
            filter:true,
            c:this.cols.length,
            f:"f3"
        });

        //relon sponsor
        this.cols.push({
            active:false,  
            text:"sponsor", 
            ttype:"anne", 
            dataprop:"relon_sponsor", 
            displayprop:"relon_sponsor", 
            drill_neuron:true, 
            drill_txid:true, 
            sortprop:"**DISPLAY**",
            filter:true,
            c:this.cols.length,
            f:"f3"
        });
        
        this.cols.push({
            active:init_cols.indexOf("actions")!=-1 ? true : false,
            text:"actions", 
            ttype:"**ADMIN**", 
            dataprop:"", 
            displayprop:"",
            filter:false, 
            c:this.cols.length,
            f:"f2",
            extra_class:"actions-col-header"
        });


        this.neuronLinkType = this.pObj.neuronLinkType;//displayFunct
        if (this.neuronLinkType==undefined || this.neuronLinkType==null) this.neuronLinkType = LINKS_NEURON_TBL_VIEW; 

        this.relonLinkType = this.pObj.relonLinkType;  //relonDisplayFunctStr
        if (this.relonLinkType==undefined) this.relonLinkType = LINKS_RELON_ANNE;

        for (var c=0; c < this.cols.length; c++) {
            var colObj = this.cols[c];
            var checked = true;
            var disabled = true;
            if (colObj.active==false) {
                checked = false;
                disabled = false;
            }
            var chk = ANNE.A.ezCheckMark(this.el_colchks, "chk_"+this.ID+"_"+colObj.dataprop, "xx", colObj.text, checked, disabled, "truncate120");
            chk.setAttribute("dataprop", colObj.dataprop);

            chk.addEventListener("click", $e=> this.chk_click($e));
        }

        //one-time, on init.  Any added columns is handled int the checkmark click event.
        var col_index = 0;
        for (var c=0; c < this.cols.length; c++) {
            var col = this.cols[c];
            if (col.active==false) continue;
            this.addColumnHeader(col, col_index);
            col.col_index = col_index;
            col_index+=1;
        }

        //this should have already been set, but fix it if it isn't.
        //the goveneor will try to collab if it doesn't see it is bMINE=true.
        if (this.nObj.owned_by==USER._userNObj.nid) this.nObj.bMINE=true;

        //iterate through the data ---
        //inject new "row" with cols and data.
        this.el_tblbody.setAttribute("active-cols", parseInt(col_index));
    }

    /**
     * Init w/ async support.
     * any inits we need that are async come through this standard initASYNC
     * init function called by the NF when it sees that it exists. 
     */
    initASYNC=async($pgui)=> {

        //cleanup and setting of .mine
        for (var dd=0; dd < this.data.length; dd++) {
            if (this.data[dd].rObj==null) {
                alert("this should have never happened");
                continue;
            }
            if (this.data[dd].rObj.f==undefined) {
                alert("this should have never happened");
                var fNOBJ = MEMG.getOrMakeIfNew(this.data[dd].rObj.from_nid);
                if (fNOBJ==null) continue;
                this.data[dd].rObj.f=fNOBJ.temp_nid;
            }
            var nObj = MEMG.getNeuronByTempNid(this.data[dd].rObj.f);
            if (nObj==null) {
                alert("this should have never happened");
                console.log(this.data[dd].rObj);
                continue;
            }
        }
        
        //pass the data here even though we have it.
        await this.addDataToColsInit(this.data);
        
        //serves as a callback..
        this.pgui.addRelon = async($relon)=> {
            var rObj = {rObj:$relon, active:true};
            await this.addDataToColsInit([rObj], true);
        }     

        this.pgui.hideRid = async($rid)=> {
            var row = this.el_tblbody.querySelector(".rowrid_"+$rid);
            if (row) ANNE.A.hide(row);
        } 

        //set up table footer display
        var rowslbl = ANNE.TALK.pluralizeNounIf2(this.data.length, "row", "rows");
        ANNE.A.setHTML("tbl_summary_"+this.ID, this.data.length+" "+rowslbl);

        //initialize the final table FX DOM events.
        this.initEvents(this.tbl_divid);
        ANNE.A.hide("loading"); 


        
        if (this.pObj.misc!=null) {
            if (this.pObj.misc.dataprop!=undefined) {
                var col = this.getColByDataProp(this.pObj.misc.dataprop);
                if (col && col.sortIco!=undefined) {
                    this.defaultSort(col.sortIco, this.pObj.misc.sort);
                }
            }
        }
    }

    
    /**
     * get active and inactive here..
     */
    getOuts = function() {
        var outs = [];
        for (var d=0; d < this.data.length; d++) { outs.push(this.data[d].rObj);}
        return outs;
    }


    /**
     */
    chk_click = function($e) {
        if ($e.target.checked==true) {
            var dataprop = $e.target.getAttribute("dataprop");
            var col = this.getColByDataProp(dataprop);
            if (col==null) return;
            console.log("you checked a new column of data w/ datanid:"+dataprop);
            col.active = true;
            var col_index = parseInt(this.el_tblbody.getAttribute("active-cols"));
            this.el_tblbody.setAttribute("active-cols", parseInt((col_index+1)));
            col.col_index = col_index; 

            //sort ico and filters are wired up in the addColumnHeader..
            this.addColumnHeader(col, col_index, this.tbl_divid, this.el_rowsearch, this.el_rowheader);
            this.addColumnToRows(col); //add the data to the rows.. 
        }
        else {
            var dataprop = $e.target.getAttribute("dataprop");
            var col_index = parseInt(this.el_tblbody.getAttribute("active-cols")-1);
            this.el_tblbody.setAttribute("active-cols", parseInt((col_index)));
            var col = this.getColByDataProp(dataprop)
            if (col==null) return;
            this.deleteColumnFromRows(col); //add the data to the rows..
            this.deleteColumnHeader(col.col_index);              
            col.active=false;
        }
    }

    /**
     */
    getColByDataProp = function($dataprop) {
        for (var c=0; c < this.cols.length; c++) {
            if (this.cols[c].dataprop==$dataprop) return this.cols[c];
        }
        return null;
    }


    /**
     * This will handle any collab row for this thing that is in the DOM,
     * even if it showed up in a table or ANNET.. etc.. (or both)
     */
    static updateCollabRow=async($ID, $collab_txid, $status_text)=> {
        var el_tbl = document.getElementById("anne_tbl_"+$ID);
        if (el_tbl==null) {
            console.log("relon tbl with id "+$ID+" not found in the DOM");
            return;
        }
        var el_rows = el_tbl.querySelectorAll(".rowtxid_"+$collab_txid);
        if (el_rows==null || el_rows.length==0) return;
        if ($status_text=="d") {
            for (var e=0; e < el_rows.length; e++) {
                var el_row = el_row[e];
                ANNE.A.removeSelf(el_row);
            }
            await MEM_UDF.removeCollab($collab_txid);                   // remove collab from collab memory
        }
        else if ($status_text=="a") {
            var collab_relon = await MEM_UDF.removeCollab($collab_txid); // remove collab from collab memory
            if (collab_relon==null) return;

            //run the collab relon through the mem processor.. get a real rid.
            var relon = MEMP.processNeuronsFromRelons([collab_relon], true, true, "relons", "relon_table.updateCollabRow");
            for (var e=0; e < el_rows.length; e++) {
                var el_row = el_row[e];
                el_row.classList.remove("pending-collab");
                el_row.classList.remove("rowtxid_"+$collab_txid);
                var el_datacol = el_row.querySelector('actionstxid_'+$collab_txid);
                if (el_datacol==null) continue;
                el_datacol.classList.remove('actionstxid_'+$collab_txid);  
                el_datacol.classList.remove('andy-ico');            
                el_row.classList.add("rowrid_"+relon.rid);
                el_datacol.classList.add("actionsrid_"+relon.rid);
            }
        }
    }

    /** 
     * A required param was set which allows for another param
     * to be activated now..
     */
    static makeNewTempParamFromVarParam=async($el, $newRelon, $param_txid)=> {
        var txid = $el.getAttribute("txid");
        if (txid==null) return;
        var relon = MEMG.lookupRelonByTXID(txid);
        if (relon==null) return;

        //make sure we don't make a glorious blunder.
        //we are trying to update a row that depended on another param being set first.
        //(conditional param)
        if (relon.depends_on==undefined) return;
        if (relon.depends_on!=$param_txid) return;
        
        //chase up this el to get the first anne-tbl.  this will have the tblid we 
        //need to get the instance of anne_relon_table.  (we are currently in a static function)
        var tbl = ANNE.A.getFirstParentOf($el, "anne-tbl");
        if (tbl==null) return;

        //extract the guid.
        var widget_id = tbl.id.substring(9);    //anne_tbl_ xxxxx
        if (widget_id=="") return;

        //ge the anne_relon_table.. (the INST on the pgui at runtime creation).
        var ANNE_RELON_TBL = NF.getINSTbyGuid(widget_id);
        if (ANNE_RELON_TBL==null) return;

        var newRel = ANNE_RELON_TBL.makeCDXParamIfNotExists(ANNE_RELON_TBL.nid, $newRelon, relon);
        var dObj = {active:true, rObj:newRel};
        ANNE_RELON_TBL.data.push(dObj);

        await ANNE_RELON_TBL.addDataToColsInit([dObj], true);

        //revisit this if we are "building" a definition and not "using" one.
        ANNE_RELON_TBL.deactivateRelon(relon.txid, $el);
    }   

    deactivateRelon = function($txid, $el) {
        for (var d=0; d < this.data.length; d++) {
            var dObj = this.data[d];
            if (dObj.active==false) continue;
            if (dObj.rObj.txid==$txid) {
                dObj.active=false;
                break;
            }
        }
        ANNE.A.hide($el);
    }

    getParamVarFulfillment=function($nObj, $txid) {
        var relon = MEMG.lookupRelonByTXID($txid);
        console.log(relon);
        ANNE.TALK.printRelon(relon);
        var rNOBJ = MEMG.getNeuronByTempNid(relon.r);
        console.log("(getParamVarFulfillment) looking for relon "+rNOBJ.text);

        if (relon.type!=TYPE_PARAM) return null;

        console.log($nObj);
        console.log($nObj.text);
        for (var r=0; r < $nObj.outs.length; r++) {
            var rel = $nObj.outs[r];
            if (rel.type!=TYPE_HAS) continue;
            if (rel.r==relon.r) return rel;
        }
        return null;
    }


    /**
     * make the new param that depended on another param to exist.
     * We can do this on-demand whenever this neuron comes into "mind".
     */
    makeCDXParamIfNotExists=function($nid, $fulfillmentRelon, $relon_pat) {
        console.log("makeCDXParam "+$nid);
        var nObj = MEMG.getNeuronByNid($nid);
        var to_t = $fulfillmentRelon.t;
        var to_s = $fulfillmentRelon.to_s;
        var relPatArr = [{prop:'type', val:TYPE_PARAM}, 
                            {prop:'r', val:$relon_pat.r}, 
                            {prop:'t', val:to_t}];
        console.log(relPatArr);
        var tempParamPat = MEMG.getRelByPat(nObj.outs, relPatArr);
        if (tempParamPat==null) {
            console.log("MAKE VAR PARAM!");
            relPatArr.push({from_nid:$nid});
            console.log("make param for:"+nObj.nid);
            var RNOBJ_AUDIT = MEMG.getNeuronByNid($relon_pat.reln);
            console.log("reln audit:"+RNOBJ_AUDIT.text);
            console.log("to_s audit:"+to_s);
            var to_type = TO_TYPE_ANNE;
            var newRelon = MEM.makeTempRelon(nObj, TYPE_PARAM, $relon_pat.reln, to_type, to_s, true);
            if ($relon_pat.required==true) newRelon.required=true;
            console.log(newRelon);
            var relpatrow = document.querySelector('rowrid_'+$relon_pat.rid);
            if (relpatrow!=null) ANNE.A.hide(relpatrow);
            return newRelon;
        }
        return null;
    }


    static refreshRowFromRelonUpdate = async($relon)=> {
        var relon = MEMG.lookupRelonByTXID(txid);
        if (relon==null) return;

        var row_els = $el.querySelectorAll('[txid="'+relon.txid+'"]');

        //if we have multiple tables with this entry open, this will still work.
        for (var e=0; e < row_els.length; e++) {
            var row_el = row_els[e];

            var tbl = ANNE.A.getFirstParentOf(row_el, "anne-tbl");
            if (tbl==null) return;
    
            //extract the guid.
            var widget_id = tbl.id.substring(9);    //anne_tbl_ xxxxx

            var ANNE_RELON_TBL = NF.getINSTbyGuid(widget_id);
            if (ANNE_RELON_TBL==null) return;

            ANNE.A.removeSelf(row_el); //remove the row from the GUI TABLE.

            //add the row back to the gui table.
            var newrow = await ANNE_RELON_TBL.addDataToColsInit([relon], true);
            newrow.classList.add("just-added");
        }
    }

    

    /**
     * Add data to cols.
     * 
     * We pass the data here because we also use this function for new single adds.
     * @author {Mr.Scatman}
     */
    addDataToColsInit=async($data, $bPREPEND=false, $callback=null)=> {
        console.log("data in table:"+$data.length);
        var dataNOBJ = MEMG.getNeuronByNid(this.nid);
        if (dataNOBJ==null) {
            alert("this can't be null here");
            return;
        }

        var thisTnid = dataNOBJ.temp_nid;
        var prepends = [];
        
        for (var d=0; d < $data.length; d++) {
            var bINHERITED = false;
            var dObj = $data[d];
            if (dObj.active==false) {
                console.log("skipping relon", dObj);
                continue;   //this was set in the helpers (to hide non-active types)
            }
            var relonObj = dObj.rObj;
            if (relonObj==null) {
                console.log("relon empty, skipping");
                continue;       //we must have a relon here.
            }
            if (relonObj.f!=thisTnid) {
                bINHERITED=true;
                console.log("INHERITED");
            }

            var newrow = document.createElement("div");
            newrow.classList="row";
            if (relonObj.status_text!=undefined && relonObj.status_text=="p") {
                newrow.classList.add("pending-collab");
                newrow.classList.add("rowtxid_"+relonObj.txid);
            }
            else newrow.classList.add("rowrid_"+relonObj.rid);

            if ($bPREPEND==false) this.el_tblbody.append(newrow);
            else {
                this.el_tblbody.prepend(newrow);
                newrow.classList.add("just-added");
            }

            newrow.setAttribute("txid", relonObj.txid);
            newrow.setAttribute("type", parseInt(relonObj.type));

            //highlight the required relon.
            var bDOINGREQUIRED = false;
            var adminMsgOverride = "";

            if (relonObj.type==TYPE_PARAM) {
                if (relonObj.required!=undefined && relonObj.required==true) {
                    newrow.classList.add("relon-required");
                    bDOINGREQUIRED = true;
                }
                
                if (relonObj.depends_on!=undefined) {
                    var fulfillmentRelon = this.getParamVarFulfillment(this.nObj, relonObj.depends_on);
                    if (fulfillmentRelon==null) {
                        newrow.classList.add("relon-dependson");
                        //if we get a param fulfilled of this txid we can do something 
                        //automatcially in the DOM
                        newrow.setAttribute("dotxid", relonObj.depends_on);
                        adminMsgOverride = "do "+LINKS.makeRelonLink(relonObj.depends_on, this.relonLinkType)+" first.";
                    }

                    //for already-made relons on reload of app or
                    //revisiting this neuron for the first time this session.
                    //(we do not store the cdx param relon extrapolation.. we run-time create it on-demand)
                    else {
                        var newRel = this.makeCDXParamIfNotExists(this.nid, fulfillmentRelon, relonObj);
                        if (newRel) {
                            if (relonObj.required!=undefined) newRel.required = relonObj.required;
                            if (relonObj.prompt!=undefined) newRel.prompt = relonObj.prompt;
                            prepends.push({active:true, rObj:newRel});
                        }
                        dObj.active = false;
                        ANNE.A.removeSelf(newrow);
                        continue;
                    }
                }
            }

            for (var c=0; c < this.cols.length; c++) {
                var col = this.cols[c];
                if (col.active==false) continue;
                var datacol = document.createElement("div");
                datacol.classList = "column cell";
                datacol.classList.add(col.f);
                
                if (col.style_class!=undefined) datacol.classList.add(col.style_class);

                var dataVal = relonObj[col.dataprop];
                var display = "";
                
                if (col.dataprop) datacol.setAttribute("dp", col.dataprop);

                newrow.append(datacol);

                if (col.ttype=="**ADMIN**") {
                    datacol.setAttribute("dp", "admin");
                    if (adminMsgOverride!="") {
                        //alert("admin override: "+adminMsgOverride)
                        datacol.innerHTML = "<div class='col-span'>"+adminMsgOverride+"</div>";
                        continue;
                    }

                    //no admin actions for frozen neurons.
                    if (dataNOBJ.freeze!=undefined && dataNOBJ.freeze==1) {
                        console.log("THIS NEURON IS FROZEN (aka locked)")
                        continue;
                    }
                    
                    //EXT TO DO: must make real events not injected js ones..
                    //await this.doAdminCol(newrow, datacol, dataVal, relonObj, dataNOBJ);
                    continue;
                }

                else if (col.dataprop=="type") {
                    display = TALK.typeTalk(dataVal);
                }
                else if (col.dataprop=="to_type") {
                    display = "<span class='text-white-soft'>"+TALK.toTypeTalk(dataVal)+"</span>";
                }
                else if (col.ttype=="anne") {
                    var nObj = MEMG.getNeuronByNid(dataVal);
                    EXT_BTNS.makeNeuronLink(datacol, nObj.nid, "col-span");
                    continue;
                    //display = "<span class='col-span'>"+LINKS.makeNeuronLink(nObj, this.neuronLinkType)+"</span>";
                }
                else if (col.ttype=="misc") {
                    if (col.dataprop=="to_s" && relonObj.to_type==TO_TYPE_ANNE) {
                        var nObj = MEMG.getNeuronByNid(dataVal);
                        ANNE.MEM_UDF.makeNeuronLink(datacol, nObj.nid, "col-span");
                        continue;
                    }
                    else {
                        if (relonObj.to_type==TO_TYPE_URL) {
                            display = "<a href='"+relonObj.to_s+"' class='link-blue' target='_new'><i class='ai-external-link-alt'></i>"+relonObj.to_s+"</a>";
                        }
                        else if (relonObj.to_type==TO_TYPE_TXID) {
                            //display =  "<span class='col-span'>"+LINKS.makeRelonLink(relonObj.to_s, this.relonLinkType)+"</span>";
                            ANNE.MEM_UDF.makeRelonViewLink(datacol, relonObj.to_s);
                            continue;
                        }
                        else {
                            display = "<span class='text-whiteF-lbl'>"+relonObj.to_s+"</span>";
                        }
                    }
                }

                //this will gen the txid ico and the relevant ghost ico (if needed)
                else if (col.ttype=="txid") {
                    var inh = "";
                    if (bINHERITED==true) inh = "inherited-relon";
                    ANNE.MEM_UDF.makeRelonViewLink(datacol, relonObj.txid, false, 8, true, inh);
                    continue;
                    //display =  "<span class='col-span'>"+LINKS.makeRelonLink(relonObj.txid, this.relonLinkType)+inh+"</span>";
                }

                else if (col.display!=undeined) {
                    display = relonObj[col.display];
                }

                if (display==undefined) display = dataVal;
                
                if (dataVal!=undefined && dataVal!=null) {
                    datacol.setAttribute("dataz", dataVal);
                }
                else console.log("UT OH");
                datacol.innerHTML = display;
            }

            if (dObj.active==false) newrow.display="none";
        }

        if (prepends.length) {
            await this.addDataToColsInit(prepends, true);
        }

        if ($callback!=null && typeof $callback==="function") $callback();
        return newrow;
    }


    /**
     * @author {Mr.Scatman} 
     */
    addColumnHeader = function($col, $col_index) {
        if ($col.filter==true) {
            var div = document.createElement("div");
            div.classList = "column";
            div.classList.add($col.f);
            if ($col.extra_class!=undefined) div.classList.add($col.extra_class);
            div.setAttribute("colnum", $col_index);
            div.setAttribute("tbl", this.tbl_divid);
            this.el_rowsearch.append(div);
            var input = document.createElement("input");
            input.classList = "tbl-filter";
            input.setAttribute("type", "text");
            input.setAttribute("placeholder", "filter the "+$col.text);
            div.append(input);
            input.addEventListener('input', $e=>relon_table.DOM_filterEvent($e))
        }
        else {
            var div = document.createElement("div");
            div.classList = "column";
            div.classList.add($col.f);
            if ($col.extra_class!=undefined) div.classList.add($col.extra_class);
            div.setAttribute("colnum", $col_index);
            div.setAttribute("tbl", this.tbl_divid);
            this.el_rowsearch.append(div);
        }

        //create the header cols in the header row
        var divh = document.createElement("div");
        divh.classList = "column";
        divh.classList.add($col.f);
        divh.setAttribute("colnum", $col_index);
        divh.setAttribute("tbl", this.tbl_divid);
        this.el_rowheader.append(divh);

        var sortIco = ANNE.A.ezSortCol(divh, $col, this.tbl_divid, "asc");
        sortIco.addEventListener("click", $e=> this.sortIcoClick($e));
        $col.sortIco = sortIco;
        return input;   //RETURN THE TBL FILTER
    }

    /**
     * The sort ico has been clicked
     * @author {Mr.Scatman}
     */
    sortIcoClick = function($e) {
        var el = $e.target;
        var sortDataType = el.getAttribute("prop");
        console.log(sortDataType);

        //parent child index is the column index of this header.
        //this will inform the DOM sort what column to pay attention to.
        var col_index = ANNE.A.getFirstParentAttr(el, "column", "colnum");
        var tbl = el.getAttribute("tbl");
        var isActive = el.classList.contains("activesort");
        if (isActive==null) isActive=false;
        var sort = el.getAttribute("sort");
        console.log("current sort:"+sort+" active:"+isActive);
        ANNE.A.removeAddClassOfAllIn(tbl, ".sortico", "activesort", el);
        var sort = relon_table.toggleSortIco(el, sortDataType, isActive, sort);
        
        //var iFix = (i*2) + 1;
        relon_table.DOM_sortTbl(tbl, col_index, sortDataType, sort);
    }

    defaultSort = function($el, $sort="asc") {
        var sortDataType = $el.getAttribute("prop");
        //console.log(sortDataType);

        //parent child index is the column index of this header.
        //this will inform the DOM sort what column to pay attention to.
        var col_index = ANNE.A.getFirstParentAttr($el, "column", "colnum");
        var tbl = $el.getAttribute("tbl");
        var isActive = $el.classList.contains("activesort");
        if (isActive==null) isActive=false;
        var sort = $el.setAttribute("sort", $sort);
        //console.log("current sort:"+sort+" active:"+isActive);
        ANNE.A.removeAddClassOfAllIn(tbl, ".sortico", "activesort", $el);
        var sort = relon_table.toggleSortIco($el, sortDataType, isActive, sort);
        relon_table.DOM_sortTbl(tbl, col_index, sortDataType, sort);
    }


    /**
     * @author {Mr.Scatman} 
     */
    deleteColumnHeader = function($col_index) {
        var searchheader = this.el_rowsearch.querySelectorAll('div[colnum="'+$col_index+'"]')[0];
        searchheader.remove();
        var colheader = this.el_rowheader.querySelectorAll('div[colnum="'+$col_index+'"]')[0];
        colheader.remove();
    }


    /**
     * @author {Mr.Scatman} 
     */
    addColumnToRows = function($col) {
        for (var d=0; d < this.data.length; d++) {
            if (this.data[d].active==false) continue;
            var relonObj = this.data[d].rObj;
            var rowdiv = this.el_tblbody.querySelectorAll('div[txid="'+relonObj.txid+'"]')[0];
            if ($col.active==false) break; //this should be active
            var datacol = document.createElement("div");
            datacol.classList = "column cell";
            datacol.classList.add($col.f);
            var dataVal = relonObj[$col.dataprop];
            if ($col.ttype=="anne") {
                var nObj = MEMG.getNeuronByNid(dataVal);
                display = GUI_STUFF.makeANNENeuronLink(nObj, 64, true);
            }
            else var display = relonObj[$col.display];
            datacol.setAttribute("dataz", dataVal);
            datacol.innerHTML=display;
            rowdiv.append(datacol);
        }
    }


    /**
     * @author {Mr.Scatman} 
     */
    deleteColumnFromRows = function($col) {
        const tblbody = this.tbl.querySelector('.anne-tbl-body-overflow');
        for (var d=0; d < this.data.length; d++) {
            if (this.data[d].active==false) continue;
            var relonObj = this.data[d].rObj;
            var rowdiv = tblbody.querySelectorAll('div[txid="'+relonObj.txid+'"]')[0];
            var datacol = rowdiv.children[$col.col_index];
            if (datacol!=null) datacol.remove();
        }
    }


    /**
     * @author {Mr.Scatman} 
     */
    initEvents = function($tbldivid) {
        return;
        //these jack with the formatting too much. not worth it.
        //const fxwrapper = tbl.querySelector(".anne-tbl-fx-wrapper"); //we can use this for bigger FX
        const tbl = document.getElementById($tbldivid);
        const footer = document.querySelector(".anne-tbl-footer");
        const downs = tbl.querySelector(".anne-downloadables");
        const ups = tbl.querySelector(".anne-uploadables");

        footer.addEventListener("mouseenter", (e) => {
            tbl.style.transition = "none";
            downs.style.transition  =  "all 0.5s ease-in";
            downs.style.transform = "translateX(-180px) translateY(20px)  scale(1.4)";
            ups.style.transition  =  "all 0.5s ease-in";
            ups.style.transform = "translateX(-100px) translateY(20px) scale(1.4)";
            footer.style["height"] = "64px";
            footer.style.transition  =  "all 0.5s ease-in";
        });

        footer.addEventListener("mouseleave", (e) => {
            downs.style.transition  =  "all 0.3s ease-out";
            downs.style.transform = "translateX(0px) translateY(0px)  scale(1)";
            ups.style.transition  =  "all 0.3s ease-out";
            ups.style.transform = "translateX(0px) translateY(0px) scale(1)";
            footer.style["height"] = "32px";
            footer.style.transition  =  "all 0.3s ease-out";
        });
    }


    /**
     * @author {Mr.Scatman} 
     */
    static DOM_sortTbl=function($divid, $col_index, $sortDataType, $sortDir) {
        var tbl = document.getElementById($divid); 
        if (tbl==null) return;
        const rows = tbl.querySelectorAll(".row");
        var masterRowParent = rows[0].parentElement;
        var rowsData = Array.prototype.slice.call(rows, 0);
        var dir = 1;
        if ($sortDir=="asc") dir *= -1;

        //sort them  (keep these separated even tho they are the same.. for now)..
        //we may need to handle differently..
        if ($sortDataType=="string" || $sortDataType=="anne") {
            rowsData.sort(function(a,b) {
                if (a.children[$col_index]==undefined) return 0;
                var txta = a.children[$col_index].innerHTML;//getAttribute("dataz");//textContent;
                if (b.children[$col_index]==undefined) return 0;
                var txtb = b.children[$col_index].innerHTML;//getAttribute("dataz");
                if(txta > txtb) { return -1*dir; }
                if(txta < txtb) { return 1*dir; }
                return 0;
            });
            
        }
        else if ($sortDataType=="numeric") {
            rowsData.sort(function(a,b) {
                if (a.children[$col_index]==undefined) return 0;
                var txta = (a.children[$col_index].innerHTML);//.getAttribute("dataz"));
                if (b.children[$col_index]==undefined) return 0;
                
                var txtb = (b.children[$col_index].innerHTML);//.getAttribute("dataz"));
                if(txta > txtb) { return -1*dir; }
                if(txta < txtb) { return 1*dir; }
                return 0;
            });
        }

        else {
            rowsData.sort(function(a,b) {
                if (a.children[$col_index]==undefined) return 0;
                var txta = (a.children[$col_index].innerHTML);//.getAttribute("dataz"));
                if (b.children[$col_index]==undefined) return 0;
                
                var txtb = (b.children[$col_index].innerHTML);//.getAttribute("dataz"));
                if(txta > txtb) { return -1*dir; }
                if(txta < txtb) { return 1*dir; }
                return 0;
            });
        }

        //put them back in.
        rowsData.forEach(row => {
            masterRowParent.appendChild(row)
        });
    }


    /**
     */
    static DOM_filterEvent = async($e)=> {
        var el = $e.target;
        var text = el.value;
        await relon_table.DOM_Filter(el, text); 
    }


    /**
     */
    static DOM_Filter=async($el, $text)=> {
        const col = ANNE.A.getFirstParentOf($el, "column");
        const tbldivid = col.getAttribute("tbl");
        const childindex = col.getAttribute("colnum");
        const tbl = document.getElementById(tbldivid);
        //console.log("filter tbl:"+tbl+" col "+childindex+" text "+$text);

        //get all the rows, turn off any rows where the colIndex doesn't match the text.
        const ID = tbldivid.split("_").reverse()[0].trim();

        var max_rows = 0;
        var on_cnt = 0;

        //var pgui = NF.getPguiByGUID(ID);

        //turn on all rows
        tbl.querySelectorAll(".row").forEach(row => {
            row.style.display="flex";
            max_rows++;
        });

        const tblFilters = tbl.querySelectorAll(".tbl-filter");
        for (var t=0; t < tblFilters.length; t++) {
            var tblfilter = tblFilters[t];
            var cIndex = ANNE.A.getFirstParentAttr(tblfilter, "column", "colnum");
            
            if (tblfilter.value.length) {
                var on_cnt = relon_table.DOM_Filter_single(tblfilter, tblfilter.value, cIndex);
                
                //check the last filter (the net sum of all visible/not visible)..
                //it will return the on_cnt.. 
                if (tblFilters.length-1==t) {
                    max_rows = max_rows-on_cnt;
                }
            }
        }

        var rowslbl = ANNE.TALK.pluralizeNounIf2(on_cnt, "row", "rows");
        ANNE.A.setHTML("tbl_summary_"+ID, on_cnt+" "+rowslbl);
    }



    /**
     */
    externalDataChange = function ($tbl_el, $types) {
        var max_rows = 0;
        var on_cnt = 0;

        var tbl_el = typeof $tbl_el === "string" ? document.getElementById($tbl_el) : tbl_el = $tbl_el;
        if (tbl_el==null) return null;
        var ID = $tbl_el.id;
        
        //turn on all rows
        tbl_el.querySelectorAll(".row").forEach(row => {
            var type = parseInt(row.getAttribute("type"));
            if ($types.indexOf(type)!=-1) row.style.display="flex";
            else row.style.display="none";
            max_rows++;
        });


        const tblFilters = tbl_el.querySelectorAll(".tbl-filter");
        for (var t=0; t < tblFilters.length; t++) {
            var tblfilter = tblFilters[t];
            var cIndex = ANNE.A.getFirstParentAttr(tblfilter, "column", "colnum");
            
            if (tblfilter.value.length) {
                var on_cnt = relon_table.DOM_Filter_single(tblfilter, tblfilter.value, cIndex);
                
                //check the last filter (the net sum of all visible/not visible)..
                //it will return the on_cnt.. 
                if (tblFilters.length-1==t) {
                    max_rows = max_rows-on_cnt;
                }
            }
        }

        var rowslbl = ANNE.TALK.pluralizeNounIf2(on_cnt, "row", "rows");
        ANNE.A.setHTML("tbl_summary_"+ID, on_cnt+" "+rowslbl);
    }


    static DOM_Filter_single=function($el, $text) {
        const col = ANNE.A.getFirstParentOf($el, "column");
        const tbldivid = col.getAttribute("tbl");
        const childindex = col.getAttribute("colnum");
        const tbl = document.getElementById(tbldivid);
        console.log("filter tbl:"+tbl+" col "+childindex+" text "+$text);

        var regex = new RegExp($text, 'i');
        var bEXACT = false;
        var onCnt = 0;

        tbl.querySelectorAll(".row").forEach(row => {
            var dataz = row.children[childindex].innerHTML;
            if (row.style.display=="none") return;  //skip row, go to next.
            if (dataz==null) row.style.display="none";
            else if (bEXACT==false) {
                if(regex.test(dataz)==false) row.style.display="none";
                else {
                    row.style.display="flex";
                    onCnt+=1;
                }
            }
            else if (dataz !== $text) row.style.display="none";
            else {
                row.style.display="flex";
                onCnt+=1;
            }
        });
        return onCnt;
    }


    /**
     * toggleSortIco 
     * If bISACTIVE=false then do NOT toggle the sort.. just apply the       
     * .activesort class.  If it is active we will leave it active (no need  
     * to apply the activesort class) but we will flip the ico and the dir.
     */
    static toggleSortIco = function($el, $sortDataType, $bISACTIVE, $dir="asc") {
        //console.log("toggleSortIco sort coming set to dir:"+$dir+" active:"+$bISACTIVE);
        if ($bISACTIVE==false) {
            $el.classList.add("activesort");
            //console.log("toggleSortIco returning dir:"+$dir);
            return $dir;
        }
        if ($dir=="asc") {
            ANNE.A.setAttribute($el, "sort", "desc");
            if ($sortDataType=="string" || $sortDataType=="anne") ANNE.A.addRemoveClass($el, "ai-sort-alpha-up", "ai-sort-alpha-down"); 
            else if ($sortDataType=="number") ANNE.A.addRemoveClass($el, "ai-sort-amount-up", "ai-sort-amount-down"); 
            else ANNE.A.addRemoveClass($el, "ai-sort-up", "ai-sort-down"); 
            console.log("toggleSortIco returning dir:desc");
            return "desc";
        } 
        else {
            ANNE.A.setAttribute($el, "sort", "asc");
            if ($sortDataType=="string" || $sortDataType=="anne") ANNE.A.addRemoveClass($el, "ai-sort-alpha-down", "ai-sort-alpha-up"); 
            else if ($sortDataType=="number") ANNE.A.addRemoveClass($el, "ai-sort-amount-down", "ai-sort-amount-up"); 
            else ANNE.A.addRemoveClass($el, "ai-sort-down", "ai-sort-up"); 
            console.log("toggleSortIco returning dir:asc");
            return "asc";
        }
    }

    
    /** 
     * Display a relons table.
     * 
     * hijack the relons content table to display relons
     * These can be edited and created.
     *
     * @author {Mr.Scatman}
     */
     static initRelonsTblDisplay=async ($parent_pgui, $displaydivid, $ID="demouniqueid", $new_relon_injection_divid="new_relon_injection",$pObj=null, $part_page="") => {
        var acsEl = document.getElementById($displaydivid+'_'+$ID);
        var acceptable_outs = [];
        var nid = "";
        var targetNOBJ=null;

        //NEED TO GET ALT-INHERITED LATERAL BES.
        //either from BE_CHILDREN/BE_PARENT
        //or an alt BE..  (so any TYPE_BE alt TO_TYPE_ANNE).

        if ($parent_pgui.pObj.p1!=USER._userNObj.nid || ($pObj!=null && $pObj.hijackp1!=undefined)) {
            if ($pObj!=null && $pObj.hijackp1!=undefined) nid=$pObj.hijackp1;
            else nid = $parent_pgui.pObj.p1;

            targetNOBJ = MEMG.getNeuronByNid(nid);
            
            //if this is an identity, re-route this to our identity display which 
            //has some subtle nuances.
            if (MEM.tempBeIsA(targetNOBJ.temp_nid, MEM.identity.temp_nid, NTYPE_INST)==true) {
                var basic_types_other_identity =  [TYPE_HAS, TYPE_BE, TYPE_CLUMP, TYPE_ROLE];
                acceptable_outs = MEMG.prepForIdentity(targetNOBJ, basic_types_other_identity);
            }

            //TO DO ---
            //WE NEED TO INHERIT CLUMPS that specify HAS type info..
            //If a class defines a HAS via a clump, we need to get it!
            else {
                
                //parent line inherits
                var bADDSELF = true;
                var bEXTRAPRETURN = true;
                acceptable_outs = MEMG.getParentLineRelons(targetNOBJ, [TYPE_SYS, TYPE_BE, TYPE_PARAM, TYPE_HAS, TYPE_CLUMP, TYPE_ROLE], [], bADDSELF, bEXTRAPRETURN);
            }
        }


        //used for self-identity
        else {
            targetNOBJ = MEMG.getNeuronByNid($parent_pgui.pObj.p1);
            acceptable_outs = MEMG.prepForIdentity(targetNOBJ);
        }

        return await relon_table.buildRelonContentTbl($parent_pgui, acsEl, targetNOBJ.nid, [0,1,2,3,5,6,7,8,9], acceptable_outs, $new_relon_injection_divid, $pObj, $part_page);
    }


    /**
     * Build a relons content table.
     * 
     * @author {Mr.Scatman}
     */
    static buildRelonContentTbl=async ($parent_pgui, $domEl, $nid, $types=[0,1,2,3,5,6,7,8,9], $useOnlyTheseOuts=[], $newRelonEl="display_data", $pObj=null, $part_page="") => {
        var nObj = MEMG.getNeuronByNid($nid);
        var bUS = USER.isUsOrOwnedByUs(nObj.nid);
        var outs = $useOnlyTheseOuts;

        if (outs.length==0) outs = nObj.outs;
        if (outs.length==0) {
            var el=document.createElement("div");
            el.classList = "no-more";

            el.innerHTML='<span><i class="ai-exclamation-triangle"></i>&nbsp;There are no additional relons in the system for this neuron</span>';
            $domEl.append(el);
            return;
        }

        //do our best to have basic info for all the parts of the relons.
        var done = await MEMG.extractAllFromRelonsAndChaseMin(outs,true);

        var finalRelons=[];
        var _usedTXIDs=[];
        var types=[0,1,2,3,5,6,7,8,9];

        if ($pObj!=null && $pObj.misc!=null && $pObj.misc.types!=undefined) {
            types = $pObj.misc.types;
            console.log(types);
        }

        console.log($pObj);

        //ANNE.TALK.printRelons(outs);

        for (var r=0; r < outs.length; r++) {
            var relon = outs[r];
            if (_usedTXIDs.indexOf(relon.txid)!=-1) continue;

            //skip any PARAM relons we already have supplied a HAS for...
            //for now multiples_ok is a hack prop we hardcoded to set for easy access.
            //to do it right (dynamically) we will need to encode the multiples_ok into a relon
            //and process it -- and set the flag in the mem processing whenever we find
            //a relon pointing from some class to a TXID with the multiples_ok reln.
            //ie,   class->multiples_ok->txid 22o34u2o3oi23uo2i3u42o
            //txid 22o34u2o3oi23uo2i3u42o  =  PARAM class->annothers->class 
            if (relon.type==TYPE_PARAM && (relon._multiples_ok==undefined || relon._multiples_ok==false)) {
                var toNObj = MEMG.getNeuronByNid(relon.to_s);
                var bWEHAVEIT=false;

                //if no garden is set, this is not us, and this is the garden relon,
                //skip it.  WE can't collab on no garden classes!
                //if (bUS==false && nObj._gt==null && relon.r==MEM.garden_type.temp_nid) continue;
                
                bWEHAVEIT = MEM.hasMetClassDefn(outs, relon, toNObj);

                var relnNOBJ = MEMG.getNeuronByTempNid(relon.r);
                
                if (bWEHAVEIT == true) {
                    continue;
                }
            }

            _usedTXIDs.push(relon.txid);
            var active = false;
            if (relon.r==MEM.name.temp_nid) {
                console.log("test");
            }

            if (types.indexOf(relon.type)!=-1) active = true;
            finalRelons.push({rObj:relon, active:active});
        }

        //gets relons from collab space (MEM_UDF._collab_relons)
        var andy_relons = MEM_UDF.getAndyTblRelonsForNid($nid);
        if (andy_relons!=null) {
            finalRelons = andy_relons.concat(finalRelons);
        }

        //pass the relons we want into the RELONTBL..
        var paramsObj=new page_params(null, null, null, $nid, finalRelons, bUS, $newRelonEl);
        var div = document.createElement("div");
        div.id = "relons_tbl_"+$domEl.id;
        console.log(div.id);
        div.style['min-width']="100%";
        $domEl.append(div);
        paramsObj.injection_div = div.id;
        paramsObj.randSeed = UTILS.randomHex(4);

        //default sort -- (we could pass this through the pObj if we wanted..
        //to override this default)
        if (paramsObj.misc==null) paramsObj.misc = {sort:"asc", dataprop:"type"};
        else {
            paramsObj.misc.sort = "asc";
            paramsObj.misc.dataprop = "type";
        }

        //transfer over any important props for this load.
        //we may have things like .strip_all, .init_cols, etc.
        if($pObj!=null) {
            var keys = Object.keys($pObj);
            for(var k=0; k < keys.length; k++) {
                var key = keys[k];
                paramsObj[key] = $pObj[key];
            }
        }

        if ($part_page!="") await $parent_pgui.loadPart($part_page, paramsObj, false, true);
        else return paramsObj;
    }



    /** 
     * Delete a relon.
     * 
     * Typically invoked from clicking on a X in a display column of some 
     * kind.  What we do differs depending on what type of relon this is.  
     * 
     * Ghosts are deleted from the ghost DB..  real TXIDS create inhibits.                                                                  *
     * 
     * Inhibits of this variety must be inhibited from the from...        
     * For self identity this is easy, the logged in user is the from.      
     * For neurons they own (like a favorite list) THAT from must be used   
     * to send the inhibit in order for it to be respected/honored in ANNE. 
     * 
     * @param {string} - the long string txid of the relon we want to delete.
     * @author {Mr.Scatman}
     * 
     */
    static deleteThisRelon=async ($txid) => {
        console.log($txid);
        console.log("delete relon here");
        console.log("remove the relon from the gui");
        var rObj = MEMG.lookupRelonByTXID($txid);
        var text = "";
        if (rObj == null) {
            //chase txid.. we should have it, but let's try again anyhow.
            rObj = await CHASE.getANNETX($txid);
            if (rObj == null) return;
        }

        if (ANNE.TALK != null)  text = ANNE.TALK.printRelon(rObj,true);
        var bGHOSTLOCALDELETE = false;;
        var msg = "";
        if (rObj.ghost == true) {
            bGHOSTLOCALDELETE = true;
            msg = "Are you sure you want to delete this GHOST from local memory?";
        }
        else {
            msg = "Are you sure you want to delete this from ANNE?";
            if (rObj.temp == false) msg = msg+"  We must send a delete transaction to ANNE to delete GUI_STUFF.";
        }

        var r = confirm(text+"<BR>"+msg);
        if (r == false) return;

        //if this is temp, remove it from the Q and the present display table.
        //the user has changed their mind.
        if (rObj.temp == true) {
            ANNE.A.removeSelf('.rowrid_'+rObj.rid);     //remove the rid anywhere it is displayed

            //this is for displayed relons that were created by the user,
            //then they decided to uncreate them.
            //this shows up the option to add the same thing once again.
            if (rObj.param_rid!=undefined) ANNE.A.fadeIn(".rowrid_"+rObj.param_rid);

            //delete it from ghost db tables if this is OUR ghost.
            if (bGHOSTLOCALDELETE) {
                if(ANNE.DB_local!=null) await ANNE.DB_local.delete([rObj]);
            }
            await SENDQ.deleteItemsByTXID(rObj.txid,rObj);
            return;
        }


        //NEW METHOD IN ANY TABLE WITH DELETES (for non temp items, ie, existing in mem and real)
        //JUST FADE OUT THE RELON
        //ON UNDO, we fade back in via the ANNE._queDelete
        //ON SUCCESSFUL actual delete, we search for, and remove, any of these rows in ANNE._postProcessSentTXIDS
        ANNE.A.fadeOut('.rowrid_'+rObj.rid);

        var fromNOBJ=null;
        if (rObj.from_nid == USER._userNObj.nid) fromNOBJ = USER._userNObj;
        else {
            fromNOBJ = MEMG.getOrMakeIfNew(rObj.from_nid);
            if (ANNE.CHASE!=null) var done = await CHASE.queryForOuts(fromNOBJ,true,[0,1]);
        }
        
        //inhibit or arbor prune??  //_makeArborPrune
        await fromNOBJ._makeArborPrune($txid);
    }
}