/**
 * This is a quick method for table display..
 * Below this class is the DSTBL obj which is a different method.
 */
class neuron_table {
    constructor($pgui, $bDOHEADING=true, $heading_prop="title", $dcf=".smart-scroll-framer", $YBUF=52) {
        this.pgui = $pgui;
        this.guid = "000000";
        if ($pgui!=null) this.guid=$pgui._guid;
        this.el_update_cnt = null;

        this.do_heading = $bDOHEADING;
        this.heading_prop = $heading_prop;
        this.records = [];
        this.cols = {};
        this.bPAGINATOR=true;
        this.PAGINATOR = null;
        this.default_class_framer = $dcf;
        this.YBUF = $YBUF;
        this.heading_col_class = "";
        this.tbl_row_class = "anne-table-row";
        this.neuron_heading_row_class= "neuron-tbl-heading";

        var el_page = document.querySelector(this.default_class_framer);
        if (el_page==null) {
            conosle.warn("set the el_page via the default_class_framer here!" +$dcf);
            var el_loader = document.querySelector("load-wrapper");
            var bcr = el_loader.getBoundingClientRect();
            this.max_bottom =  bcr.bottom;
        }
        else {
            var bcr = el_page.getBoundingClientRect();
            this.max_bottom = bcr.bottom;
        }

        this.rankCol = {
            neuron_link:false,
            title:"",
            class1:"mw40",
            prop:"rank",
            sort_prop:"rank",
            sort_type:"numeric"
        }

        this.bDOCELLCLASSES = false;
        this.bCOLORSQARES = false;

        this.bDOBORDER = true;

        this.el_heading_row = null;
        this.el_tbl_body = null;
        this.el_paginator = null;

        this._ROW_MAX_H = 30;
        this.primaryKey = null;
    }

    setPrimaryKey = function($primaryKey) {
        this.primaryKey = $primaryKey;
    }

    wipeTableEls = function() {
        ANNE.A.removeSelf(this.el_heading_row);
        ANNE.A.removeSelf(this.el_tbl_body);
        ANNE.A.removeSelf(this.el_paginator);
        this.el_heading_row = null;
        this.el_tbl_body = null;
        this.el_paginator = null;
    }


    /**
     * For manual set we just pass the objects and add
     * an active prop
     */
    setManualCols = function($cols, $objs) {
        this.cols = $cols;

        var pkcheck = new Object();
        if ($objs.length>0) {
            for (var x=0; x < $objs.length;x++) {
                var obj = $objs[x];
                if (this.primaryKey!=null) {
                    var pk = obj[this.primaryKey];
                    if (pk==null) {
                        console.log("pk missing on obj, skipping")
                        continue;
                    }

                    if (pkcheck[ pk] !=null) {
                        console.log("pk violation, skippping");
                        continue;
                    }

                    //just turn it on, only one can use this key.
                    pkcheck [ pk ]  = true;
                }

                obj.active = true;
                obj.rank="#"+(x+1);
                this.records.push(obj);
            }
        }
    }


    /**
     * 
     * @param {*} $objs 
     */
    updateRecordsAndRefresh = function($objs) {
        console.log("updateRecordsAndRefresh");
        this.records = [];

        var pkcheck = new Object();
        if ($objs.length>0) {
            for (var x=0; x < $objs.length;x++) {
                var obj = $objs[x];
                if (this.primaryKey!=null) {
                    var pk = obj[this.primaryKey];
                    if (pk==null) {
                        console.log("pk missing on obj, skipping")
                        continue;
                    }

                    if (pkcheck[ pk] !=null) {
                        console.log("pk violation, skippping");
                        continue;
                    }

                    //just turn it on, only one can use this key.
                    pkcheck [ pk ]  = true;
                }

                obj.active = true;
                obj.rank="#"+(x+1);
                this.records.push(obj);
            }
        }
    }



    /**
     * custom maker view cols for the maker widget
     * We could just pass these in but I prefer them here.
     */
    makerViewSubCols = function($nObjs) {
        this.setRecsFromNObjs($nObjs);
        this.cols = [{
                neuron_link:true,
                title:"name",
                prop:"nid",
            },
            {
                neuron_link:true,
                title:"owner",
                prop:"owned_by",
            },
            {
                neuron_link:true,
                title:"sponsor",
                prop:"sponsored_by",
            }
        ];
    }   
    setRecsFromNObjs = function($nObjs) {
        for (var n=0; n < $nObjs.length; n++) {
            var obj = {};
            obj.nObj = $nObjs[n];
            obj.parent = MEMG.getNeuronByTempNid(obj.nObj.bes[0]);
            obj.active = true;
            obj.rank="#"+(n+1);
            this.records.push(obj);
        }
        //console.log(this.records);
    }

    
    /**
     * 
     * @param {*} $txt 
     */
    filterNeuronByString=async($txt)=>{
        console.log("(filterNeuronByString) "+$txt);
        $txt = $txt.toLowerCase();
        for (var r=0; r < this.records.length; r++) {
            var rec =  this.records[r];
            var nObj = rec.nObj;
            if (nObj.text.toLowerCase().indexOf($txt)!==-1) rec.active=true;
            else {
                console.log("NOT ACTIVE");
                rec.active=false;
            }
        }
        this.PAGINATOR.renderActiveResults();
    }

    
    //build a common use relon table cols here (when needed)
    makeViewRelonCols = function($relons) {
        var tbl_cols = [
        ];
    }


    /**
     * 
     * @param {*} $nObjs 
     */
    makerViewAllCols = function($nObjs) {
        this.setRecsFromNObjs($nObjs);
        this.cols = [{
                neuron_link:true,
                title:"name",
                prop:"nObj.nid",
                sort_prop:"nObj.text",
                sort_type:"string",
                input_filter:this.filterNeuronByString
            },
            {
                neuron_link:true,
                title:"type",
                prop:"parent.nid",
                sort_prop:"text",
                sort_type:"string"
            },
            {
                neuron_link:true,
                title:"owner",
                prop:"nObj.owned_by",
                sort_prop:"nObj.owned_by",
                sort_type:"string"
            },
            {
                neuron_link:true,
                title:"sponsor",
                prop:"nObj.sponsored_by",
                sort_prop:"nObj.sponsored_by",
                sort_type:"string"
            }
        ];
    }


    /**
     * 
     * @param {*} $rels 
     */
    relonTblMaker = function($rels) {
        this.setRecsFromRels($rels);
        this.cols = [{
                neuron_link:false,
                title:"from",
                prop:"rel.from_txt_temp"
            },
            {
                neuron_link:false,
                title:"reln",
                prop:"rel.reln_txt_temp"
            },
            {
                neuron_link:false,
                title:"to",
                prop:"rel.to_txt_temp"
            },
            {
                relon_link:true,
                title:"id",
                prop:"rel.txid"
            }
        ];
    }


    /**
     * 
     * @param {*} $rels 
     */
    andyRelonTblMaker = async($rels)=> {
        await this.setAndyRecsFromRels($rels);
        if (ANNE.SETTINGS.debug()==true) console.log(this.records);

        this.cols = [{
                neuron_link:false,
                title:"from",
                prop:"rel.from_txt_temp"
            },
            {
                neuron_link:false,
                title:"rights",
                prop:"rel.rights",
                class1:"w120"
            },
            {
                neuron_link:false,
                title:"reln",
                prop:"rel.reln_txt_temp",
                class1:"w120-sm"
            },
            {
                neuron_link:false,
                title:"to",
                prop:"rel.to_txt_temp"
            },
            {
                relon_link:true,
                title:"id",
                prop:"rel.txid",
                page:"page"
            },
            {
                title:"DELETE",
                prop:"rel.txid",
                actions_cb:this.deleteLNOT,
                page:"page",
                extra_class:"actions-col-header"
            }
        ];
    }


    /**
     * 
     * @param {*} $col 
     * @param {*} $record 
     * @param {*} $propVal 
     */
    deleteLNOT=function($col, $record, $propVal) {
        //console.log($col);
        //console.log($record);
        //console.log($propVal);
        var el_delete = document.createElement("span");
        el_delete.innerHTML="delete";
        el_delete.classList = "link-yellow"
        el_delete.addEventListener("click", (e)=> {
            console.log("TO DO, delete lnot. Will need to use proof of user tech.");
        });
        return $col.appendChild(el_delete);
    }



    /**
     * 
     */
    setAndyRecsFromRels = async($rels)=> {
        var lookup_nids = [];
 
        for (var r=0; r < $rels.length; r++){
            var rel = $rels[r];
            rel.rights = ANNE.MEM_UDF.getCollabType(rel);//"collab";

            var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if ((fromNOBJ==null || fromNOBJ.text=="") && lookup_nids.indexOf(rel.from_nid)==-1) {
                lookup_nids.push(rel.from_nid); 
            }

            var relnNOBJ = MEMG.getNeuronByTempNid(rel.r);
            if ((relnNOBJ==null || relnNOBJ.text=="") && lookup_nids.indexOf(rel.reln)==-1) {
                lookup_nids.push(rel.reln); 
            }

            if (rel.to_type==TO_TYPE_ANNE) {
                var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                if ((toNOBJ==null || toNOBJ.text=="") && lookup_nids.indexOf(rel.to_s)==-1) {
                    lookup_nids.push(rel.to_s); 
                }
            }
        }


        if (lookup_nids.length>0) {
            var bQUERYANNODE=true;
            //just extract the basics from IDB mem into our precious RAM.
            await ANNE.API.lookupNids(lookup_nids, [0,1], bQUERYANNODE);
        }
        

        var txids_handled = [];
       
        //loop again, now that we extracted basic infor from IDB.
        for (var r=0; r < $rels.length; r++){
            var rel = $rels[r];
            //console.log($rels[r].txid);
            
            var obj = {};

            if (txids_handled.indexOf($rels[r].txid)!=-1) continue;
            txids_handled.push($rels[r].txid);

            var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (fromNOBJ==null) rel.from_txt_temp = "(unk)";
            else rel.from_txt_temp = fromNOBJ.bestNameHTML();

            var relnNOBJ = MEMG.getNeuronByTempNid(rel.r);
            if (relnNOBJ!=null) rel.reln_txt_temp = relnNOBJ.bestNameHTML();
            else rel.reln_txt_temp = "(unk)";  
            
            if (rel.to_type==TO_TYPE_ANNE) {
                var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                if (toNOBJ!=null) rel.to_txt_temp = toNOBJ.bestNameHTML();
                else rel.to_txt_temp = "(unk)";
            }
            else rel.to_txt_temp = rel.to_s;

            obj.active=true;
            obj.rel = rel;
            obj.page = "andy";  //if set, we go back to this page after successful action.
            this.records.push(obj);
        }
    }
    

    /**
     * 
     * @param {*} $rels 
     */
    setRecsFromRels = function($rels){
        for (var r=0; r < $rels.length; r++){
            var obj = {};
            var rel = $rels[r];
            
            var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (fromNOBJ==null) rel.from_txt_temp = "(unk)";
            else rel.from_txt_temp = fromNOBJ.text;
            
            var relnNOBJ = MEMG.getNeuronByTempNid(rel.r);
            if (relnNOBJ!=null) rel.reln_txt_temp = relnNOBJ.text;
            else rel.reln_txt_temp = "(unk)";
            
            if (rel.to_type==TO_TYPE_ANNE) {
                var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                if (toNOBJ!=null) rel.to_txt_temp = toNOBJ.text;
                else rel.to_txt_temp = "(unk)";
            }
            else rel.to_txt_temp = rel.to_s;

            obj.active=true;
            obj.rel = rel;
            this.records.push(obj);
        }
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $estimatedTBLBDYTOP 
     * @param {*} $updateCnt 
     * @param {*} $bDOBORDER 
     * @param {*} $bDOPAGINATOR 
     */
    buildDOMTable=function($el, $estimatedTBLBDYTOP=-1, $updateCnt=null, $bDOBORDER=true, $bDOPAGINATOR=true, $ROW_MAX_H=null) {
        
        this.bDOBORDER = $bDOBORDER;
        this.$bDOPAGINATOR = $bDOPAGINATOR;

        if ($ROW_MAX_H!=null) {
            this._ROW_MAX_H = $ROW_MAX_H;
        }

        var el = ANNE.A.show($el);
        if ($updateCnt!=null && $updateCnt!="") {
            this.el_update_cnt = ANNE.A.__getEl($updateCnt);
        }

        if (this.do_heading==true && this.heading_prop!="") {
            this.el_heading_row = document.createElement("div");
            this.el_heading_row.classList="simple-row "+this.neuron_heading_row_class;
            this.el_heading_row.id = ANNE.UTILS.randHex(4);

            for (var c=0; c < this.cols.length; c++) {
                var colobj = this.cols[c];
                var heading = colobj[this.heading_prop];
                var headingCol = ANNE.A.ezEl(this.el_heading_row, "div", "simple-col neuron-col-heading");
                
                if (colobj.classH!=undefined) {
                    //headingCol.classList.add(colobj.classH);
                    ANNE.A.__classListParse(headingCol, colobj.classH);
                }
                else if (colobj.class1!=undefined) {
                    ANNE.A.__classListParse(headingCol, colobj.class1);
                    //headingCol.classList.add(colobj.class1);
                }

                if (this.heading_col_class!="") headingCol.classList.add(this.heading_col_class);
                
                if (this.bDOBORDER==true) {
                    if (c==0) headingCol.classList.add("vcolborderLR");
                    else headingCol.classList.add("vcolborderR");
                }

                if (colobj.input_filter!=undefined && typeof colobj.input_filter=="function") {
                    ANNE.A.ezEl(headingCol, "span", "dib", heading+"&nbsp;");
                    ANNE.A.ezInputText(headingCol, "", "anne-table-filter", "", colobj.input_filter);
                }
                else {
                    if (heading=="") heading="&nbsp;";
                    ANNE.A.ezEl(headingCol, "span", "dib", heading);
                }
                if (colobj.s_prop!=undefined && colobj.s_type!=undefined) {
                    if (colobj.s_type=="numeric") {
                        ANNE.A.sortToggle(headingCol, c, "none", this.sortNumericData);
                    }
                }
            }
            el.append(this.el_heading_row);
        }

        this.el_tbl_body = ANNE.A.ezEl(el, "div", "anne-table-body");
        this.el_tbl_body.style['width']="100%";
        var bcr2 = this.el_tbl_body.getBoundingClientRect();
        var topy = 0;

        if ($estimatedTBLBDYTOP>0 && bcr2.top==0) topy=$estimatedTBLBDYTOP;
        else topy = bcr2.top;

        var bh = (this.max_bottom - topy) - this.YBUF;
        
        this.el_tbl_body.style['max-height']=bh+"px";
        this.el_tbl_body.style['height']=bh+"px";
        
        if (this.bPAGINATOR==true) {
            this.el_paginator = ANNE.A.ezEl(el, "div", "simple-row paginator-row");
            var shard = Math.floor(bh/this._ROW_MAX_H);
            this.PAGINATOR = new paginator(this.el_paginator, this.pgui, this.guid, this.records, this.renderCallback, shard);
            this.PAGINATOR.render($updateCnt);
        }
    }
        
    sortNumericData=async($colNumb, $sort)=>{
        //var prop = 'col_'+$colNumb+'_propVal';
        if ($sort=="none") return;
        var multiplier = 1;
        if ($sort=="desc") multiplier=-1;

        //hmmm.  only the rendered items have colvals set from renderData.
        //we need to sort  with the actual s_prop in the col (not prop value col stuff).
        console.log(this.cols);
        var col = this.cols[$colNumb];
        var prop = col.s_prop;
        
        this.records.sort( function($a, $b) {
            if (parseInt($a[prop]) > parseInt($b[prop])) return 1*multiplier;
            else if (parseInt($a[prop]) < parseInt($b[prop])) return -1*multiplier;
            return 0;
        });
        ANNE.A.empty(this.el_tbl_body);
        this.auditSort(this.records, prop);
        
        //sort_arr is now sorted... we just need to rebuild our this.records.
        this.PAGINATOR.renderActiveResults();
    }

    auditSort = function($arr, $prop) {
        for (var a=0; a < $arr.length; a++) {
            if ($arr[a][$prop]==undefined) {
                console.log($arr[a]);
            }
            console.log("#a "+$arr[a][$prop]);
        }
    }

    renderCallback = async($pgui, $data)=> {
        this.renderData($data);
    }


    /**
     * Render data handed to us by the paginator.
     */
    renderData = function($arr) {
        ANNE.A.empty(this.el_tbl_body);
        //console.log("renderData", $arr);
        for (var r=0; r < $arr.length; r++) {
            var record = $arr[r];
            var recordRow = ANNE.A.ezEl(this.el_tbl_body, "div", "simple-row "+this.tbl_row_class);
            for (var c=0; c < this.cols.length; c++) {
                var colobj = this.cols[c];
                var col = ANNE.A.ezEl(recordRow, "div", "simple-col");

                if (this.bDOBORDER==true) {
                    if (c==0) col.classList.add("vcolborderLR");
                    else col.classList.add("vcolborderR");
                }
                
                if (colobj.class1!=undefined) {
                    ANNE.A.__classListParse(col, colobj.class1);
                }
                var propVal = record['col_'+c+'_propVal'];

                if (propVal==undefined) {
                    if (colobj.prop==undefined || colobj.prop==null || colobj.prop=="") {
                        col.innerHTML="&nbsp;";
                        continue;
                    }
                    else if (colobj.prop.length) {
                        var props = colobj.prop.split(".");
                        propVal = this._propExtractor(record, props);
                        record['col_'+c+'_propVal'] = propVal;
                    }
                }


                if (colobj.actions_cb!=undefined && typeof colobj.actions_cb==="function") {
                    colobj.actions_cb(col, record, propVal);
                }
                
                else if (propVal==undefined || propVal==null || propVal=="") {
                    col.innerHTML="&nbsp;";
                    record['col_'+c+'_propVal'] = "";  
                }

                //if bDOCELLCLASSES is on we want to turn the col a color based
                //on the val of the col.
                else if (colobj.neuron_link==true) {
                    var btn = null;

                    var page = "dossier";
                    if (record.page!=undefined) {
                        console.log("override dossier for page '"+page+"'");
                        page = record.page;
                    }

                    if (this.bCOLORSQARES == true) btn=EXT_BTNS.makeNeuronLink_colorSquares(col, propVal, "link-bigger", "", false, "", page);
                    else btn=ANNE.EXT_BTNS.makeNeuronLink(col, propVal, "link-bigger", "", false, "", page);
                    
                    if (colobj.achat!=undefined) {
                        var achat_sesh_id = record.achat_sesh_id;
                        if (achat_sesh_id!=undefined) {
                            btn.setAttribute("miscp1", "achat_sesh_id");
                            btn.setAttribute("achat_sesh_id", achat_sesh_id);
                            btn.setAttribute("page", "achat");  //change page to achat.
                        }
                    }

                    if (this.bDOCELLCLASSES==true) {
                        var nOBJ=MEMG.getNeuronByNid(propVal);
                        var cellClass=EXT_BTNS.classifySpanBtn(nOBJ, null);
                        if (cellClass!="") col.classList.add(cellClass);
                    }
                }

                //if bDOCELLCLASSES is on we want to turn the col a color based
                //on the val of the col.
                else if (colobj.relon_link!=undefined && colobj.relon_link==true) {
                    var relon = null;

                    if (typeof ANNE.MEM_UDF.getAnyRel==="function") relon = ANNE.MEM_UDF.getAnyRel(propVal);
                    else relon = ANNE.MEMG.lookupByTXID(propVal);

                    var el_link = null;

                    if (relon) el_link = ANNE.MEM_UDF.makeRelonViewLink_SMART(col, relon, true, 10);
                    else el_link = ANNE.MEM_UDF.makeRelonViewLink(col, propVal, false, 10, true);
                
                    //if we have a page var in the data we want to pass that through
                    //to the link to pass that fwd thru to the page of the link.
                    if (record.page!=undefined & record.page!=null 
                        && record.page.length>0 && el_link!=undefined && el_link!=null) {
                        el_link.setAttribute("page", record.page);
                    }
                }


                else {
                    if (colobj.formatter!=undefined) {
                        if (colobj.formatter=="ezAnniesToAnneDisplay") {
                            ANNE.A.ezAnniesToAnneDisplay(col, propVal);
                        }
                        else if (colobj.formatter=="ezAnneDisplayApprox") {
                            ANNE.A.ezAnneDisplayApprox(col, propVal);
                        }
                        else {
                            console.log("unhandled formatter");
                            col.innerHTML = propVal;
                        }
                    }
                    else col.innerHTML = propVal;
                }
            }
        }
    }
    

    _propExtractor = function ($v, $props) {
        for (var p=0; p < $props.length; p++) {
            var prop = $props[p];
            if (prop==undefined || $v[prop]==undefined) {
                console.log("ut oh with propVal:"+$v+" prop:'"+prop+"'");
                break;
            } 
            else $v = $v[ prop ];
        }
        return $v;
    }
}


var DSTBL = {};


/**
 * use in data source widgets (no in the EXT)
 */
DSTBL.init=async($pgui)=> {

    //should have a fancier loader to say "building live data source"
    ANNE.A.show("loading"); 

    var ID = $pgui._guid;
    var pObj = $pgui.pObj;
    var data_src_aid = pObj.p1;
    var manualNOBJS = pObj.p2;
    var manual_col_props = pObj.p3;

    var tbl_divid = "anne_tbl_"+ID;
    var tbl = document.getElementById(tbl_divid);
  
    var nObj = ANNE.MEMG.getNeuronByNid(data_src_aid);
    if (nObj==null) {
        alert("inconceivable!");
        return;
    }

    //datasources are derrivatives of neuron data.
    //they will be used in BI, reporting, etc.
    //Traditionally, BI shops will pre-make cubes to control their
    //universe.. They will have "snapshots" ready w/ summary data that matches
    //the desired grain.  (monthly, weekly, etc)
    //We will do it live with the later option to save-off snapshots.
    //we may want a MEM.BI here tied to indexDB tbl we work with during the session...
    //as these DS will not change  much during the session and are heavy on processing.
    $pgui.INST = new anne_datasource(nObj);

    if (manualNOBJS!=null && manual_col_props!=null) {
        await $pgui.INST.init_manual_override(manualNOBJS, manual_col_props);
    }
    else {
        await $pgui.INST.init();
    }
    
    var cols = $pgui.INST.cols;
    var data = $pgui.INST.data;
    console.log(cols);
    
    const rowsearch = tbl.querySelector('.row-search');
    const rowheader = tbl.querySelector('.row-header');

    ANNE.A.setHTML("tbl_title_"+ID, " "+nObj.text);

    if ($pgui.INST.GEN1SRC==true) ANNE.A.hide("anne_embedded_filters_"+ID);
    else {
        var filterString = $pgui.INST.getFilterStrings();
        ANNE.A.setHTML("anne_embedded_filters_"+ID, filterString, true);
    }

    const availableCols = document.getElementById("ds_available_cols_"+ID);

    var gardeninfo = availableCols.querySelector(".ds-let-deny-list");
    gardeninfo.innerHTML = "";
    await ANNE.MEMZ.ezDSGardenInfo(gardeninfo, $pgui.INST.ddsNObj, LINKS_NEURON_TBL_VIEW);

    var colchks = availableCols.querySelector(".ds-col-checks");

    for (var c=0; c < $pgui.INST.cols.length; c++) {
        var colObj = $pgui.INST.cols[c];
        var checked = true;
        var disabled = true;
        if (colObj.active==false) {
            checked = false;
            disabled = false;
        }
        var chk = ANNE.A.ezCheckMark(colchks, "chk_"+ID+"_"+colObj.datanid, colObj.prelon, colObj.text, checked, disabled, "truncate120");
        
        chk.addEventListener("click", $e=> {
            if ($e.target.checked==true) {
                var datanid = $e.target.id.split("_").reverse()[0];
                var col = $pgui.INST.getColByDatanid(datanid);
                if (col==null) return;
                console.log("you checked a new column of data w/ datanid:"+datanid);
                $pgui.INST.addSingleColRuntime(col);

                var col_index = parseInt(tblbody.getAttribute("active-cols"));
                tblbody.setAttribute("active-cols", parseInt((col_index+1)));

                col.col_index = col_index; 

                //sort ico and filters are wired up in the addColumnHeader..
                DSTBL.addColumnHeader(col, col_index, tbl_divid, rowsearch, rowheader);
                DSTBL.addColumnToRows(col, $pgui.INST.data, tbl); //add the data to the rows.. 

                col.bPENDING_SAVE = true;
                var bNEWPENDINGCHANGE = $pgui.INST.setPendingChanges();
                if (bNEWPENDINGCHANGE==true) DSTBL.handleSaveEditBtns($pgui, ID);
            }
            else {
                var datanid = $e.target.id.split("_").reverse()[0];
                console.log("you unckecked a column of data w/ datanid:"+datanid);

                var col_index = parseInt(tblbody.getAttribute("active-cols")-1);
                tblbody.setAttribute("active-cols", parseInt((col_index)));
                
                var datanid = $e.target.id.split("_").reverse()[0];
                var col = $pgui.INST.getColByDatanid(datanid);
                if (col==null) return;
                
                DSTBL.deleteColumnFromRows(col, $pgui.INST.data, tbl); //add the data to the rows..
                DSTBL.deleteColumnHeader(col.col_index, rowsearch, rowheader);
                                        
                col.active=false;
                col.bPENDING_SAVE = false;

                //this checks if we have any pending saves in the Datasource...
                var bNEWPENDINGCHANGE = $pgui.INST.setPendingChanges();
                if (bNEWPENDINGCHANGE==true) DSTBL.handleSaveEditBtns($pgui, ID);
            }
        });
    }

    //one-time, on init.  Any added columns is handled int the checkmark click event.
    var col_index = 0;
    for (var c=0; c < cols.length; c++) {
        var col = cols[c];
        if (col.active==false) continue;
        
        //filter events are added in this addColumnHeader function
        DSTBL.addColumnHeader(col, col_index, tbl_divid, rowsearch, rowheader);
        col.col_index = col_index;
        col_index+=1;
    }


    //iterate through the data ---
    //inject new "row" with all 3 cols and respective data.
    const tblbody = tbl.querySelector('.anne-tbl-body-overflow');
    tblbody.setAttribute("active-cols", parseInt(col_index));
    DSTBL.addDataToColsInit(data, cols, tblbody);
    
    //set up table footer display
    var rowslbl = ANNE.TALK.pluralizeNounIf2(data.length, "row", "rows");
    ANNE.A.setHTML("tbl_summary_"+ID, data.length+" "+rowslbl);

    //initialize the final table FX DOM events.
    DSTBL.initEvents(tbl_divid, $pgui, ID);
    ANNE.A.hide("loading"); 
}



/*** handleSaveEditBtns ********************************** xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.handleSaveEditBtns=function($pgui, $ID) {

    //if this is a self-owned data source we can either:
    //edit, OR create a new datasource.
    if ($pgui.INST.GEN1SRC==false && $pgui.INST.ddsNObj.owned_by==USER._userNObj.nid) {
        //do an edit.
        var btnel = ANNE.A.fadeInPop('tbl_update_btn_'+$ID, "glow");
        ANNE.A.addRemoveClass(btnel, "hoverable-yellow", "hoverable-green");

        //do a save (either option is possible)
        var btnel = ANNE.A.fadeInPop('tbl_save_btn_'+$ID, "glow");
        ANNE.A.addRemoveClass(btnel, "hoverable-yellow", "hoverable-green");
    }

    //if this is not self-owned then the only option is to save a new datasource.
    else {
        var btnel = ANNE.A.fadeInPop('tbl_save_btn_'+$ID, "glow");
        ANNE.A.addRemoveClass(btnel, "hoverable-yellow", "hoverable-green");
    }
}



/*** addDataToColsInit *********************************** xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.addDataToColsInit=function($data, $cols, $tblBody) {
    for (var d=0; d < $data.length; d++) {
        var dataobj = $data[d].nObj;
        if (dataobj==null) continue;
        var newrow = document.createElement("div");
        newrow.classList="row";
        $tblBody.append(newrow);
        if ($data[d].active==false) {
            console.log("live skip of data obj.. not from DS, from this session changes");
            continue;
        }
        newrow.setAttribute("nid", dataobj.temp_nid);
        for (var c=0; c < $cols.length; c++) {
            var col = $cols[c];
            if (col.active==false) continue;
            var datacol = document.createElement("div");
            datacol.classList = "column cell";
            var dataVal = dataobj[col.dataprop];
            var display = dataobj[col.display];
            if (display==undefined) display=dataVal;
            datacol.setAttribute("dataz", dataVal);
            datacol.innerHTML=display;
            newrow.append(datacol);
        }
    }
}


/*** addColumnHeader ************************************* xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.addColumnHeader = function($col, $col_index, $tbl_divid, $rowsearch, $rowheader) {
    var div = document.createElement("div");
    div.classList = "column";
    div.setAttribute("colnum", $col_index);
    div.setAttribute("tbl", $tbl_divid);
    $rowsearch.append(div);
    var input = document.createElement("input");
    input.classList = "tbl-filter";
    input.setAttribute("type", "text");
    input.setAttribute("width", 300);
    input.style["min-height"]="30px";   //do this in css instead..
    input.setAttribute("placeholder", "filter the "+$col.text);
    div.append(input);
    input.addEventListener('input', $e=>DSTBL.DOM_filterEvent($e))

    //create the header cols in the header row
    var divh = document.createElement("div");
    divh.classList = "column";
    divh.setAttribute("colnum", $col_index);
    divh.setAttribute("tbl", $tbl_divid);
    $rowheader.append(divh);

    var sortIco = ANNE.A.ezSortCol(divh, $col, $tbl_divid, "asc");
    sortIco.addEventListener("click", $e=> {
        var el = $e.target;
        var sortDataType = el.getAttribute("prop");
        console.log(sortDataType);

        //parent child index is the column index of this header.
        //this will inform the DOM sort what column to pay attention to.
        var col_index = ANNE.A.getFirstParentAttr(el, "column", "colnum");
        var tbl = el.getAttribute("tbl");
        var isActive = el.classList.contains("activesort");
        if (isActive==null) isActive=false;
        var sort = el.getAttribute("sort");
        console.log("current sort:"+sort+" active:"+isActive);
        ANNE.A.removeAddClassOfAllIn(tbl, ".sortico", "activesort", el);
        var sort = DSTBL.toggleSortIco(el, sortDataType, isActive, sort);
        
        //var iFix = (i*2) + 1;
        DSTBL.DOM_sortTbl(tbl, col_index, sortDataType, sort);
    });

    //set up the default sort ico state if this table was pre-sorted.
    if ($col.default_sort!=undefined) {
        sortIco.setAttribute("sort", $col.default_sort);
        ANNE.A.removeAddClassOfAllIn(tbl, ".sortico", "activesort", sortIco);
        var isActive = sortIco.classList.add("activesort");
        var sortDataType = sortIco.getAttribute("prop");
        var sort = DSTBL.toggleSortIco(sortIco, sortDataType, isActive, sort);
    }

    return input;   //RETURN THE TBL FILTER
}


/*** deleteColumnHeader ********************************** xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.deleteColumnHeader = function($col_index, $rowsearch, $rowheader) {
    var searchheader = $rowsearch.querySelectorAll('div[colnum="'+$col_index+'"]')[0];
    searchheader.remove();
    var colheader = $rowheader.querySelectorAll('div[colnum="'+$col_index+'"]')[0];
    colheader.remove();
    //we need to either de-activate or delete any filters.
}



/*** addColumnToRows ************************************* xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.addColumnToRows = function($col, $data, $tbl) {
    const tblbody = $tbl.querySelector('.anne-tbl-body-overflow');
    for (var d=0; d < $data.length; d++) {
        if ($data[d].active==false) continue;
        var dataobj = $data[d].nObj;
        var rowdiv = tblbody.querySelectorAll('div[nid="'+dataobj.temp_nid+'"]')[0];
        if ($col.active==false) break; //this should be active
        var datacol = document.createElement("div");
        datacol.classList = "column cell";
        var dataVal = dataobj[$col.dataprop];
        var display = dataobj[$col.display];
        if (display==undefined) display=dataVal;
        datacol.setAttribute("dataz", dataVal);
        datacol.innerHTML=display;
        rowdiv.append(datacol);
    }
}


/*** deleteColumnFromRows ******************************** xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.deleteColumnFromRows = function($col, $data, $tbl) {
    const tblbody = $tbl.querySelector('.anne-tbl-body-overflow');
    for (var d=0; d < $data.length; d++) {
        if ($data[d].active==false) continue;
        var dataobj = $data[d].nObj;
        var rowdiv = tblbody.querySelectorAll('div[nid="'+dataobj.temp_nid+'"]')[0];
        //var dataVal = dataobj[$col.dataprop];
        var datacol = rowdiv.children[$col.col_index];
        if (datacol!=null) datacol.remove();
    }
}


/*** initEvents ****************************************** xx/xx/202x ***
******************************************************** Mr.Scatman ****/ 
DSTBL.initEvents = function($tbldivid, $pgui, $ID) {
    //const fxwrapper = tbl.querySelector(".anne-tbl-fx-wrapper"); //we can use this for bigger FX
    const tbl = document.getElementById($tbldivid);
    const footer = document.querySelector(".anne-tbl-footer");
    const downs = tbl.querySelector(".anne-downloadables");
    const ups = tbl.querySelector(".anne-uploadables");

    footer.addEventListener("mouseenter", (e) => {
        tbl.style.transition = "none";
        downs.style.transition  =  "all 0.5s ease-in";
        downs.style.transform = "translateX(-180px) translateY(20px)  scale(1.4)";
        ups.style.transition  =  "all 0.5s ease-in";
        ups.style.transform = "translateX(-100px) translateY(20px) scale(1.4)";
        footer.style["height"] = "64px";
        footer.style.transition  =  "all 0.5s ease-in";
    });

    footer.addEventListener("mouseleave", (e) => {
        downs.style.transition  =  "all 0.3s ease-out";
        downs.style.transform = "translateX(0px) translateY(0px)  scale(1)";
        ups.style.transition  =  "all 0.3s ease-out";
        ups.style.transform = "translateX(0px) translateY(0px) scale(1)";
        footer.style["height"] = "32px";
        footer.style.transition  =  "all 0.3s ease-out";
    });

    var editBtn = ANNE.A.fadeInPop('tbl_update_btn_'+$ID, "glow");
    editBtn.addEventListener("click", (e) => {
        $pgui.INST.saveEditsToExisting();
    });


    var saveBtn = ANNE.A.fadeInPop('tbl_save_btn_'+$ID, "glow");
    saveBtn.addEventListener("click", (e) => {
        $pgui.INST.savePendingChangesToNew();
    });

    var jsonBtn = document.getElementById("btn_json_"+$ID);
    jsonBtn.addEventListener("click", (e)=> {
        alert("dl json");
    });

    var csvBtn = document.getElementById("btn_csv_"+$ID);
    csvBtn.addEventListener("click", (e)=> {
        alert("dl csv");
    });
    
    var excelBtn = document.getElementById("btn_excel_"+$ID);
    excelBtn.addEventListener("click", (e)=> {
        alert("dl excel");
    });
    
}


/*** DOM_sortTbl ***************************************** 0x/xx/20xx ***
******************************************************** Mr.Scatman ****/
DSTBL.DOM_sortTbl=function($divid, $col_index, $sortDataType, $sortDir) {
    var tbl = document.getElementById($divid); 
    if (tbl==null) return;

    const rows = tbl.querySelectorAll(".row");

    var masterRowParent = rows[0].parentElement;
    var rowsData = Array.prototype.slice.call(rows, 0);
    var dir = 1;
    if ($sortDir=="asc") dir *= -1;

    //sort them  (keep these separated even tho they are the same.. for now)..
    //we may need to handle differently..
    if ($sortDataType=="string" || $sortDataType=="anne") {
        rowsData.sort(function(a,b) {
            if (a.children[$col_index]==undefined) return 0;
            var txta = a.children[$col_index].getAttribute("dataz");//textContent;
            if (b.children[$col_index]==undefined) return 0;
            var txtb = b.children[$col_index].getAttribute("dataz");
            if(txta > txtb) { return -1*dir; }
            if(txta < txtb) { return 1*dir; }
            return 0;
        });
          
    }
    else if ($sortDataType=="numeric") {
        rowsData.sort(function(a,b) {
            if (a.children[$col_index]==undefined) return 0;
            var txta = (a.children[$col_index].getAttribute("dataz"));
            if (b.children[$col_index]==undefined) return 0;
            
            var txtb = (b.children[$col_index].getAttribute("dataz"));
            if(txta > txtb) { return -1*dir; }
            if(txta < txtb) { return 1*dir; }
            return 0;
        });
    }

    else {
        rowsData.sort(function(a,b) {
            if (a.children[$col_index]==undefined) return 0;
            var txta = (a.children[$col_index].getAttribute("dataz"));
            if (b.children[$col_index]==undefined) return 0;
            
            var txtb = (b.children[$col_index].getAttribute("dataz"));
            if(txta > txtb) { return -1*dir; }
            if(txta < txtb) { return 1*dir; }
            return 0;
        });
    }

    //put them back in.
    rowsData.forEach(row => {
        masterRowParent.appendChild(row)
    });
}


/*** DOM_filterEvent ************************************* 0x/xx/20xx ***
******************************************************** Mr.Scatman ****/
DSTBL.DOM_filterEvent = async($e)=> {
    var el = $e.target;
    var text = el.value;
    if (text.length && text[text.length-1]=="") return;
    await DSTBL.DOM_Filter(el, text);
}


/*** DOM_Filter ****************************************** 0x/xx/20xx ***
******************************************************** Mr.Scatman ****/
DSTBL.DOM_Filter=async(el, text)=> {
    const col = ANNE.A.getFirstParentOf(el, "column");
    const tbldivid = col.getAttribute("tbl");
    const childindex = col.getAttribute("colnum");
    const tbl = document.getElementById(tbldivid);
    console.log("filter tbl:"+tbl+" col "+childindex+" text "+text);

    //get all the rows, turn off any rows where the colIndex doesn't match the text.
    const ID = tbldivid.split("_").reverse()[0].trim();

    var max_rows = 0;
    var on_cnt = 0;

    var pgui = NF.getPguiByGUID(ID);

    //turn on all rows
    tbl.querySelectorAll(".row").forEach(row => {
        row.style.display="flex";
        max_rows++;
    });

    const tblFilters = tbl.querySelectorAll(".tbl-filter");
    for (var t=0; t < tblFilters.length; t++) {
        var tblfilter = tblFilters[t];
        var cIndex = ANNE.A.getFirstParentAttr(tblfilter, "column", "colnum");

        //this is the filter the user just edited/changed...
        if (cIndex==childindex) {
            await pgui.INST.make_unsaved_filter(tblfilter.value, cIndex);
        }

        if (tblfilter.value.length) {
            var on_cnt = DSTBL.DOM_Filter_single(pgui, tblfilter, tblfilter.value, cIndex);
            
            //check the last filter (the net sum of all visible/not visible)..
            //it will return the on_cnt.. 
            if (tblFilters.length-1==t) {
                max_rows = max_rows-on_cnt;
            }
        }
    }

    var rowslbl = ANNE.TALK.pluralizeNounIf2(on_cnt, "row", "rows");
    ANNE.A.setHTML("tbl_summary_"+ID, on_cnt+" "+rowslbl);
    if (on_cnt!=max_rows) {
        var bNEWPENDINGCHANGE = pgui.INST.setPendingChanges();
        if (bNEWPENDINGCHANGE==true) DSTBL.handleSaveEditBtns(pgui, ID);
    }
}


/*** DOM_Filter_single *********************************** 0x/xx/20xx ***
******************************************************** Mr.Scatman ****/
DSTBL.DOM_Filter_single=function($pgui, el, text, $cIndex) {
    const col = ANNE.A.getFirstParentOf(el, "column");
    const tbldivid = col.getAttribute("tbl");
    const childindex = col.getAttribute("colnum");
    const tbl = document.getElementById(tbldivid);
    console.log("filter tbl:"+tbl+" col "+childindex+" text "+text);

    //var regex = new RegExp(text, 'i');
    //var bEXACT = false;

    var onCnt = 0;

    var coldataobj = $pgui.INST.cols[$cIndex];
    var filters = coldataobj.filters;
    if (filters==undefined || filters==null) filters = [];

    //these are filters we made to support the user actions of typing in the live-filter boxes
    var uf =  $pgui.INST.unsaved_filters;

    if (uf.length && uf[$cIndex]!=undefined) {
        filters.push(uf[$cIndex]);
    }

    tbl.querySelectorAll(".row").forEach(row => {
        var dataz = row.children[childindex].innerHTML;//.getAttribute("dataz");
        if (row.style.display=="none") return;  //skip row, go to next.
        if (dataz==null) row.style.display="none";
        else {
            
            var test = anne_x_filter.testFiltersRuntime(dataz, filters);

            if(test==false) row.style.display="none";
            else {
                row.style.display="flex";
                onCnt+=1;
            }
        }
        //else if (dataz !== text) row.style.display="none";
        //else {
         //row.style.display="flex";
            //onCnt+=1;
       // }
    });

    return onCnt;
}


/*** toggleSortIco *************************************** 0x/xx/20xx ***
* If bISACTIVE=false then do NOT toggle the sort.. just apply the       *
* .activesort class.  If it is active we will leave it active (no need  *
* to apply the activesort class) but we will flip the ico and the dir.  *
******************************************************** Mr.Scatman ****/
DSTBL.toggleSortIco = function($el, $sortDataType, $bISACTIVE, $dir="asc") {
    console.log("toggleSortIco sort coming set to dir:"+$dir+" active:"+$bISACTIVE);
    if ($bISACTIVE==false) {
        $el.classList.add("activesort");
        console.log("toggleSortIco returning dir:"+$dir);
        return $dir;
    }
    if ($dir=="asc") {
        ANNE.A.setAttribute($el, "sort", "desc");
        if ($sortDataType=="string" || $sortDataType=="anne") ANNE.A.addRemoveClass($el, "ai-sort-alpha-up", "ai-sort-alpha-down"); 
        else if ($sortDataType=="number") ANNE.A.addRemoveClass($el, "ai-sort-amount-up", "ai-sort-amount-down"); 
        else ANNE.A.addRemoveClass($el, "ai-sort-up", "ai-sort-down"); 
        console.log("toggleSortIco returning dir:desc");
        return "desc";
    } 
    else {
        ANNE.A.setAttribute($el, "sort", "asc");
        if ($sortDataType=="string" || $sortDataType=="anne") ANNE.A.addRemoveClass($el, "ai-sort-alpha-down", "ai-sort-alpha-up"); 
        else if ($sortDataType=="number") ANNE.A.addRemoveClass($el, "ai-sort-amount-down", "ai-sort-amount-up"); 
        else ANNE.A.addRemoveClass($el, "ai-sort-down", "ai-sort-up"); 
        console.log("toggleSortIco returning dir:asc");
        return "asc";
    }
}

DSTBL.addRelon = function() {
    console.log("not relevant here");
}

DSTBL.destroyAll = function() {
    alert("do we get here"); 
}


//GENERICTBL  -- this is for anything (not just neurons or relons)
class generic_table {
    constructor($pgui) {
        this.pgui = $pgui;
        this.ID = $pgui._guid;
        this.pObj = $pgui.pObj;
        this.tbl_obj = this.pObj.p1;// {cols:this.default_cols, data:sl1c_data}; 
        this.cols =  this.tbl_obj.cols;
        this.data =  this.tbl_obj.data;
        //this.nObj = MEMG.getNeuronByNid(this.nid);
        this.misc = this.pObj.misc;

        var tbl_divid = "anne_tbl_"+this.ID;
        var tbl = document.getElementById(tbl_divid);

        const rowsearch = tbl.querySelector('.row-search');
        const rowheader = tbl.querySelector('.row-header');

        ANNE.A.setHTML("tbl_title_"+this.ID, this.pObj.p2);

        //one-time, on init.  Any added columns is handled int the checkmark click event.
        var col_index = 0;
        for (var c=0; c < this.cols.length; c++) {
            var col = this.cols[c];
            if (col.active==false) continue;
            
            //filter events are added in this addColumnHeader function
            generic_table.addColumnHeader(col, col_index, tbl_divid, rowsearch, rowheader);
            col.col_index = col_index;
            col_index+=1;
        }

         //iterate through the data ---
        //inject new "row" with all 3 cols and respective data.
        const tblbody = tbl.querySelector('.anne-tbl-body-overflow');
        tblbody.setAttribute("active-cols", parseInt(col_index));
        generic_table.addDataToColsInit(this.data, this.cols, tblbody);
        
        //set up table footer display
        var rowslbl = ANNE.TALK.pluralizeNounIf2(this.data.length, "row", "rows");
        ANNE.A.setHTML("tbl_summary_"+this.ID, this.data.length+" "+rowslbl);

        //initialize the final table FX DOM events.
        generic_table.initEvents(tbl_divid, $pgui, this.ID);
        ANNE.A.hide("loading"); 
    }
    
    static addDataToColsInit=function($data, $cols, $tblBody) {
        for (var d=0; d < $data.length; d++) {
            var dataobj = $data[d].nObj;
            if (dataobj==null) continue;
            var newrow = document.createElement("div");
            newrow.classList="row generic-tbl-row";
            $tblBody.append(newrow);
            if ($data[d].active==false) {
                console.log("live skip of data obj.. not from DS, from this session changes");
                continue;
            }
            newrow.setAttribute("nid", dataobj.temp_nid);
            for (var c=0; c < $cols.length; c++) {
                var col = $cols[c];
                if (col.active==false) continue;
                var datacol = document.createElement("div");
                datacol.classList = "column cell";
                
                //flex amount added to col
                if (col.f!=undefined) datacol.classList.add(col.f);

                var dataVal = dataobj[col.dataprop];
                var display = dataobj[col.displayprop];
                if (display==undefined) display=dataVal;
                datacol.setAttribute("dataz", dataVal);
                datacol.innerHTML=display;
                newrow.append(datacol);
            }
        }
    }

    static initEvents = function($tbldivid, $pgui, $ID) {
        //const fxwrapper = tbl.querySelector(".anne-tbl-fx-wrapper"); //we can use this for bigger FX
        const tbl = document.getElementById($tbldivid);
        const footer = document.querySelector(".anne-tbl-footer");
        const downs = tbl.querySelector(".anne-downloadables");
        const ups = tbl.querySelector(".anne-uploadables");

        var jsonBtn = document.getElementById("btn_json_"+$ID);
        jsonBtn.addEventListener("click", (e)=> {
            alert("dl json");
        });
        var csvBtn = document.getElementById("btn_csv_"+$ID);
        csvBtn.addEventListener("click", (e)=> {
            alert("dl csv");
        });
        var excelBtn = document.getElementById("btn_excel_"+$ID);
        excelBtn.addEventListener("click", (e)=> {
            alert("dl excel");
        });
    }

    static DOM_filterEvent = async($e)=> {
        var el = $e.target;
        var text = el.value;
        if (text.length && text[text.length-1]=="") return;
        await generic_table.DOM_Filter(el, text);
    }

    static addColumnHeader = function($col, $col_index, $tbl_divid, $rowsearch, $rowheader) {
        var div = document.createElement("div");
        div.classList = "column";
        div.setAttribute("colnum", $col_index);
        div.setAttribute("tbl", $tbl_divid);
        $rowsearch.append(div);
        var input = document.createElement("input");
        input.classList = "tbl-filter";
        
        //flex amount added to col
        if ($col.f!=undefined) div.classList.add($col.f);

        input.setAttribute("type", "text");
        input.setAttribute("width", 300);
        input.style["min-height"]="30px";   //do this in css instead..
        input.setAttribute("placeholder", "filter the "+$col.text);
        div.append(input);
        input.addEventListener('input', $e=>generic_table.DOM_filterEvent($e))

        //create the header cols in the header row
        var divh = document.createElement("div");
        divh.classList = "column";

        //flex amount added to col
        if ($col.f!=undefined) divh.classList.add($col.f);

        divh.setAttribute("colnum", $col_index);
        divh.setAttribute("tbl", $tbl_divid);
        $rowheader.append(divh);

        var sortIco = ANNE.A.ezSortCol(divh, $col, $tbl_divid, "asc");
        sortIco.addEventListener("click", $e=> {
            var el = $e.target;
            var sortDataType = el.getAttribute("prop");
            console.log(sortDataType);

            //parent child index is the column index of this header.
            //this will inform the DOM sort what column to pay attention to.
            var col_index = ANNE.A.getFirstParentAttr(el, "column", "colnum");
            var tbl = el.getAttribute("tbl");
            var isActive = el.classList.contains("activesort");
            if (isActive==null) isActive=false;
            var sort = el.getAttribute("sort");
            console.log("current sort:"+sort+" active:"+isActive);
            ANNE.A.removeAddClassOfAllIn(tbl, ".sortico", "activesort", el);
            var sort = generic_table.toggleSortIco(el, sortDataType, isActive, sort);
            
            //var iFix = (i*2) + 1;
            generic_table.DOM_sortTbl(tbl, col_index, sortDataType, sort);
        });

        return input;   //RETURN THE TBL FILTER
    }

    static DOM_Filter=async(el, text)=> {
        const col = ANNE.A.getFirstParentOf(el, "column");
        const tbldivid = col.getAttribute("tbl");
        const childindex = col.getAttribute("colnum");
        const tbl = document.getElementById(tbldivid);
        console.log("filter tbl:"+tbl+" col "+childindex+" text "+text);

        //get all the rows, turn off any rows where the colIndex doesn't match the text.
        const ID = tbldivid.split("_").reverse()[0].trim();
        var max_rows = 0;
        var on_cnt = 0;
        var pgui = NF.getPguiByGUID(ID);

        //turn on all rows
        tbl.querySelectorAll(".row").forEach(row => {
            row.style.display="flex";
            max_rows++;
        });

        const tblFilters = tbl.querySelectorAll(".tbl-filter");
        for (var t=0; t < tblFilters.length; t++) {
            var tblfilter = tblFilters[t];
            var cIndex = ANNE.A.getFirstParentAttr(tblfilter, "column", "colnum");

            if (tblfilter.value.length) {
                var on_cnt = generic_table.DOM_Filter_single(pgui, tblfilter, tblfilter.value, cIndex);
                
                //check the last filter (the net sum of all visible/not visible)..
                //it will return the on_cnt.. 
                if (tblFilters.length-1==t) {
                    max_rows = max_rows-on_cnt;
                }
            }
        }

        var rowslbl = ANNE.TALK.pluralizeNounIf2(on_cnt, "row", "rows");
        ANNE.A.setHTML("tbl_summary_"+ID, on_cnt+" "+rowslbl);
    }

    static DOM_sortTbl=function($divid, $col_index, $sortDataType, $sortDir) {
        var tbl = document.getElementById($divid); 
        if (tbl==null) return;
        const rows = tbl.querySelectorAll(".row");
        var masterRowParent = rows[0].parentElement;
        var rowsData = Array.prototype.slice.call(rows, 0);
        var dir = 1;
        if ($sortDir=="asc") dir *= -1;

        //sort them  (keep these separated even tho they are the same.. for now)..
        //we may need to handle differently..
        if ($sortDataType=="string" || $sortDataType=="anne") {
            rowsData.sort(function(a,b) {
                if (a.children[$col_index]==undefined) return 0;
                var txta = a.children[$col_index].getAttribute("dataz");//textContent;
                if (b.children[$col_index]==undefined) return 0;
                var txtb = b.children[$col_index].getAttribute("dataz");
                if(txta > txtb) { return -1*dir; }
                if(txta < txtb) { return 1*dir; }
                return 0;
            });
            
        }
        else if ($sortDataType=="numeric") {
            rowsData.sort(function(a,b) {
                if (a.children[$col_index]==undefined) return 0;
                var txta = (a.children[$col_index].getAttribute("dataz"));
                if (b.children[$col_index]==undefined) return 0;
                
                var txtb = (b.children[$col_index].getAttribute("dataz"));
                if(txta > txtb) { return -1*dir; }
                if(txta < txtb) { return 1*dir; }
                return 0;
            });
        }

        else {
            rowsData.sort(function(a,b) {
                if (a.children[$col_index]==undefined) return 0;
                var txta = (a.children[$col_index].getAttribute("dataz"));
                if (b.children[$col_index]==undefined) return 0;
                
                var txtb = (b.children[$col_index].getAttribute("dataz"));
                if(txta > txtb) { return -1*dir; }
                if(txta < txtb) { return 1*dir; }
                return 0;
            });
        }

        //put them back in.
        rowsData.forEach(row => {
            masterRowParent.appendChild(row)
        });
    }
    

    static DOM_Filter_single=function($pgui, el, text, $cIndex) {
        const col = ANNE.A.getFirstParentOf(el, "column");
        const tbldivid = col.getAttribute("tbl");
        const childindex = col.getAttribute("colnum");
        const tbl = document.getElementById(tbldivid);
        console.log("filter tbl:"+tbl+" col "+childindex+" text "+text);
        var onCnt = 0;
        var coldataobj = $pgui.INST.cols[$cIndex];
        var filters = coldataobj.filters;
        if (filters==undefined || filters==null) filters = [];
        tbl.querySelectorAll(".row").forEach(row => {
            var dataz = row.children[childindex].innerHTML;//.getAttribute("dataz");
            if (row.style.display=="none") return;  //skip row, go to next.
            if (dataz==null) row.style.display="none";
            else {
                var test = anne_x_filter.testFiltersRuntime(dataz, filters);
                if(test==false) row.style.display="none";
                else {
                    row.style.display="flex";
                    onCnt+=1;
                }
            }
        });

        return onCnt;
    }
}