class ANNODE_API extends ANNE_NET {
    constructor($base_uri){	//expects url:port like http://localhost:9116
		super($base_uri);	//converthing ANNODE_API to use ANNE_NET (standalone networking class)
		this.client = null;
		this.db = null;
		this.anon_user_id = null;	//for use when AUTHing anon externally.
		this._AAUTH = null;
		this._bNONODE=false;
		this._consecutive_network_errors = 0;
		this.privateFolderAbsolute = "";

	}

	/**
	 * Used when getting new annode details.
	 * We potentially have new _active vars.
	 * @param {*} $obj 
	 */
	processAuxAAUTHData=async($obj)=>{
		var bCHANGE = false;
        if (USER==null || USER._userLS==null || USER._userLS.aauth==null) return;
		
		if (USER._userLS.aauth.ANNDLE_active!=$obj.anndle_active) {
            USER._userLS.aauth.ANNDLE_active = $obj.anndle_active;
			ANNE.API._AAUTH.ANNDLE_active = $obj.anndle_active;
			ANNE.SETTINGS.ANNDLE_active = $obj.anndle_active;
            bCHANGE=true;
        }
        if (ANNE.API._AAUTH.ASDF_active!=$obj.asdf_active) {
            USER._userLS.aauth.ASDF_active = $obj.asdf_active;
			ANNE.API._AAUTH.ASDF_active = $obj.asdf_active;
			ANNE.SETTINGS.ASDF_active = $obj.asdf_active;
            bCHANGE=true;
        }
        if (ANNE.API._AAUTH.PDNS_active!=$obj.pdn_active) {
            USER._userLS.aauth.PDNS_active = $obj.pdn_active;
			ANNE.API._AAUTH.PDNS_active = $obj.pdn_active;
			ANNE.SETTINGS.PDNS_active = $obj.pdn_active;
            bCHANGE=true;
        }
        if (ANNE.API._AAUTH.BOUNTY_active!=$obj.bounty_active) {
            USER._userLS.aauth.BOUNTY_active = $obj.bounty_active;
			ANNE.API._AAUTH.BOUNTY_active = $obj.bounty_active; 
			ANNE.SETTINGS.BOUNTY_active = $obj.bounty_active;
            bCHANGE=true;
        }
        if (bCHANGE==true) {	//will save updates to _AAUTH.
			if (USER.seedObj!=null) {
				ANNE.API._AAUTH = USER._userLS.aauth;
				await USER.__saveHashInEXTScope(USER._userLS);
		        localStorage.setItem('ANNE', JSON.stringify(USER._userLS));
			}
		}
	}


	setAAUTHFromLS = function($resp) {
		this._AAUTH = new annode_auth($resp);
		this._bNONODE=false;
		USER.aauth = this._AAUTH;
		
	}

	getNextProofId = function() {
		if (this._AAUTH==null) return -1;
		return this._AAUTH.next_proof_id;
	}

	updateAndSaveNextProofId = async($id)=> {
		if (this._AAUTH==null) return -1;
		this._AAUTH.next_proof_id = $id;
		USER._userLS.aauth = this._AAUTH;
		console.log("%c (updateAndSaveNextProofId) id:"+$id, TALK.bgbigred);
		return await ANNE.USER.updateNextProofId($id);
	}

	getRelonLimit = function() {
		if (this._AAUTH == null) return 0;
		return this._AAUTH.drl();
	}


	/**
	 * 
	 * @param {*} $functName 
	 * @param {*} $params 
	 * @returns 
	 */
	apiSimpleQueryWithParams=async($functName, $params, $bDOLOADER=true)=> {
		if ($bDOLOADER) ANNE.A.show("loading");
		var response = await this.query($functName, $params);
		if ($bDOLOADER) ANNE.A.hide("loading");
		return response;
	}
	apiSimpleQueryWithParamsNS=async($functName, $params)=> {
		var response = await this.query($functName, $params);
		return response;
	}
	apiSimpleQuery=async($functName, $bDOLOADER=true)=> {
		if ($bDOLOADER) ANNE.A.show("loading");
		var response = await this.query($functName, null);
		if ($bDOLOADER) ANNE.A.hide("loading");
		return response;
	}


	//***************************************************** */
	//////  TRANACTION CREATION / SIGNING / BROADCAST ////////
	//***************************************************** */



	//***************************************************** */
	////////////////  TRANSACT WITH AN ANNDOE ////////////////
	//***************************************************** */
	

	/**
	 * Add boosties to de-centivize annexes against your sponsored neuron!
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	addBoosties = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=>{
		if (ANNE.SETTINGS.debug()==true) console.log("(adddBoosties) sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		if ($relon.referencedTransactionFullHash!=undefined) {
			params.referencedTransactionFullHash = $relon.referencedTransactionFullHash;
		}
		else if ($relon.sys_ref_txid!=undefined) {
			alert("THIS SHOULDNT BE NEEDED HERE");
			var json = await this.getBlockchainTransaction($relon.sys_ref_txid);
			console.log(json);
			if (json!=null && json.fullHash!=undefined) {
				params.referencedTransactionFullHash = json.fullHash;
			}
			else if ($relon.r==MEM.action_delegate.temp_nid) {
				alert("error, couldn't get ref sys txid's hash for delegation request");
				return;
			}
		}
		
		var json = await this.makeOnNodeSignOnJSThenBroadcast("addBoosties",params);
		return json;
	}
	

	/**
	 * Send a relon where the FROM is the sender (you).
	 * 
	 * If the .sys_ref_txid is set in the sending relon the API will lookup 
	 * the full hash of the transaction.  When broadcast as part of the TX it serves
	 * as a dependency to mine first.
	 * 
	 * In our ANNE GRAPH we also use this variable after-the-fact to link TXs to other
	 * TXs they are in reference (or response) to.
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	sendSelfRelon = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (ANNE.SETTINGS.debug()==true) console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;

		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};

		if ($relon.r==ANNE.MEM.annex.temp_nid) {
			params.chase_from=true;
		}

		//the api needs the referencedTransactionFullHash
		if ($relon.sys_ref_txid!=undefined) {
			var json = await this.getBlockchainTransaction($relon.sys_ref_txid);
			console.log(json);
			if (json!=null && json.fullHash!=undefined) {
				params.referencedTransactionFullHash = json.fullHash;
			}
			else if ($relon.r==MEM.action_delegate.temp_nid) {
				alert("error, couldn't get ref sys txid's hash for delegation request");
				return;
			}
		}

		//with annexes this is already stored and set as part of the annex chain.
		//just pass it through here.
		if ($relon.referencedTransactionFullHash!=undefined) {
			params.referencedTransactionFullHash = $relon.referencedTransactionFullHash;
		}

		var json = await this.makeOnNodeSignOnJSThenBroadcast("sendSelfRelon",params);
		if (ANNE.SETTINGS.debug()==true) console.log(json);
		return json;
	}

	
	/**
	 * Call for a distribution vote for an annorg (technically this will work on ANY keyless neuron)
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	anorgVoteCall = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (ANNE.SETTINGS.debug()==true) console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;

		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		
		//the api needs the referencedTransactionFullHash
		if ($relon.sys_ref_txid!=undefined) {
			var json = await this.getBlockchainTransaction($relon.sys_ref_txid);
			console.log(json);
			if (json!=null && json.fullHash!=undefined) {
				params.referencedTransactionFullHash = json.fullHash;
			}
			else if ($relon.r==MEM.action_delegate.temp_nid) {
				alert("error, couldn't get ref sys txid's hash for delegation request");
				return;
			}
			else if ($relon.r==MEM.distro_vote.nid) {
				alert("error, couldn't get ref sys txid's hash for DISTRO VOTE (must tie to FREEZE)");
				return;
			}
		}
		
		var json = await this.makeOnNodeSignOnJSThenBroadcast("anorgVoteCall",params);
		return json;
	}
	

	/**
	 * Claim a bounty.
	 * This will invoke an ACHAT session on the annode it is broadcast through.
	 * The bounty will specify the annode that it wants to ACHAT on.
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	bountyClaim = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (ANNE.SETTINGS.debug()==true) console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeBountyClaim",params);
		return json;
	}

	/**
	 * Accept some risk being offered by an ASDF.
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	asdfAcceptRisk = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("ASDFacceptRisk",params);
		return json;
	}


	/**
	 * Add more risk to an ASDF you own.
	 * @param {Object} $relon 
	 * @param {int} $annies 
	 * @param {int} $minerFee 
	 * @returns 
	 */
	asdfAddRisk = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("ASDFaddRisk",params);
		return json;
	}


	/**
	 * A way to stop accepting risk takers for an ASDF.
	 * AKin to no-more-bets or the real-world event has started.
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	asdfNomoreRisk = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("ASDFnoMoreRisk",params);
		return json;
	}


	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	anndleSellback = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("anndleSellback",params);
		return json;
	}


	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	anndleRenew = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("anndleRenew",params);
		return json;
	}
	

	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	annexNeuron = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("annexNeuron",params);
		return json;
	}


	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	makeAnndleOffer = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("anndleBuysideOffer",params);
		return json;
	}



	
	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	acceptAnndleOffer = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_froms:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("anndleOfferAccept",params);
		return json;
	}


	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	revokeAnndleOffer = async($relon, $annies=400, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("anndleOfferRevoke",params);
		return json;
	}

	/**
	 * Make an ANNE admin for a specific class you have access to grant rights to.
	 * @param {Object} $relon 
	 * @param {int} $annies 
	 * @param {int} $minerFee 
	 * @returns 
	 */
	makeAnneAdmin = async($relon, $annies=1000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeAnneAdmin",params);
		return json;
	}


	/**
	 * Add to the data of an ANNDLE you have sponsored.
	 * Only class Params are relns that will be accepted by the ANNODE.
	 * @param {Object} $relon 
	 * @param {int} $annies 
	 * @param {int} $minerFee 
	 * @returns 
	 */
	makeAnndleEdit = async($relon, $annies=1000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeAnndleEdit",params);
		return json;
	}
	

	/**
	 * Make a subanndle under an anndle that you control (are the sponsor of).
	 * @param {Object} $relon 
	 * @param {int} $annies 
	 * @param {int} $minerFee 
	 * @returns 
	 */
	makeSubAnndle = async($relon,  $annies=1000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeSubAnndle",params);
		return json;
	}


	/**
	 * Accept some amount of an ANNE OTC offer.
	 * This is specific to the SIGNA integration since we can 
	 * broadcast the SIGNA transaction from the ANNODE to the SIGNA node.
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	acceptAOTCOffer = async($relon,  $annies=1000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var params = {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		if (ANNE.UTILS.isset($relon.signedTransactionBytes)==false) {
			alert("we must have the signed transaction bytes from the AOE CHAIN TX!")
			return;
		}
		else params.signedAOETransactionBytes = $relon.signedTransactionBytes;

		var json = await this.makeOnNodeSignOnJSThenBroadcast("AOTCacceptOfferSIGNA",params);
		return json;
	}

	

	/**
	 * Response to a collab request.
	 * 
	 * NOTE: This must be a TO_TYPE_TXID with the collab request as the to
	 * 
	 * It also must reference the full hash of the collab request (even if only in blockchain and not in hypergraph).
	 * This ensures payment for admin is available prior to the admin's response being mined.
     * 
	 * The only time amountNQT is relevant is when approving a merge that has a required annex to settle it.
     * No other collab response patterns require annies to respond.  (in fact, admins gain annies for responding)
	 */
	 makeCollabResp = async($relon, $annies=0, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		};
		
		//the api needs the referencedTransactionFullHash
		if ($relon.sys_ref_txid!=undefined) {
			var json = await this.getBlockchainTransaction($relon.sys_ref_txid);
			console.log(json);
			if (json!=null && json.fullHash!=undefined) {
				params.referencedTransactionFullHash = json.fullHash;
			}
			else if ($relon.r==MEM.action_delegate.temp_nid) {
				alert("error, couldn't get ref sys txid's hash for delegation request");
				return;
			}
		}

		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeCollabResp", params);

		return json;
	}

	/**
	 * Respond to the invitation to be an Anjucator.
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	makeAnjInviteResp = async($relon, $annies=0, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
    	console.log("sending relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to);
		if (MEM.__isMalformedRelon($relon)==true) return false;
		
		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$minerFee,
			deadline:1440
		};
		
		//the api needs the referencedTransactionFullHash
		if ($relon.sys_ref_txid!=undefined) {
			var json = await this.getBlockchainTransaction($relon.sys_ref_txid);
			console.log(json);
			if (json!=null && json.fullHash!=undefined) {
				params.referencedTransactionFullHash = json.fullHash;
			}
			else if ($relon.r==MEM.action_delegate.temp_nid) {
				alert("error, couldn't get ref sys txid's hash for delegation request");
				return;
			}
		}

		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeAnjInviteResp", params);
		return json;
	}


	/**
	 * Make a keyless class
	 * 
	 * Keyless class makers are the owner of the neuron class.
	 * 
	 * The RELN should be the standard CLASS or INST to denote the nType (neuron type).
	 * The TO should be the parent class.  This is a standard TYPE_BE parent relon,
	 * We send it through as a TYPE_SYS_MSG but on the annode a TYPE BE will be created.
	 * 
	 * @param {Object}
	 * @param {string}
	 * @param {string}
	 * @param {integer}
	 * @author Mr.Scatman
	 */
	 makeKeylessNeuron = async($relon,  $annies=900, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeKeylessNeuron",{
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		});
		//console.log(json);
		return json;
	}


	/**
	 * Make a new Private Data Neuron.
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	makePDN = async($relon,  $annies=2000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makePDN",{
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		});
		console.log(json);
		return json;
	}


	/**
	 * Make a custodial Neuron that this particular ANNODE will manage.
	 * 
	 * DO EXTRAS FLAG HERE IS CRUCIAL!!!!!
	 * WE MUST RETURN THE CUSTODIAL NEW NID AND KEY AFTER SIGNING AND BROADCAST!!!
	 * @param {*} $relon 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	makeCustodialNeuron = async($relon,  $annies=800, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeCustodialNeuron",{
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			do_extras:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		});
		console.log(json);
		return json;
	}


	/**
	 * We default to 1 coin in the custodial neuron.
	 * THere are NO fees so these remain in the faucet as an initial bump.
	 * @param {*} $relon 
	 * @param {*} $recipientPublicKey 
	 * @param {*} $annies 
	 * @param {*} $minerFee 
	 * @returns 
	 */
	announceCustodial = async($relon, $recipientPublicKey, $referencedTransactionFullHash, $recipient, $annies=100, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if ($recipientPublicKey=="") {
			console.log("MUST HAVE A RECIPIENT PUBLIC KEY!");
			return false;
		}
		if ($recipient=="") {
			console.log("WE MUST HAVE RECIPIENT HERE!");
			return false;
		}
		if (MEM.__isMalformedRelon($relon)==true) return false;


		var params = {
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440,
			recipientPublicKey:$recipientPublicKey,
			recipient:$recipient
		}

		if ($referencedTransactionFullHash!="") params.referencedTransactionFullHash = $referencedTransactionFullHash;
		else if ($relon.referencedTransactionFullHash!=undefined) {
			params.referencedTransactionFullHash = $relon.referencedTransactionFullHash;
		}
		else if ($relon.sys_ref_txid!=undefined) {
			alert("THIS SHOULDNT BE NEEDED HERE");
			var json = await this.getBlockchainTransaction($relon.sys_ref_txid);
			console.log(json);
			if (json!=null && json.fullHash!=undefined) {
				params.referencedTransactionFullHash = json.fullHash;
			}
			else if ($relon.r==MEM.action_delegate.temp_nid) {
				alert("error, couldn't get ref sys txid's hash for delegation request");
				return;
			}
		}

		var json = await this.makeOnNodeSignOnJSThenBroadcast("announceCustodialNeuron", params);

		console.log(json);
		return json;
	}

	

	/**
	 * Make (sponsor) a new global neuron.
	 * 
	 * @param {Object}
	 * @param {string}
	 * @param {string}
	 * @param {integer}
	 * @author Mr.Scatman
	 */
	 makeNewGlobal = async($relon, $annies=1000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeGlobal",{
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		});
		console.log(json);
		return json;
	}

	/**
	 * Make (sponsor) a new global neuron. (location)
	 * 
	 * @param {Object}
	 * @param {string}
	 * @param {string}
	 * @param {integer}
	 * @author Mr.Scatman
	 */
	makeGlobalLocation = async($relon, $annies=1000, $minerFee=ANNE.ANNE_TO_ANNIES)=> {
		if (MEM.__isMalformedRelon($relon)==true) return false;
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeGlobalLocation",{
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			chase_from:true,
			feeNQT:$minerFee,
			amountNQT:$annies,
			deadline:1440
		});
		console.log(json);
		return json;
	}	


	/**
	 * 
	 * @param {Object} $relon 
	 * @param {int} $amount   (2,147,483,647 billion annies)  going to likely have to do a sys overhaul of all amounts and use bigint.
	 * @param {int} $fee 
	 * @returns 
	 */
	 sendChildRelon = async($relon, $amount=400, $fee=ANNE.ANNE_TO_ANNIES)=> {
    	if ($relon==undefined || $relon.from_nid==undefined || $relon.type==undefined || $relon.reln==undefined || $relon.to_type==undefined || $relon.to_s==undefined ) {
			console.warn("FIX THIS!!! this should NEVER happen.");
			console.log($relon);
			return {status:"fail", reason:"missing relon info"};
		}
		//console.log("(sendChildRelon) sending");
		ANNE.TALK.printRelon($relon);

		var fhi=0;
		if ($relon.flathexint!=undefined) fhi = $relon.flathexint;

		var params = {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$fee,
			amountNQT:$amount,
			flathexint:fhi,
			deadline:1440
		};

		//we want the relons back on a freeze.
		if ($relon.nid==MEM.CMD_FREEZE.nid) {
			params.chase_from=true;
		}

		if ($relon.referencedTransactionFullHash!=undefined) {
			params.referencedTransactionFullHash = $relon.referencedTransactionFullHash;
		}

		else {
			//if future devs use this API this will ensure any NEW uses of custodials will
			//not throw any errors on the annodes.
			var fromNOBJ = MEMG.getNeuronByNid($relon.from_nid);
			if (fromNOBJ!=null && ANNE.UTILS.isset(fromNOBJ.origin)==true && fromNOBJ.origin==ORIGIN_CUSTODIAL) {
				//we need to make sure all child relon TXs of custodials refer back to their
				//TXTYPE_ANNOUNCE   reln:MAKE_CUSTODIAL TO_TYPE_TXID transaction.

				//we can find our make custodial request as an in of the from (the cusodial)
				//pubkey was broadcast on MAKE_CUSTODIAL tx.. we can get that txid
				//and lookup the pubky if we don't have it in local mem.

				var rel = null;
				var the_txid_we_want_the_fullhash_of = "";
				var fullHash = "";

				for (var o=0; o < fromNOBJ.outs.length; o++) {
					if (fromNOBJ.outs[o].r==MEM.class.temp_nid || fromNOBJ.outs[o].r==MEM.inst.temp_nid) {
						the_txid_we_want_the_fullhash_of = fromNOBJ.outs[o].sys_ref_txid;
						rel  = MEMG.lookupByTXID(fromNOBJ.outs[o].sys_ref_txid);
						if (rel!=null && rel.fullHash!=undefined) fullHash = rel.fullHash;
						break;
					}
				}

				if (fullHash.length==0) {

					//we need to get the txid.. otherwise we can't continue.
					if (the_txid_we_want_the_fullhash_of=="") {
						await CHASE.lookupMinNid(fromNOBJ.nid);
						for (var o=0; o < fromNOBJ.outs.length; o++) {
							if (fromNOBJ.outs[o].r==MEM.class.temp_nid || fromNOBJ.outs[o].r==MEM.inst.temp_nid) {
								the_txid_we_want_the_fullhash_of = fromNOBJ.outs[o].sys_ref_txid;
								break;
							}
						}
					}

					//if we don't have the txid, we can't continue.
					if (the_txid_we_want_the_fullhash_of=="") {
						console.log("problem with finding custoidal reference.");
						return;
					}


					//go get the hash.  We must reference it.
					if (the_txid_we_want_the_fullhash_of.length>0) {	//this is a BE relon.. just do min chase
						var json = await this.getBlockchainTransaction(the_txid_we_want_the_fullhash_of);
						console.log(json);
						if (json!=null && json.fullHash!=undefined) {
							params.referencedTransactionFullHash = json.fullHash;
						}
						else if ($relon.r==MEM.action_delegate.temp_nid) {
							alert("error, couldn't get ref sys txid's hash for delegation request");
							return;
						}
					}
				}

				else params.referencedTransactionFullHash = fullHash;
			}
		}


		var json = await this.makeOnNodeSignOnJSThenBroadcast("sendChildRelon", params);
		return json;
	}

	
	
	/**
	 * Send a viewPDN relon transaction.
	 * This is the same pattern as child relon and it 
	 * will use the child relon TX in the ANNODE.
	 * 
	 * @param {Object}
	 * @param {string}
	 * @author Mr.Scatman
	 */
	viewPDN = async($relon, $amount=400, $fee=ANNE.ANNE_TO_ANNIES)=> {
		console.log("sending viewPDN relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to);
		if ($relon==undefined || $relon.from_nid==undefined || $relon.type==undefined || $relon.reln==undefined || $relon.to_type==undefined || $relon.to_s==undefined ) {
			console.warn("FIX THIS!!! this should NEVER happen.");
			return {status:"fail", reason:"missing relon info"};
		}
		console.log("(viewPDN) sending");
		ANNE.TALK.printRelon($relon);

		var json = await this.makeOnNodeSignOnJSThenBroadcast("viewPDN", {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$fee,
			amountNQT:$amount,
			deadline:1440
		});
		return json;
	}


	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $amount 
	 * @param {*} $fee 
	 * @param {*} $bEXPECTED_DELEGATION 
	 * @author Mr.Scatman
	 */
	makeCollabReq = async($relon, $amount=400, $fee=ANNE.ANNE_TO_ANNIES, $bEXPECTED_DELEGATION=false)=> {
    	console.log("sending child relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to_s);
		if ($relon==undefined || $relon.from_nid==undefined || $relon.type==undefined || $relon.reln==undefined || $relon.to_type==undefined || $relon.to_s==undefined ) {
			console.warn("FIX THIS!!! this should NEVER happen.");
			return {status:"fail", reason:"missing relon info"};
		}
		ANNE.TALK.printRelon($relon);

		var fhi=0;
		if ($relon.flathexint!=undefined) fhi = $relon.flathexint;

		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeCollabReq", {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$fee,
			amountNQT:$amount,
			deadline:1440,
			flathexint:fhi,
			expect_delegation:$bEXPECTED_DELEGATION
		});
		return json;
	}


	/**
	 * 
	 * @param {*} $relon 
	 * @param {*} $amount 
	 * @param {*} $fee 
	 * @param {*} $bEXPECTED_DELEGATION 
	 * @author Mr.Scatman
	 */
	makeHanaiCollabReq = async($relon, $amount=400, $fee=ANNE.ANNE_TO_ANNIES, $bEXPECTED_DELEGATION=false)=> {
    	console.log("sending child relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to);
		if ($relon==undefined || $relon.from_nid==undefined || $relon.type==undefined || $relon.reln==undefined || $relon.to_type==undefined || $relon.to_s==undefined ) {
			console.warn("FIX THIS!!! this should NEVER happen.");
			return {status:"fail", reason:"missing relon info"};
		}
		ANNE.TALK.printRelon($relon);
		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeHanaiCollabReq", {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true, 
			feeNQT:$fee,
			amountNQT:$amount,
			deadline:1440
		});
		return json;
	}	


	/**
	 */
	makeHanaiOutReq = async($relon, $amount=400, $fee=ANNE.ANNE_TO_ANNIES)=> {
    	console.log("sending hanai out relon from:"+$relon.from_nid+" type:"+$relon.type+" reln:"+$relon.reln, "to_type:"+$relon.to_type+" to:"+$relon.to);
		if ($relon==undefined || $relon.from_nid==undefined || $relon.type==undefined || $relon.reln==undefined || $relon.to_type==undefined || $relon.to_s==undefined ) {
			console.warn("FIX THIS!!! this should NEVER happen.");
			return {status:"fail", reason:"missing relon info"};
		}
		ANNE.TALK.printRelon($relon);
		
		var fhi=0;
		if ($relon.flathexint!=undefined) fhi = $relon.flathexint;

		var json = await this.makeOnNodeSignOnJSThenBroadcast("makeHanaiOutReq", {
			from:$relon.from_nid,
			type:$relon.type,
			reln:$relon.reln,
			to_type:$relon.to_type,
			to:$relon.to_s,
			makeSignSend:true,
			feeNQT:$fee,
			amountNQT:$amount,
			flathexint:fhi,
			deadline:1440
		});
		return json;
	}	



	
	/**
	 * Send a standard payment TX to another Account.
	 * @param {string}
	 * @param {string}
	 * @param {string}
	 * @author Mr.Scatman
	 */
	 sendAnne = async($recipient, $recipientPublicKey, $amount, $fee=ANNE.ANNE_TO_ANNIES, $deadline=1440, $msg="", $encrypted=false, $edata=null, $ndata=null)=> {
		console.log("(sendAnne) recipient:"+$recipient+" amount:"+$amount+" fee:"+$fee);
		var paramsObj = {
			recipient:$recipient, 
			amountNQT:$amount, 
			feeNQT:$fee,
			deadline:$deadline,
			makeSignSend:true,
		} 

		//onboarding a pubKey with send..
		//this should be auto with the sendAnne functionality and the PublicKeyAnnouncement appendix
		//also required when sending encrypted message to recipient (even when their key is known)
		if (ANNE.UTILS.isset($recipientPublicKey)==true) paramsObj.recipientPublicKey=$recipientPublicKey;
		else if ($encrypted==true) return {status:"bad", reason:"must have recipientPublicKey to encrypt"};
		 
		if ($msg!="") {
			console.log("%c (sendAnne) with plaintext msg", TALK.bgpink);
			paramsObj.message = $msg;
			paramsObj.messageIsText = true;
		}
		else {
			if ($encrypted==true) {
				if (ANNE.UTILS.isset($edata)==false || ANNE.UTILS.isset($ndata)==false) {
					return {status:"bad", reason:"user wants to send encrypted data but the provided encrypted data is missing."};
				}
				console.log("%c (sendAnne) with encrypted msg", TALK.bgpink);
				paramsObj.encryptedMessageData = $edata;
		        paramsObj.encryptedMessageNonce = $ndata;
			}
		}
		var rez = await this.makeOnNodeSignOnJSThenBroadcast("sendAnne", paramsObj); 
		if (rez.broadcasted==undefined) rez.status = "bad";
		else rez.status = "good";
		return rez;
	}


	//***************************************************** */
	///////////////////  PING & HANDSHAKE ////////////////////
	//***************************************************** */

	/**
	 * Initialize the ANNODE auth handshake.
	 * 
	 * If already "logged" in, just ping node w/ ANNODEAuthHandshake and set the js _AAUTH object.
	 * This will be required to get the nodeId for certain types of transactions that payout the annode that processes the TX.
	*/
	ANNODEPING=async()=> {
		var response = await ANNE.API.apiSimpleQueryWithParams("ANNODEAuthHandshake", {
			annode_claimed_uri:ANNE._annodesLS.last_uri}
			);
		if (response.status=="good") {
			var AAUTHOBJ = new annode_auth(response.result);
			this._AAUTH = AAUTHOBJ;
		}
		else {
			console.warn("we have a problem houston");
			return;
		}
	}


	/**
	 * Handshake with an annode.
	 * 
	 * Set up the active aauth object.
	 * This does not persist session to session.
	 * If another handshake is made w/ the same or different node
	 * the API uses it.
	 * 
	 * @param {*} $aO 
	 * @param {*} $uniqueReqRandId 
	 * @param {*} $height 
	 * @returns 
	 */
	ANNODEHANDSHAKE=async($aO, $uniqueReqRandId, $height=0) => {
		//handshake with annode
		var response = await ANNE.API.apiSimpleQueryWithParams("ANNODEAuthHandshake", {
			annode_claimed_uri:ANNE._annodesLS.last_uri}
			);

		if (response.status=="good") {
			var AAUTHOBJ = new annode_auth(response.result);
			this._AAUTH = AAUTHOBJ;
			if (USER._userNObj!=null) USER._userNObj.aauth = this._AAUTH;
		}
		else {
			//roll back to last successful node.
			console.warn("we have a problem houston");
			return;
		}

		//returned from the NODE.
		var annode_time = this._AAUTH.time;
		var annode_pubKey = this._AAUTH.pubKey;

		//We will encrypt a string of the user's public nid and the annode time
		//The handling node will verify this time is within a reasonable ping range 
		//of milliseconds.
		var encryptThis = USER.public_nid+"::"+annode_time;

        var eObj = await ANNE.USER.encryptMsgForPUBKEY(encryptThis, annode_pubKey, $aO.priv_key, true);
        //console.log(eObj);

        
		//we send info back to the server to close the ANNODEAUTH
        var result = await ANNE.API.apiSimpleQueryWithParams("ANNODEAuthFinish", {
												user_nid:USER.public_nid, 
												user_pubKey:$aO.pub_key, 
												annode_time:annode_time, 
												user_sig_data:eObj.data_string,
												user_sig_nonce:eObj.nonce_string,
												height:$height,
												uid:$uniqueReqRandId}
												);

		//console.log(result);
		result.original_uid = $uniqueReqRandId;
		if (result.lnots!=undefined) {
			if (result.lnots.length) {
				console.log("%c lnots present", TALK.bgbigred);
				console.log(result.lnots);
			}
		}
		return result;
	}
	
	//***************************************************** */
	//////////////////  QUERY THE l1 ANNODE //////////////////
	//***************************************************** */
	


	/**
	 * Match condition and do join to chase values to prevent further lookups
	 * 
	 * normal space relons contain awareness relons so they must be filtered
	 * for type to avoid clutter.				
	 * @param {string}
	 * @param {array}
	 * @param {array} 
	 * @param {boolean}
	 * @param {array}  
	 * @param {array}   
	 * 
	 * @author Mr.Scatman								
	 */
	chaseInsGWV = async($nid, $adopt, $bMUSTPULL, $types=[1,3], $chasetypes=[0,1,2])=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.chaseInsGWV ", $nid);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;
		if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {	//means it is a one-time query per session.
			console.log("super optimizer");
			return [];
		}

		var response = await this.apiSimpleQueryWithParams("chaseInsGWV", 
				{
					nid:$nid, 
					adopt:$adopt,
					types:$types,
					chase_types:$chasetypes,
					height:lastBlock

				});
		console.log(response);
		phObj.bDONETHISSESSION=true;
		var aRelons = [];
		if (response.status=="good") {
			var results = response.result;
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.chaseInsGWV");
		}
		return aRelons;
	}
	
	
	/**
	 * Match condition and do join to chase values to prevent further lookups
	 * 
	 * normal space relons contain awareness relons so they must be filtere
	 * for type to avoid clutter.				
	 * @param {string}
	 * @param {string}
	 * @param {array}
	 * @param {array} 
	 * @param {boolean}
	 * @param {array}  
	 * @param {array}   
	 * @author Mr.Scatman								
	 */
	chaseInsWithRelnGWV = async($nid, $reln, $adopt, $types=[1,3], $chasetypes=[0,1,2], $parentNOBJ)=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.chaseInsWithRelnGWV ", $nid);
		lastBlock = phObj.lastBlock;
		var response = await this.apiSimpleQueryWithParams("chaseInsWithRelnGWV", 
			{
				nid:$nid, 
				reln:$reln,
				adopt:$adopt,
				types:$types,
				chase_types:$chasetypes,
				be:$parentNOBJ.nid,
				height:lastBlock

			});

		var aRelons = [];
		if (response.status=="good") {
			var results = response.result;
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.chaseInsWithRelnGWV");
		}
		return aRelons;
	}
	
		
	/**
	 * Get account by accountId (ANNE neurons in the memory handler call this nid).
	 * 
	 * @param {string}
	 * @author Mr.Scatman
	 */
	getAccount = async($accountId)=> {
		var json = await this.apiSimpleQueryWithParams("getAccount",{account:$accountId});
		if (json.status!=undefined && json.status=="fail") return null;
		return json;
	}


	/**
	 * 
	 * @param {*} $account 
	 * @param {*} $ts 
	 * @param {*} $firstIndex 
	 * @param {*} $lastIndex 
	 * @returns 
	 */
	getAccountBlocks = async($account, $firstIndex=0, $lastIndex=100000000)=>{
		var response = await this.apiSimpleQueryWithParams("getAccountBlocks", 
		{	account:$account,
			timestamp:0,
			firstIndex:$firstIndex,
			lastIndex:$lastIndex
		});
		if (response.blocks!=undefined) {
			console.log(response.blocks);
			return response.blocks;
		}
		return [];
	}


	/**
	 * firstIndex is the literal list index of the TXs for that account.
	 * 1st TX is 0, 2nd is 1, etc.
	 * 
	 * TO DO: we can store these to opimize.. OR just accept the last 500 and 
	 * do a more robust transaction area later.
	 * 
	 * @param {string} - account we want to query TXs for.
	 * 
	 * @author Mr.Scatman								
	 */
	getAccountTransactions = async($account, $firstIndex=0)=> {

		//todo first the first index.

		var response = await this.apiSimpleQueryWithParams("getAccountTransactions", 
			{	account:$account,
				timestamp:0,
				type:-1,
				subtype:-1,
				firstIndex:0,
				lastIndex:10000000,
				numberOfConfirmations:0,
				includeIndirect:true
			});
		console.log(response);
		if (response.transactions!=undefined) {
			console.log(response.transactions);
			console.log(response.transactions.length);//153
			return response.transactions;
		}
		return [];
	}


	/**
	 * Get all preloaded relons from the ANNODE.
     * 
     * This is a one-time preload done to establish a base in the browser's indexeddb.
	 * This is NOW (updated) stored in the relonsMinBoot table for optimized preload.
	 * 
     * The data is retained as long as the indexeddb is not wiped.
     * When it is wiped this function will run again the next time the app loads.
     * 
	 * @author Mr.Scatman
	 */
	 getAllPreloads=async()=> {
		console.log("%c GET ALL PRELOADS", ANNE.TALK.bgbigred);
		var aMinBootRelons = [];
		const LIMIT = 9000;
		var offset = 0;
		var response = await this.apiSimpleQueryWithParams("getAllPreloads", {
			limit:LIMIT,
			offset:offset
		});

		var safety=4;

		while (response.status=="good" && --safety>=0) {
			aMinBootRelons = aMinBootRelons.concat(response.result);
			if (response.result.length==LIMIT) {
				offset+=LIMIT;
				response = await this.apiSimpleQueryWithParams("getAllPreloads", {
					limit:LIMIT,
					offset:offset
				});
			}
		}

		console.log("final process of all relons: "+aMinBootRelons.length);
		return await MEMP.processNeuronsFromRelons(aMinBootRelons, true, true, "relons", "API.getAllPreloads");
		
		//return await MEMP.processNeuronsFromRelons(aMinBootRelons, true, true, "relonsMinBoot");

	 }



	/**
	 * We have payment relons from sender->receiver with .annies.
	 * @param {*} $nid 
	 * @returns 
	 */
	getAllPaymentsIn=async($nid)=>{
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getAllPaymentsIn", $nid);
		lastBlock = phObj.lastBlock;
		console.log("%c(getAllPaymentsIn) with lastBlock:"+lastBlock, TALK.bgred);
        var aNewRelons = [];
		var response = await this.apiSimpleQueryWithParams("getAllPaymentsIn", {
			nid:$nid,
			height:lastBlock,
		});
		if (response.status=="good") {
			var relons_to_process = response.result;
            aNewRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.getAllPaymentsIn");
			await HISTORY.processResultsForNewPullHistory(relons_to_process, phObj);
        }
        return aNewRelons;
	}

	
	/**
	 * TYPE_BROADCAST and TYPE_INTERNAL_PAY are now in relons_payment tbl.
	 * The API will pull from them.  Once in this app they are all treated the same
	 * as they are still just relons.
	 * @param {*} $nid 
	 * @param {*} $fromMsg 
	 * @param {*} $bDOIDB 
	 * @returns 
	 */
	getAllPayments=async($nid, $fromMsg="", $bDOIDB=true)=>{
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getAllPayments", $nid);
		var aNewRelons = [];
		var lastHeight = phObj.lastBlock;

		var response = await this.apiSimpleQueryWithParams("getAllPayments", {
			nid:$nid,
			height:lastHeight
		});
		
		if (response.status=="good") {
			var relons_to_process = response.result;

			if (relons_to_process.length==0) return [];

            aNewRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.getAllPayments <-"+$fromMsg);
			await HISTORY.processResultsForNewPullHistory(relons_to_process, phObj);
        }
        return aNewRelons;
	}


	/**
	 * 
	 * @param {*} $el 
	 * @param {*} $annecoin 
	 * @param {*} $fee 
	 * @param {*} $msg 
	 * @returns 
	 */
	generateSendTransactionQRCode=async($el, $annies, $fee=100, $msg="")=>{
		const elImg = document.createElement("img");
		$el.appendChild(elImg);
        elImg.classList.add("qrsquare");
		var uri = this.base_uri;
		if (uri==undefined) {
			uri = ANNE.setAnnodeByURI();
		}
		elImg.src = uri+"/anne?requestType=generateSendTransactionQRCode&immutable=true&receiverId="+USER._userNObj.nid+"&amountNQT="+$annies+"&feeNQT="+$fee+"&message="+$msg;
		return {requestType:'generateSendTransactionQRCode',
				immutable:true,
				receiverId:USER._userNObj.nid,
				amountNQT:$annies,
				feeNQT:$fee,
				message:$msg
		}
	}


	/**
	 * 
	 * @returns 
	 */
	getREDLIST=async()=>{
		var response = await this.apiSimpleQueryWithParams("getRedlist", {});
		if (response.status=="good") {
			return response;
        }
		return null;
	}
	


	/**
	 * Get All my neurons
	 */
	getAllNeuronsFor=async($nid, $bSPONSOREDTOO=true)=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getAllNeuronsFor", $nid+$bSPONSOREDTOO);
		lastBlock = phObj.lastBlock;

		console.log("%c(getAllNeuronsFor) with lastBlock:"+lastBlock, TALK.bgred);
        var aNewRelons = [];
		var response = await this.apiSimpleQueryWithParams("getAllNeuronsFor", {
			nid:$nid,
			height:lastBlock,
			sponsored:$bSPONSOREDTOO
		});
	
		console.time("processganf");
		if (response.status=="good") {
			var relons_to_process = response.result;
            aNewRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.getAllNeuronsFor");
			await HISTORY.processResultsForNewPullHistory(relons_to_process, phObj);
			console.log(aNewRelons.length);
        }
		console.timeEnd("processganf");

        return aNewRelons;
	}


	/**
	 * 
	 * @param {*} $txids_to_check 
	 */
	getTXIDSThatDontExistInMEMPOOOL=async($txids_to_check)=>{
		console.log("%c(getTXIDSThatDontExistInMEMPOOOL) with "+$txids_to_check.length+" txids", TALK.bgred);
		var response = await this.apiSimpleQueryWithParams("getTXIDSThatDontExistInMEMPOOOL", {
			txids:$txids_to_check,
		});
	
		if (response.status=="good") {
			console.log(response.IDS_NOT_IN_MEMPOOL);
			return response.IDS_NOT_IN_MEMPOOL;
        }
        return [];
	}


	/**
	 * An example how to use this QUERY LANGUAGE.
	 * 
	 * from:{
	 * 		val:"{}" || "somevalue", 
	 * 		op: "=" | "!="" | "LIKE", 
	 * 		use_results_from_pool:"unique_name_of_pool_to_use_for_filter"
	 * 		slot: "toA" || "from"
	 * 		},
	 * type: TYPE,
	 * reln: {val:nid, op:"="},
	 * to_type: TO_TYPE,
	 * to: {
	 * 		val:"{}" || "somevalue", 
	 * 		op: "=" | "!="" | "LIKE" | "DOWNLINE" | "DATE_GREATERTHAN" | "DATE_LESSTHAN" | "DATE_EQUAL" | "DATE_BETWEEN", 
	 * 		use_results_from_pool:"unique_name_of_pool_to_use_for_filter" 
	 * 		slot: "toA" || "from" (defaults to "from if not set",
	 * 		reln_down: "(set if using op "DOWNLINE") nid of reln if using DOWNLINE",
	 *      max_gens: "(optional) numbber of gens to chase down building the pool"
	 * 		},
	 * pool_type: "match" || "lookup_pool"
	 * results_pool_name:"unique_name_for_results_in_this_pool",
	 * debug: "somenameforprinting"
	 * 
	 * @returns 
	 */
	test_queryByRelonJSON_archerPool = async()=>{

		//test dynamic lang
		//person named trump
		var relons = [
			{
				from:{val:"", op:""},
				type:TYPE_BE,
				reln:{val:ANNE.MEM.inst.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:ANNE.MEM.person.nid, op:"="},
				pool_type:"match"
			},
			{
				from:{val:"", op:""},
				type:TYPE_BE,
				reln:{val:ANNE.MEM.name.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"%archer%", op:"LIKE"},
				results_pool_name:"archerpool",
				pool_type:"match",
				debug:"people with name archer in their name"
			},

			//do a lookup pool of all TEXAS locations.
			{
				from:{val:"", op:""},
				type:-1,
				reln:{val:"", op:""},
				to_type:-1,
				to:{val:"9008074888561760466", op:"DOWNLINE", reln_down:MEM.constituent.nid, max_gens:4},
				results_pool_name:"texas locations",
				pool_type:"lookup_pool",
				debug:"texas locations"
			},

			//find a relon to ANY LOCATION IN THE ABOVE POOL.
			//birthplace IN Texas (anywhere)
			{
				from:{val:"", op:"", use_results_from_pool:"archerpool"},
				type:-1,
				reln:{val:"7777813598381855599", op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"{}", op:"=", use_results_from_pool:"texas locations", slot:"toA"},
				pool_type:"match",
				debug:"match users to birth place in texas"
			},
		];

		return await this.queryByRelonJSON(relons);
	}



	test_queryByRelonJSON_dates = async()=>{
		var relons = [
			{
				from:{val:"", op:""},
				type:TYPE_BE,
				reln:{val:ANNE.MEM.inst.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:ANNE.MEM.person.nid, op:"="},
				pool_type:"match",
				debug:"all people pool (not efficient, lol)"
			},
			{
				from:{val:"", op:""},
				type:TYPE_BE,
				reln:{val:ANNE.MEM.name.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"%trump%", op:"LIKE"},
				results_pool_name:"trumppool",
				pool_type:"match",
				debug:"people with name trump in their name"
			},

			//do a lookup pool of all TEXAS locations.
			{
				from:{val:"", op:""},
				type:-1,
				reln:{val:"", op:""},
				to_type:-1,
				to:{val:"", op:"DATE_BETWEEN", date_min:"4655170", date_max:"4655190"},
				results_pool_name:"datepool",
				pool_type:"lookup_pool",
				debug:"dates equal to 1946-06-14"
			},

			//find a relon to ANY LOCATION IN THE ABOVE POOL.
			//birthplace IN Texas (anywhere)
			{
				from:{val:"", op:"", use_results_from_pool:"trumppool"},
				type:-1,
				reln:{val:MEM.birthday.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"{}", op:"=", use_results_from_pool:"datepool", slot:"from"},
				pool_type:"match",
				debug:"persons born on date 4655179"
			},
		];

		return await this.queryByRelonJSON(relons);
	}


	/**
	 * find a clump by its roles (however many you like.)  Daisy chain of pools..
	 * @param {*} $action_nid 
	 * @param {*} $roles 
	 */
	findClump=async($action_nid, $roles)=> {
		var role_cmds = [];
		var actionNOBJ = MEMG.getNeuronByNid($action_nid);
		if (actionNOBJ.ghost==true) {
			console.warn("ghost neuron detected in to "+actionNOBJ.text);
			return [];
		}

		//action nid is the BE/parent.
		//this will build a pool of ALL clumps with this action.
		var action_role = {
			from:{val:"", op:""},
			type:TYPE_BE,
			reln:{val:ANNE.MEM.inst.nid, op:"="},
			to_type:TO_TYPE_ANNE,
			to:{val:$action_nid, op:"="},
			pool_type:"match"
		};
		console.log("audit clump lookup: [BE] "+actionNOBJ.text);
		role_cmds.push(action_role);

		//{role:$roleNid, role_value:$roleValueNid}
		//these cmds will serve as additional filters for the pool of 
		//actions that match the initial pool.
		for (var r=0; r < $roles.length; r++) {
			var role = $roles[r];
			
			var toNOBJ = ANNE.MEMG.getNeuronByNid(role.role_value);
			if (toNOBJ.ghost==true) {
				console.warn("ghost neuron detected in to "+toNOBJ.text);
				return [];	
			}
			
			var rcmd = 
			{
				from:{val:"", op:""},
				type:TYPE_ROLE,
				reln:{val:role.role, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:role.role_value, op:"="},
				pool_type:"match"
			};
			
			if (r==0) {
				rcmd.results_pool_name="r0";
			}
			else {
				if (r!=$roles.length-1) {
					rcmd.results_pool_name="r"+r;
				}
				else rcmd.use_results_from_pool = "r"+(r-1);
			}
			
			var roleNOBJ = ANNE.MEMG.getNeuronByNid(role.role);
			console.log("audit clump lookup: ["+roleNOBJ.text.toLowerCase()+"] "+toNOBJ.text);
			role_cmds.push(rcmd);
		}
		
		var relons = await this.queryByRelonJSON(role_cmds);
		
		if (relons.length>0) {
			var froms = [];
			for (var r=0; r < relons.length; r++) {
				if (froms.indexOf(relons[r].from_nid)==-1) {
					froms.push(relons[r].from_nid);
				}
			}
			return ANNE.MEMG.getNObjsFromList(froms);
		}
		
		else return [];
	}


	test_queryByRelonJSON_clump = async()=>{

		//test dynamic lang
		//person named trump
		var relons = [
			{
				from:{val:"", op:""},
				type:TYPE_BE,
				reln:{val:ANNE.MEM.inst.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"7618523810988349729", op:"="},
				pool_type:"match"
			},
			{
				from:{val:"", op:""},
				type:TYPE_ROLE,
				reln:{val:ANNE.MEM.role_when.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"2579424936603799988", op:"="},
				pool_type:"match",
				debug:"when role to 2579424936603799988"
			},
			{
				from:{val:"", op:""},
				type:TYPE_ROLE,
				reln:{val:ANNE.MEM.role_actor.nid, op:"="},
				to_type:TO_TYPE_ANNE,
				to:{val:"3482471539687014039", op:"="},
				pool_type:"match",
				debug:"role actor should be x.com"
			}
		];

		console.log("debug");
		console.log(relons);
		return await this.queryByRelonJSON(relons);
	}


	/**
	 * 
	 * @param {*} $rObjs 
	 * @returns 
	 */
	queryByRelonJSON = async($rObjs)=>{
		console.log($rObjs);
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryByRelonJSON");
		lastBlock = 0;// phObj.lastBlock;
		console.log("%c(queryByRelonJSON) with lastBlock:"+lastBlock, TALK.bgred);
		var response = await this.apiSimpleQueryWithParams("queryByRelonJSON", {
			jsonstring:JSON.stringify($rObjs),
			height:lastBlock
		});

		console.log(response);
		var aRelons = [];

		if (response.status=="good") {
			if(response.result.length) {
				await HISTORY.processResultsForNewPullHistory(response.result, phObj);
				aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryByRelonJSON");
			}
		}
		return aRelons;
	}



	/**
	 * Get all neurons, outbound payments and inbound payments
	 * First load data from IDB so we have it in RAM.
	 * @param {*} $nid 
	 * @param {*} $bSPONSOREDTOO 
	 * @returns 
	 */
	getAllMyStuff=async($nid, $bSPONSOREDTOO=true, $forceNEW=false)=> {
		if (USER._userNObj.nid==MEM.ANNE_ACCTID) return [];
		if (USER._userNObj.ghost==true) return [];
		console.time("API.getAllMyStuff");
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getAllMyStuff", $nid+$bSPONSOREDTOO);
		
		lastBlock = Math.max(0, phObj.lastBlock-10);
		
		if ($forceNEW==true) lastBlock=0;
		console.log("%c(getAllMyStuff) with lastBlock:"+lastBlock, TALK.bgred);
		
		//moving to an IDB helper to keep it cleaner.
		if (ANNE.SETTINGS && ANNE.SETTINGS.bPRELOADALLDATA==true) {
			await ANNE.IDB.getAllMyStuff(phObj, $nid, $bSPONSOREDTOO);
		}
		
		var aRelons = [];
		var LIMIT = 8000;
		var currentOffset = 0;
		var response = await this.apiSimpleQueryWithParams("getAllMyStuff", {
			nid:$nid,
			height:lastBlock,
			sponsored:$bSPONSOREDTOO,
			limit:LIMIT,
			offset:currentOffset
		});
		
		//abandoned the limit/offset as we have multiple functions (AAAAR)
		if (response.status=="good") {
			if (response.result.length>0) {
				
				await HISTORY.processResultsForNewPullHistory(response.result, phObj);
				aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.getAllMyStuff");
				
			}
		}
		
		console.timeEnd("API.getAllMyStuff");
		return;
	}
	


	/** 
	 * Get the anneid summary level data for an ANNE identity.
	 * this is used for tallies, summaries, of a user's andy_actions, relons_sponsored, hanais, and other metrics.
	 * @author Mr.Scatman
	 */
	getANNEID=async($nObj, $bFORCEREDO=false)=> {
		if ($nObj==null) return;
		if ($bFORCEREDO==false && $nObj._anneid) return $nObj._anneid;

		var response = await this.apiSimpleQueryWithParams("getANNEID", {
			nid:$nObj.nid
		});

		if (response.status=="good") {
			if (response.result!=null && response.results) $nObj._anneid = new anneid($nObj, response.result);
			else $nObj._anneid = null;
		}
		return $nObj._anneid;
	}


	/**
	 * 
	 * @param {*} $nObj 
	 */
	getANNEID_ranks=async($nObj, $bFORCEREDO=false)=>{
		if ($nObj==null) return;
		if ($bFORCEREDO==false && $nObj._anneid!=null && $nObj._anneid.bRANKS==true) return $nObj._anneid;

		var response = await this.apiSimpleQueryWithParams("getANNEID_ranks", {
			nid:$nObj.nid
		});

		if (response.status=="good") {
			if (response.result!=null && response.results) {
				$nObj._anneid = new anneid($nObj);
				$nObj._anneid.processFromObj(response.result[0]);
			}
			else $nObj._anneid = null;
		}
		return $nObj._anneid;
	}


	/**
	 * Get the annode pubKey from the annode auth object stored from the handshake.
	 */
	getAnnodePk = function() {
		if (this._AAUTH==null) return null;
		else return this._AAUTH.pubKey;
	}


	/**
	 * Get balance by nid.
	 * 
	 * @param {string}
	 * @author Mr.Scatman
	 */
	getBalance = async($nid)=> {
		var json = await this.apiSimpleQueryWithParams("getNeuronBalance",{nid:$nid});
		if (json.status!=undefined && json.status=="fail") return null;
		return json;
	}

	
	/**
	 * Get a merge analysis object for helpful info.
	 * @param {*} $nid1 - nid of a neuron.
	 * @param {*} $nid2 - nid of another neuron.
	 * @returns 
	 */
	getMergeReconByNids = async($nid1, $nid2)=> {
		if ($nid1==$nid2) return {status:"bad", reason:"can't merge a neuron into itself"};
		var json = await this.apiSimpleQueryWithParams("getMergeReconByNids",{nid1:$nid1, nid2:$nid2});
		if (json.status!=undefined && json.status=="fail") return null;
		console.log(json);
		return json;
	}

	getMergeReconByTXID = async($txid)=> {
		var json = await this.apiSimpleQueryWithParams("getMergeReconByTXID",{txid:$txid});
		if (json.status!=undefined && json.status=="fail") return null;
		console.log(json);
		return json;
	}


	/**
	 * query the NAPLEX of a given sponsor and class.
	 * Build the aplex objects so we have access to their data in our viz.
	 * @param {*} $sponsored_by_nid 
	 * @param {*} $class_nid 
	 * @returns 
	 */
	queryNAPLEX=async($sponsored_by, $class_nid, $offset=0, $nObjs=[])=> {
		const LIMIT = 2000;
		var json = await this.apiSimpleQueryWithParams("getNaplexByClass", 
				{sponsored_by:$sponsored_by, class_nid:$class_nid, limit:LIMIT, offset:$offset}
		);
		if (json.status!=undefined && json.status=="fail") return null;
		console.log(json);
		var results = json.result;
		var nObjs = $nObjs;
		for (var r=0; r < results.length; r ++) {
			var rez = results[r];
			var nObj = MEMG.getOrMakeIfNew(rez.id);
			if (rez.text!="" && nObj.text=="") nObj.text = rez.text;

			if ($sponsored_by!=undefined && $sponsored_by!=null) {
				nObj.sponsored_by = $sponsored_by;
			}
			
			nObj._aplex = new aplex(nObj, nObj.nid, rez);	//here

			if (results.pending!=undefined) {
                await MEMP.processNeuronsFromRelons(results.pending, false, false, "relons", "API.queryNAPLEX");
            }

			nObjs.push(nObj);
		}
		if (nObjs.length==LIMIT+$offset) {
			return await this.queryNAPLEX($sponsored_by, $class_nid, $offset+LIMIT, nObjs);
		}
		return nObjs;
	}


	/**
	 * We get a set of aplex objects here.
	 * @returns {Array} nObjs - an array of neurons that are the top by level.
	 */
	getTopXAnnexByLevel = async($limit=10)=>{
		var json = await this.apiSimpleQueryWithParams("getTopXAnnexByLevel", {limit:$limit});
		if (json.status!=undefined && json.status=="fail") return null;
		console.log(json);
		var results = json.result;
		var nObjs = [];
		for (var r=0; r < results.length; r ++) {
			var rez = results[r];
			var nObj = MEMG.getOrMakeIfNew(rez.id);
			if (rez.text!="" && nObj.text=="") nObj.text = rez.text;
			nObj._aplex = new aplex(nObj, nObj.nid, rez);

			if (results.pending!=undefined) {
                await MEMP.processNeuronsFromRelons(results.pending, false, false, "relons", "API.getTopXAnnexByLevel");
            }

			nObjs.push(nObj);
			if (nObjs.length==$limit) break;
		}
		return nObjs;
	}


	/**
	 * we get annex sys relons back here of the most recent annex relons pointing to TO nids (the annexed neuron)
	 * @param {*} $cnt 
	 * @returns {Array} an array of {.nObj, .cnt}
	 */
	getLatestXAnnexes = async($limit=10)=>{
		var response = await this.apiSimpleQueryWithParams("queryForLatestXANNEX", {limit:$limit});
		if (response.status=="good") {

			var results = response.result;
			await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.getLatestXAnnexes");
			
			var ln_objs = [];
			var neurons = 0;

			for (var r=0; r < results.length; r++) {
				var to_s = results[r].to_s;
				if (ln_objs[to_s]==undefined) {
					var nObj = MEMG.getNeuronByNid(to_s);
					ln_objs[to_s] = {nObj:nObj, cnt:1};
					neurons+=1;
				}
				else ln_objs[to_s].cnt+=1;

				if (neurons==$limit) {
					break;
				}
			}

			var final_arr =  ANNE.UTILS.convArr(ln_objs);
			final_arr.sort(function($a, $b) {
				if ($a.cnt>$b.cnt) return -1;
				else if ($b.cnt>$a.cnt) return 1;
				return 0;
			})
			return final_arr;
		}
		return [];
	}

	
	getAwarvuSummary = async($since_height=0)=>{
		var response = await this.apiSimpleQueryWithParams("getAwarvuSummary", {height:$since_height});
		var annexerWhales = [];
		if (response.status=="good") {
			var results = response.result;
			for (var r=0; r < results.length; r++) {
				var anneid_obj = results[r];
				var nid = anneid_obj.nid;
				var nObj = MEMG.getOrMakeIfNew(nid);

				nObj._anneid = new anneid(nObj, anneid_obj);
				
				annexerWhales.push(nObj);
			}
		}
		return annexerWhales;
	}


	/**
	 * we get an array of anneid records here.
	 * @param {*} $cnt 
	 * @returns {array} annexWhalers - an array of nObjs with thie respective ._anneid objects set.
	 */
	getAnnexerWhales = async($limit=10)=>{
		var response = await this.apiSimpleQueryWithParams("getANNEXWhales", {limit:$limit});
		var annexerWhales = [];
		if (response.status=="good") {
			var results = response.result;
			for (var r=0; r < results.length; r++) {
				var anneid_obj = results[r];
				var nid = anneid_obj.nid;
				var nObj = MEMG.getOrMakeIfNew(nid);

				nObj._anneid = new anneid(nObj, anneid_obj);
				
				annexerWhales.push(nObj);
			}
		}
		return annexerWhales;
	}


	/**
	 * 
	 * @param {*} $nObj 
	 * @param {*} $height 
	 * @returns 
	 */
	getAwarvuSummaryFor = async($nObj, $since_height=0) => {
		if ($nObj==null) return null;
		if ($nObj.ghost==true) return null;
		var response = await this.apiSimpleQueryWithParams("getAwarvuSummaryFor", {
			nid:$nObj.nid,
			since_height:$since_height
		});
		if (response.status=="good") {
			var apxs = new aplex_sum($nObj, APLEX_SUMMARY_SPECIFIC_NEURON, response);
			$nObj._aplex_sum = apxs;
			return apxs;
        }
		return null;
	}


	/**
	 * Will summarize ALL AWAREZ over the entire system.
	 * @param {*} $since_height 
	 * @returns 
	 */
	getAwarvuMetaSummary = async($since_height=0) => {
		var response = await this.apiSimpleQueryWithParams("getAwarvuMetaSummary", {
			since_height:$since_height
		});
		if (response.status=="good") {
			if (response.result!=null && parseInt(response.results)>0) {
				var apxs = new aplex_sum(MEM.___SELF___, APLEX_SUMMARY_NEURON_LINE, response);
				return apxs;
			}
			else {
				var apxs = new aplex_sum(MEM.___SELF___, APLEX_SUMMARY_NEURON_LINE, null);
				return apxs;
			}
        }
		return null;
	}

	
	/**
	 * Get the aplex data for neuron or hypergraph edge (relon).
	 * 
	 * This will get a feelz summary for any neuron or edge.
	 */
	getAplex=async($nObj=null, $bFORCENEW=false)=> {
		if ($bFORCENEW==false && $nObj._aplex!=undefined && $nObj._aplex!=null) return $nObj._aplex;

		if ($nObj==null) return null;
		if ($nObj.ghost==true) return null;
		var response = await this.apiSimpleQueryWithParams("getAplex", {
			id:$nObj.nid,
			id_type:0
		});
		if (response.status=="good") {
			if (response.result!=null && response.results!=0 && response.results!="") {
				if (response.result.text!="" && $nObj.text=="") $nObj.text = response.result.text;
				
				var extra_out = null;
				
				if (response.result.pending!=undefined) {
					if (response.result.pending.extra_outs!=undefined) {
						var extras = response.result.pending.extra_outs;
						extra_out = extras[0];
						ANNE.TALK.printRelons(extras);
						await MEMP.processNeuronsFromRelons(extras, false, false, "relons", "API.getAplex pending.extra_outs");
					}
				}
				else if (response.result && response.result.sponsored_by && response.result.sponsored_by!=$nObj.sponsored_by) {
					//update neuron sponsored by
					console.log("update neuron sponsored by.");
					$nObj.sponsored_by = response.result.sponsored_by;
				}

				var updates = [];
				var ghost_updates = [];

				if($nObj.sponsored_by!=null && $nObj.sponsored_by!=undefined) {
					for (var r=0; r < $nObj.outs.length; r++) {
						if ($nObj.outs[r].sponsored_by!=$nObj.sponsored_by) {
							$nObj.outs[r].sponsored_by = $nObj.sponsored_by;
							if ($nObj.ghost==true || $nObj.outs[r].ghost==true || $nObj.outs[r].txid[0]=="z") {
								ghost_updates.push($nObj.outs[r]);
							}
							else {
								updates.push($nObj.outs[r]);
							}
						}
					}
				}
				
				if (updates.length) {
					await ANNE.DB.___updateAll(updates);
				}
				if (ghost_updates.length) {
					await ANNE.DB_local.___updateAll(ghost_updates, "ghost_relons");
				}

				$nObj._aplex = new aplex($nObj, $nObj.nid, response.result);
			}
			else {
				$nObj._aplex = new aplex($nObj, $nObj.nid, null);
			}
        }

        //augment with our ghost tally. (????)
        AWARE.augmentGhosts($nObj);

        return $nObj._aplex;
	}


	/**
	 * 
	 * @param {*} $yearNid 
	 * @param {*} $monthNid 
	 * @param {*} $dayNid 
	 */
	getDates = async($yearNid, $monthNid, $dayNid)=>{
		var searchRels = [];
		var target="from_nid";

		if ($yearNid!=0) {
			var yrRel = {target:target, be:[ANNE.MEM.date_gregorian.nid], type:[TYPE_HAS], reln:ANNE.MEM.year.nid, to_a:$yearNid};
			searchRels.push(yrRel);
			target="pool";
		}

		if ($monthNid!=0) {
			var monthRel = {target:target, type:[TYPE_HAS], reln:ANNE.MEM.month.nid, to_a:$monthNid};
			if (searchRels.length==0) monthRel.be=[ANNE.MEM.date_gregorian.nid];
			searchRels.push(monthRel);
			target="pool";
		}

		if ($dayNid!=0) {
			var dayRel = {target:target, type:[TYPE_HAS], reln:ANNE.MEM.day.nid, to_a:$dayNid};
			if (searchRels.length==0) dayRel.be=[ANNE.MEM.date_gregorian.nid];
			searchRels.push(dayRel);
		}

		
		var response = await this.apiSimpleQueryWithParams("getAplex", {
			json_relon:searchRels
		});


		console.log(response);
		return;
	}

	
	/**
	 * for relons (pass id_type 1)
	 */
	 getAplexRelon=async($relon=null)=> {
		if ($relon==null) return null;
		if ($relon.ghost==true) return null;
		var response = await this.apiSimpleQueryWithParams("getAplex", {
			id:$relon.txid,
			id_type:1
		});
		if (response.status=="good") {
			if (response.result!=null && response.results!=0) new aplex($relon, $relon.txid, response.result);
			else new aplex($relon, $relon.txid, null);
        }

		//augment with our ghost tally.
		AWARE.augmentGhosts($relon);

        return $relon._aplex;
	}


	/** 
	 * Get the blockchain status info. 
     */
	getBlockchainStatus = async()=> {
		var json = await this.apiSimpleQuery("getBlockchainStatus");
		console.log(json);
		return json;
	}


	/**
	 * @param {String} $nid - nid longstring 
	 * @author Mr.Scatman
	 */
	getLNOTS = async($nid)=> {
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getLnots", $nid);
		var lastBlock = 0;//phObj.lastBlock;	//optimize this later after testing.
		var json = await this.apiSimpleQueryWithParams("getLnots",{nid:$nid});// height:lastBlock});
		if (json.status!=undefined && json.status=="fail") return null;
		await HISTORY.processResultsForNewPullHistory(json.lnots, phObj);
		return json.lnots;
	}

	
	/**
	 * 
	 * @param {*} $reln 
	 * @param {*} $to 
	 * @param {*} $to_type 
	 * @returns 
	 */
	getRelonsWithTo = async($reln, $to, $to_type)=> { 
		var response = await this.apiSimpleQueryWithParams("getRelonsWithTo",{reln:$reln, to:$to, to_type:$to_type});// height:lastBlock});
		if (response.status=="good") return response.result;
		return [];
	}
	
	
	/**
	 * 
	 * @param {String} $accountId - nid longstring in ANNE that we will check for in SIGNA. 
	 * @param {String} $signaURI
	 * @returns 
	 */
	getSignaBalance = async($accountId, $signaURI="https://europe.signum.network")=> {
		var json = await this.apiSimpleQueryWithParams("getBalance",{account:$accountId}, $signaURI, "burst");
		if (json.status!=undefined && json.status=="fail") return null;
		return json;
	}


	/**
	 * 
	 * @param {String} $parentNid - nid longstring 
	 * @param {*} $value - proposed new subanndle under the parent anndle/subanndle
	 * @returns 
	 */
	getSubAnndle = async($parentNid, $value)=> {
		var json = await this.apiSimpleQueryWithParams("getSubAnndle",{parent_nid:$parentNid, value:$value});
		return json;
	}

	/**
	 * 
	 * @param {String} $anndle_str 
	 * @returns 
	 */
	getAnndlePricing = async($anndle_str)=>{
		var response = await this.apiSimpleQueryWithParams("getAnndlePricing", {anndle:$anndle_str});
		console.log(response);
		if (response.status=="good") {
			return response.result;
		}
		return null;
	}

	/**
	 * 
	 * @param {*} $nid 
	 * @returns 
	 */
	calculateAnnexPrice = async($nid)=>{
		var response = await this.apiSimpleQueryWithParams("calculateAnnexPrice", {nid:$nid});
		console.log(response);
		if (response.status=="good") {
			return response.result;
		}
		return null;
	}


	/**
	 * 
	 * @param {string} - account we want to query TXs for.
	 * 
	 * @author Mr.Scatman								
	 */
	getUnconfirmedTransactions = async($account)=> {
		var response = await this.apiSimpleQueryWithParams("getUnconfirmedTransactions", 
			{	
				account:$account
			}
			);
		console.log(response);
		if (response.unconfirmedTransactions!=undefined
			&& response.unconfirmedTransactions.length) {
			console.log(response.unconfirmedTransactions);
			return response.unconfirmedTransactions;
		}
		return [];
	}




	/**
	 * @param {*} $txid 
	 * @returns 
	 */
	getRelon = async($txid)=> {
    	var response = await this.apiSimpleQueryWithParams("getRelon",{
			txid:$txid
		});
		if (response.status=="good") {
			if (response.result!=null) {
				response.result.bMUSTINSERT=true;
				await MEMP.processNeuronsFromRelons([response.result], false, true, "relons", "API.getRelon");
			}
		}
		return ANNE.MEMG.lookupByTXID($txid);
	}

	getRelonsBySYSREFTXID = async($txid)=> {
    	var response = await this.apiSimpleQueryWithParams("getRelonsWithSysRefTxid",{
			txid:$txid
		});
		if (response.status=="good") {
			if (response.result.length) {
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.getRelonsBySYSREFTXID");
				return aRelons;
			}
		}
		return [];
	}


	/**
	 * Get the ANNODE tranasction (traditional bockchain format), not the hypergraph relon.
	 * @param {*} $txid 
	 * @returns 
	 */
	 getBlockchainTransaction = async($txid)=> {
    	var json = await this.apiSimpleQueryWithParams("getBlockchainTransaction",{
			transaction:$txid
		});

		if (ANNE.SETTINGS.debug()==true) console.log(json);

		if(ANNE.UTILS.isset(json.attachment)==true) {
			if (json.attachment.reln!=undefined) {
				var from_nid = "";
				var attachment = json.attachment;
				if (json.type==40) from_nid=json.sender;
				else from_nid = attachment.from;
	
				var temp_rel = {
					txid:json.transaction,
					from_nid:from_nid,
					type:attachment.type,
					reln:attachment.reln,
					to_type:attachment.to_type,
					to_s:attachment.to,
					height:json.height,
					annies:json.amountNQT,
					force_update:true
				}
	
				//put this in mem (or update existing relon in mem)
				await MEMP.processNeuronsFromRelons([temp_rel], false, true, "relons", "API.getBlockchainTransaction");
			}
		}

		return json;
	}


	/**
	 * Get the public key for a neuron.
	 * This is only relevant with key'd neurons, not keyless.
	 * @param {*} $nid 
	 */
	getAccountPublicKey = async($nid, $uri="")=>{
		var nObj = MEMG.getNeuronByNid($nid);
		if (nObj!=null) {
			if (nObj.pubKey!=undefined) return nObj.pubKey;	
		}
		var json = await this.apiSimpleQueryWithParams("getAccountPublicKey",{account:$nid}, $uri);
		console.log("json:",json);
		if (json.publicKey!=undefined && json.publicKey.length>0) {
			var nObj = MEMG.getOrMakeIfNew($nid);
			nObj.pubKey = json.publicKey; 
			return json.publicKey;
		}
		return "";
	}


	/**
	 * No saving in local db here.. just a quick pull
	 */
	 getDirectFundsOf = async($account)=>{
		var response = await this.apiSimpleQueryWithParams("getDirectFundsOf", {nid:$account,});
		console.log(response);
		if (response.status=="good") {
			return response.result;
		}
		return [];
	}

	
	//get a specific feelz/opinion reln (from a list) that points into a nid.
	getSpecificAwarenesses = async($to_nid, $relns)=> {
		var lastBlock = 0;
		if ($to_nid[ $to_nid.length-1]=="z") {
			console.log("DONT CALL THIS WITH TEMP NEURONS!");
			return [];
		}
		var hash = ANNE.other.sha256($to_nid+$relns.join());
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getSpecificAwarenesses ", hash);
		lastBlock = phObj.lastBlock;
		var response = await this.apiSimpleQueryWithParams("getSpecificAwarenesses", 
			{
				nid:$to_nid, 
				relns:$relns,
				height:lastBlock

			});
		console.log(response);
		var aRelons = [];
		if (response.status=="good") {
			var results = response.result;
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.getSpecificAwarenesses");
		}
		return aRelons;
	}
	
	

	/**
	 * 
	 */
	getVoteData = async ($nid)=> {
		var lastBlock = 0;
		var response = await this.apiSimpleQueryWithParams("getVoteData", 
				{
					nid:$nid,
					height:0
				});
		console.log(response);
		var aRelons = [];
		if (response.status=="good") {
			var results = response.result;
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.getVoteData");
		}
		return aRelons;					
	}



	
	/**
	 * TO DO, pass through height and store a local optimizer
	 */
	queryForRecents=async($classNids, $max_results=200)=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForRecents", $classNids.join("")+$max_results);
		lastBlock = phObj.lastBlock;
		if (lastBlock==0) lastBlock = ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK;
		var aNewRelons = [];
		var response = await this.apiSimpleQueryWithParams("queryForRecents", {
			class_nids:$classNids,
			height:lastBlock-10,
			max_results:$max_results
		});
		if (response.status=="good") {
		
			/************************************************************** */
			//OPTIMIZED and far cleaner.
			//this should be done, everywhere we pull in new data.
			var relons_to_process = response.result;
			//var am = new arraymap();
			//am.setMapKey("txid");
			//for(var r=0; r < relons_to_process.length; r++) {
				//if (ANNE.SETTINGS.debug()==true) console.log("audit: txid:"+relons_to_process[r].txid+" sp by:"+relons_to_process[r].sponsored_by);
				//am.addU( relons_to_process[r]);
			//}
			//await ANNE.IDB.checkForNewTxids(am);
			//those left in the relons map are new.
            if(relons_to_process.length>0) {
				aNewRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.queryForRecents");
			}
			/************************************************************** */
			
			if (ANNE.SETTINGS.debug()==true) ANNE.TALK.printRelons(aNewRelons);
			await HISTORY.processResultsForNewPullHistory(relons_to_process, phObj);
        }
        return aNewRelons;
	}

	/**
	 * Query for awareness relons.
	 * There could potentially be alot of these for any given $nid.
	 * These are outbound awareness relons, or "feelz" and "opinionz" expressed.
	 * @param {*} $nid 
	 * @param {*} $lastBlock 
	 * @param {*} $offset 
	 * @returns {Array}
	 */
	queryForAwareness=async($nid, $lastBlock, $offset)=> {
	   var aNewRelons = [];
	   var response = await this.apiSimpleQueryWithParams("queryForAwareness", {
		   nid:$nid,
		   height:$lastBlock,
		   offset:$offset
	   });

	   console.log("(queryForAwareness)");
	   if (response.status=="good") {
		   aNewRelons = response.result;
	   }

	   return aNewRelons;
   }


	/**
	 * get the global for this class and value
	 * 
	 * @param {String} $classNid - nid longstring
 	 * @param {*} $value
	 * @author Mr.Scatman
	 */
	queryForGlobal = async($classNid, $value)=> {
		var json = await this.apiSimpleQueryWithParams("getGlobal",{class_nid:$classNid, value:$value});
		return json;
	}


	/**
	 * Query for a neuron of a given class with a given value.
	 * Optionally provide a required reln and to_s value of that reln.
	 * The ANNODE will first match the class/value and then filter for reln_nid/to_s (if provided).
	 * 
	 * This does not check BEM line (be line class).  The neuron must have a be value of the value searched for 
	 * in classNid.  This is intended for flat value classes like persons, company, thing etc.
	 * @param {*} $classNid 
	 * @param {*} $value 
	 * @param {*} $reln_nid 
	 * @param {*} $to_type 
	 * @param {*} $to_s 
	 * @returns 
	 */
	queryFoNeuronByClassAndRelon = async($classNid, $value, $reln_nid, $to_type=TO_TYPE_ANNE, $to_s)=> {
		var json = await this.apiSimpleQueryWithParams("getByClassAndRelon",
			{class_nid:$classNid, 
				value:$value,
				reln:$reln_nid,
				to_type:$to_type,
				to:$to_s});
		return json;
	}


	queryFoNeuronByAltBeTexAndBe = async($classNid, $text, $alt_be_reln, $alt_be_to)=> {
		var json = await this.apiSimpleQueryWithParams("getByAltBeTextAndBe",
			{class_nid:$classNid, 
				text:$text,
				alt_be_reln:$alt_be_reln,
				alt_be_to:$alt_be_to});
		return json;
	}


	/**
	 * get a person by name and bday
	 * 
	 * @param {string}
	 * @param {string}
	 * @param {string}
	 * @param {string}
	 * @param {string}
	 * @author Mr.Scatman
	 */
	queryForPersonWithBday=async($bday, $namestr, $alias="")=> {
		var json = await this.apiSimpleQueryWithParams("getPersonWithBday",
				{	
					bday:$bday, 
					name:$namestr,
					alias:$alias
				});
		return json;
	}

	getPerson=async($namestr)=> {
		var json = await this.apiSimpleQueryWithParams("getPerson",{name:$namestr});
		return json;
	}


	/**
	 * 
	 * @param {*} $foundedOnStr 
	 * @param {*} $namestr 
	 * @param {*} $foundedAtNID 
	 * @returns 
	 */
	getCompany=async($namestr, $registratonPolityNid=null)=> {
		var json = await this.apiSimpleQueryWithParams("getCompany",
		{	 
			name:$namestr,
			registration_polity_nid:$registratonPolityNid
		});
		return json;
	}


	/**
	 * Query for a global location.
	 * We pass along the sender nid so we can check for user-owned neurons too..
	 * @param {string}
	 * @author Mr.Scatman
	 */
	queryForLocation = async($name, $constituent_of_nid, $alt_be_nid)=> {
		var json = await this.apiSimpleQueryWithParams("getLocation",{
					name:$name, 
					constituent_of_nid:$constituent_of_nid,
					alt_be_nid:$alt_be_nid,
					sender_nid:ANNE.USER._userNObj.nid
				});
		return json;
	}


	/**
	 * Recon on the parts of a location that we are looking to potentially resolve.
	 * @param {*} $name 
	 * @returns 
	 */
	getLocationParts = async($name)=> {
		var response = await this.apiSimpleQueryWithParams("getLocationParts",{
			name:$name
		});
		
		if (response.status=="good") {
			/************************************************************** */
			//OPTIMIZED and far cleaner.
			//this should be done, everywhere we pull in new data.
			var relons_to_process = response.result;
			//var am = new arraymap();
			//am.setMapKey("txid");
			//for(var r=0; r < relons_to_process.length; r++) {
				//am.addU( relons_to_process[r]);
			//}
			//await ANNE.IDB.checkForNewTxids(am);
			//those left in the relons map are new.
            if(relons_to_process.length>0) {
				var aNewRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.getLocationParts");
				return aNewRelons;
			}
			/************************************************************** */
		}
		return;
	}


	/**
	 * 
	 * @param {*} $anums 
	 * @returns 
	 */
	getNidsByAnums = async($anums)=> {
		var json = await this.apiSimpleQueryWithParams("getNidsByAnums",{
			anums:$anums
		});
		if (json && json.status=="good") {
			for (var a=0; a < json.result.length; a++) {
				var nid = json.result[a].nid;
				var nObj = ANNE.MEMG.getOrMakeIfNew(nid);
				if (nObj.text=="") nObj.text = json.result[a].anblstr;
			}
			return json.result.concat();
		}
		return null;
	}

	

	/**
	 * 
	 * @param {*} $name 
	 * @returns 
	 */
	queryForNamedLocation = async($name)=> {
		console.log("queryForNamedLocation: "+$name);
		var response = await this.apiSimpleQueryWithParams("getNamedLocation",{
					name:$name
				});

		if (response.status=="good") {
			var relons_to_process = response.result;
			if (relons_to_process.length) {
				aRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.queryForNamedLocation");
				//await HISTORY.processResultsForNewPullHistory(relons_to_process, phObj);
				return aRelons;
			}
		}
		return [];
	}

	/**
	 * Query for a hanai.
	 * 
	 * @param {string}
	 * @author Mr.Scatman
	 */
	queryForHanai = async($nid, $height=0)=> {
		$height = Math.max(0, $height);
		//var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForHanai", $nid);
		//lastBlock = phObj.lastBlock;
		var response = await this.apiSimpleQueryWithParams("queryForHanai", {
			nid:$nid, 
			height:$height
		});
		console.log(response);
		if (response.status=="good") {
			var relons_to_process = response.result;
			if (relons_to_process.length) {
				var aRelons = await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.queryForHanai");
				//await HISTORY.processResultsForNewPullHistory(relons_to_process, phObj);
				return aRelons;
			}
		}
		return [];
	}


	/**
	 * User is an admin for an open hanai request that doesnt have a sys_ref_txid set.
	 * That is set when the repsonse is officially processed.
	 * Look for an admin response to the request that is pending mining.
	 */
	queryForHanaiResponseTo = async($txid)=>{
		var response = await this.apiSimpleQueryWithParams("queryForHanaiResponseTo", {
			txid:$txid
		});
		console.log(response);
		if (response.status=="good" && response.result.length>0) {
			var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForHanaiResponseTo");
			return aRelons[0];
		}
		return null;
	}
	

	/**
	 * 
	 * @param {string}
	 * @author Mr.Scatman
	 */
	 queryForAndy=async($nid, $nids_i_am_delegated_admin_for=[])=> {
		//var lastBlock = 0;	//optimize later
		if ($nid==null) return;
		if ($nids_i_am_delegated_admin_for==null) $nids_i_am_delegated_admin_for=[];

		var height = ANNE.MEM_UDF._collab_hlc;
		 height = 0;

		//de-optimize until we get this right....
		var response = await this.apiSimpleQueryWithParams("queryForAndy", {
				from:$nid, 
				nids:$nids_i_am_delegated_admin_for, 
				height:height
			});

		//_collab_hlc is managed in MEM_UDF _processCollabs.
		//when a user is "unlocked" it preloads from local DB mem.
		//run-time it updates through here.
		console.log(response);
		if (response.status=="good") {
			if (response.result.length) {
				await MEM_UDF._processCollabs(response.result);
			}
			return MEM_UDF._collab_relons;
		}
		return MEM_UDF._collab_relons;
	}


	/**
	 * Query the node for this text name.
	 * 
	 * @param {string}
	 * @author Mr.Scatman
	 */
	queryForNakedText = async ($searchString, $bEXACT=false) => {
		if ($searchString=="") return;
		var aRelons = [];
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForNakedText", $searchString);
		lastBlock = 0;//phObj.lastBlock;

		//console.log("(API.queryForNakedText)");
		var exact = "no";
		if ($bEXACT==true) exact = "yes";

		console.time("queryForNaked");
		var response = await this.apiSimpleQueryWithParams("queryForNakedText", {
				text:$searchString,
				exact:exact, 
				height:lastBlock
		});
		console.timeEnd("queryForNaked");

		if (response.status=="good") {
			if (response.result.length>0) {
				var froms = [];
				for (var r=0; r < response.result.length; r++) {
					if (froms.indexOf(response.result[r].from_nid)==-1) {
						froms.push(response.result[r].from_nid);
					}
				}
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForNakedText");
				await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
				return froms;
			}
		}
		return [];
	}

		
	/**
	 * 
	 * @param {*} $searchString 
	 * @param {*} $wvs 
	 * @param {*} $bes 
	 * @param {*} $bEXACT 
	 * @param {*} $bAPPLYTOBELINE ---must be true to invoke enforement of $bes array OR bem line via inbeline
	 * @param {*} $inbeline  --- left at 0 (or null) when not wanting a BEM LINE seearch of that class nid
	 * @returns 
	 */
	queryForText = async ($searchString, $wvs=[], $bes=[], $bEXACT=false, $bAPPLYTOBELINE=false, $inbeline=0) => {
		if ($searchString=="") return;
		$searchString = $searchString+"";
		$searchString = $searchString.trim();
		var aRelons = [];
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForText", $searchString+$bEXACT+$bAPPLYTOBELINE);
		lastBlock = 0;//phObj.lastBlock;

		console.log("(API.queryForText) "+$searchString);
		var response = await this.apiSimpleQueryWithParams("queryForText", {
				text:$searchString, 
				wvs:$wvs, 
				bes:$bes,
				applytobeline:$bAPPLYTOBELINE,
				inbeline:$inbeline, 
				height:lastBlock
			});

		if (response.status=="good") {
			if (response.result.length>0) {
				if(response.result.length>100) {
					console.log("what is this??  so many results for "+$searchString);
				}
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForText");
				await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
				return aRelons;
			}
		}
		return [];
	}


	/**
	 * Much more efficient to use this when we know we are looking for a valid identity (by text string)
	 * @param {*} $searchString 
	 * @returns 
	 */
	queryForIdentity = async ($searchString) => {
		if ($searchString=="") return;
		var aRelons = [];
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForIdentity", $searchString);
		lastBlock = 0;//phObj.lastBlock;

		console.log("(API.queryForIdentity)");
		var response = await this.apiSimpleQueryWithParams("queryForIdentity", {
				text:$searchString, 
				height:lastBlock
			});

		if (response.status=="good") {
			if (response.result.length>0) {
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForIdentity");
				await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
				return aRelons;
			}
		}
		return [];
	}
	


	/**
	 * Test rollback handling.
	 * REMOVE THIS IN MAINNET -- AS WELL AS ALTER THE APIKEY (if we want to use it at all!)
	 * @returns 
	 */
	popOffMocknet = async()=> {
		return await this.apiSimpleQueryWithParams("popOff",{numBlocks:1, height:0, apiKey:"aaaa"}); 
	}

	
	mempoolOk = async()=>{
		var rez = await this.annodeDetails();
		if (rez.mempool_ok==true) return true;
		return false;
	}

	/**
	 * 
	 * @returns 
	 */
	annodeDetails = async()=> {
		var rez = await this.apiSimpleQuery("annodeDetails"); 
		if (rez.status=="good") {
			await this.processAuxAAUTHData(rez.result);
			return rez.result;
		}
		else return {};
	}
	

	/** 
	 * Get outs for an nid, and types w/ filters.
	 * Note: This gets the BEM outs on the ANNODE (the entire be-line)
	 *
 	 * @param {string}
	 * @param {Boolean}
	 * @param {Array}
	 * @author Mr.Scatman
	*/
	queryForOuts_not = async($nid, $bMUSTPULL=false, $types=[4])=> {
		var nOBJ = MEMG.getOrMakeIfNew($nid)
		if (nOBJ.ghost==true) {
			alert("DO NOT QUERY GHOSTS AGAINST THE ANNODE!!!");
			return [];
		}
		
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOuts_not", $nid);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;
		console.log("(API.queryForOuts_not) with nid:"+$nid+" and lastBlock:"+lastBlock);
		await ANNE.IDB.queryForOuts_not(phObj, $nid, $types);

		var response = await this.apiSimpleQueryWithParams("queryForOuts_not", {
				from:$nid, 
				type:$types, 
				height:lastBlock
		});

		if (response.status=="good") {
			if (response.result.length>0) {
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOuts_not");
				await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
				return aRelons;
			}
		}
		return [];
	}


	getANNEBasicDemogrpahics = async($nids, $bDOLOCALONLY=false, $bEXTERNALONLY=false)=>{
		return await this.queryTosFromRelns($nids, 0, null, $bDOLOCALONLY, $bEXTERNALONLY);
        //await ANNE.API.queryTosFromRelns(MEM.tribal.nid, 0, null, bDOLOCALONLY);
	}


	/**
	 * 
	 * @param {*} $reln_nid 
	 * @param {*} $offset 
	 * @param {*} $phObj 
	 * @param {*} $bDOLOCALONLY 
	 * @param {*} $bEXTERNALONLY 
	 * @returns 
	 */
	queryTosFromRelns=async($relns, $offset=0, $phObj=null, $bDOLOCALONLY=false, $bEXTERNALONLY=false)=>{
		var nObjs = [];
		var nids = [];
		for (var r=0; r < $relns.length; r++) {
			var relNOBJ = MEMG.getOrMakeIfNew($relns[r]);
			if (relNOBJ.ghost==true) {
				continue;
			}
			nObjs.push(relNOBJ);
			nids.push(relNOBJ.nid);
		}
			
		var lastBlock = 0;
		var hash = ANNE.other.sha256(nids.join(""));
		
		var phObj = $phObj;
		if (phObj==null && $bEXTERNALONLY==false) {
			phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryTosFromRelns", hash);
			await ANNE.IDB.queryTosFromRelns(phObj, nids);
		}

		if ($bDOLOCALONLY==true) return;

		const LIMIT = 2000;

		var response = await this.apiSimpleQueryWithParams("queryTosFromRelns", {
				nids:nids, 
				height:lastBlock,
				limit:LIMIT,
				offset:$offset
		});

		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result.length) {
				await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryTosFromRelns");
			}

			//if we got max values, we need to go back in again and get the rest.
			if (response.result.length==LIMIT+$offset) {
				return await this.getTosFromRelns(nids, $offset+LIMIT, phObj);
			}
		}

		if (response.result.length && $offset==0) {
			await HISTORY.processResultsForNewPullHistory(response.result, phObj);
		}

		return;
	}


	//this will NOT get awareness relons..
    getIns = async($nid, $bMUSTPULL=false)=>{
        return await this.queryForIns($nid, $bMUSTPULL);
    }


	/**
	 * THIS WILL NOT GET AWARENESS RELONS.
	 * @param {*} $nid 
	 * @param {*} $bMUSTPULL 
	 * @returns 
	 */
    queryForIns = async($nid, $bMUSTPULL=false)=>{
        var nOBJ = MEMG.getOrMakeIfNew($nid)
		if (nOBJ.ghost==true) {
			alert("DO NOT QUERY GHOSTS AGAINST THE ANNODE!!!");
			return [];
		}

		var aRelons = [];
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForIns", $nid);
		lastBlock = phObj.lastBlock;

		await ANNE.IDB.queryForIns(phObj, $nid);

		if ($bMUSTPULL==true) lastBlock = 0; //phObj.lastBlock;

		var response = await this.apiSimpleQueryWithParams("queryForIns", {
				to:$nid, 
				height:0
			});

		if (response.status=="good") {
			if (response.result.length>0) {
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForIns");
				await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
				return aRelons;
			}
		}
		return [];
    }

	
	/** 
	 * We want to chase updated sponsored by values to prevent us drama on the annode
	 * by submitting the wrong TXs.
	 * 
	 * 
	 * @author Mr.Scatman
	 */
	queryForGhostPrep = async($nids)=> {
		var hash = ANNE.other.sha256($nids.join(""));
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForGhostPrep", hash);
		
		var nids = [];
		for (var n=0; n < $nids.length; n++) {
			var nid = $nids[n];
			var nOBJ = null;
			if ((nid instanceof anne_neuron)==true) {
				console.warn("FIX THIS, s.b. a nid, not a neuron");
				nOBJ = nid;
			}
			else nOBJ = MEMG.getOrMakeIfNew($nids[n]);
			
			if (nOBJ.ghost==true) continue;
			nids.push(nOBJ.nid);
		}

		await ANNE.IDB.queryForOutsFroms_not(phObj, nids, [4]);
		var nids2 = [];
		for (var n=0; n < nids.length; n++) {
			var nObj=MEMG.getNeuronByNid(nids[n]);
			if (nObj.sponsored_by=="" || nObj.sponsored_by==ANNE.MEM.USER._userNObj.nid) {
				nids2.push(nObj.nid);
			}
		}
		nids = nids2;
		

		if (nids.length==0) return []; //we're good now with the IDB pull.

		var aRelons = [];
		var lastBlock = phObj.lastBlock;
		
		//too many nids..
		const nid_SHARD=30;
		if (nids.length>nid_SHARD) {
			var loops = Math.ceil(nids/nid_SHARD);
			var aRelsAll = [];
			for (var n=0; n < loops; n++) {
				var nids2 = nids.slice(n*nid_SHARD, Math.min( (n*nid_SHARD)+nid_SHARD, nids.length-1) );
				var response = await this.apiSimpleQueryWithParams("queryForOutsFroms_not", {
					froms:nids2, 
					types:$types, 
					height:lastBlock
				});
				if (response.status=="good") {
					if (response.result.length>0) {
						var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForGhostPrep");
						aRelsAll = aRelsAll.concat(aRelons);
					}
				}
			}
			if (aRelsAll.length>0) {
				await HISTORY.processResultsForNewPullHistory(aRelsAll, phObj);
				return aRelsAll;
			}
		}

		else {
			//we only need 0/1 here.
			var response = await this.apiSimpleQueryWithParams("queryForOutsFroms_not", {
				froms:nids, 
				types:[2,3,4,5,6,7,8,9,10], 
				height:lastBlock
			});
			if (response.status=="good") {
				if (response.result.length>0) {
					var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForGhostPrep");
					await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
					return aRelons;
				}
			}
		}
		return [];
	}

	
	/** 
	 * Get outs for a list of nids, and types w/ filters.
	 * 
	 * This is helpful when wanting all the data but not relons like feelz/awareness..
	 * as we could eventually get millions of those edges on any given neuron.
	 * 
	 * @author Mr.Scatman
	*/
	queryForOutsFroms_not = async($nids, $bMUSTPULL=false, $types=[4], $bDOIDB=true, $bREBASE01=false)=> {
		if ($nids==undefined || $nids==null) return [];
		
		//use this instead.
		if ($nids.length==1) {
			return await this.queryForOuts_not($nids[0], $bMUSTPULL, $types);
		}
		
		var hash = ANNE.other.sha256($nids.join("")+$types.join(""));
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOuts_not", hash);
		
		var nids = [];
		for (var n=0; n < $nids.length; n++) {
			var nid = $nids[n];
			var nOBJ = null;
			if ((nid instanceof anne_neuron)==true) {
				console.warn("FIX THIS, s.b. a nid, not a neuron");
				nOBJ = nid;
			}
			else nOBJ = MEMG.getOrMakeIfNew($nids[n]);
			
			if (nOBJ.ghost==true) continue;
			nids.push(nOBJ.nid);
		}

		if ($bDOIDB==true) await ANNE.IDB.queryForOutsFroms_not(phObj, nids, $types);

		//we only are using this function to chase for name and be.
		//if we now have those, don't chase them.
		if ($bREBASE01==true) {
			var nids2 = [];
			for (var n=0; n < nids.length; n++) {
				var nObj=MEMG.getNeuronByNid(nids[n]);
				if (nObj.text.length>0 && nObj.bes.length>0) {
					nids2.push(nObj.nid);
				}
			}
			nids = nids2;
		}

		if (nids.length==0) return []; //we're good now with the IDB pull.

		var aRelons = [];

		//intended for multi nids
		var lastBlock = 0;// phObj.lastBlock;
		
		//too many nids..
		const nid_SHARD=30;
		if (nids.length>nid_SHARD) {
			var loops = Math.ceil(nids/nid_SHARD);
			var aRelsAll = [];
			for (var n=0; n < loops; n++) {
				var nids2 = nids.slice(n*nid_SHARD, Math.min( (n*nid_SHARD)+nid_SHARD, nids.length-1) );
				var response = await this.apiSimpleQueryWithParams("queryForOutsFroms_not", {
					froms:nids2, 
					types:$types, 
					height:lastBlock
				});
				if (response.status=="good") {
					if (response.result.length>0) {
						var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOutsFroms_not");
						aRelsAll = aRelsAll.concat(aRelons);
					}
				}
			}
			if (aRelsAll.length>0) {
				await HISTORY.processResultsForNewPullHistory(aRelsAll, phObj);
				return aRelsAll;
			}
		}

		else {
			var response = await this.apiSimpleQueryWithParams("queryForOutsFroms_not", {
				froms:nids, 
				types:$types, 
				height:lastBlock
			});
			if (response.status=="good") {
				if (response.result.length>0) {
					var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOutsFroms_not");
					await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
					return aRelons;
				}
			}
		}
		return [];
	}


	/** 
	 * Get outs for an nid, and types w/ filters.
	 * Note: This gets the BEM outs on the ANNODE (the entire be-line)
	 *
 	 * @param {string}
	 * @param {Boolean}
	 * @param {Array}
	 * @author Mr.Scatman
	*/
	getAllOuts = async($nid, $bMUSTPULL=false, $types=[0,1,2,3])=> {
		return await this.queryForOuts($nid, $bMUSTPULL, $types);
	}
	getOuts = async($nid, $bMUSTPULL=false, $types=[0,1,2,3])=> {
		return await this.queryForOuts($nid, $bMUSTPULL, $types);
	}
	chaseOuts = async($nid, $bMUSTPULL=false, $types=[0,1,2,3])=> {
		return await this.queryForOuts($nid, $bMUSTPULL, $types);
	}
	queryForOuts = async($nid, $bMUSTPULL=false, $types=[0,1,2,3])=> {
		if ($nid==undefined || $nid==null) return [];
		
		var nOBJ = MEMG.getOrMakeIfNew($nid)
		if (nOBJ.ghost==true) {
			alert("DO NOT QUERY GHOSTS AGAINST THE ANNODE!!!");
			return [];
		}

		var aRelons = [];
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOuts", $nid);
		lastBlock = phObj.lastBlock;

		await ANNE.IDB.queryForOuts(phObj, $nid, $types);

		if ($bMUSTPULL==true) lastBlock = 0; //phObj.lastBlock;
		
		var response = await this.apiSimpleQueryWithParams("queryForOuts", {
				from:$nid, 
				type:$types, 
				height:lastBlock
			});

		if (response.status=="good") {
			if (response.result.length>0) {
				var aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOuts");
				await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
				return aRelons;
			}
		}
		return [];
	}
	


	/**
	 * Used in emulation when we need more identities
	 * @param {*} $limit 
	 * @returns 
	 */
	getIdentities=async($limit=100, $offset=0)=>{
		return await this.getChildren(MEM.identity.nid, $limit, $offset);
	}
	
	/**
	 * We should do an IDB query here too... dagnab.
	 * @param {*} $parent_nid 
	 * @param {*} $limit 
	 * @param {*} $offset 
	 * @returns 
	 */
	getChildren=async($parent_nid, $limit=100, $offset=0, $phObj=null, $bDOLOCALONLY=false) => {
		if ($parent_nid==undefined || $parent_nid==null) return [];
		
		$limit = Math.min($limit, 2000);

		var phObj = $phObj;
		if (phObj==null) {
			phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForInstChildren", $nid);
			if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {
				return [];
			}
			await ANNE.IDB.getChldren(phObj, $parent_nid, NTYPE_INST);
		}

		if ($bDOLOCALONLY==true) return;

		var response = await this.apiSimpleQueryWithParams("queryForInstChildren", {
			nid:$parent_nid,
			offset:$offset,
			limit:$limit
		});
		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result.length) {
				aRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.getChildren");
			}

			//if we got max values, we need to go back in again and get the rest.
			if (response.result.length==LIMIT+$offset) {
				return await this.getChildren($parent_nid, $limit, $offset+$limit, phObj);
			}
		}

		if (response.result.length && $offset==0) {
			await HISTORY.processResultsForNewPullHistory(response.result, phObj);
		}
		return;
	}



	/**
	 * USE THIS WISELY.  If done against a big class the return is not desirable.
	 * It should not be used to query large classes.  It is intended for instance neurons.
	 * 
	 * @param {*} $nid 
	 * @param {*} $bMUSTPULL 
	 * @param {*} $type 
	 * @returns 
	 */
	queryForOutsAndIns = async($nid, $bMUSTPULL=false, $types=[0,1,2,3], $offset=0, $phObj=null)=> {
		if ($nid==undefined || $nid==null) return [];
		
		var nOBJ = MEMG.getOrMakeIfNew($nid)
		if (nOBJ.ghost==true) {
			alert("DO NOT QUERY GHOSTS AGAINST THE ANNODE!!!");
			return [];
		}
		if (nOBJ.ntype==NTYPE_CLASS) {
			console.warn("You are going to to query with queryForOutsAndIns with a class neuron.  NOT IDEAL.")
		}

		var lastBlock = 0;
		var phObj = $phObj;
		if (phObj==null) {
			phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOutsAndIns", $nid);
			if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {
				return [];
			}
			await ANNE.IDB.queryForOutsAndIns(phObj, $nid, $types);
		}

		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;

		const LIMIT = 4000;

		if (ANNE.SETTINGS && ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("(API.queryForOutsAndIns) with nid:"+$nid+" and lastBlock:"+lastBlock);
		var response = await this.apiSimpleQueryWithParams("queryForOutsAndIns", {
				from:$nid, 
				type:$types, 
				height:lastBlock,
				limit:LIMIT,
				offset:$offset
			});

		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result && response.result.length) {
				await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOutsAndIns");
			}

			//if we got max values, we need to go back in again and get the rest.
			if (response.result.length==LIMIT+$offset) {
				return await this.queryForOutsAndIns($nid, $bMUSTPULL, $types, $offset+LIMIT, phObj);
			}
		}

		if (response.result && response.result.length && $offset==0) {
			await HISTORY.processResultsForNewPullHistory(response.result, phObj);
		}
	}


	/**
	 * This can get CRAZY big.. if ur not calling it wisely.
	 * 
	 * @param {*} $nids 
	 * @param {*} $bMUSTPULL 
	 * @param {*} $types 
	 * @returns 
	 */
	queryForOutsAndInsFroms = async($nids, $bMUSTPULL=false, $types=[0,1,2,3], $offset=0, $phObj=null, $bDOIDB=true, $rels=[])=> {
		var nids = [];
		for (var n=0; n < $nids.length; n++) {
			var nObj = MEMG.getOrMakeIfNew($nids[n]);
			if (nObj.ghost==true) continue;
			nids.push(nObj.nid);
		}

		if (nids.length==0) return [];

		var aRelons = [];
		var lastBlock = 0;

		var hash = ANNE.other.sha256(nids.join(""));
		var phObj = $phObj;
		
		//only first pass (when phObj is null) is optimizer.. 
		if (phObj==null) {
			phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOutsAndInsFroms", hash);
			if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {
				console.log("super optimizer");
				return [];
			}
			if($bDOIDB==true) await ANNE.IDB.queryForOutsAndInsFroms(phObj, nids, $types);
		}
		
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;

		const LIMIT = 4000;
		
		var response = await this.apiSimpleQueryWithParams("queryForOutsAndInsFroms", {
				froms:nids, 
				type:$types, 
				height:lastBlock,
				limit:LIMIT,
				offset:$offset
			});

		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result.length) {
				$rels = $rels.concat(response.result);
			}

			//if we got max values, we need to go back in again and get the rest.
			if (response.result.length==LIMIT+$offset) {
				aRelons = await this.queryForOutsAndInsFroms($nids, $bMUSTPULL, $types, $offset+LIMIT, phObj, $bDOIDB, $rels);
			}
		}

		if (aRelons.length>0 && $offset==0) {
			await MEMP.processNeuronsFromRelons(aRelons, true, true, "relons", "API.queryForOutsAndInsFroms");
			await HISTORY.processResultsForNewPullHistory(aRelons, phObj);
			return aRelons;
		}

		return $rels;
	}

	/**
	 * This one does the entire BEM line for the outs (chasing up the parents and getting their outs too)
	 * @param {*} $nid 
	 * @param {*} $bMUSTPULL 
	 * @param {*} $types 
	 * @returns 
	 */
	queryForOutsAndIns_BEM = async($nid, $bMUSTPULL=false, $types=[0,1,2,3])=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOutsAndIns_BEM", $nid);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;
		if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {
			return [];
		}

		var nObj = MEMG.getNeuronByTempNid($nid);
		var bem_nids = nObj.getBemNids();
		if (bem_nids.length) {
			await ANNE.IDB.queryForOutsAndIns_BEM(phObj, $nid, $types);
		}

		if (ANNE.SETTINGS.debug()==true) console.log("(API.queryForOutsAndIns) with nid:"+$nid+" and lastBlock:"+lastBlock);
		var response = await this.apiSimpleQueryWithParams("queryForOutsAndIns_BEM", {
				from:$nid, 
				type:$types, 
				height:lastBlock
		});

		var aNewRelons = [];
		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result.length) {
				aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOutsAndIns_BEM");
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
				return aNewRelons;
			}
		}

		return [];
	}


	/**
	 * This one does the entire BEM line for the outs (chasing up the parents and getting their outs too)
	 * @param {*} $nid 
	 * @param {*} $bMUSTPULL 
	 * @param {*} $types 
	 * @returns 
	 */
	queryForOuts_BEM = async($nid, $bMUSTPULL=false, $types=[0,1,2,3])=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForOuts_BEM", $nid);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;
		if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {
			return [];
		}

		var nObj = MEMG.getNeuronByNid($nid);
		if (nObj==null) return [];
		
		var bem_nids = nObj.getBemNids();
		
		await ANNE.IDB.queryForOuts_BEM(phObj, bem_nids, $types);
		
		if (ANNE.SETTINGS.bCONSOLE_DEBUG==true)  console.log("(API.queryForOuts_BEM) with nid:"+$nid+" and lastBlock:"+lastBlock);
		var response = await this.apiSimpleQueryWithParams("queryForOuts_BEM", {
				from:$nid, 
				type:$types, 
				height:lastBlock
			});

		var aNewRelons = [];
		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result.length) {
				try {
					//ANNE.TALK.printRelons(response.result);
					aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForOuts_BEM");
				}
				catch(e) {
					console.log(e);
				}
				
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
				return aNewRelons;
			}
		}

		return [];
	}


	/**
	 * 
	 * @param {*} $last_id 
	 */
	getLatestMsgs = async($last_id)=> {
		console.log("getLatestMsgs");
		
		//piggy back this and send any error msg to help debugging
		//anytime we have logging on and we have errors.
		if (ANNE.SETTINGS && ANNE.SETTINGS.bSERVERSIDE_ERROR_LOGGING==true) {
			while(ANNE._errors_to_send.length) {
				var err = ANNE._errors_to_send.shift()
				//send via API to annode to store tx file in a folder.
	        	//scan connected peers for annode listed as "ANNODE JS DEBUG" flag set.
	        	//send data to them in p2p function.
	        	//their annode stores it, and puts it in a folder, and pings their gui.
	        	await ANNE.API.javscriptErrorReporting(err.message, err.source, err.lineno, err.colno, err.error);
			}
		}

		var response = await this.apiSimpleQueryWithParamsNS("getLatestMsgs", {
			last_id:$last_id
		});

		this.processBlockCycleMsgs(response);
	}


	/**
	 * graph explore neuron query
	 * Get all outs/ins other than awareness relons
	 */
	queryForCircuitOutsAndIns = async($nid, $bMUSTPULL=false)=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForCircuitOutsAndIns", $nid);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;
		if (phObj.bDONETHISSESSION==true && $bMUSTPULL==false) {
			return [];
		}
		
		var aRelonsAudit = await ANNE.IDB.queryForCircuitOutsAndIns(phObj, $nid);
		console.log(aRelonsAudit.length);
		
		console.log("(API.queryForCircuitOutsAndIns) with nid:"+$nid+" and lastBlock:"+lastBlock);
		var response = await this.apiSimpleQueryWithParams("queryForCircuitOutsAndIns", {
				from:$nid, 
				height:lastBlock
			});

		if (response.status=="good") {
			phObj.bDONETHISSESSION=true;
			if (response.result.length) {
				var aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForCircuitOutsAndIns");
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
				return aNewRelons;
			}
		}
		return [];
	}


	/**
	 */
	queryForLocationParts = async($aParts)=>{
		var response = await this.apiSimpleQueryWithParams("queryForLocationParts", {
			parts:$aParts
		});
		console.log(response);
		if (response.status=="good") {
			var relons_to_process = response.result;
			if (relons_to_process.length) {
				return await MEMP.processNeuronsFromRelons(relons_to_process, true, true, "relons", "API.queryForLocationParts");
			}
		}
		return [];
	}


	/**
	 * 
	 * @param {*} $text 
	 * @param {*} $be_nid 
	 * @param {*} $WVs 
	 * @param {*} $bMUSTPULL 
	 * @returns 
	 */
	queryForDate=async($text, $WVs=[], $bMUSTPULL=false)=>{
		console.log("(API.queryForDate) with text:"+$text);
		if (ANNE.UTILS.isset($text)==false) return [];
		var hash = ANNE.other.sha256($text+$WVs.join(""));
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForTextAndBe", hash);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;

		//if we have results for date, bail.
		//we're trying to resolve here only.
		var aRels = await ANNE.IDB.queryForTextAndBe(phObj, $text, MEM.date_gregorian.nid, $WVs);
		if (aRels.length>0) {
			return aNewRelons;
		}

		var response = await this.apiSimpleQueryWithParams("queryForTextAndBe", {
				text:$text, 
				class_nid:MEM.date_gregorian.nid, 
				wvs:$WVs,
				height:lastBlock
			});
		
		if (response.status=="good") {
			if (response.result.length) {
				var aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForDate");
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
			}
		}

		var dateNOBJ = await ANNE.MEMG.getDateNeuron($text);
		if (dateNOBJ!=null) {
			return dateNOBJ;
		}
		
		return null;
	}



	queryForMonthYear=async($text, $WVs=[], $bMUSTPULL=false)=>{
		console.log("(API.queryForMonthYear) with text:"+$text);
		if (ANNE.UTILS.isset($text)==false) return [];
		var hash = ANNE.other.sha256($text+$WVs.join(""));
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForMonthYear", hash);
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;

		//if we have results for date, bail.
		//we're trying to resolve here only.
		var aRels = await ANNE.IDB.queryForTextAndBe(phObj, $text, MEM.monthyear.nid, $WVs);
		if (aRels.length>0) {
			return aNewRelons;
		}

		var response = await this.apiSimpleQueryWithParams("queryForTextAndBe", {
				text:$text, 
				class_nid:MEM.monthyear.nid, 
				wvs:$WVs,
				height:lastBlock
			});
		
		if (response.status=="good") {
			if (response.result.length) {
				var aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForMonthYear");
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
			}
		}

		//will get dates or date parts.
		var dateNOBJ = await ANNE.MEMG.getDateNeuron($text);
		if (dateNOBJ!=null) {
			return dateNOBJ;
		}
		
		return null;
	}

	
	/** 
 	 * @param {string}
	 * @param {string} - nid long string of the be class
	 * @author Mr.Scatman
	*/
	queryForTextAndBe = async($text, $be_nid, $WVs=[], $bMUSTPULL=false)=> {
		console.log("(API.queryForTextAndBe) with text:"+$text);
		if (ANNE.UTILS.isset($text)==false) return [];

		var hash = ANNE.other.sha256($text+$be_nid+$WVs.join(""));
		
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForTextAndBe", hash);
		
		if ($bMUSTPULL==false) lastBlock = phObj.lastBlock;

		await ANNE.IDB.queryForTextAndBe(phObj, $text, $be_nid, $WVs);

		var response = await this.apiSimpleQueryWithParams("queryForTextAndBe", {
				text:$text, 
				class_nid:$be_nid, 
				wvs:$WVs,
				height:lastBlock
			});
		
		if (response.status=="good") {
			if (response.result.length) {
				var aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForTextAndBe");
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
				return aNewRelons;
			}
		}
		return [];
	}


	/**
	 * This returns the beline object of props .nid, .text, .be_nid, .owned_by and .sponsored_by 
	 * 
	 * Here we don't know where a possible match may fall in a be line that has multiple sub-classes.
	 * Primary use case here is for ec_action.   Actions will subclass and their parent and can be more than 2 levels deep.
	 * When a user is search for an existing actions we can't look for the simple parent because the parent may 
	 * be another action.  (and will not match)
	 * @param {*} $text 
	 * @param {*} $be_nid 
	 * @param {*} $WVs 
	 * @returns 
	 */
	queryForText_BEM = async($text, $class_nid, $wvs=[])=> {
		console.log("(API.queryForText_BEM) with text:"+$text);

		//do we need to do this here?
		//var hash = ANNE.other.sha256($text+$class_nid+$wvs.join(""));
		//var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForText_BEM", hash);
		//await ANNE.IDB.queryForText_BEM(phObj, $text, $class_nid, $wvs);
		
		var response = await this.apiSimpleQueryWithParams("queryForText_BEM", {
				text:$text, 
				class_nid:$class_nid, 
				wvs:$wvs
			});

		var beline_objs = [];
		if (response.status=="good") {
			beline_objs = response.result;
			if (beline_objs.length) {
				//if we do this again in any other function, we can build a processor function in the MEMP.
				for (var b=0; b < beline_objs.length; b++) {
					var bemObj = beline_objs[b];
					var nOBJ = MEMG.getNeuronByNid(bemObj.nid.trim());
					if (nOBJ==null) {
						var nOBJ = new anne_neuron(bemObj.text, parseInt(bemObj.ntype), bemObj.nid);
						if (bemObj.owned_by!="") {
							nOBJ.addOwnedBy(bemObj.owned_by);
						}
						if (bemObj.sponsored_by!="") {
							nOBJ.addSponsoredBy(bemObj.sponsored_by);
						}
					}
					else {
						nOBJ.text = bemObj.text;
						bemObj.ntype = parseInt(bemObj.ntype);
					}
				}
			}
		}
		return beline_objs;
	}


	//because i have a hard time remembering things.
	queryNidBasic = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	queryNeuron = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	lookupNeuron = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	getNeuronByNid = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	getNeuron = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	getNid = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	queryNid = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		return await this.lookupNid($nid, $types, $bDOPUBKEY);
	}
	

	/**
	 * Use to find get relons of to neurons a from neuron connects to.
	 * ie, service terms.
	 * @param {*} $nid 
	 * @param {*} $reln 
	 * @returns 
	 */
	getAllToNeuronRelonsGeneric = async($from_nid, $reln)=> {
		var fromNOBJ = ANNE.MEMG.getNeuronByNid($from_nid);
		var relnNOBJ = ANNE.MEMG.getNeuronByNid($reln);
		console.log("(getAllToNeuronRelonsGeneric) from "+fromNOBJ.text+" with reln:"+relnNOBJ.text);
		var response = await this.apiSimpleQueryWithParams("getAllToNeuronRelonsGeneric", {
			from_nid:$from_nid, 
			reln:$reln
		});
		if (response.status=="good" && response.result.length) {
			return await this.returnNOBJS(response.result, "relons", "API.getAllToNeuronRelonsGeneric");
		}
		return [];
	}

	getAllToNeuronRelonsGeneric2 = async($nids, $reln)=> {
		if ($nids.length==1) return await this.getAllToNeuronRelonsGeneric($nids[0], $reln);
		var response = await this.apiSimpleQueryWithParams("getAllToNeuronRelonsGeneric2", {
			nids:$nids, 
			reln:$reln
		});
		if (response.status=="good" && response.result.length) {
			return await this.returnNOBJS(response.result, "relons", "API.getAllToNeuronRelonsGeneric");
		}
		return [];
	}


	/**
	 * 
	 * @param {*} $reln 
	 * @param {*} $to_s 
	 * @returns 
	 */
	getAllFromNeuronRelonsGeneric = async($reln, $to_s)=> {
		if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("(API.getAllFromNeuronRelonsGeneric) with to_s:"+$to_s+" reln:"+$reln);
		var response = await this.apiSimpleQueryWithParams("getAllFromNeuronRelonsGeneric", {
			reln:$reln,
			to_nid:$to_s
		});

		if (response.status=="good" && response.result.length) {
			return await this.returnNOBJS(response.result, "relons", "API.getAllFromNeuronRelonsGeneric");
		}
		return [];
	}


	/**
	 * 
	 * @param {*} $relons 
	 * @param {*} $tbl 
	 * @param {*} $msg 
	 * @returns 
	 */
	returnNOBJS=async($relons, $tbl="relons", $msg="")=> {
		if ($relons==undefined || $relons==null || $relons.length==0) return [];
		var froms = [];
		for (var r=0; r < $relons.length; r++) {
			var rel = $relons[r];
			if (froms.indexOf(rel.from_nid)==-1) froms.push(rel.from_nid);
		}
		await MEMP.processNeuronsFromRelons($relons, true, true, $tbl, $msg);
		return ANNE.MEMG.getNObjsFromList(froms);
	}


	/**
	 * Process these ones as they come in..
	 * We can monitor if it is better to concat the relons and process into our local MEM in one batch
	 * or to do them as they come in the shards...
	 * @param {*} $to_nids 
	 * @returns 
	 */
	getAllInsToTheseNids = async($to_nids, $SHARD_SIZE=30)=> {
		if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) 
		var SHARD=$SHARD_SIZE;
		var handled_nids = [];
		var to_nids = [];

		console.log("(API.getAllInsToTheseNids) with $to_nids:"+$to_nids+" shard size:"+$SHARD_SIZE);
		console.time("getAllInsToTheseNids");

		//loop into shards to reduce strain on annode w/ too many nids in list search.
		for (var n=0; n<$to_nids.length; n++) {
			var nid = $to_nids[n];
			if (handled_nids.indexOf(nid)==-1) {
				handled_nids.push(nid);
				to_nids.push(nid);
			}
			else continue;

			if (to_nids.length==SHARD) {
				var response = await this.apiSimpleQueryWithParams("getAllInsToTheseNids", {
					to_nids:to_nids
				});
				if (response.status=="good" && response.result.length) {
					await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.getAllInsToTheseNids");
				}
				to_nids = [];
			}
		}

		//get any left overs that didn't hit a shard limit (the last bits)
		if (to_nids.length) {
			var response = await this.apiSimpleQueryWithParams("getAllFromNeuronRelonsGeneric", {
				to_nids:to_nids
			});
			if (response.status=="good" && response.result.length) {
				await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.getAllFromNeuronRelonsGeneric");
			}
			to_nids = [];
		}

		console.timeEnd("getAllFromNeuronRelonsGeneric");

		return;
	}



	/**
	 * Lookup a nid (neuron id) to get relons of types.	
	 * no height filter on this??? why??
	 * 
	 * @param {string} - The longstring of the neuron id.
	 * @param {array} - Array of types to filter to
	 */
	 lookupNid = async($nid, $types=[0,1,2], $bDOPUBKEY=false)=> {
		if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("(API.lookupNid) with nid:"+$nid);
		
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.lookupNid", $nid+$types.join(""));
		await ANNE.IDB.lookupNid(phObj, $nid, $types);

		var response = await this.apiSimpleQueryWithParams("lookupNid", {
			nid:$nid, 
			types:$types,
			dopubkey:$bDOPUBKEY
		});

		if (response.status=="good" && response.result.length) {
			return await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.lookupNid :"+$nid+" types:"+$types.join("/"));
		}

		return [];
	}


	/**
	 * 
	 * @param {*} $nids 
	 * @param {*} $types 
	 * @param {*} $sysMsgRelns 
	 * @returns 
	 */
	lookupForNidsAndSysMsgRelns = async($nids, $types=[0,1,2], $sysMsgRelns=[])=> {
		
		var hash = ANNE.other.sha256($nids+$types.join()+$sysMsgRelns.join(""));
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.lookupForNidsAndSysMsgRelns", hash);
		
		await ANNE.IDB.lookupForNidsAndSysMsgRelns(phObj, $nids, $types, $sysMsgRelns);
		
		var response = await this.apiSimpleQueryWithParams("lookupNidsAndSysMsgRelns", {nids:$nids, types:$types, relns:$sysMsgRelns});
		console.log(response);

		if (response.status=="good" && response.result.length>0) {
			return await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.lookupForNidsAndSysMsgRelns");
		}
		return [];
	}

	getNames =async($nids)=>{
		return this.lookupNids($nids, [0,1], true, false);
	}

	/**
	 * Lookup a list of ANNE Ids. 
	 * We have missing info and need to get the minimums to display a prop	
	 * or neuron.  If it is ever clicked on we will chase it out a bit more.
	 * Once this is done once, it
	 * will not need to be done again as long as
	 * the user has the data in their indexDB.
	 * @param {Array}
	 * @param {Array}
	 * @author Mr.Scatman								
	 */
	lookupNids = async($nids, $types=[0,1,2], $bDOQUERY=true, $bDOLOADER=true, $from="", $fixAfterIDB=false)=> {
		console.log("%clookupNids nid cnt:"+$nids.length+" %c"+$from, ANNE.TALK.funct, ANNE.TALK.bgred, ANNE.TALK.msg)
		const SHARD = 30;

		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.lookupNids", $nids.join("")+$types.join(""));
		
		await ANNE.IDB.lookupNids(phObj, $nids, $types);

		if ($bDOQUERY==true) {
			var nids = [];
			var rezRelons = [];
			for (var n=0; n < $nids.length; n++) {
				
				if ($fixAfterIDB==true) {
					var NOBJ = ANNE.MEMG.getNeuronByNid($nids[n]);
					if (NOBJ.text!="" && NOBJ.bes.length>0) continue;
				}
				
				nids.push($nids[n]);	
				if (nids.length==SHARD) {
					var response = await this.apiSimpleQueryWithParams("lookupNids", {nids:nids, types:$types});
					if (response.status=="good" && response.result.length) {
						if (rezRelons.length==0) rezRelons = response.result;
						else rezRelons = rezRelons.concat(response.result);
					}
					nids = [];
				}
			}

			if (nids.length) {
				var response = await this.apiSimpleQueryWithParams("lookupNids", {nids:nids, types:$types}, $bDOLOADER);
				if (response.status=="good" && response.result.length) {
					if (rezRelons.length==0) rezRelons = response.result;
					else rezRelons = rezRelons.concat(response.result);
				}
				nids = [];
			}
			
			if (rezRelons.length) {
				return await MEMP.processNeuronsFromRelons(rezRelons, true, true, "relons", "API.lookupNids");
			}	
		}

		return [];
	}



	/**
	 * limit is a node param used with the offset. (where did it go?  LOLZ) 
	 * @param {*} $nids 
	 * @param {*} $offset 
	 * @returns 
	 */
	lookupNidsGetAllOuts = async($nids, $offset=0, $bDOIDB=true)=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.lookupNidsGetAllOuts ", $nids);
		lastBlock = phObj.lastBlock;
	
		//we get them all on offset=0
		if ($offset==0 && $bDOIDB==true) {
			await ANNE.IDB.lookupNidsGetAllOuts(phObj, $nids);
		}
		
		var response = await this.apiSimpleQueryWithParams("lookupNidsGetAllOuts", {
			nids:$nids,
			height:lastBlock,
			offset:$offset
		});
		
		if (response.status=="good") {
			if (response.result.length) {
				var aNewRelons = await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.lookupNidsGetAllOuts");
				await HISTORY.processResultsForNewPullHistory(aNewRelons, phObj);
				return aNewRelons;
			}
		}
	}


	/**
	 * lookup max 30 txids at a time.
	 */
	lookupTxids = async ($txids)=> {

		await IDB.lookupTxids($txids);
		
		var txids = [];
		var shard=100;	//is this too big?  (100 * int(20)+ a few extras?)
		var results = [];
		for (var t=0; t < $txids.length; t++) {
			txids.push($txids[t]);
			if (txids.length==shard) {
				var response = await this.apiSimpleQueryWithParams("lookupTxids", 
					{
						txids:txids
					});
				if (response.status=="good") {
					results = results.concat(response.result);
				}
				txids=[];
			}
		}

		//left overs
		if (txids.length>0) {
			var response = await this.apiSimpleQueryWithParams("lookupTxids", 
				{
					txids:txids
				});
			if (response.status=="good") {
				results = results.concat(response.result);
			}
			txids=[];
		}

		var aRelons = [];
		if (results.length) {
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.lookupTxids");
		}
		return aRelons;					
	}
	

	/**
	 * 
	 * @param {*} $nids 
	 * @param {*} $types 
	 * @param {*} $relns 
	 * @param {*} $height 
	 * @returns 
	 */
	participantChase = async($nids, $types=[0,1,2], $relns=[], $height=0)=> {
		var response = await this.apiSimpleQueryWithParams("participantChase", {nids:$nids, types:$types, relns:$relns, height:$height});
		var aRelons = [];
		if (response.status=="good") {
			var results = response.result;
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.participantChase");
		}
		return aRelons;
	}


	javscriptErrorReporting = async($message, $source, $lineno, $colno, $error)=> {
		var response = await this.apiSimpleQueryWithParams("javscriptErrorReporting", 
			{
				message:$message, 
				source:$source, 
				lineno:$lineno, 
				colno:$colno,
				error:$error
			});
		console.log(response);
		return;
	}

		
	/**
	 * NOTE: not in use yet in the EXT.
	 * 
	 * Query for delete
	 * Do a super query on every spot we see this in from, reln, to.
	 * This helps us understand the impact of a delete (necrosis).
	 * 
	 * @param {string} - nid we want to potentially dlete
	 * @author Mr.Scatman							
	 */
	 queryForDelete = async($nid)=> {
		var lastBlock = 0;
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForDelete ", $nid);
		lastBlock = phObj.lastBlock;
		var response = await this.apiSimpleQueryWithParams("queryForDelete", {nid:$nid, height:lastBlock});

		if (response.status=="good") {
			var results = response.result;
			aRelons = await MEMP.processNeuronsFromRelons(results, true, true, "relons", "API.queryForDelete");
		}
		return aRelons;
	}


	/**			
	 * @param {int}
	 * @param {string}
	 * @param {string}
	 * @param {int} 
	 * @param {int}
	 * 
	 * @author Mr.Scatman								
	 */
	 queryForInsWithTo = async($type, $reln, $to, $to_type, $offset=0)=> {
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.queryForInsWithTo ", ANNE.other.sha256($type+$reln+$to+$to_type+$offset));
		var lastBlock = phObj.lastBlock;
		
		if ($offset==0) {
			await ANNE.IDB.queryForInsWithTo(phObj, $type, $reln, $to, $to_type);
		}
		
		var response = await this.apiSimpleQueryWithParams("queryForInsWithTo", 
			{
				type:$type, 
				reln:$reln,
				to:$to,
				to_type:$to_type,
				offset:$offset,
				height:lastBlock

			});
		
		if (response.status=="good") {
			if (aRelons.length) {
				return await MEMP.processNeuronsFromRelons(response.result, true, true, "relons", "API.queryForInsWithTo");
			}
		}
		return [];
	}


	/**
	 * Delete an lnot.
	 * We must prove who we are to the ANNODE in order for the ANNODE to honor our request.
	 * @param {*} $txid 
	 */
	deleteLNOT=async($txid, $el_error=null)=> {
		var encrypted_msg = ANNE.USER.genGeneralProveIt($txid);
		console.log(encrypted_msg);
		var response = await this.apiSimpleQueryWithParams("sendMsgForSesh", {
			claimed_sender_nid:USER._userNObj.nid,
			encrypted_msg:encrypted_msg
		});
		console.log(response);
		if (response.status=="good") {
			var next_proof_id = response.next_proof_id;
			if (next_proof_id && next_proof_id!=-1) {
				await this.updateAndSaveNextProofId(next_proof_id);
			}
			return;
        }
		else {
			if (response.reason!=undefined) {
				console.log("%c "+response.reason, TALK.bgbigred);
				if ($el_error!=null) ANNE.A.setHTML($el_error, response.reason);
			}
			else if ($el_error!=null) ANNE.A.setHTML($el_error, "unknown error");
			return [];
		}
	}

	//***************************************************** */
	/////////////////  ANNODE SPECIFIC ACHAT /////////////////
	//***************************************************** */

	/**
	 * Send an ACHAT message.
	 * @param {*} $msg 
	 * @param {*} $sesh_id 
	 * @param {*} $min_msg_id 
	 * @param {*} $el_error 
	 * @param {*} $bREFRESHONFAIL 
	 * @returns 
	 */
	 sendACHATMsgForSeshId=async($msg, $sesh_id, $min_msg_id, $el_error=null, $bREFRESHONFAIL=true)=>{
		console.log("chat msg to encrypt:"+$msg);
		if ($msg=="") return;
		var encrypted_msg = await ANNE.USER.genACHATProveIt([$msg], $sesh_id);
		console.log(encrypted_msg);
		var response = await this.apiSimpleQueryWithParams("sendMsgForSesh", {
			claimed_sender_nid:USER._userNObj.nid,
			encrypted_msg:encrypted_msg,
			sesh_id:$sesh_id,
			min_msg_id:$min_msg_id
		});
		console.log(response);
		if (response.status=="good") {
			var next_proof_id = response.next_proof_id;
			if (next_proof_id && next_proof_id!=-1) {
				await this.updateAndSaveNextProofId(next_proof_id);
			}
			else {
				if ($bREFRESHONFAIL==true) {
					var ok  = await USER.refreshAAUTH(USER.seedObj.seed, USER._userLS);
					return await ANNE.API.getACHATMsgsForSeshId($sesh_id, $min_msg_id, $el_error, false);
				}
			}
			var chatmsgs = response.result;
			return chatmsgs;
        }
		else {
			if (response.reason!=undefined) {
				console.log("%c "+response.reason, TALK.bgbigred);
				if ($el_error!=null) ANNE.A.setHTML($el_error, response.reason);
			}
			else if ($el_error!=null) ANNE.A.setHTML($el_error, "unknown error");
			return [];
		}
	}


	/**
	 * Get ACHAT messages for a chat sesionId.
	 * @param {*} $sesh_id 
	 * @param {*} $min_msg_id 
	 * @param {*} $el_error 
	 * @param {*} $bREFRESHONFAIL 
	 * @returns 
	 */
	getACHATMsgsForSeshId=async($sesh_id, $min_msg_id, $el_error=null, $bREFRESHONFAIL=true)=>{
		var encrypted_msg = await ANNE.USER.genACHATProveIt(null);
		console.log(encrypted_msg);
		var response = await this.apiSimpleQueryWithParams("getMsgsForSesh", {
			claimed_sender_nid:USER._userNObj.nid,
			encrypted_msg:encrypted_msg,
			sesh_id:$sesh_id,
			min_msg_id:$min_msg_id
		});
		console.log(response);
		if (response.status=="good") {
			var next_proof_id = response.next_proof_id;
			if (next_proof_id && next_proof_id!=-1) {
				await this.updateAndSaveNextProofId(next_proof_id);
			}
			else {
				if ($bREFRESHONFAIL==true) {
					await USER.refreshAAUTH(USER.seedObj.seed, USER._userLS);
					return await ANNE.API.getACHATMsgsForSeshId($sesh_id, $min_msg_id, $el_error, false);
				}
			}
			var chatmsgs = response.result;
			return chatmsgs;
        }
		else {
			if (response.reason!=undefined) {
				console.log("%c "+response.reason, TALK.bgbigred);
				if ($el_error!=null) ANNE.A.setHTML($el_error, response.reason, true);
			}
			else if ($el_error!=null) ANNE.A.setHTML($el_error, "unknown error", true);
			return [];
		}
	}


	/**
	 * We need to do the proveIt in order to get the ACHATs since this is
     * **NOT** A transaction and we do not want other users to be able to 
     * get our ACHAT logs even when they are encrypted.  It potentially poses a shared_key
     * security risk by allowing multiple encrypted strings to be viewed.   It still 
	 * would likely be fine but this is how I'd prefer to do it.
	 * 
	 * @author Mr.Scatman
	 */
	getACHATSessions = async($bREFRESHONFAIL=true, $el_error=null)=>{
		var phObj = HISTORY.getLastBlockFromPullHistory("ANNODE", "API.getACHATSessions");
		var lastBlock = 0;//phObj.lastBlock;  optimize
		
		//no extra message in this one.
		var encrypted_msg = await ANNE.USER.genACHATProveIt(null);
		if (encrypted_msg.length==0) return [];
		var response = await this.apiSimpleQueryWithParams("getAChatSessions", {
			claimed_sender_nid:USER._userNObj.nid,
			encrypted_msg:encrypted_msg,
			height:lastBlock
		});

		//response contains our next proof id which is crucial
		//to store in mem.  If we don't have it we will need to do a 
		//refresh AUUTH using our real ANNE KEY.
		if (response.status=="good") {
			var next_proof_id = response.next_proof_id;
			
			//this updates saved cookie LS too
			if (next_proof_id && next_proof_id!=-1) {
				await this.updateAndSaveNextProofId(next_proof_id);

				//update the local_history with the latest block. 
				//in this function we get the "height" returned in the api result.
				//This is done in HISTORY LOCAL as it is a non-standard data save for this pull.
				//when ghosts are reset we want this pull history to reset, else we can't get the data again.
				await HISTORY_LOCAL.manuallyUpdatePullHistory(phObj, this._GREATEST_LAST_KNOWN_BLOCK);
			}

			//we could have had the wrong next_proof_id.
			//try to refresh the AAUTH and give er' one more go.
			else {
				if ($bREFRESHONFAIL==true) {

					//make sure we have the most up to date next id.
					var ok  = await USER.refreshAAUTH(USER.seedObj.seed, USER._userLS);
	
					return await ANNE.API.getACHATSessions(false);
				}
			}

			var sessions = response.result;
			return sessions;
        }

		else {
			if (response.reason!=undefined) {
				console.log("%c "+response.reason, TALK.bgbigred);
				if ($el_error!=null) ANNE.A.setHTML($el_error, response.reason);
			}
			else if ($el_error!=null) ANNE.A.setHTML($el_error, "unknown error");
			return [];
		}
	}
	

	/**
	 * TODO: get this to work after timeouts or disconnects.
	 * 
	 * Get life info from node.
	 * 
	 * We will use this when we get to registering public ANNODES which are 
	 * competing for public use and service fees.
	 * 
	 * Client-side apps will ping the registry of ANNODES to see if the one they
	 * want to handshake with is alive.
	 */
	ping = async($node_uri_override="")=> {
		try {
			var response = await this.query("ping", null, $node_uri_override);
			if (response.status!=undefined && response.status!="good") {
				console.log(response);
			}
			return response;
		} 
		catch (e) {
			console.log('node not alive', e);
			return {status:"fail", reason:e};
		}
	}


	/**
	 * A willy-wonka CORS workaround, but hey, I like chocolate.  (actually, I don't)
	 * @param {*} $formatted_name 
	 * @returns 
	 */
	avoidCorsWIKISPOOKS = async($formatted_name="")=> {
		if ($formatted_name=="" || $formatted_name.indexOf(" ")!==-1) {
			return {status:"fail", reason:"must provide a wikispooks formatted name"};
		}
		try {
			var response = await this.apiSimpleQueryWithParams("avoidCorsWIKISPOOKS", {formatted_name:$formatted_name});
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}
	

	/**
	 * 
	 * @param {*} $formatted_name 
	 * @returns 
	 */
	avoidCorsDBPEDIA = async($formatted_name="")=> {
		if ($formatted_name=="" || $formatted_name.indexOf(" ")!==-1) {
			return {status:"fail", reason:"must provide a dbpedia formatted name"};
		}
		try {
			var response = await this.apiSimpleQueryWithParams("avoidCorsDBPEDIA", {formatted_name:$formatted_name});
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}


	/**
	 * 
	 * @param {*} $relative 
	 * @returns 
	 */
	loadLocalOnlyFile=async($relative)=> {
		let FILERESP =  await fetch($relative).catch(function($e){
			console.log("error:"+$e);
			return;
		});
		//console.log(FILERESP);
		if (FILERESP==undefined) return null; 
		let blob = await FILERESP.blob();
		var response = {};
		response.mimetype2 = blob.type;
		
		return new Promise((resolve, reject) => {
			let reader = new FileReader();
			reader.onloadend = function() {
				let b64data = reader.result;
				response.b64data = b64data;
				return resolve(response);
			};
			reader.readAsDataURL(blob);
		});
	}


	/**
	 * Extract actual src from page..
	 * get image.. store on annode, for later upgrade to real folder.
	 * @param {*} $url 
	 * @param {*} $ext
	 * @param {*} $baseurl  
	 * @param {*} $elid 
	 * @returns 
	 */
	getAndCacheFileFromElement = async($url, $ext, $baseurl="", $elid="")=>{
		if ($url=="") {
			return {status:"fail", reason:"must provide a url"};
		}
		$url = $url.replaceAll(" ", "_");
		try {
			var response = await this.apiSimpleQueryWithParams("getAndCacheFileFromElement",
						 {url:$url, ext:$ext, baseurl:$baseurl, elid:$elid});
			
			if (response.status=="good" && response.finger!=undefined) {
				
				//the files are in the html/ui/  a2a_cache... || a2a_neurons...  
				//let's go get it directly from our folder.
				var relativepath = response.relativepath;
				let FILERESP =  await fetch(relativepath+"/"+response.filename).catch(function($e){
					console.log("error:"+e);
					return;
				}
				);
		
				if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log(FILERESP);
				if (FILERESP==undefined) return response; 
				
				let blob = await FILERESP.blob();
				response.mimetype2 = blob.type;

				return new Promise((resolve, reject) => {
					let reader = new FileReader();
					reader.onloadend = function() {
						let b64data = reader.result;
						response.b64data = b64data;
						return resolve(response);
					};
					reader.readAsDataURL(blob);
				});
				
			}
			else {
				console.log("bad??  why?");
				console.log(response);
				return response;
			}
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}


	/**
	 * Cache file, where??  On the ANNODE?
	 * @param {*} $url 
	 * @param {*} $ext 
	 * @param {*} $nid 
	 * @returns 
	 */
	getAndANNODECacheTheFile = async($url, $ext="", $nid="")=>{
		if ($url=="") {
			return {status:"fail", reason:"must provide a url"};
		}
		try {
			var response = await this.apiSimpleQueryWithParams("getAndCacheFile", {url:$url, ext:$ext, nid:$nid});
			if (response.status=="good" && response.finger!=undefined) {
				
				//the files are in the html/ui/  a2a_cache... || a2a_neurons...  
				//let's go get it directly from our folder.
				var relativepath = response.relativepath;
				let FILERESP =  await fetch(relativepath+"/"+response.filename).catch(function($e){
					console.log("error:"+e);
					return;
				}
				);
		
				//console.log(FILERESP);
				if (FILERESP==undefined) return response; 
				
				let blob = await FILERESP.blob();
				response.mimetype2 = blob.type;
				//if (response.mimetype2!="image/jpeg") {
					//console.log("%cTEST we found a non-jpeg mimetype "+response.mimetype2, ANNE.TALK.bgbigred);
				//}
				return new Promise((resolve, reject) => {
					let reader = new FileReader();
					reader.onloadend = function() {
						let b64data = reader.result;
						response.b64data = b64data;
						return resolve(response);
					};
					reader.readAsDataURL(blob);
				});
				
			}
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}
	

	avoidCorsWikimediaImg = async($name="bill_clinton.png", $width=200)=> {
		if ($name=="") {
			return {status:"fail", reason:"must provide a wikimedia name"};
		}
		try {
			var response = await this.apiSimpleQueryWithParams("avoidCorsWikimediaImg", {img_name:$name, img_width:$width});
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}
	

	/**
	 * 
	 * @param {*} $txid 
	 * @param {*} $nid 
	 * @param {*} $type 
	 * @param {*} $reln 
	 * @param {*} $to_type 
	 * @param {*} $to_s 
	 * @returns 
	 */
	saveLocalRelon = async($txid, $nid, $type, $reln, $to_type, $to_s)=> {
		if ($txid=="" || $nid=="" || $type=="" || $reln=="" || $to_type=="" || $to_s=="") {
			return;
		}
		try {
			var response = await this.apiSimpleQueryWithParams("saveLocalRelon", 
				{txid:$txid, from:$nid, type:$type, reln:$reln, to_type:$to_type, to:$to_s});
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}


	/**
	 * 
	 * @returns 
	 */
	getPrivateFolderAbsolute = async()=>{
		try {
			var response = await this.apiSimpleQueryWithParams("getPrivateFolderAbsolute");
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}



	/**
	 * 
	 * @param {*} $nid 
	 * @param {*} $b64data 
	 * @param {*} $ext 
	 * @returns 
	 */
	sendB64Data = async($nid, $b64data, $ext)=> {
		try {
			var response = await this.apiSimpleQueryWithParams("sendB64Data", 
					{nid:$nid, b64data:$b64data, ext:$ext});
			return response;
		} 
		catch (e) {
			return {status:"fail", reason:e};
		}
	}
}
