class semantic_role_part {
    constructor($arr, $pre_text="", $post_text="") {
        this.arr = $arr;
        this.pre_clues = $pre_text;
        this.post_test = $post_text;
        this.target_role = null;
        this.extras = [];

        this.original_text = "";

        this.remaining = "";
    }
    setTargetRole=function($target_role) {
        this.target_role = $target_role;
    }
    
}

var WIKIDATA = {};

//tribal (now downgraded to ETHNICITY/HERITAGE, to be accurate) 
//jewish data is in the "Early Life" section of wikipedia.
//Add to this to grab other variables in early life 
//and in any other known sections.
WIKIDATA.tribal = [{kw:"Jewish", prop:"eheritage"},
                   {kw:"Jewish father", kw2:"Jewish", prop:"eheritage"},
                   {kw:"Jewish mother", kw2:"Jewish", prop:"eheritage"},
                   {kw:"Jewish family", kw2:"Jewish", prop:"eheritage"},
                   {kw:"Hungarian Jew", kw2:"Jewish", prop:"eheritage"},
                   {kw:"[[Jew]]ish", kw2:"Jewish", prop:"eheritage"},
                   {kw:"Cajun", kw2:"Cajun", prop:"eheritage"},
                   {kw:"Brazilian", kw2:"Brazilian", prop:"eheritage"},
                   {kw:"Canadian", kw2:"Canadian", prop:"eheritage"},
                ];

WIKIDATA.school = [{kw:"college preparatory", prep:"school_type"},
                {kw:"boarding school", prop:"school_type"}];

WIKIDATA._type_person = ["judge", "scientist", "comedian", "martial artist", 
                            "officeholder", "person", "musical artist", "royalty"];
                            
WIKIDATA._type_person_partials = ["biography"];

WIKIDATA._type_company = ["central bank", "corporation", "company", "institution", "university", "school", "legislature"];

WIKIDATA._type_service = ["website", "service"];

WIKIDATA._type_group = ["militant organization"];

WIKIDATA._type_date = ["births", "deaths", "events"];

WIKIDATA._type_street = ["street", "lane", "avenue", "boulevard", "route", "highway", "interstate"];

WIKIDATA._type_location = ["settlement", "building"];

WIKIDATA._type_concept = ["examination"]; //like bachelor of arts (BA)

WIKIDATA._subtype_location_site = ["building"];
WIKIDATA._subtype_location_geosite = ["river", "mountain", "lake", "valley", "peak", "ocean", "plateau"];


WIKIDATA.findPage=function($pages, $text) {
    var text = $text.toLowerCase();
    //clean pages are odd pages (evens are bracketed)
    for (var p=1; p < $pages.length; p+=2) {
        var page = $pages[p].toLowerCase();
        if (page.indexOf(text)!=-1) {
            return $pages[p].replace(" ", "_");
        }
    }
    return null;
}


/**
 * willy wonka process  to extract info from the api tha extracted info.
 */
WIKIDATA.extractDisambig=function($doc, $txt){
    var _sections = $doc._sections;
    if (_sections==null) return null;
    var dpages = [];

    var dateScore = 0;
    
    for (var s=0; s < _sections.length; s++) {
        var wikistring = _sections[s]._wiki;

        var title = _sections[s]._title;
        if (WIKIDATA._type_date.indexOf(title.toLowerCase())!=-1) {
            dateScore+=1;
        }
        
        //this is just extracting all page references from a section.
        var regExp = /\[\[(.*?)\]\]/g
        var matches = [...wikistring.matchAll(regExp)].flat();
        for (var m=0; m < matches.length; m++) {
            //if (((m+10) % 2)==0) continue;
            dpages.push(matches[m]);
        }
    }
    return {pages:dpages, search:$txt, dateScore:dateScore, status:"disambig"};
}


/**
 * get all the pages in category.
 */
WIKIDATA.categoryChaser=async()=>{
    var pages = await WIKIDATA.getPagesOfCategory();
}


//this is kind of lovely.  (thanks WTF!)
WIKIDATA.getPagesOfCategory=async($cat="Category:21st-century American judges")=>{
    wtf.plugin(window.wtfApi);
    let result = await wtf.getCategoryPages($cat);
    return result;
}

WIKIDATA.isSurname = function($json) {
    var cat = $json.categories;   
    for (var c=0; c < cat.length; c++) {
        var ca = cat[c].toLowerCase();
        if (ca.indexOf("surnames of")!=-1) {
            return true;
        }
    }
    return false;
}


WIKIDATA.exploreType=async($txt, $aec=null, $pageid=null)=> {
    var printToBest = function(...$args) {
        if ($aec==null) return;
        $aec.printf(...$args);
    }

    return new Promise((resolve, reject) => {//BillyBobThortonExpress
        var formatted = null;
        if (typeof $txt=="string") formatted = $txt.replaceAll(" ", "_");
        else if (Array.isArray($txt)==true) formatted = $txt; //leave is as an array.. sb. pageid
        wtf.plugin(window.wtfApi);
        
        //et docs = wtf.fetch(['Whistling', 2983], { follow_redirects: false })

        wtf.fetch(formatted, {'Api-User-Agent': 'BillyBobThortonExpress'}, async(err, doc)=> {
            printToBest(_CYAN, "exploreType for", _GREEN, $txt);
            console.log(doc);
            if (doc==undefined || doc==null || err!=null) {
                return resolve({status:"bad"});
            }

            var infobox=doc.infobox();
            console.log(infobox);

            var json = doc.json();
            console.log(json);

            var _type = "";
            var subtype = "";

            if (infobox==undefined || infobox==null) {
                if (json.description=="Surname list") {
                    printToBest(_CYAN, "surname list received");
                    await WIKIDATA.preProcessNameCategories(json);
                    var allData = {};
                    allData.status = "good";
                    allData.intended_type = "";
                    allData.wiki_type = "name";
                    allData.wiki_type_conformed = "name";
                    allData.search_text = $txt;
                    allData.infobox = null;
                    allData.doc = doc;
                    allData.json = json;
                    allData.searchObj = UTILS.fixHack($txt, " ");
                    allData.status="success";
                    allData.result_type="result";
                    allData.subtype = subtype;
                    return resolve(allData);
                }

                var dataObj = WIKIDATA.extractDisambig(doc, $txt);
                console.log(dataObj);

                if (dataObj!=null) {
                    if (dataObj.dateScore>=3) {
                        printToBest(_CYAN, "likely date");
                        return resolve({status:"good", wiki_type_conformed:"date", type:"date", subtype:subtype});
                    }
                        
                    else if (WIKIDATA._type_street.indexOf($txt.toLowerCase())!=-1) {
                        if ($txt.length<50) {
                            printToBest(_CYAN, "likely roadway");
                            subtype = "roadway";
                            return resolve({status:"good", wiki_type_conformed:"site", type:"", subtype:subtype});
                        }

                        ///too lazy to write the address detector
                        else {
                            dataObj.status="bad";
                            return resolve(dataObj);
                        } 
                    }
                        
                    else if (dataObj.status=="disambig") {
                        return resolve(dataObj);
                    }
                    
                    dataObj.status="bad";
                    return resolve(dataObj);
                }

                else return resolve(null);

            }

            console.log("%c type: "+infobox._type, TALK.bgblackgreen);
            printToBest("wikitype for",_GREEN, $txt,_CYAN, infobox._type);

            _type = infobox._type;

            //build this out as needed.
            //we can use this to go lookup type quickly.
            if (WIKIDATA._type_company.indexOf(_type)!=-1) {
                printToBest("process",_GREEN,$txt,_WHITE,"as",_CYAN,"ANNE company class");
                return resolve({status:"good", wiki_type_conformed:"company", type:_type, subtype:subtype});
            }
            else if (WIKIDATA._type_person.indexOf(_type)!=-1) {
                printToBest("process",_GREEN,$txt,_WHITE,"as",_CYAN, "ANNE person class");
                return resolve({status:"good", wiki_type_conformed:"person", type:_type, subtype:subtype});
            }
            else if (WIKIDATA._type_location.indexOf(_type)!=-1) {
                printToBest("process",_GREEN,$txt,_WHITE,"as",_CYAN, "ANNE location class");
                if (WIKIDATA._subtype_location_site.indexOf(_type)!=-1) {
                    subtype = "site";
                }
                else if (WIKIDATA._subtype_location_geosite.indexOf(_type)!=-1) {
                    subtype = "geosite";
                }
                return resolve({status:"good", wiki_type_conformed:"location", type:_type, subtype:subtype});
            }
            
            else if (WIKIDATA._type_service.indexOf(_type)!=-1) {
                printToBest("process",_GREEN,$txt,_WHITE,"as",_CYAN, "ANNE service class");
                return resolve({status:"good", wiki_type_conformed:"service", type:_type, subtype:subtype});
            }
                
            else if (_type=="surname") {
                 return resolve({status:"good", wiki_type_conformed:"name", type:"name", subtype:subtype});
            }

            else if (WIKIDATA._type_concept.indexOf(_type)!=-1) {
                return resolve({status:"good", wiki_type_conformed:"concept", type:"concept", subtype:subtype});
            }
            
            else {
                console.log("unmapped wikitype "+_type+"thus far -- get desperate.");
            }
            
            //tennis biography.. etc.. 
            for (var p=0; p < WIKIDATA._type_person_partials.length; p++) {
                if (_type.indexOf(WIKIDATA._type_person_partials[p])!=-1) {
                    printToBest("process",_GREEN,$txt,_WHITE,"as",_CYAN,"ANNE person class");
                    return resolve({status:"good", wiki_type_conformed:"person", type:_type, subtype:subtype});
                }
            }

            //unknown conformed type (need more mappings)
            printToBest("unknown ANNE type for wikitype",_CYAN, _type);
            return resolve({status:"good", wiki_type_conformed:"", type:_type, subtype:subtype});
        });
    });
}


/**
 * 
 * @param {*} $doc 
 * @param {*} $json 
 * @param {*} $txt 
 * @param {*} $intended_type
 * @param {*} $printToBest 
 * @returns 
 */
WIKIDATA.handleNoInfoBox=async($doc, $json, $txt, $intended_type, $printToBest)=> {
    if ($json.description=="Surname list") {
        $printToBest(_CYAN, "surname list received");
        await WIKIDATA.preProcessNameCategories($json);
        var allData = {};
        allData.status = "good";
        allData.intended_type = $intended_type;
        allData.wiki_type = "name";
        allData.wiki_type_conformed = "name";
        allData.search_text = $txt;
        allData.infobox = null;
        allData.doc = $doc;
        allData.json = $json;
        allData.searchObj = UTILS.fixHack($txt, " ");
        allData.status="success";
        allData.result_type="result";
        return allData;
    }

    else if ($json.description!=undefined && $doc._type!=undefined && $json.title!=undefined 
            && $txt.replaceAll("_"," ").indexOf($json.title)!=-1) {
        var allData = {};
        allData.intended_type = $intended_type;
        allData.wiki_type = WIKIDATA.checkSentenceOne($json);
        allData.wiki_type_conformed = allData.wiki_type;
        allData.search_text = $txt;
        allData.doc = $doc;
        allData.json = $json;
        allData.infobox = null; //need to somehow get this from doc.
        allData.searchObj = UTILS.fixHack($txt, " ");
        return allData;
    }

    var dataObj = WIKIDATA.extractDisambig($doc, $txt);
    console.log(dataObj);
    if (dataObj!=null) {
        if (dataObj.dateScore>=3) {
            $printToBest(_CYAN, "likely date");
            var allData = {};
            allData.intended_type = $intended_type;
            allData.wiki_type = "";
            allData.wiki_type_conformed = "date";
            allData.search_text = $txt;
            allData.doc = $doc;
            allData.json = $json;
            allData.infobox = null; //need to somehow get this from doc.
            allData.searchObj = UTILS.fixHack($txt, " ");
            return allData;
        }

        else if (WIKIDATA._type_street.indexOf($txt.toLowerCase())!=-1) {
            var allData = {};
            allData.intended_type = $intended_type;
            allData.wiki_type = "";
            allData.wiki_type_conformed = "site";   //a street/road/highway etc
            allData.search_text = $txt;
            allData.doc = $doc;
            allData.json = $json;
            allData.infobox = null; //need to somehow get this from doc.
            allData.searchObj = UTILS.fixHack($txt, " ");
            return allData;
        }

        dataObj.status="need_info";
        dataObj.result_type = "disambig";
        $printToBest(_CYAN, "ambiguous results, need info");
        return dataObj;
    }
    return null;
}


/**
 * https://en.wikipedia.org/?curid=35894626  -- getting by page id.
 * @param {*} $txt 
 * @param {*} $intended_type 
 * @param {*} $printf
 * @param {*} $pageidnumber - optional if we have it, and is better for disambiguation. 
 */
WIKIDATA.getExternalWikiData=function($txt, $intended_type="", $aec=null, $pageidnumber=null) {

    var printToBest = function(...$args) {
        if ($aec==null) return;
        $aec.printf(...$args);
    }

    return new Promise((resolve, reject) => {
        wtf.plugin(window.wtfApi);

        //var formatted = null;
        //if (typeof $txt=="string") formatted = $txt.replaceAll(" ", "_");
        //else if (Array.isArray($txt)==true) formatted = $txt; //leave is as an array.. sb. pageid

        var val = null;
        var msg = "";

        if ($pageidnumber!=null) {
            val = $pageidnumber;
            msg = "wiki pageid "+val;
        }
        else {
            val = $txt;
            msg = val;
        }

        wtf.fetch(val,{'Api-User-Agent': 'BillyBobThortonExpress'}, async(err,doc)=> {
            if ($intended_type!="") printToBest("fetched wikidata for wiki type",_CYAN, $intended_type, _GREEN, $txt);
            else printToBest("fetched wikidata for", _GREEN, msg);

            if (doc==undefined || doc==null || err!=null) {
                printToBest(_RED, "ERROR -- no wikidocument for", _CYAN, msg);
                return resolve(null);
            }
            
            var infobox=doc.infobox();
            var json = doc.json();
            console.log(doc);
            console.log(infobox);
            console.log(json);

            if (doc!=null) {
                WIKIDATA.extractImgs(doc, json);
            }

            //exit here with no infobox.
            if (infobox==undefined || infobox==null) {
                var rez = await WIKIDATA.handleNoInfoBox(doc, json, $txt, $intended_type, printToBest);
                return resolve(rez);
            }
            
            var _type = infobox._type;
            var allData = {};
            allData.intended_type = $intended_type;
            allData.wiki_type = _type;
            allData.wiki_type_conformed = "";
            allData.search_text = $txt;
            allData.infobox = infobox;
            allData.doc = doc;
            allData.json = json;
            allData.searchObj = UTILS.fixHack($txt, " ");
            
            
            //allData.incoming_links = await doc.getIncoming();
            //console.log(allData.incoming_links);

            //TODO:
            //find a references to all the page types and code them to our main neurons classes this app uses of: 
            //company, person, location, religion, political party, company type, group, group event,
            //date, month-year, integer, action (conveyor) and events. (clumps)

            //build this out to handle props for specifc things we want based on what the
            //wtf_wikipedia external js provides us.
            
            if (WIKIDATA._type_person.indexOf(_type)!=-1) {
                allData.wiki_type_conformed="person";
                if ($intended_type!="person" && $intended_type!="unk") {
                    printToBest(_RED,"ERRROR",_WHITE,"person not found, try the person form for people.");
                    return resolve({status:"error", error_msg:"try the person form for people"});
                }

                this.nameFix(infobox, doc, $txt, printToBest);
                this.addedPropsFromSection(infobox, doc, WIKIDATA.tribal, "Early Life", printToBest);
                this.addedPropsFromSection(infobox, doc, WIKIDATA.tribal, "Life and career", printToBest);
            
                //does this get called??
                await WIKIDATA.personTermFix(infobox, printToBest, $aec);

                if (infobox.data.birth_name==undefined) {
                    infobox.data.birth_name = {data:{text:$txt}};
                }
            }
            
            //test these with things like "stanford", "apple computer" or "the federal reserve bank" to see what  
            //comes through on infobox._type from wikipedia.
            else if (WIKIDATA._type_company.indexOf(_type)!=-1) {
                allData.wiki_type_conformed="company";

                this.locationFix(infobox, printToBest);
                
                if (_type=="school") {
                    this.addedPropsFromSection(infobox, doc, WIKIDATA.school, "", printToBest);
                }
                else if (_type=="university") {
                    allData.alt_be = MEM.company_type;
                    allData.alt_be_val = MEM.university.nid;
                }
    
            }

            //tennis biography.. etc.. ??? is this a person?  RECHECK
            else if (_type.indexOf("biography")!=-1) {
                allData.wiki_type_conformed="person";
            }

            //groups
            else if (WIKIDATA._type_group.indexOf(_type)!=-1) {
                allData.wiki_type_conformed="group";            
            }
    
            printToBest("wikitype for",_GREEN, $txt, _CYAN, infobox._type, _WHITE, "mapped to", _CYAN, allData.wiki_type_conformed);


            allData.status="success";
            allData.result_type="result";
            allData.wiki_type = _type;
            return resolve(allData);
            
        });
    });
}



WIKIDATA.extractImgs=function($doc, $json) {
    var imgs = $doc.images();
    console.log(imgs);
    if (imgs.length>0) {
        $json.imgsfix = [];
        for (var i=0; i < imgs.length; i++) {
            var full = imgs[i].url();
            var thumb = imgs[i].thumbnail();
            var ext = imgs[i].format() 
            var capt = imgs[i].caption();
            var imgObj = {img_full:full, img_thumb:thumb, ext:ext, caption:capt, to_s:""};
            $json.imgsfix.push(imgObj);
        }
    }
    return;
}


WIKIDATA.checkSentenceOne=function($json) {
    var sec = $json.sections[0];
    if (sec==undefined) return "";
    var par = sec.paragraphs[0];
    if (par==undefined) return "";;
    var sent = par.sentences[0];
    if (sent==undefined) return "";;
    if (sent.text.indexOf("(born ")!=-1) {
        $json['per_desc']=[{lookupval:$json.description}];
        return "person";
    }
    return "";
}


WIKIDATA.preProcessNameCategories=async($json)=> {
    var cats = $json.categories;
    if (cats==undefined || cats==null || cats.length==0) return;
    for (var c=0; c < cats.length; c++) {
        var cat = cats[c];
        if (cat.indexOf("-language")!=-1) {
            var lang = cat.replace("-language", "");
            lang = lang.replace("surnames","");
            lang = lang.trim();
            if ($json.language==undefined) $json.language=[];
            $json.language.push({lookupval:lang, to_s:""});
        }

        //if only surname, and not -language..
        else {
            if (cat.indexOf("surnames")!=-1) {
                var eth = cat.replace("surnames","");
                eth = eth.trim();
                if ($json.ethnicity==undefined) $json.ethnicity=[];
                $json.ethnicity.push({lookupval:eth, to_s:""});
            }
        }
    }

    var sec = $json.sections[0];
    if (sec==undefined) return;
    var par = sec.paragraphs[0];
    if (par==undefined) return;

     $json['name_desc']=[];
    
    for(var s=0; s < par.sentences.length; s++) {
        var si = "";
        if (s==0) si="";
        else si=(s+1);
        $json['name_desc'].push({lookupval:par.sentences[s].text});
    }

    if ($json.people==undefined) {
        $json.people = [];
        $json.people_cnt = 0;
    }
    if ($json.variants==undefined) {
        $json.variants=[];
    }

    for (var s=0; s < $json.sections.length; s++) {
        var sec = $json.sections[s];
        var lists = sec.lists;
        if (lists==undefined) continue;

        var assoc_to = null;

        var bDOINVARIANTGATHER = false;
        var tit = sec.title.toLowerCase();

        if (tit=="variant surnames") {
            bDOINVARIANTGATHER=true;
        }
            
        else if (tit=="see also") {
            $json.see_also = sec;
            continue;
        }
            
        else if (tit=="references") {
            $json.references = sec;
            continue;
        }

        else if (tit=="fictional characters'") {
            $json.fictional_characters = sec;
            continue;
        }
            
        else {
            if (tit=="arts") assoc_to = ANNE.MEM.arts;
            else if (tit=="mathematics") assoc_to = ANNE.MEM.mathematics;
            else if (tit=="miliary") assoc_to = ANNE.MEM.military;
            else if (tit=="religion") assoc_to = ANNE.MEM.religion;
            else if (tit=="science and medicine") assoc_to = ANNE.MEM.science_and_medicine;
            else if (tit=="sport") assoc_to = ANNE.MEM.sport;
            else if (tit=="politics and law") assoc_to = ANNE.MEM.politics_and_law;
        }

        for (var l=0; l < lists.length; l++) {
            var persons = lists[l];
            for (var p=0; p < persons.length; p++) {
                var person = persons[p];
                var parts = person.text.split(",");
                var Xcontext = "";
                if (parts.length>1) Xcontext = parts[1].trim();
                var link = null;
                if (person.links!=undefined) link = person.links[0];
                else {
                    console.log("no link here. check to make sure we have their willywonka format right.");
                    continue;
                }
                var ourObj = new data_resolver_person("", "","", "", Xcontext);
                ourObj.wiki_original = person.text;
                
                //assoc to the category we found them in?
                //perhaps better in the conceptual dimension of HAS?
                if (assoc_to) {
                    ourObj.addExtra(TYPE_BRAIN, ANNE.MEM.brain_assoc_strong.nid, TO_TYPE_ANNE, assoc_to.nid);
                }

                if (link!=undefined && link!=null) {
                    ourObj.wikipart = link.page.replaceAll(" ", "_");
                    var cObj = ANNE.UTILS.stripParens(link.page);
                    ourObj.name = cObj.str;

                    var p0trim = parts[0].trim();
                    
                    //this has context in the name, first.
                    if (link.page.indexOf("(")!=-1 && link.page.indexOf(")")!=-1) {
                        var tObj = ANNE.UTILS.stripParens(p0trim);
                        p0trim = tObj.str;
                    }
                    
                    var bObj = ANNE.UTILS.stripParens(p0trim);
                    
                    if (bObj && bObj.context.length>0) {
                        var b2obj = WIKIDATA.birthDeathExtract(bObj.context);
                        if (b2obj && b2obj.birth!=null) {
                            if (isNaN(parseInt(b2obj.birth))==true)  {
                                b2obj.birth = ANNE.UTILS.extractNumberStr(b2obj.birth);
                                if (b2obj.birth.length) ourObj.birth = b2obj.birth;
                            }
                            else ourObj.birth = b2obj.birth;
                           
                        }
                        if (b2obj && b2obj.death!=null) {
                            if (isNaN(parseInt(b2obj.death))==true)  {
                                b2obj.death = ANNE.UTILS.extractNumberStr(b2obj.birth);
                                if (b2obj.death.length) ourObj.death = b2obj.death;
                            }
                            else ourObj.death = b2obj.death;
                        }
                    }
                }
                else {
                    var cObj = ANNE.UTILS.stripParens(parts[0].trim())
                    ourObj.name = cObj.str;
                    var b2obj = WIKIDATA.birthDeathExtract(cObj.context);
                    if (b2obj && cObj.context.length>0) {
                        if (b2obj.birth!=null) {
                            if (isNaN(parseInt(b2obj.birth))==true)  {
                                b2obj.birth = ANNE.UTILS.extractNumberStr(b2obj.birth);
                                if (b2obj.birth.length) ourObj.birth = b2obj.birth;
                            }
                            else ourObj.birth = b2obj.birth;
                        }
                        if (b2obj.death!=null) {
                            if (isNaN(parseInt(b2obj.death))==true)  {
                                b2obj.death = ANNE.UTILS.extractNumberStr(b2obj.birth);
                                if (b2obj.death.length) ourObj.death = b2obj.death;
                            }
                            else ourObj.death = b2obj.death;
                        }
                    }
                } 

                await ourObj.extractPersonExtras(ourObj.person_desc);

                //we will do a [has]-> variants -> to alt names (make alt name if doesn't exist)
                if (bDOINVARIANTGATHER==true) {
                    if ($json.variants.indexOf(this.last_name)===1) {
                        $json.variants.push({name:this.last_name, to_s:""});    
                    }
                } 
                else {
                    $json.people.push(ourObj); 
                    $json.people_cnt+=1;
                }
            }
        }
    }
}


WIKIDATA.birthDeathExtract=function($bdinfo=null) {
    if ($bdinfo==null || $bdinfo==undefined) return null;
    console.log("birthDeathExtract:"+$bdinfo)
    if ($bdinfo.indexOf("born ")!=-1) {
        $bdinfo = $bdinfo.replace("born ", "");
        $bdinfo.trim();
        return {birth:$bdinfo};
    }
    var parts = $bdinfo.split("–");
    if (parts.length==1) parts = $bdinfo.split("-");
    if (parts.length!=2) {
        console.log(parts);
    }
    return {birth:parts[0].trim(), death:parts[1].trim()}
}

WIKIDATA.marriageDivorceExtraction=function($mdinfo=null) {
    if ($mdinfo==null || $mdinfo==undefined) return null;
    console.log("marriageDivorceExtraction:"+$mdinfo);
    var obj = {married:null, divorced:null};

    if ($mdinfo.indexOf("married ")!=-1) {
        $mdinfo = $mdinfo.replace("married ", "");
        $mdinfo.trim();
        obj.married = $mdinfo;
        return obj;
    }
    if ($mdinfo.indexOf("m. ")!=-1) {
        $mdinfo = $mdinfo.replace("m. ", "");
        $mdinfo.trim();
        var parts = $mdinfo.split("–");
        if (parts.length==1) parts = $mdinfo.split("-");
        if (parts.length!=2) {
            console.log(parts);
        }
        obj.married=parts[0].trim();
        if (parts.length>1) obj.divorced=parts[1].trim();
        return obj;
    }
   
    return obj;
}



WIKIDATA.locationFix = function($infobox, $printToBest) {
    var city = "";
    var state = "";
    var country = "";

    if ($infobox.data.city!=undefined) {
        city = $infobox.data.city.data.text;
        if ($infobox.data.state!=undefined) {
            state = $infobox.data.state.data.text;
            if ($infobox.data.country!=undefined) {
                country = $infobox.data.country.data.text;
            }
        }
        else if ($infobox.data.country!=undefined) {
            country = $infobox.data.country.data.text;
        }
    }
    else if ($infobox.data.state!=undefined) {
        state = $infobox.data.state.data.text;
        if ($infobox.data.country!=undefined) {
            country = $infobox.data.country.data.text;
        }
    }

    var locationParts = [];
    var newobj = new Object();
    if (city!="") {
        locationParts.push(city);
        newobj.city=city;
    }
    if (state!="") {
        locationParts.push(state);
        newobj.state=state;
    }
    if (country!="") {
        locationParts.push(country);
        newobj.country=country;
    }
    if (locationParts.length>1) {
        newobj.text=locationParts.join(",");
        newobj.parts=locationParts;
        $infobox.data.location_prefix = new Object();
        $infobox.data.location_prefix.data = newobj;
        $printToBest(_CYAN, "fixing location", _WHITE, "to", _GREEN, newobj.text);
    }
}

WIKIDATA.getSectionByTitle = function($sections, $title) {
    var str = $title.toLowerCase();
    for (var s = 0; s < $sections.length; s++) {
        var title = $sections[s]._title.toLowerCase();
        if (title.indexOf(str)>=0) return $sections[s];
    }
    return null;
}


/**
 * fix the data so we have the terms ready to go.
 * @param {*} $infobox 
 */
WIKIDATA.personTermFix=async($infobox, $printToBest, $aec=null)=> {  
    var sameOffice = null;
    var process=[];
    var nohits = 0;
    for (var x=0; x < 20; x++) {
        var postfix = "";
        if (x>0) postfix = x;

        //if only once office then it applies to all terms?
        //is that how wikipedia did it here?
        if (x==0 && $infobox.data["office"]!=undefined) {
            sameOffice = WIKIDATA.extractWikiData($infobox.data["office"].data, [MEM.ROLE_THEME_THING, MEM.ROLE_AFFECTED_THING]);
        }
        
        //these come through with start (we must have start)
        //and either order/constituency/office (with #postfix for more than 1)
        if (($infobox.data["order"+postfix]==undefined && sameOffice=="" && $infobox.data["office"+postfix]==undefined) 
                || $infobox.data["term_start"+postfix]==undefined) {
            
            if (x>0) break;
            else continue; //sometimes missing the postfix and starts at 1.  Jenky, but it is what it is. 
        }

        process.push(postfix);
    }

    var totalExtra=0;
    
    for (var p=0; p < process.length; p++) {
        var postfix = process[p];
        var wt = new wiki_clump_neuron(ANNE.UTILS.randHex(3), $aec);

        //use the custom office, if it exists.
        //otherwise, use the same office which is set once for roles that repeat.
        //NOTE: unclear if some roles repeat and others done.. what that looks like..
        //because all of this is a rat-nest MESS.
        if ($infobox.data["office"+postfix]==undefined || $infobox.data["office"+postfix]==null) {
            continue;
        }

        var office = WIKIDATA.extractWikiData($infobox.data["office"+postfix].data, [MEM.role_theme_thing, MEM.role_affected_thing]);//$infobox.data["office"+postfix].data.text;
        if (office==null && sameOffice==null) continue;
        if (office==null) office=sameOffice;

        //office: [[Special prosecutor|Independent Counsel]] for the [[Whitewater Controversy]]
        $printToBest("office", _CYAN, $infobox.data["office"+postfix].data.wiki, _GREEN,$infobox.data["office"+postfix].data.text);
                    
        await wt.processServiceTermFromWikipedia($infobox.data, postfix, office, $aec);
        
        //for US House of rep, it should be 2 yrs..
        //but willy wonka donkey code smushes those together in consecutive terms..
        //So we need to dupe them.
        if (wt.term_length_years!=null) {
            var term_length = wt.getTermLength();
            if (term_length>wt.term_length_years) {
                var start = wt.start_year;
                var end = wt.end_year;
                var tly = wt.term_length_years;
                var endend = end-tly;
                
                for (var t=start; t <= endend; t+=tly) {       
                    var wt_dupe = new wiki_clump_neuron(ANNE.UTILS.randHex(3), $aec);
                    await wt_dupe.processServiceTermFromWikipedia($infobox.data, postfix, office);
                    wt_dupe.nObj = null;
                    await wt_dupe.setTermStartManual(t);
                    await wt_dupe.setTermEndManual(t+tly);
                
                    if ($infobox.data.service_terms==undefined) $infobox.data.service_terms=[];
                    $infobox.data.service_terms.push(wt_dupe);
                    var stProp = "";
                    if (t==start) stProp = "service_term"+(postfix);
                    else stProp = "service_term"+(postfix+(process.length-1)+totalExtra);

                    $printToBest("extrapolating", _CYAN, wt.term_length_years+"yr", _WHITE,"service term", _CYAN, stProp, _WHITE, "term "+t+" - "+(t+wt_dupe.term_length_years));
                    
                    $infobox.data[stProp]={data:wt_dupe};
                    if (t!=start) totalExtra+=1;
                }
            }

            //no extras to extract.
            else {
                if ($infobox.data.service_terms==undefined) $infobox.data.service_terms=[];
                $infobox.data.service_terms.push(wt);
                $infobox.data["service_term"+postfix]={data:wt};
            }
        }

        //we dont know how long a term is so we can't extrapolate nested terms in this donkey kong data set.
        else {
            //add the terms to our data.
            //we will process them one term at a time into neurons (or find existing ones)
            if ($infobox.data.service_terms==undefined) $infobox.data.service_terms=[];
            $infobox.data.service_terms.push(wt);
            $infobox.data["service_term"+postfix]={data:wt};
        }
    }

    return;
}



/**
 * 
 * @param {*} $copyFrom 
 * @param {*} $copyTo 
 */
WIKIDATA.copyFrom = function($copyFrom, $copyTo) {
    var keys = Object.keys($copyFrom);
    for (var k=0; k < keys.length; k++) {
        var key = keys[k];
        if (key=="nObj") continue;
        if (key=="rand") continue;
        if (key=="term_start" || key=="term_end") continue;
        if (key=="end_year" || key=="start_year") continue;
        $copyTo[ keys[k]] = $copyFrom[ keys[k]];
    }
    $copyTo.text = "";
}



/**
 * Extract some additional infos from various sections based on wiki _type
 * No $section means search the primary $doc._wiki
 * @param {*} $infobox 
 * @param {*} $doc 
 * @param {*} $kwdRelons 
 * @param {*} $section 
 * @returns 
 */
WIKIDATA.addedPropsFromSection = function($infobox, $doc, $kwdRelons, $section="Early Life", $printToBest) {
    if ($section.length>0) {
        var _sections = $doc._sections;
        if (_sections==null) return;
        var section = WIKIDATA.getSectionByTitle(_sections, $section);
        if (section==null) return;
        if (section._wiki==undefined) return;
    }
    else var section = $doc;
    var hits = 0;
    for (var k=0; k < $kwdRelons.length; k++) {
        var kwobj = $kwdRelons[k];
        var kw = kwobj.kw;
        if (section._wiki.indexOf(kw)!=-1) {
            hits+=1;
            var val = kw;
            if (kwobj.kw2!=undefined) val = kwobj.kw2;

            if ($infobox[kwobj.prop]==undefined) {
                $infobox[kwobj.prop] = [];
            }
            
            $infobox[kwobj.prop].push(val);

            if ($infobox.data[kwobj.prop]==undefined) {
                $infobox.data[kwobj.prop] = [];
            }
            $infobox.data[kwobj.prop].push(val);
        }
    }
    
    if (hits>0) {
        if ($section.length>0) $printToBest("extracted ", _CYAN, hits, _WHITE, "item(s) from ", _GREEN, $section);
        else $printToBest("extracted ", _CYAN, hits, _WHITE, "item(s) from document");
    }
}


/**
 * 
 * @param {*} $data 
 * @param {*} $roles 
 * @returns 
 */
WIKIDATA.extractWikiData = function($data, $roles=[]) {
    if ($data==undefined || $data==null) return;

    var string = $data.wiki;//'"[[Special prosecutor|Independent Counsel]] for the [[Whitewater Controversy]]";
    
    if (string==undefined || string==null) return;
    string = string.replaceAll("\n", " ");

    console.log("%c"+string, ANNE.TALK.bggreen);

    var regex = /\[\[([^|\]]+)(?:\|([^|\]]+))?\]\](?:(?!\[\[).)*/g;
    var results = [];
    var match;

    while ((match = regex.exec(string)) !== null) {
        var arr = [];
        for (var m=1; m < match.length; m++) {
            var text = match[m];
            if (text==undefined || text=="") continue;
            arr.push(text);
        }

        var pre_text = "";
        var ss = string.substring(0, match.index);
        var ss_post = match[0].substring(match[1].length+5);
        
        console.log(ss_post);
        
        if (ss_post.indexOf("[[")!=-1 || ss_post.indexOf("]]")!=-1) ss_post="";
        
        if (ss.indexOf("]]")==-1) {
            pre_text = ss.trim();
        }
        else {
            var pt = ss.split("]]");
            pre_text = pt[1];
            if (pre_text==undefined) pre_text="";
            else pre_text = pre_text.trim();
        }

        arr = WIKIDATA.getMostSimilarOnly(arr, $data.text);
        
        var role_part = new semantic_role_part(arr, pre_text, ss_post);
        role_part.original_text = string;
        role_part.links = $data.links;

        if ($roles[results.length]!=undefined) {
            role_part.setTargetRole($roles[ results.length]);
        }
        
        if (results.length>0) {
            console.log(role_part);
            continue;
        }
        results.push(role_part);
        
    }
    
    if (results.length==0) {
        var role_part = new semantic_role_part([string], "");
        if ($roles[0]!=undefined) {
            role_part.setTargetRole($roles[0]);
            results.push(role_part);
        }
    } 

    return results;
}


//we are trying to avoid faux matches in the .wiki but we extract key info 
//from the .wiki property.  This can yield more than one match.. and we want to know which is
//the one we're interested in.. (not always the first one).
//The .text prop is a clean prop so let's compare to that.
WIKIDATA.getMostSimilarOnly=function($arr, $comparisonText) {
    var maxSim = 0;
    var topText = "";
    for (var a=0; a < $arr.length; a++) {
        var simScore = ANNE.UTILS.similarity($comparisonText, $arr[a]);
        if (simScore > maxSim) {
            maxSim = simScore;
            topText = $arr[a];
        }
    }
    return [topText];
}

WIKIDATA.nameFix = function ($infobox, $doc, $txt, $printToBest) {
    if ($infobox.data.birth_name==undefined) {
        if ($doc._sections && $doc._sections.length) {
            var test = $doc._sections[0];
            if (test._paragraphs!=undefined && test._paragraphs.length) {
                test = test._paragraphs[0].data.wiki;
            }
            else test=null;

            if (test && test[0]=="'" && test[1]=="'" && test[2]=="'") {
                var end =false;
                var iitest=3;
                var audit="";
                var safety=50;
                while(end==false && safety>0) {
                    var char = test[iitest++]    
                    if (char=="'") {
                        end=true;
                        break;
                    }
                    audit+=char;
                    safety--;
                }
                console.log(audit);
                if (audit.length>=$txt.length) {
                    var parts=$txt.split(" ");
                    var noextend=false;
                    for (var p=0; p < parts.length; p++) {
                        if (audit.indexOf(parts[p])==-1) {
                            noextend=true;
                            break;
                        }
                    }
                    if (noextend==false) {
                        $infobox.data.birth_name = {data:{text:audit}};
                        $printToBest("extracting birth name ", _GREEN, audit, _WHITE, "from body");
                    }
                }
            }
        }
    }

}