class quickRezMetrics {
    constructor() {
        this.highest_score = 0;
        this.highest_cat = "";
        this.total_all=0;
        this.total_group=0;
        this.total_person=0;
        this.total_company=0;
        this.total_concept=0;
        this.total_location=0;
        this.total_event=0;
    }
    addRez=function($type) {
        if ($type=="Group") {
            this.total_group+=1;
            if (this.total_group > this.highest_score) {
                this.highest_score = this.total_group;
                this.highest_cat = "Group";
            }
        }
        else if ($type=="Person") {
            this.total_person+=1;
            if (this.total_person > this.highest_score) {
                this.highest_score = this.total_person;
                this.highest_cat = "Person";
            }
        }
        else if ($type=="Company") {
            this.total_company+=1;
            if (this.total_company > this.highest_score) {
                this.highest_score = this.total_company;
                this.highest_cat = "Company";
            }
        }
        else if ($type=="Concept") {
            this.total_concept+=1;
            if (this.total_concept > this.highest_score) {
                this.highest_score = this.total_concept;
                this.highest_cat = "Concept";
            }
        }
        else if ($type=="Location") {
            this.total_location+=1;
            if (this.total_location > this.highest_score) {
                this.highest_score = this.total_location;
                this.highest_cat = "Location";
            }
        }
        else if ($type=="Event") {
            this.total_event+=1;
            if (this.total_event > this.highest_score) {
                this.highest_score = this.total_event;
                this.highest_cat = "Event";
            }
        }

        this.total_all+=1;
    }


    //pretty dumb, but ok for now
    //3 or more rez for the same type, let's go with that.
    guessRez = function() {
        if (this.total_all > 2 && this.highest_score==this.total_all) return this.highest_cat;
        return "";
    }

    guessRezDesperado = function() {
        if (this.total_all > 0) return this.highest_cat;
        return "";
    }
    
}


class wikispooks  {
    constructor($CIRCUIT_MOD=null, $trackerMap = null, $altConsole=null, $resolveAmbigsCb=null) {
        this.parentTGEN = null;
        
        //AEC stuff.
        this.aec = new anne_external_connector("http://wikispooks.com/w/index.php?title=Special:ExportRDF/", "wikispooks", $CIRCUIT_MOD);
        if ($trackerMap!=null) this.aec.setTracker($trackerMap);

        //print stuff here instead.
        if ($altConsole!=null) {
            this.aec.setAltConsole($altConsole);
        }
        
        this.person=0;
        this.company=0;
        this.location=0;
        this.date=0;
        this._props = [];
        
        //will be populated by the specific search.
        this.resolvedNOBJ = null;
        this.page_name = null;              //needs to be set the last slash uri of this page.
        this.wiki_type_nObj = null;         //needs to be set to the neuron we will make in ANNE for this new search result thing  
        this.original_search_text = null;
        this.url = "";
        this.new_relons = [];

        this.groupType = null;      //will set to text value and resolve if needed.
        
        //too subjective for ANNE.
        //others can store these on opinionz.
        //(not that i disagree w/ them.. lolz)
        this._ignoredValues=["US Deep state", "rapist", "rapist?", 
                            "vipaedophile", "Deep politician", "spook", 
                            "puppet leader", "fixer?", "fixer"]; //, "US Deep State"
    
        this.json = null;

        this._processing_complete_callback = null;
        this.ambiguous_resolutions = [];


        this.known_classes_to_chase = [MEM.group.temp_nid, MEM.group_event.temp_nid, 
                                    MEM.person.temp_nid, MEM.company.temp_nid, MEM.location.temp_nid];
    
        this.top_desc = ""; //used for help disamb'ing

        this._quickRezMetrics = new quickRezMetrics();

        this.subjs_to_process = [];

        this.trackerMap = $trackerMap;

        this._rez_part = MEM.wikispooks_respart;
        this.savedParams=null;

        //if we get a new one, lets save the afile ref and display it.
        this.successful_img_afile = null;

        this._propChild=null;

        this.resolveAmbigs_cb = $resolveAmbigsCb;

        this.printf("initializing", _CYAN, "wikispooks data connector");

        //this is set when we get a redirect from another search.
        //we need to note the self reference is the redirect so that when we see it
        //we reference ourself, not a new thing.
        this.SELF_REFERENCE = "";

        this.extras = [];

        this._new_external_data = 0;
        
        /****** BUILD THE PROPS ************/        
        this.buildProps();
    }

    addExtra = function($type, $reln, $to_type, $to_s) {
        this.extras.push({type:$type, reln:$reln, to_type:$to_type, to_s:$to_s});
    }

    /**
     * props we want to map
     */
    buildProps=function(){   
        
        //property:Has_website
        //property:Display_image2
        
        //person specific.
        var prop0 = this.makeFM(this.processLocation, "Has_birthPlace", "birth place", TYPE_BE, MEM.birthplace.nid, TO_TYPE_ANNE, "per"); 
        prop0.process_array_as_one=true;
        prop0.onlyOne = true;
        prop0.multi_types = [TYPE_BE, TYPE_HAS];


        //WAY TOO MUCH NOISE in this field to deal with.  NOT WORTH IT.
        //var prop22 = this.makeFM(this.processOccupation, "Constitutes", "occupation", TYPE_HAS, MEM.occupation.nid, TO_TYPE_ANNE, "per"); 
        //prop22.only_class_nids = [MEM.person.nid];
        //prop22.only_pages = ["Person"];
        
        this.makeFM(this.processReligion, "Has_religion", "religion", TYPE_HAS, MEM.religion.nid, TO_TYPE_ANNE, "per"); 
        this.makeFM(this.processNationality, "Has_nationality", "nationality", TYPE_BE, MEM.nationality.nid, TO_TYPE_ANNE, "per"); 
        this.makeFM(this.processParty, "Has_politicalParty", "party", TYPE_HAS, MEM.political_party.nid, TO_TYPE_ANNE, "per");

        //property:Born_on:content:"1956-09-28Z"rdf:datatype:"http://www.w3.org/2001/XMLSchema#date"

        this.makeFM(this.processDateZ, "birthDate", "birth date", TYPE_BE, MEM.birthday.nid, TO_TYPE_ANNE, "per"); 
        this.makeFM(this.processDateZ, "Born_on", "birth date", TYPE_BE, MEM.birthday.nid, TO_TYPE_ANNE, "per"); 
        
        var propSib = this.makeFM(this.processPerson, "Has_sibling", "sibbling", TYPE_HAS, MEM.kinfolk_sibbling.nid, TO_TYPE_ANNE, "per"); 
        propSib.make_be_dual = MEM.kinfolk_sibbling;
        propSib.dual_type = TYPE_HAS;

        var propParent = this.makeFM(this.processPerson, "Has_parent", "parent", TYPE_HAS, MEM.kinfolk_parent.nid, TO_TYPE_ANNE, "per"); 
        propParent.make_be_dual = MEM.kinfolk_child;
        propParent.dual_type = TYPE_HAS;

        //we only want real names of real people here, not some number.
        this._propChild = this.makeFM(this.processKinfolk, "Has_child", "child", TYPE_HAS, MEM.kinfolk_child.nid, TO_TYPE_ANNE, "per"); 
        this._propChild.make_be_dual = MEM.kinfolk_parent;
        this._propChild.dual_type = TYPE_HAS;
        this._propChild.skipIFKws=["daughter", "with "];  //sometimes these come through as "2 daughters" which is NOT a person.
        
        var prop1 = this.makeFM(this.processSpouse, "Has_spouse", "spouse", TYPE_HAS, MEM.spouse.nid, TO_TYPE_ANNE, "per"); 
        prop1.make_be_dual = MEM.spouse;
        prop1.dual_type = TYPE_HAS;
        prop1.resolve_subj = this.processSpouse;

        //companies have founders of persons..
        var prop2 = this.makeFM(this.processPerson, "Has_founder", "founder", TYPE_HAS, MEM.founder.nid, TO_TYPE_ANNE, "cor"); 
        prop2.make_be_dual = MEM.founder_of;
        prop2.dual_type = TYPE_BE;
        prop2.resolve_subj = this.processCompany;

        //member of a board, group, commission, a list, a club.. etc.
        //member can also be PERSON or COUNTRY.  (yikes)
        //could pause and ask user the question?
        //GROUP->has->member->  name of member
        //member->be->member of-> GROUP
        var prop3 = this.makeFM(this.processMisc, "Has_member", "member", TYPE_HAS, MEM.member.nid, TO_TYPE_ANNE, "per"); 
        prop3.make_be_dual = MEM.member_of;
        prop3.dual_type = TYPE_BE;
        prop3.resolve_subj = this.processMisc;


        //********PROBLEMATIC********
        //this could be a group or a person or a company!  UUUGH.
        //also, if the thing we are parsing is any EVENT -- then
        //this should not be a constituent.
        //constituent works for group->subgroup or company->company
        var propConst = this.makeFM(this.processSubGroup, "Has_parentFullPageName", "constituent", TYPE_HAS, MEM.constituent.nid, TO_TYPE_ANNE, "per"); 
        propConst.ignore_classes = [ANNE.MEM.person.nid];

        //********//
        
        var prop37 = this.makeFM(this.processCompany, "Has_sponsor", "corp sponsor", TYPE_HAS, MEM.corpSponsor.nid, TO_TYPE_ANNE, "per"); 
        prop37.make_be_dual = MEM.corpSponsor_of;
        prop37.dual_type = TYPE_BE;
        prop37.resolve_subj = this.processCompany;    //could be company (ngo)  company (edu) or even group (like wef)
        
        //from a person this is a GROUP EVENT.
        //from the event this needs to make a person!
        var prop4 = this.makeFM(this.processPerson, "Has_participant", "participant", TYPE_HAS, MEM.participant.nid, TO_TYPE_ANNE, "per"); 
        prop4.make_be_dual = MEM.participant_of;
        prop4.dual_type = TYPE_BE;
        prop4.resolve_subj = this.processGroupEvent;
        
        //people be alumnis of --  edus have alumnis
        var prop11 = this.makeFM(this.processEducation, "Has_almaMater", "alma mater", TYPE_BE, MEM.alumni_of.nid, TO_TYPE_ANNE, "per"); 
        prop11.make_be_dual = MEM.alumni;
        prop11.dual_type = TYPE_HAS;
        prop11.resolve_subj = this.processPerson;

        //WIKISPOOKS IMG GET CORS, not going through ANNODE proxy to get them.  Sorry.
        //this.makeFM(this.processImage, "Has_image", "image", TYPE_HAS, MEM.neuronImg.nid, TO_TYPE_ANNE, "cor"); 
        
        
        this.makeFM(this.processImage, "Has_image2", "image", TYPE_HAS, MEM.neuronImg.nid, TO_TYPE_ANNE, "per"); 

        //start/end date of event
        
        var prop5 = this.makeFM(this.processDateZ, "Start", "start date", TYPE_BE, MEM.start_date.nid, TO_TYPE_ANNE, "cor"); 
        prop5['rdf:datatype'] = 'http://www.w3.org/2001/XMLSchema#gYear';
        prop5.resolve_alt = this.processInteger;
        prop5.alt_reln = MEM.established.nid;
        
        this.makeFM(this.processDateZ, "End", "end date", TYPE_BE, MEM.end_date.nid, TO_TYPE_ANNE, "cor"); 
        
        //location of an event (or company)
        //we do not want to process this inverted relon if tagged on anyone else.
        var prop33 = this.makeFM(this.processLocation2, "Has_location", "location", TYPE_HAS, MEM.location.nid, TO_TYPE_ANNE, "per"); 
        prop33.only_class_nids = [MEM.company.nid, MEM.group_event.nid];
        

        //LOOK TO FILLING THIS IN IF IT IS < 255 chars.
        //we also want this for descriptions of "participants" in meetings.
        //verify if this is in addition to the person description.
        
        //this.makeFM(null, "Description", "description", TYPE_HAS, MEM.wikispooks_desc.nid, TO_TYPE_BLOB, "per"); 


        //Has interest
        //this could be a simple assoc
    }


    makeFM=function($cb_resolve, $src_prop_name, $anne_prop_name, $type, $reln, $to_type, $incr="per"){
        var prop = this.aec.makeFM($cb_resolve, $src_prop_name, $anne_prop_name, $type, $reln, $to_type, $incr);
        this._props.push(prop);
        prop.only_class_nids = [];
        return prop;
    }

    setParentTGEN=function($parentTGEN=null){
        this.parentTGEN = $parentTGEN;
    }
    
    printToBest=function($msg) {
        if (this.aec!=null) {
            this.aec.addToConsole($msg);
        }
    }

    //TODO --- handle these via user gui to differentiate which one.
    addAmbiguous=function($jsonobj, $matches, $lookupval="") {
        if ($matches.length==0) {
            console.log("this was not ambiguous!");
        }
        var ambig = {jsonobj:$jsonobj, matches:$matches, lookupval:$lookupval};
        this.ambiguous_resolutions.push(ambig);
        var match_texts = [];
        for (var m=0; m < $matches.length; m++) {
            var match = $matches[m];
            match_texts.push("match #"+(m+1)+" "+match.text);
        }
        this.printf("ambiguious",_GREEN, $lookupval,_WHITE, "potential results", match_texts.join(" | "));
    }


    
    /**
     * 
     * @param {*} $page 
     * @returns 
     */
    quickResolveType = async($page)=> {
        var responseObj = await ANNE.API.avoidCorsWIKISPOOKS($page);
        if (ANNE.SETTINGS.debugExternal()==true) console.log(responseObj);
        if (responseObj==null) {
            ANNE.MEM_UDF.debug_ws_externals.push($page);
            return null;
        }
        if (responseObj.blah==undefined) {
            ANNE.MEM_UDF.debug_ws_externals.push($page);
            return null;
        }
        if (responseObj.blah['rdf:RDF']==undefined) {
            ANNE.MEM_UDF.debug_ws_externals.push($page);
            return null;
        }
        var $subj = responseObj.blah['rdf:RDF']['swivt:Subject'];
        if ($subj==undefined || $subj==null || Array.isArray($subj)==false) {
            ANNE.MEM_UDF.debug_ws_externals.push($page);
            return null;
        }

        if ($subj.length==0 || $subj[0]['property:Has_objectClass2']==undefined) {
            ANNE.MEM_UDF.debug_ws_externals.push($page);
            return null;
        }
        
        var type = $subj[0]['property:Has_objectClass2'];
        if (type!=undefined && type!=null) this.printf("inline explore for type of",_GREEN, $page, _CYAN, type.content);
        
        if (type.content=="Group") {
            if ($subj[0]['property:Has_headquarters']!=undefined) type.content = "Company";
            else if ($subj[0]['property:Has_founder']!=undefined) type.content = "Company";
            else if ($subj[0]['property:Has_nndb']!=undefined) type.content = "Company";
        }
        return {subj:$subj[0], subjs:$subj, type:type.content};
    }


    /**
     * We're not looking for too much from wikispooks in terms of variable classes.
     * Mostly person pages and company pages.
     * @param {*} $page_name 
     */
    setLikelyANNEClass=async($page_name="", $json2=null)=> {
        if (typeof $page_name!=="string") {
            console.log("????");
            return false;
        }
        var page_name = $page_name.toLowerCase();
        
        if (page_name=="person") {
            this.wiki_type_nObj = MEM.person;
        }
            
        //wikispooks doesn't have companies..  derrrrp
        else if (page_name=="company") {
            this.wiki_type_nObj = MEM.company;
            if ($json2!=null && $json2['property:Has_groupType']!=null) {

                //we expect things like military/non-profit, etc here.
                //this will help us create the right neuron or classify the corp.
                var groupTypes =$json2['property:Has_groupType'];
                if (groupTypes!=undefined) {
                    if (Array.isArray(groupTypes)== true) {
                        this.groupType = this.parseResource(groupTypes[0]['rdf:resource']);
                    }
                    else if (groupTypes['rdf:resource']!=undefined) {
                        this.groupType = this.parseResource(groupTypes['rdf:resource']);
                    }
                }
            }
        }

        //we need to expand this notion from wikispooks.
        //they have some great events that are NOT group events.
        //see: United Airlines Flight 553 (for example)
        //this is an event that happened, not a group.
        //We want an event clump.
        else if (page_name=="event") {
            this.wiki_type_nObj = MEM.group_event;
        }

        //consistutes for group is the group type (Family/Elite)
        else if (page_name=="group" || page_name=="groups") {
            this.wiki_type_nObj = MEM.group;    
            if ($json2!=null && $json2['property:Has_groupType']!=null) {

                //we expect things like military/non-profit, etc here.
                //this will help us create the right neuron or classify the corp.
                var groupTypes =$json2['property:Has_groupType'];
                if (groupTypes!=undefined) {
                    if (Array.isArray(groupTypes)== true) {
                        this.groupType = this.parseResource(groupTypes[0]['rdf:resource']);
                    }
                    else if (groupTypes['rdf:resource']!=undefined) {
                        this.groupType = this.parseResource(groupTypes['rdf:resource']);
                    }
                }
                

                this.wiki_type_nObj = MEM.company;
                //this may be a concpet, since they do things willy wonka depending on the direction.
                //we need to query it so we don't create group instance... when this is a class
                //we don't actually want this neuron anyhow but it is how we can get to the nested actual
                //instances.  (see WEF -> WEF annual meeting -> the ACTUAL WEF MEETING + YEAR (an instance))
            }
            else {
                var need2 = 0;
                if ($json2['property:Has_headquarters']!=undefined) need2+=1;
                else if ($json2['property:Has_founder']!=undefined) need2+=1;
                else if ($json2['property:Has_nndb']!=undefined) need2+=1;
                if (need2>=2) {
                    this.wiki_type_nObj = MEM.company;
                }
            }
        }
        
        //this is their notion of a class neuron, yet they often make is very specialized.
        //a bit of a pain in the arse, yet again.
        //WEF/Annual Meeting (the class) ---> yet the WEF instance referenced this with the same
        //relationship as it did actual instances.
        else if (page_name=="concept") {
            if (this.resolvedNOBJ!=null) this.wiki_type_nObj = this.resolvedNOBJ.getParent();
            else {
                this.wiki_type_nObj = ANNE.MEM.ec_thing; //default concept/thing
                this.printf("DEV WARNING - wikispooks target class very general", _BLUE, ANNE.MEM.ec_thing.text);
            }
        }
            
        else {
            this.printf("Unhandled wikispooks page_name", _RED,page_name);
            return false;
        }

        if (this.groupType!=null) {
            if (this.groupType=="NGO") {
                //hmmm.
            }
            if (ANNE.SETTINGS.debugExternal()==true) {
                console.log("%c GROUP TYPE "+this.groupType, ANNE.TALK.bgbigred);
            }
        }

        if (this.wiki_type_nObj!=null) {
            this.printf("setting wikispooks target class to", _BLUE, this.wiki_type_nObj.text);
        }
        return true;
    }


    formatSearchUri=function($searchObj) {
        return this.aec.baseUri + $searchObj.search_ready;
    }

    parseResource = function($r) {
         var slash = $r.replace("&wiki;", "");
         return slash.replaceAll("-2D","-");
    }
    

    /**
     * Don't chase classes we don't want.
     * @returns 
     */
    chaseableClass = function() {
        if (this.resolvedNOBJ==null) return true;
        if (this.aec!=null && this.aec.CIRCUIT_MOD!=null && this.aec.CIRCUIT_MOD.ACE) {
             return this.aec.CIRCUIT_MOD.ACE.isWikispooksChaseable(this.resolvedNOBJ);
        }
        return true;
    }

    printf = function(...$args) {
        var msg = ANNE.TALK.printf(...$args);
        this.printToBest(msg);
    }

    /**
     * @param {*} $resolvedNOBJ 
     * @param {*} $txt 
     * @param {*} $original_search_val 
     * @returns 
     */
    getData=async($resolvedNOBJ=null, $txt = "Barack Obama", $external_search_val="", $completeCallback=null, $bTRYALIASONFAIL=false)=> {
        
        if ($resolvedNOBJ!=null) this.printf("getting wikispooks data for known", _YELLOW, $resolvedNOBJ.text);
        else this.printf("getting wikispooks data for unknown",_GREEN, $txt);

        this._processing_complete_callback = $completeCallback;

        var txt1= $txt;
        //we don't want existing ANNE names that are not the proper external data file name to fail.
        //we populate external search val if we have it from our resolvedNOBJ
        if ($resolvedNOBJ!=null && txt1=="") {
            if ($resolvedNOBJ.text!="") txt1=$resolvedNOBJ.text;
        }
        var searchObj = this.prepSearch(txt1, $external_search_val);
        if (ANNE.SETTINGS.debugExternal()==true) console.log("wikispooks chase " + searchObj.search_ready);
        this.resolvedNOBJ = $resolvedNOBJ;
        this.name =  searchObj.search;
  
        if (this.resolvedNOBJ!=null) {
            if (this.chaseableClass()==false) {
                this.printf(_BLUE,this.resolvedNOBJ.text,_WHITE,"is not a wikispooks chaseable class");
                this._processing_complete_callback(this);
                return;
            }
        }

        var url = this.formatSearchUri(searchObj, $external_search_val);
        if (ANNE.SETTINGS.debugExternal()==true) console.log(url);
        this.url = url;

        this.name =  searchObj.search;

        var parts = this.name.split("_");
        if (parts.length==1) {
            parts = this.name.split(" ");
        }
        if (parts.length>1) {
            var suffix = ["jr", "jr.", "sr", "sr.", "iii", "ii", "iv", "i", "v", "vi", "vii", "viii", "ix"];
            var last = parts[parts.length-1];
            if (suffix.indexOf(last.toLowerCase())==-1) {
                this._propChild.appendIfMissing=last;
            }    
        }
        
        //*********** UNTESTED optimization (oct 4 2023) **********
        //we scooped this rezObjExtra on a prev query to resolve a member or other reln.
        //no need to hit the annode.  Use it here!
        if ($resolvedNOBJ!=null && $resolvedNOBJ.rezObjExtra!=undefined) {
            var rezObjExtra = $resolvedNOBJ.rezObjExtra;
            delete $resolvedNOBJ.rezObjExtra;
            return await this.getDataFinal(rezObjExtra.subjs, searchObj);
        }

        
        //RINKY-DINK CORS.
        this.printf("hitting ANNODE for wikipooks ",_CYAN, "cors bipass");
        
        var responseObj = await ANNE.API.avoidCorsWIKISPOOKS(searchObj.search_ready);
        
        if (ANNE.SETTINGS.debugExternal()==true) console.log(responseObj);

        this.status = responseObj.status;
        if (responseObj.status=="bad" || responseObj.status=="fail") {
            this.printf(_RED,"bad get data attempt for wikispooks");
            this.status="no_results";
            this._processing_complete_callback(this);
            return;
        }
        
        //var json = this.aec.xmlToJson(responseObj.blah);
        var json = responseObj.blah;
        if (ANNE.SETTINGS.debugExternal()==true) console.log(json);
        var RDF = json['rdf:RDF'];
        if (RDF == undefined) {
            this.printf(_RED,"nothing Found","in wikispooks for", _GREEN,this.name);
            this.status="no_results";
            this._processing_complete_callback(this);
            return;
        }
        if (RDF.length < 2) {
            this.printf(_RED,"nothing Found","in wikispooks for", _GREEN,this.name);
            this.status="no_results";
            this._processing_complete_callback(this);
            return;
        };

        var bONEMORETRY = false;
        var subj = RDF['swivt:Subject'];
        
        if (subj==undefined) {
            this.printf("nothing Found in wikispooks for ", _GREEN,this.name);

            //var bNEVERMIND=true;

            //a saved neuron that has a complicated full name which doesn't match any of our external
            //data sources, however, we have an alias we can try.  one-attempt.
            //do not try with no neuron, no alias
            if ($bTRYALIASONFAIL==true && $external_search_val=="" && this.resolvedNOBJ!=null &&  this.resolvedNOBJ.aka!=undefined && this.resolvedNOBJ.aka.length) {
                
                //we could, in theory, have set a bad external search val (or it could have changed)
                //if our alias is long, give up
                var shortestAlias = this.resolvedNOBJ.getShortestAlias();
                if ($external_search_val!="" && $external_search_val.length<shortestAlias) {
                    this._processing_complete_callback(this);
                    return;
                }

                this.printf("trying first alias", _GREEN,shortestAlias);
                bONEMORETRY=true;
                searchObj.search_ready=shortestAlias.replaceAll(" ", "_");
            }
            
            else {
                this.status="no_results";
                this._processing_complete_callback(this);
                return;
            }
        }

        //a redirect is present.
        else if (subj['swivt:redirectsTo']!=undefined && subj['swivt:redirectsTo']['rdf:resource']!=undefined) {
            bONEMORETRY=true;
            searchObj.search_ready=subj['swivt:redirectsTo']['rdf:resource'].replace("&wiki;", "");;
            this.printf("wikispooks redirect to ", _CYAN, searchObj.search_ready);
            this.SELF_REFERENCE = searchObj.search_ready;
        }
        
        if (bONEMORETRY==true) {
            responseObj = await ANNE.API.avoidCorsWIKISPOOKS(searchObj.search_ready);
            if (ANNE.SETTINGS.debugExternal()==true) console.log(responseObj);
            this.status = responseObj.status;
            if (responseObj.status=="bad" || responseObj.status=="fail") {
                this.printf(_RED,"wikispooks redirect failed, no data.");
                this.status="no_results";
                this._processing_complete_callback(this);
                return;
            }
            
            json = responseObj.blah;
            if (ANNE.SETTINGS.debugExternal()==true) console.log(json);
            RDF = json['rdf:RDF'];

            this.printf("parsing wikispooks data.");
        
            if (RDF == undefined) {
                this.printf("nothing Found in wikispooks for ", _GREEN, this.name);
                this.status="no_results";
                this._processing_complete_callback(this);
                return;
            }
            if (RDF.length < 2) {
                this.printf("nothing Found in wikispooks for ", _GREEN, this.name);
                this.status="no_results";
                this._processing_complete_callback(this);
                return;
            };
            if (RDF['swivt:Subject']==undefined) {
                this.printf("nothing Found in wikispooks for ", _GREEN, this.name);
                this.status="no_results";
                this._processing_complete_callback(this);
                return;
            };

            subj = RDF['swivt:Subject'];
            if (subj==undefined || subj==null) {
                this.printf("wikispooks redirect extraction problem ", _GREEN,this.name);
                this.status="no_results";
                this._processing_complete_callback(this);
                return;
            }
        }
        
        return this.getDataFinal(subj, searchObj);
    }


    /**
     * 
     * @param {*} $subj 
     * @param {*} searchObj 
     * @returns 
     */
    getDataFinal = async($subj, searchObj)=>{
        var json2 = $subj[0];
        if (json2==undefined || json2==null) {
            this.printf(_RED,"problem ", _GREEN, this.name);
            this._processing_complete_callback(this);
            return;
        }

        
        if ($subj['rdfs:label']!=undefined) {
            this.name = $subj['rdfs:label'];
            searchObj.search_ready = this.name;
        }
        else if (json2['rdfs:label']!=undefined) {
            this.name = json2['rdfs:label'];
            searchObj.search_ready = this.name;
        }

        if (ANNE.SETTINGS.debugExternal()==true) {
            console.log(json2);
        }

        
        var Has_member = [];
        var Has_participant = [];
        var Has_founder = [];
        var Has_almaMater = [];
        var Has_spouse = [];
        var Has_location = [];
        
        var Has_parentFullPageName = [];

        //Category: "Groups" with no Has_groupType and a Has fullPageNamee is a GROUP.
        //Category: "Groups" with a Has_groupType is a corporation.  GroupType will tell us what kind.
        //property:Has_objectClass2 {rdf:datatype: 'http://www.w3.org/2001/XMLSchema#string', content: 'Event'}

        console.log($subj);
        
        var extras = 0;

        var pre = "property:";
        
        //extract some goodies from the subj.
        for (var rd=1; rd < $subj.length; rd++) {
            var sub = $subj[rd];
            if (sub['property:Description']!=undefined) {
                this.top_desc = sub['property:Description'];
            }
            if (sub[pre+"Query_depth"]!=undefined) continue;
            if (sub[pre+"Query_format"]!=undefined) continue;

            //this is a problem for persons.. when parsing people.  We will skip it in the handler.
            if (sub[pre+'Has_parentFullPageName']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_parentFullPageName.push({content:lbl, last_slash_uri:slashlbl});
                extras+=1;
            }
            
            if (sub[pre+'Has_member']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_member.push({content:lbl, last_slash_uri:slashlbl, relon_to_subj:true});
                extras+=1;
            }

            else if (sub[pre+'Has_participant']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_participant.push({content:lbl, last_slash_uri:slashlbl, relon_to_subj:true});
                extras+=1;
            }

            else if (sub[pre+'Has_founder']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_founder.push({content:lbl, last_slash_uri:slashlbl, relon_to_subj:true});
                extras+=1;
            }

            //if this is a corp/college then has_almaMater are back links.
            else if (sub[pre+'Has_almaMater']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_almaMater.push({content:lbl, last_slash_uri:slashlbl, relon_to_subj:true});
                extras+=1;
            }   
            
            else if (sub[pre+'Has_spouse']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_spouse.push({content:lbl, last_slash_uri:slashlbl, relon_to_subj:true});
                extras+=1;
            }

            else if (sub[pre+'Has_location']!=undefined) {
                var lbl = sub['rdfs:label'];
                if (lbl==undefined) continue;
                var slashlbl = lbl.replaceAll(" ", "_");
                Has_location.push({content:lbl, last_slash_uri:slashlbl, relon_to_subj:true});
                extras+=1;
            }
        }

        ANNE.A.playSound("typing_short");

        this.printf("extracted", _CYAN, extras, _WHITE, "extra semantic object subjects");
        
        if (Has_parentFullPageName.length) {
            json2[pre+"Has_parentFullPageName"]=Has_parentFullPageName;//override
        }

        //this is a better one.  Take it!
        if (Has_location.length) {
            json2[pre+'Has_location']=Has_location; //override
        }

        if (Has_spouse.length) {
            json2[pre+'Has_spouse_DATES'] = json2[pre+'Has_spouse'];
            json2[pre+'Has_spouse']=Has_spouse; //override
        }
        
        //jam these in for standard handling.
        if (Has_member.length) {
            if (json2[pre+'Has_member']==undefined) {
                json2[pre+'Has_member']=Has_member;
            }
            else {
                var arr = json2[pre+'Has_member'];
                if (Array.isArray(arr)==true) json2[pre+'Has_member'] = json2[pre+'Has_member'].concat(Has_member);
                else {
                    Has_member.push(arr);
                    json2[pre+'Has_member'] = Has_member;
                }
            }
        }
        if (Has_participant.length) {
            if (json2[pre+'Has_participant']==undefined) {
                json2[pre+'Has_participant']=Has_participant;
            }
            else {
                var arr = json2[pre+'Has_participant'];
                if (Array.isArray(arr)==true) json2[pre+'Has_participant'] = json2[pre+'Has_participant'].concat(Has_participant);
                else {
                    Has_participant.push(arr);
                    json2[pre+'Has_participant'] = Has_participant;
                }
            }
        }
        if (Has_founder.length) {
            if (json2[pre+'Has_founder']==undefined) {
                json2[pre+'Has_founder']=Has_founder;
            }
            else {
                var arr = json2[pre+'Has_founder'];
                if (Array.isArray(arr)==true) json2[pre+'Has_founder'] = json2[pre+'Has_founder'].concat(Has_founder);
                else {
                    Has_founder.push(arr);
                    json2[pre+'Has_founder'] = Has_founder;
                }
            }
        }

        if (Has_almaMater.length) {
            if (json2[pre+'Has_almaMater']==undefined) {
                json2[pre+'Has_almaMater']=Has_almaMater;
            }
            else {
                var arr = json2[pre+'Has_almaMater'];
                if (Array.isArray(arr)==true) json2[pre+'Has_almaMater'] = json2[pre+'Has_almaMater'].concat(Has_almaMater);
                else {
                    Has_almaMater.push(arr);
                    json2[pre+'Has_almaMater'] = Has_almaMater;
                }
            }
        }
        
        //Event, Group, etc.
        var _type = "";
        if (json2['property:Has_objectClass2']!=undefined) _type = json2['property:Has_objectClass2'].content;
        var _type2 = json2["property:Has_objectClass"];

        console.log("%c wikispooks objectClass2:%c"+_type, ANNE.TALK.bgblack, ANNE.TALK.bgbigred);
        if (_type2!=null) {
            console.log(_type2);
            console.log("%c wikispooks objectClass2:%c"+_type2, ANNE.TALK.bgblack, ANNE.TALK.bgbigred);
        }

        this.json = json2;
        var bCONTINUE = await this.setLikelyANNEClass(_type, json2);
        if (bCONTINUE==false) return;

        
        await this.procesMainYearFromName(this.name);

        
        //*************************************************************************** */
        await this.doProps();
        //*************************************************************************** */
        

        //resolve ambigs.
        //TODO ---- where to do this with dossier?  Probably in the console?
        if (this.ambiguous_resolutions.length && this.resolveAmbigs_cb!=undefined) {
            this.resolveAmbigs_cb(this.ambiguous_resolutions, this._processing_complete_callback, this);
            this.printf(_CYAN,this.ambiguous_resolutions.length, _WHITE,"ambiguous mappings need resolution");
            return;
        }

        else {
            this._processing_complete_callback(this);
        }
    }


    /**
     * 
     * @returns 
     */
    doProps = async()=> {
        console.log(this._props);

        for(var p=0; p < this._props.length; p++) {
            //this could be the same pIndex as before (if we have another a index to cover);
            var prop = this._props[p];
            var pre = "property:";

            //extract the data from the wikispooks rdf jacked format (from how we pulled it)
            prop.json_objs = [];

            //skip some fields depending on what we are processing
            //(see occupation for Constitutes)
            if (prop.only_class_nids.length>0 && this.wiki_type_nObj!=null) {
                if (prop.only_class_nids.indexOf( this.wiki_type_nObj.nid)==-1) continue;
            }

            var propf = pre+prop.src_prop_name;

            this.printf("conceptualizing", _CYAN, propf);
            
            if (this.json[propf] != undefined) {
                
                //for any given prop in our props we have an array of results (if any at all)
                var arr = this.json[propf];
                if (Array.isArray(arr)==false) {
                    arr = [arr];
                }
                if (prop.process_array_as_one!=undefined && prop.process_array_as_one==true) {
                    if (prop.resolve_obj != undefined && prop.resolve_obj!=null && typeof prop.resolve_obj === "function") {
                        prop.json_objs.push(arr[0]); //push only the first one.
                        await prop.resolve_obj(arr, prop);
                    }
                    continue;
                }
                
                //array of json results for THIS prop.
                for (var a=0; a < arr.length; a++) {
                    var jsonobj = arr[a];
                    jsonobj.from_prop = prop.src_prop_name;

                    //if a literal, load the to_s already.
                    //we are ready to go.
                    if (jsonobj.content!=undefined) {
                        if (jsonobj.content=="") {
                            if (a<arr.length-1) continue
                        }
                        jsonobj.to_s = jsonobj.content;

                        if (typeof jsonobj.to_s =="string") {
                            var contextObj = UTILS.fixHack(jsonobj.to_s);
                            jsonobj.to_s = contextObj.str;
                            if (contextObj.context!="undefined" && contextObj.context!="") {
                                jsonobj.to_s = contextObj.str;
                                jsonobj.context = contextObj.context;
                            }   
                            if (prop.skipIFKws!=undefined) {
                                if (this.hasSkips(prop.skipIFKws,jsonobj.to_s)==true) {
                                    continue;
                                }
                            }
                        }

                        prop.json_objs.push(jsonobj);
                    }

                    else if (jsonobj['rdf:resource']!=undefined) {
                        var slash = jsonobj['rdf:resource'].replace("&wiki;", "");
                        slash = slash.replaceAll("-2D","-");
                        jsonobj.last_slash_uri = slash;
                        jsonobj.text_to_map = jsonobj.last_slash_uri.replaceAll("_", " "); 

                        var contextObj = UTILS.fixHack(jsonobj.text_to_map)
                        jsonobj.text_to_map = contextObj.str;
                        if (prop.skipIFKws!=undefined) {
                            if (this.hasSkips(prop.skipIFKws,jsonobj.text_to_map)==true) {
                                continue;
                            }
                        }
                        if (contextObj.context!="") {
                            jsonobj.context = contextObj.context;
                        }

                        //we are not creating any new neurons to ourselves here.  This gets willywonky very
                        //quickly.
                        if (jsonobj.text_to_map==this.name) {
                            continue;
                        }
                        

                        prop.json_objs.push(jsonobj);  //keep the uri
                    }

                    //we have to take the alt resolve and alt_reln!
                    //see "Start".  Sometimes it is a date, othertimes a year.
                    //when a year it means "established".
                    if (prop['rdf:datatype']!=undefined && jsonobj['rdf:datatype']!=undefined && jsonobj['rdf:datatype']==prop['rdf:datatype']) {
                        if (prop.alt_reln==undefined || prop.resolve_alt==undefined) continue;
                        prop.reln = prop.alt_reln;
                        await prop.resolve_alt(jsonobj, prop);
                        continue;
                    }
                    
                    //resolve to a known neuron if we have resolve set.
                    //we have prepped the data in a string or an array of strings.
                    //we will map ALL possible wikispook values to neurons here.
                    if (jsonobj.relon_to_subj!=undefined && jsonobj.relon_to_subj==true) {

                        if (typeof prop.resolve_subj==="function") {
                            await prop.resolve_subj(jsonobj, prop);
                        }
                        else {
                            alert("MISSING resolve_subj for inverted relon");    
                            console.log(prop);
                            console.log(jsonobj);
                            continue;
                        }
                    }
                    else if (typeof prop.resolve_obj=="function") {
                        await prop.resolve_obj(jsonobj, prop);
                    }

                    //something else?
                    else continue;
                }
            }
        }

        return;
    }

    
    /**
     * 
     * @param {*} $arr 
     * @param {*} $val 
     * @returns 
     */
    hasSkips=function($arr,$val) {
        if ($arr==undefined || $arr==null) return false;
        if ($val==undefined || $val==null || $val.length==0) return false;
        for (var a=0; a < $arr.length; a++) {
            if ($val.indexOf($arr[a])!=-1) return true
        }
        return false;
    }


    /**
     * we need all first letters capitalized.
     * we need underscores for spaces.             
     * we need to put dots after suffix and middle initials!
     * ie, John_D._Rockefeller_III
     * John_D._Rockefeller_Jr.
     * @param {*} $search 
     * @returns 
     */
    prepSearch = function($search, $external_override="") {
        var searchObj = {search_ready:"", search:"", original:$search};
        if ($external_override.length) {
            $external_override = $external_override.replace("-28", "(");
            $external_override = $external_override.replace("-29", ")");
            searchObj.search_ready = $external_override;
            searchObj.search = $external_override;
            this.external_ready_search = searchObj.search_ready;
            return searchObj;
        }

        searchObj = this.fixSearch($search);

        this.external_ready_search = searchObj.search_ready;
        if (searchObj.original.indexOf("/")!=-1) {
            this.external_ready_search = searchObj.original;  //"UK/Treasury";
        }
        return searchObj;
    }


    /**
     * 
     * @param {*} $search 
     * @returns 
     */
    fixSearch = function($search) {
        $search = $search.trim();
        //in wikispooks this is converted to %27 in their page names.
        $search = $search.replaceAll("'", "%27");
        
        if ($search===$search.toUpperCase()) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log("leave all caps"); //like FBI, or CIA, or MOSSAD, or WEF etc.
        }
        else if (UTILS.isMixedCase($search)==true) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log("leave as camel case");
        }
        else $search = $search.toLowerCase();
        
        var wds = $search.split(" ");
        for (var p=0; p < wds.length; p++) {
            wds[p] = wds[p][0].toUpperCase() + wds[p].substr(1);
            if (wds[p].length==1) wds[p]=wds[p]+".";
            else {
                var wd = wds[p];
                if(wd=="Sr" || wd=="Jr") wd = wd+".";
            }
            if (p>0 && wds[p-1]=="'") wds[p] = wds[p].toUpperCase();    //D'Aniello
        }
        return {search_ready:wds.join("_"), search:wds.join(" "), original:$search};
    }
    

    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processDateZ = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processDateZ";
        if (ANNE.SETTINGS.debugExternal()==true) console.log($jsonobj);
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s+"";
        if (lookupval==undefined || lookupval==null || lookupval=="") return;
        var lookupval = lookupval.replace("Z", "");

        //hmm.. sometimes we only have year/month  (year part, not a date)
        var ad = new anne_date(lookupval);
        if (ad==null) return;

        var bMAKEGHOSTIFNOTFOUND=true;
        await ad.testDate(bMAKEGHOSTIFNOTFOUND);
        
        if (ad.nObj!=null) {
            $jsonobj.to_s = ad.nObj.nid;
            this.printf("found existing date of", _YELLOW, ad.nObj.text); 
        }
        else {
            this.printf("something wrong with this date ", _GREEN, lookupval);   
        }
        return;
    }
    

    /**
     * 
     * @param {*} $jsonobj 
     */
    processLogo = async($jsonobj, $propObj)=>{
        $jsonobj.processedBy="wikispooks.processLogo";
        return;
    }
    
    processLocation2 = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processLocation2";
        return;
    }

    /**
     * 
     * @param {*} $arr 
     */
    processLocation = async($arr, $propObj)=> {
        var jsonobj = {};

        var text_to_map = "";
        if (Array.isArray($arr)==true) {
            var parts = [];
            var seattle = false;
            for(var a=0; a < $arr.length; a++) {
                var jsonobj = $arr[a];
                var fix = jsonobj['rdf:resource'].replace("&wiki;", "");
                fix = fix.replaceAll("_", " ");
                fix = fix.trim();
                parts.push(fix);
                if (fix.toLowerCase()=="seattle") seattle=true;
            }

            //fix for wikispooks bad link to DC.
            if (seattle==true) {
                for (var d=0; d < parts.length; d++) {
                    if (parts[d].toLowerCase()=="washington dc") {
                        parts[d] = "Washington";
                        break;
                    }
                }
            }
            
            text_to_map = parts.join(",");
            jsonobj = $arr[0];
            jsonobj.text_to_map = text_to_map;
        }
        else {
            alert("TRACK THIS >>>>>>> WE HAVE JACKED UP OUR FUNCTION.")
            var jsonObj = $arr;
            if (ANNE.UTILS.isset($jsonobj.to_s)==true) text_to_map = $jsonobj.to_s;
        }
        
        if (text_to_map=="") {
            console.log("is this in the source data???");
            return;
        }


        var anne_loc = new anne_location(text_to_map);
        var bMAKEGHOSTIFNOTFOUND = true;

        var parts = text_to_map.split(",");
        for (var p=0; p < parts.length; p++) {
            parts[p] = parts[p].trim()
        }

        //supposed to be lowest level first, not upper here.
        var piece = parts[0];
        if (this.aec.hasLocation(piece)==true) {
            jsonobj.to_s = this.aec.getLocation(text_to_map);
            return;
        }

        await anne_loc.processFull([],  false, bMAKEGHOSTIFNOTFOUND);
        anne_loc.print();

        if (anne_loc.nObj!=null) {

            if (this.resolvedNOBJ!=null && $propObj.onlyOne!=undefined && $propObj.onlyOne==true) {
                var bISBEST = MEMZ.isBestLocation(this.resolvedNOBJ, $propObj.reln, anne_loc.nObj.nid, anne_loc);
                if (bISBEST==false) {
                    var jsonobj = $arr[0];
                    jsonobj.to_s  = "";
                    return;
                }
            }


            jsonobj.to_s = anne_loc.nObj.nid;

            if (anne_loc.nObj.bNEW==undefined) {
                this.aec.mappedToExisting(text_to_map, anne_loc.nObj, ANNE.MEM.location);
            }
            else if (anne_loc.nObj.bNEW==false) {
                this.aec.mappedToExisting(text_to_map, anne_loc.nObj, ANNE.MEM.location);
            }
            else if (anne_loc.nObj.bNEW==true) {
                this.printf("added new", _BLUE, anne_loc.nObj.text);
                anne_loc.nObj.createdBy="WIKISPOOKS";
                this.aec.addLocation(anne_loc.nObj);
            }
        }
        else {
            this.printf(_RED, "parsing problem, skipped", _GREEN, text_to_map);
        }
        return;
    }



    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processSpouse = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processSpouse";
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        
        var lp = lookupval.indexOf("-28");
        var marriage_start_yr = "";
        var marriage_end_yr = "";

        if ($jsonobj.context!=undefined && $jsonobj.context.length>0) {
            
            //fix the last slash so we store the right page. (to get further details)
            $jsonobj.last_slash_uri = lookupval.replaceAll(" ", "_");

            var dates = $jsonobj.context.split("-");
            if (dates.length==1) {
                var startdate = parseInt(dates[0]);
                if (startdate > 1500) marriage_start_yr = startdate;
            }
            else if (dates.length==2) {
                var startdate = parseInt(dates[0]);
                if (startdate > 1500) {
                    var endDate = parseInt(dates[1]);
                    if (endDate < startdate) {
                        var centuries = Math.round(startdate / 100) * 100;
                        endDate = centuries+endDate;
                        if (endDate < startdate) {
                            console.log("give up");
                        }
                        else {
                            //we have a date range.
                            marriage_start_yr = startdate;
                            marriage_end_yr = endDate;
                        }
                    }
                }
            }
        }
        
        if (ANNE.SETTINGS.debugExternal()==true) console.log("(processSpouse) %c"+lookupval, TALK.bgyellow);

        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;
        if (this.aec.hasPerson(lookupval)==true) {
            nObj=this.aec.getPerson(lookupval);
        }
        else {
            var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
            if (GMOBJ.status=="good") {
                nObj = GMOBJ.match;
                this.aec.addPerson(nObj);
            }
            else if (GMOBJ.status=="ambiguous") {
                this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
                return;
            }
        } 
        

        $jsonobj.to_s = nObj.nid;
        return;
    }

    
    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processChild = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processChild";
        
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        if (ANNE.SETTINGS.debugExternal()==true) console.log("(processChild) %c"+lookupval, TALK.bgyellow);

        if (lookupval.indexOf("With ")==0) return;
        
        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;
        if (this.aec.hasPerson(lookupval)==true) {
            nObj=this.aec.getPerson(lookupval);
        }
        else {
            var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
            if (GMOBJ.status=="good") {
                nObj = GMOBJ.match;
                this.aec.addPerson(nObj);
            }
            else if (GMOBJ.status=="ambiguous") {
                this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
                return;
            }
        }
        $jsonobj.to_s = nObj.nid;
        return;
    }
    

    /**
     * So many willy wonka hacks.  So be it.
     * This is messy businesses.
     * 
     * This processes their Has_m3mber RDF triplet which is used in multiple conceptual concepts..
     * We have to break them out to store things the way we want to in ANNE.
     */
    processMisc = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processMisc";
        
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        this.printf("(processMisc)", _GREEN, lookupval);
        
        var desc = "";
        if (this.top_desc!="" && typeof this.top_desc=="string") {
            desc = this.top_desc.toLowerCase();
        }
        if (desc.length>0 && desc.indexOf("companies")!=-1) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log("time saver, company via desc: **"+desc+"**");
            return await this.processCompany($jsonobj);
        }

        else if (desc.length>0 && (desc.indexOf("people")!=-1 || desc.indexOf("persons")!=-1)) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log("time saver, person via desc: **"+desc+"**");
            return await processPerson($jsonobj, $propObj)
        }

        else if (desc.length>0 && desc.indexOf("annual meeting")!=-1) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log("time saver, GroupEvent via desc: **"+desc+"**");
            return await this.processGroupEvent($jsonobj, $propObj);
        }

        //we have to investigate this.. and it is costly, but so be it.
        //we will presume the others are in this class as well.
        else {

            //ONLY done with Has_m3mber, thus we can try to optimize our attempts here..
            //still attepmting to prevent a needless hit of wikispooks.
            var quickGuess = this._quickRezMetrics.guessRez();
            if (quickGuess!="") {
                if (quickGuess=="Group") return await this.processGroup($jsonobj, $propObj);
                if (quickGuess=="Company") return await this.processCompany($jsonobj, $propObj);
                if (quickGuess=="Concept") return await this.processGroupClass($jsonobj, $propObj);
                if (quickGuess=="Event") return await this.processGroupEvent($jsonobj, $propObj);
                if (quickGuess=="Person") return await this.processPerson($jsonobj, $propObj);
                if (quickGuess=="Location") {
                    var anne_loc_test = new anne_location(lookupval);
                    var bMAKEGHOSTIFNOTFOUND = false;
                    var bMUSTBECOUNTRY=false;

                    //found a real location.
                    await anne_loc_test.processFull([],  bMUSTBECOUNTRY, bMAKEGHOSTIFNOTFOUND);
                    anne_loc.print();
                    
                    if (anne_loc_test.nObj && anne_loc_test.nObj.ghost==false) {
                        $jsonobj.to_s = anne_loc_test.nObj.nid;
                        if ($propObj.loc==undefined) $propObj.loc=1;
                        else $propObj.loc+=1;
                        return;
                    }
                } 
            }


            //this helps us make sure not to bungle up the classification.
            var test2 = await this.quickResolveType($jsonobj.last_slash_uri);

            if (test2==null) {
                var quickGuess = this._quickRezMetrics.guessRezDesperado();
                if (quickGuess!="") test2 = {type:quickGuess};
                if (ANNE.SETTINGS.debugExternal()==true) console.log("skip this");
                $jsonobj.to_s = "";
                return;   
            }
                    
            if (test2!=null) {
                if (test2.type=="Group") {
                    this._quickRezMetrics.addRez(test2.type);
                    return await this.processGroup($jsonobj, $propObj, test2);
                }
                if (test2.type=="Company") {
                    this._quickRezMetrics.addRez(test2.type);
                    return await this.processCompany($jsonobj, $propObj, test2);
                }
                if (test2.type=="Concept") {
                    this._quickRezMetrics.addRez(test2.type);
                    return await this.processGroupClass($jsonobj);
                }
                if (test2.type=="Event") {
                    this._quickRezMetrics.addRez(test2.type);
                    return await this.processGroupEvent($jsonobj, $propObj, test2);
                }

                //validate that wikispooks actually passes a type="Location"
                if (test2.type=="Location") {
                     //if known location, do location.
                    this._quickRezMetrics.addRez(test2.type);
                    var anne_loc_test = new anne_location(lookupval);
                    var bMAKEGHOSTIFNOTFOUND = false;
                    var bMUSTBECOUNTRY=false; 
                    await anne_loc_test.processFull([],  bMUSTBECOUNTRY, bMAKEGHOSTIFNOTFOUND);
                    anne_loc.print();
                    
                    if (anne_loc_test.nObj && anne_loc_test.nObj.ghost==false) {
                        $jsonobj.to_s = anne_loc_test.nObj.nid;
                        if ($propObj.loc==undefined) $propObj.loc=1;
                        else $propObj.loc+=1;
                        return;
                    }
                }
                
                if (test2.type=="Person") {
                    this._quickRezMetrics.addRez(test2.type);
                    return await this.processPerson($jsonobj, $propObj)
                }
                    
                else {
                    if (ANNE.SETTINGS.debugExternal()==true) console.log("skip this");
                    $jsonobj.to_s = "";
                    return;
                }
            }
        }
    }




    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processPerson = async($jsonobj, $propObj, $rezObjExtra=null)=> {
        $jsonobj.processedBy="wikispooks.processPerson";
        
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        //we don't care about "number of children"
        if (parseInt(lookupval)>0) {
            return;    
        }
        
        if (lookupval.indexOf("With ")!=-1) {
            console.log("bad data, catch this earlier, what a KLUGE");
            return;
        }

        if ($propObj.appendIfMissing!=undefined) {
            var lower = lookupval.toLowerCase();
            var ismissing = $propObj.appendIfMissing.toLowerCase();
            if (lower.indexOf(ismissing)==-1) {
                lookupval = lookupval + " "+$propObj.appendIfMissing;
            }
        }

        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;
        if (this.aec.hasPerson(lookupval)==true) {
            nObj=this.aec.getPerson(lookupval);
            $jsonobj.to_s = nObj.nid;
        }
        else {
            var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
            if (GMOBJ.status=="good") {
                nObj = GMOBJ.match;
                $jsonobj.to_s = nObj.nid;
                this.aec.addPerson(nObj);
            }
            else if (GMOBJ.status=="ambiguous") {
                this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
                return;
            }
        }

        //what is $reszObjExtra?  The Full object used to chase this?
        if ($rezObjExtra!=null) nObj.wikiSpooksExtra = $rezObjExtra;
        
        return;
    }



    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processKinfolk = async($jsonobj, $propObj, $rezObjExtra=null)=> {
        $jsonobj.processedBy="wikispooks.processKinfolk";
        
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        //we don't care about "number of children"
        if (parseInt(lookupval)>0) {
            return;    
        }
        
        if ($propObj.appendIfMissing!=undefined) {
            var lower = lookupval.toLowerCase();
            var ismissing = $propObj.appendIfMissing.toLowerCase();
            if (lower.indexOf(ismissing)==-1 && lower.indexOf(" ")==-1) {
                lookupval = lookupval + " "+$propObj.appendIfMissing;
            }
        }
        
        if (lookupval.indexOf(" ")==-1) {
            console.warn("ONLY ONE NAME ALERT "+lookupval);
            return;
        }

        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;
        if (this.aec.hasPerson(lookupval)==true) {
            nObj=this.aec.getPerson(lookupval);
            $jsonobj.to_s = nObj.nid;
        }
        else {
            var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
            if (GMOBJ.status=="good") {
                nObj = GMOBJ.match;
                $jsonobj.to_s = nObj.nid;
                this.aec.addPerson(nObj);
            }
            else if (GMOBJ.status=="ambiguous") {
                this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
                return;
            }
        }

        //what is $reszObjExtra?  The Full object used to chase this?
        if ($rezObjExtra!=null) nObj.wikiSpooksExtra = $rezObjExtra;
        
        return;
    }



    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processCompany = async($jsonobj, $propObj, $rezObjExtra=null)=> {
        $jsonobj.processedBy="wikispooks.processCompany";

        var lookupval ="";
        var bBOARD = false;
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval = $jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;


        //note -- GROUPS CANNOT FOUND COMPANIES, COMPANIES ARE LEGAL ENTITIES...
        if (this.wiki_type_nObj.nid==MEM.group.temp_nid) {

            //we need to reroute this to NOT process a company!
            var test2 = await this.quickResolveType(lookupval);
    
            if (test2!=null && test2.type!="Group") {
                this.printf("**** explored type of ",_GREEN, lookupval,_WHITE, "found type", _CYAN,test2.type);
                
                if (test2.type=="Company") {
                    //no sub group relationships of constiuent if the resolved isn't also a group.
                    if (this.resolvedNOBJ!=null && this.resolvedNOBJ.is(MEM.company)==false) {
                        return;
                    }
                    return await this.processCompany($jsonobj, $propObj, test2);
                }

                //??? a group class?  This should simply be a generic "thing" concept in this case.
                //they have "antidepressant" as something the "big pharma" is founder of.
                //bizarre ---- to me.. thus we need to re-route their concepts in this type of
                //patterns to create a... concept.
                //however, we need the groups/corps under big_pharma, like "Center for Medicine in the Public Interest",
                //to indeed create a new corp.
                if (test2.type=="Concept") {
                    this.printf(_RED, "skipping concept", _GREEN, lookupval, _WHITE, "UNCLEAR HOW TO CONCEPTUALIZE IT.");
                    return;
                    //return await this.processThing($jsonobj, $propObj, test2);
                }
                if (test2.type=="Event") {
                    return await this.processGroupEvent($jsonobj, $propObj, test2);
                }     
                if (test2.type=="Person") {
                    return await this.processPerson($jsonobj, $propObj, test2)
                }
                else {
                    this.printf(_RED, "UNHANLDED explore PAGE TYPE for", _CYAN,test2.type, _GREEN,$jsonobj.last_slash_uri);
                    $jsonobj.to_s="";
                    return;
                }
            }
        }
        
    
        //uhhh.
        if (this.SELF_REFERENCE!="" && lookupval==this.SELF_REFERENCE) {
            console.warn("self reference from redirect found.  Investigate.  Skip for now")
            return;
        }

        //instead of member/member_of we want board member/board member_of as the reln.
        var test = lookupval.toLowerCase();
        if (test.indexOf("board")!=-1) {
            bBOARD=true;
            //we can presume this is a board memeber relon.
            if (test.indexOf("trustees")!=-1 || test.indexOf("directors")!=-1) {
                $jsonobj.OVERRIDE_RELN = MEM.board_member_of.nid;
                $jsonobj.OVERRIDE_MAKE_BE_DUAL = MEM.board_member.nid;
            }
        }

        this.printf("(processCompany)", _GREEN, lookupval);
        
        var highest_nObj = null;
        if (bBOARD==true) highest_nObj = MEM.governance_board;
        else {
            highest_nObj = await this.aec.estimateClass(lookupval, MEM.corp_entity_thetype, .7, this.groupType);
        }
        
        var GMOBJ = await MEMG.getOrMakeIfNewCorp(this.aec, lookupval, highest_nObj);
        var nObj = null;
        if (GMOBJ.status=="good") nObj = GMOBJ.match;
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
            return;
        }
        $jsonobj.to_s = nObj.nid;
        
        if ($rezObjExtra!=null) {
            nObj.wikiSpooksExtra = $rezObjExtra;
        }
        
        return;
    }


    procesMainYearFromName=async($name)=>{
        var parts = $name.split("/");
        if (parts.length<=1) parts = $name.split(" ");
        if (parts.length<=1) parts = $name.split("_");
        if (parts.length>1) {
            var last = parts[ parts.length-1].toLowerCase();
            if (last.indexOf("members")!=-1) {
                parts.pop();
                last = parts[ parts.length-1];
            }
            
            var yr = parseInt(last);
            
            if (yr>=1000) {
                var yrNOBJ = await ANNE.MEMG.getOrMakeIfNewInteger(this.aec, yr);
                this.printf("extracted when role for year", yrNOBJ.text);
                this.addExtra(TYPE_ROLE, MEM.role_when.nid, TO_TYPE_ANNE, yrNOBJ.nid);
            }
        }
    }


    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processGroup = async($jsonobj, $propObj, $rezObjExtra=null)=> {
        $jsonobj.processedBy="wikispooks.processGroup";
        
        var lookupval ="";

        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval = $jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        //don't want this stuff.
        if (lookupval.indexOf("Conspiracy theories")!=-1) {
            $jsonobj.bDEAD=true;
            $jsonobj.to_s="";
            return; 
        }

        if(lookupval.toLowerCase()=="council on foreign relations") {
            console.log("test this -- we should be finding this.");
        }

        //uhhh.
        if (this.SELF_REFERENCE!="" && lookupval==this.SELF_REFERENCE) {
            console.warn("self reference from redirect found.  Investigate.  Skip for now");
            return;
        }
        
        var parts = lookupval.split("/");
        var makeYrRelonForYear = 0;
        if (parts.length>1) {
            var last = parts[ parts.length-1].toLowerCase();
            if (last.indexOf("members")!=-1) {
                parts.pop();
            }
            else {
                var yrtag = parseInt(last);
                var yr = parseInt(yrtag);
                if (Number.isInteger(yr)==true) {
                    //this is a tag they use to split up the page.  Ignore it!
                    if (yr<1000) {
                        parts.pop();
                        lookupval = parts.join(" ");
                    }
                    
                    //this will need a yr relon!
                    else {
                        console.log("tack on a yr "+yr+"relon to this event -- or wait until it is queried??");
                        lookupval = parts.join(" ");
                        makeYrRelonForYear=yr;
                    }
                }  
            }
                    
            var original_lookup_val = lookupval;
            lookupval = parts.join(" ");
            this.printf("group lookup orginal value", _GREEN, original_lookup_val, _WHITE, "vs ANNE formatted value", _GREEN, lookupval);
        }

        
        var GMOBJ = await ANNE.MEMG.getOrMakeIfNewGroup(this.aec, lookupval, true);
        var nObj = null;
        if (GMOBJ.status=="good") nObj = GMOBJ.match;
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
            return;
        }
        $jsonobj.to_s = nObj.nid;
        if ($rezObjExtra!=null) nObj.wikiSpooksExtra = $rezObjExtra;

        if (nObj.ghost==true) {
            if (makeYrRelonForYear>0) {
                var yrNOBJ = await ANNE.MEMG.getOrMakeIfNewInteger(this.aec, makeYrRelonForYear);
                var yrrel = ANNE.MEMG.getRelonFromWithTo(nObj.outs, TYPE_ROLE, MEM.role_when.nid, yrNOBJ.nid);
                if (yrrel==null) {
                    await ANNE.GHOSTDATA.makeGhostRelon(TYPE_ROLE, nObj, MEM.role_when.nid, TO_TYPE_ANNE, yrNOBJ.nid);
                }
            }
        }
        return;
    }


    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processGroupClass = async($jsonobj)=> {
        $jsonobj.processedBy="wikispooks.processGroupClass";
        console.log($jsonobj);
        return await this.findOrAddNew($jsonobj, MEM.group, NTYPE_CLASS);
    }

    getParent=function() {
        if (this.parentTGEN!=null) {
            return MEMG.getNeuronByTempNid(this.parentTGEN.tnid);
        }
        return null;
    }
    

    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processSubGroup = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processSubGroup";

        //do not process subgroups from persons.
        //we have to do this another way... perhaps flip the sub/obj?
        if (this.wiki_type_nObj!=null && this.wiki_type_nObj.nid==ANNE.MEM.person.nid) {
            $jsonobj.to_s="";
            return;//get this with something else.
        }
        
        //only groups can have subgroups.
        if (this.wiki_type_nObj!=null && this.wiki_type_nObj.nid!=ANNE.MEM.group.nid) {
            $jsonobj.to_s="";
            return;
        }

        //if this main obj we are storing info on is an ignore class.. ignore this.
        //$propObj.ignore_classes
        
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval = $jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        //don't want this stuff.  make an array of things we are skipping from wikispooks.
        if (lookupval.indexOf("Conspiracy theories")!=-1) {
            $jsonobj.bDEAD=true;
            $jsonobj.to_s="";
            return; 
        }

        var ptNOBJ = this.getParent();
        if(ptNOBJ!=null) {
            //we want to skip this if we are referencing the parent tgen here. (ie, WEF)
            if (ptNOBJ.textMatch(lookupval)==true) {
                $jsonobj.bDEAD=true;
                $jsonobj.to_s="";
                return; 
            }
        }
        
        //do a quick look at what this thing is.
        var fix = $jsonobj.last_slash_uri.replaceAll("/", " ");
        fix = fix.replaceAll("_", " ");
        var indexResults = await ANNE.MEM.searchTextIndex(fix, false, true);
        var nObj = null;

        //quick resolution.. save drama pulling exploratory info from wikispooks.
        if (indexResults.length==1) {
            nObj = indexResults[0];
            if (nObj.is(MEM.company)==true && this.resolvedNOBJ!=null && this.resolvedNOBJ.is(MEM.company)==false) {
                nObj=null;
            }
            else if (nObj.is(MEM.group_event)==true && this.resolvedNOBJ!=null && this.resolvedNOBJ.is(MEM.group)==false) {
                nObj=null;
            }
        }

        //we don't know what this is yet...
        if (nObj==null) {

            //explore what the type is.
            var test2 = await this.quickResolveType($jsonobj.last_slash_uri);
    
            if (test2!=null && test2.type!="Group") {
                this.printf("**** explored type of ",_GREEN,$jsonobj.last_slash_uri,_WHITE, "found type", _CYAN,test2.type);
                if (test2.type=="Company") {
                    //no sub group relationships of constiuent if the resolved isn't also a group.
                    if (this.resolvedNOBJ!=null && this.resolvedNOBJ.is(MEM.company)==false) {
                        return;
                    }
                    return await this.processCompany($jsonobj, $propObj, test2);
                }


                if (test2.type=="Concept") {
                    if (this.resolvedNOBJ!=null && this.resolvedNOBJ.is(MEM.group)==false) {
                        return;
                    }
                    return await this.processGroupClass($jsonobj, $propObj, test2);
                }
                
                if (test2.type=="Event") {
                    return await this.processGroupEvent($jsonobj, $propObj, test2);
                }     
                
                if (test2.type=="Person") {
                    return await this.processPerson($jsonobj, $propObj, test2)
                }
                
                else {
                    console.log("%cUNHANLDED explore PAGE TYPE for %c"+test2.type+" %c"+$jsonobj.last_slash_uri, ANNE.TALK.bgbigred, ANNE.TALK.bgblue, ANNE.TALK.bggreen);
                    console.log("skip this");
                    $jsonobj.to_s="";
                    return;
                }
            }
    
            //instead of member/member_of we want board member/board member_of as the reln.
            var test = lookupval.toLowerCase();
            if (test.indexOf("board")!=-1) {
                bBOARD=true;
                if (test.indexOf("trustees")!=-1 || test.indexOf("directors")!=-1) {
                    $jsonobj.OVERRIDE_RELN = MEM.board_member_of.nid;
                    $jsonobj.OVERRIDE_MAKE_BE_DUAL = MEM.board_member.nid;
                }
            }
            
            var parts = lookupval.split("/");
            var makeYrRelonForYear = 0;
            if (parts.length>1) {
                var last = parts[ parts.length-1].toLowerCase();
                if (last.indexOf("members")!=-1) {
                    parts.pop();
                }
                else {
                    var yrtag = parseInt(last);
                    var yr = parseInt(yrtag);
                    if (Number.isInteger(yr)==true) {
                        //this is a tag they use to split up the page.  Ignore it!
                        if (yr<1000) {
                            parts.pop();
                            lookupval = parts.join(" ");
                        }
                        
                        //this will need a yr relon!
                        else {
                            lookupval = parts.join(" ");
                            makeYrRelonForYear=yr;
                        }
                    }  
                }
                lookupval = parts.join(" ");
            }
    
            //this is a WEF board or program.. we want it to be a consistuent of WEF.
            this.printf("(processGroup) lookup", _GREEN, lookupval);
    
            //this is likely a CLASS bucket used by them to organize all the meetings.
            //we don't actually need it as a neuron but we need to query it to get all the actual meetings.
            //straigt up bullocks.
            if (lookupval.indexOf("annual meeting")!=-1 && makeYrRelonForYear==0) {
                if (ANNE.SETTINGS.debugExternal()==true) console.log("bullocks neuron");
            }
            
            //var highest_nObj = null;
            //if (bBOARD==true) highest_nObj = MEM.governance_board;
            //else highest_nObj = this.aec.estimateClass(lookupval, MEM.corp_entity_thetype);
            var GMOBJ = await MEMG.getOrMakeIfNewGroup(this.aec, lookupval, true);
            
            if (GMOBJ.status=="good") nObj = GMOBJ.match;
            else if (GMOBJ.status=="ambiguous") {
                this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
                return;
            }
        }
        
        $jsonobj.to_s = nObj.nid;

        if (nObj.ghost==true) {
            if (makeYrRelonForYear>0) {
                var yrNOBJ = await MEMG.getOrMakeIfNewInteger(this.aec, makeYrRelonForYear);
                var yrrel = MEMG.getRelonFromWithTo(nObj.outs, TYPE_ROLE, MEM.role_when.nid, yrNOBJ.nid);
                if (yrrel==null) {
                    await GHOSTDATA.makeGhostRelon(TYPE_ROLE, nObj, MEM.role_when.nid, TO_TYPE_ANNE, yrNOBJ.nid);
                }
            }
        }
        
        
        //if the page (like WEF) had Has_parentFullPageName, we called make sub group...
        //so we could back-tie this thing to the parent.  (ie, WEF links to WEF global shapers.. etc)
        //WE DO NOT WANT TO DO THIS TO PEOPLE --- IT WILL BE A DIASTER.
        //ONLY GROUPS OR GROUP EVENTS OR COMPANIES

        if (this.resolvedNOBJ!=null && this.resolvedNOBJ.is(ANNE.MEM.person)==false 
            &&  (this.wiki_type_nObj.nid==ANNE.MEM.group.nid || this.wiki_type_nObj.nid==ANNE.MEM.group_event.nid
                || this.wiki_type_nObj.nid==ANNE.MEM.company.nid)) {

            var co_rel = MEMG.getRelonFromWithTo(nObj.outs, TYPE_BE, MEM.constituent_of.nid, this.resolvedNOBJ.nid);
            if (co_rel==null) {
                //BE CONSTITUENT OF ---> correct.
                await GHOSTDATA.makeGhostRelon(TYPE_BE, nObj, MEM.constituent_of.nid, TO_TYPE_ANNE, this.resolvedNOBJ.nid);
            }

            var c_rel = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, TYPE_HAS, MEM.constituent.nid, nObj.nid);
            if (c_rel==null) {
                //HAS CONSTIENT OF.
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.resolvedNOBJ, MEM.constituent.nid, TO_TYPE_ANNE, nObj.nid);
            }
        }

        if (this.resolvedNOBJ!=null) {  
            var x_relon = MEMG.getSysRelon(nObj.outs, MEM.wikispooks_respart.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_SYS, nObj, MEM.wikispooks_respart.nid, TO_TYPE_STRING, $jsonobj.last_slash_uri);
            }
        }

        return;
    }

    
    /**
     * Typically in wikispooks events come with years in the name.
     * We want to split that out and create a ROLE_WHEN relon to document the year of the event.
     * For more refined start and finish dates we will process those when the event page is pulled up.
     * @param {*} $jsonobj 
     * @returns 
     */
    processGroupEvent = async($jsonobj, $propObj, $rezObjExtra=null)=> {
        $jsonobj.processedBy="wikispooks.processGroupEvent";
        
        console.log($jsonobj);
        console.log($propObj);

        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;

        var GMOBJ = await MEMG.getOrMakeIfNewGroupEvent(this.aec, lookupval);
        
        var nObj = null;
        
        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;
            $jsonobj.to_s = nObj.nid;
        }
            
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
            return;
        }
        
        if ($rezObjExtra!=null) nObj.wikiSpooksExtra = $rezObjExtra;

        if (this.resolvedNOBJ!=null && this.resolvedNOBJ.is(ANNE.MEM.person)==false 
        &&  (this.wiki_type_nObj.nid==ANNE.MEM.group.nid || this.wiki_type_nObj.nid==ANNE.MEM.group_event.nid
            || this.wiki_type_nObj.nid==ANNE.MEM.company.nid)) {
            var co_rel = ANNE.MEMG.getRelonFromWithTo(nObj.outs, TYPE_BE, MEM.constituent_of.nid, this.resolvedNOBJ.nid);
            if (co_rel==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_BE, nObj, MEM.constituent_of.nid, TO_TYPE_ANNE, this.resolvedNOBJ.nid);
            }
            
            var c_rel = ANNE.MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, TYPE_HAS, MEM.constituent.nid, nObj.nid);
            if (c_rel==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, this.resolvedNOBJ, MEM.constituent.nid, TO_TYPE_ANNE, nObj.nid);
            }            
        }

        //if we don't have a wikispooks respart, store one.
        if (this.resolvedNOBJ!=null) {           
            var x_relon = ANNE.MEMG.getSysRelon(nObj.outs, MEM.wikispooks_respart.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_SYS, nObj, ANNE.MEM.wikispooks_respart.nid, TO_TYPE_STRING, $jsonobj.last_slash_uri);
            }
        }

        return;
    }

    
    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processOccupation = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processOccupation";
        
        var lookupval = "";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval = $jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;
        if (this._ignoredValues.indexOf(lookupval.toLowerCase())!=-1) return;
        var nObj = null;

        //not doing this if it is not a person.
        if (this.wiki_type_nObj.nid!=MEM.person.nid) return;

        var GMOBJ = await ANNE.MEMG.getOrMakeIfNewOccupationClass(this.aec, lookupval);
        console.log(GMOBJ);
        if (GMOBJ.status=="good") nObj = GMOBJ.match;
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
            return;
        }
        if (nObj==undefined || nObj==null) {
            if (ANNE.SETTINGS.debugExternal()==true) console.log($jsonobj);
            if (ANNE.SETTINGS.debugExternal()==true) console.log(GMOBJ);
            return;
        }
        
        $jsonobj.to_s = nObj.nid;
        return;
    }
    
    

    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processReligion = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processReligion";
        
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;
        
        //this data source (wikispooks) is weird with their label...
        //the most accurate here will be tribal jewish (presumption) for these values.
        if (lookupval.toLowerCase()=="jew" || lookupval.toLowerCase()=="jewish") {
            $jsonobj.to_s = "";
            this.addExtra(TYPE_BE, MEM.tribal.nid, TO_TYPE_ANNE, MEM.jewish.nid);
            return;
        }
        
        var GMOBJ = await MEMG.getOrMakeIfNewReligion(this.aec, lookupval);
        var nObj = null;
        if (GMOBJ.status=="good") nObj = GMOBJ.match;
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
            return;
        }
        $jsonobj.to_s = nObj.nid;
        return;
    }


    /**
     * 
     * @param {*} $jsonobj 
     * @returns 
     */
    processParty = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processParty";
        
        await this.findOrAddNew($jsonobj, MEM.political_party, NTYPE_INST);
        return;
    }


    /**
     * would love to tie this to the nation, not just a rando nationality.  Hmm.
     * @param {*} $jsonobj 
     * @param {*} $propObj 
     * @returns 
     */
    processNationality = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processNationality";
        
        if (this._ignoredValues.indexOf($jsonobj.text_to_map)!=-1) return;
        if (this._ignoredValues.indexOf($jsonobj.to_s)!=-1) {
            $jsonobj.to_s="";
            return;
        }
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;
        
        this.printf("(processNationality) lookup", _GREEN, lookupval);

        var matches = await ANNE.CIRCUIT.searchToResolve(lookupval, MEM.nationality);
        if (matches.length==0) {
            var lowerz=lookupval.toLowerCase();
            for (var c=0; c < MEM.COUNTRY._aChildren.length; c++) {
                var cNOBJ = MEMG.getNeuronByTempNid(MEM.COUNTRY._aChildren[c]);
                if (cNOBJ.text.toLowerCase()==lowerz) {
                    var nat = MEMG.getHasRelon(cNOBJ.outs, MEM.nationality.temp_nid);
                    if (nat==null) return;
                   
                    var natNOBJ = MEMG.getNeuronByNid(nat.to_s);
                    $jsonobj.to_s = natNOBJ.nid;
                    this.printf("found existing nationality of", _YELLOW, natNOBJ.text);
                    return [natNOBJ];
                }
            }
        }

        if (matches.length==1) {
            if (matches[0].anyBe(MEM.country)==true) {
                $jsonobj.to_s = await ANNE.MEMG.getNationalityFromNation(matches[0]);
                return; //country data is not a nationality.
            }
            $jsonobj.to_s = matches[0].nid;
            this.printf("found existing nationality of", _YELLOW, matches[0].text);
        }
        
        else if (matches.length>1) {
            this.printf(_CYAN, "ambiguous nationality",_WHITE, "for", _GREEN, lookupval);
            $jsonobj.to_s = matches[0].nid;
            return matches;
        }

        //no new nationalities here.  We've populated these with our nations already. (most of them)

        return matches;
    }

    
    /**
     * Process a new corp (higher learning)
     * We also want to attempt to narrow down the company type under the edu branch, if we can.
     * it will be a guess based on name similarity to classes we have.
     * @param {*} $jsonobj 
     * @returns 
     */
    processEducation = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processEducation";
        
        var lookupval = "";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else lookupval =$jsonobj.to_s;
        if (lookupval==undefined || lookupval==null || lookupval=="") return;
        this.printf("(processEducation) lookup", _GREEN, lookupval);
        var highest_nObj = await this.aec.estimateClass(lookupval, MEM.higher_education);
        var GMOBJ = await MEMG.getOrMakeIfNewCorp(this.aec, lookupval, highest_nObj);
        var nObj = null;
        if (GMOBJ.status=="good") nObj = GMOBJ.match;
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches, lookupval);
            return;
        }
        $jsonobj.to_s = nObj.nid;
        return;
    }    


    /**
     * 
     * @param {*} $jsonobj 
     */
    processImage = async($jsonobj, $propObj)=>{
        $jsonobj.processedBy="wikispooks.processImage";
        
        //return;
        //https://wikispooks.com/w/images/thumb/f/f1/
        //https://wikispooks.com/wiki/File:Rahm_Emanuel.jpg#file
        $jsonobj.to_s  = $jsonobj.to_s.replaceAll(" ", "_");
        
        var anneimg = await ANNE.IMAGES.getImgMetaFromUrlElement("https://wikispooks.com/wiki/"+$jsonobj.to_s, "https://wikispooks.com", "file");
        if (anneimg==undefined || anneimg==null) {
            return;
        }

        //check that this checks local space too (ghost imgs not on ANNE)
        var result = await CHASE.getGlobal(MEM.neuronImg, anneimg.live_finger);
        
        if (result.status=="good" && result.message=="available") {
            var imgNOBJ = await anneimg.makeGhost(null, this.resolvedNOBJ, TYPE_HAS, MEM.neuronImg.nid, this.name);
            $jsonobj.to_s = imgNOBJ.nid;
            
            //we will be wanting to move this from our html/ui/a2a_cache to the a2a_neurons once upgraded.
            //otherwise, we will not have the file data as it will be tied to the url (we didn't have a neuron)
            //at the time we originally stored it.
            //Unless we want to store a data_src relon to the external site... which could change based on
            //their willy-nilly needs to store imgs (as it often does).
            imgNOBJ.temp_href = "https://wikispooks.com/wiki/"+$jsonobj.to_s;
            if (this.successful_img_afile==null) {
                this.successful_img_afile = anneimg;
                this.printf("added new img from", _BLUE, imgNOBJ.temp_href);
            }
        }
        
        //dupe img
        else {
            $jsonobj.to_s = "";
        }
    }

    
    /**
     * we want a real integer here.
     * @param {*} $jsonobj 
     */
    processInteger = async($jsonobj, $propObj)=> {
        $jsonobj.processedBy="wikispooks.processInteger";
        await this.findOrAddNew($jsonobj, MEM.integer, false);
        return;
    }


    processLivingThing = async($jsonobj)=> {
        $jsonobj.processedBy="wikispooks.processLivingThing";
        if (ANNE.SETTINGS.debugExternal()==true) console.log($jsonobj);
        return await this.findOrAddNew($jsonobj, MEM.ec_living);
    }

    processThing = async($jsonobj)=> {
        $jsonobj.processedBy="wikispooks.processThing";
        if (ANNE.SETTINGS.debugExternal()==true) console.log($jsonobj);
        return await this.findOrAddNew($jsonobj, MEM.ec_thing);
    }


    /**
     * Standard search and if not found, create new.
     * We will process all pvals in the json_objs array as relons according to the prop definition.
     * We will also create another relon for MEM.dbpedia_respart / last_slash_uri if this to_s was a uri value in dbpedia. 
     * @param {*} $prop 
     * @param {*} $classNOBJ 
     */
    findOrAddNew=async($jsonobj, $classNOBJ, $ntype=NTYPE_CLASS)=> {
        if (this._ignoredValues.indexOf($jsonobj.text_to_map)!=-1) return;
        if (this._ignoredValues.indexOf($jsonobj.to_s)!=-1) {
            $jsonobj.to_s="";
            return;
        }
        var lookupval ="";
        if ($jsonobj.text_to_map!=undefined) lookupval = $jsonobj.text_to_map;
        else if($jsonobj.to_s!=undefined && $jsonobj.to_s!=null) {
            if (typeof $jsonobj.to_s =="string") {
                lookupval = $jsonobj.to_s;
                lookupval = lookupval.replaceAll("/", " ");
            }
            else if ($jsonobj.to_s!=undefined) lookupval = $jsonobj.to_s;
        }
        
        if (lookupval==undefined || lookupval==null || lookupval=="") return;
        
        var matches = await ANNE.CIRCUIT.searchToResolve(lookupval, $classNOBJ);

        if (matches.length==1) {
            $jsonobj.to_s = matches[0].nid;
            this.printf("found existing", _CYAN, $classNOBJ.text, _WHITE, "of", _YELLOW,matches[0].text);
        }
        else if (matches.length>1) {
            this.printf(_CYAN,"ambiguous "+$classNOBJ.text+" for", _GREEN, lookupval);
            $jsonobj.to_s = matches[0].nid;
            return matches;
        }
        else {
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron($classNOBJ, lookupval, $ntype);
            $jsonobj.to_s = ghostNOBJ.nid;
            this.printf("added new",_CYAN,$classNOBJ.text, _BLUE, ghostNOBJ.text);
        }
        return matches;
    }
}