class threeanne {
    constructor($three, $gsap, $GUI, $scene, $controls) {
        this.THREE = $three;
        this.gsap = $gsap;
        this.GUI = $GUI;
        this.scene = $scene;
        this.controls = $controls;
    }
}


class neuron_gen {
    constructor($circ, $parent_tgen, $tnid, $gen, $rel, $mesh=null) {
        
        this.parent_tgen = $parent_tgen;
        
        this.tnid = $tnid;
        var NOBJ = MEMG.getNeuronByTempNid(this.tnid);
        
        this.tgenid = UTILS.randHex(8);

        //helpful on refreshes.
        this.init_nid = NOBJ.nid;
        if (NOBJ.ghost==true) this.init_ghost = true;
        else this.init_ghost = false;

        this.audit = MEMG.getNeuronByTempNid(this.tnid).text;
        this.gen = $gen;
        if ($rel!=null) this.ins = [$rel];            //
        else this.ins = [];
        
        this.weight=0;
        this.mesh = $mesh;           //when on screen, this will be the mesh.
        this.circ = $circ;
        this.tgens = [];

        //will set this to true if this is a chaseable further (to explore deeper values)
        this.anne_chaseable = false;

        //will set this to true if we can get external info about this neuron.
        this.external_chaseable = false;

        this.in_bound_lines = [];
        this.out_bound_lines = [];
        
        //this.bOPEN = false;  //we want this undefined to start
        this.primaryRelon =  null;   //the line css3 object

        this.bOPEN=false;
        this.bCHASED=false;

        this.bNOCLICK = false;

        this.bANIMATING=false;  //we are currently animating this box/neuron
        this.bHASBOXIMG=false;  //we have an img on the box for this neuron

        this.dupe_master = null;    
        
        if ($rel!=null) this.initiating_rel=$rel;
        else this.initiating_rel=null;

        this.CIRC_MATCH = false;    //set if this tgen is in both circuits.
        this.CIRC_MATCH_LINEAGE = false; 
        this.CIRC_DEAD_END = false;  //marked on occurances of the OTHER CIRCUIT top within the other network
        this.init_backlinks_made = false;

        this.sib_index = 0;
        this.bDUPEDOWNSTREAM = false;

        this.primaryNeuronLbl = null;

        //may not have to go this far.. but may have to.
        this.tnid_parent_line = [];

        this.queryable_nids = [];
    }


    /**
     * Easier than culling/fixing memory for a circ compare
     * Just mark a line as dead.
     * @param {*} $bALL 
     */
    markChildrenDead = function($bALL=true) {
        for (var c=0; c<this.tgens.length; c++) {
            var tgenc = this.tgens[c];
            tgenc.CIRC_DEAD_END=true;
            tgenc.CIRC_MATCH=false;
            tgenc.CIRC_MATCH_LINEAGE=false;
            if (tgenc.tgens.length) {
                tgenc.markChildrenDead();
            }
        }
    }

    
    
    /**
     * This is removing the child (to) tgen from the mesh of this parent (from) tgen.
     * It also removes it from the parent tgens array.
     * 
     * A different removeTgen handles the circuit cleanup.
     */
    removeTgen = function($tgen_to_remove, $CIRCUIT) {

        //remove child tgen from this tgens
        for (var t=0; t < this.tgens.length; t++) {
            var tg = this.tgens[t];
            if ($tgen_to_remove.tnid==tg.tnid) {

                //splice out the tgen from this tgens array
                this.tgens.splice(t, 1);

                //remove the neuron lbl.
                $tgen_to_remove.mesh.remove($tgen_to_remove.primaryNeuronLbl);
                
                ANNE.A.hide($tgen_to_remove.primaryNeuronLbl.element);

                //remove the tgen_to_remove.mesh out the mesh from the parent mesh
                this.mesh.remove($tgen_to_remove.mesh);  
                
                break;
            }
        }
    }


    removeOutLine = function($line) {
        for (var i=0; i < this.out_bound_lines.length; i++) {
            var rel = this.out_bound_lines[i].relon;
            if (rel.txid==$line.relon.txid) {
                this.out_bound_lines.splice(i,1);
                break;
            }
        }
    }


    /**
     * We need to remove the relon from the .ins and from the .in_bound_lines.
     */
    removeInRelon=function($txid, $fromTGEN) {
        
        for (var i=0; i < this.ins.length; i++) {
            var in_rel = this.ins[i];
            if (in_rel.txid==$txid) {
                this.ins.splice(i, 1);
                break;
            }
        }

        //remove the line object from the in_bound_lines array.
        for (var i=0; i < this.in_bound_lines.length; i++) {
            var line = this.in_bound_lines[i];
            var rel = line.relon;
            if (rel.txid==$txid) {
                this.in_bound_lines.splice(i,1);
      
                $fromTGEN.removeOutLine(line);
                $fromTGEN.mesh.remove(line);
                this.circ.removeLine(line);     //could use C.removeByMESHIDFromArray instead

                this.primaryRelon = null;
                if (this.in_bound_lines.length) {
                    this.primaryRelon = this.in_bound_lines[0];
                }

                //this will remove the tgen entirely from the circuit
                //since there are no other references.
                else {
                    this.circ.removeTgen(this);
                }
                break;
            }
        }
    }

    
    /**
     * Make the relon opacity 1 (solid).  
     * If $bUNFADENEURONLBLS is set Remove any faded-neuron classes so the neuron label is ful opacity too.
     * @param {*} $bUNFADENEURONLBLS 
     */
    turnOnSolidOutboundRelons = function($bUNFADENEURONLBLS=true) {
        for (var l=0; l  < this.out_bound_lines.length; l++) {
            this.out_bound_lines[l].material.opacity=1; 
        }

        //make the lbl for the neurons solid again.
        if ($bUNFADENEURONLBLS==true) {
            for (var t=0; t < this.tgens.length; t++) {
                if (this.tgens[t].primaryNeuronLbl==undefined || this.tgens[t].primaryNeuronLbl==null) continue;
                ANNE.A.removeClass(this.tgens[t].primaryNeuronLbl.element, "faded-neuron");
            }
        }
    }
    

    /**
     * 
     */
    hideInboundLineLbls=function() {
        for (var l=0; l  < this.in_bound_lines.length; l++) {
            if (this.in_bound_lines[l].children.length==0) continue;
            ANNE.A.hide(this.in_bound_lines[l].children[0].element);
        }
    }

    
    setMesh=function($mesh){
        this.mesh = $mesh;
        $mesh.tgen=this;//backlink to help us easily get to the tgen obj
    }
     
 
    /**
     */
    getName=function($initiating_rel=null) {
        var nObj = MEMG.getNeuronByTempNid(this.tnid);
        var name = "";
        if (nObj.text.length>0) name = nObj.text;
        else name = nObj.nid;
        
        if (nObj.ghost==true) name = "(g) "+name;

        //if (nObj._uico!=undefined) return name+nObj._uico;

        //var parentNOBJ = nObj.getParent();
        
        //if (parentNOBJ!=null) {
           // if (parentNOBJ._uico!=undefined) return name+parentNOBJ._uico;
        //}

        //bday and dday should be coming through here.
        //if ($initiating_rel!=null) {
           // var relnNOBJ = MEMG.getNeuronByTempNid($initiating_rel.r);
           // if (relnNOBJ && relnNOBJ._uico!=undefined) {
             //   return name+relnNOBJ._uico;
            //}
       // }
        
        //if this doesn't work, look at the initiating_rel .r for _uico.
        //var rel_inicos = "";
        //for (var i=0; i < this.ins.length; i++) {
           // var relnNOBJ = MEMG.getNeuronByTempNid(this.ins[i].r);
           // if (relnNOBJ._uico!=undefined) rel_inicos+=relnNOBJ._uico;
        //} 
        //if (rel_inicos.length) return name+rel_inicos;
    
        return name;
    }
    

    getParentY = function() {
        if (this.parent_tgen==null || this.parent_tgen.mesh==null) return 0;
        return this.parent_tgen.mesh.position.y;
    }
    getParentX = function() {
        if (this.parent_tgen==null || this.parent_tgen.mesh==null) return 0;
        return this.parent_tgen.mesh.position.x;
    }
    getParentZ = function() {
        if (this.parent_tgen==null || this.parent_tgen.mesh==null) return 0;
        return this.parent_tgen.mesh.position.z;
    }
    getParentPosition=function() {
        if (this.parent_tgen==null || this.parent_tgen.mesh==null) return null;
        return this.parent_tgen.mesh.position;
    }


    /**
     * We need to query ANNE for further information for this.
     * We want to do this efficiently so we will do them all together
     * after each circuit gen.
     * @param {*} $nid 
     * @returns 
     */
    add_this_circuit_querable_nid = function($nid) {
        if (this.queryable_nids.indexOf($nid)!=-1) return;
        this.queryable_nids.push($nid);
    }


    /**
     * neuron gen version of this function.
     */
    chase_this_circuit_queryables = async()=> {
        if (this.queryable_nids.length==0) return;
        var bFORCEPULL=true;
        await ANNE.CHASE.queryForOutsFroms_not(this.queryable_nids, bFORCEPULL);
        for (var n=0; n < this.queryable_nids.length; n++) {
            var nid = this.queryable_nids[n];
            var nObj = MEMG.getNeuronByNid(nid);
            if (nObj.text=="") continue;
            const elements = document.querySelectorAll('div[nid="'+nid+'"], span[nid="'+nid+'"]');
            for (var e=0; e < elements.length; e++) {
                elements[e].innerHTML=nObj.text;
            }
        }
        this.queryable_nids = [];
    }


    /**
     * Chase a given neuron out one more gen deep.
     * This is typically from a user-click of the neuron on the gui.
     * 
     * This depends on any chasing of the neuron from external sources (including the annode) to 
     * have already been done prior to getting here.
     * @param {*} $CIRCUIT 
     * @param {neuron_circuit} $circ 
     * @param {anne_neuron} $nObj  
     * @param {boolean} $bDOBASICCHASE
     */
    buildCircuitLineOneMoreGen = async($CIRCUIT, $circ, $nObj, $bDOBASICCHASE=true, $bDOGUI=true)=> {
        if ($circ==undefined || $circ==null) {
            console.log("circ undefined, skipping");
            return;
        }
        
        var nObj = $nObj;
        if (nObj==null) nObj = MEMG.getNeuronByTempNid(this.tnid);
        var usable = [];
        
        var ro = new Object();
        var ghost_dupes = [];
        
        for (var r=0; r < nObj.outs.length; r++) {
            var rel = nObj.outs[r];
            if (rel.to_type!=TO_TYPE_ANNE) continue;
            if (rel.type==TYPE_PARAM || rel.type==TYPE_SYS || rel.type==TYPE_SYS_MSG) continue;
            if ($circ.types.length && $circ.types.indexOf(rel.type)==-1) continue;
            if ($CIRCUIT.tnid_reln_skips.indexOf(rel.r)!=-1) continue;

            //we don't need self relons to our circ primary (unless they are roles)
            if (rel.t==$circ.nObj.temp_nid && rel.type!=TYPE_ROLE) continue;

            //backlinks are killers here, skip them.
            //WEF 2020-> participant -> someguy....   some guy-> participant -> WEF2020 (dont' want a new tgen wef2020)
            if (rel.t==this.tnid) continue;
            if (this.parent_tgen!=null && rel.t==this.parent_tgen.tnid) continue;
            
            if ($bDOBASICCHASE==true) {
                //if this is a clump we're going to want to chase it out as a default,
                //and NOT count this as an extra gen.
                //clumps should display in a different way on the circuit display (gui)
                var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                if (toNOBJ==undefined || toNOBJ==null) {
                    console.log("grrr");
                    console.log(rel);
                    this.add_this_circuit_querable_nid(rel.to_s);
                    continue;
                }

                if ((toNOBJ.text=="" || toNOBJ.bes.length==0) && toNOBJ.ghost==false) {
                    this.add_this_circuit_querable_nid(toNOBJ.nid);
                }

                //help fix pinks that are pending by auto checking for their updates.
                else {
                    var pending_hanai = ANNE.HANAI.getPendingHanai(toNOBJ);
                    if (pending_hanai!=null) this.add_this_circuit_querable_nid(toNOBJ.nid);
                }
            }


            //sometimes we have ghost dupes that didn't get deleted when a TX was broadcast.
            //instead of hunting down all those nuances (which I will do, as possible)
            //we can head off this here too.  Anytime we open a new level we will check that the
            //ghosts we have created are not dupes against any other real relons.  (by from/reln/to/type/to_type)
            var dupehash = rel.type+rel.from_nid+rel.reln+rel.type+rel.to_s;
            if (rel.ghost==true && rel.type!=TYPE_AWARENESS && ro[dupehash]!=undefined) {
                ghost_dupes.push(rel.txid);
                continue;
            }

            if (rel.ghost==false) ro[dupehash]=rel;
            
            usable.push(rel);
        }

        //nuke these.
        if (ghost_dupes.length) {
            console.log("delete ghost dupes ", ghost_dupes);
            await GHOSTDATA.deleteGhostTxidsFull(ghost_dupes);
            ghost_dupes = null;
        }

        //get the missing basic goodies we want to display our stuff.
        //we are operating in high-query of annode mode and low-mem app mode w/ the circuit explorer app.
        //we will have TONS of data coming through and don't necessarily store it in our browser mem
        //from session to session.  We can, in INDEXDB but that will pile up and at some point become too
        //big to load and in browser MEM (when we load up all relons/neurons from mem).
        //So -- we will have to try to go on-demand from the ANNODE to maximize life of the app.
        if ($bDOBASICCHASE==true) {
            await this.chase_this_circuit_queryables();
        }

        var bNOLABELS = false;
        if (usable.length>$CIRCUIT._maxTgenSpokes) {
            bNOLABELS=true;
        }
        for (var r=0; r < usable.length; r++) {
            var rel = usable[r];

            //tgen will always return here, either new or reused.
            var to_tgen = $circ.addUniqueTgen(this, rel.t, this.gen+1, rel);
            if (to_tgen==null) continue;

             //not blowing out any bDUPEDOWNSTREAMS -- it can get very recursive and blow up the gui.
            if (to_tgen.bDUPEDOWNSTREAM==true) continue;

            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            if ($circ.be_tnids.length) {
                if (toNOBJ.isMultiT($circ.be_tnids)==false) continue; //not a valid class for the circuit
            }
            
            if (to_tgen.mesh==null && $bDOGUI==true) {  
                $CIRCUIT.addSubGen(to_tgen, usable.length, rel, bNOLABELS);   //makes the mesh with position relative to parent
            }

            //we want more for our compare ready circuit -- so we don't force the user to open
            //all items just to get a good compare.
            await to_tgen.blowOutTgens($CIRCUIT);
        }
    }


    /**
     * New infos has come in and we want to add that into the display 
     * This is typically done by doing an external pull of an already-created tgen lvl.
     * (green wikipedia/dbpedia/tmdb links in the primary explorer app)
     * while altering the current placements of all the existing already-on-screen neurons for this gen.
     * @param {*} $CIRCUIT 
     * @param {neuron_circuit} $circ 
     * @param {anne_neuron} $nObj  
     * @param {boolean} $bDOGUI - make the mesh 
     */
    extendNeuron = async($CIRCUIT, $circ, $nObj, $bDOGUI=true)=> {
        if ($circ==undefined || $circ==null) {
            console.log("circ undefined, skipping");
            return;
        }
        
        var nObj = $nObj;
        if (nObj==null) nObj = MEMG.getNeuronByTempNid(this.tnid);
        var usable = [];
  
        
        for (var r=0; r < nObj.outs.length; r++) {
            var rel = nObj.outs[r];
            if (rel.to_type!=TO_TYPE_ANNE) continue;

            if ($circ.types.length && $circ.types.indexOf(rel.type)==-1) continue;
            else if (rel.type==TYPE_PARAM || rel.type==TYPE_SYS || rel.type==TYPE_SYS_MSG) continue;
            
            if ($CIRCUIT.tnid_reln_skips.indexOf(rel.r)!=-1) continue;

            //if this is a clump we're going to want to chase it out as a default,
            //and NOT count this as an extra gen.
            //clumps should display in a different way on the circuit display (gui)
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            if (toNOBJ==undefined || toNOBJ==null) {
                console.log("grrr");
                console.log(rel);
                continue;
            }

            usable.push(rel);
        }


        for (var r=0; r < usable.length; r++) {
            var rel = usable[r];
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            if ($circ.be_tnids.length) {
                if (toNOBJ.isMultiT($circ.be_tnids)==false) continue; //not a valid class for the circuit
            }
            
            //we need to adjust the placement only, not add the new subgen.
            var tgen_existing = $circ.alreadyHaveIt(this, rel.t, this.gen+1, rel);

            if (tgen_existing==false) {
                var tgen = $circ.addUniqueTgen(this, rel.t, this.gen+1, rel);
                if (tgen==null) continue;
                
                if (tgen.mesh==null && $bDOGUI==true) {   //new returns tgen, existing returns null
                    $CIRCUIT.addSubGen(tgen, usable.length, rel);   //makes the mesh with position relative to parent
                }
                await tgen.blowOutTgens($CIRCUIT);
            }
            else continue;
        }
    }



    /**
     * We are trying to build out circuits in mem for matching.
     * Do not create them yet in the GUI (meshes) as we do not need them yet.
     * 
     * @param {*} $CIRCUIT 
     * @param {*} $bDOBASICSEARCH 
     * @returns 
     */
    blowOutTgens = async($CIRCUIT, $bDOBASICSEARCH=false)=> {
        if (this.circ.all_tnids.indexOf(this.tnid)!=-1) return;

        this.circ.all_tnids.push(this.tnid);
        
        var bDOGUI = false;
        
        //blow out TGENS but DO NOT CREATE MESHES.
        if (this.gen+1 <= ANNE.ACE._compareDepth) {
            var NOBJ = MEMG.getNeuronByTempNid(this.tnid);
            await this.buildCircuitLineOneMoreGen($CIRCUIT, this.circ, NOBJ, $bDOBASICSEARCH, bDOGUI);
        }

        return;
    }
}



/**
 * 
 */
class neuron_circuit {
    constructor($nObj) {
        this.nObj = $nObj;
        this.name = this.nObj.text;
        
        //if ghost nObj and updated, we lose the nid on refresh and don't know what to refresh.
        //this will point to the old ghost nid and we can match it to the was_znid val.
        this.init_nid = $nObj.nid;

        this.circ_id = UTILS.randHex(3);
        this.c_index = -1;

        //degrees of seperation of the neuron connection.
        //a direct reln is a 1st gen neuron in the circuit.
        this.gen = 1;      //default 1 gen chase.
        
        //limit the type of relationships.
        this.types = [];

        //limit the be parent line of the neurons in the network.
        this.be_tnids = [];

        //neurons by their gens.
        this.tgens = [];
        this.tgens_map =  new Object();
        this.unique_tnids = [];

        //an array of all relon line objects in this circuit.
        this.lines = [];

        //root tgen
        this.root_tgen = new neuron_gen(this, null, this.nObj.temp_nid, 0, null);
        this.tgens_map[this.nObj.temp_nid+"_"] = this.root_tgen;   //easy lookup w/ keys
        this.all_tnids = [];

        this.addTgen(this.root_tgen);          //normal iterable array

        this.queryable_nids = [];

        //just a tally for debugging.
        this.optimization_skips = 0;

        this.sub_gens_open = 0;
    }




    /**
     */
    turnOffAllForCirc=function($C) {
        for (var cl=0; cl < $C.css3dLbls.length; cl++) {
            
            var lbl = $C.css3dLbls[cl];

            if (lbl.circ_id!=this.circ_id) continue;

            //gen0 lbl should always be on, never faded.
            if (lbl.tgen.gen==0) {
                ANNE.A.removeClass(lbl.element, "faded-neuron");
                continue;  //never the root.
            }
            
            //set neuron labels to be faded.
            if (lbl.lbl_type==$C.CSS3_NEURON_LBL) {

                //fade out neuron labels
                if (lbl.tgen.gen!=0) ANNE.A.addClass(lbl.element, "faded-neuron");

                //fade out the relon LINES and make them black.
                if (lbl.tgen.bOPEN==true) continue;
                
                //if the box itself isn't open, we want to fade out the inbound lines.
                var csslbl = lbl;
                if (csslbl.tgen==undefined || csslbl.tgen==null) return;
                
                //turn relon lines to BLACK for the circuit when a specific neuron is highlighted.
                //we will turn all it's lines back to the original circuit color.
                for (var l=0; l < csslbl.tgen.in_bound_lines.length; l++) {
                    csslbl.tgen.in_bound_lines[l].material.opacity=0.2;
                }

                continue;
            }
                
            else {
                //hide RELON LBLS
                ANNE.A.hide(lbl.element);
            }
        }
    }


    /**
     * @param {*} $tnid 
     * @returns 
     */
    getAllCircTgensByTnid = function($tnid) {
        return ANNE.CIRCUIT.getAllCircTgensByTnid(this.circ_id, $tnid);
    }


    /**
     * The 2nd circuit has come in --
     * Mark anything south of our circuit 2 tnid in circuit 1 as a dead-end.
     * We do not want to chase this.
     * @param {*} $circ2tnid 
     */
    markDeadEnders=function($circ2tnid) {

        //for now, just mark it as a dead-end.
        var tgens = this.getAllCircTgensByTnid($circ2tnid);
        for (var t=0; t < tgens.length; t++) {
            if (tgens[t].gen==0) continue;
            tgens[t].CIRC_DEAD_END=true;
            tgens[t].markChildrenDead();
        }
    }


    /**
     * @param {*} CMD 
     * @param {*} current_compare_depth 
     * @param {*} $new_compare_depth 
     */
    extend_depth_from_gen_to_gen($from_depth, $extend_to_depth) {
    }


    /**
     * parent ptr already set.  TGEN already created. This adds it to the circuit 
     * @param {*} $tgen 
     */
    addTgen = function($tgen) {
        this.tgens.push($tgen);  

        if ($tgen.tnid==8507) {
            console.log("wef2017??");
        }

        if ($tgen.parent_tgen!=null) {
            $tgen.sib_index = $tgen.parent_tgen.tgens.length;
            $tgen.parent_tgen.tgens.push($tgen); //parents copy of tgens.

            //copy the existing parent tnid line
            $tgen.tnid_parent_line = $tgen.parent_tgen.tnid_parent_line.concat();

            //add in the parent (it isn't in its own parent line, the parent line terminated above it)
            $tgen.tnid_parent_line.push($tgen.parent_tgen.tnid);
        }
        return;
    }
        

    /**
     * Key for map is tgen tnid + "_" and then the parent tnid.
     * This will make neurons within a given mini-same-lvl circuit for a given neuron
     * but will create new tgens when these neurons show up for other neurons.
     * We do this for clarity of gui display.
     * 
     * When we compare we can open up all relevant matching circuits and connect to the matching item.
     * @param {neuron_gen} $parent_tgen
     * @param {*} $tnid 
     * @param {*} $gen 
     */
    addUniqueTgen = function($parent_tgen, $tnid, $gen, $rel) {
        var bDUPEDOWNSTREAM = false;
        
        if ($parent_tgen.tnid_parent_line.indexOf($tnid)!=-1) {
            this.optimization_skips+=1;
            console.log("skip self backlink ref, not helpful");
            return null;
        }

        //we don't want to make another tgen here. 
        //OVERKILL.
        if ($parent_tgen.parent_tgen!=null && $parent_tgen.parent_tgen.tnid==$tnid) {
            return null;
        }

        if (this.tgens_map[$tnid+"_"+$parent_tgen.tnid]!=undefined) {
            var tgen = this.tgens_map[$tnid+"_"+$parent_tgen.tnid];
            bDUPEDOWNSTREAM = true;
            if (tgen.initiating_rel.txid==$rel.txid) return null; //straight up dupe
            return tgen; //return and link to the same tgen, a legit dupe of tos in this gen.
        }
        
        else if ($parent_tgen!=null && $parent_tgen.circ.nObj.temp_nid==$tnid) {
            bDUPEDOWNSTREAM = true;
        }

        //console.log("New tgen gen "+$gen+" %c"+nOBJ.text+" %cparent %c"+$parent_tgen.audit, ANNE.TALK.bgred, ANNE.TALK.bggreen, ANNE.TALK.bgblack, ANNE.TALK.bgyellow)
        var tgen = new neuron_gen(this, $parent_tgen, $tnid, $gen, $rel);
        tgen.mesh=null;
        this.tgens_map[$tnid+"_"+$parent_tgen.tnid] = tgen;   //easy lookup w/ keys
        this.addTgen(tgen);
        tgen.bDUPEDOWNSTREAM = bDUPEDOWNSTREAM;
        
        return tgen;
    }


    /**
     * WE ARE NOT YET CALLING THIS...
     * 
     * Extend depth by one on this tnid.  (getting connected tos)
     * 
     * TODO: for some neurons we will need to get the from_nids connecting in, particularly. date neurons.
     * Even tho they are ins and "up" in the graph, in terms of "degrees of separation" they are just one more gen
     * 
     * @param {*} $nObj 
     * @param {*} $depth 
     */
    extendOne = function($nObj, $depth) {
        var last_gen = [];
        for (var r=0; r < $nObj.outs.length; r++) {
            if ($nObj.outs[r].to_type!=TO_TYPE_ANNE) continue;

            //we've already hit this tnid in this circuit somewhere earlier.
            if (this.all_tnids.indexOf($nObj.outs[r].t)!=-1) continue;

            this.all_tnids.push($nObj.outs[r].t);
            last_gen.push($nObj.outs[r].t);
        }
        return last_gen;
    }



    /**
     * Clear out the flags if we close a main circuit
     */
    resetAnimating = function() {
        for (var t=0; t < this.tgens.length; t++) {
            if (this.tgens[t].tnid!=this.nObj.temp_nid) {
                this.tgens[t].bANIMATING=false;
            }
        }
    }

    /**
     * Remove Tgen from entire circuit
     * We only do this if we know we have no other refs to it.
     */
    removeTgen = function($tgen_to_remove) {

        //remove it from the unique_tnids array.
        UTILS.removeFromTnidsArray(this.unique_tnids, $tgen_to_remove.tnid);

        //remove child tgen from this tgens
        for (var t=0; t < this.tgens.length; t++) {
            var tg = this.tgens[t];
            if ($tgen_to_remove.tnid==tg.tnid) {

                //splice out the tgen from this tgens array
                this.tgens.splice(t, 1);
                continue;
            }
        }
    
        //remove the mesh from the tracker arrays.
        if (ANNE!=undefined && ANNE.CIRCUIT!=undefined) ANNE.CIRCUIT.removeMesh($tgen_to_remove.mesh);
    }


    removeLine = function($line) {
        for (var i=0; i < this.lines.length; i++) {
            var rel = this.lines[i].relon;
            if (rel.txid==$line.relon.txid) {
                this.lines.splice(i,1);
                break;
            }
        }
        return;
    }

    setTypes = function($types) {
        this.types = $types;
    }

    setBeTnids = function($be_tnids) {
        this.be_tnids=$be_tnids;
    }

    getTgen = function($tgen_parent, $tnid) {
        return this.tgens_map[$tnid+"_"+$tgen_parent.tnid];
    }


    /**
     * 
     * @param {*} $tnid 
     * @param {*} $gen 
     * @param {*} $rel 
     * @returns 
     */
    alreadyHaveIt = function($tgen_parent, $tnid, $gen, $rel) {
        if (this.unique_tnids.indexOf($tnid)==-1) {
            this.unique_tnids.push($tnid);
        }

        if (this.tgens_map[$tnid+"_"+$tgen_parent.tnid]!=undefined) {
            var tgen = this.tgens_map[$tnid+"_"+$tgen_parent.tnid];

            //we have this tgen in our circuit.
            if (ANNE.UTILS.pushIfUniqueRel(tgen.ins, $rel)==true) {
                tgen.weight+=7-$gen;
                tgen.ins.push($rel);            //tgen ins are the relevant connections INBOUND to this tgen. 
            }
            return true;
        }
        return false;
    } 




    /**
     * We need to query ANNE for further information for this.
     * We want to do this efficiently so we will do them all together
     * after each circuit gen.
     * @param {*} $nid 
     * @returns 
     */
    add_this_circuit_querable_nid = function($nid) {
        if (this.queryable_nids.indexOf($nid)!=-1) return;
        this.queryable_nids.push($nid);
    }


    /**
     * We query for text and basic data.
     * If we didn't have it when we displayed the neuron in the display -- it will be missingg
     * info.  Lets update it.  :)
     */
    chase_this_circuit_queryables = async()=> {
        if (this.queryable_nids.length==0) return;
        await ANNE.CHASE.lookupMinList(this.queryable_nids, [0,1]);

        for (var n=0; n < this.queryable_nids.length; n++) {
            var nid = this.queryable_nids[n];
            var nObj = MEMG.getNeuronByNid(nid);
            if (nObj.text=="") continue;
            const elements = document.querySelectorAll('div[nid="'+nid+'"], span[nid="'+nid+'"]');
            for (var e=0; e < elements.length; e++) {
                elements[e].innerHTML=nObj.text;
            }
        }
        this.queryable_nids = [];
    }



    /**
     * Called one time from the primary circuit generator for a target neuron.
     * This creates the meshes and adds them to the screen.
     * 
     * This is where we want to chase out wikispooks, wikipedia and TMDB data sources 
     * to blowout more info.  Chase those AFTER we chase ANNE -- so we don't create ghost dupes.
     *
     * Will need to handle contradictory info at some pt.. but not a priority at this stage.
     * Priority is ANNE, then spooks, then wikipedia/dbpedia, then then TMDB.
     * 
     * @param {*} $CIRCUIT 
     * @param {neuron_gen} $parent_tgen 
     * @param {int} $genMax 
     */
    buildGens = async($CIRCUIT, $parent_tgen, $gen=1)=> {
        this.gen = $gen;   
        var outs = [];
        this.nObj.outs.sort(UTILS.sortGhostsLast);

        //auto cleanup for missed ghosts we need to nuke.
        var ro = new Object();
        var ghost_dupes = [];

        for (var r=0; r < this.nObj.outs.length; r++) {
            var rel = this.nObj.outs[r];

            //can show in display left but not in graph.
            if (rel.to_type!=TO_TYPE_ANNE) continue;
 
            //put desired types in here.
            if (this.types.length && this.types.indexOf(rel.type)==-1) continue;
            
            //default types to skip
            else if (rel.type==TYPE_PARAM || rel.type==TYPE_SYS || rel.type==TYPE_SYS_MSG || rel.type==TYPE_AWARENESS) continue;
           
            //we need to chase the clump for more details.
            if (rel.to_type==TYPE_CLUMP) {

                //if we already have this clump, we don't need to chase it.
                var clumpNOBJ = MEMG.getNeuronByNid(rel.to_s);
                if (clumpNOBJ.outs<=2) this.add_this_circuit_querable_nid(rel.to_s);
            }

            else if (rel.r==MEM.primaryNeuronImg.temp_nid) {
                continue;
            }

            var relNOBJ = MEMG.getNeuronByTempNid(rel.r);

            if ($CIRCUIT.tnid_reln_skips.indexOf(rel.r)!=-1) {
                //console.log('skipping '+relNOBJ.text);
                continue;
            }

            if (relNOBJ.text=="") this.add_this_circuit_querable_nid(relNOBJ.nid);
            
            //if this is a clump we're going to want to chase it out as a default,
            //and NOT count this as an extra gen.
            //clumps should display in a different way on the circuit display (gui)
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);

            //if this happens we have bad data in our relon and WE SHOULDN"T HAVE LET IT THROUGH.
            if (toNOBJ==undefined || toNOBJ==null) {
                console.log("skipping missing toNOBJ in rel", rel);
                continue;
            }

            
            if (this.be_tnids.length) {
                if (toNOBJ.isMultiT(this.be_tnids)==false) {
                    console.log("%c WE WOULD BE SKIPPING %c", TALK.bgred, TALK.bggreen);
                    //continue; //not a valid class for the circuit
                }
            }

            
            //we aren't considering digital asset neurons (for display) in three explorer.
            //we are most interested in conceptual instances and known classes (that act like instances)
            //people, places, colleges, businesses, dates..e tc.
            //We can display the primary neuron img (and/or audit/video).
            //NOTE: maybe, we DO want this when it comes to "evidence" viewing..
            //then we could browse through proof of connections w/ documentations to videos/img/references.
            if (toNOBJ.is(MEM.fileX)==true) {
                console.log("%c NOT PUTTING DIGITAL ASSETS ON THE SCREEN, skip", TALK.bgred, TALK.bggreen);
                continue;
            }

            ///we want basic text and class for items for display reasons.
            if (toNOBJ.text=="" && toNOBJ.ghost==false) {
                this.add_this_circuit_querable_nid(toNOBJ.nid);
            }

            //help fix pinks that are pending by auto checking for their updates.
            else {
                var pending_hanai = ANNE.HANAI.getPendingHanai(toNOBJ);
                if (pending_hanai!=null) this.add_this_circuit_querable_nid(toNOBJ.nid);
            }

            var dupehash = rel.type+rel.from_nid+rel.reln+rel.type+rel.to_s;
            if (rel.from_nid!=USER._userNObj.nid && rel.ghost==true && rel.type!=TYPE_AWARENESS && ro[dupehash]!=undefined) {
                ghost_dupes.push(rel.txid);
                continue;
            }
            
            if (rel.ghost==false) ro[dupehash]=rel;

            outs.push(rel);
        }

        //nuke these.
        //GHOST FIX for hangers.
        if (ghost_dupes.length) {
            console.warn("delete ghost dupes ", ghost_dupes);
            await GHOSTDATA.deleteGhostTxidsFull(ghost_dupes);
            ghost_dupes = null;
        }

        //get infos from ANNODE to support this gen of display.
        //this is not next-level chasing. This is query of supporting info needed for THIS GEN.
        if (this.queryable_nids.length) {
            console.log("%c query the queryables in this circuit level", TALK.bgred);
            await this.chase_this_circuit_queryables();
        }
        
        //the real loop.
        //we have all supporting infos now.
        for (var r=0; r < outs.length; r++) {
            var rel = outs[r];

            var tgen = this.addUniqueTgen($parent_tgen, rel.t, this.gen, rel);
            
            //add the graphics (tgen mesh should always be null here, as this is our circuit inception function)
            if (tgen!=null && tgen.mesh==null) {   //new returns tgen, existing returns null
                $CIRCUIT.addSubGen(tgen, outs.length, rel);  

                if (tgen.tnid==4718 || tgen.audit=="St. Albans School") {
                    console.log("here");
                }
                await tgen.blowOutTgens($CIRCUIT);
            } 
        }
    }
}