var LNOTS = {};

/**
 * Essentially this is like a static function within the anne_local_notifications class..
 * but when I use static functions they crash the chrome debugger.
 * When I create a psuedo module (object) they can more easily be debugged.
 * Not going to chase why at this point.  Just going with it.
 */
LNOTS.getLNOTS = async()=> {
    var lnots = await ANNE.API.getLNOTS(USER._userNObj.nid);
    console.log(lnots);
    if (lnots==null) return [];
    return lnots;
}


class anne_local_notifications {
    constructor($pgui) {
        this.pgui = $pgui;
        this.tbl_cols = [{
            neuron_link:false,
            title:"notice",
            prop:"title",
            class1:"lnot-notice"
        },
        {
            neuron_link:true,
            title:"asset",
            prop:"asset_nid",
            class1:"lnot-asset",
            achat:"achat_sesh_id"
        },        
        {
            neuron_link:false,
            title:"block",
            prop:"time",
            class1:"lnot-block"
        },
        {
            relon_link:true,
            title:"txid",
            prop:"txid",
            class1:"lnot-txid"
        },
        {   title:"",
            prop:"",
            actions_cb:this.deleteMaker,
            class1:"lnot-delete"  
        }
    ];

    }


    /**
     * 
     * @param {*} $col 
     * @param {*} $record 
     * @param {*} $propVal 
     */
    deleteMaker = function($col, $record, $propVal) {
        var btndelete = document.createElement("button");
        btndelete.innerHTML = "[remove]";
        btndelete.id = "delete_" + $rel.rid + "_" + $guid;
        span2.append(btndelete);
        btndelete.setAttribute("txid", $rel.txid);
        btndelete.addEventListener("click", e => this._deleteLNOT($propVal, $col));
        btndelete.style['margin-left'] = '4px';
    }


    /**
     * 
     * @param {*} $txid 
     */
    _deleteLNOT = async($txid, $col)=>{
        //user the col to get to the row and delete the row from the table.
        console.log($col);
        var rez = await ANNE.API.deleteLNOT($txid);
        console.log(rez);
    }
    

    /**
     */
    init=async()=>{
        var lnots = await ANNE.LNOTS.getLNOTS();
        var chase_nids = [];

        if (lnots.length==0) { 
            ANNE.A.ezEl("anneid_lnot_div", "div", "", "You have no local notifications.");
            return;
        }

        for (var a=0; a < lnots.length; a++) {
            var lnot = lnots[a];
            var asset_nid = lnot.asset_nid;                     //the asset here is the neuron we want to distro from
            if (lnot.area_nid==MEM.achat.nid) continue;         //this is NOT a nid!
            var assetNOBJ = MEMG.getOrMakeIfNew(asset_nid);
            if (assetNOBJ.text=="") chase_nids.push(assetNOBJ.nid);
            var area_nid = lnot.area_nid;
            var areaNOBJ = MEMG.getOrMakeIfNew(area_nid);
            if (areaNOBJ.text=="") chase_nids.push(areaNOBJ.nid);
        }

        //if no text, pull all text.
        if(chase_nids.length>0) {
            await CHASE.lookupMinList(chase_nids, [0,1,2,3,4,5,6,7,8,9]);
        }

        for (var a=0; a < lnots.length; a++) {
            var lnot = lnots[a];
            var asset_nid = lnot.asset_nid;                     //the asset here is the neuron we want to distro from
            console.log(lnot);
            
            var areaNOBJ = MEMG.getNeuronByNid(lnot.area_nid);

            if (lnot.area_nid==MEM.delegation_rights.nid) {
                lnot.title = "collab request";
                lnot.asset_nid = asset_nid;
                
                //only way to get this lnot is to be an andyrel for this request.
                if (lnot.txid!=undefined) {
                    var andyrel = MEMG.lookupRelonByTXID(lnot.txid);
                    if (andyrel!=undefined) andyrel.isAndyRel=true;
                }
            }
            else if (lnot.area_nid==MEM.hanai_out.nid) {
                lnot.title = "hanai in request";
                lnot.asset_nid = asset_nid;
                
                //only way to get this lnot is to be an andyrel for this request.
                if (lnot.txid!=undefined) {
                    var andyrel = MEMG.lookupRelonByTXID(lnot.txid);
                    if (andyrel!=undefined) andyrel.isAndyRel=true;
                }
            }

            else if (lnot.area_nid==MEM.hanai_in.nid) {
                //we can update this msg if this has been already acted upon.
                lnot.title = "hanai complete!";
                lnot.asset_nid = asset_nid;
            }

            else if (lnot.area_nid==MEM.hanai_in_reject.nid) {
                //we can update this msg if this has been already acted upon.
                lnot.title = "hanai rejected!";
                lnot.asset_nid = asset_nid;
            }
            else if (lnot.area_nid==MEM.hanai_and_collab.nid) {
                lnot.title = "hanai & collab";
                lnot.asset_nid = asset_nid;
                //only way to get this lnot is to be an andyrel for this request.
                if (lnot.txid!=undefined) {
                    var andyrel = MEMG.lookupRelonByTXID(lnot.txid);
                    if (andyrel!=undefined) andyrel.isAndyRel=true;
                }
            }

            else if (lnot.area_nid==MEM.PDN_ANSWER.nid) {
                lnot.title = "PDN encrypted answer";
                lnot.asset_nid = asset_nid;
                var burnbackRelon = MEMG.lookupByTXID(lnot.txid);
                if (burnbackRelon==null) {
                    await CHASE.lookupTxid(lnot.txid);
                    burnbackRelon = MEMG.lookupByTXID(lnot.txid);
                    console.log(burnbackRelon);
                }
            }

            else if (lnot.area_nid==MEM.achat.nid) {
                lnot.title = "Chat invite";
                lnot.achat_sesh_id = asset_nid; //the chat session id for launch.
                lnot.asset_nid = MEM.achat.nid; //override this with the achat class neuron
            }

            else if (lnot.area_nid==MEM.distro_req.nid) {
                lnot.title = "Distro request (vote)";
                lnot.page = "anne_vote";    //override dossier
                lnot.asset_nid = asset_nid;
            }
            
            else if (lnot.area_nid==MEM.ASDF.nid) {
                lnot.title = lnot.msg;
                lnot.asset_nid = asset_nid;
            }

            //new admin rights added for this user.
            else if (MEM.delegation_rights.children.indexOf(areaNOBJ.temp_nid)!=-1) {
                lnot.asset_nid = asset_nid;
                var rel = MEMG.lookupRelonByTXID(lnot.txid);
                var rightsNOBJ = MEMG.getNeuronByNid(rel.reln);
                if (rightsNOBJ==null) lnot.title = lnot.msg;
                else lnot.title = lnot.msg + " "+rightsNOBJ.text;
            }

            else {
                var areaNOBJ = MEMG.getNeuronByNid(lnot.area_nid);
                if (areaNOBJ.temp_nid==MEM.anjucator.temp_nid) {
                    lnot.title = "anjucator invite"; 
                    lnot.asset_nid = asset_nid;
                }
                else {
                    console.log(areaNOBJ);
                    lnot.title = lnot.msg;
                    lnot.asset_nid = asset_nid;
                }
                
                var burnbackRelon = MEMG.lookupByTXID(lnot.txid);
                if (burnbackRelon==null) {
                    await CHASE.lookupTxid(lnot.txid);
                    burnbackRelon = MEMG.lookupByTXID(lnot.txid);
                    if (burnbackRelon!=undefined) {
                        console.log(burnbackRelon);
                        burnbackRelon.isAndyRel=true;
                    }
                }
                else {
                    console.log(burnbackRelon);
                    burnbackRelon.isAndyRel=true;
                }
            }
        }

        var tableObj = new neuron_table(this.pgui);
        tableObj.bCOLORSQARES=true;
        tableObj.setManualCols(this.tbl_cols, lnots);
        var el_lnot = ANNE.A.__getEl("anneid_lnot_div");
        ANNE.A.empty(el_lnot);
        ANNE.A.show(el_lnot);
        tableObj.heading_col_class = "lnot-heading";
        tableObj.buildDOMTable(el_lnot);
    }
}
